
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/
 #include "Q7BRuntime.h"

#include "Global.h"
#include "Q7BCodeView.h"

#include "Q7BCompiler.h"

#include <typeinfo>
#include "Application.h"

#include "CodeView.h"

CodeView *q7b_CodeView_sharedSingleton = 0;
Q7B q7b_CodeView_sharedSingletonQ7B;
bool q7b_CodeView_sharedSingletonFinalized = false;
bool q7b_CodeView_sharedSingletonInit = false;
extern Q7B Q7B_idGLOBAL;
extern Q7B Q7B_idAPPLICATION;
extern Q7B Q7B_idSTATUSBAR;
extern Q7B Q7B_idSOUNDS;
extern Q7B Q7B_idDATABASE;
extern Q7B Q7B_idTABLE;
extern Q7B Q7B_idRECORDS;
extern Q7B Q7B_idQUERY;
extern Q7B Q7B_idPIXMAPS;
extern Q7B Q7B_idCOLORS;
extern Q7B Q7B_idFONTS;
extern Q7B Q7B_idTOOLBAR;
extern Q7B Q7B_idSYSTEMTRAY;
extern Q7B Q7B_idMAINWINDOW;
extern Q7B Q7B_idDEBUG;
extern Q7B Q7B_idFILE;
extern Q7B Q7B_idPREFERENCES;
extern Q7B Q7B_idDIR;
extern Q7B Q7B_idDESKTOP;
extern Q7B Q7B_idOPENFILEDIALOG;
extern Q7B Q7B_idSAVEFILEDIALOG;
extern Q7B Q7B_idCOLORDIALOG;
extern Q7B Q7B_idFONTDIALOG;
extern Q7B Q7B_idPROGRESSDIALOG;
extern Q7B Q7B_idINPUTDIALOG;
extern Q7B Q7B_idMESSAGEBOX;
extern Q7B Q7B_idOS;
#define CommandButton Q7B_CommandButton
#define CommandLinkButton Q7B_CommandLinkButton
#define ImageButton Q7B_ImageButton
#define ToolButton Q7B_ToolButton
#define CheckBox Q7B_CheckBox
#define RadioButton Q7B_RadioButton
#define Label Q7B_Label
#define Frame Q7B_Frame
#define ImageBox Q7B_ImageBox
#define TextBox Q7B_TextBox
#define uiClass Q7B_uiClass
#define Class Q7B_Class
#define Module Q7B_Module
#define Control QWidget
#include "MainWindow.h"
#include "Parser.h"

#include "ui_CodeView.h"

CodeView::CodeView(Q7B _q7b_this, QWidget *parent)
 : QWidget(parent), ui(new Ui::CodeView)
{
q7b_this = _q7b_this;
  ui->setupUi(this);
  Q7B q;
  QObject *o;
  o = findChild<QObject *>("Q7BCodeBox"); if (o){ q = Q7B(new Q7B_id(typeid(Q7BCodeView).name(), o)); Q7BCodeBox = q; }
  o = findChild<QObject *>("tbDefinitions"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbDefinitions = q; }
  o = findChild<QObject *>("tbConditions"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbConditions = q; }
  o = findChild<QObject *>("tbLoops"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbLoops = q; }
  o = findChild<QObject *>("tbOutlets"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbOutlets = q; }
  o = findChild<QObject *>("tbSignals"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbSignals = q; }
  o = findChild<QObject *>("tbEvents"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbEvents = q; }
  o = findChild<QObject *>("tbActions"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbActions = q; }
  o = findChild<QObject *>("lLine"); if (o){ q = Q7B(new Q7B_id(typeid(QLabel).name(), o)); lLine = q; }
  o = findChild<QObject *>("tbShiftLeft"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbShiftLeft = q; }
  o = findChild<QObject *>("tbShiftRight"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbShiftRight = q; }
  o = findChild<QObject *>("tbComment"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbComment = q; }
  o = findChild<QObject *>("tbUncomment"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbUncomment = q; }
  o = findChild<QObject *>("lInsertMessage"); if (o){ q = Q7B(new Q7B_id(typeid(QLabel).name(), o)); lInsertMessage = q; }
  o = findChild<QObject *>("cbDefinition"); if (o){ q = Q7B(new Q7B_id(typeid(QComboBox).name(), o)); cbDefinition = q; }
  o = findChild<QObject *>("cbCondition"); if (o){ q = Q7B(new Q7B_id(typeid(QComboBox).name(), o)); cbCondition = q; }
  o = findChild<QObject *>("cbLoop"); if (o){ q = Q7B(new Q7B_id(typeid(QComboBox).name(), o)); cbLoop = q; }
if (q7b_CodeView_sharedSingletonInit){ q7b_CodeView_sharedSingletonInit = false; q7b_CodeView_sharedSingletonQ7B = q7b_this = Q7B(new Q7B_id(typeid(CodeView).name(), this)); } else q7b_this = Q7B(new Q7B_id(typeid(CodeView).name(), this)); 
gr = Q7B__QBUTTONGROUP(Q7B_QBUTTONGROUP_INIT(this, "gr"));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(GetCompletion(QString)), this, SLOT(Q7B_on_Q7BCodeBox_GetCompletion_(QString)));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(GetCompletion2(QString)), this, SLOT(Q7B_on_Q7BCodeBox_GetCompletion2_(QString)));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(textChanged()), this, SLOT(Q7B_on_Q7BCodeBox_textChanged_()));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(cursorPositionChanged()), this, SLOT(Q7B_on_Q7BCodeBox_cursorPositionChanged_()));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(CopyAvailable(bool)), this, SLOT(Q7B_on_Q7BCodeBox_CopyAvailable_(bool)));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(PasteAvailable(bool)), this, SLOT(Q7B_on_Q7BCodeBox_PasteAvailable_(bool)));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(UndoAvailable(bool)), this, SLOT(Q7B_on_Q7BCodeBox_UndoAvailable_(bool)));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(RedoAvailable(bool)), this, SLOT(Q7B_on_Q7BCodeBox_RedoAvailable_(bool)));
mActions = Q7B__QMENU(Q7B_QMENU_INIT(this, "mActions"));
bLoading = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
nChanged = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0)));
toSave = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
mLoops = Q7B__QMENU(Q7B_QMENU_INIT(this, "mLoops"));
mConditions = Q7B__QMENU(Q7B_QMENU_INIT(this, "mConditions"));
mDefinitions = Q7B__QMENU(Q7B_QMENU_INIT(this, "mDefinitions"));
mOutlets = Q7B__QMENU(Q7B_QMENU_INIT(this, "mOutlets"));
mSignals = Q7B__QMENU(Q7B_QMENU_INIT(this, "mSignals"));
mSignals2 = Q7B__QMENU(Q7B_QMENU_INIT(this, "mSignals2"));
sControlName = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
mEvents = Q7B__QMENU(Q7B_QMENU_INIT(this, "mEvents"));
                      Q7BS("CodeView.QWidget", "Init", "38", 0);
                      Q7BS("CodeView.QWidget", "Init", "39", 1);
Q7B tabWidget; tabWidget = Q7B__QTABWIDGET(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(q7b_this, Q7B_QOBJECT("tabWidget"))));
                      Q7BS("CodeView.QWidget", "Init", "41", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "Init", "42", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_QTABWIDGET_COUNT(tabWidget)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "Init", "42", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "Init", "43", 1);
Q7B o; o = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QTABWIDGET_WIDGET(tabWidget, Q7B_QOBJECT(i))));
                      Q7BS("CodeView.QWidget", "Init", "44", 1);
Q7B ll; ll = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_QOBJECT_CHILDREN(o))));
                      Q7BS("CodeView.QWidget", "Init", "46", 1);
Q7B ii; ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "Init", "47", 1);
for (ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(ii), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(ll)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "Init", "47", 1),ii = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(ii), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "Init", "48", 1);
Q7B_QBUTTONGROUP_ADDBUTTON(gr, Q7B_QOBJECT(Q7B_LIST_OBJECT(ll, Q7B_QOBJECT(ii))));
}
}
                      Q7BS("CodeView.QWidget", "Init", "52", 2);
}
CodeView::CodeView(QWidget *parent)
 : QWidget(parent), ui(new Ui::CodeView)
{
q7b_this = Q7B(new Q7B_id(typeid(CodeView).name(), this, false));
  ui->setupUi(this);
  Q7B q;
  QObject *o;
  o = findChild<QObject *>("Q7BCodeBox"); if (o){ q = Q7B(new Q7B_id(typeid(Q7BCodeView).name(), o)); Q7BCodeBox = q; }
  o = findChild<QObject *>("tbDefinitions"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbDefinitions = q; }
  o = findChild<QObject *>("tbConditions"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbConditions = q; }
  o = findChild<QObject *>("tbLoops"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbLoops = q; }
  o = findChild<QObject *>("tbOutlets"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbOutlets = q; }
  o = findChild<QObject *>("tbSignals"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbSignals = q; }
  o = findChild<QObject *>("tbEvents"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbEvents = q; }
  o = findChild<QObject *>("tbActions"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbActions = q; }
  o = findChild<QObject *>("lLine"); if (o){ q = Q7B(new Q7B_id(typeid(QLabel).name(), o)); lLine = q; }
  o = findChild<QObject *>("tbShiftLeft"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbShiftLeft = q; }
  o = findChild<QObject *>("tbShiftRight"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbShiftRight = q; }
  o = findChild<QObject *>("tbComment"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbComment = q; }
  o = findChild<QObject *>("tbUncomment"); if (o){ q = Q7B(new Q7B_id(typeid(QToolButton).name(), o)); tbUncomment = q; }
  o = findChild<QObject *>("lInsertMessage"); if (o){ q = Q7B(new Q7B_id(typeid(QLabel).name(), o)); lInsertMessage = q; }
  o = findChild<QObject *>("cbDefinition"); if (o){ q = Q7B(new Q7B_id(typeid(QComboBox).name(), o)); cbDefinition = q; }
  o = findChild<QObject *>("cbCondition"); if (o){ q = Q7B(new Q7B_id(typeid(QComboBox).name(), o)); cbCondition = q; }
  o = findChild<QObject *>("cbLoop"); if (o){ q = Q7B(new Q7B_id(typeid(QComboBox).name(), o)); cbLoop = q; }
if (q7b_CodeView_sharedSingletonInit){ q7b_CodeView_sharedSingletonInit = false; q7b_CodeView_sharedSingletonQ7B = q7b_this = Q7B(new Q7B_id(typeid(CodeView).name(), this)); } else q7b_this = Q7B(new Q7B_id(typeid(CodeView).name(), this)); 
gr = Q7B__QBUTTONGROUP(Q7B_QBUTTONGROUP_INIT(this, "gr"));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(GetCompletion(QString)), this, SLOT(Q7B_on_Q7BCodeBox_GetCompletion_(QString)));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(GetCompletion2(QString)), this, SLOT(Q7B_on_Q7BCodeBox_GetCompletion2_(QString)));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(textChanged()), this, SLOT(Q7B_on_Q7BCodeBox_textChanged_()));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(cursorPositionChanged()), this, SLOT(Q7B_on_Q7BCodeBox_cursorPositionChanged_()));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(CopyAvailable(bool)), this, SLOT(Q7B_on_Q7BCodeBox_CopyAvailable_(bool)));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(PasteAvailable(bool)), this, SLOT(Q7B_on_Q7BCodeBox_PasteAvailable_(bool)));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(UndoAvailable(bool)), this, SLOT(Q7B_on_Q7BCodeBox_UndoAvailable_(bool)));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(RedoAvailable(bool)), this, SLOT(Q7B_on_Q7BCodeBox_RedoAvailable_(bool)));
mActions = Q7B__QMENU(Q7B_QMENU_INIT(this, "mActions"));
bLoading = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
nChanged = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0)));
toSave = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
mLoops = Q7B__QMENU(Q7B_QMENU_INIT(this, "mLoops"));
mConditions = Q7B__QMENU(Q7B_QMENU_INIT(this, "mConditions"));
mDefinitions = Q7B__QMENU(Q7B_QMENU_INIT(this, "mDefinitions"));
mOutlets = Q7B__QMENU(Q7B_QMENU_INIT(this, "mOutlets"));
mSignals = Q7B__QMENU(Q7B_QMENU_INIT(this, "mSignals"));
mSignals2 = Q7B__QMENU(Q7B_QMENU_INIT(this, "mSignals2"));
sControlName = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
mEvents = Q7B__QMENU(Q7B_QMENU_INIT(this, "mEvents"));
                      Q7BS("CodeView.QWidget", "Init", "38", 0);
                      Q7BS("CodeView.QWidget", "Init", "39", 1);
Q7B tabWidget; tabWidget = Q7B__QTABWIDGET(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(q7b_this, Q7B_QOBJECT("tabWidget"))));
                      Q7BS("CodeView.QWidget", "Init", "41", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "Init", "42", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_QTABWIDGET_COUNT(tabWidget)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "Init", "42", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "Init", "43", 1);
Q7B o; o = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QTABWIDGET_WIDGET(tabWidget, Q7B_QOBJECT(i))));
                      Q7BS("CodeView.QWidget", "Init", "44", 1);
Q7B ll; ll = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_QOBJECT_CHILDREN(o))));
                      Q7BS("CodeView.QWidget", "Init", "46", 1);
Q7B ii; ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "Init", "47", 1);
for (ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(ii), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(ll)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "Init", "47", 1),ii = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(ii), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "Init", "48", 1);
Q7B_QBUTTONGROUP_ADDBUTTON(gr, Q7B_QOBJECT(Q7B_LIST_OBJECT(ll, Q7B_QOBJECT(ii))));
}
}
                      Q7BS("CodeView.QWidget", "Init", "52", 2);
}

CodeView::~CodeView()
{
  delete ui;
  q7b_this->ref = 0;
}


void CodeView::Q7B_on_gr_buttonClicked(Q7B theButton)
{
                      Q7BS("CodeView.QWidget", "on_gr_buttonClicked", "13", 0);
                      Q7BS("CodeView.QWidget", "on_gr_buttonClicked", "13", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(theButton, "Insert"))), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("CodeView.QWidget", "on_gr_buttonClicked", "14", 1);
this->InsertCodeAtCurrentPosition(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QABSTRACTBUTTON_TEXT(theButton)))));
} else {
                      Q7BS("CodeView.QWidget", "on_gr_buttonClicked", "16", 1);
this->InsertCodeAtCurrentPosition(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(theButton, "Insert"))))));
}
                      Q7BS("CodeView.QWidget", "on_gr_buttonClicked", "18", 2);

}

void CodeView::Q7B_on_delayed()
{
                      Q7BS("CodeView.QWidget", "on_delayed", "23", 0);
                      Q7BS("CodeView.QWidget", "on_delayed", "23", 1);
Q7B tabWidget; tabWidget = Q7B__QTABWIDGET(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(q7b_this, Q7B_QOBJECT("tabWidget"))));
                      Q7BS("CodeView.QWidget", "on_delayed", "25", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "on_delayed", "26", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_QTABWIDGET_COUNT(tabWidget)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "on_delayed", "26", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "on_delayed", "27", 1);
Q7B o; o = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QTABWIDGET_WIDGET(tabWidget, Q7B_QOBJECT(i))));
                      Q7BS("CodeView.QWidget", "on_delayed", "28", 1);
Q7B ll; ll = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_QOBJECT_CHILDREN(o))));
                      Q7BS("CodeView.QWidget", "on_delayed", "30", 1);
Q7B ii; ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "on_delayed", "31", 1);
for (ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(ii), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(ll)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "on_delayed", "31", 1),ii = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(ii), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "on_delayed", "32", 1);
Q7B_QBUTTONGROUP_ADDBUTTON(gr, Q7B_QOBJECT(Q7B_LIST_OBJECT(ll, Q7B_QOBJECT(ii))));
}
}
                      Q7BS("CodeView.QWidget", "on_delayed", "35", 2);

}

CodeView::CodeView(Q7B _q7b_this) : QWidget()
{
q7b_this = _q7b_this;
if (q7b_CodeView_sharedSingletonInit){ q7b_CodeView_sharedSingletonInit = false; q7b_CodeView_sharedSingletonQ7B = q7b_this = Q7B(new Q7B_id(typeid(CodeView).name(), this)); } else q7b_this = Q7B(new Q7B_id(typeid(CodeView).name(), this)); 
gr = Q7B__QBUTTONGROUP(Q7B_QBUTTONGROUP_INIT(this, "gr"));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(GetCompletion(QString)), this, SLOT(Q7B_on_Q7BCodeBox_GetCompletion_(QString)));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(GetCompletion2(QString)), this, SLOT(Q7B_on_Q7BCodeBox_GetCompletion2_(QString)));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(textChanged()), this, SLOT(Q7B_on_Q7BCodeBox_textChanged_()));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(cursorPositionChanged()), this, SLOT(Q7B_on_Q7BCodeBox_cursorPositionChanged_()));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(CopyAvailable(bool)), this, SLOT(Q7B_on_Q7BCodeBox_CopyAvailable_(bool)));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(PasteAvailable(bool)), this, SLOT(Q7B_on_Q7BCodeBox_PasteAvailable_(bool)));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(UndoAvailable(bool)), this, SLOT(Q7B_on_Q7BCodeBox_UndoAvailable_(bool)));
if (Q7BCodeBox->ref) connect(((Q7BCodeView*)Q7BCodeBox->ref), SIGNAL(RedoAvailable(bool)), this, SLOT(Q7B_on_Q7BCodeBox_RedoAvailable_(bool)));
mActions = Q7B__QMENU(Q7B_QMENU_INIT(this, "mActions"));
bLoading = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
nChanged = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0)));
toSave = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
mLoops = Q7B__QMENU(Q7B_QMENU_INIT(this, "mLoops"));
mConditions = Q7B__QMENU(Q7B_QMENU_INIT(this, "mConditions"));
mDefinitions = Q7B__QMENU(Q7B_QMENU_INIT(this, "mDefinitions"));
mOutlets = Q7B__QMENU(Q7B_QMENU_INIT(this, "mOutlets"));
mSignals = Q7B__QMENU(Q7B_QMENU_INIT(this, "mSignals"));
mSignals2 = Q7B__QMENU(Q7B_QMENU_INIT(this, "mSignals2"));
sControlName = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
mEvents = Q7B__QMENU(Q7B_QMENU_INIT(this, "mEvents"));
                      Q7BS("CodeView.QWidget", "Init", "38", 0);
                      Q7BS("CodeView.QWidget", "Init", "39", 1);
Q7B tabWidget; tabWidget = Q7B__QTABWIDGET(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(q7b_this, Q7B_QOBJECT("tabWidget"))));
                      Q7BS("CodeView.QWidget", "Init", "41", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "Init", "42", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_QTABWIDGET_COUNT(tabWidget)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "Init", "42", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "Init", "43", 1);
Q7B o; o = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QTABWIDGET_WIDGET(tabWidget, Q7B_QOBJECT(i))));
                      Q7BS("CodeView.QWidget", "Init", "44", 1);
Q7B ll; ll = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_QOBJECT_CHILDREN(o))));
                      Q7BS("CodeView.QWidget", "Init", "46", 1);
Q7B ii; ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "Init", "47", 1);
for (ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(ii), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(ll)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "Init", "47", 1),ii = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(ii), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "Init", "48", 1);
Q7B_QBUTTONGROUP_ADDBUTTON(gr, Q7B_QOBJECT(Q7B_LIST_OBJECT(ll, Q7B_QOBJECT(ii))));
}
}
                      Q7BS("CodeView.QWidget", "Init", "52", 2);

}

void CodeView::Q7B_on_singleshot()
{
                      Q7BS("CodeView.QWidget", "on_singleshot", "56", 0);
                      Q7BS("CodeView.QWidget", "on_singleshot", "56", 1);
this->Save();
                      Q7BS("CodeView.QWidget", "on_singleshot", "57", 1);
if (Q7B_CBOOLEAN(true)){
                      Q7BS("CodeView.QWidget", "on_singleshot", "58", 1);
return;
}
                      Q7BS("CodeView.QWidget", "on_singleshot", "60", 2);

}

Q7B CodeView::GetActions()
{
                      Q7BS("CodeView.QWidget", "GetActions", "79", 0);
                      Q7BS("CodeView.QWidget", "GetActions", "80", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "GetActions", "81", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))));
                      Q7BS("CodeView.QWidget", "GetActions", "82", 1);
Q7B s2; s2 = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_FILEPATH(Q7B_QOBJECT(s))), Q7B_QOBJECT("/"))), Q7B_QOBJECT(Q7B_FILEBASENAME(Q7B_QOBJECT(s))))), Q7B_QOBJECT(".ui")))));
                      Q7BS("CodeView.QWidget", "GetActions", "84", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
                      Q7BS("CodeView.QWidget", "GetActions", "86", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(s2)))){
                      Q7BS("CodeView.QWidget", "GetActions", "87", 1);
Q7B_QMENU_CLEAR(mActions);
                      Q7BS("CodeView.QWidget", "GetActions", "89", 1);
Q7B k; k = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_READSTRING(Q7B_QOBJECT(s2), Q7B_QOBJECT("")))));
                      Q7BS("CodeView.QWidget", "GetActions", "91", 1);
Q7B sName; sName = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("CodeView.QWidget", "GetActions", "92", 1);
Q7B sType; sType = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("CodeView.QWidget", "GetActions", "94", 1);
Q7B n; n = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(k), Q7B_QOBJECT("<action name=\""), Q7B_QOBJECT(0), Q7B_QOBJECT(true)))));
                      Q7BS("CodeView.QWidget", "GetActions", "96", 1);
while(Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(n), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "GetActions", "97", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n), Q7B_QOBJECT(14))))));
                      Q7BS("CodeView.QWidget", "GetActions", "98", 1);
Q7B n2; n2 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(k), Q7B_QOBJECT("\""), Q7B_QOBJECT(n), Q7B_QOBJECT(true)))));
                      Q7BS("CodeView.QWidget", "GetActions", "99", 1);
if (Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(n2), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "GetActions", "100", 1);
Q7B_ASSIGNMENT(&sType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(k), Q7B_QOBJECT(n), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(n2), Q7B_QOBJECT(n))))))));
                      Q7BS("CodeView.QWidget", "GetActions", "102", 1);
if (Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(sType), Q7B_QOBJECT("separator")))){
                      Q7BS("CodeView.QWidget", "GetActions", "103", 1);
Q7B_DICTIONARY_SETOBJECT(d, Q7B_QOBJECT(sType), Q7B_QOBJECT(sType));
}
}
                      Q7BS("CodeView.QWidget", "GetActions", "107", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(k), Q7B_QOBJECT("<action name=\""), Q7B_QOBJECT(n), Q7B_QOBJECT(true))))));
}
                      Q7BS("CodeView.QWidget", "GetActions", "110", 1);
return Q7B_QOBJECT(d);
} else {
                      Q7BS("CodeView.QWidget", "GetActions", "113", 1);
Q7B__MSGBOX(Q7B_QOBJECT("There is no ui file for the current code available or there are no outlets in the ui file for the current code file."));
}
                      Q7BS("CodeView.QWidget", "GetActions", "116", 2);
return Q7B_IDNIL();

}

void CodeView::Q7B_on_tbSyncActions_clicked(Q7B Checked)
{
                      Q7BS("CodeView.QWidget", "on_tbSyncActions_clicked", "119", 0);
                      Q7BS("CodeView.QWidget", "on_tbSyncActions_clicked", "119", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_QOBJECT(this->GetActions())));
                      Q7BS("CodeView.QWidget", "on_tbSyncActions_clicked", "121", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(d), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("CodeView.QWidget", "on_tbSyncActions_clicked", "121", 1);
return;
}
                      Q7BS("CodeView.QWidget", "on_tbSyncActions_clicked", "123", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "on_tbSyncActions_clicked", "125", 1);
Q7B l; l = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_KEYS(d))));
                      Q7BS("CodeView.QWidget", "on_tbSyncActions_clicked", "127", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(l)), Q7B_QOBJECT(1))))); Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1))), Q7B_QOBJECT(0))) ? Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(0))) : Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(0))); Q7BS("CodeView.QWidget", "on_tbSyncActions_clicked", "127", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1))))))))){
                      Q7BS("CodeView.QWidget", "on_tbSyncActions_clicked", "128", 1);
this->InsertCode(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT("Signal on_"), Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))))), Q7B_QOBJECT("_triggered(Checked As Boolean)\n  \nEnd Signal\n\n"))))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
}
                      Q7BS("CodeView.QWidget", "on_tbSyncActions_clicked", "131", 2);

}

void CodeView::Q7B_on_tbActions_clicked(Q7B Checked)
{
                      Q7BS("CodeView.QWidget", "on_tbActions_clicked", "135", 0);
                      Q7BS("CodeView.QWidget", "on_tbActions_clicked", "135", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_QOBJECT(this->GetActions())));
                      Q7BS("CodeView.QWidget", "on_tbActions_clicked", "137", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(d), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("CodeView.QWidget", "on_tbActions_clicked", "137", 1);
return;
}
                      Q7BS("CodeView.QWidget", "on_tbActions_clicked", "139", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "on_tbActions_clicked", "141", 1);
Q7B l; l = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_KEYS(d))));
                      Q7BS("CodeView.QWidget", "on_tbActions_clicked", "143", 1);
Q7B o; o = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("CodeView.QWidget", "on_tbActions_clicked", "144", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(l)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "on_tbActions_clicked", "144", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "on_tbActions_clicked", "145", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_ISEMPTY(Q7B_QOBJECT(o))))) && Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(o), Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))), Q7B_QOBJECT(7)))))))){
                      Q7BS("CodeView.QWidget", "on_tbActions_clicked", "146", 1);
Q7B_QMENU_ADDSEPARATOR(mActions);
}
                      Q7BS("CodeView.QWidget", "on_tbActions_clicked", "148", 1);
Q7B_QMENU_ADDACTION(mActions, Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))));
                      Q7BS("CodeView.QWidget", "on_tbActions_clicked", "149", 1);
Q7B_ASSIGNMENT(&o, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))), Q7B_QOBJECT(7))))));
}
                      Q7BS("CodeView.QWidget", "on_tbActions_clicked", "153", 1);
Q7B_QTOOLBUTTON_MENU(tbActions, Q7B_QOBJECT(mActions));
                      Q7BS("CodeView.QWidget", "on_tbActions_clicked", "154", 1);
((QToolButton *) (tbActions)->ref)->showMenu();
                      Q7BS("CodeView.QWidget", "on_tbActions_clicked", "155", 1);
Q7B_QTOOLBUTTON_MENU(tbActions, Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("CodeView.QWidget", "on_tbActions_clicked", "157", 2);

}

void CodeView::Q7B_on_mActions_triggered(Q7B Action)
{
                      Q7BS("CodeView.QWidget", "on_mActions_triggered", "160", 0);
                      Q7BS("CodeView.QWidget", "on_mActions_triggered", "160", 1);
this->InsertCodeAtCurrentPosition(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT("\nSignal on_"), Q7B_QOBJECT(Q7B_QACTION_TEXT(Action)))), Q7B_QOBJECT("_triggered(Checked As Boolean)\n  \nEnd Signal\n"))))));
                      Q7BS("CodeView.QWidget", "on_mActions_triggered", "161", 2);

}

Q7B CodeView::Load(Q7B sFileName)
{
                      Q7BS("CodeView.QWidget", "Load", "174", 0);
                      Q7BS("CodeView.QWidget", "Load", "175", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "Load", "176", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("CodeView.QWidget", "Load", "178", 1);
((Q7BCodeView *) (cb)->ref)->setCPPKeywords(Q7B_CQSTRINGLIST(Q7B_QOBJECT(((Global *) Q7B_idGLOBAL->ref)->CPPKeywords)));
                      Q7BS("CodeView.QWidget", "Load", "179", 1);
((Q7BCodeView *) (cb)->ref)->setKeywords(Q7B_CQSTRINGLIST(Q7B_QOBJECT(((Global *) Q7B_idGLOBAL->ref)->Keywords)));
                      Q7BS("CodeView.QWidget", "Load", "180", 1);
((Q7BCodeView *) (cb)->ref)->setConsts(Q7B_CQSTRINGLIST(Q7B_QOBJECT(((Global *) Q7B_idGLOBAL->ref)->Consts)));
                      Q7BS("CodeView.QWidget", "Load", "181", 1);
((Q7BCodeView *) (cb)->ref)->setTypes(Q7B_CQSTRINGLIST(Q7B_QOBJECT(((Global *) Q7B_idGLOBAL->ref)->Types)));
                      Q7BS("CodeView.QWidget", "Load", "182", 1);
((Q7BCodeView *) (cb)->ref)->setFunctions(Q7B_CQSTRINGLIST(Q7B_QOBJECT(((Global *) Q7B_idGLOBAL->ref)->Functions)));
                      Q7BS("CodeView.QWidget", "Load", "183", 1);
((Q7BCodeView *) (cb)->ref)->setClasses(Q7B_CQSTRINGLIST(Q7B_QOBJECT(((Global *) Q7B_idGLOBAL->ref)->Classes)));
                      Q7BS("CodeView.QWidget", "Load", "184", 1);
((Q7BCodeView *) (cb)->ref)->setObjects(Q7B_CQSTRINGLIST(Q7B_QOBJECT(((Global *) Q7B_idGLOBAL->ref)->Objects)));
                      Q7BS("CodeView.QWidget", "Load", "186", 1);
Q7B_ASSIGNMENT(&bLoading, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
                      Q7BS("CodeView.QWidget", "Load", "188", 1);
if (Q7B_CBOOLEAN(Q7B_QOBJECT(((Q7BCodeView *) (cb)->ref)->Load(Q7B_CQSTRING(Q7B_QOBJECT(sFileName)))))){
                      Q7BS("CodeView.QWidget", "Load", "190", 1);
Q7B_QWIDGET_WINDOWTITLE(w, Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(sFileName))));
                      Q7BS("CodeView.QWidget", "Load", "191", 1);
Q7B_PROPERTY(w, "PathFileName", Q7B_QOBJECT(Q7B_QOBJECT(sFileName)));
                      Q7BS("CodeView.QWidget", "Load", "193", 1);
Q7B_ASSIGNMENT(&bLoading, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("CodeView.QWidget", "Load", "194", 1);
return Q7B_QOBJECT(true);
}
                      Q7BS("CodeView.QWidget", "Load", "196", 1);
Q7B_ASSIGNMENT(&bLoading, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("CodeView.QWidget", "Load", "198", 1);
return Q7B_QOBJECT(false);
                      Q7BS("CodeView.QWidget", "Load", "199", 2);
return Q7B_IDNIL();

}

Q7B CodeView::Save()
{
                      Q7BS("CodeView.QWidget", "Save", "206", 0);
                      Q7BS("CodeView.QWidget", "Save", "207", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(nChanged), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "Save", "208", 1);
Q7B_ASSIGNMENT(&nChanged, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(nChanged), Q7B_QOBJECT(1))))));
}
                      Q7BS("CodeView.QWidget", "Save", "212", 1);
if (Q7B_CBOOLEAN(Q7B_QOBJECT(((Q7BCodeView *) (toSave)->ref)->Save()))){
                      Q7BS("CodeView.QWidget", "Save", "213", 1);
return Q7B_QOBJECT(true);
}
                      Q7BS("CodeView.QWidget", "Save", "216", 1);
return Q7B_QOBJECT(false);
                      Q7BS("CodeView.QWidget", "Save", "217", 2);
return Q7B_IDNIL();

}

Q7B CodeView::SaveIfChanged()
{
                      Q7BS("CodeView.QWidget", "SaveIfChanged", "220", 0);
                      Q7BS("CodeView.QWidget", "SaveIfChanged", "221", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(nChanged), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "SaveIfChanged", "222", 1);
Q7B_ASSIGNMENT(&nChanged, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(nChanged), Q7B_QOBJECT(1))))));
                      Q7BS("CodeView.QWidget", "SaveIfChanged", "223", 1);
if (Q7B_CBOOLEAN(Q7B_QOBJECT(((Q7BCodeView *) (toSave)->ref)->Save()))){
                      Q7BS("CodeView.QWidget", "SaveIfChanged", "224", 1);
return Q7B_QOBJECT(true);
}
}
                      Q7BS("CodeView.QWidget", "SaveIfChanged", "227", 1);
return Q7B_QOBJECT(false);
                      Q7BS("CodeView.QWidget", "SaveIfChanged", "228", 2);
return Q7B_IDNIL();

}

void CodeView::CloseEvent(Q7B e)
{
                      Q7BS("CodeView.QWidget", "CloseEvent", "233", 0);
                      Q7BS("CodeView.QWidget", "CloseEvent", "234", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(nChanged), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "CloseEvent", "235", 1);
this->SaveIfChanged();
}
                      Q7BS("CodeView.QWidget", "CloseEvent", "238", 2);

}

void CodeView::Q7B_on_Q7BCodeBox_textChanged()
{
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_textChanged", "241", 0);
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_textChanged", "242", 1);
Q7B_ASSIGNMENT(&nChanged, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(nChanged), Q7B_QOBJECT(1))))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_textChanged", "243", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_textChanged", "244", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_textChanged", "245", 1);
Q7B_ASSIGNMENT(&toSave, &Q7B__QOBJECT(Q7B_QOBJECT(cb)));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_textChanged", "246", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(bLoading), Q7B_QOBJECT(false)))){
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_textChanged", "248", 1);
QTimer::singleShot(Q7B_toInteger2(Q7B_QOBJECT(2000)), this, SLOT(Q7B_on_singleshot()));
}
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_textChanged", "250", 2);

}

void CodeView::Q7B_LastPositionTimer()
{
                      Q7BS("CodeView.QWidget", "LastPositionTimer", "253", 0);
                      Q7BS("CodeView.QWidget", "LastPositionTimer", "254", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QOBJECT(((MainWindow *) MainWindow::q7b_sharedSingleton())->Get_bBlockLastPosition())), Q7B_QOBJECT(true)))){
                      Q7BS("CodeView.QWidget", "LastPositionTimer", "254", 1);
return;
}
                      Q7BS("CodeView.QWidget", "LastPositionTimer", "257", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "LastPositionTimer", "258", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("CodeView.QWidget", "LastPositionTimer", "260", 1);
MainWindow::q7b_sharedSingleton()->Set_sLastPositionFile(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName"))));
                      Q7BS("CodeView.QWidget", "LastPositionTimer", "261", 1);
MainWindow::q7b_sharedSingleton()->Set_nLastPositionLine(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCodeView *) (cb)->ref)->getCurrentLine())));
                      Q7BS("CodeView.QWidget", "LastPositionTimer", "263", 2);

}

void CodeView::Q7B_on_Q7BCodeBox_cursorPositionChanged()
{
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_cursorPositionChanged", "267", 0);
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_cursorPositionChanged", "268", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QOBJECT(((MainWindow *) MainWindow::q7b_sharedSingleton())->Get_bBlockLastPosition())), Q7B_QOBJECT(false)))){
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_cursorPositionChanged", "268", 1);
QTimer::singleShot(Q7B_toInteger2(Q7B_QOBJECT(2000)), this, SLOT(Q7B_LastPositionTimer()));
}
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_cursorPositionChanged", "270", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_cursorPositionChanged", "271", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_cursorPositionChanged", "273", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_cursorPositionChanged", "274", 1);
Q7B_ASSIGNMENT(&s, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCodeView *) (cb)->ref)->getCurrentLine())), Q7B_QOBJECT(false))))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_cursorPositionChanged", "275", 1);
Q7B_QLABEL_TEXT(lLine, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(" L "), Q7B_QOBJECT(s))), Q7B_QOBJECT("   C "))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCodeView *) (cb)->ref)->getCurrentColumn())), Q7B_QOBJECT(false))))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_cursorPositionChanged", "276", 2);

}

void CodeView::Q7B_on_Q7BCodeBox_CopyAvailable(Q7B b)
{
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_CopyAvailable", "279", 0);
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_CopyAvailable", "280", 1);
Q7B_QACTION_ENABLED(((MainWindow *) MainWindow::q7b_sharedSingleton())->actionCut, Q7B_QOBJECT(b));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_CopyAvailable", "281", 1);
Q7B_QACTION_ENABLED(((MainWindow *) MainWindow::q7b_sharedSingleton())->actionCopy, Q7B_QOBJECT(b));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_CopyAvailable", "282", 1);
Q7B_QACTION_ENABLED(((MainWindow *) MainWindow::q7b_sharedSingleton())->actionDelete, Q7B_QOBJECT(b));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_CopyAvailable", "284", 1);
Q7B_QACTION_ENABLED(((MainWindow *) MainWindow::q7b_sharedSingleton())->actionTo_UPPERCASE, Q7B_QOBJECT(b));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_CopyAvailable", "285", 1);
Q7B_QACTION_ENABLED(((MainWindow *) MainWindow::q7b_sharedSingleton())->actionTo_lowercase, Q7B_QOBJECT(b));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_CopyAvailable", "286", 1);
Q7B_QACTION_ENABLED(((MainWindow *) MainWindow::q7b_sharedSingleton())->actionComment, Q7B_QOBJECT(b));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_CopyAvailable", "287", 1);
Q7B_QACTION_ENABLED(((MainWindow *) MainWindow::q7b_sharedSingleton())->actionUncomment, Q7B_QOBJECT(b));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_CopyAvailable", "288", 1);
Q7B_QACTION_ENABLED(((MainWindow *) MainWindow::q7b_sharedSingleton())->actionShift_Left, Q7B_QOBJECT(b));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_CopyAvailable", "289", 1);
Q7B_QACTION_ENABLED(((MainWindow *) MainWindow::q7b_sharedSingleton())->actionShift_Right, Q7B_QOBJECT(b));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_CopyAvailable", "291", 2);

}

void CodeView::Q7B_on_Q7BCodeBox_PasteAvailable(Q7B b)
{
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_PasteAvailable", "294", 0);
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_PasteAvailable", "294", 1);
Q7B_QACTION_ENABLED(((MainWindow *) MainWindow::q7b_sharedSingleton())->actionPaste, Q7B_QOBJECT(b));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_PasteAvailable", "295", 2);

}

void CodeView::Q7B_on_Q7BCodeBox_UndoAvailable(Q7B b)
{
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_UndoAvailable", "298", 0);
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_UndoAvailable", "298", 1);
Q7B_QACTION_ENABLED(((MainWindow *) MainWindow::q7b_sharedSingleton())->actionUndo, Q7B_QOBJECT(b));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_UndoAvailable", "299", 2);

}

void CodeView::Q7B_on_Q7BCodeBox_RedoAvailable(Q7B b)
{
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_RedoAvailable", "302", 0);
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_RedoAvailable", "302", 1);
Q7B_QACTION_ENABLED(((MainWindow *) MainWindow::q7b_sharedSingleton())->actionRedo, Q7B_QOBJECT(b));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_RedoAvailable", "303", 2);

}

void CodeView::Q7B_on_tbShiftLeft_clicked(Q7B Checked)
{
                      Q7BS("CodeView.QWidget", "on_tbShiftLeft_clicked", "306", 0);
                      Q7BS("CodeView.QWidget", "on_tbShiftLeft_clicked", "306", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "on_tbShiftLeft_clicked", "307", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("CodeView.QWidget", "on_tbShiftLeft_clicked", "308", 1);
((Q7BCodeView *) (cb)->ref)->PerformUnindent();
                      Q7BS("CodeView.QWidget", "on_tbShiftLeft_clicked", "309", 2);

}

void CodeView::Q7B_on_tbShiftRight_clicked(Q7B Checked)
{
                      Q7BS("CodeView.QWidget", "on_tbShiftRight_clicked", "312", 0);
                      Q7BS("CodeView.QWidget", "on_tbShiftRight_clicked", "312", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "on_tbShiftRight_clicked", "313", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("CodeView.QWidget", "on_tbShiftRight_clicked", "314", 1);
((Q7BCodeView *) (cb)->ref)->PerformIndent();
                      Q7BS("CodeView.QWidget", "on_tbShiftRight_clicked", "315", 2);

}

void CodeView::Q7B_on_tbComment_clicked(Q7B Checked)
{
                      Q7BS("CodeView.QWidget", "on_tbComment_clicked", "318", 0);
                      Q7BS("CodeView.QWidget", "on_tbComment_clicked", "318", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "on_tbComment_clicked", "319", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("CodeView.QWidget", "on_tbComment_clicked", "320", 1);
((Q7BCodeView *) (cb)->ref)->PerformComment();
                      Q7BS("CodeView.QWidget", "on_tbComment_clicked", "321", 2);

}

void CodeView::Q7B_on_tbUncomment_clicked(Q7B Checked)
{
                      Q7BS("CodeView.QWidget", "on_tbUncomment_clicked", "324", 0);
                      Q7BS("CodeView.QWidget", "on_tbUncomment_clicked", "324", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "on_tbUncomment_clicked", "325", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("CodeView.QWidget", "on_tbUncomment_clicked", "326", 1);
((Q7BCodeView *) (cb)->ref)->PerformUncomment();
                      Q7BS("CodeView.QWidget", "on_tbUncomment_clicked", "327", 2);

}

void CodeView::InsertCodeAtCurrentPosition(Q7B s)
{
                      Q7BS("CodeView.QWidget", "InsertCodeAtCurrentPosition", "335", 0);
                      Q7BS("CodeView.QWidget", "InsertCodeAtCurrentPosition", "335", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "InsertCodeAtCurrentPosition", "336", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("CodeView.QWidget", "InsertCodeAtCurrentPosition", "338", 1);
Q7B te; te = Q7B__QPLAINTEXTEDIT(Q7B_QPLAINTEXTEDIT_INIT(this, "te"));
                      Q7BS("CodeView.QWidget", "InsertCodeAtCurrentPosition", "339", 1);
Q7B_ASSIGNMENT(&te, &Q7B__QPLAINTEXTEDIT(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCodeView *) (cb)->ref)->getQPlainTextEdit()))));
                      Q7BS("CodeView.QWidget", "InsertCodeAtCurrentPosition", "341", 1);
((QPlainTextEdit *) (te)->ref)->insertPlainText(Q7B_CQSTRING(Q7B_QOBJECT(s)));
                      Q7BS("CodeView.QWidget", "InsertCodeAtCurrentPosition", "342", 2);

}

void CodeView::InsertCode(Q7B s, Q7B bGoto)
{
                      Q7BS("CodeView.QWidget", "InsertCode", "345", 0);
                      Q7BS("CodeView.QWidget", "InsertCode", "347", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "InsertCode", "348", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("CodeView.QWidget", "InsertCode", "350", 1);
Q7B te; te = Q7B__QPLAINTEXTEDIT(Q7B_QPLAINTEXTEDIT_INIT(this, "te"));
                      Q7BS("CodeView.QWidget", "InsertCode", "351", 1);
Q7B_ASSIGNMENT(&te, &Q7B__QPLAINTEXTEDIT(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCodeView *) (cb)->ref)->getQPlainTextEdit()))));
                      Q7BS("CodeView.QWidget", "InsertCode", "353", 1);
Q7B t; t = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT("\n"), Q7B_QOBJECT(Q7B_QPLAINTEXTEDIT_PLAINTEXT(te))))));
                      Q7BS("CodeView.QWidget", "InsertCode", "355", 1);
Q7B l; l = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(s)));
                      Q7BS("CodeView.QWidget", "InsertCode", "356", 1);
Q7B n; n = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(s), Q7B_QOBJECT("\n"), Q7B_QOBJECT(0), Q7B_QOBJECT(true)))));
                      Q7BS("CodeView.QWidget", "InsertCode", "357", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(n), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "InsertCode", "358", 1);
Q7B_ASSIGNMENT(&l, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(l), Q7B_QOBJECT(n))))));
}
                      Q7BS("CodeView.QWidget", "InsertCode", "361", 1);
if (Q7B_CBOOLEAN(Q7B_STARTSWITH(Q7B_QOBJECT(l), Q7B_QOBJECT("\n"), Q7B_QOBJECT(true)))){
} else {
                      Q7BS("CodeView.QWidget", "InsertCode", "363", 1);
Q7B_ASSIGNMENT(&l, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT("\n"), Q7B_QOBJECT(l))))));
}
                      Q7BS("CodeView.QWidget", "InsertCode", "366", 1);
if (Q7B_CBOOLEAN(Q7B_CONTAINS(Q7B_QOBJECT(t), Q7B_QOBJECT(l), Q7B_QOBJECT(true)))){
                      Q7BS("CodeView.QWidget", "InsertCode", "368", 1);
if (Q7B_CBOOLEAN(bGoto)){
                      Q7BS("CodeView.QWidget", "InsertCode", "369", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(t), Q7B_QOBJECT(l), Q7B_QOBJECT(0), Q7B_QOBJECT(true))))));
                      Q7BS("CodeView.QWidget", "InsertCode", "370", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_COUNT(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(t), Q7B_QOBJECT(n))), Q7B_QOBJECT("\n"), Q7B_QOBJECT(true))))));
                      Q7BS("CodeView.QWidget", "InsertCode", "371", 1);
((Q7BCodeView *) (cb)->ref)->GotoLine((int) Q7B_CINTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n), Q7B_QOBJECT(1)))));
}
                      Q7BS("CodeView.QWidget", "InsertCode", "375", 1);
return;
}
                      Q7BS("CodeView.QWidget", "InsertCode", "380", 1);
if (Q7B_CBOOLEAN(bGoto)){
                      Q7BS("CodeView.QWidget", "InsertCode", "380", 1);
((Q7BCodeView *) (cb)->ref)->GotoLine((int) Q7B_CINTEGER(Q7B_QOBJECT(1)));
}
                      Q7BS("CodeView.QWidget", "InsertCode", "382", 1);
((QPlainTextEdit *) (te)->ref)->insertPlainText(Q7B_CQSTRING(Q7B_QOBJECT(s)));
                      Q7BS("CodeView.QWidget", "InsertCode", "383", 2);

}

void CodeView::Q7B_on_tbLoops_clicked(Q7B Checked)
{
                      Q7BS("CodeView.QWidget", "on_tbLoops_clicked", "405", 0);
                      Q7BS("CodeView.QWidget", "on_tbLoops_clicked", "406", 1);
Q7B_QMENU_CLEAR(mLoops);
                      Q7BS("CodeView.QWidget", "on_tbLoops_clicked", "407", 1);
Q7B q; q = Q7B__QACTION(Q7B_QACTION_INIT(this, "q"));
                      Q7BS("CodeView.QWidget", "on_tbLoops_clicked", "408", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mLoops, Q7B_QOBJECT("For ... Next")))));
                      Q7BS("CodeView.QWidget", "on_tbLoops_clicked", "408", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("For COUNTER = 0 To EXPRESSION\n  ...\nNext\n"));
                      Q7BS("CodeView.QWidget", "on_tbLoops_clicked", "409", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mLoops, Q7B_QOBJECT("Do While ... Loop")))));
                      Q7BS("CodeView.QWidget", "on_tbLoops_clicked", "409", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("Do While CONDITION\n  ...\nLoop\n"));
                      Q7BS("CodeView.QWidget", "on_tbLoops_clicked", "410", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mLoops, Q7B_QOBJECT("Do ... Loop While")))));
                      Q7BS("CodeView.QWidget", "on_tbLoops_clicked", "410", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("Do\n  ...\nLoop While CONDITION\n"));
                      Q7BS("CodeView.QWidget", "on_tbLoops_clicked", "412", 1);
Q7B_QTOOLBUTTON_MENU(tbLoops, Q7B_QOBJECT(mLoops));
                      Q7BS("CodeView.QWidget", "on_tbLoops_clicked", "413", 1);
((QToolButton *) (tbLoops)->ref)->showMenu();
                      Q7BS("CodeView.QWidget", "on_tbLoops_clicked", "414", 1);
Q7B_QTOOLBUTTON_MENU(tbLoops, Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("CodeView.QWidget", "on_tbLoops_clicked", "416", 2);

}

void CodeView::Q7B_on_mLoops_triggered(Q7B Action)
{
                      Q7BS("CodeView.QWidget", "on_mLoops_triggered", "419", 0);
                      Q7BS("CodeView.QWidget", "on_mLoops_triggered", "419", 1);
this->InsertCodeAtCurrentPosition(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QACTION_TAG(Action)))));
                      Q7BS("CodeView.QWidget", "on_mLoops_triggered", "420", 2);

}

void CodeView::Q7B_on_tbConditions_clicked(Q7B Checked)
{
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "427", 0);
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "428", 1);
Q7B_QMENU_CLEAR(mConditions);
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "429", 1);
Q7B q; q = Q7B__QACTION(Q7B_QACTION_INIT(this, "q"));
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "430", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mConditions, Q7B_QOBJECT("If Then ...")))));
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "430", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("If CONDITION Then ...\n"));
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "431", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mConditions, Q7B_QOBJECT("If Then ... Else")))));
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "431", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("If CONDITION Then ... Else ... End If\n"));
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "432", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mConditions, Q7B_QOBJECT("If Then ... Else ... End If")))));
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "432", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("If CONDITION Then\n  ... \nElse\n  ...\nEnd If\n"));
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "433", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mConditions, Q7B_QOBJECT("If Then ... Else If ... Else ... End If")))));
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "433", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("If CONDITION Then\n  ... \nElse If CONDTION Then\n  ... \nElse  ...\nEnd If\n"));
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "434", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mConditions, Q7B_QOBJECT("Select ... End Select")))));
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "434", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("Select KEY\n  Case VALUE\n    ...\n  Case VALUE\n    ...   Case Else\n    ... \nEnd Select\n"));
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "436", 1);
Q7B_QTOOLBUTTON_MENU(tbConditions, Q7B_QOBJECT(mConditions));
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "437", 1);
((QToolButton *) (tbConditions)->ref)->showMenu();
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "438", 1);
Q7B_QTOOLBUTTON_MENU(tbConditions, Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("CodeView.QWidget", "on_tbConditions_clicked", "440", 2);

}

void CodeView::Q7B_on_mConditions_triggered(Q7B Action)
{
                      Q7BS("CodeView.QWidget", "on_mConditions_triggered", "443", 0);
                      Q7BS("CodeView.QWidget", "on_mConditions_triggered", "443", 1);
this->InsertCodeAtCurrentPosition(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QACTION_TAG(Action)))));
                      Q7BS("CodeView.QWidget", "on_mConditions_triggered", "444", 2);

}

void CodeView::Q7B_on_tbDefinitions_clicked(Q7B Checked)
{
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "449", 0);
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "450", 1);
Q7B_QMENU_CLEAR(mDefinitions);
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "451", 1);
Q7B q; q = Q7B__QACTION(Q7B_QACTION_INIT(this, "q"));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "452", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mDefinitions, Q7B_QOBJECT("Sub")))));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "452", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("Sub NAME(NAME As TYPE, NAME As TYPE)\n\nEnd Sub\n"));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "453", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mDefinitions, Q7B_QOBJECT("Function")))));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "453", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("Function NAME(NAME As TYPE, NAME As TYPE) As TYPE\n\nEnd Function\n"));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "454", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mDefinitions, Q7B_QOBJECT("Dim")))));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "454", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("Dim NAME As TYPE\n"));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "455", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mDefinitions, Q7B_QOBJECT("Const")))));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "455", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("Const NAME As TYPE\n"));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "456", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mDefinitions, Q7B_QOBJECT("Type")))));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "456", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("Type NAME\n  NAME As TYPE\n  NAME As TYPE\nEnd Type\n"));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "457", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mDefinitions, Q7B_QOBJECT("Enum")))));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "457", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("Enum NAME\n  NAME As TYPE\n  NAME As TYPE\nEnd Enum\n"));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "458", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mDefinitions, Q7B_QOBJECT("Outlet")))));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "458", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("Outlet NAME As TYPE\n"));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "459", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mDefinitions, Q7B_QOBJECT("Signal")))));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "459", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("Signal on_OBJECTNAME_signal(NAME As TYPE, NAME As TYPE)\n\nEnd Signal\n"));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "460", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mDefinitions, Q7B_QOBJECT("Slot")))));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "460", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT("Sub NAME(NAME As TYPE, NAME As TYPE)\n\nEnd Slot\n"));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "462", 1);
Q7B_QTOOLBUTTON_MENU(tbDefinitions, Q7B_QOBJECT(mDefinitions));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "463", 1);
((QToolButton *) (tbDefinitions)->ref)->showMenu();
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "464", 1);
Q7B_QTOOLBUTTON_MENU(tbDefinitions, Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("CodeView.QWidget", "on_tbDefinitions_clicked", "466", 2);

}

void CodeView::Q7B_on_mDefinitions_triggered(Q7B Action)
{
                      Q7BS("CodeView.QWidget", "on_mDefinitions_triggered", "469", 0);
                      Q7BS("CodeView.QWidget", "on_mDefinitions_triggered", "469", 1);
this->InsertCodeAtCurrentPosition(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT("\n"), Q7B_QOBJECT(Q7B_QACTION_TAG(Action)))))));
                      Q7BS("CodeView.QWidget", "on_mDefinitions_triggered", "470", 2);

}

Q7B CodeView::GetOutlets()
{
                      Q7BS("CodeView.QWidget", "GetOutlets", "474", 0);
                      Q7BS("CodeView.QWidget", "GetOutlets", "475", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "GetOutlets", "476", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))));
                      Q7BS("CodeView.QWidget", "GetOutlets", "477", 1);
Q7B s2; s2 = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_FILEPATH(Q7B_QOBJECT(s))), Q7B_QOBJECT("/"))), Q7B_QOBJECT(Q7B_FILEBASENAME(Q7B_QOBJECT(s))))), Q7B_QOBJECT(".ui")))));
                      Q7BS("CodeView.QWidget", "GetOutlets", "479", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
                      Q7BS("CodeView.QWidget", "GetOutlets", "481", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(s2)))){
                      Q7BS("CodeView.QWidget", "GetOutlets", "482", 1);
Q7B_QMENU_CLEAR(mOutlets);
                      Q7BS("CodeView.QWidget", "GetOutlets", "484", 1);
Q7B k; k = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_READSTRING(Q7B_QOBJECT(s2), Q7B_QOBJECT("")))));
                      Q7BS("CodeView.QWidget", "GetOutlets", "487", 1);
Q7B sName; sName = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("CodeView.QWidget", "GetOutlets", "488", 1);
Q7B sType; sType = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("CodeView.QWidget", "GetOutlets", "490", 1);
Q7B n; n = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(k), Q7B_QOBJECT("<widget class=\""), Q7B_QOBJECT(0), Q7B_QOBJECT(true)))));
                      Q7BS("CodeView.QWidget", "GetOutlets", "492", 1);
while(Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(n), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "GetOutlets", "493", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n), Q7B_QOBJECT(15))))));
                      Q7BS("CodeView.QWidget", "GetOutlets", "494", 1);
Q7B n2; n2 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(k), Q7B_QOBJECT("\""), Q7B_QOBJECT(n), Q7B_QOBJECT(true)))));
                      Q7BS("CodeView.QWidget", "GetOutlets", "495", 1);
if (Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(n2), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "GetOutlets", "496", 1);
Q7B_ASSIGNMENT(&sType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(k), Q7B_QOBJECT(n), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(n2), Q7B_QOBJECT(n))))))));
                      Q7BS("CodeView.QWidget", "GetOutlets", "497", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(k), Q7B_QOBJECT("name=\""), Q7B_QOBJECT(n), Q7B_QOBJECT(true))))));
                      Q7BS("CodeView.QWidget", "GetOutlets", "498", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n), Q7B_QOBJECT(6))))));
                      Q7BS("CodeView.QWidget", "GetOutlets", "499", 1);
Q7B_ASSIGNMENT(&n2, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(k), Q7B_QOBJECT("\""), Q7B_QOBJECT(n), Q7B_QOBJECT(true))))));
                      Q7BS("CodeView.QWidget", "GetOutlets", "500", 1);
if (Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(n2), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "GetOutlets", "501", 1);
Q7B_ASSIGNMENT(&sName, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(k), Q7B_QOBJECT(n), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(n2), Q7B_QOBJECT(n))))))));
                      Q7BS("CodeView.QWidget", "GetOutlets", "503", 1);
Q7B_DICTIONARY_SETOBJECT(d, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sName), Q7B_QOBJECT(" As "))), Q7B_QOBJECT(sType))), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sName), Q7B_QOBJECT(" As "))), Q7B_QOBJECT(sType))));
}
}
                      Q7BS("CodeView.QWidget", "GetOutlets", "507", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(k), Q7B_QOBJECT("<widget class=\""), Q7B_QOBJECT(n), Q7B_QOBJECT(true))))));
}
                      Q7BS("CodeView.QWidget", "GetOutlets", "510", 1);
return Q7B_QOBJECT(d);
} else {
                      Q7BS("CodeView.QWidget", "GetOutlets", "512", 1);
Q7B__MSGBOX(Q7B_QOBJECT("There is no ui file for the current code available or there are no outlets in the ui file for the current code file."));
}
                      Q7BS("CodeView.QWidget", "GetOutlets", "515", 2);
return Q7B_IDNIL();

}

void CodeView::Q7B_on_tbSyncOutlets_clicked(Q7B Checked)
{
                      Q7BS("CodeView.QWidget", "on_tbSyncOutlets_clicked", "518", 0);
                      Q7BS("CodeView.QWidget", "on_tbSyncOutlets_clicked", "518", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_QOBJECT(this->GetOutlets())));
                      Q7BS("CodeView.QWidget", "on_tbSyncOutlets_clicked", "520", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(d), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("CodeView.QWidget", "on_tbSyncOutlets_clicked", "520", 1);
return;
}
                      Q7BS("CodeView.QWidget", "on_tbSyncOutlets_clicked", "522", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "on_tbSyncOutlets_clicked", "524", 1);
Q7B l; l = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_KEYS(d))));
                      Q7BS("CodeView.QWidget", "on_tbSyncOutlets_clicked", "526", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(l)), Q7B_QOBJECT(1))))); Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1))), Q7B_QOBJECT(0))) ? Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(0))) : Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(0))); Q7BS("CodeView.QWidget", "on_tbSyncOutlets_clicked", "526", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1))))))))){
                      Q7BS("CodeView.QWidget", "on_tbSyncOutlets_clicked", "528", 1);
this->InsertCode(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT("Outlet "), Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))))), Q7B_QOBJECT("\n"))))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
}
                      Q7BS("CodeView.QWidget", "on_tbSyncOutlets_clicked", "534", 2);

}

void CodeView::Q7B_on_tbOutlets_clicked(Q7B Checked)
{
                      Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "543", 0);
                      Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "544", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_QOBJECT(this->GetOutlets())));
                      Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "546", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(d), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "546", 1);
return;
}
                      Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "548", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "550", 1);
Q7B l; l = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_KEYS(d))));
                      Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "552", 1);
Q7B o; o = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "553", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(l)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "553", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "554", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_ISEMPTY(Q7B_QOBJECT(o))))) && Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(o), Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))), Q7B_QOBJECT(1)))))))){
                      Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "555", 1);
Q7B_QMENU_ADDSEPARATOR(mOutlets);
}
                      Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "557", 1);
Q7B_QMENU_ADDACTION(mOutlets, Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))));
                      Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "558", 1);
Q7B_ASSIGNMENT(&o, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))), Q7B_QOBJECT(1))))));
}
                      Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "561", 1);
Q7B_QTOOLBUTTON_MENU(tbOutlets, Q7B_QOBJECT(mOutlets));
                      Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "562", 1);
((QToolButton *) (tbOutlets)->ref)->showMenu();
                      Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "563", 1);
Q7B_QTOOLBUTTON_MENU(tbOutlets, Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("CodeView.QWidget", "on_tbOutlets_clicked", "565", 2);

}

void CodeView::Q7B_on_mOutlets_triggered(Q7B Action)
{
                      Q7BS("CodeView.QWidget", "on_mOutlets_triggered", "568", 0);
                      Q7BS("CodeView.QWidget", "on_mOutlets_triggered", "568", 1);
this->InsertCodeAtCurrentPosition(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT("\nOutlet "), Q7B_QOBJECT(Q7B_QACTION_TEXT(Action)))), Q7B_QOBJECT("\n"))))));
                      Q7BS("CodeView.QWidget", "on_mOutlets_triggered", "569", 2);

}

Q7B CodeView::GetSignals()
{
                      Q7BS("CodeView.QWidget", "GetSignals", "575", 0);
                      Q7BS("CodeView.QWidget", "GetSignals", "577", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "GetSignals", "578", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))));
                      Q7BS("CodeView.QWidget", "GetSignals", "579", 1);
Q7B s2; s2 = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_FILEPATH(Q7B_QOBJECT(s))), Q7B_QOBJECT("/"))), Q7B_QOBJECT(Q7B_FILEBASENAME(Q7B_QOBJECT(s))))), Q7B_QOBJECT(".ui")))));
                      Q7BS("CodeView.QWidget", "GetSignals", "581", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
                      Q7BS("CodeView.QWidget", "GetSignals", "583", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(s2)))){
                      Q7BS("CodeView.QWidget", "GetSignals", "584", 1);
Q7B_QMENU_CLEAR(mSignals);
                      Q7BS("CodeView.QWidget", "GetSignals", "586", 1);
Q7B k; k = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_READSTRING(Q7B_QOBJECT(s2), Q7B_QOBJECT("")))));
                      Q7BS("CodeView.QWidget", "GetSignals", "589", 1);
Q7B sName; sName = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("CodeView.QWidget", "GetSignals", "590", 1);
Q7B sType; sType = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("CodeView.QWidget", "GetSignals", "592", 1);
Q7B n; n = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(k), Q7B_QOBJECT("<widget class=\""), Q7B_QOBJECT(0), Q7B_QOBJECT(true)))));
                      Q7BS("CodeView.QWidget", "GetSignals", "594", 1);
while(Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(n), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "GetSignals", "596", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n), Q7B_QOBJECT(15))))));
                      Q7BS("CodeView.QWidget", "GetSignals", "597", 1);
Q7B n2; n2 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(k), Q7B_QOBJECT("\""), Q7B_QOBJECT(n), Q7B_QOBJECT(true)))));
                      Q7BS("CodeView.QWidget", "GetSignals", "598", 1);
if (Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(n2), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "GetSignals", "599", 1);
Q7B_ASSIGNMENT(&sType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(k), Q7B_QOBJECT(n), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(n2), Q7B_QOBJECT(n))))))));
                      Q7BS("CodeView.QWidget", "GetSignals", "600", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(k), Q7B_QOBJECT("name=\""), Q7B_QOBJECT(n), Q7B_QOBJECT(true))))));
                      Q7BS("CodeView.QWidget", "GetSignals", "601", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n), Q7B_QOBJECT(6))))));
                      Q7BS("CodeView.QWidget", "GetSignals", "602", 1);
Q7B_ASSIGNMENT(&n2, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(k), Q7B_QOBJECT("\""), Q7B_QOBJECT(n), Q7B_QOBJECT(true))))));
                      Q7BS("CodeView.QWidget", "GetSignals", "603", 1);
if (Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(n2), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "GetSignals", "604", 1);
Q7B_ASSIGNMENT(&sName, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(k), Q7B_QOBJECT(n), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(n2), Q7B_QOBJECT(n))))))));
                      Q7BS("CodeView.QWidget", "GetSignals", "606", 1);
Q7B_DICTIONARY_SETOBJECT(d, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sName), Q7B_QOBJECT(" As "))), Q7B_QOBJECT(sType))), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sName), Q7B_QOBJECT(" As "))), Q7B_QOBJECT(sType))));
}
}
                      Q7BS("CodeView.QWidget", "GetSignals", "610", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(k), Q7B_QOBJECT("<widget class=\""), Q7B_QOBJECT(n), Q7B_QOBJECT(true))))));
}
                      Q7BS("CodeView.QWidget", "GetSignals", "613", 1);
return Q7B_QOBJECT(d);
} else {
                      Q7BS("CodeView.QWidget", "GetSignals", "617", 1);
Q7B__MSGBOX(Q7B_QOBJECT("There is no ui file for the current code available or there are no outlets in the ui file for the current code file."));
}
                      Q7BS("CodeView.QWidget", "GetSignals", "620", 2);
return Q7B_IDNIL();

}

void CodeView::Q7B_on_tbSyncSignals_clicked(Q7B Checked)
{
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "625", 0);
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "625", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_QOBJECT(this->GetSignals())));
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "629", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(d), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "629", 1);
return;
}
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "631", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "633", 1);
Q7B l; l = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_KEYS(d))));
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "637", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(l)), Q7B_QOBJECT(1))))); Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1))), Q7B_QOBJECT(0))) ? Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(0))) : Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(0))); Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "637", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1))))))))){
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "639", 1);
Q7B le; le = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i)))));
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "640", 1);
Q7B n; n = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(le), Q7B_QOBJECT(" As "), Q7B_QOBJECT(0), Q7B_QOBJECT(true)))));
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "641", 1);
Q7B_ASSIGNMENT(&le, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_TRIM(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))), Q7B_QOBJECT(n))))))));
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "642", 1);
Q7B re; re = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_TRIM(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n), Q7B_QOBJECT(4))), Q7B_QOBJECT(-1)))))));
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "644", 1);
if (Q7B_CBOOLEAN(Q7B_DICTIONARY_CONTAINS(((Global *) Q7B_idGLOBAL->ref)->Signals_Tree, Q7B_QOBJECT(re)))){
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "646", 1);
Q7B aa; aa = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(((Global *) Q7B_idGLOBAL->ref)->Signals_Tree, Q7B_QOBJECT(re)))));
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "648", 1);
Q7B ii; ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "650", 1);
for (ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(ii), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(aa)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "650", 1),ii = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(ii), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "651", 1);
Q7B sKey; sKey = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(aa, Q7B_QOBJECT(ii)))));
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "655", 1);
if (Q7B_CBOOLEAN(Q7B_DICTIONARY_CONTAINS(((Global *) Q7B_idGLOBAL->ref)->Signals, Q7B_QOBJECT(sKey)))){
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "657", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(((Global *) Q7B_idGLOBAL->ref)->Signals, Q7B_QOBJECT(sKey)))));
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "661", 1);
Q7B ii; ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "663", 1);
for (ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1))), Q7B_QOBJECT(0))) ? Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(ii), Q7B_QOBJECT(0))) : Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(ii), Q7B_QOBJECT(0))); Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "663", 1),ii = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(ii), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1))))))))){
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "665", 1);
Q7B_ASSIGNMENT(&re, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(ii))))));
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "670", 1);
this->InsertCode(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT("Signal on_"), Q7B_QOBJECT(le))), Q7B_QOBJECT("_"))), Q7B_QOBJECT(re))), Q7B_QOBJECT("\n  \nEnd Signal\n\n"))))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
}
}
}
}
}
                      Q7BS("CodeView.QWidget", "on_tbSyncSignals_clicked", "682", 2);

}

void CodeView::Q7B_on_tbSignals_clicked(Q7B Checked)
{
                      Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "685", 0);
                      Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "686", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_QOBJECT(this->GetSignals())));
                      Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "688", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(d), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "688", 1);
return;
}
                      Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "690", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "692", 1);
Q7B l; l = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_KEYS(d))));
                      Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "694", 1);
Q7B o; o = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "695", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(l)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "695", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "696", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_ISEMPTY(Q7B_QOBJECT(o))))) && Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(o), Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))), Q7B_QOBJECT(1)))))))){
                      Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "697", 1);
Q7B_QMENU_ADDSEPARATOR(mSignals);
}
                      Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "699", 1);
Q7B_QMENU_ADDACTION(mSignals, Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))));
                      Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "700", 1);
Q7B_ASSIGNMENT(&o, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))), Q7B_QOBJECT(1))))));
}
                      Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "704", 1);
Q7B_QTOOLBUTTON_MENU(tbSignals, Q7B_QOBJECT(mSignals));
                      Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "705", 1);
((QToolButton *) (tbSignals)->ref)->showMenu();
                      Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "706", 1);
Q7B_QTOOLBUTTON_MENU(tbSignals, Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("CodeView.QWidget", "on_tbSignals_clicked", "708", 2);

}

void CodeView::Q7B_on_mSignals_triggered(Q7B Action)
{
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "714", 0);
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "715", 1);
Q7B_QMENU_CLEAR(mSignals2);
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "718", 1);
Q7B n; n = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(Q7B_QACTION_TEXT(Action)), Q7B_QOBJECT(" As"), Q7B_QOBJECT(0), Q7B_QOBJECT(true)))));
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "719", 1);
Q7B_ASSIGNMENT(&sControlName, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(Q7B_QACTION_TEXT(Action)), Q7B_QOBJECT(n))))));
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "720", 1);
Q7B sType; sType = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(Q7B_QACTION_TEXT(Action)), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n), Q7B_QOBJECT(4))), Q7B_QOBJECT(-1)))));
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "722", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "724", 1);
if (Q7B_CBOOLEAN(Q7B_DICTIONARY_CONTAINS(((Global *) Q7B_idGLOBAL->ref)->Signals_Tree, Q7B_QOBJECT(sType)))){
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "726", 1);
Q7B aa; aa = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(((Global *) Q7B_idGLOBAL->ref)->Signals_Tree, Q7B_QOBJECT(sType)))));
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "728", 1);
Q7B ii; ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "730", 1);
for (ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(ii), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(aa)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "on_mSignals_triggered", "730", 1),ii = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(ii), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "731", 1);
Q7B sKey; sKey = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(aa, Q7B_QOBJECT(ii)))));
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "733", 1);
if (Q7B_CBOOLEAN(Q7B_DICTIONARY_CONTAINS(((Global *) Q7B_idGLOBAL->ref)->Signals, Q7B_QOBJECT(sKey)))){
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "734", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(((Global *) Q7B_idGLOBAL->ref)->Signals, Q7B_QOBJECT(sKey)))));
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "735", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "737", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "on_mSignals_triggered", "737", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "738", 1);
Q7B_DICTIONARY_SETOBJECT(d, Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))), Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))));
}
}
}
}
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "748", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "750", 1);
Q7B l; l = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_KEYS(d))));
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "752", 1);
Q7B o; o = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "753", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(l)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "on_mSignals_triggered", "753", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "754", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_ISEMPTY(Q7B_QOBJECT(o))))) && Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(o), Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))), Q7B_QOBJECT(1)))))))){
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "755", 1);
Q7B_QMENU_ADDSEPARATOR(mSignals2);
}
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "757", 1);
Q7B_QMENU_ADDACTION(mSignals2, Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))));
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "758", 1);
Q7B_ASSIGNMENT(&o, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))), Q7B_QOBJECT(1))))));
}
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "768", 1);
Q7B_QTOOLBUTTON_MENU(tbSignals, Q7B_QOBJECT(mSignals2));
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "770", 1);
((QToolButton *) (tbSignals)->ref)->showMenu();
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "771", 1);
Q7B_QTOOLBUTTON_MENU(tbSignals, Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("CodeView.QWidget", "on_mSignals_triggered", "772", 2);

}

void CodeView::Q7B_on_mSignals2_triggered(Q7B Action)
{
                      Q7BS("CodeView.QWidget", "on_mSignals2_triggered", "775", 0);
                      Q7BS("CodeView.QWidget", "on_mSignals2_triggered", "775", 1);
this->InsertCodeAtCurrentPosition(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT("\nSignal on_"), Q7B_QOBJECT(sControlName))), Q7B_QOBJECT("_"))), Q7B_QOBJECT(Q7B_QACTION_TEXT(Action)))), Q7B_QOBJECT("\n   \nEnd Signal\n\n"))))));
                      Q7BS("CodeView.QWidget", "on_mSignals2_triggered", "776", 2);

}

Q7B CodeView::GetEvents()
{
                      Q7BS("CodeView.QWidget", "GetEvents", "784", 0);
                      Q7BS("CodeView.QWidget", "GetEvents", "786", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "GetEvents", "787", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("CodeView.QWidget", "GetEvents", "789", 1);
Q7B_QMENU_CLEAR(mEvents);
                      Q7BS("CodeView.QWidget", "GetEvents", "791", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
                      Q7BS("CodeView.QWidget", "GetEvents", "793", 1);
Q7B sType; sType = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_FILEEXTENSION(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))))));
                      Q7BS("CodeView.QWidget", "GetEvents", "796", 1);
if (Q7B_CBOOLEAN(Q7B_DICTIONARY_CONTAINS(((Global *) Q7B_idGLOBAL->ref)->Signals_Tree, Q7B_QOBJECT(sType)))){
                      Q7BS("CodeView.QWidget", "GetEvents", "798", 1);
Q7B aa; aa = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(((Global *) Q7B_idGLOBAL->ref)->Signals_Tree, Q7B_QOBJECT(sType)))));
                      Q7BS("CodeView.QWidget", "GetEvents", "800", 1);
Q7B ii; ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "GetEvents", "802", 1);
for (ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(ii), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(aa)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "GetEvents", "802", 1),ii = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(ii), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "GetEvents", "803", 1);
Q7B sKey; sKey = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(aa, Q7B_QOBJECT(ii)))));
                      Q7BS("CodeView.QWidget", "GetEvents", "805", 1);
if (Q7B_CBOOLEAN(Q7B_DICTIONARY_CONTAINS(((Global *) Q7B_idGLOBAL->ref)->Events, Q7B_QOBJECT(sKey)))){
                      Q7BS("CodeView.QWidget", "GetEvents", "806", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(((Global *) Q7B_idGLOBAL->ref)->Events, Q7B_QOBJECT(sKey)))));
                      Q7BS("CodeView.QWidget", "GetEvents", "807", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "GetEvents", "809", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "GetEvents", "809", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "GetEvents", "810", 1);
Q7B_DICTIONARY_SETOBJECT(d, Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))), Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))));
}
}
}
}
                      Q7BS("CodeView.QWidget", "GetEvents", "819", 1);
return Q7B_QOBJECT(d);
                      Q7BS("CodeView.QWidget", "GetEvents", "821", 2);
return Q7B_IDNIL();

}

void CodeView::Q7B_on_tbSyncEvents_clicked(Q7B Checked)
{
                      Q7BS("CodeView.QWidget", "on_tbSyncEvents_clicked", "824", 0);
                      Q7BS("CodeView.QWidget", "on_tbSyncEvents_clicked", "824", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_QOBJECT(this->GetEvents())));
                      Q7BS("CodeView.QWidget", "on_tbSyncEvents_clicked", "826", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(d), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("CodeView.QWidget", "on_tbSyncEvents_clicked", "826", 1);
return;
}
                      Q7BS("CodeView.QWidget", "on_tbSyncEvents_clicked", "828", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "on_tbSyncEvents_clicked", "830", 1);
Q7B l; l = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_KEYS(d))));
                      Q7BS("CodeView.QWidget", "on_tbSyncEvents_clicked", "832", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(l)), Q7B_QOBJECT(1))))); Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1))), Q7B_QOBJECT(0))) ? Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(0))) : Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(0))); Q7BS("CodeView.QWidget", "on_tbSyncEvents_clicked", "832", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1))))))))){
                      Q7BS("CodeView.QWidget", "on_tbSyncEvents_clicked", "834", 1);
this->InsertCode(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT("\nEvent "), Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))))), Q7B_QOBJECT("\n   \nEnd Event\n\n"))))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
}
                      Q7BS("CodeView.QWidget", "on_tbSyncEvents_clicked", "840", 2);

}

void CodeView::Q7B_on_tbEvents_clicked(Q7B Checked)
{
                      Q7BS("CodeView.QWidget", "on_tbEvents_clicked", "843", 0);
                      Q7BS("CodeView.QWidget", "on_tbEvents_clicked", "844", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_QOBJECT(this->GetEvents())));
                      Q7BS("CodeView.QWidget", "on_tbEvents_clicked", "846", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "on_tbEvents_clicked", "848", 1);
Q7B l; l = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_KEYS(d))));
                      Q7BS("CodeView.QWidget", "on_tbEvents_clicked", "850", 1);
Q7B o; o = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("CodeView.QWidget", "on_tbEvents_clicked", "851", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(l)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "on_tbEvents_clicked", "851", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "on_tbEvents_clicked", "852", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_ISEMPTY(Q7B_QOBJECT(o))))) && Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(o), Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))), Q7B_QOBJECT(1)))))))){
                      Q7BS("CodeView.QWidget", "on_tbEvents_clicked", "853", 1);
Q7B_QMENU_ADDSEPARATOR(mEvents);
}
                      Q7BS("CodeView.QWidget", "on_tbEvents_clicked", "855", 1);
Q7B_QMENU_ADDACTION(mEvents, Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))));
                      Q7BS("CodeView.QWidget", "on_tbEvents_clicked", "856", 1);
Q7B_ASSIGNMENT(&o, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(Q7B_LIST_OBJECT(l, Q7B_QOBJECT(i))), Q7B_QOBJECT(1))))));
}
                      Q7BS("CodeView.QWidget", "on_tbEvents_clicked", "859", 1);
Q7B_QTOOLBUTTON_MENU(tbEvents, Q7B_QOBJECT(mEvents));
                      Q7BS("CodeView.QWidget", "on_tbEvents_clicked", "860", 1);
((QToolButton *) (tbEvents)->ref)->showMenu();
                      Q7BS("CodeView.QWidget", "on_tbEvents_clicked", "861", 1);
Q7B_QTOOLBUTTON_MENU(tbEvents, Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("CodeView.QWidget", "on_tbEvents_clicked", "863", 2);

}

void CodeView::Q7B_on_mEvents_triggered(Q7B Action)
{
                      Q7BS("CodeView.QWidget", "on_mEvents_triggered", "866", 0);
                      Q7BS("CodeView.QWidget", "on_mEvents_triggered", "866", 1);
this->InsertCodeAtCurrentPosition(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT("\nEvent "), Q7B_QOBJECT(Q7B_QACTION_TEXT(Action)))), Q7B_QOBJECT("\n   \nEnd Event\n\n"))))));
                      Q7BS("CodeView.QWidget", "on_mEvents_triggered", "867", 2);

}

void CodeView::Q7B_on_cbDefinition_activated(Q7B Text)
{
                      Q7BS("CodeView.QWidget", "on_cbDefinition_activated", "876", 0);
                      Q7BS("CodeView.QWidget", "on_cbDefinition_activated", "876", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QCOMBOBOX_CURRENTINDEX(cbDefinition)), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "on_cbDefinition_activated", "877", 1);
return;
}
                      Q7BS("CodeView.QWidget", "on_cbDefinition_activated", "880", 1);
if (Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(Q7B_QCOMBOBOX_CURRENTINDEX(cbDefinition)), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "on_cbDefinition_activated", "881", 1);
Q7B_QCOMBOBOX_CURRENTINDEX(cbDefinition, Q7B_QOBJECT(0));
}
                      Q7BS("CodeView.QWidget", "on_cbDefinition_activated", "884", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "on_cbDefinition_activated", "885", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("CodeView.QWidget", "on_cbDefinition_activated", "887", 1);
Q7B te; te = Q7B__QPLAINTEXTEDIT(Q7B_QPLAINTEXTEDIT_INIT(this, "te"));
                      Q7BS("CodeView.QWidget", "on_cbDefinition_activated", "888", 1);
Q7B_ASSIGNMENT(&te, &Q7B__QPLAINTEXTEDIT(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCodeView *) (cb)->ref)->getQPlainTextEdit()))));
                      Q7BS("CodeView.QWidget", "on_cbDefinition_activated", "889", 1);
((QPlainTextEdit *) (te)->ref)->insertPlainText(Q7B_CQSTRING(Q7B_QOBJECT(Text)));
                      Q7BS("CodeView.QWidget", "on_cbDefinition_activated", "890", 2);

}

void CodeView::Q7B_on_cbCondition_activated(Q7B Text)
{
                      Q7BS("CodeView.QWidget", "on_cbCondition_activated", "895", 0);
                      Q7BS("CodeView.QWidget", "on_cbCondition_activated", "895", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QCOMBOBOX_CURRENTINDEX(cbCondition)), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "on_cbCondition_activated", "896", 1);
return;
}
                      Q7BS("CodeView.QWidget", "on_cbCondition_activated", "898", 1);
if (Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(Q7B_QCOMBOBOX_CURRENTINDEX(cbCondition)), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "on_cbCondition_activated", "899", 1);
Q7B_QCOMBOBOX_CURRENTINDEX(cbCondition, Q7B_QOBJECT(0));
}
                      Q7BS("CodeView.QWidget", "on_cbCondition_activated", "902", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "on_cbCondition_activated", "903", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("CodeView.QWidget", "on_cbCondition_activated", "905", 1);
Q7B te; te = Q7B__QPLAINTEXTEDIT(Q7B_QPLAINTEXTEDIT_INIT(this, "te"));
                      Q7BS("CodeView.QWidget", "on_cbCondition_activated", "906", 1);
Q7B_ASSIGNMENT(&te, &Q7B__QPLAINTEXTEDIT(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCodeView *) (cb)->ref)->getQPlainTextEdit()))));
                      Q7BS("CodeView.QWidget", "on_cbCondition_activated", "907", 1);
((QPlainTextEdit *) (te)->ref)->insertPlainText(Q7B_CQSTRING(Q7B_QOBJECT(Text)));
                      Q7BS("CodeView.QWidget", "on_cbCondition_activated", "908", 2);

}

void CodeView::Q7B_on_cbLoop_activated(Q7B Text)
{
                      Q7BS("CodeView.QWidget", "on_cbLoop_activated", "913", 0);
                      Q7BS("CodeView.QWidget", "on_cbLoop_activated", "913", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QCOMBOBOX_CURRENTINDEX(cbLoop)), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "on_cbLoop_activated", "914", 1);
return;
}
                      Q7BS("CodeView.QWidget", "on_cbLoop_activated", "917", 1);
if (Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(Q7B_QCOMBOBOX_CURRENTINDEX(cbLoop)), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "on_cbLoop_activated", "918", 1);
Q7B_QCOMBOBOX_CURRENTINDEX(cbLoop, Q7B_QOBJECT(0));
}
                      Q7BS("CodeView.QWidget", "on_cbLoop_activated", "921", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "on_cbLoop_activated", "922", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("CodeView.QWidget", "on_cbLoop_activated", "924", 1);
Q7B te; te = Q7B__QPLAINTEXTEDIT(Q7B_QPLAINTEXTEDIT_INIT(this, "te"));
                      Q7BS("CodeView.QWidget", "on_cbLoop_activated", "925", 1);
Q7B_ASSIGNMENT(&te, &Q7B__QPLAINTEXTEDIT(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCodeView *) (cb)->ref)->getQPlainTextEdit()))));
                      Q7BS("CodeView.QWidget", "on_cbLoop_activated", "926", 1);
((QPlainTextEdit *) (te)->ref)->insertPlainText(Q7B_CQSTRING(Q7B_QOBJECT(Text)));
                      Q7BS("CodeView.QWidget", "on_cbLoop_activated", "927", 2);

}

void CodeView::Q7B_on_Q7BCodeBox_GetCompletion(Q7B sCompletion)
{
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "932", 0);
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "935", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "937", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "938", 1);
Q7B tv; tv = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "943", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "946", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sCompletion), Q7B_QOBJECT("!?$%&/()=?")))){
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "948", 1);
Q7B aKey; aKey = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_KEYS(((Global *) Q7B_idGLOBAL->ref)->dCompletion2function))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "950", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(aKey)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "950", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "951", 1);
Q7B_LIST_APPEND(a, Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(((Global *) Q7B_idGLOBAL->ref)->dCompletion2function, Q7B_QOBJECT(Q7B_LIST_OBJECT(aKey, Q7B_QOBJECT(i))))));
}
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "954", 1);
Q7B__MSGBOX(Q7B_QOBJECT(a));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "956", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(Global::ObjectiveBasicConsts)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "956", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "957", 1);
Q7B_LIST_APPEND(a, Q7B_QOBJECT(Q7B_LIST_OBJECT(Global::ObjectiveBasicConsts, Q7B_QOBJECT(i))));
}
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "960", 1);
Q7B__MSGBOX(Q7B_QOBJECT(a));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "962", 1);
Q7B ll; ll = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Parser::q7b_sharedSingleton()->GetCustomClassIdentifiers(Q7B_QWIDGET(Q7B_QOBJECT(w)), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_FILEBASENAME(Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))))))))))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "964", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(ll)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "964", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "965", 1);
Q7B_LIST_APPEND(a, Q7B_QOBJECT(Q7B_LIST_OBJECT(ll, Q7B_QOBJECT(i))));
}
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "968", 1);
Q7B__MSGBOX(Q7B_QOBJECT(a));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "970", 1);
((Q7BCodeView *) (tv)->ref)->SetCompletion(Q7B_CQSTRINGLIST(Q7B_QOBJECT(a)));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "971", 1);
return;
}
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "978", 1);
if (Q7B_CBOOLEAN(Q7B_DICTIONARY_CONTAINS(Global::dObjectCompletion, Q7B_QOBJECT(sCompletion)))){
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "980", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(Global::dObjectCompletion, Q7B_QOBJECT(sCompletion)))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "981", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_DICTIONARY_LENGTH(d)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "981", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "982", 1);
Q7B b; b = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(d, Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(i), Q7B_QOBJECT(false)))))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "983", 1);
Q7B_LIST_APPEND(a, Q7B_QOBJECT(Q7B_LIST_OBJECT(b, Q7B_QOBJECT(1))));
}
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "986", 1);
((Q7BCodeView *) (tv)->ref)->SetCompletion(Q7B_CQSTRINGLIST(Q7B_QOBJECT(a)));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "987", 1);
return;
}
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "991", 1);
Q7B sType; sType = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Parser::q7b_sharedSingleton()->FindType(Q7B_QWIDGET(Q7B_QOBJECT(w)), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sCompletion))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)))))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "1003", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sType))), Q7B_QOBJECT(0)))){
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "1004", 1);
((Q7BCodeView *) (tv)->ref)->SetCompletion(Q7B_CQSTRINGLIST(Q7B_QOBJECT(Q7B_List::init())));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "1005", 1);
return;
}
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "1010", 1);
if (Q7B_CBOOLEAN(Q7B_DICTIONARY_CONTAINS(Global::dClassCompletion, Q7B_QOBJECT(sType)))){
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "1012", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(Global::dClassCompletion, Q7B_QOBJECT(sType)))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "1014", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_DICTIONARY_LENGTH(d)), Q7B_QOBJECT(1))))); Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "1014", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "1015", 1);
Q7B b; b = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(d, Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(i), Q7B_QOBJECT(false)))))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "1016", 1);
Q7B_LIST_APPEND(a, Q7B_QOBJECT(Q7B_LIST_OBJECT(b, Q7B_QOBJECT(1))));
}
} else {
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "1019", 1);
Q7B_ASSIGNMENT(&a, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Parser::q7b_sharedSingleton()->GetCustomClassIdentifiers(Q7B_QWIDGET(Q7B_QOBJECT(w)), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sType))))))));
}
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "1022", 1);
((Q7BCodeView *) (tv)->ref)->SetCompletion(Q7B_CQSTRINGLIST(Q7B_QOBJECT(a)));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "1023", 1);
return;
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion", "1025", 2);

}

void CodeView::Q7B_on_Q7BCodeBox_GetCompletion2(Q7B sCompletion)
{
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1029", 0);
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1038", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1039", 1);
Q7B tv; tv = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1041", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_CONTAINS(Q7B_QOBJECT(sCompletion), Q7B_QOBJECT("."), Q7B_QOBJECT(false))), Q7B_QOBJECT(false)))){
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1042", 1);
if (Q7B_CBOOLEAN(Q7B_DICTIONARY_CONTAINS(((Global *) Q7B_idGLOBAL->ref)->dCompletion2function, Q7B_QOBJECT(Q7B_LCASE(Q7B_QOBJECT(sCompletion)))))){
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1043", 1);
((Q7BCodeView *) (tv)->ref)->SetCompletion2(Q7B_CQSTRING(Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(((Global *) Q7B_idGLOBAL->ref)->dCompletion2function, Q7B_QOBJECT(Q7B_LCASE(Q7B_QOBJECT(sCompletion)))))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1044", 1);
return;
}
}
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1047", 1);
Q7B sType; sType = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Parser::q7b_sharedSingleton()->FindType(Q7B_QWIDGET(Q7B_QOBJECT(w)), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sCompletion))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true)))))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1050", 1);
if (Q7B_CBOOLEAN(Q7B_DICTIONARY_CONTAINS(Global::dClassCompletion, Q7B_QOBJECT(sType)))){
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1051", 1);
Q7B n; n = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTRREV(Q7B_QOBJECT(sCompletion), Q7B_QOBJECT("."), Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sCompletion))), Q7B_QOBJECT(false)))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1053", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(sCompletion), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n), Q7B_QOBJECT(1))), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sCompletion))), Q7B_QOBJECT(n))), Q7B_QOBJECT(1)))))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1055", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(Global::dClassCompletion, Q7B_QOBJECT(sType)))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1056", 1);
Q7B b; b = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(d, Q7B_QOBJECT(s)))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1058", 1);
if (Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(b), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1059", 1);
((Q7BCodeView *) (tv)->ref)->SetCompletion2(Q7B_CQSTRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(b, Q7B_QOBJECT(1)))));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1060", 1);
return;
}
}
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1064", 1);
((Q7BCodeView *) (tv)->ref)->SetCompletion2(Q7B_CQSTRING(Q7B_QOBJECT("")));
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1065", 1);
return;
                      Q7BS("CodeView.QWidget", "on_Q7BCodeBox_GetCompletion2", "1066", 2);

}


