
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/
 #ifndef codeview_h
#define codeview_h

#include <QtGui>


#ifdef Q_WS_X11
  #include <phonon>
#else
  #include <Phonon>
#endif
#include "Q7BRuntime.h"

#include "Global.h"

namespace Ui {
  class CodeView;
}


extern QMap<QString, Q7B>q7b_ui;
class CodeView;
 extern CodeView *q7b_CodeView_sharedSingleton;
 extern Q7B q7b_CodeView_sharedSingletonQ7B;
extern bool q7b_CodeView_sharedSingletonFinalized;
extern bool q7b_CodeView_sharedSingletonInit;
class CodeView : public QWidget
{
Q_OBJECT
public:

CodeView(Q7B _q7b_this, QWidget *parent = 0);
CodeView(QWidget *parent = 0);
Ui::CodeView *ui;

~CodeView();
CodeView(Q7B _q7b_this);
Q7B GetActions();
Q7B Load(Q7B sFileName);
Q7B Save();
Q7B SaveIfChanged();
void CloseEvent(Q7B e);
void closeEvent(QCloseEvent *e)
{
  this->CloseEvent(Q7B_QOBJECT(e));
  if (e->isAccepted()) q7b_CodeView_sharedSingleton = 0;
}

void InsertCodeAtCurrentPosition(Q7B s);
void InsertCode(Q7B s, Q7B bGoto);
Q7B GetOutlets();
Q7B GetSignals();
Q7B GetEvents();

public slots:
void Q7B_on_gr_buttonClicked(Q7B theButton);
void on_gr_buttonClicked(QAbstractButton *theButton)
{
  this->Q7B_on_gr_buttonClicked(Q7B_QOBJECT(theButton));
}

void Q7B_on_delayed();
void Q7B_on_singleshot();
void Q7B_on_Q7BCodeBox_GetCompletion_(QString sCompletion)
{
  this->Q7B_on_Q7BCodeBox_GetCompletion(Q7B_QOBJECT(sCompletion));
}

void Q7B_on_Q7BCodeBox_GetCompletion2_(QString sCompletion)
{
  this->Q7B_on_Q7BCodeBox_GetCompletion2(Q7B_QOBJECT(sCompletion));
}

void Q7B_on_Q7BCodeBox_textChanged_()
{
  this->Q7B_on_Q7BCodeBox_textChanged();
}

void Q7B_on_Q7BCodeBox_cursorPositionChanged_()
{
  this->Q7B_on_Q7BCodeBox_cursorPositionChanged();
}

void Q7B_on_Q7BCodeBox_CopyAvailable_(bool b)
{
  this->Q7B_on_Q7BCodeBox_CopyAvailable(Q7B_QOBJECT(b));
}

void Q7B_on_Q7BCodeBox_PasteAvailable_(bool b)
{
  this->Q7B_on_Q7BCodeBox_PasteAvailable(Q7B_QOBJECT(b));
}

void Q7B_on_Q7BCodeBox_UndoAvailable_(bool b)
{
  this->Q7B_on_Q7BCodeBox_UndoAvailable(Q7B_QOBJECT(b));
}

void Q7B_on_Q7BCodeBox_RedoAvailable_(bool b)
{
  this->Q7B_on_Q7BCodeBox_RedoAvailable(Q7B_QOBJECT(b));
}

void Q7B_on_tbSyncActions_clicked(Q7B Checked);
void on_tbSyncActions_clicked(bool checked = false)
{
  this->Q7B_on_tbSyncActions_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_tbActions_clicked(Q7B Checked);
void on_tbActions_clicked(bool checked = false)
{
  this->Q7B_on_tbActions_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_mActions_triggered(Q7B Action);
void on_mActions_triggered(QAction *action)
{
  this->Q7B_on_mActions_triggered(Q7B_QOBJECT(action));
}

void Q7B_on_Q7BCodeBox_textChanged();
void on_Q7BCodeBox_textChanged()
{
  this->Q7B_on_Q7BCodeBox_textChanged();
}

void Q7B_LastPositionTimer();
void Q7B_on_Q7BCodeBox_cursorPositionChanged();
void on_Q7BCodeBox_cursorPositionChanged()
{
  this->Q7B_on_Q7BCodeBox_cursorPositionChanged();
}

void Q7B_on_Q7BCodeBox_CopyAvailable(Q7B b);
void Q7B_on_Q7BCodeBox_PasteAvailable(Q7B b);
void Q7B_on_Q7BCodeBox_UndoAvailable(Q7B b);
void Q7B_on_Q7BCodeBox_RedoAvailable(Q7B b);
void Q7B_on_tbShiftLeft_clicked(Q7B Checked);
void on_tbShiftLeft_clicked(bool checked = false)
{
  this->Q7B_on_tbShiftLeft_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_tbShiftRight_clicked(Q7B Checked);
void on_tbShiftRight_clicked(bool checked = false)
{
  this->Q7B_on_tbShiftRight_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_tbComment_clicked(Q7B Checked);
void on_tbComment_clicked(bool checked = false)
{
  this->Q7B_on_tbComment_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_tbUncomment_clicked(Q7B Checked);
void on_tbUncomment_clicked(bool checked = false)
{
  this->Q7B_on_tbUncomment_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_tbLoops_clicked(Q7B Checked);
void on_tbLoops_clicked(bool checked = false)
{
  this->Q7B_on_tbLoops_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_mLoops_triggered(Q7B Action);
void on_mLoops_triggered(QAction *action)
{
  this->Q7B_on_mLoops_triggered(Q7B_QOBJECT(action));
}

void Q7B_on_tbConditions_clicked(Q7B Checked);
void on_tbConditions_clicked(bool checked = false)
{
  this->Q7B_on_tbConditions_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_mConditions_triggered(Q7B Action);
void on_mConditions_triggered(QAction *action)
{
  this->Q7B_on_mConditions_triggered(Q7B_QOBJECT(action));
}

void Q7B_on_tbDefinitions_clicked(Q7B Checked);
void on_tbDefinitions_clicked(bool checked = false)
{
  this->Q7B_on_tbDefinitions_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_mDefinitions_triggered(Q7B Action);
void on_mDefinitions_triggered(QAction *action)
{
  this->Q7B_on_mDefinitions_triggered(Q7B_QOBJECT(action));
}

void Q7B_on_tbSyncOutlets_clicked(Q7B Checked);
void on_tbSyncOutlets_clicked(bool checked = false)
{
  this->Q7B_on_tbSyncOutlets_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_tbOutlets_clicked(Q7B Checked);
void on_tbOutlets_clicked(bool checked = false)
{
  this->Q7B_on_tbOutlets_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_mOutlets_triggered(Q7B Action);
void on_mOutlets_triggered(QAction *action)
{
  this->Q7B_on_mOutlets_triggered(Q7B_QOBJECT(action));
}

void Q7B_on_tbSyncSignals_clicked(Q7B Checked);
void on_tbSyncSignals_clicked(bool checked = false)
{
  this->Q7B_on_tbSyncSignals_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_tbSignals_clicked(Q7B Checked);
void on_tbSignals_clicked(bool checked = false)
{
  this->Q7B_on_tbSignals_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_mSignals_triggered(Q7B Action);
void on_mSignals_triggered(QAction *action)
{
  this->Q7B_on_mSignals_triggered(Q7B_QOBJECT(action));
}

void Q7B_on_mSignals2_triggered(Q7B Action);
void on_mSignals2_triggered(QAction *action)
{
  this->Q7B_on_mSignals2_triggered(Q7B_QOBJECT(action));
}

void Q7B_on_tbSyncEvents_clicked(Q7B Checked);
void on_tbSyncEvents_clicked(bool checked = false)
{
  this->Q7B_on_tbSyncEvents_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_tbEvents_clicked(Q7B Checked);
void on_tbEvents_clicked(bool checked = false)
{
  this->Q7B_on_tbEvents_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_mEvents_triggered(Q7B Action);
void on_mEvents_triggered(QAction *action)
{
  this->Q7B_on_mEvents_triggered(Q7B_QOBJECT(action));
}

void Q7B_on_cbDefinition_activated(Q7B Text);
void on_cbDefinition_activated(const QString  & text)
{
  this->Q7B_on_cbDefinition_activated(Q7B_QOBJECT(text));
}

void on_cbDefinition_activated(QSystemTrayIcon::ActivationReason reason)
{
  this->Q7B_on_cbDefinition_activated(Q7B_QOBJECT((qint64) reason));
}

void Q7B_on_cbCondition_activated(Q7B Text);
void on_cbCondition_activated(const QString  & text)
{
  this->Q7B_on_cbCondition_activated(Q7B_QOBJECT(text));
}

void on_cbCondition_activated(QSystemTrayIcon::ActivationReason reason)
{
  this->Q7B_on_cbCondition_activated(Q7B_QOBJECT((qint64) reason));
}

void Q7B_on_cbLoop_activated(Q7B Text);
void on_cbLoop_activated(const QString  & text)
{
  this->Q7B_on_cbLoop_activated(Q7B_QOBJECT(text));
}

void on_cbLoop_activated(QSystemTrayIcon::ActivationReason reason)
{
  this->Q7B_on_cbLoop_activated(Q7B_QOBJECT((qint64) reason));
}

void Q7B_on_Q7BCodeBox_GetCompletion(Q7B sCompletion);
void Q7B_on_Q7BCodeBox_GetCompletion2(Q7B sCompletion);
public:
public:
Q7B gr;
Q7B Q7BCodeBox;
Q7B tbDefinitions;
Q7B tbConditions;
Q7B tbLoops;
Q7B tbOutlets;
Q7B tbSignals;
Q7B tbEvents;
Q7B tbActions;
Q7B mActions;
Q7B lLine;
Q7B tbShiftLeft;
Q7B tbShiftRight;
Q7B tbComment;
Q7B tbUncomment;
Q7B bLoading;
Q7B nChanged;
Q7B toSave;
Q7B lInsertMessage;
Q7B mLoops;
Q7B mConditions;
Q7B mDefinitions;
Q7B mOutlets;
Q7B mSignals;
Q7B mSignals2;
Q7B sControlName;
Q7B mEvents;
Q7B cbDefinition;
Q7B cbCondition;
Q7B cbLoop;


private:
Q7B q7b_this;


public:
static Q7B q7b_sharedSingletonQ7B()
{
q7b_sharedSingleton();
return q7b_CodeView_sharedSingletonQ7B;
};


static CodeView* q7b_sharedSingleton()
{
if (q7b_CodeView_sharedSingletonFinalized) return 0;
if (q7b_CodeView_sharedSingleton == 0){
q7b_CodeView_sharedSingletonInit = true;
if (q7b_ui.contains("CodeView")){
  q7b_CodeView_sharedSingleton = (CodeView *) (QWidget *) q7b_ui["CodeView"]->ref; 
} else {
  q7b_CodeView_sharedSingleton = new CodeView(q7b_CodeView_sharedSingletonQ7B, 0);
}
}
return q7b_CodeView_sharedSingleton;
}



void Set_gr(Q7B q7b_var){ gr = q7b_var; }
Q7B Get_gr(){ return gr; }
void Set_Q7BCodeBox(Q7B q7b_var){ Q7BCodeBox = q7b_var; }
Q7B Get_Q7BCodeBox(){ return Q7BCodeBox; }
void Set_tbDefinitions(Q7B q7b_var){ tbDefinitions = q7b_var; }
Q7B Get_tbDefinitions(){ return tbDefinitions; }
void Set_tbConditions(Q7B q7b_var){ tbConditions = q7b_var; }
Q7B Get_tbConditions(){ return tbConditions; }
void Set_tbLoops(Q7B q7b_var){ tbLoops = q7b_var; }
Q7B Get_tbLoops(){ return tbLoops; }
void Set_tbOutlets(Q7B q7b_var){ tbOutlets = q7b_var; }
Q7B Get_tbOutlets(){ return tbOutlets; }
void Set_tbSignals(Q7B q7b_var){ tbSignals = q7b_var; }
Q7B Get_tbSignals(){ return tbSignals; }
void Set_tbEvents(Q7B q7b_var){ tbEvents = q7b_var; }
Q7B Get_tbEvents(){ return tbEvents; }
void Set_tbActions(Q7B q7b_var){ tbActions = q7b_var; }
Q7B Get_tbActions(){ return tbActions; }
void Set_mActions(Q7B q7b_var){ mActions = q7b_var; }
Q7B Get_mActions(){ return mActions; }
void Set_lLine(Q7B q7b_var){ lLine = q7b_var; }
Q7B Get_lLine(){ return lLine; }
void Set_tbShiftLeft(Q7B q7b_var){ tbShiftLeft = q7b_var; }
Q7B Get_tbShiftLeft(){ return tbShiftLeft; }
void Set_tbShiftRight(Q7B q7b_var){ tbShiftRight = q7b_var; }
Q7B Get_tbShiftRight(){ return tbShiftRight; }
void Set_tbComment(Q7B q7b_var){ tbComment = q7b_var; }
Q7B Get_tbComment(){ return tbComment; }
void Set_tbUncomment(Q7B q7b_var){ tbUncomment = q7b_var; }
Q7B Get_tbUncomment(){ return tbUncomment; }
void Set_bLoading(Q7B q7b_var){ bLoading = q7b_var; }
Q7B Get_bLoading(){ return bLoading; }
void Set_nChanged(Q7B q7b_var){ nChanged = q7b_var; }
Q7B Get_nChanged(){ return nChanged; }
void Set_toSave(Q7B q7b_var){ toSave = q7b_var; }
Q7B Get_toSave(){ return toSave; }
void Set_lInsertMessage(Q7B q7b_var){ lInsertMessage = q7b_var; }
Q7B Get_lInsertMessage(){ return lInsertMessage; }
void Set_mLoops(Q7B q7b_var){ mLoops = q7b_var; }
Q7B Get_mLoops(){ return mLoops; }
void Set_mConditions(Q7B q7b_var){ mConditions = q7b_var; }
Q7B Get_mConditions(){ return mConditions; }
void Set_mDefinitions(Q7B q7b_var){ mDefinitions = q7b_var; }
Q7B Get_mDefinitions(){ return mDefinitions; }
void Set_mOutlets(Q7B q7b_var){ mOutlets = q7b_var; }
Q7B Get_mOutlets(){ return mOutlets; }
void Set_mSignals(Q7B q7b_var){ mSignals = q7b_var; }
Q7B Get_mSignals(){ return mSignals; }
void Set_mSignals2(Q7B q7b_var){ mSignals2 = q7b_var; }
Q7B Get_mSignals2(){ return mSignals2; }
void Set_sControlName(Q7B q7b_var){ sControlName = q7b_var; }
Q7B Get_sControlName(){ return sControlName; }
void Set_mEvents(Q7B q7b_var){ mEvents = q7b_var; }
Q7B Get_mEvents(){ return mEvents; }
void Set_cbDefinition(Q7B q7b_var){ cbDefinition = q7b_var; }
Q7B Get_cbDefinition(){ return cbDefinition; }
void Set_cbCondition(Q7B q7b_var){ cbCondition = q7b_var; }
Q7B Get_cbCondition(){ return cbCondition; }
void Set_cbLoop(Q7B q7b_var){ cbLoop = q7b_var; }
Q7B Get_cbLoop(){ return cbLoop; }

};
#endif
