
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/
 #ifndef findreplacefile_h
#define findreplacefile_h

#include <QtGui>


#ifdef Q_WS_X11
  #include <phonon>
#else
  #include <Phonon>
#endif
#include "Q7BRuntime.h"

#include "Global.h"

namespace Ui {
  class FindReplaceFile;
}


extern QMap<QString, Q7B>q7b_ui;
class FindReplaceFile;
 extern FindReplaceFile *q7b_FindReplaceFile_sharedSingleton;
 extern Q7B q7b_FindReplaceFile_sharedSingletonQ7B;
extern bool q7b_FindReplaceFile_sharedSingletonFinalized;
extern bool q7b_FindReplaceFile_sharedSingletonInit;
class FindReplaceFile : public QDialog
{
Q_OBJECT
public:

FindReplaceFile(Q7B _q7b_this, QWidget *parent = 0);
FindReplaceFile(QWidget *parent = 0);
Ui::FindReplaceFile *ui;

~FindReplaceFile();
FindReplaceFile(Q7B _q7b_this);
void perform_pbFindAll();
void perform_pbReplaceAll();
void ReloadData();

public slots:
void Q7B_on_tableWidget_cellDoubleClicked_(int row, int column)
{
  this->Q7B_on_tableWidget_cellDoubleClicked(Q7B_QOBJECT(row), Q7B_QOBJECT(column));
}

void Q7B_on_FindInFile_clicked(Q7B Checked);
void on_FindInFile_clicked(bool checked = false)
{
  this->Q7B_on_FindInFile_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_ReplaceInFile_clicked(Q7B Checked);
void on_ReplaceInFile_clicked(bool checked = false)
{
  this->Q7B_on_ReplaceInFile_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_tableWidget_cellDoubleClicked(Q7B row, Q7B column);
public:
public:
Q7B cbFind;
Q7B cbReplace;
Q7B cbIgnoreCase;
Q7B cbIgnoreCommentLines;
Q7B cbCurrentFileOnly;
Q7B lInfo;
Q7B tableWidget;
Q7B files;
Q7B bFirst;


private:
Q7B q7b_this;


public:
static Q7B q7b_sharedSingletonQ7B()
{
q7b_sharedSingleton();
return q7b_FindReplaceFile_sharedSingletonQ7B;
};


static FindReplaceFile* q7b_sharedSingleton()
{
if (q7b_FindReplaceFile_sharedSingletonFinalized) return 0;
if (q7b_FindReplaceFile_sharedSingleton == 0){
q7b_FindReplaceFile_sharedSingletonInit = true;
if (q7b_ui.contains("FindReplaceFile")){
  q7b_FindReplaceFile_sharedSingleton = (FindReplaceFile *) (QWidget *) q7b_ui["FindReplaceFile"]->ref; 
} else {
  q7b_FindReplaceFile_sharedSingleton = new FindReplaceFile(q7b_FindReplaceFile_sharedSingletonQ7B, 0);
}
}
return q7b_FindReplaceFile_sharedSingleton;
}



void Set_cbFind(Q7B q7b_var){ cbFind = q7b_var; }
Q7B Get_cbFind(){ return cbFind; }
void Set_cbReplace(Q7B q7b_var){ cbReplace = q7b_var; }
Q7B Get_cbReplace(){ return cbReplace; }
void Set_cbIgnoreCase(Q7B q7b_var){ cbIgnoreCase = q7b_var; }
Q7B Get_cbIgnoreCase(){ return cbIgnoreCase; }
void Set_cbIgnoreCommentLines(Q7B q7b_var){ cbIgnoreCommentLines = q7b_var; }
Q7B Get_cbIgnoreCommentLines(){ return cbIgnoreCommentLines; }
void Set_cbCurrentFileOnly(Q7B q7b_var){ cbCurrentFileOnly = q7b_var; }
Q7B Get_cbCurrentFileOnly(){ return cbCurrentFileOnly; }
void Set_lInfo(Q7B q7b_var){ lInfo = q7b_var; }
Q7B Get_lInfo(){ return lInfo; }
void Set_tableWidget(Q7B q7b_var){ tableWidget = q7b_var; }
Q7B Get_tableWidget(){ return tableWidget; }
void Set_files(Q7B q7b_var){ files = q7b_var; }
Q7B Get_files(){ return files; }
void Set_bFirst(Q7B q7b_var){ bFirst = q7b_var; }
Q7B Get_bFirst(){ return bFirst; }

};
#endif
