
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/
 #ifndef mainwindow_h
#define mainwindow_h

#include <QtGui>


#ifdef Q_WS_X11
  #include <phonon>
#else
  #include <Phonon>
#endif
#include "Q7BRuntime.h"

#include "Global.h"

namespace Ui {
  class MainWindow;
}


extern QMap<QString, Q7B>q7b_ui;
extern Q7B Q7B_idMAINWINDOW;
class MainWindow;
 extern MainWindow *q7b_MainWindow_sharedSingleton;
 extern Q7B q7b_MainWindow_sharedSingletonQ7B;
extern bool q7b_MainWindow_sharedSingletonFinalized;
extern bool q7b_MainWindow_sharedSingletonInit;
class MainWindow : public QMainWindow
{
Q_OBJECT
public:

MainWindow(Q7B _q7b_this, QWidget *parent = 0);
MainWindow(QWidget *parent = 0);
Ui::MainWindow *ui;

~MainWindow();
void UpdateRecentProjects(Q7B sNewlyOpenedProject);
MainWindow(Q7B _q7b_this);
void SetWindowTitle(Q7B s);
void RequeryUIFiles();
Q7B ExampleMenuIsProjectDir(Q7B s);
void BuildExampleMenu(Q7B menu, Q7B s);
void ReopenCode(Q7B PathFileName, Q7B nGoto);
void ReopenCodeAndLoadBefore(Q7B PathFileName, Q7B nGoto);
void PrintStatusBar(Q7B s);
void ShowLastError(Q7B Text, Q7B sFileName, Q7B nLine);
void ShowError(Q7B sError);
Q7B CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary();
void cleanandrebuildall(Q7B bDeployment);
void DoActions();
void ResetDebugPosition();
void myStop();
void ShowInternalError(Q7B s);
Q7B getCurrentFileName();
void OpenUI(Q7B s, Q7B s2);
void Configuration(Q7B Action, Q7B bRebuild);
void CloseEvent(Q7B e);
void closeEvent(QCloseEvent *e)
{
  this->CloseEvent(Q7B_QOBJECT(e));
  if (e->isAccepted()) q7b_MainWindow_sharedSingleton = 0;
}


public slots:
void Q7B_on_actionQt_Quick_Manual_triggered(Q7B Checked);
void on_actionQt_Quick_Manual_triggered(bool checked)
{
  this->Q7B_on_actionQt_Quick_Manual_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionQt_Quick_triggered(Q7B Checked);
void on_actionQt_Quick_triggered(bool checked)
{
  this->Q7B_on_actionQt_Quick_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionNew_uiCode_triggered(Q7B Checked);
void on_actionNew_uiCode_triggered(bool checked)
{
  this->Q7B_on_actionNew_uiCode_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_menuRecent_Projects_triggered(Q7B Action);
void on_menuRecent_Projects_triggered(QAction *action)
{
  this->Q7B_on_menuRecent_Projects_triggered(Q7B_QOBJECT(action));
}

void Q7B_on_actionOpen_Single_File_Project_triggered(Q7B Checked);
void on_actionOpen_Single_File_Project_triggered(bool checked)
{
  this->Q7B_on_actionOpen_Single_File_Project_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_Compiler_Started(Q7B nCountFilesToCompile);
void Q7B_on_actionTo_UPPERCASE_triggered(Q7B Checked);
void on_actionTo_UPPERCASE_triggered(bool checked)
{
  this->Q7B_on_actionTo_UPPERCASE_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_menuUi_Files_aboutToShow();
void on_menuUi_Files_aboutToShow()
{
  this->Q7B_on_menuUi_Files_aboutToShow();
}

void Q7B_on_tb_uilist_clicked(Q7B Checked);
void on_tb_uilist_clicked(bool checked = false)
{
  this->Q7B_on_tb_uilist_clicked(Q7B_QOBJECT(checked));
}

void Q7B_on_mUIFiles_triggered(Q7B Action);
void on_mUIFiles_triggered(QAction *action)
{
  this->Q7B_on_mUIFiles_triggered(Q7B_QOBJECT(action));
}

void Q7B_on_ProjectOpen();
void Q7B_on_actionNew_Single_File_Project_triggered(Q7B Checked);
void on_actionNew_Single_File_Project_triggered(bool checked)
{
  this->Q7B_on_actionNew_Single_File_Project_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionNew_Project_triggered(Q7B Checked);
void on_actionNew_Project_triggered(bool checked)
{
  this->Q7B_on_actionNew_Project_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_menuExamples_aboutToShow();
void on_menuExamples_aboutToShow()
{
  this->Q7B_on_menuExamples_aboutToShow();
}

void Q7B_on_menuExamples_triggered(Q7B Action);
void on_menuExamples_triggered(QAction *action)
{
  this->Q7B_on_menuExamples_triggered(Q7B_QOBJECT(action));
}

void Q7B_on_menuWindows_aboutToShow();
void on_menuWindows_aboutToShow()
{
  this->Q7B_on_menuWindows_aboutToShow();
}

void Q7B_on_menuWindows_triggered(Q7B Action);
void on_menuWindows_triggered(QAction *action)
{
  this->Q7B_on_menuWindows_triggered(Q7B_QOBJECT(action));
}

void Q7B_on_actionOpen_Project_triggered(Q7B Checked);
void on_actionOpen_Project_triggered(bool checked)
{
  this->Q7B_on_actionOpen_Project_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionApplication_QApplication_triggered(Q7B Checked);
void on_actionApplication_QApplication_triggered(bool checked)
{
  this->Q7B_on_actionApplication_QApplication_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionSystemTray_QSystemTrayIcon_triggered(Q7B Checked);
void on_actionSystemTray_QSystemTrayIcon_triggered(bool checked)
{
  this->Q7B_on_actionSystemTray_QSystemTrayIcon_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionResources_triggered(Q7B Checked);
void on_actionResources_triggered(bool checked)
{
  this->Q7B_on_actionResources_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionCpp_triggered(Q7B Checked);
void on_actionCpp_triggered(bool checked)
{
  this->Q7B_on_actionCpp_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionCopy_2_triggered(Q7B Checked);
void on_actionCopy_2_triggered(bool checked)
{
  this->Q7B_on_actionCopy_2_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionQuit_triggered(Q7B Checked);
void on_actionQuit_triggered(bool checked)
{
  this->Q7B_on_actionQuit_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionUndo_triggered(Q7B Checked);
void on_actionUndo_triggered(bool checked)
{
  this->Q7B_on_actionUndo_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionRedo_triggered(Q7B Checked);
void on_actionRedo_triggered(bool checked)
{
  this->Q7B_on_actionRedo_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionCut_triggered(Q7B Checked);
void on_actionCut_triggered(bool checked)
{
  this->Q7B_on_actionCut_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionCopy_triggered(Q7B Checked);
void on_actionCopy_triggered(bool checked)
{
  this->Q7B_on_actionCopy_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionPaste_triggered(Q7B Checked);
void on_actionPaste_triggered(bool checked)
{
  this->Q7B_on_actionPaste_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionDelete_triggered(Q7B Checked);
void on_actionDelete_triggered(bool checked)
{
  this->Q7B_on_actionDelete_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionSelect_All_triggered(Q7B Checked);
void on_actionSelect_All_triggered(bool checked)
{
  this->Q7B_on_actionSelect_All_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionFind_Replace_triggered(Q7B Checked);
void on_actionFind_Replace_triggered(bool checked)
{
  this->Q7B_on_actionFind_Replace_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionFind_Next_triggered(Q7B Checked);
void on_actionFind_Next_triggered(bool checked)
{
  this->Q7B_on_actionFind_Next_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionFind_File_Replace_File_triggered(Q7B Checked);
void on_actionFind_File_Replace_File_triggered(bool checked)
{
  this->Q7B_on_actionFind_File_Replace_File_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionReplace_File_triggered(Q7B Checked);
void on_actionReplace_File_triggered(bool checked)
{
  this->Q7B_on_actionReplace_File_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionGo_To_Line_triggered(Q7B Checked);
void on_actionGo_To_Line_triggered(bool checked)
{
  this->Q7B_on_actionGo_To_Line_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionGlobal_triggered(Q7B Checked);
void on_actionGlobal_triggered(bool checked)
{
  this->Q7B_on_actionGlobal_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionFind_Definition_triggered(Q7B Checked);
void on_actionFind_Definition_triggered(bool checked)
{
  this->Q7B_on_actionFind_Definition_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionLog_Window_triggered(Q7B Checked);
void on_actionLog_Window_triggered(bool checked)
{
  this->Q7B_on_actionLog_Window_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionCompiler_Window_triggered(Q7B Checked);
void on_actionCompiler_Window_triggered(bool checked)
{
  this->Q7B_on_actionCompiler_Window_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionShift_Left_triggered(Q7B Checked);
void on_actionShift_Left_triggered(bool checked)
{
  this->Q7B_on_actionShift_Left_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionShift_Right_triggered(Q7B Checked);
void on_actionShift_Right_triggered(bool checked)
{
  this->Q7B_on_actionShift_Right_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionComment_triggered(Q7B Checked);
void on_actionComment_triggered(bool checked)
{
  this->Q7B_on_actionComment_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionUncomment_triggered(Q7B Checked);
void on_actionUncomment_triggered(bool checked)
{
  this->Q7B_on_actionUncomment_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionTo_lowercase_triggered(Q7B Checked);
void on_actionTo_lowercase_triggered(bool checked)
{
  this->Q7B_on_actionTo_lowercase_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_Compiler_Started_(int nCountFilesToCompile)
{
  this->Q7B_on_Compiler_Started(Q7B_QOBJECT(nCountFilesToCompile));
}

void Q7B_on_Compiler_Compiled_(const QString& sPathFileName, int nCountFilesCompiled)
{
  this->Q7B_on_Compiler_Compiled(Q7B_QOBJECT(sPathFileName), Q7B_QOBJECT(nCountFilesCompiled));
}

void Q7B_on_Compiler_Finished_(int nCountFilesCompiled)
{
  this->Q7B_on_Compiler_Finished(Q7B_QOBJECT(nCountFilesCompiled));
}

void Q7B_on_Compiler_Error_(const QString& sError)
{
  this->Q7B_on_Compiler_Error(Q7B_QOBJECT(sError));
}

void Q7B_on_Compiler_BreakpointReached_(QString sFile, QString sLine)
{
  this->Q7B_on_Compiler_BreakpointReached(Q7B_QOBJECT(sFile), Q7B_QOBJECT(sLine));
}

void Q7B_on_Compiler_ReadyForDebugging_()
{
  this->Q7B_on_Compiler_ReadyForDebugging();
}

void Q7B_on_Compiler_StandardOutput_(QString s)
{
  this->Q7B_on_Compiler_StandardOutput(Q7B_QOBJECT(s));
}

void Q7B_on_Compiler_StandardError_(QString s)
{
  this->Q7B_on_Compiler_StandardError(Q7B_QOBJECT(s));
}

void Q7B_on_Compiler_StandardOutputOfCompiler_(QString s)
{
  this->Q7B_on_Compiler_StandardOutputOfCompiler(Q7B_QOBJECT(s));
}

void Q7B_on_Compiler_StandardErrorOfCompiler_(QString s)
{
  this->Q7B_on_Compiler_StandardErrorOfCompiler(Q7B_QOBJECT(s));
}

void Q7B_on_Compiler_CompilerOrApplicationFinished_(bool bApplication)
{
  this->Q7B_on_Compiler_CompilerOrApplicationFinished(Q7B_QOBJECT(bApplication));
}

void Q7B_on_Compiler_Compiled(Q7B sPathFileName, Q7B nCountFilesCompiled);
void Q7B_on_Compiler_Finished(Q7B nCountFilesCompiled);
void Q7B_on_actionLast_Error_triggered(Q7B Checked);
void on_actionLast_Error_triggered(bool checked)
{
  this->Q7B_on_actionLast_Error_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionLast_Position_triggered(Q7B Checked);
void on_actionLast_Position_triggered(bool checked)
{
  this->Q7B_on_actionLast_Position_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_Compiler_Error(Q7B sError);
void Q7B_on_Compiler_BreakpointReached(Q7B sFile, Q7B sLine);
void Q7B_on_actionRun_triggered(Q7B Checked);
void on_actionRun_triggered(bool checked)
{
  this->Q7B_on_actionRun_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionBuild_triggered(Q7B Checked);
void on_actionBuild_triggered(bool checked)
{
  this->Q7B_on_actionBuild_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionClean_RebuildAll_triggered(Q7B Checked);
void on_actionClean_RebuildAll_triggered(bool checked)
{
  this->Q7B_on_actionClean_RebuildAll_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_Compiler_ReadyForDebugging();
void Q7B_on_actionStop_triggered(Q7B Checked);
void on_actionStop_triggered(bool checked)
{
  this->Q7B_on_actionStop_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionDebug_triggered(Q7B Checked);
void on_actionDebug_triggered(bool checked)
{
  this->Q7B_on_actionDebug_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_Compiler_StandardOutput(Q7B s);
void Q7B_on_Compiler_StandardError(Q7B s);
void Q7B_on_Compiler_StandardOutputOfCompiler(Q7B s);
void Q7B_on_Compiler_StandardErrorOfCompiler(Q7B s);
void Q7B_on_Compiler_CompilerOrApplicationFinished(Q7B bApplication);
void Q7B_on_actionStep_Into_triggered(Q7B Checked);
void on_actionStep_Into_triggered(bool checked)
{
  this->Q7B_on_actionStep_Into_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionStep_Over_triggered(Q7B Checked);
void on_actionStep_Over_triggered(bool checked)
{
  this->Q7B_on_actionStep_Over_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionStep_Out_triggered(Q7B Checked);
void on_actionStep_Out_triggered(bool checked)
{
  this->Q7B_on_actionStep_Out_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionRun_To_Cursor_triggered(Q7B Checked);
void on_actionRun_To_Cursor_triggered(bool checked)
{
  this->Q7B_on_actionRun_To_Cursor_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionToggle_Breakpoint_triggered(Q7B Checked);
void on_actionToggle_Breakpoint_triggered(bool checked)
{
  this->Q7B_on_actionToggle_Breakpoint_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionDeploy_triggered(Q7B Checked);
void on_actionDeploy_triggered(bool checked)
{
  this->Q7B_on_actionDeploy_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionQObject_triggered(Q7B Checked);
void on_actionQObject_triggered(bool checked)
{
  this->Q7B_on_actionQObject_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionQWidget_triggered(Q7B Checked);
void on_actionQWidget_triggered(bool checked)
{
  this->Q7B_on_actionQWidget_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionNew_Class_triggered(Q7B Checked);
void on_actionNew_Class_triggered(bool checked)
{
  this->Q7B_on_actionNew_Class_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionNew_Module_triggered(Q7B Checked);
void on_actionNew_Module_triggered(bool checked)
{
  this->Q7B_on_actionNew_Module_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionQDialog_triggered(Q7B Checked);
void on_actionQDialog_triggered(bool checked)
{
  this->Q7B_on_actionQDialog_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionNew_File_With_triggered(Q7B Checked);
void on_actionNew_File_With_triggered(bool checked)
{
  this->Q7B_on_actionNew_File_With_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionDelete_Current_File_triggered(Q7B Checked);
void on_actionDelete_Current_File_triggered(bool checked)
{
  this->Q7B_on_actionDelete_Current_File_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionDuplicate_Current_File_triggered(Q7B Checked);
void on_actionDuplicate_Current_File_triggered(bool checked)
{
  this->Q7B_on_actionDuplicate_Current_File_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionRename_Current_File_triggered(Q7B Checked);
void on_actionRename_Current_File_triggered(bool checked)
{
  this->Q7B_on_actionRename_Current_File_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionMainWindow_ui_2_triggered(Q7B Checked);
void on_actionMainWindow_ui_2_triggered(bool checked)
{
  this->Q7B_on_actionMainWindow_ui_2_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionQt_Designer_for_MainWindow_ui_triggered(Q7B Checked);
void on_actionQt_Designer_for_MainWindow_ui_triggered(bool checked)
{
  this->Q7B_on_actionQt_Designer_for_MainWindow_ui_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionShow_Project_Folder_triggered(Q7B Checked);
void on_actionShow_Project_Folder_triggered(bool checked)
{
  this->Q7B_on_actionShow_Project_Folder_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionLanguage_Reference_triggered(Q7B Checked);
void on_actionLanguage_Reference_triggered(bool checked)
{
  this->Q7B_on_actionLanguage_Reference_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionQt_DesignerHelp_triggered(Q7B Checked);
void on_actionQt_DesignerHelp_triggered(bool checked)
{
  this->Q7B_on_actionQt_DesignerHelp_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionContribute_triggered(Q7B Checked);
void on_actionContribute_triggered(bool checked)
{
  this->Q7B_on_actionContribute_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionBug_Report_triggered(Q7B Checked);
void on_actionBug_Report_triggered(bool checked)
{
  this->Q7B_on_actionBug_Report_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionQt_Reference_Documentation_triggered(Q7B Checked);
void on_actionQt_Reference_Documentation_triggered(bool checked)
{
  this->Q7B_on_actionQt_Reference_Documentation_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionSQLite_triggered(Q7B Checked);
void on_actionSQLite_triggered(bool checked)
{
  this->Q7B_on_actionSQLite_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionMySQL_triggered(Q7B Checked);
void on_actionMySQL_triggered(bool checked)
{
  this->Q7B_on_actionMySQL_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionPostgreSQL_2_triggered(Q7B Checked);
void on_actionPostgreSQL_2_triggered(bool checked)
{
  this->Q7B_on_actionPostgreSQL_2_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionQ7Basic_Essentials_triggered(Q7B Checked);
void on_actionQ7Basic_Essentials_triggered(bool checked)
{
  this->Q7B_on_actionQ7Basic_Essentials_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionGeneral_Manual_triggered(Q7B Checked);
void on_actionGeneral_Manual_triggered(bool checked)
{
  this->Q7B_on_actionGeneral_Manual_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionQuick_Start_triggered(Q7B Checked);
void on_actionQuick_Start_triggered(bool checked)
{
  this->Q7B_on_actionQuick_Start_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionQt_Designer_triggered(Q7B Checked);
void on_actionQt_Designer_triggered(bool checked)
{
  this->Q7B_on_actionQt_Designer_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionRegister_triggered(Q7B Checked);
void on_actionRegister_triggered(bool checked)
{
  this->Q7B_on_actionRegister_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionSave_triggered(Q7B Checked);
void on_actionSave_triggered(bool checked)
{
  this->Q7B_on_actionSave_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionReadme_triggered(Q7B Checked);
void on_actionReadme_triggered(bool checked)
{
  this->Q7B_on_actionReadme_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionLicense_triggered(Q7B Checked);
void on_actionLicense_triggered(bool checked)
{
  this->Q7B_on_actionLicense_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_actionAbout_Q7Basic_triggered(Q7B Checked);
void on_actionAbout_Q7Basic_triggered(bool checked)
{
  this->Q7B_on_actionAbout_Q7Basic_triggered(Q7B_QOBJECT(checked));
}

void Q7B_on_menuConfiguration_triggered(Q7B Action);
void on_menuConfiguration_triggered(QAction *action)
{
  this->Q7B_on_menuConfiguration_triggered(Q7B_QOBJECT(action));
}

public:
Q7B sMingwQtVersion;
Q7B statusBar;
Q7B progressBar;
Q7B testList;
Q7B bBlockLastPosition;
Q7B actionCopy;
Q7B actionCut;
Q7B actionUndo;
Q7B actionRedo;
Q7B actionDelete;
Q7B actionPaste;
Q7B actionTo_UPPERCASE;
Q7B actionTo_lowercase;
Q7B actionComment;
Q7B actionUncomment;
Q7B actionShift_Left;
Q7B actionShift_Right;
public:
Q7B toolBar;
Q7B menuRecent_Projects;
Q7B actionLast_Error;
Q7B aRecentProjects;
Q7B _nCountFilesToCompile;
Q7B sQtVersion;
Q7B menuExamples;
Q7B menuWindows;
Q7B menuConfiguration;
Q7B sVCDir;
Q7B sQtMINGWDir;
Q7B sQtDir;
Q7B tb_uilist;
Q7B actionMainWindow_ui_2;
Q7B mUIFiles;
Q7B menuUi_Files;
Q7B lUIFiles;
Q7B myDebugWindow;
Q7B DebugStack;
Q7B DebugGlobal;
Q7B DebugLocal;
Q7B DebugMe;
Q7B sFind;
Q7B Compiler;
Q7B bCompilerError;
Q7B sLastPositionFile;
Q7B nLastPositionLine;
Q7B sLastErrorText;
Q7B sLastErrorFile;
Q7B nLastErrorLine;
Q7B actionRun;
Q7B actionBuild;
Q7B actionStop;
Q7B actionClean_RebuildAll;
Q7B actionDebug;
Q7B actionDeploy;
Q7B actionStep_Into;
Q7B actionStep_Over;
Q7B actionStep_Out;
Q7B actionRun_To_Cursor;
Q7B dockDebug;
Q7B dockLog;
Q7B dockCompiler;
Q7B plainTextEditLog;
Q7B plainTextEditCompiler;
Q7B bDebug;
Q7B bRunOrBuild;
Q7B bBuildOnly;
Q7B gcc;
Q7B vs;


private:
Q7B q7b_this;


public:
static Q7B q7b_sharedSingletonQ7B()
{
q7b_sharedSingleton();
return q7b_MainWindow_sharedSingletonQ7B;
};


static MainWindow* q7b_sharedSingleton()
{
if (q7b_MainWindow_sharedSingletonFinalized) return 0;
if (q7b_MainWindow_sharedSingleton == 0){
q7b_MainWindow_sharedSingletonInit = true;
if (q7b_ui.contains("MainWindow")){
  q7b_MainWindow_sharedSingleton = (MainWindow *) (QWidget *) q7b_ui["MainWindow"]->ref; 
} else {
  q7b_MainWindow_sharedSingleton = new MainWindow(q7b_MainWindow_sharedSingletonQ7B, 0);
}
}
return q7b_MainWindow_sharedSingleton;
}



void Set_toolBar(Q7B q7b_var){ toolBar = q7b_var; }
Q7B Get_toolBar(){ return toolBar; }
void Set_menuRecent_Projects(Q7B q7b_var){ menuRecent_Projects = q7b_var; }
Q7B Get_menuRecent_Projects(){ return menuRecent_Projects; }
void Set_actionLast_Error(Q7B q7b_var){ actionLast_Error = q7b_var; }
Q7B Get_actionLast_Error(){ return actionLast_Error; }
void Set_aRecentProjects(Q7B q7b_var){ aRecentProjects = q7b_var; }
Q7B Get_aRecentProjects(){ return aRecentProjects; }
void Set__nCountFilesToCompile(Q7B q7b_var){ _nCountFilesToCompile = q7b_var; }
Q7B Get__nCountFilesToCompile(){ return _nCountFilesToCompile; }
void Set_sQtVersion(Q7B q7b_var){ sQtVersion = q7b_var; }
Q7B Get_sQtVersion(){ return sQtVersion; }
void Set_sMingwQtVersion(Q7B q7b_var){ sMingwQtVersion = q7b_var; }
Q7B Get_sMingwQtVersion(){ return sMingwQtVersion; }
void Set_menuExamples(Q7B q7b_var){ menuExamples = q7b_var; }
Q7B Get_menuExamples(){ return menuExamples; }
void Set_menuWindows(Q7B q7b_var){ menuWindows = q7b_var; }
Q7B Get_menuWindows(){ return menuWindows; }
void Set_menuConfiguration(Q7B q7b_var){ menuConfiguration = q7b_var; }
Q7B Get_menuConfiguration(){ return menuConfiguration; }
void Set_sVCDir(Q7B q7b_var){ sVCDir = q7b_var; }
Q7B Get_sVCDir(){ return sVCDir; }
void Set_sQtMINGWDir(Q7B q7b_var){ sQtMINGWDir = q7b_var; }
Q7B Get_sQtMINGWDir(){ return sQtMINGWDir; }
void Set_sQtDir(Q7B q7b_var){ sQtDir = q7b_var; }
Q7B Get_sQtDir(){ return sQtDir; }
void Set_statusBar(Q7B q7b_var){ statusBar = q7b_var; }
Q7B Get_statusBar(){ return statusBar; }
void Set_progressBar(Q7B q7b_var){ progressBar = q7b_var; }
Q7B Get_progressBar(){ return progressBar; }
void Set_tb_uilist(Q7B q7b_var){ tb_uilist = q7b_var; }
Q7B Get_tb_uilist(){ return tb_uilist; }
void Set_actionMainWindow_ui_2(Q7B q7b_var){ actionMainWindow_ui_2 = q7b_var; }
Q7B Get_actionMainWindow_ui_2(){ return actionMainWindow_ui_2; }
void Set_mUIFiles(Q7B q7b_var){ mUIFiles = q7b_var; }
Q7B Get_mUIFiles(){ return mUIFiles; }
void Set_menuUi_Files(Q7B q7b_var){ menuUi_Files = q7b_var; }
Q7B Get_menuUi_Files(){ return menuUi_Files; }
void Set_lUIFiles(Q7B q7b_var){ lUIFiles = q7b_var; }
Q7B Get_lUIFiles(){ return lUIFiles; }
void Set_myDebugWindow(Q7B q7b_var){ myDebugWindow = q7b_var; }
Q7B Get_myDebugWindow(){ return myDebugWindow; }
void Set_DebugStack(Q7B q7b_var){ DebugStack = q7b_var; }
Q7B Get_DebugStack(){ return DebugStack; }
void Set_DebugGlobal(Q7B q7b_var){ DebugGlobal = q7b_var; }
Q7B Get_DebugGlobal(){ return DebugGlobal; }
void Set_DebugLocal(Q7B q7b_var){ DebugLocal = q7b_var; }
Q7B Get_DebugLocal(){ return DebugLocal; }
void Set_DebugMe(Q7B q7b_var){ DebugMe = q7b_var; }
Q7B Get_DebugMe(){ return DebugMe; }
void Set_testList(Q7B q7b_var){ testList = q7b_var; }
Q7B Get_testList(){ return testList; }
void Set_sFind(Q7B q7b_var){ sFind = q7b_var; }
Q7B Get_sFind(){ return sFind; }
void Set_Compiler(Q7B q7b_var){ Compiler = q7b_var; }
Q7B Get_Compiler(){ return Compiler; }
void Set_bCompilerError(Q7B q7b_var){ bCompilerError = q7b_var; }
Q7B Get_bCompilerError(){ return bCompilerError; }
void Set_bBlockLastPosition(Q7B q7b_var){ bBlockLastPosition = q7b_var; }
Q7B Get_bBlockLastPosition(){ return bBlockLastPosition; }
void Set_sLastPositionFile(Q7B q7b_var){ sLastPositionFile = q7b_var; }
Q7B Get_sLastPositionFile(){ return sLastPositionFile; }
void Set_nLastPositionLine(Q7B q7b_var){ nLastPositionLine = q7b_var; }
Q7B Get_nLastPositionLine(){ return nLastPositionLine; }
void Set_sLastErrorText(Q7B q7b_var){ sLastErrorText = q7b_var; }
Q7B Get_sLastErrorText(){ return sLastErrorText; }
void Set_sLastErrorFile(Q7B q7b_var){ sLastErrorFile = q7b_var; }
Q7B Get_sLastErrorFile(){ return sLastErrorFile; }
void Set_nLastErrorLine(Q7B q7b_var){ nLastErrorLine = q7b_var; }
Q7B Get_nLastErrorLine(){ return nLastErrorLine; }
void Set_actionCopy(Q7B q7b_var){ actionCopy = q7b_var; }
Q7B Get_actionCopy(){ return actionCopy; }
void Set_actionCut(Q7B q7b_var){ actionCut = q7b_var; }
Q7B Get_actionCut(){ return actionCut; }
void Set_actionUndo(Q7B q7b_var){ actionUndo = q7b_var; }
Q7B Get_actionUndo(){ return actionUndo; }
void Set_actionRedo(Q7B q7b_var){ actionRedo = q7b_var; }
Q7B Get_actionRedo(){ return actionRedo; }
void Set_actionDelete(Q7B q7b_var){ actionDelete = q7b_var; }
Q7B Get_actionDelete(){ return actionDelete; }
void Set_actionPaste(Q7B q7b_var){ actionPaste = q7b_var; }
Q7B Get_actionPaste(){ return actionPaste; }
void Set_actionTo_UPPERCASE(Q7B q7b_var){ actionTo_UPPERCASE = q7b_var; }
Q7B Get_actionTo_UPPERCASE(){ return actionTo_UPPERCASE; }
void Set_actionTo_lowercase(Q7B q7b_var){ actionTo_lowercase = q7b_var; }
Q7B Get_actionTo_lowercase(){ return actionTo_lowercase; }
void Set_actionComment(Q7B q7b_var){ actionComment = q7b_var; }
Q7B Get_actionComment(){ return actionComment; }
void Set_actionUncomment(Q7B q7b_var){ actionUncomment = q7b_var; }
Q7B Get_actionUncomment(){ return actionUncomment; }
void Set_actionShift_Left(Q7B q7b_var){ actionShift_Left = q7b_var; }
Q7B Get_actionShift_Left(){ return actionShift_Left; }
void Set_actionShift_Right(Q7B q7b_var){ actionShift_Right = q7b_var; }
Q7B Get_actionShift_Right(){ return actionShift_Right; }
void Set_actionRun(Q7B q7b_var){ actionRun = q7b_var; }
Q7B Get_actionRun(){ return actionRun; }
void Set_actionBuild(Q7B q7b_var){ actionBuild = q7b_var; }
Q7B Get_actionBuild(){ return actionBuild; }
void Set_actionStop(Q7B q7b_var){ actionStop = q7b_var; }
Q7B Get_actionStop(){ return actionStop; }
void Set_actionClean_RebuildAll(Q7B q7b_var){ actionClean_RebuildAll = q7b_var; }
Q7B Get_actionClean_RebuildAll(){ return actionClean_RebuildAll; }
void Set_actionDebug(Q7B q7b_var){ actionDebug = q7b_var; }
Q7B Get_actionDebug(){ return actionDebug; }
void Set_actionDeploy(Q7B q7b_var){ actionDeploy = q7b_var; }
Q7B Get_actionDeploy(){ return actionDeploy; }
void Set_actionStep_Into(Q7B q7b_var){ actionStep_Into = q7b_var; }
Q7B Get_actionStep_Into(){ return actionStep_Into; }
void Set_actionStep_Over(Q7B q7b_var){ actionStep_Over = q7b_var; }
Q7B Get_actionStep_Over(){ return actionStep_Over; }
void Set_actionStep_Out(Q7B q7b_var){ actionStep_Out = q7b_var; }
Q7B Get_actionStep_Out(){ return actionStep_Out; }
void Set_actionRun_To_Cursor(Q7B q7b_var){ actionRun_To_Cursor = q7b_var; }
Q7B Get_actionRun_To_Cursor(){ return actionRun_To_Cursor; }
void Set_dockDebug(Q7B q7b_var){ dockDebug = q7b_var; }
Q7B Get_dockDebug(){ return dockDebug; }
void Set_dockLog(Q7B q7b_var){ dockLog = q7b_var; }
Q7B Get_dockLog(){ return dockLog; }
void Set_dockCompiler(Q7B q7b_var){ dockCompiler = q7b_var; }
Q7B Get_dockCompiler(){ return dockCompiler; }
void Set_plainTextEditLog(Q7B q7b_var){ plainTextEditLog = q7b_var; }
Q7B Get_plainTextEditLog(){ return plainTextEditLog; }
void Set_plainTextEditCompiler(Q7B q7b_var){ plainTextEditCompiler = q7b_var; }
Q7B Get_plainTextEditCompiler(){ return plainTextEditCompiler; }
void Set_bDebug(Q7B q7b_var){ bDebug = q7b_var; }
Q7B Get_bDebug(){ return bDebug; }
void Set_bRunOrBuild(Q7B q7b_var){ bRunOrBuild = q7b_var; }
Q7B Get_bRunOrBuild(){ return bRunOrBuild; }
void Set_bBuildOnly(Q7B q7b_var){ bBuildOnly = q7b_var; }
Q7B Get_bBuildOnly(){ return bBuildOnly; }
void Set_gcc(Q7B q7b_var){ gcc = q7b_var; }
Q7B Get_gcc(){ return gcc; }
void Set_vs(Q7B q7b_var){ vs = q7b_var; }
Q7B Get_vs(){ return vs; }

};
#endif
