
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/
 #include "Q7BRuntime.h"

#include "Global.h"
#include "Q7BCodeView.h"

#include "Q7BCompiler.h"

#include <typeinfo>
#include "Application.h"

#include "Parser.h"

Parser *q7b_Parser_sharedSingleton = 0;
Q7B q7b_Parser_sharedSingletonQ7B;
bool q7b_Parser_sharedSingletonFinalized = false;
bool q7b_Parser_sharedSingletonInit = false;
extern Q7B Q7B_idGLOBAL;
extern Q7B Q7B_idAPPLICATION;
extern Q7B Q7B_idSTATUSBAR;
extern Q7B Q7B_idSOUNDS;
extern Q7B Q7B_idDATABASE;
extern Q7B Q7B_idTABLE;
extern Q7B Q7B_idRECORDS;
extern Q7B Q7B_idQUERY;
extern Q7B Q7B_idPIXMAPS;
extern Q7B Q7B_idCOLORS;
extern Q7B Q7B_idFONTS;
extern Q7B Q7B_idTOOLBAR;
extern Q7B Q7B_idSYSTEMTRAY;
extern Q7B Q7B_idMAINWINDOW;
extern Q7B Q7B_idDEBUG;
extern Q7B Q7B_idFILE;
extern Q7B Q7B_idPREFERENCES;
extern Q7B Q7B_idDIR;
extern Q7B Q7B_idDESKTOP;
extern Q7B Q7B_idOPENFILEDIALOG;
extern Q7B Q7B_idSAVEFILEDIALOG;
extern Q7B Q7B_idCOLORDIALOG;
extern Q7B Q7B_idFONTDIALOG;
extern Q7B Q7B_idPROGRESSDIALOG;
extern Q7B Q7B_idINPUTDIALOG;
extern Q7B Q7B_idMESSAGEBOX;
extern Q7B Q7B_idOS;
#define CommandButton Q7B_CommandButton
#define CommandLinkButton Q7B_CommandLinkButton
#define ImageButton Q7B_ImageButton
#define ToolButton Q7B_ToolButton
#define CheckBox Q7B_CheckBox
#define RadioButton Q7B_RadioButton
#define Label Q7B_Label
#define Frame Q7B_Frame
#define ImageBox Q7B_ImageBox
#define TextBox Q7B_TextBox
#define uiClass Q7B_uiClass
#define Class Q7B_Class
#define Module Q7B_Module
#define Control QWidget
#include "Parser.h"
#include "Project.h"


Parser::Parser(Q7B _q7b_this)
{
q7b_this = _q7b_this;
if (q7b_Parser_sharedSingletonInit){ q7b_Parser_sharedSingletonInit = false; q7b_Parser_sharedSingletonQ7B = q7b_this = Q7B(new Q7B_id(typeid(Parser).name(), this)); } else q7b_this = Q7B(new Q7B_id(typeid(Parser).name(), this)); 
aAll = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
aSub = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
aFunction = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
aAction = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
aDim = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
aConst = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
aEvent = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
aProperty = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
aIBOutlet = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
aIBAction = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
aLineSeparators = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
aLineSeparatorsType = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
aLocalList = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
alllist = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
sublist = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
functionlist = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
eventlist = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
Dimlist = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
constlist = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
actionlist = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
propertylist = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
iboutletlist = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
ibactionlist = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
remlist = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
locallist = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
LineSeparators = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
LineSeparatorsType = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
comletionlist = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
comletion = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
lock = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_Dictionary::init()));
}


void Parser::ParseFile(Q7B sFile)
{
                      Q7BS("Parser.QObject", "ParseFile", "47", 0);
                      Q7BS("Parser.QObject", "ParseFile", "48", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sFile))), Q7B_QOBJECT(0)))){
                      Q7BS("Parser.QObject", "ParseFile", "49", 1);
return;
}
                      Q7BS("Parser.QObject", "ParseFile", "53", 1);
if (Q7B_CBOOLEAN(Q7B_DICTIONARY_CONTAINS(lock, Q7B_QOBJECT(sFile)))){
                      Q7BS("Parser.QObject", "ParseFile", "54", 1);
return;
}
                      Q7BS("Parser.QObject", "ParseFile", "57", 1);
Q7B_DICTIONARY_SETOBJECT(lock, Q7B_QOBJECT(sFile), Q7B_QOBJECT("locked"));
                      Q7BS("Parser.QObject", "ParseFile", "60", 1);
Q7B sCode; sCode = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_READSTRING(Q7B_QOBJECT(sFile), Q7B_QOBJECT("")))));
                      Q7BS("Parser.QObject", "ParseFile", "63", 1);
Q7B_ASSIGNMENT(&alllist, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init()))));
                      Q7BS("Parser.QObject", "ParseFile", "64", 1);
Q7B_ASSIGNMENT(&sublist, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init()))));
                      Q7BS("Parser.QObject", "ParseFile", "65", 1);
Q7B_ASSIGNMENT(&functionlist, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init()))));
                      Q7BS("Parser.QObject", "ParseFile", "66", 1);
Q7B_ASSIGNMENT(&eventlist, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init()))));
                      Q7BS("Parser.QObject", "ParseFile", "67", 1);
Q7B_ASSIGNMENT(&Dimlist, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init()))));
                      Q7BS("Parser.QObject", "ParseFile", "68", 1);
Q7B_ASSIGNMENT(&constlist, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init()))));
                      Q7BS("Parser.QObject", "ParseFile", "69", 1);
Q7B_ASSIGNMENT(&actionlist, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init()))));
                      Q7BS("Parser.QObject", "ParseFile", "70", 1);
Q7B_ASSIGNMENT(&propertylist, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init()))));
                      Q7BS("Parser.QObject", "ParseFile", "71", 1);
Q7B_ASSIGNMENT(&iboutletlist, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init()))));
                      Q7BS("Parser.QObject", "ParseFile", "72", 1);
Q7B_ASSIGNMENT(&ibactionlist, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init()))));
                      Q7BS("Parser.QObject", "ParseFile", "73", 1);
Q7B_ASSIGNMENT(&remlist, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init()))));
                      Q7BS("Parser.QObject", "ParseFile", "74", 1);
Q7B_ASSIGNMENT(&LineSeparators, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init()))));
                      Q7BS("Parser.QObject", "ParseFile", "75", 1);
Q7B_ASSIGNMENT(&LineSeparatorsType, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init()))));
                      Q7BS("Parser.QObject", "ParseFile", "77", 1);
Q7B_ASSIGNMENT(&locallist, &Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_QOBJECT(Q7B_Dictionary::init()))));
                      Q7BS("Parser.QObject", "ParseFile", "79", 1);
Q7B_ASSIGNMENT(&comletionlist, &Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_QOBJECT(Q7B_Dictionary::init()))));
                      Q7BS("Parser.QObject", "ParseFile", "80", 1);
Q7B_ASSIGNMENT(&comletion, &Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_QOBJECT(Q7B_Dictionary::init()))));
                      Q7BS("Parser.QObject", "ParseFile", "83", 1);
Q7B_DICTIONARY_REMOVEALL(comletion);
                      Q7BS("Parser.QObject", "ParseFile", "86", 1);
Q7B_LIST_REMOVEALL(LineSeparators);
                      Q7BS("Parser.QObject", "ParseFile", "90", 1);
this->UpdateCodeInsightHelper(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sCode))), Q7B_QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT("\nSub "), Q7B_QOBJECT("\nPrivate Sub "), Q7B_QOBJECT("\nPublic Sub "), Q7B_QOBJECT("\nGlobal Sub "))))), Q7B_QOBJECT(Q7B_LIST(Q7B_QOBJECT(sublist))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("Parser.QObject", "ParseFile", "91", 1);
this->UpdateCodeInsightHelper(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sCode))), Q7B_QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT("\nFunction "), Q7B_QOBJECT("\nPrivate Function "), Q7B_QOBJECT("\nPublic Function "), Q7B_QOBJECT("\nGlobal Function "))))), Q7B_QOBJECT(Q7B_LIST(Q7B_QOBJECT(functionlist))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("Parser.QObject", "ParseFile", "92", 1);
this->UpdateCodeInsightHelper(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sCode))), Q7B_QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT("\nSignal "))))), Q7B_QOBJECT(Q7B_LIST(Q7B_QOBJECT(ibactionlist))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("Parser.QObject", "ParseFile", "93", 1);
this->UpdateCodeInsightHelper(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sCode))), Q7B_QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT("\nDim "), Q7B_QOBJECT("\nPrivate Dim "), Q7B_QOBJECT("\nPublic Dim "), Q7B_QOBJECT("\nGlobal Dim "))))), Q7B_QOBJECT(Q7B_LIST(Q7B_QOBJECT(Dimlist))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("Parser.QObject", "ParseFile", "94", 1);
this->UpdateCodeInsightHelper(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sCode))), Q7B_QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT("\nOutlet "), Q7B_QOBJECT("\nPrivate Outlet "), Q7B_QOBJECT("\nPublic Outlet "))))), Q7B_QOBJECT(Q7B_LIST(Q7B_QOBJECT(iboutletlist))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("Parser.QObject", "ParseFile", "95", 1);
this->UpdateCodeInsightHelper(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sCode))), Q7B_QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT("\nConst "), Q7B_QOBJECT("\nPrivate Const "), Q7B_QOBJECT("\nPublic Const "), Q7B_QOBJECT("\nGlobal Const "))))), Q7B_QOBJECT(Q7B_LIST(Q7B_QOBJECT(constlist))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("Parser.QObject", "ParseFile", "96", 1);
this->UpdateCodeInsightHelper(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sCode))), Q7B_QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT("\nEvent "))))), Q7B_QOBJECT(Q7B_LIST(Q7B_QOBJECT(eventlist))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("Parser.QObject", "ParseFile", "101", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0)));
                      Q7BS("Parser.QObject", "ParseFile", "150", 1);
Q7B_DICTIONARY_SETOBJECT(aAll, Q7B_QOBJECT(sFile), Q7B_QOBJECT(alllist));
                      Q7BS("Parser.QObject", "ParseFile", "151", 1);
Q7B_DICTIONARY_SETOBJECT(aSub, Q7B_QOBJECT(sFile), Q7B_QOBJECT(sublist));
                      Q7BS("Parser.QObject", "ParseFile", "152", 1);
Q7B_DICTIONARY_SETOBJECT(aFunction, Q7B_QOBJECT(sFile), Q7B_QOBJECT(functionlist));
                      Q7BS("Parser.QObject", "ParseFile", "153", 1);
Q7B_DICTIONARY_SETOBJECT(aAction, Q7B_QOBJECT(sFile), Q7B_QOBJECT(actionlist));
                      Q7BS("Parser.QObject", "ParseFile", "154", 1);
Q7B_DICTIONARY_SETOBJECT(aDim, Q7B_QOBJECT(sFile), Q7B_QOBJECT(Dimlist));
                      Q7BS("Parser.QObject", "ParseFile", "155", 1);
Q7B_DICTIONARY_SETOBJECT(aConst, Q7B_QOBJECT(sFile), Q7B_QOBJECT(constlist));
                      Q7BS("Parser.QObject", "ParseFile", "156", 1);
Q7B_DICTIONARY_SETOBJECT(aEvent, Q7B_QOBJECT(sFile), Q7B_QOBJECT(eventlist));
                      Q7BS("Parser.QObject", "ParseFile", "157", 1);
Q7B_DICTIONARY_SETOBJECT(aProperty, Q7B_QOBJECT(sFile), Q7B_QOBJECT(propertylist));
                      Q7BS("Parser.QObject", "ParseFile", "158", 1);
Q7B_DICTIONARY_SETOBJECT(aIBOutlet, Q7B_QOBJECT(sFile), Q7B_QOBJECT(iboutletlist));
                      Q7BS("Parser.QObject", "ParseFile", "159", 1);
Q7B_DICTIONARY_SETOBJECT(aIBAction, Q7B_QOBJECT(sFile), Q7B_QOBJECT(ibactionlist));
                      Q7BS("Parser.QObject", "ParseFile", "160", 1);
Q7B_DICTIONARY_SETOBJECT(aLineSeparators, Q7B_QOBJECT(sFile), Q7B_QOBJECT(LineSeparators));
                      Q7BS("Parser.QObject", "ParseFile", "161", 1);
Q7B_DICTIONARY_SETOBJECT(aLineSeparatorsType, Q7B_QOBJECT(sFile), Q7B_QOBJECT(LineSeparatorsType));
                      Q7BS("Parser.QObject", "ParseFile", "163", 1);
Q7B_DICTIONARY_SETOBJECT(comletionlist, Q7B_QOBJECT(Q7B_FILEEXTENSION(Q7B_QOBJECT(sFile))), Q7B_QOBJECT(comletion));
                      Q7BS("Parser.QObject", "ParseFile", "167", 1);
Q7B sCode2; sCode2 = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(sCode)));
                      Q7BS("Parser.QObject", "ParseFile", "169", 1);
Q7B_ASSIGNMENT(&sCode2, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_REPLACE(Q7B_QOBJECT(sCode2), Q7B_QOBJECT("\nDim "), Q7B_QOBJECT("\n "), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "170", 1);
Q7B_ASSIGNMENT(&sCode2, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_REPLACE(Q7B_QOBJECT(sCode2), Q7B_QOBJECT("\nPublic Dim "), Q7B_QOBJECT("\n "), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "171", 1);
Q7B_ASSIGNMENT(&sCode2, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_REPLACE(Q7B_QOBJECT(sCode2), Q7B_QOBJECT("\nPrivate Dim "), Q7B_QOBJECT("\n "), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "172", 1);
Q7B_ASSIGNMENT(&sCode2, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_REPLACE(Q7B_QOBJECT(sCode2), Q7B_QOBJECT("\nGlobal Dim "), Q7B_QOBJECT("\n "), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "187", 1);
Q7B sLine; sLine = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("Parser.QObject", "ParseFile", "188", 1);
Q7B n; n = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0)));
                      Q7BS("Parser.QObject", "ParseFile", "189", 1);
while(Q7B_CBOOLEAN((Q7B_QOBJECT(true)))){
                      Q7BS("Parser.QObject", "ParseFile", "190", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(n), Q7B_QOBJECT(0)))){
                      Q7BS("Parser.QObject", "ParseFile", "191", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sCode2), Q7B_QOBJECT("\n"), Q7B_QOBJECT(n), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "192", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "ParseFile", "193", 1);
break;
}
                      Q7BS("Parser.QObject", "ParseFile", "195", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n), Q7B_QOBJECT(1))))));
}
                      Q7BS("Parser.QObject", "ParseFile", "198", 1);
Q7B n2; n2 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sCode2), Q7B_QOBJECT("\n"), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n), Q7B_QOBJECT(1))), Q7B_QOBJECT(true)))));
                      Q7BS("Parser.QObject", "ParseFile", "199", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n2), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "ParseFile", "200", 1);
break;
}
                      Q7BS("Parser.QObject", "ParseFile", "204", 1);
Q7B_ASSIGNMENT(&sLine, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(sCode2), Q7B_QOBJECT(n), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(n2), Q7B_QOBJECT(n))))))));
                      Q7BS("Parser.QObject", "ParseFile", "206", 1);
Q7B n3; n3 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Parser.QObject", "ParseFile", "207", 1);
while(Q7B_CBOOLEAN((Q7B_QOBJECT(true)))){
                      Q7BS("Parser.QObject", "ParseFile", "208", 1);
Q7B_ASSIGNMENT(&n3, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sLine), Q7B_QOBJECT("\""), Q7B_QOBJECT(0), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "209", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n3), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "ParseFile", "210", 1);
break;
}
                      Q7BS("Parser.QObject", "ParseFile", "212", 1);
Q7B n4; n4 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sLine), Q7B_QOBJECT("\""), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n3), Q7B_QOBJECT(1))), Q7B_QOBJECT(true)))));
                      Q7BS("Parser.QObject", "ParseFile", "213", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n4), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "ParseFile", "214", 1);
break;
}
                      Q7BS("Parser.QObject", "ParseFile", "216", 1);
Q7B_ASSIGNMENT(&sLine, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(sLine), Q7B_QOBJECT(n3))), Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(sLine), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n4), Q7B_QOBJECT(1))), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sLine))), Q7B_QOBJECT(n4))), Q7B_QOBJECT(1))))))))));
}
                      Q7BS("Parser.QObject", "ParseFile", "219", 1);
Q7B_ASSIGNMENT(&n3, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sLine), Q7B_QOBJECT("'"), Q7B_QOBJECT(0), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "220", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(n3), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "ParseFile", "221", 1);
Q7B_ASSIGNMENT(&sLine, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(sLine), Q7B_QOBJECT(n3))))));
}
                      Q7BS("Parser.QObject", "ParseFile", "226", 1);
if (Q7B_CBOOLEAN(Q7B_CONTAINS(Q7B_QOBJECT(sLine), Q7B_QOBJECT("Dim "), Q7B_QOBJECT(true)))){
                      Q7BS("Parser.QObject", "ParseFile", "228", 1);
Q7B sKey; sKey = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("Parser.QObject", "ParseFile", "229", 1);
Q7B sDataType; sDataType = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("Parser.QObject", "ParseFile", "230", 1);
Q7B sScope; sScope = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("Parser.QObject", "ParseFile", "232", 1);
Q7B na2; na2 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Parser.QObject", "ParseFile", "234", 1);
Q7B na4; na4 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Parser.QObject", "ParseFile", "236", 1);
Q7B x; x = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Parser.QObject", "ParseFile", "237", 1);
for (x = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(x), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sLine))), Q7B_QOBJECT(1))))); Q7BS("Parser.QObject", "ParseFile", "237", 1),x = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(x), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("Parser.QObject", "ParseFile", "238", 1);
if (Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(sLine), Q7B_QOBJECT(x), Q7B_QOBJECT(1))), Q7B_QOBJECT(" ")))){
                      Q7BS("Parser.QObject", "ParseFile", "239", 1);
break;
}
}
                      Q7BS("Parser.QObject", "ParseFile", "244", 1);
Q7B_ASSIGNMENT(&sLine, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(sLine), Q7B_QOBJECT(x), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sLine))), Q7B_QOBJECT(x))))))));
                      Q7BS("Parser.QObject", "ParseFile", "246", 1);
Q7B_ASSIGNMENT(&na2, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sLine), Q7B_QOBJECT(" "), Q7B_QOBJECT(0), Q7B_QOBJECT(false))), Q7B_QOBJECT(1))))));
                      Q7BS("Parser.QObject", "ParseFile", "247", 1);
Q7B_ASSIGNMENT(&sLine, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(sLine), Q7B_QOBJECT(na2), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sLine))), Q7B_QOBJECT(na2))))))));
                      Q7BS("Parser.QObject", "ParseFile", "249", 1);
Q7B_ASSIGNMENT(&na2, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sLine), Q7B_QOBJECT(" "), Q7B_QOBJECT(0), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "ParseFile", "250", 1);
Q7B_ASSIGNMENT(&n3, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sLine), Q7B_QOBJECT("("), Q7B_QOBJECT(0), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "ParseFile", "251", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(n3), Q7B_QOBJECT(-1)))){
                      Q7BS("Parser.QObject", "ParseFile", "252", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_SMALLER(Q7B_QOBJECT(n3), Q7B_QOBJECT(na2))) || Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(na2), Q7B_QOBJECT(-1)))))){
                      Q7BS("Parser.QObject", "ParseFile", "253", 1);
Q7B_ASSIGNMENT(&na2, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(n3))));
}
}
                      Q7BS("Parser.QObject", "ParseFile", "257", 1);
Q7B_ASSIGNMENT(&na4, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTRREV(Q7B_QOBJECT(sLine), Q7B_QOBJECT(" As "), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sLine))), Q7B_QOBJECT(1))), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "ParseFile", "259", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(na4), Q7B_QOBJECT(-1)))){
                      Q7BS("Parser.QObject", "ParseFile", "261", 1);
Q7B_ASSIGNMENT(&sDataType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_RIGHT(Q7B_QOBJECT(sLine), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sLine))), Q7B_QOBJECT(na4))), Q7B_QOBJECT(4))))))));
                      Q7BS("Parser.QObject", "ParseFile", "267", 1);
Q7B_ASSIGNMENT(&na4, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sDataType), Q7B_QOBJECT(" "), Q7B_QOBJECT(0), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "ParseFile", "268", 1);
Q7B n5; n5 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sDataType), Q7B_QOBJECT("("), Q7B_QOBJECT(0), Q7B_QOBJECT(false)))));
                      Q7BS("Parser.QObject", "ParseFile", "269", 1);
Q7B n6; n6 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sDataType), Q7B_QOBJECT("'"), Q7B_QOBJECT(0), Q7B_QOBJECT(false)))));
                      Q7BS("Parser.QObject", "ParseFile", "270", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(n5), Q7B_QOBJECT(-1))) && Q7B_CBOOLEAN((Q7B_QOBJECT((Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(na4), Q7B_QOBJECT(-1))) || Q7B_CBOOLEAN(Q7B_SMALLER(Q7B_QOBJECT(n5), Q7B_QOBJECT(na4)))))))))){
                      Q7BS("Parser.QObject", "ParseFile", "271", 1);
Q7B_ASSIGNMENT(&na4, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(n5))));
}
                      Q7BS("Parser.QObject", "ParseFile", "273", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(n6), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1))))) && Q7B_CBOOLEAN((Q7B_QOBJECT((Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(na4), Q7B_QOBJECT(-1))) || Q7B_CBOOLEAN(Q7B_SMALLER(Q7B_QOBJECT(n6), Q7B_QOBJECT(na4)))))))))){
                      Q7BS("Parser.QObject", "ParseFile", "274", 1);
Q7B_ASSIGNMENT(&na4, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(n6))));
}
                      Q7BS("Parser.QObject", "ParseFile", "277", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(na4), Q7B_QOBJECT(-1)))){
                      Q7BS("Parser.QObject", "ParseFile", "278", 1);
Q7B_ASSIGNMENT(&sDataType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(sDataType), Q7B_QOBJECT(na4))))));
}
}
                      Q7BS("Parser.QObject", "ParseFile", "282", 1);
Q7B_ASSIGNMENT(&sKey, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(sLine), Q7B_QOBJECT(na2))))));
                      Q7BS("Parser.QObject", "ParseFile", "284", 1);
Q7B_ASSIGNMENT(&sScope, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(this->GetCurrentScope(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile))), Q7B_QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(n))))))));
                      Q7BS("Parser.QObject", "ParseFile", "292", 1);
Q7B_ASSIGNMENT(&sDataType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_REPLACE(Q7B_QOBJECT(Q7B_TRIM(Q7B_QOBJECT(sDataType))), Q7B_QOBJECT("\n"), Q7B_QOBJECT(""), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "293", 1);
Q7B_ASSIGNMENT(&sDataType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_REPLACE(Q7B_QOBJECT(Q7B_TRIM(Q7B_QOBJECT(sDataType))), Q7B_QOBJECT("\r"), Q7B_QOBJECT(""), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "294", 1);
Q7B_DICTIONARY_SETOBJECT(locallist, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sScope), Q7B_QOBJECT("."))), Q7B_QOBJECT(sKey))), Q7B_QOBJECT(sDataType));
}
                      Q7BS("Parser.QObject", "ParseFile", "305", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(n2))));
}
                      Q7BS("Parser.QObject", "ParseFile", "313", 1);
Q7B aa; aa = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT("\nSub "), Q7B_QOBJECT("\nPrivate Sub "), Q7B_QOBJECT("\nPublic Sub "), Q7B_QOBJECT("\nGlobal Sub "), Q7B_QOBJECT("\nFunction "), Q7B_QOBJECT("\nPrivate Function "), Q7B_QOBJECT("\nPublic Function "), Q7B_QOBJECT("\nGlobal Function "), Q7B_QOBJECT("\nSignal "), Q7B_QOBJECT("\nEvent ")))));
                      Q7BS("Parser.QObject", "ParseFile", "314", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(aa)), Q7B_QOBJECT(1))))); Q7BS("Parser.QObject", "ParseFile", "314", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("Parser.QObject", "ParseFile", "315", 1);
Q7B sSearch; sSearch = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(aa, Q7B_QOBJECT(i)))));
                      Q7BS("Parser.QObject", "ParseFile", "317", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))));
                      Q7BS("Parser.QObject", "ParseFile", "318", 1);
while(Q7B_CBOOLEAN((Q7B_QOBJECT(Q7B_SMALLER(Q7B_QOBJECT(n), Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sCode)))))))){
                      Q7BS("Parser.QObject", "ParseFile", "320", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sCode), Q7B_QOBJECT(sSearch), Q7B_QOBJECT(n), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "321", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "ParseFile", "322", 1);
break;
}
                      Q7BS("Parser.QObject", "ParseFile", "325", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n), Q7B_QOBJECT(1))))));
                      Q7BS("Parser.QObject", "ParseFile", "327", 1);
Q7B n22; n22 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sCode), Q7B_QOBJECT("\n"), Q7B_QOBJECT(n), Q7B_QOBJECT(true)))));
                      Q7BS("Parser.QObject", "ParseFile", "328", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n22), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "ParseFile", "329", 1);
break;
}
                      Q7BS("Parser.QObject", "ParseFile", "333", 1);
Q7B sLine2; sLine2 = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(sCode), Q7B_QOBJECT(n), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(n22), Q7B_QOBJECT(n)))))));
                      Q7BS("Parser.QObject", "ParseFile", "336", 1);
Q7B n33; n33 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Parser.QObject", "ParseFile", "337", 1);
Q7B n44; n44 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Parser.QObject", "ParseFile", "339", 1);
while(Q7B_CBOOLEAN((Q7B_QOBJECT(true)))){
                      Q7BS("Parser.QObject", "ParseFile", "340", 1);
Q7B_ASSIGNMENT(&n33, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sLine2), Q7B_QOBJECT("\""), Q7B_QOBJECT(0), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "341", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n33), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "ParseFile", "342", 1);
break;
}
                      Q7BS("Parser.QObject", "ParseFile", "344", 1);
Q7B_ASSIGNMENT(&n44, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sLine), Q7B_QOBJECT("\""), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n33), Q7B_QOBJECT(1))), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "345", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n44), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "ParseFile", "346", 1);
break;
}
                      Q7BS("Parser.QObject", "ParseFile", "348", 1);
Q7B_ASSIGNMENT(&sLine, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(sLine2), Q7B_QOBJECT(n33))), Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(sLine2), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n44), Q7B_QOBJECT(1))), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sLine2))), Q7B_QOBJECT(n44))), Q7B_QOBJECT(1))))))))));
}
                      Q7BS("Parser.QObject", "ParseFile", "351", 1);
Q7B_ASSIGNMENT(&n33, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sLine2), Q7B_QOBJECT("'"), Q7B_QOBJECT(0), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "352", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(n33), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "ParseFile", "353", 1);
Q7B_ASSIGNMENT(&sLine2, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(sLine2), Q7B_QOBJECT(n33))))));
}
                      Q7BS("Parser.QObject", "ParseFile", "358", 1);
Q7B_ASSIGNMENT(&n33, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sLine2), Q7B_QOBJECT("("), Q7B_QOBJECT(0), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "360", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n33), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "ParseFile", "361", 1);
break;
}
                      Q7BS("Parser.QObject", "ParseFile", "364", 1);
Q7B_ASSIGNMENT(&n33, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n33), Q7B_QOBJECT(1))))));
                      Q7BS("Parser.QObject", "ParseFile", "367", 1);
Q7B_ASSIGNMENT(&n44, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sLine2), Q7B_QOBJECT(")"), Q7B_QOBJECT(0), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "368", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n44), Q7B_QOBJECT(-1)))){
                      Q7BS("Parser.QObject", "ParseFile", "369", 1);
break;
}
                      Q7BS("Parser.QObject", "ParseFile", "373", 1);
Q7B sScope2; sScope2 = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_TRIM(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(sLine2), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sSearch))), Q7B_QOBJECT(1))), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(n33), Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sSearch)))))))))));
                      Q7BS("Parser.QObject", "ParseFile", "374", 1);
Q7B sKey2; sKey2 = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("Parser.QObject", "ParseFile", "375", 1);
Q7B sDataType2; sDataType2 = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("Parser.QObject", "ParseFile", "377", 1);
Q7B sArgs; sArgs = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_TRIM(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(sLine2), Q7B_QOBJECT(n33), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(n44), Q7B_QOBJECT(n33)))))))));
                      Q7BS("Parser.QObject", "ParseFile", "380", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sArgs))), Q7B_QOBJECT(0)))){
                      Q7BS("Parser.QObject", "ParseFile", "381", 1);
Q7B aaa; aaa = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_SPLIT(Q7B_QOBJECT(sArgs), Q7B_QOBJECT(","), Q7B_QOBJECT(true)))));
                      Q7BS("Parser.QObject", "ParseFile", "383", 1);
Q7B ii; ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Parser.QObject", "ParseFile", "384", 1);
for (ii = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(ii), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(aaa)), Q7B_QOBJECT(1))))); Q7BS("Parser.QObject", "ParseFile", "384", 1),ii = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(ii), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("Parser.QObject", "ParseFile", "385", 1);
Q7B sArg; sArg = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(aaa, Q7B_QOBJECT(ii)))));
                      Q7BS("Parser.QObject", "ParseFile", "386", 1);
Q7B_ASSIGNMENT(&n44, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sArg), Q7B_QOBJECT(" As "), Q7B_QOBJECT(0), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "387", 1);
if (Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(n44), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "ParseFile", "388", 1);
Q7B_ASSIGNMENT(&sKey2, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_TRIM(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(sArg), Q7B_QOBJECT(n44))))))));
                      Q7BS("Parser.QObject", "ParseFile", "389", 1);
Q7B_ASSIGNMENT(&sDataType2, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(sArg), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n44), Q7B_QOBJECT(4))), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sArg))), Q7B_QOBJECT(n44))), Q7B_QOBJECT(4))))))));
} else {
                      Q7BS("Parser.QObject", "ParseFile", "391", 1);
Q7B_ASSIGNMENT(&sKey2, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_TRIM(Q7B_QOBJECT(sArg))))));
                      Q7BS("Parser.QObject", "ParseFile", "392", 1);
Q7B_ASSIGNMENT(&sDataType2, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT("id"))));
}
                      Q7BS("Parser.QObject", "ParseFile", "394", 1);
Q7B_ASSIGNMENT(&sDataType2, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_REPLACE(Q7B_QOBJECT(Q7B_TRIM(Q7B_QOBJECT(sDataType2))), Q7B_QOBJECT("\n"), Q7B_QOBJECT(""), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "395", 1);
Q7B_ASSIGNMENT(&sDataType2, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_REPLACE(Q7B_QOBJECT(Q7B_TRIM(Q7B_QOBJECT(sDataType2))), Q7B_QOBJECT("\r"), Q7B_QOBJECT(""), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "ParseFile", "396", 1);
Q7B_DICTIONARY_SETOBJECT(locallist, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sScope2), Q7B_QOBJECT("."))), Q7B_QOBJECT(sKey2))), Q7B_QOBJECT(sDataType2));
}
}
                      Q7BS("Parser.QObject", "ParseFile", "402", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(n22))));
}
}
                      Q7BS("Parser.QObject", "ParseFile", "412", 1);
Q7B_DICTIONARY_SETOBJECT(aLocalList, Q7B_QOBJECT(sFile), Q7B_QOBJECT(locallist));
                      Q7BS("Parser.QObject", "ParseFile", "413", 1);
Q7B_DICTIONARY_REMOVE(lock, Q7B_QOBJECT(sFile));
                      Q7BS("Parser.QObject", "ParseFile", "415", 2);

}

void Parser::UpdateCodeInsightHelper(Q7B sFile, Q7B sCode, Q7B a, Q7B m, Q7B b, Q7B bRem)
{
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "418", 0);
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "421", 1);
Q7B n; n = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0)));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "422", 1);
Q7B l; l = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sCode)))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "424", 1);
Q7B_LIST_REMOVEALL(m);
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "428", 1);
Q7B sScope; sScope = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "430", 1);
Q7B sName; sName = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_TRIM(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(0)))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "432", 1);
Q7B sKind; sKind = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(sName)));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "434", 1);
Q7B nCounter; nCounter = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0)));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "436", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0)));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "437", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "437", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "438", 1);
Q7B sSearch; sSearch = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i)))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "440", 1);
if (Q7B_CBOOLEAN(Q7B_STARTSWITH(Q7B_QOBJECT(sSearch), Q7B_QOBJECT("\nPublic "), Q7B_QOBJECT(false)))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "441", 1);
Q7B_ASSIGNMENT(&sScope, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT("Public"))));
} else if (Q7B_CBOOLEAN(Q7B_STARTSWITH(Q7B_QOBJECT(sSearch), Q7B_QOBJECT("\nPrivate "), Q7B_QOBJECT(false)))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "443", 1);
Q7B_ASSIGNMENT(&sScope, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT("Private"))));
} else if (Q7B_CBOOLEAN(Q7B_STARTSWITH(Q7B_QOBJECT(sSearch), Q7B_QOBJECT("\nGlobal "), Q7B_QOBJECT(false)))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "445", 1);
Q7B_ASSIGNMENT(&sScope, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT("Global"))));
} else {
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "447", 1);
Q7B_ASSIGNMENT(&sScope, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT("Private"))));
}
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "450", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "451", 1);
while(Q7B_CBOOLEAN(Q7B_SMALLER(Q7B_QOBJECT(n), Q7B_QOBJECT(l)))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "454", 1);
Q7B n2; n2 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "458", 1);
Q7B_ASSIGNMENT(&n2, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sCode), Q7B_QOBJECT(sSearch), Q7B_QOBJECT(n), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "459", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n2), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "460", 1);
break;
}
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "463", 1);
Q7B n3; n3 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sCode), Q7B_QOBJECT("\n"), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n2), Q7B_QOBJECT(1))), Q7B_QOBJECT(false)))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "465", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n3), Q7B_QOBJECT(-1)))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "466", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n), Q7B_QOBJECT(1))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "467", 1);
continue;
}
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "475", 1);
Q7B nn; nn = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sSearch)))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "477", 1);
Q7B n4; n4 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "478", 1);
if (Q7B_CBOOLEAN(b)){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "479", 1);
Q7B_ASSIGNMENT(&n4, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sCode), Q7B_QOBJECT("("), Q7B_QOBJECT(n2), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "480", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n4), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "481", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n), Q7B_QOBJECT(1))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "482", 1);
continue;
}
} else {
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "485", 1);
Q7B_ASSIGNMENT(&n4, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sCode), Q7B_QOBJECT(" As "), Q7B_QOBJECT(n2), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "486", 1);
if (Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(n4), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "487", 1);
Q7B_ASSIGNMENT(&n4, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sCode), Q7B_QOBJECT(" "), Q7B_QOBJECT(n2), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "488", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n4), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "489", 1);
Q7B_ASSIGNMENT(&n4, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sCode), Q7B_QOBJECT("("), Q7B_QOBJECT(n2), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "490", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n4), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "491", 1);
Q7B_ASSIGNMENT(&n4, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sCode), Q7B_QOBJECT("\n"), Q7B_QOBJECT(n2), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "492", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n4), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "493", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n), Q7B_QOBJECT(1))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "494", 1);
continue;
}
}
}
} else {
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "499", 1);
Q7B_ASSIGNMENT(&n4, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(n3))));
}
}
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "503", 1);
Q7B sTitle; sTitle = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "505", 1);
Q7B_ASSIGNMENT(&sTitle, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(sCode), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n2), Q7B_QOBJECT(nn))), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(n3), Q7B_QOBJECT((Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n2), Q7B_QOBJECT(nn))))))))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "509", 1);
Q7B_ASSIGNMENT(&sTitle, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_REPLACE(Q7B_QOBJECT(sTitle), Q7B_QOBJECT("\n"), Q7B_QOBJECT(""), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "510", 1);
Q7B_ASSIGNMENT(&sTitle, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_REPLACE(Q7B_QOBJECT(sTitle), Q7B_QOBJECT("\r"), Q7B_QOBJECT(""), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "515", 1);
Q7B nLine; nLine = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_COUNT(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(sCode), Q7B_QOBJECT(n2))), Q7B_QOBJECT("\n"), Q7B_QOBJECT(false))), Q7B_QOBJECT(2)))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "532", 1);
Q7B n22; n22 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(n2)));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "534", 1);
Q7B_ASSIGNMENT(&nCounter, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(nCounter), Q7B_QOBJECT(1))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "536", 1);
Q7B_ASSIGNMENT(&n, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(n2), Q7B_QOBJECT(1))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "542", 1);
Q7B sKey; sKey = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "543", 1);
Q7B sArguments; sArguments = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "544", 1);
Q7B sDataType; sDataType = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "546", 1);
Q7B_ASSIGNMENT(&n2, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sTitle), Q7B_QOBJECT(" "), Q7B_QOBJECT(0), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "547", 1);
Q7B_ASSIGNMENT(&n3, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sTitle), Q7B_QOBJECT("("), Q7B_QOBJECT(0), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "549", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(n3), Q7B_QOBJECT(-1)))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "550", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_SMALLER(Q7B_QOBJECT(n3), Q7B_QOBJECT(n2))) || Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n2), Q7B_QOBJECT(-1)))))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "551", 1);
Q7B_ASSIGNMENT(&n2, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(n3))));
}
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "553", 1);
Q7B_ASSIGNMENT(&n4, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sTitle), Q7B_QOBJECT(")"), Q7B_QOBJECT(0), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "555", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(sKind), Q7B_QOBJECT("Dim"))) && Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(sKind), Q7B_QOBJECT("Const"))))) && Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(n4), Q7B_QOBJECT(-1)))))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "556", 1);
Q7B_ASSIGNMENT(&sArguments, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(sTitle), Q7B_QOBJECT(n3), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(n4), Q7B_QOBJECT(n3))), Q7B_QOBJECT(1))))))));
}
}
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "560", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN((Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sKind), Q7B_QOBJECT("Function"))) || Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sKind), Q7B_QOBJECT("Dim"))))) || Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sKind), Q7B_QOBJECT("Const"))))) || Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sKind), Q7B_QOBJECT("Outlet")))))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "562", 1);
Q7B_ASSIGNMENT(&n4, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTRREV(Q7B_QOBJECT(sTitle), Q7B_QOBJECT(" As "), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sTitle))), Q7B_QOBJECT(1))), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "564", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(n4), Q7B_QOBJECT(-1)))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "566", 1);
Q7B_ASSIGNMENT(&sDataType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_RIGHT(Q7B_QOBJECT(sTitle), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sTitle))), Q7B_QOBJECT(n4))), Q7B_QOBJECT(4))))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "570", 1);
Q7B_ASSIGNMENT(&n4, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sDataType), Q7B_QOBJECT(" "), Q7B_QOBJECT(0), Q7B_QOBJECT(false))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "571", 1);
Q7B n5; n5 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sDataType), Q7B_QOBJECT("("), Q7B_QOBJECT(0), Q7B_QOBJECT(false)))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "572", 1);
Q7B n6; n6 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sDataType), Q7B_QOBJECT("'"), Q7B_QOBJECT(0), Q7B_QOBJECT(false)))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "573", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(n5), Q7B_QOBJECT(-1))) && Q7B_CBOOLEAN((Q7B_QOBJECT((Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n4), Q7B_QOBJECT(-1))) || Q7B_CBOOLEAN(Q7B_SMALLER(Q7B_QOBJECT(n5), Q7B_QOBJECT(n4)))))))))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "574", 1);
Q7B_ASSIGNMENT(&n4, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(n5))));
}
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "576", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(n6), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1))))) && Q7B_CBOOLEAN((Q7B_QOBJECT((Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(n4), Q7B_QOBJECT(-1))) || Q7B_CBOOLEAN(Q7B_SMALLER(Q7B_QOBJECT(n6), Q7B_QOBJECT(n4)))))))))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "577", 1);
Q7B_ASSIGNMENT(&n4, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(n6))));
}
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "580", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(n4), Q7B_QOBJECT(-1)))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "581", 1);
Q7B_ASSIGNMENT(&sDataType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(sDataType), Q7B_QOBJECT(n4))))));
}
}
}
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "586", 1);
Q7B_ASSIGNMENT(&sKey, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(sTitle), Q7B_QOBJECT(n2))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "592", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(b), Q7B_QOBJECT(true)))){
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "593", 1);
Q7B_LIST_APPEND(LineSeparators, Q7B_QOBJECT(n22));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "594", 1);
Q7B_LIST_APPEND(LineSeparatorsType, Q7B_QOBJECT(sKey));
}
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "597", 1);
Q7B_ASSIGNMENT(&sDataType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_REPLACE(Q7B_QOBJECT(Q7B_TRIM(Q7B_QOBJECT(sDataType))), Q7B_QOBJECT("\n"), Q7B_QOBJECT(""), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "598", 1);
Q7B_ASSIGNMENT(&sDataType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_REPLACE(Q7B_QOBJECT(Q7B_TRIM(Q7B_QOBJECT(sDataType))), Q7B_QOBJECT("\r"), Q7B_QOBJECT(""), Q7B_QOBJECT(true))))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "601", 1);
Q7B_LIST_APPEND(m, Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT(nLine), Q7B_QOBJECT(sScope), Q7B_QOBJECT(sKind), Q7B_QOBJECT(sKey), Q7B_QOBJECT(sArguments), Q7B_QOBJECT(sDataType))));
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "603", 1);
Q7B_LIST_APPEND(alllist, Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT(nLine), Q7B_QOBJECT(sScope), Q7B_QOBJECT(sKind), Q7B_QOBJECT(sKey), Q7B_QOBJECT(sArguments), Q7B_QOBJECT(sDataType))));
}
}
                      Q7BS("Parser.QObject", "UpdateCodeInsightHelper", "608", 2);

}

Q7B Parser::GetAll(Q7B sFile)
{
                      Q7BS("Parser.QObject", "GetAll", "611", 0);
                      Q7BS("Parser.QObject", "GetAll", "611", 1);
return Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(aAll, Q7B_QOBJECT(sFile)));
                      Q7BS("Parser.QObject", "GetAll", "612", 2);
return Q7B_IDNIL();

}

Q7B Parser::GetSub(Q7B sFile)
{
                      Q7BS("Parser.QObject", "GetSub", "615", 0);
                      Q7BS("Parser.QObject", "GetSub", "615", 1);
return Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(aSub, Q7B_QOBJECT(sFile)));
                      Q7BS("Parser.QObject", "GetSub", "616", 2);
return Q7B_IDNIL();

}

Q7B Parser::GetFunction(Q7B sFile)
{
                      Q7BS("Parser.QObject", "GetFunction", "619", 0);
                      Q7BS("Parser.QObject", "GetFunction", "619", 1);
return Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(aFunction, Q7B_QOBJECT(sFile)));
                      Q7BS("Parser.QObject", "GetFunction", "620", 2);
return Q7B_IDNIL();

}

Q7B Parser::GetAction(Q7B sFile)
{
                      Q7BS("Parser.QObject", "GetAction", "623", 0);
                      Q7BS("Parser.QObject", "GetAction", "623", 1);
return Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(aAction, Q7B_QOBJECT(sFile)));
                      Q7BS("Parser.QObject", "GetAction", "624", 2);
return Q7B_IDNIL();

}

Q7B Parser::GetDim(Q7B sFile)
{
                      Q7BS("Parser.QObject", "GetDim", "627", 0);
                      Q7BS("Parser.QObject", "GetDim", "627", 1);
return Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(aDim, Q7B_QOBJECT(sFile)));
                      Q7BS("Parser.QObject", "GetDim", "628", 2);
return Q7B_IDNIL();

}

Q7B Parser::GetConst(Q7B sFile)
{
                      Q7BS("Parser.QObject", "GetConst", "631", 0);
                      Q7BS("Parser.QObject", "GetConst", "631", 1);
return Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(aConst, Q7B_QOBJECT(sFile)));
                      Q7BS("Parser.QObject", "GetConst", "632", 2);
return Q7B_IDNIL();

}

Q7B Parser::GetEvent(Q7B sFile)
{
                      Q7BS("Parser.QObject", "GetEvent", "635", 0);
                      Q7BS("Parser.QObject", "GetEvent", "635", 1);
return Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(aEvent, Q7B_QOBJECT(sFile)));
                      Q7BS("Parser.QObject", "GetEvent", "636", 2);
return Q7B_IDNIL();

}

Q7B Parser::GetDelegate(Q7B sFile)
{
                      Q7BS("Parser.QObject", "GetDelegate", "639", 0);
                      Q7BS("Parser.QObject", "GetDelegate", "639", 1);
return Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(aProperty, Q7B_QOBJECT(sFile)));
                      Q7BS("Parser.QObject", "GetDelegate", "640", 2);
return Q7B_IDNIL();

}

Q7B Parser::GetIBOutlet(Q7B sFile)
{
                      Q7BS("Parser.QObject", "GetIBOutlet", "643", 0);
                      Q7BS("Parser.QObject", "GetIBOutlet", "643", 1);
return Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(aIBOutlet, Q7B_QOBJECT(sFile)));
                      Q7BS("Parser.QObject", "GetIBOutlet", "644", 2);
return Q7B_IDNIL();

}

Q7B Parser::GetIBAction(Q7B sFile)
{
                      Q7BS("Parser.QObject", "GetIBAction", "647", 0);
                      Q7BS("Parser.QObject", "GetIBAction", "647", 1);
return Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(aIBAction, Q7B_QOBJECT(sFile)));
                      Q7BS("Parser.QObject", "GetIBAction", "648", 2);
return Q7B_IDNIL();

}

Q7B Parser::GetLineSeparators(Q7B sFile)
{
                      Q7BS("Parser.QObject", "GetLineSeparators", "651", 0);
                      Q7BS("Parser.QObject", "GetLineSeparators", "651", 1);
return Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(aLineSeparators, Q7B_QOBJECT(sFile)));
                      Q7BS("Parser.QObject", "GetLineSeparators", "652", 2);
return Q7B_IDNIL();

}

Q7B Parser::GetLineSeparatorsType(Q7B sFile)
{
                      Q7BS("Parser.QObject", "GetLineSeparatorsType", "655", 0);
                      Q7BS("Parser.QObject", "GetLineSeparatorsType", "655", 1);
return Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(aLineSeparatorsType, Q7B_QOBJECT(sFile)));
                      Q7BS("Parser.QObject", "GetLineSeparatorsType", "656", 2);
return Q7B_IDNIL();

}

Q7B Parser::GetLocalList(Q7B sFile)
{
                      Q7BS("Parser.QObject", "GetLocalList", "659", 0);
                      Q7BS("Parser.QObject", "GetLocalList", "659", 1);
return Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(aLocalList, Q7B_QOBJECT(sFile)));
                      Q7BS("Parser.QObject", "GetLocalList", "660", 2);
return Q7B_IDNIL();

}

Q7B Parser::GetCurrentScope(Q7B sFile, Q7B nPosition)
{
                      Q7BS("Parser.QObject", "GetCurrentScope", "663", 0);
                      Q7BS("Parser.QObject", "GetCurrentScope", "663", 1);
Q7B sScope; sScope = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("Parser.QObject", "GetCurrentScope", "665", 1);
Q7B q; q = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Parser.QObject", "GetCurrentScope", "666", 1);
Q7B min; min = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(-1)));
                      Q7BS("Parser.QObject", "GetCurrentScope", "667", 1);
Q7B ming; ming = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(-1)));
                      Q7BS("Parser.QObject", "GetCurrentScope", "670", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(this->GetLineSeparators(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile)))))));
                      Q7BS("Parser.QObject", "GetCurrentScope", "671", 1);
for (q = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(q), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("Parser.QObject", "GetCurrentScope", "671", 1),q = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(q), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("Parser.QObject", "GetCurrentScope", "672", 1);
Q7B u; u = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(q))), Q7B_QOBJECT(1)))))));
                      Q7BS("Parser.QObject", "GetCurrentScope", "673", 1);
if (Q7B_CBOOLEAN(Q7B_SMALLER(Q7B_QOBJECT(u), Q7B_QOBJECT(nPosition)))){
                      Q7BS("Parser.QObject", "GetCurrentScope", "674", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(u), Q7B_QOBJECT(min)))){
                      Q7BS("Parser.QObject", "GetCurrentScope", "675", 1);
Q7B_ASSIGNMENT(&min, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(u))));
                      Q7BS("Parser.QObject", "GetCurrentScope", "676", 1);
Q7B_ASSIGNMENT(&ming, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(q))), Q7B_QOBJECT(1))))));
}
} else {
}
}
                      Q7BS("Parser.QObject", "GetCurrentScope", "686", 1);
if (Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(ming), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "GetCurrentScope", "687", 1);
Q7B b; b = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(this->GetLineSeparatorsType(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile)))))));
                      Q7BS("Parser.QObject", "GetCurrentScope", "689", 1);
Q7B_ASSIGNMENT(&sScope, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(b, Q7B_QOBJECT(ming))))));
}
                      Q7BS("Parser.QObject", "GetCurrentScope", "692", 1);
return Q7B_QOBJECT(sScope);
                      Q7BS("Parser.QObject", "GetCurrentScope", "693", 2);
return Q7B_IDNIL();

}

Q7B Parser::FindLocalVariable(Q7B sFile, Q7B sScope, Q7B sVariable)
{
                      Q7BS("Parser.QObject", "FindLocalVariable", "696", 0);
                      Q7BS("Parser.QObject", "FindLocalVariable", "696", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_QOBJECT(this->GetLocalList(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile)))))));
                      Q7BS("Parser.QObject", "FindLocalVariable", "698", 1);
if (Q7B_CBOOLEAN(Q7B_DICTIONARY_CONTAINS(a, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sScope), Q7B_QOBJECT("."))), Q7B_QOBJECT(sVariable)))))){
                      Q7BS("Parser.QObject", "FindLocalVariable", "699", 1);
return Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(a, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sScope), Q7B_QOBJECT("."))), Q7B_QOBJECT(sVariable)))));
}
                      Q7BS("Parser.QObject", "FindLocalVariable", "702", 1);
return Q7B_QOBJECT("");
                      Q7BS("Parser.QObject", "FindLocalVariable", "703", 2);
return Q7B_IDNIL();

}

Q7B Parser::FindClassVariable(Q7B sFile, Q7B sVariable, Q7B sNeededScope)
{
                      Q7BS("Parser.QObject", "FindClassVariable", "706", 0);
                      Q7BS("Parser.QObject", "FindClassVariable", "706", 1);
Q7B alllist; alllist = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Parser::q7b_sharedSingleton()->GetAll(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile)))))));
                      Q7BS("Parser.QObject", "FindClassVariable", "708", 1);
Q7B list; list = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(alllist)));
                      Q7BS("Parser.QObject", "FindClassVariable", "712", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(list), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("Parser.QObject", "FindClassVariable", "712", 1);
return Q7B_QOBJECT("");
}
                      Q7BS("Parser.QObject", "FindClassVariable", "714", 1);
Q7B y; y = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Parser.QObject", "FindClassVariable", "715", 1);
for (y = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(y), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(list)), Q7B_QOBJECT(1))))); Q7BS("Parser.QObject", "FindClassVariable", "715", 1),y = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(y), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("Parser.QObject", "FindClassVariable", "719", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LIST_OBJECT(list, Q7B_QOBJECT(y)))));
                      Q7BS("Parser.QObject", "FindClassVariable", "721", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(a), Q7B_QOBJECT(Q7B_QOBJECTNULL(0)))) && Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(-1)))))){
                      Q7BS("Parser.QObject", "FindClassVariable", "723", 1);
Q7B nLine; nLine = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(0)))));
                      Q7BS("Parser.QObject", "FindClassVariable", "724", 1);
Q7B sScope; sScope = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(1)))));
                      Q7BS("Parser.QObject", "FindClassVariable", "725", 1);
Q7B sKind; sKind = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(2)))));
                      Q7BS("Parser.QObject", "FindClassVariable", "727", 1);
Q7B sKey; sKey = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(3)))));
                      Q7BS("Parser.QObject", "FindClassVariable", "728", 1);
Q7B sArguments; sArguments = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(4)))));
                      Q7BS("Parser.QObject", "FindClassVariable", "729", 1);
Q7B sDataType; sDataType = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(5)))));
                      Q7BS("Parser.QObject", "FindClassVariable", "731", 1);
Q7B b; b = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
                      Q7BS("Parser.QObject", "FindClassVariable", "733", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sNeededScope), Q7B_QOBJECT(""))) || Q7B_CBOOLEAN((Q7B_QOBJECT((Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sNeededScope), Q7B_QOBJECT("Public"))) && Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sScope), Q7B_QOBJECT("Public"))))))))) || Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sScope), Q7B_QOBJECT("Global")))))){
                      Q7BS("Parser.QObject", "FindClassVariable", "734", 1);
Q7B_ASSIGNMENT(&b, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
}
                      Q7BS("Parser.QObject", "FindClassVariable", "741", 1);
if (Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(sKey), Q7B_QOBJECT(sVariable)))){
                      Q7BS("Parser.QObject", "FindClassVariable", "742", 1);
Q7B_ASSIGNMENT(&b, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
}
                      Q7BS("Parser.QObject", "FindClassVariable", "745", 1);
if (Q7B_CBOOLEAN(b)){
                      Q7BS("Parser.QObject", "FindClassVariable", "746", 1);
return Q7B_QOBJECT(sDataType);
}
}
}
                      Q7BS("Parser.QObject", "FindClassVariable", "754", 1);
return Q7B_QOBJECT("");
                      Q7BS("Parser.QObject", "FindClassVariable", "755", 2);
return Q7B_IDNIL();

}

Q7B Parser::FindGlobalVariable(Q7B sVariable)
{
                      Q7BS("Parser.QObject", "FindGlobalVariable", "758", 0);
                      Q7BS("Parser.QObject", "FindGlobalVariable", "758", 1);
return Q7B_QOBJECT(this->FindClassVariable(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/"))), Q7B_QOBJECT("Global.QObject"))))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sVariable))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT("Public")))));
                      Q7BS("Parser.QObject", "FindGlobalVariable", "759", 2);
return Q7B_IDNIL();

}

Q7B Parser::FindType(Q7B w, Q7B sCompletion, Q7B bCompletion2)
{
                      Q7BS("Parser.QObject", "FindType", "762", 0);
                      Q7BS("Parser.QObject", "FindType", "764", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("Parser.QObject", "FindType", "766", 1);
Q7B sFile; sFile = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))));
                      Q7BS("Parser.QObject", "FindType", "767", 1);
Q7B nPosition; nPosition = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCodeView *) (cb)->ref)->getCurrentPosition()))));
                      Q7BS("Parser.QObject", "FindType", "768", 1);
Q7B sScope; sScope = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(this->GetCurrentScope(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile))), Q7B_QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(nPosition)))))));
                      Q7BS("Parser.QObject", "FindType", "769", 1);
Q7B sType; sType = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("Parser.QObject", "FindType", "772", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Parser.QObject", "FindType", "773", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_SPLIT(Q7B_QOBJECT(sCompletion), Q7B_QOBJECT("."), Q7B_QOBJECT(true)))));
                      Q7BS("Parser.QObject", "FindType", "775", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("Parser.QObject", "FindType", "775", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("Parser.QObject", "FindType", "777", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(bCompletion2) && Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1)))))))){
                      Q7BS("Parser.QObject", "FindType", "778", 1);
break;
}
                      Q7BS("Parser.QObject", "FindType", "781", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i)))));
                      Q7BS("Parser.QObject", "FindType", "782", 1);
Q7B n; n = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(s), Q7B_QOBJECT("("), Q7B_QOBJECT(0), Q7B_QOBJECT(false)))));
                      Q7BS("Parser.QObject", "FindType", "783", 1);
if (Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(n), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("Parser.QObject", "FindType", "784", 1);
Q7B_ASSIGNMENT(&s, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(s), Q7B_QOBJECT(n))))));
}
                      Q7BS("Parser.QObject", "FindType", "788", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(0)))){
                      Q7BS("Parser.QObject", "FindType", "789", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_LCASE(Q7B_QOBJECT(s))), Q7B_QOBJECT(Q7B_LCASE(Q7B_QOBJECT("me")))))){
                      Q7BS("Parser.QObject", "FindType", "790", 1);
Q7B_ASSIGNMENT(&sType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(sFile), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sFile))), Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(Q7B_FILEEXTENSION(Q7B_QOBJECT(sFile))))))), Q7B_QOBJECT(1))))))))));
} else {
                      Q7BS("Parser.QObject", "FindType", "797", 1);
Q7B_ASSIGNMENT(&sType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(this->FindLocalVariable(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sScope))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))))))));
                      Q7BS("Parser.QObject", "FindType", "803", 1);
if (Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sType)))))){
                      Q7BS("Parser.QObject", "FindType", "804", 1);
Q7B_ASSIGNMENT(&sType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(this->FindClassVariable(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(""))))))));
                      Q7BS("Parser.QObject", "FindType", "806", 1);
if (Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(sType)))))){
                      Q7BS("Parser.QObject", "FindType", "807", 1);
Q7B_ASSIGNMENT(&sType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(this->FindGlobalVariable(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))))))));
}
}
}
} else {
                      Q7BS("Parser.QObject", "FindType", "819", 1);
if (Q7B_CBOOLEAN(Q7B_DICTIONARY_CONTAINS(Global::dClassCompletion, Q7B_QOBJECT(sType)))){
                      Q7BS("Parser.QObject", "FindType", "820", 1);
Q7B d; d = Q7B__QOBJECT(Q7B_DICTIONARY(Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(Global::dClassCompletion, Q7B_QOBJECT(sType)))));
                      Q7BS("Parser.QObject", "FindType", "821", 1);
Q7B b; b = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DICTIONARY_OBJECT(d, Q7B_QOBJECT(s)))));
                      Q7BS("Parser.QObject", "FindType", "822", 1);
Q7B_ASSIGNMENT(&sType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(b, Q7B_QOBJECT(2))))));
} else {
                      Q7BS("Parser.QObject", "FindType", "825", 1);
Q7B sNeededScope; sNeededScope = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("Parser.QObject", "FindType", "826", 1);
Q7B y; y = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Parser.QObject", "FindType", "827", 1);
for (y = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(y), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_aProjectFiles()))), Q7B_QOBJECT(1))))); Q7BS("Parser.QObject", "FindType", "827", 1),y = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(y), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("Parser.QObject", "FindType", "831", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_FILEBASENAME(Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Q7B_LIST_OBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_aProjectFiles()), Q7B_QOBJECT(y))))))), Q7B_QOBJECT(sType)))){
                      Q7BS("Parser.QObject", "FindType", "832", 1);
Q7B_ASSIGNMENT(&sFile, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_aProjectFiles()), Q7B_QOBJECT(y))))));
                      Q7BS("Parser.QObject", "FindType", "834", 1);
break;
}
}
                      Q7BS("Parser.QObject", "FindType", "838", 1);
Q7B_ASSIGNMENT(&sNeededScope, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT("Public"))));
                      Q7BS("Parser.QObject", "FindType", "844", 1);
Q7B alllist; alllist = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Parser::q7b_sharedSingleton()->GetAll(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile)))))));
                      Q7BS("Parser.QObject", "FindType", "846", 1);
Q7B list; list = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(alllist)));
                      Q7BS("Parser.QObject", "FindType", "848", 1);
for (y = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(y), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(list)), Q7B_QOBJECT(1))))); Q7BS("Parser.QObject", "FindType", "848", 1),y = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(y), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("Parser.QObject", "FindType", "850", 1);
Q7B aa; aa = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LIST_OBJECT(list, Q7B_QOBJECT(y)))));
                      Q7BS("Parser.QObject", "FindType", "852", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(aa), Q7B_QOBJECT(Q7B_QOBJECTNULL(0)))) && Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LIST_LENGTH(aa)), Q7B_QOBJECT(-1)))))){
                      Q7BS("Parser.QObject", "FindType", "854", 1);
Q7B nLine; nLine = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_LIST_OBJECT(aa, Q7B_QOBJECT(0)))));
                      Q7BS("Parser.QObject", "FindType", "855", 1);
Q7B sScope2; sScope2 = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(aa, Q7B_QOBJECT(1)))));
                      Q7BS("Parser.QObject", "FindType", "856", 1);
Q7B sKind; sKind = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(aa, Q7B_QOBJECT(2)))));
                      Q7BS("Parser.QObject", "FindType", "858", 1);
Q7B sKey; sKey = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(aa, Q7B_QOBJECT(3)))));
                      Q7BS("Parser.QObject", "FindType", "859", 1);
Q7B sArguments; sArguments = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(aa, Q7B_QOBJECT(4)))));
                      Q7BS("Parser.QObject", "FindType", "860", 1);
Q7B sDataType; sDataType = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(aa, Q7B_QOBJECT(5)))));
                      Q7BS("Parser.QObject", "FindType", "862", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sNeededScope), Q7B_QOBJECT(""))) || Q7B_CBOOLEAN((Q7B_QOBJECT((Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sNeededScope), Q7B_QOBJECT("Public"))) && Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sScope2), Q7B_QOBJECT("Public")))))))))){
                      Q7BS("Parser.QObject", "FindType", "868", 1);
Q7B_ASSIGNMENT(&sType, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(sDataType))));
                      Q7BS("Parser.QObject", "FindType", "870", 1);
break;
}
}
}
}
}
}
                      Q7BS("Parser.QObject", "FindType", "880", 1);
return Q7B_QOBJECT(sType);
                      Q7BS("Parser.QObject", "FindType", "882", 2);
return Q7B_IDNIL();

}

Q7B Parser::GetCustomClassIdentifiers(Q7B w, Q7B sType)
{
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "885", 0);
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "886", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "888", 1);
Q7B sFile; sFile = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "892", 1);
Q7B sNeededScope; sNeededScope = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "894", 1);
if (Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(Q7B_FILEBASENAME(Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(sFile))))), Q7B_QOBJECT(sType)))){
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "900", 1);
Q7B bFound; bFound = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "901", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "903", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_aProjectFiles()))), Q7B_QOBJECT(1))))); Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "903", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "907", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_FILEBASENAME(Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Q7B_LIST_OBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_aProjectFiles()), Q7B_QOBJECT(i))))))), Q7B_QOBJECT(sType)))){
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "908", 1);
Q7B_ASSIGNMENT(&sFile, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_aProjectFiles()), Q7B_QOBJECT(i))))));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "910", 1);
Q7B_ASSIGNMENT(&bFound, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "911", 1);
break;
}
}
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "915", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(bFound), Q7B_QOBJECT(false)))){
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "916", 1);
return Q7B_QOBJECT(Q7B_List::init());
}
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "918", 1);
Q7B_ASSIGNMENT(&sNeededScope, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT("Public"))));
}
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "924", 1);
Q7B alllist; alllist = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Parser::q7b_sharedSingleton()->GetAll(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile)))))));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "927", 1);
Q7B list; list = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(alllist)));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "929", 1);
Q7B aa; aa = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "930", 1);
Q7B y; y = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "931", 1);
for (y = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(y), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(list)), Q7B_QOBJECT(1))))); Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "931", 1),y = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(y), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "933", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LIST_OBJECT(list, Q7B_QOBJECT(y)))));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "935", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(a), Q7B_QOBJECT(Q7B_QOBJECTNULL(0)))) && Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(-1)))))){
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "937", 1);
Q7B nLine; nLine = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(0)))));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "938", 1);
Q7B sScope; sScope = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(1)))));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "939", 1);
Q7B sKind; sKind = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(2)))));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "941", 1);
Q7B sKey; sKey = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(3)))));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "942", 1);
Q7B sArguments; sArguments = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(4)))));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "943", 1);
Q7B sDataType; sDataType = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(5)))));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "945", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sNeededScope), Q7B_QOBJECT(""))) || Q7B_CBOOLEAN((Q7B_QOBJECT((Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sNeededScope), Q7B_QOBJECT("Public"))) && Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sScope), Q7B_QOBJECT("Public")))))))))){
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "946", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "947", 1);
Q7B_ASSIGNMENT(&s, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sKey), Q7B_QOBJECT(sArguments))))));
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "951", 1);
Q7B_LIST_APPEND(aa, Q7B_QOBJECT(s));
}
}
}
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "957", 1);
return Q7B_QOBJECT(aa);
                      Q7BS("Parser.QObject", "GetCustomClassIdentifiers", "958", 2);
return Q7B_IDNIL();

}


