
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/
 #ifndef parser_h
#define parser_h

#include <QtGui>


#ifdef Q_WS_X11
  #include <phonon>
#else
  #include <Phonon>
#endif
#include "Q7BRuntime.h"

#include "Global.h"

class Parser;
 extern Parser *q7b_Parser_sharedSingleton;
 extern Q7B q7b_Parser_sharedSingletonQ7B;
extern bool q7b_Parser_sharedSingletonFinalized;
extern bool q7b_Parser_sharedSingletonInit;
class Parser : public QObject
{
Q_OBJECT
public:

Parser(Q7B _q7b_this);
void ParseFile(Q7B sFile);
void UpdateCodeInsightHelper(Q7B sFile, Q7B sCode, Q7B a, Q7B m, Q7B b, Q7B bRem);
Q7B GetAll(Q7B sFile);
Q7B GetSub(Q7B sFile);
Q7B GetFunction(Q7B sFile);
Q7B GetAction(Q7B sFile);
Q7B GetDim(Q7B sFile);
Q7B GetConst(Q7B sFile);
Q7B GetEvent(Q7B sFile);
Q7B GetDelegate(Q7B sFile);
Q7B GetIBOutlet(Q7B sFile);
Q7B GetIBAction(Q7B sFile);
Q7B GetLineSeparators(Q7B sFile);
Q7B GetLineSeparatorsType(Q7B sFile);
Q7B GetLocalList(Q7B sFile);
Q7B GetCurrentScope(Q7B sFile, Q7B nPosition);
Q7B FindLocalVariable(Q7B sFile, Q7B sScope, Q7B sVariable);
Q7B FindClassVariable(Q7B sFile, Q7B sVariable, Q7B sNeededScope);
Q7B FindGlobalVariable(Q7B sVariable);
Q7B FindType(Q7B w, Q7B sCompletion, Q7B bCompletion2);
Q7B GetCustomClassIdentifiers(Q7B w, Q7B sType);
public:
public:
Q7B aAll;
Q7B aSub;
Q7B aFunction;
Q7B aAction;
Q7B aDim;
Q7B aConst;
Q7B aEvent;
Q7B aProperty;
Q7B aIBOutlet;
Q7B aIBAction;
Q7B aLineSeparators;
Q7B aLineSeparatorsType;
Q7B aLocalList;
Q7B alllist;
Q7B sublist;
Q7B functionlist;
Q7B eventlist;
Q7B Dimlist;
Q7B constlist;
Q7B actionlist;
Q7B propertylist;
Q7B iboutletlist;
Q7B ibactionlist;
Q7B remlist;
Q7B locallist;
Q7B LineSeparators;
Q7B LineSeparatorsType;
Q7B comletionlist;
Q7B comletion;
Q7B lock;


private:
Q7B q7b_this;


public:
static Q7B q7b_sharedSingletonQ7B()
{
q7b_sharedSingleton();
return q7b_Parser_sharedSingletonQ7B;
};


static Parser* q7b_sharedSingleton()
{
if (q7b_Parser_sharedSingletonFinalized) return 0;
if (q7b_Parser_sharedSingleton == 0){
q7b_Parser_sharedSingletonInit = true;
q7b_Parser_sharedSingleton = new Parser(q7b_Parser_sharedSingletonQ7B);
}
return q7b_Parser_sharedSingleton;
}



void Set_aAll(Q7B q7b_var){ aAll = q7b_var; }
Q7B Get_aAll(){ return aAll; }
void Set_aSub(Q7B q7b_var){ aSub = q7b_var; }
Q7B Get_aSub(){ return aSub; }
void Set_aFunction(Q7B q7b_var){ aFunction = q7b_var; }
Q7B Get_aFunction(){ return aFunction; }
void Set_aAction(Q7B q7b_var){ aAction = q7b_var; }
Q7B Get_aAction(){ return aAction; }
void Set_aDim(Q7B q7b_var){ aDim = q7b_var; }
Q7B Get_aDim(){ return aDim; }
void Set_aConst(Q7B q7b_var){ aConst = q7b_var; }
Q7B Get_aConst(){ return aConst; }
void Set_aEvent(Q7B q7b_var){ aEvent = q7b_var; }
Q7B Get_aEvent(){ return aEvent; }
void Set_aProperty(Q7B q7b_var){ aProperty = q7b_var; }
Q7B Get_aProperty(){ return aProperty; }
void Set_aIBOutlet(Q7B q7b_var){ aIBOutlet = q7b_var; }
Q7B Get_aIBOutlet(){ return aIBOutlet; }
void Set_aIBAction(Q7B q7b_var){ aIBAction = q7b_var; }
Q7B Get_aIBAction(){ return aIBAction; }
void Set_aLineSeparators(Q7B q7b_var){ aLineSeparators = q7b_var; }
Q7B Get_aLineSeparators(){ return aLineSeparators; }
void Set_aLineSeparatorsType(Q7B q7b_var){ aLineSeparatorsType = q7b_var; }
Q7B Get_aLineSeparatorsType(){ return aLineSeparatorsType; }
void Set_aLocalList(Q7B q7b_var){ aLocalList = q7b_var; }
Q7B Get_aLocalList(){ return aLocalList; }
void Set_alllist(Q7B q7b_var){ alllist = q7b_var; }
Q7B Get_alllist(){ return alllist; }
void Set_sublist(Q7B q7b_var){ sublist = q7b_var; }
Q7B Get_sublist(){ return sublist; }
void Set_functionlist(Q7B q7b_var){ functionlist = q7b_var; }
Q7B Get_functionlist(){ return functionlist; }
void Set_eventlist(Q7B q7b_var){ eventlist = q7b_var; }
Q7B Get_eventlist(){ return eventlist; }
void Set_Dimlist(Q7B q7b_var){ Dimlist = q7b_var; }
Q7B Get_Dimlist(){ return Dimlist; }
void Set_constlist(Q7B q7b_var){ constlist = q7b_var; }
Q7B Get_constlist(){ return constlist; }
void Set_actionlist(Q7B q7b_var){ actionlist = q7b_var; }
Q7B Get_actionlist(){ return actionlist; }
void Set_propertylist(Q7B q7b_var){ propertylist = q7b_var; }
Q7B Get_propertylist(){ return propertylist; }
void Set_iboutletlist(Q7B q7b_var){ iboutletlist = q7b_var; }
Q7B Get_iboutletlist(){ return iboutletlist; }
void Set_ibactionlist(Q7B q7b_var){ ibactionlist = q7b_var; }
Q7B Get_ibactionlist(){ return ibactionlist; }
void Set_remlist(Q7B q7b_var){ remlist = q7b_var; }
Q7B Get_remlist(){ return remlist; }
void Set_locallist(Q7B q7b_var){ locallist = q7b_var; }
Q7B Get_locallist(){ return locallist; }
void Set_LineSeparators(Q7B q7b_var){ LineSeparators = q7b_var; }
Q7B Get_LineSeparators(){ return LineSeparators; }
void Set_LineSeparatorsType(Q7B q7b_var){ LineSeparatorsType = q7b_var; }
Q7B Get_LineSeparatorsType(){ return LineSeparatorsType; }
void Set_comletionlist(Q7B q7b_var){ comletionlist = q7b_var; }
Q7B Get_comletionlist(){ return comletionlist; }
void Set_comletion(Q7B q7b_var){ comletion = q7b_var; }
Q7B Get_comletion(){ return comletion; }
void Set_lock(Q7B q7b_var){ lock = q7b_var; }
Q7B Get_lock(){ return lock; }

};
#endif
