
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/
 #include "Q7BRuntime.h"

#include "Global.h"
#include "Q7BCodeView.h"

#include "Q7BCompiler.h"

#include <typeinfo>
#include "Application.h"

#include "Project.h"

Project *q7b_Project_sharedSingleton = 0;
Q7B q7b_Project_sharedSingletonQ7B;
bool q7b_Project_sharedSingletonFinalized = false;
bool q7b_Project_sharedSingletonInit = false;
extern Q7B Q7B_idGLOBAL;
extern Q7B Q7B_idAPPLICATION;
extern Q7B Q7B_idSTATUSBAR;
extern Q7B Q7B_idSOUNDS;
extern Q7B Q7B_idDATABASE;
extern Q7B Q7B_idTABLE;
extern Q7B Q7B_idRECORDS;
extern Q7B Q7B_idQUERY;
extern Q7B Q7B_idPIXMAPS;
extern Q7B Q7B_idCOLORS;
extern Q7B Q7B_idFONTS;
extern Q7B Q7B_idTOOLBAR;
extern Q7B Q7B_idSYSTEMTRAY;
extern Q7B Q7B_idMAINWINDOW;
extern Q7B Q7B_idDEBUG;
extern Q7B Q7B_idFILE;
extern Q7B Q7B_idPREFERENCES;
extern Q7B Q7B_idDIR;
extern Q7B Q7B_idDESKTOP;
extern Q7B Q7B_idOPENFILEDIALOG;
extern Q7B Q7B_idSAVEFILEDIALOG;
extern Q7B Q7B_idCOLORDIALOG;
extern Q7B Q7B_idFONTDIALOG;
extern Q7B Q7B_idPROGRESSDIALOG;
extern Q7B Q7B_idINPUTDIALOG;
extern Q7B Q7B_idMESSAGEBOX;
extern Q7B Q7B_idOS;
#define CommandButton Q7B_CommandButton
#define CommandLinkButton Q7B_CommandLinkButton
#define ImageButton Q7B_ImageButton
#define ToolButton Q7B_ToolButton
#define CheckBox Q7B_CheckBox
#define RadioButton Q7B_RadioButton
#define Label Q7B_Label
#define Frame Q7B_Frame
#define ImageBox Q7B_ImageBox
#define TextBox Q7B_TextBox
#define uiClass Q7B_uiClass
#define Class Q7B_Class
#define Module Q7B_Module
#define Control QWidget
#include "MainWindow.h"
#include "Parser.h"
#include "CodeView.h"


Project::Project(Q7B _q7b_this)
{
q7b_this = _q7b_this;
if (q7b_Project_sharedSingletonInit){ q7b_Project_sharedSingletonInit = false; q7b_Project_sharedSingletonQ7B = q7b_this = Q7B(new Q7B_id(typeid(Project).name(), this)); } else q7b_this = Q7B(new Q7B_id(typeid(Project).name(), this)); 
sProjectPath = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
sProjectName = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
aProjectFiles = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
}


Q7B Project::Open(Q7B Path)
{
                      Q7BS("Project.QObject", "Open", "19", 0);
                      Q7BS("Project.QObject", "Open", "21", 1);
Q7B_ASSIGNMENT(&sProjectPath, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Path))));
                      Q7BS("Project.QObject", "Open", "22", 1);
if (Q7B_CBOOLEAN(this->OpenInternal(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sProjectPath)))))){
} else {
}
                      Q7BS("Project.QObject", "Open", "29", 1);
MainWindow::q7b_sharedSingleton()->UpdateRecentProjects(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Path))));
                      Q7BS("Project.QObject", "Open", "31", 2);
return Q7B_IDNIL();

}

Q7B Project::IsSingleFileProject()
{
                      Q7BS("Project.QObject", "IsSingleFileProject", "34", 0);
                      Q7BS("Project.QObject", "IsSingleFileProject", "34", 1);
return Q7B_QOBJECT(Q7B_FILE(Q7B_QOBJECT(sProjectPath)));
                      Q7BS("Project.QObject", "IsSingleFileProject", "35", 2);
return Q7B_IDNIL();

}

Q7B Project::OpenInternal(Q7B Path)
{
                      Q7BS("Project.QObject", "OpenInternal", "38", 0);
                      Q7BS("Project.QObject", "OpenInternal", "41", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Path)))){
                      Q7BS("Project.QObject", "OpenInternal", "43", 1);
Q7B_CLOSEALLMDI();
                      Q7BS("Project.QObject", "OpenInternal", "45", 1);
Q7B_LIST_REMOVEALL(aProjectFiles);
                      Q7BS("Project.QObject", "OpenInternal", "47", 1);
this->OpenCodeView(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Path))));
                      Q7BS("Project.QObject", "OpenInternal", "48", 1);
Q7B_LIST_APPEND(aProjectFiles, Q7B_QOBJECT(Path));
} else {
                      Q7BS("Project.QObject", "OpenInternal", "55", 1);
if (Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_DIR(Q7B_QOBJECT(Path), Q7B_QOBJECT(false)))))){
                      Q7BS("Project.QObject", "OpenInternal", "56", 1);
return Q7B_QOBJECT(false);
}
                      Q7BS("Project.QObject", "OpenInternal", "59", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DIR_LIST(Q7B_idDIR, Q7B_QOBJECT(Path)))));
                      Q7BS("Project.QObject", "OpenInternal", "61", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Project.QObject", "OpenInternal", "62", 1);
Q7B bValid; bValid = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
                      Q7BS("Project.QObject", "OpenInternal", "63", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("Project.QObject", "OpenInternal", "63", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("Project.QObject", "OpenInternal", "64", 1);
if (Q7B_CBOOLEAN(Q7B_ENDSWITH(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))), Q7B_QOBJECT("Global.QObject"), Q7B_QOBJECT(true)))){
                      Q7BS("Project.QObject", "OpenInternal", "65", 1);
Q7B_ASSIGNMENT(&bValid, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
                      Q7BS("Project.QObject", "OpenInternal", "66", 1);
break;
}
}
                      Q7BS("Project.QObject", "OpenInternal", "69", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(bValid), Q7B_QOBJECT(false)))){
                      Q7BS("Project.QObject", "OpenInternal", "70", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Selected folder is not a valid Q7Basic project"));
                      Q7BS("Project.QObject", "OpenInternal", "71", 1);
return Q7B_QOBJECT(false);
}
                      Q7BS("Project.QObject", "OpenInternal", "76", 1);
Q7B_CLOSEALLMDI();
                      Q7BS("Project.QObject", "OpenInternal", "88", 1);
Q7B_LIST_REMOVEALL(aProjectFiles);
                      Q7BS("Project.QObject", "OpenInternal", "90", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("Project.QObject", "OpenInternal", "90", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("Project.QObject", "OpenInternal", "92", 1);
if (Q7B_CBOOLEAN(Q7B_ISDIR(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i)))))){
                      Q7BS("Project.QObject", "OpenInternal", "93", 1);
continue;
}
                      Q7BS("Project.QObject", "OpenInternal", "96", 1);
if (Q7B_CBOOLEAN(Q7B_ENDSWITH(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))), Q7B_QOBJECT(".ui"), Q7B_QOBJECT(true)))){
                      Q7BS("Project.QObject", "OpenInternal", "97", 1);
continue;
}
                      Q7BS("Project.QObject", "OpenInternal", "100", 1);
if (Q7B_CBOOLEAN(Q7B_ENDSWITH(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))), Q7B_QOBJECT(".qrc"), Q7B_QOBJECT(true)))){
                      Q7BS("Project.QObject", "OpenInternal", "101", 1);
continue;
}
                      Q7BS("Project.QObject", "OpenInternal", "104", 1);
if (Q7B_CBOOLEAN(Q7B_STARTSWITH(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))), Q7B_QOBJECT("."), Q7B_QOBJECT(true)))){
                      Q7BS("Project.QObject", "OpenInternal", "105", 1);
continue;
}
                      Q7BS("Project.QObject", "OpenInternal", "110", 1);
this->OpenCodeView(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))))));
                      Q7BS("Project.QObject", "OpenInternal", "113", 1);
Q7B_LIST_APPEND(aProjectFiles, Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))));
                      Q7BS("Project.QObject", "OpenInternal", "120", 1);
Parser::q7b_sharedSingleton()->ParseFile(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))))));
}
                      Q7BS("Project.QObject", "OpenInternal", "130", 1);
Q7B aa; aa = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LISTMDI())));
                      Q7BS("Project.QObject", "OpenInternal", "132", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(aa)), Q7B_QOBJECT(1))))); Q7BS("Project.QObject", "OpenInternal", "132", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("Project.QObject", "OpenInternal", "133", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_LIST_OBJECT(aa, Q7B_QOBJECT(i))));
                      Q7BS("Project.QObject", "OpenInternal", "134", 1);
if (Q7B_CBOOLEAN(Q7B_ENDSWITH(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName"))), Q7B_QOBJECT("Global.QObject"), Q7B_QOBJECT(true)))){
                      Q7BS("Project.QObject", "OpenInternal", "135", 1);
Q7B_SETFOCUSMDI(Q7B_QOBJECT(w));
                      Q7BS("Project.QObject", "OpenInternal", "137", 1);
break;
}
}
}
                      Q7BS("Project.QObject", "OpenInternal", "145", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_PREFERENCES_STRING(Q7B_idPREFERENCES, Q7B_QOBJECT("Serial")))));
                      Q7BS("Project.QObject", "OpenInternal", "146", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(s))), Q7B_QOBJECT(0)))){
                      Q7BS("Project.QObject", "OpenInternal", "149", 1);
Q7B_QWIDGET_WINDOWTITLE(MainWindow::q7b_sharedSingletonQ7B(), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT("Q7Basic - "), Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Path))))));
                      Q7BS("Project.QObject", "OpenInternal", "151", 1);
if (Q7B_CBOOLEAN(Q7B_OS_ISMAC(Q7B_idOS))){
                      Q7BS("Project.QObject", "OpenInternal", "152", 1);
MainWindow::q7b_sharedSingleton()->SetWindowTitle(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Path))))));
} else {
                      Q7BS("Project.QObject", "OpenInternal", "154", 1);
MainWindow::q7b_sharedSingleton()->SetWindowTitle(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Path))), Q7B_QOBJECT(" - Q7Basic"))))));
}
} else {
                      Q7BS("Project.QObject", "OpenInternal", "158", 1);
if (Q7B_CBOOLEAN(Q7B_OS_ISMAC(Q7B_idOS))){
                      Q7BS("Project.QObject", "OpenInternal", "159", 1);
MainWindow::q7b_sharedSingleton()->SetWindowTitle(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Path))), Q7B_QOBJECT(" (NOT REGISTERED)"))))));
} else {
                      Q7BS("Project.QObject", "OpenInternal", "161", 1);
MainWindow::q7b_sharedSingleton()->SetWindowTitle(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Path))), Q7B_QOBJECT(" - Q7Basic (NOT REGISTERED)"))))));
}
}
                      Q7BS("Project.QObject", "OpenInternal", "168", 1);
return Q7B_QOBJECT(true);
                      Q7BS("Project.QObject", "OpenInternal", "170", 2);
return Q7B_IDNIL();

}

Q7B Project::IsOpened()
{
                      Q7BS("Project.QObject", "IsOpened", "173", 0);
                      Q7BS("Project.QObject", "IsOpened", "173", 1);
return Q7B_QOBJECT(Q7B_GREATER(Q7B_QOBJECT(Q7B_LIST_LENGTH(aProjectFiles)), Q7B_QOBJECT(0)));
                      Q7BS("Project.QObject", "IsOpened", "174", 2);
return Q7B_IDNIL();

}

void Project::OpenCodeView(Q7B f)
{
                      Q7BS("Project.QObject", "OpenCodeView", "179", 0);
                      Q7BS("Project.QObject", "OpenCodeView", "180", 1);
if (Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_CONTAINS(Q7B_QOBJECT(f), Q7B_QOBJECT("/"), Q7B_QOBJECT(true)))))){
                      Q7BS("Project.QObject", "OpenCodeView", "181", 1);
Q7B_ASSIGNMENT(&f, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sProjectPath), Q7B_QOBJECT("/"))), Q7B_QOBJECT(f))))));
}
                      Q7BS("Project.QObject", "OpenCodeView", "185", 1);
Q7B cw; cw = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_OPENMDI(Q7B_QOBJECT("CodeView"))));
                      Q7BS("Project.QObject", "OpenCodeView", "187", 1);
((CodeView *) cw->ref)->Load(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(f))));
                      Q7BS("Project.QObject", "OpenCodeView", "189", 2);

}

void Project::SaveAll()
{
                      Q7BS("Project.QObject", "SaveAll", "192", 0);
                      Q7BS("Project.QObject", "SaveAll", "193", 1);
Q7B b; b = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT((bool) false)));
                      Q7BS("Project.QObject", "SaveAll", "195", 1);
Q7B aa; aa = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LISTMDI())));
                      Q7BS("Project.QObject", "SaveAll", "196", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("Project.QObject", "SaveAll", "198", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(aa)), Q7B_QOBJECT(1))))); Q7BS("Project.QObject", "SaveAll", "198", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("Project.QObject", "SaveAll", "199", 1);
Q7B cw; cw = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_LIST_OBJECT(aa, Q7B_QOBJECT(i))));
                      Q7BS("Project.QObject", "SaveAll", "200", 1);
Q7B_ASSIGNMENT(&b, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(((CodeView *) cw->ref)->SaveIfChanged()))));
}
                      Q7BS("Project.QObject", "SaveAll", "203", 2);

}


