
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/
 
#include "Q7BCodeView.h"

#define WINDOWS true





QString kbasicPath(QString)
{
  return "";
}

QString DefaultFontName()
{
    QString sFamily = "";
if (sFamily.isEmpty()){
#ifdef Q_OS_WIN32
sFamily = "Courier New";
#elif defined Q_WS_MAC
sFamily = "Monaco";
#elif defined Q_WS_X11
sFamily = "Monospace";
#endif
  
}
return sFamily;
}

int DefaultFontSize()
{
    int nSize = 0;
if (nSize == 0) nSize = 10;
#ifdef Q_OS_MAC
     nSize += 2;
#endif
  return nSize;
}
   
QSet<QString> Q7B_keyword_set;
QMap<QString, QString> Q7B_keyword;








QSet<QString> Q7B_type_set;
QMap<QString, QString> Q7B_type;




CodeSyntaxHighlighter::CodeSyntaxHighlighter(QTextDocument *parent) : QSyntaxHighlighter(parent)
 {
     


     QString sFamily = DefaultFontName();
     int nSize = DefaultFontSize();

     normalFormat.setFontFamily(sFamily); 
     normalFormat.setFontPointSize(nSize);

     typeFormat.setForeground(Qt::darkCyan);
     typeFormat.setFontFamily(sFamily); 
     typeFormat.setFontPointSize(nSize);

     keywordFormat.setForeground(Qt::blue);
     keywordFormat.setFontFamily(sFamily); 
     keywordFormat.setFontPointSize(nSize);

     commentFormat.setForeground(Qt::darkGreen);
     commentFormat.setFontFamily(sFamily); 
     commentFormat.setFontPointSize(nSize);

     quotationFormat.setForeground(Qt::darkBlue);
     quotationFormat.setFontFamily(sFamily); 
     quotationFormat.setFontPointSize(nSize);

     signalFormat.setForeground(Qt::darkGray);
     signalFormat.setFontFamily(sFamily); 
     signalFormat.setFontPointSize(nSize);     

     static QColor c1 = QColor(194, 150, 264).darker();
     static QBrush b1 = c1;
     eventFormat.setForeground(Qt::darkMagenta); 
     eventFormat.setFontFamily(sFamily); 
     eventFormat.setFontPointSize(nSize);

     static QColor c2 = QColor(61, 208, 244).darker();
     static QBrush b2 = c2;
     outletFormat.setForeground(b2);
     outletFormat.setFontFamily(sFamily); 
     outletFormat.setFontPointSize(nSize);


     bString_string = false;

 }

 void CodeSyntaxHighlighter::highlightBlock(const QString &text)
 {
   int nLen = text.length();
  

     setFormat(0, nLen, normalFormat);


     int index = 0;
     int index2 = 0;
     int nString = 0;
     bool b = false;
     bool bString = false;

     if (bString_string){
       nString = 0;
     }

     if (text.startsWith("Signal on_")){
        setFormat(7, 3, signalFormat);    
        int n = text.indexOf("(");
        int n2 = text.lastIndexOf("_", n);
        if (n >= 0 && n2 >= 0){
          setFormat(10, n - 10, outletFormat); 
          setFormat(n2, n - n2, signalFormat);       
        }
     }
     
     if (text.startsWith("Event ")){
        int n = text.indexOf("(");
        if (n >= 0) setFormat(6, n - 6, eventFormat);    
     }
n:
     while (index < nLen){
       int i;
       for (i = index; i < nLen; i++){
         QChar c = text.at(i);
         QChar c2 = 0; if (i > 0) c2 = text.at(i - 1);

         QString string;

         if (c == '>' && i - 7 > 0){
           string = text.mid(i - 7, 8);

           if (string == "<string>"){
             bString_string = true;
             nString = i + 1;
           } 
         }        

         if (c == '>' && i - 8 > 0){
           string = text.mid(i - 8, 9);

           if (string == "</string>"){
             bString_string = false;
             setFormat(nString, i - nString + 1 - 9, quotationFormat);                           
           }
         }        

         if (bString_string == false && c == '\"' && c2 != '\\'){
           if (bString){
              setFormat(nString, i - nString + 1, quotationFormat);              
           } else {
             nString = i;
           }
           bString = !bString;
         }
         if (!bString_string && !bString && c == '\''){
           QString r = text.mid(index, i - index);

          if (Q7B_type_set.contains(r)){
            setFormat(index, i - index, typeFormat);
          } else 
          if (Q7B_keyword_set.contains(r)){
            setFormat(index, i - index, keywordFormat);
          }

           setFormat(i, nLen - i, commentFormat);
           return; 
         }

       
         if (!bString_string && !bString && ((!c.isLetter() && i == index && c != '_') || c.isSpace() || c.isMark() || c == '(')) break;

       }

       if (bString_string){
         setFormat(nString, i, quotationFormat);                           
       } else {
         if (Q7B_type_set.contains(text.mid(index, i - index))){
           setFormat(index, i - index, typeFormat);
           index2 = index + (i - index);
         } else if (Q7B_keyword_set.contains(text.mid(index, i - index))){
           setFormat(index, i - index, keywordFormat);
           index2 = index + (i - index);
         }
       }
       index = i + 1;
       
     }

     index = index2;


     if (b == false && index == -1 && index2 && index2 + 1 < nLen){
       b = true;
       index = index2;
       goto n;
     }


 }

 
CodeCompletion2::CodeCompletion2(QWidget *parent, Q7BCodeWindow *_cw) : QLabel (parent)
{
  cw = _cw;  
  
  setAutoFillBackground(true);
    setMargin(0);
    setIndent(4);    
 QPalette p = palette();
  
 p.setColor(QPalette::Base, QColor(0xFFFF9F));
  
 setPalette(p);
 setFrameShape(QFrame::Box);

}

void CodeCompletion2::ShowUp(QString _sSignature)
{
  sSignature = _sSignature;
  setLabel("", 0, true);
  this->adjustSize();
  show();  
  setFocus();
}

void CodeCompletion2::setLabel(QString sLine, int nCursorPos, bool bStart)
{
 
  QString s = sSignature;
  int nStart = 0;
  int nEnd = 0;

  int nComma = 0;
  int nParamPos = 0;
  int h = 1;

  while (h > 0){
    h = sSignature.indexOf(",", h + 1);
    if (h > 0) nComma++;
  }  
  
  h = 1;

  while (h > 0){
    h = sLine.indexOf(",", h + 1);
    if (h > 0) nParamPos++;
  }

  if (nParamPos > nComma) nParamPos = nComma;

  if (nParamPos == 0){
    nStart = s.indexOf("(");
    nEnd = s.indexOf(",");
    if (nEnd == -1) nEnd = s.indexOf(")");   
  } else {
    nStart = s.indexOf("(");
    for (int i = 0; i < nParamPos; i++){
      int n = s.indexOf(",", nStart + 1);
      if (n == -1) n = s.indexOf(")");   
      nStart = n;      
    }
    nEnd = s.indexOf(",", nStart + 1);
    if (nEnd == -1) nEnd = s.indexOf(")", nStart);   
  }

  if (nCursorPos > 0){
    s.insert(nEnd, "</b></font>");
    s.insert(nStart + 1, "<font color=\"#111183\"><b>");
  }
  
  setText(s + " ");
  adjustSize();
  show();
}


CodeCompletion1::CodeCompletion1(QWidget *parent, Q7BCodeWindow *_cw) : QListWidget (parent)
{
  cw = _cw;  
  
  


  connect(this, SIGNAL(itemActivated(QListWidgetItem *)), this, SLOT(this_itemActivated(QListWidgetItem *)));
  connect(this, SIGNAL(itemClicked(QListWidgetItem *)), this, SLOT(this_itemActivated(QListWidgetItem *)));

  setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);




}

void CodeCompletion1::this_itemActivated(QListWidgetItem *item)
{

  QString s = "";

  if (currentText().isEmpty()) return;

  s = currentText();    
  
  if (s.startsWith(sInputedText, Qt::CaseInsensitive) && !s.isEmpty()){
    cw->PerformInsertText(s.mid(sInputedText.length()));
  }
  cw->setFocus();
  hide();       
}

void CodeCompletion1::ShowUp(QStringList & _items)
{
  clear();
  sInputedText = "";  
  items = _items;
  addItems(items);
  setCurrentRow(0);
  
  
  show();  
  setFocus();
 
 
 
 
}

void CodeCompletion1::focusOutEvent(QFocusEvent *e)
{  
  QListWidget::focusOutEvent(e);
  cw->code->setFocus();
  hide();
}


void CodeCompletion1::keyPressEvent(QKeyEvent *e)
{

  int n  = e->key();

  if (n == Qt::Key_Return || n == Qt::Key_Enter){        

    QString s = currentText();
    if (s.startsWith(sInputedText, Qt::CaseInsensitive)){
      cw->PerformInsertText(s.mid(sInputedText.length()));
    }
    cw->setFocus();
    hide(); 

  } else if (n == Qt::Key_BraceLeft){    

    QString s = currentText();
    if (s.startsWith(sInputedText, Qt::CaseInsensitive)){
      cw->PerformInsertText(s.mid(sInputedText.length()));
    }
    cw->setFocus();
    hide(); 

  } else if (n == Qt::Key_Escape){
    cw->setFocus();
    hide(); 
  } else if (n == Qt::Key_Backspace){  
    int k = sInputedText.length() - 1;

    e->ignore();
    if (k == -1){      
      hide(); 
      cw->setFocus();
    } else {      
      sInputedText = sInputedText.left(k);

      QListWidgetItem *k = itemWithText(sInputedText);
      if (k == 0){
        clearSelection();
      } else {

        clear();
        foreach(QString s, items)
        {
          if (s.startsWith(sInputedText, Qt::CaseInsensitive)){
            addItem(s);
          }
        }
        QListWidgetItem *k = itemWithText(sInputedText);
        if (k == 0){
          hide(); 
          cw->setFocus();
        } else {
          setCurrentItem(k);
        }
        
      }

    }
  } else {
    cw->code->setCursorWidth(1); cw->code->setCursorWidth(2); 
    QString s = e->text();
    if (!s.isNull() && s.length() > 0){
      e->ignore();

      sInputedText.append(s);

      QListWidgetItem *k = itemWithText(sInputedText);
      if (k == 0){
        hide(); 
        cw->setFocus();
       
      } else {

        clear();
        foreach(QString s, items)
        {
          if (s.startsWith(sInputedText, Qt::CaseInsensitive)){
            addItem(s);
          }
        }
        QListWidgetItem *k = itemWithText(sInputedText);
        if (k == 0){
          hide(); 
          cw->setFocus();
        } else {
          setCurrentItem(k);
        }
        
      }
    } else {

      if (n == Qt::Key_Up && currentRow() == 0){}
      else if (n == Qt::Key_Down && currentRow() == count() - 1){}
      else { 

        QListWidget::keyPressEvent(e);
      }
    }
  }

}



Code::Code(Q7BCodeWindow *parent = 0) : QPlainTextEdit (parent)
{
  cw = parent;
  
  
  setCursorWidth(2);
  setFrameStyle(QFrame::NoFrame);
  setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOn);
  
  document()->setDocumentMargin(18);

  connect(this, SIGNAL(textChanged(void)), cw, SLOT(code_textChanged(void)));

  connect(this, SIGNAL(cursorPositionChanged(void)), cw, SLOT(code_cursorPositionChanged(void)));
  
 
  
  connect(this, SIGNAL(blockCountChanged(int)), this, SLOT(this_blockCountChanged(int)));

  bUpdateForChangedText = false;

  codecompletion1 = new CodeCompletion1(viewport(), cw);
  codecompletion1->resize(100, 200);
  codecompletion1->setHidden(true);
  codecompletion1->setCursor(Qt::ArrowCursor);

  codecompletion2 = new CodeCompletion2(viewport(), cw);
  
  codecompletion2->resize(100, 20);
  codecompletion2->setHidden(true);
  codecompletion2->setCursor(Qt::ArrowCursor);

  


 
 



}


void Code::mousePressEvent(QMouseEvent* e)
{
  if (codecompletion1->isVisible()){
    codecompletion1->hide();
  }
  if (codecompletion2->isVisible()){
    codecompletion2->hide();
  }  
  QPlainTextEdit::mousePressEvent(e);
}

void Code::wheelEvent(QWheelEvent* e)
{
  if (codecompletion1->isVisible()){
    codecompletion1->hide();
  }
  if (codecompletion2->isVisible()){
    codecompletion2->hide();
  }  
  QPlainTextEdit::wheelEvent(e);
  viewport()->update();
}


void Code::this_blockCountChanged(int)
{
  bUpdateForChangedText = true;
  
}







void Code::paintEvent ( QPaintEvent * e )
{



    QPlainTextEdit::paintEvent(e);


    QPainter painter(viewport());
    QRect viewportRect = viewport()->rect();
    QPointF offset(contentOffset());
    QTextBlock block = firstVisibleBlock();
    QRectF r = blockBoundingRect(block).translated(offset);
    painter.translate(0, -(this->verticalScrollBar()->value() * r.height() - this->contentOffset().y()));

    
    

    {
      painter.setPen(Qt::darkRed);
      painter.setBrush(Qt::red);

     QTextBlock block = firstVisibleBlock();
     int blockNumber = block.blockNumber();
     int top = (int) blockBoundingGeometry(block).translated(contentOffset()).top();
     int bottom = top + (int) blockBoundingRect(block).height();

     while (block.isValid() ) {
       aBreakpoint *ud = (aBreakpoint*)block.userData();
       if (ud && ud->nBreakpointLine > 0 && block.isVisible() && bottom >= e->rect().top()) {
             painter.drawEllipse(2, r.height() * (blockNumber - 1) + 2 , 11, r.height() - 6);    
         }

         block = block.next();
         top = bottom;
         bottom = top + (int) blockBoundingRect(block).height();
         ++blockNumber;
     }
    }

    if (cw->nCurrentDebugPosition != 0){
      painter.setPen(Qt::darkRed);
      painter.setBrush(Qt::yellow);
      painter.drawEllipse(2, r.height() * (cw->nCurrentDebugPosition - 1) + 2 , 11, r.height() - 6);    
    }



    QTextCursor cc = textCursor();
    int nBlockNumber = cc.blockNumber();

    int u = r.height() / 2;
    painter.setPen(Qt::lightGray);
    for (int i = 0; i < cw->browser->count(); i++){
      QVariant v = cw->browser->itemData(i);
      qint64 n = v.toLongLong();
      int l = n / 1000000;
      int m = n % 1000000;
      

      if (l && n > 0 && m > 0){
        if (bUpdateForChangedText == false || m < nBlockNumber){ 
          int y = r.height() * (m) - u;
          painter.drawLine(0, y, viewportRect.width(), y);
          
        }

      }
    }    


   
}


void Code::move_codecompletion(QWidget *w)
{
  QPointF offset(contentOffset());
  QTextBlock block = firstVisibleBlock();
  QRectF r = blockBoundingRect(block).translated(offset);

  QTextCursor c = textCursor();
  int n = c.blockNumber() - block.blockNumber() + 1;

  int a = c.columnNumber();
  int b = QFontMetrics(currentCharFormat().font()).averageCharWidth();

  int x = a * b + offset.x() + document()->documentMargin();        
  int y = r.y() + r.height() * n;
  if (w == codecompletion2 || y + w->height() > viewport()->height()){
    y -= w->height() + r.height() + 1;
  }

  w->move(x, y);
}

void Code::focusInEvent(QFocusEvent* e)
{
  QPlainTextEdit::focusInEvent(e);
  cw->UndoRedoCut();
}

void Code::keyPressEvent(QKeyEvent* e)
{
  int n = e->key();

  if (n == Qt::Key_Return || n == Qt::Key_Enter){   
    QTextCursor f = textCursor();
    int nColumn = f.columnNumber();
    f.select(QTextCursor::LineUnderCursor);         

    QString r = f.selectedText();   
    if (!r.isEmpty() && nColumn == r.length()){
      QString k = cw->beautify(r);
      if (r != k){   
        f.beginEditBlock();
        f.insertText(k);
        setTextCursor(f);  
        f.endEditBlock();
      }
    }

  } else if (n == Qt::Key_Backtab){

    cw->PerformUnindent();
    return;
    
  } else if (n == Qt::Key_Tab){

    cw->PerformIndent();
    return;
  }

  bool bStart_codecompletion2 = false;
  QPlainTextEdit ::keyPressEvent(e);
  bool bAppend = false;

  if (!e->text().isNull()){
    QString s = e->text();
    if (false && s.compare(".") == 0){     

      

      move_codecompletion(codecompletion1);
       QStringList l;  

       cw->emit_GetCompletion("");
       
       l = cw->lCompletion1;

       if (l.count()){
         codecompletion1->ShowUp(l);
       }
      

    } else if (s.compare("(") == 0){

      QString s = "";
      sLineBeforeInput = cw->getCurrentCompletionTrigger();
      nStartTrigger = textCursor().columnNumber();

      sLineBeforeInput = sLineBeforeInput.left(sLineBeforeInput.length() - 1); 
      if (sLineBeforeInput.endsWith("$")){
        sLineBeforeInput = sLineBeforeInput.left(sLineBeforeInput.length() - 1); 
      }

      

      move_codecompletion(codecompletion2);

      cw->emit_GetCompletion2(sLineBeforeInput);

      s = cw->sCompletion2;

      if (!s.isEmpty())
      {
        codecompletion2->ShowUp(s);
        bStart_codecompletion2 = true;
      }

    } else if (codecompletion2->isVisible() && s.compare(")") == 0){

      
      QString s = cw->getCurrentLineAsString();
      int nStartTrigger2 = textCursor().columnNumber() - 1;

      s = s.mid(nStartTrigger, nStartTrigger2 - nStartTrigger);
      
      

      int nLeft = 0;
      int nRight = 0;
      int h = -1;

      do {
        h = s.indexOf("(", h + 1);
        if (h >= 0) nLeft++;
      } while (h >= 0);  
          
      h = -1;

      do {
        h = s.indexOf(")", h + 1);
        if (h >= 0) nRight++;
      } while (h >= 0);  
      

      if (nLeft == nRight && codecompletion2->isVisible()){
        cw->setFocus();
        codecompletion2->hide();
        sLineBeforeInput = "";
      }

    } else {
      QString s = cw->getCurrentLineAsString();
      int nIndex = cw->getCurrentColumn();
      s = s.left(nIndex);
      if (s.endsWith(" As ", Qt::CaseInsensitive) || (nIndex - 4 == 0 && s.endsWith("As ", Qt::CaseInsensitive))){                  
 
         move_codecompletion(codecompletion1);

       
         
         

         QStringList l; 
         l << Q7B_type_set.values();

         codecompletion1->ShowUp(l);
         
      }
      
    }
  }


  
  if (n == Qt::Key_Return || n == Qt::Key_Enter){   
    insertCorrectIdentForLine(bAppend);
  } else if (n == Qt::Key_Escape){   
    if (codecompletion2->isVisible()){
      setFocus();
      codecompletion2->hide();
    } else {



    }
  }

  if (codecompletion2->isVisible()){
    QString s = cw->getCurrentLineAsString();
    int nIndex = cw->getCurrentColumn();

    if (s.length() < sLineBeforeInput.length()){
      setFocus();
      codecompletion2->hide();
    } else {
      if (nIndex > 1) codecompletion2->setLabel(s, nIndex, false);
      cw->code->setCursorWidth(1); cw->code->setCursorWidth(2); 
    }
  }

  
  
}


void Code::insertCorrectIdentForLine(bool bAppend)
{  


  int x;
  QString d = cw->getBeforeCurrentLineAsString();  
  QString e = d.trimmed();

  for (x = 0; x < d.length(); x++){
    if (d.at(x) != ' ') break;
  }

  if (
    e.startsWith("IF ", Qt::CaseInsensitive) || e.startsWith("IF(", Qt::CaseInsensitive)
    || e.startsWith("SELECT ", Qt::CaseInsensitive) || e.startsWith("SELECT(", Qt::CaseInsensitive)
    || e.startsWith("WHILE ", Qt::CaseInsensitive) || e.startsWith("WHILE(", Qt::CaseInsensitive)
    || e.startsWith("DO ", Qt::CaseInsensitive) || e.startsWith("DO(", Qt::CaseInsensitive)
    || e.startsWith("FOR ", Qt::CaseInsensitive) || e.startsWith("FOR(", Qt::CaseInsensitive)
    || (e.startsWith("ELSE", Qt::CaseInsensitive) && e.length() == 4)
    || (e.startsWith("ELSEIF", Qt::CaseInsensitive) && e.length() == 6)
    || (e.startsWith("ELSE IF", Qt::CaseInsensitive) && e.length() == 7)

    

    
    
    || e.startsWith("EVENT ", Qt::CaseInsensitive)

    || e.startsWith("CASE ", Qt::CaseInsensitive)
    || e.startsWith("CASE(", Qt::CaseInsensitive)
    
    || e.startsWith("PUBLIC SUB ", Qt::CaseInsensitive)
    
    || e.startsWith("PRIVATE SUB ", Qt::CaseInsensitive)
    || e.startsWith("GLOBAL SUB ", Qt::CaseInsensitive)
    || e.startsWith("PROPERTY SUB ", Qt::CaseInsensitive)
    || e.startsWith("PUBLIC PROPERTY SUB ", Qt::CaseInsensitive)
    || e.startsWith("PRIVATE PROPERTY SUB ", Qt::CaseInsensitive)
    
    
    
    
    
    
    || e.startsWith("SUB ", Qt::CaseInsensitive)
    
    || e.startsWith("PUBLIC FUNCTION ", Qt::CaseInsensitive)
    
    || e.startsWith("PRIVATE FUNCTION ", Qt::CaseInsensitive)
    || e.startsWith("GLOBAL FUNCTION ", Qt::CaseInsensitive)
    || e.startsWith("PROPERTY FUNCTION ", Qt::CaseInsensitive)
    || e.startsWith("PUBLIC PROPERTY FUNCTION ", Qt::CaseInsensitive)
    || e.startsWith("PRIVATE PROPERTY FUNCTION ", Qt::CaseInsensitive)
    
    
    
    
    
    
    || e.startsWith("FUNCTION ", Qt::CaseInsensitive)
    
    
    
    || e.startsWith("SIGNAL ", Qt::CaseInsensitive)
    
    
    
    || e.startsWith("SLOT ", Qt::CaseInsensitive)
    || e.startsWith("PUBLIC ENUM ", Qt::CaseInsensitive)
    || e.startsWith("PRIVATE ENUM ", Qt::CaseInsensitive)
    || e.startsWith("ENUM ", Qt::CaseInsensitive)
    || e.startsWith("PUBLIC TYPE ", Qt::CaseInsensitive)
    || e.startsWith("PRIVATE TYPE ", Qt::CaseInsensitive)
    || e.startsWith("TYPE ", Qt::CaseInsensitive)
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    || e.startsWith("WHILE ", Qt::CaseInsensitive)
    
    
    
    
    
    
    
    
    

  ){
    d = d.left(x);

    if (e.startsWith("IF ", Qt::CaseInsensitive) || e.startsWith("IF(", Qt::CaseInsensitive)){
      int m = e.indexOf("THEN", 0, Qt::CaseInsensitive);
      static QString u; u = e.mid(m + 4);
      u = u.trimmed();
      if (u.length() == 0){
        d += "  ";
        if (bAppend){
          d += "\n";
          d += d.left(d.length() - 3);
          d += "End If";
        }
      }
      
    } else if (e.startsWith("SELECT ", Qt::CaseInsensitive) || e.startsWith("SELECT(", Qt::CaseInsensitive)){
      d += "  ";
      if (bAppend){
        d += "\n";
        d += d.left(d.length() - 3);
        d += "End Select";
      }
    } else if (e.startsWith("CASE ", Qt::CaseInsensitive) || e.startsWith("CASE(", Qt::CaseInsensitive)){
      d += "  ";
      if (bAppend){
        d += "\n";
        d += d.left(d.length() - 3);
      }    
    } else if (e.startsWith("FOR ", Qt::CaseInsensitive) || e.startsWith("FOR(", Qt::CaseInsensitive)){
      d += "  ";
      if (bAppend){
        d += "\n";
        d += d.left(d.length() - 3);
        d += "Next";
      }    
    } else if (
      
     
      e.startsWith("PUBLIC SUB ", Qt::CaseInsensitive)
      
      || e.startsWith("PRIVATE SUB ", Qt::CaseInsensitive)
      || e.startsWith("GLOBAL SUB ", Qt::CaseInsensitive)
      
      
      
      
      
      
      || e.startsWith("SUB ", Qt::CaseInsensitive)

      ){
      d += "  ";
      if (bAppend){
        d += "\n";
        d += d.left(d.length() - 3);
        d += "End Sub";
      }    
    } else if (
   
   
       e.startsWith("EVENT ", Qt::CaseInsensitive)

      ){
      d += "  ";
      if (bAppend){
        d += "\n";
        d += d.left(d.length() - 3);
        d += "End Event";
      }   
    } else if (
      
      
      e.startsWith("PUBLIC FUNCTION ", Qt::CaseInsensitive)
      
      || e.startsWith("PRIVATE FUNCTION ", Qt::CaseInsensitive)
      || e.startsWith("GLOBAL FUNCTION ", Qt::CaseInsensitive)
      
      
      
      
      
      
      || e.startsWith("FUNCTION ", Qt::CaseInsensitive)
      ){
      d += "  ";
      if (bAppend){
        d += "\n";
        d += d.left(d.length() - 3);
        d += "End Function";
      }   
      
    } else {
      d += "  ";
    }

  } else {
    d = d.left(x);
  }
  
  QTextCursor f = textCursor();

  f.clearSelection();
  f.insertText(d);
  if (d.trimmed().length()){
    f.movePosition(QTextCursor::Up);
  }
  setTextCursor(f);  
}


Q7BCodeWindow::Q7BCodeWindow(QWidget *parent) : QFrame(parent)
{
  setAttribute(Qt::WA_DeleteOnClose);
  


  commands = 0;

 
  info = 0;

  
  browser = new QComboBox(this); 
  connect(browser, SIGNAL(activated(int)), this, SLOT(browser_activated(int)));
  browser->setMaxVisibleItems(12);

  cbSub = new QToolButton(this); cbSub->setText("Sub"); cbSub->setMinimumWidth(80);
  cbSub->setPopupMode(QToolButton::InstantPopup);
  cbFunction = new QToolButton(this); cbFunction->setText("Function"); cbFunction->setMinimumWidth(80);
  cbFunction->setPopupMode(QToolButton::InstantPopup);
  cbOutlet = new QToolButton(this); cbOutlet->setText("Outlet"); cbOutlet->setMinimumWidth(80);
  cbOutlet->setPopupMode(QToolButton::InstantPopup);
  cbDim = new QToolButton(this); cbDim->setText("Dim"); cbDim->setMinimumWidth(80);
  cbDim->setPopupMode(QToolButton::InstantPopup);
  cbConst = new QToolButton(this); cbConst->setText("Const"); cbConst->setMinimumWidth(80);
  cbConst->setPopupMode(QToolButton::InstantPopup);
  cbEvent = new QToolButton(this); cbEvent->setText("Event"); cbEvent->setMinimumWidth(80);
  cbEvent->setPopupMode(QToolButton::InstantPopup);
  cbSignal = new QToolButton(this); cbSignal->setText("Signal"); cbSignal->setMinimumWidth(80);
  cbSignal->setPopupMode(QToolButton::InstantPopup);
  cbSlot = new QToolButton(this); cbSlot->setText("Slot"); cbSlot->setMinimumWidth(80);
  cbSlot->setPopupMode(QToolButton::InstantPopup);
  cbSlot->setHidden(true);
  cbEnum = new QToolButton(this); cbEnum->setText("Enum"); cbEnum->setMinimumWidth(80);
  cbEnum->setPopupMode(QToolButton::InstantPopup);
  cbType = new QToolButton(this); cbType->setText("Type"); cbType->setMinimumWidth(80);
  cbType->setPopupMode(QToolButton::InstantPopup);

  mSub = new QMenu(this); connect(mSub, SIGNAL(triggered(QAction *)), this, SLOT(triggered(QAction *)));
  mFunction = new QMenu(this); connect(mFunction, SIGNAL(triggered(QAction *)), this, SLOT(triggered(QAction *)));
  mOutlet = new QMenu(this); connect(mOutlet, SIGNAL(triggered(QAction *)), this, SLOT(triggered(QAction *)));
  mDim = new QMenu(this); connect(mDim, SIGNAL(triggered(QAction *)), this, SLOT(triggered(QAction *)));
  mConst = new QMenu(this); connect(mConst, SIGNAL(triggered(QAction *)), this, SLOT(triggered(QAction *)));
  mEvent = new QMenu(this); connect(mEvent, SIGNAL(triggered(QAction *)), this, SLOT(triggered(QAction *)));
  mSignal = new QMenu(this); connect(mSignal, SIGNAL(triggered(QAction *)), this, SLOT(triggered(QAction *)));
  mSlot = new QMenu(this);   connect(mSlot, SIGNAL(triggered(QAction *)), this, SLOT(triggered(QAction *)));
  mEnum = new QMenu(this);   connect(mEnum, SIGNAL(triggered(QAction *)), this, SLOT(triggered(QAction *)));
  mType = new QMenu(this);   connect(mType, SIGNAL(triggered(QAction *)), this, SLOT(triggered(QAction *)));

  

  code = new Code(this);
  code->setTabChangesFocus(false);
  code->setLineWrapMode(QPlainTextEdit::NoWrap);
  QFont f(DefaultFontName(), DefaultFontSize());
  code->document()->setDefaultFont(f);




  setFocusProxy(code);

  browser->setFocusProxy(code);
  

 



  QBoxLayout *l = new QBoxLayout(QBoxLayout::TopToBottom);
  
  l->addSpacing(2);
  QBoxLayout *j = new QBoxLayout(QBoxLayout::LeftToRight);

  j->addWidget(browser);

  j->addWidget(cbSub);
  j->addWidget(cbFunction);
  j->addWidget(cbDim);
  j->addWidget(cbConst);
  j->addWidget(cbType);
  j->addWidget(cbEnum);
  j->addWidget(cbEvent);
  j->addWidget(cbOutlet);
  j->addWidget(cbSignal);
  j->addWidget(cbSlot);
  
  
  

  

  j->setMargin(2);
  j->setSpacing(2);

  l->addLayout(j);
  l->addSpacing(2);


  l->addWidget(code);

  l->setMargin(0);
  l->setSpacing(0);
  setLayout(l);

  setFrameShape(QFrame::StyledPanel);

  codesyntaxhighlighter = new CodeSyntaxHighlighter(code->document());
  
  bUndoAvailable = false;
  bRedoAvailable = false;
  bCopyAvailable = false;

  connect(code, SIGNAL(copyAvailable(bool)), this, SLOT(code_copyAvailable(bool)));
  connect(code, SIGNAL(redoAvailable(bool)), this, SLOT(code_redoAvailable(bool)));
  connect(code, SIGNAL(undoAvailable(bool)), this, SLOT(code_undoAvailable(bool)));




 timerbrowser = new QTimer(this);
 connect(timerbrowser, SIGNAL(timeout()), this, SLOT(timerbrowser_timeout()));

 connect(this, SIGNAL(cursorPositionChanged()), this, SLOT(highlightCurrentLine()));

  highlightCurrentLine();


  nCurrentDebugPosition = 0;

  

 

  

  

}

 void Q7BCodeWindow::highlightCurrentLine()
 {
     code_pasteAvailable();

     QList<QTextEdit::ExtraSelection> extraSelections;

     if (!code->isReadOnly()) {
         QTextEdit::ExtraSelection selection;

         QColor lineColor = QColor(Qt::yellow).lighter(160);

         selection.format.setBackground(lineColor);
         selection.format.setProperty(QTextFormat::FullWidthSelection, true);
         selection.cursor = code->textCursor();
         selection.cursor.clearSelection();
         extraSelections.append(selection);
     }

     code->setExtraSelections(extraSelections);
 }







void Q7BCodeWindow::setCPPKeywords(QStringList l)
{
  static bool b = true;
  if (b == false) return;

  b = false;
}

void Q7BCodeWindow::setConsts(QStringList l)
{
  static bool b = true;
  if (b == false) return;

  b = false;
}

void Q7BCodeWindow::setFunctions(QStringList l)
{
  static bool b = true;
  if (b == false) return;

  b = false;
}

void Q7BCodeWindow::setKeywords(QStringList l)
{
  static bool b = true;
  if (b == false) return;

  if (Q7B_keyword_set.count() == 0){
    Q7B_keyword_set = QSet<QString>::fromList(l);
  } else {
    Q7B_keyword_set.unite(QSet<QString>::fromList(l));
  }
  for (int i = 0; i < l.size(); ++i) {
     Q7B_keyword[l.at(i).toLower()] = l.at(i);
  }
  b = false;
}

void Q7BCodeWindow::setClasses(QStringList l)
{
  static bool b = true;
  if (b == false) return;

  if (Q7B_type_set.count() == 0){
    Q7B_type_set = QSet<QString>::fromList(l);
  } else {
    Q7B_type_set.unite(QSet<QString>::fromList(l));
  }
  for (int i = 0; i < l.size(); ++i) {
     Q7B_type[l.at(i).toLower()] = l.at(i);
  }
  b = false;
}

void Q7BCodeWindow::setObjects(QStringList l)
{
  static bool b = true;
  if (b == false) return;

  if (Q7B_type_set.count() == 0){
    Q7B_type_set = QSet<QString>::fromList(l);
  } else {
    Q7B_type_set.unite(QSet<QString>::fromList(l));
  }
  for (int i = 0; i < l.size(); ++i) {
     Q7B_type[l.at(i).toLower()] = l.at(i);
  }
  b = false;
}

void Q7BCodeWindow::setTypes(QStringList l)
{
  static bool b = true;
  if (b == false) return;

  if (Q7B_type_set.count() == 0){
    Q7B_type_set = QSet<QString>::fromList(l);
  } else {
    Q7B_type_set.unite(QSet<QString>::fromList(l));
  }
  for (int i = 0; i < l.size(); ++i) {
     Q7B_type[l.at(i).toLower()] = l.at(i);
  }
  b = false;
}

QString Q7BCodeWindow::beautify(QString k)
{  
  QString s = k;
  QString sRem;
  int n = s.indexOf('\'');
  if (n >= 0){
    sRem = s.mid(n);
    s = s.left(n);
  }
  if (s.simplified().isEmpty()){
    return k;
  }
  bool bDeclare = s.simplified().startsWith("Declare ", Qt::CaseInsensitive);

  if (bDeclare) return k; 

  int nLen = s.length();
  

     int index = 0;
     int index2 = 0;
     int nString = 0;
     bool b = false;
     bool bString = false;
n:
     while (index < s.length()){
       int i;
       for (i = index; i < s.length(); i++){
         QChar c = s.at(i);

         bool bString2 = bString;

         if (c == '\"'){
           if (bString){
           } else {
             nString = i;
           }
           bString = !bString;
         }
         if (!bString2 && c == '\''){
           QString r = s.mid(index, i - index);

          if (Q7B_type.contains(r)){
            s = s.replace(index, i - index, Q7B_type[r]);
            s = s.mid(index, i - index).toUpper();
          }

          if (Q7B_keyword.contains(r)){
            s = s.replace(index, i - index, Q7B_keyword[r]);
            s = s.mid(index, i - index).toUpper();
          }

           goto r;
         }


         if (!bString2 && ((c == '(' || c == '.' || c == ')') || i + 2 == s.length())){
           int nStart = i + 1;
           int n = 0;
           
           while(--i >= 0 && s.at(i).isSpace()){
             n++;
           }
           i++;
           if (n > 0){
             
               s = s.left(nStart - n - 1) + " " + s.mid(nStart - 1);
               i = nStart - n;
             
             nStart = i + 1;             
           }      
           
          

           n = 0;
           while(++i < s.length() && s.at(i).isSpace()){
             n++;
           }
           
           i--;
           if (n > 0){
             s = s.left(nStart) + s.mid(nStart + n );
             i -= 4;
             if (i < 0) i = 0;
           }
           if (i < s.length() && i >= 0){
             c = s.at(i);
           }
           
       
        
         }
         if (!bString2 && (c == ',' || c == '+' || c == '-' || c == '/' || c == '*' || c == ':' || c == '<' || c == '>' || c == '=' || c == '&')){
           if (i + 1 < s.length() && s.at(i + 1).isSpace() == false){
             if (((c == '<' || c == '>') && s.at(i + 1) == '=')){
             } else if ((c == ':' && s.at(i + 1) == '=')){
             } else {
               s.insert(i + 1, ' ');
               if (c != ',' && s.at(i - 1).isSpace() == false){
                 if (c == '=' && (s.at(i - 1) == '<' || s.at(i - 1) == '>' || s.at(i - 1) == ':')){
                   s.insert(i - 1, ' ');
                   i++;
                 } else if (c == ':' && s.at(i - 1) == '='){
                   s.insert(i - 2, ' ');
                   i++;
                 } else {
                   s.insert(i, ' ');
                   i++;
                 }
               }
               i++;             
             }
             c = s.at(i);
           }

         }

         if ((!bString2 && (((!c.isLetter() && i == index && c != '_')) || c.isSpace() || c.isMark() || c == '(' || c == ')' || c == ',' || c == '.'))) break;

       }

       QString key = s.mid(index, i - index);
       if (!bDeclare && Q7B_type.contains(s.mid(index, i - index))){
         s = s.replace(index, i - index, Q7B_type[s.mid(index, i - index)]);
         index2 = index + (i - index);
       }
       if (!bDeclare && Q7B_keyword.contains(s.mid(index, i - index))){
         s = s.replace(index, i - index, Q7B_keyword[s.mid(index, i - index)]);
         index2 = index + (i - index);
       }
       index = i + 1;
       
     }

     index = index2;


     if (b == false && index == -1 && index2 && index2 + 1 < nLen){
       b = true;
       index = index2;
       goto n;
     }

  
r:     
  s = s.replace("< string>", "<string>", Qt::CaseSensitive);
  s = s.replace("< string >", "<string>", Qt::CaseSensitive);
  s = s.replace("< / string >", "</string>", Qt::CaseSensitive);  
  s = s.replace(")Then", ") Then", Qt::CaseSensitive);
  s = s.replace(")-", ") -", Qt::CaseInsensitive);
  s = s.replace(")+", ") +", Qt::CaseInsensitive);
  s = s.replace(")/", ") +", Qt::CaseInsensitive);
  s = s.replace(")\\", ") \\", Qt::CaseInsensitive);
  s = s.replace(")*", ") *", Qt::CaseInsensitive);
  s = s.replace(")&", ") &", Qt::CaseInsensitive);
  s = s.replace("EndIf", "End If", Qt::CaseInsensitive);
  s = s.replace("ElseIf", "Else If", Qt::CaseInsensitive);
  s = s.replace("< >", "<>", Qt::CaseSensitive);

  return s + (sRem.isEmpty() ? "" : " " + sRem);
}

void Q7BCodeWindow::commands_activated( const QString &s)
{
  if (s == "PerformComment"){ PerformComment(); return; }
  if (s == "PerformUncomment"){ PerformUncomment(); return; }
  if (s == "PerformIndent"){ PerformIndent(); return; }
  if (s == "PerformUnindent"){ PerformUnindent(); return; }
  if (s == "PerformUpper"){ PerformUpper(); return; }
  if (s == "PerformLower"){ PerformLower(); return; }
  if (s == "PerformInsertFile"){ PerformInsertFile(); return; }
  if (s == "PerformGotoLine"){ PerformGotoLine(); return; }

}


void Q7BCodeWindow::code_textChanged()
{
  timerbrowser->stop();
  timerbrowser->start(50);  
  emit textChanged();
}

void Q7BCodeWindow::timerbrowser_timeout()
{
  timerbrowser->stop();
  RefreshBrowser();
  
}

void Q7BCodeWindow::code_cursorPositionChanged(void)
{
  emit cursorPositionChanged();

  
  
 



  QString sAllText = code->toPlainText();
  QTextCursor c = code->textCursor();
  int nPosition = c.position();
  int n = sAllText.indexOf("\nEnd ", nPosition);
  QString qwert = sAllText.mid(n);
  if (n == -1){ browser->setCurrentIndex(0); return; }
  n += 5;

  int n2 = sAllText.indexOf("\n", n);
  if (n2 == -1) n2 = sAllText.length();
  int n3 = sAllText.indexOf("'", n);
  if (n3 != -1 && n3 < n2) n2 = n3;
  int n4 = sAllText.indexOf(" ", n);
  if (n4 != -1 && n4 < n2) n2 = n4;

  QString sSearch = sAllText.mid(n, n2 - n);


  

  int k = sAllText.lastIndexOf(QString("\n") + sSearch + " ", n);
  
  {
    int k2 = sAllText.lastIndexOf(QString("\nPublic ") + sSearch + " ", n);
    int k3 = sAllText.lastIndexOf(QString("\nPrivate ") + sSearch + " ", n);
    int k4 = sAllText.lastIndexOf(QString("\nGlobal ") + sSearch + " ", n);
    int k5 = sAllText.lastIndexOf(QString("\nProperty ") + sSearch + " ", n);

    if (k2 > k3 && k2 > k){
      k = k2 + 7; 
    } else if (k3 >= 0 && k3 > k){
      k = k3 + 8;
    } else if (k == -1){
      k = -1;
    }

    if (k4 > k){
      k = k4 + 7; 
    }

    if (k5 > k){
      k = k5 + 9; 
    }
  }

  if (k == -1 || k > nPosition){ browser->setCurrentIndex(0); return; }
  
  int kk = sAllText.indexOf("\n", k + 1);
  if (kk == -1){ browser->setCurrentIndex(0); return; }
  k += 2 + sSearch.length();
  QString mm = sAllText.mid(k, kk - k);
  int j = browser->findText(mm);
  if (j >= 0){
    browser->setCurrentIndex(j);
  } else {
    browser->setCurrentIndex(0);
  }
 
 


  
  

  
}

void Q7BCodeWindow::code_contentsChange(int nPosition, int charsRemoved, int charsAdded)
{
  
}


void Q7BCodeWindow::browserGoto(QVariant vv)
{
  QVariant v = vv;
  qint64 n = v.toLongLong();
  int l = n / 1000000;
 


  if (l && n > 0){
    GotoLineAndSelectLine(l);
    setFocus();
  }
}

void Q7BCodeWindow::triggered(QAction *action)
{
  browserGoto(action->data());
}

void Q7BCodeWindow::browser_activated(int index)
{
  browserGoto(browser->itemData(index));
}

void Q7BCodeWindow::GotoLineAndSelectLine(int nLine)
{  
  QTextCursor c = code->textCursor();
  c.movePosition(QTextCursor::Start, QTextCursor::MoveAnchor);
  c.movePosition(QTextCursor::Down, QTextCursor::MoveAnchor, nLine - 5);
  c.movePosition(QTextCursor::Right, QTextCursor::MoveAnchor, 1);  
  code->setTextCursor(c);

  c.movePosition(QTextCursor::Start, QTextCursor::MoveAnchor);
  c.movePosition(QTextCursor::Down, QTextCursor::MoveAnchor, nLine + 5);
  c.movePosition(QTextCursor::Right, QTextCursor::MoveAnchor, 1);  
  code->setTextCursor(c);

  c.movePosition(QTextCursor::Start, QTextCursor::MoveAnchor);
  c.movePosition(QTextCursor::Down, QTextCursor::MoveAnchor, nLine - 1);
  c.movePosition(QTextCursor::EndOfLine, QTextCursor::MoveAnchor);
  c.movePosition(QTextCursor::StartOfLine, QTextCursor::KeepAnchor);
  code->setTextCursor(c);  
}

void Q7BCodeWindow::GotoLine(int nLine, bool bTryToSaveCursorColumn)
{  
  QTextCursor c = code->textCursor();
  int n = -1;
  if (bTryToSaveCursorColumn){
    n = c.columnNumber();
  }
  c.movePosition(QTextCursor::Start, QTextCursor::MoveAnchor);
  c.movePosition(QTextCursor::Down, QTextCursor::MoveAnchor, nLine - 5);
 
  code->setTextCursor(c);

  c.movePosition(QTextCursor::Start, QTextCursor::MoveAnchor);
  c.movePosition(QTextCursor::Down, QTextCursor::MoveAnchor, nLine + 5);

  code->setTextCursor(c);

  c.movePosition(QTextCursor::Start, QTextCursor::MoveAnchor);
  c.movePosition(QTextCursor::Down, QTextCursor::MoveAnchor, nLine - 1);
  c.movePosition(QTextCursor::StartOfLine, QTextCursor::MoveAnchor);
  if (bTryToSaveCursorColumn){
    c.movePosition(QTextCursor::Right, QTextCursor::MoveAnchor, n);
  } else 
 
  code->setTextCursor(c);  
}

void Q7BCodeWindow::RefreshControls()
{
  
  
 
  
 
}


void Q7BCodeWindow::emit_GetCompletion(QString s)
{
  emit GetCompletion(s);
}

void Q7BCodeWindow::emit_GetCompletion2(QString s)
{
  emit GetCompletion2(s);
}

void Q7BCodeWindow::RefreshEvents()
{
  

  
  
}

void Q7BCodeWindow::RefreshBrowser()
{






    
    
    static QStringList l;
    
    if (l.count() == 0){
      
      l << "\nPublic Sub" << "\nPrivate Sub" << "\nGlobal Sub" << "\nPublic Property Sub" << "\nPrivate Property Sub" << "\nProperty Sub" << "\nSub" << "@";
      l << "\nPublic Function" << "\nPrivate Function" << "\nGlobal Function" << "\nPublic Property Function" << "\nPrivate Property Function" << "\nProperty Function" << "\nFunction" << "@";
      l << "\nPublic Outlet" << "\nPrivate Outlet" << "\nOutlet" << "@";
      l << "\nPublic Dim" << "\nPrivate Dim" << "\nGlobal Dim" << "\nDim" << "@";
      l << "\nPublic Const" << "\nPrivate Const" << "\nGlobal Const" << "\nConst" << "@";
      l << "\nEvent" << "@";
      l << "\nSignal" << "@";
      l << "\nSlot" << "@";
      l << "\nEnum" << "@";
      l << "\nType" << "@";

      
    }


    cbSub->setMenu(0); mSub->clear();
    cbFunction->setMenu(0); mFunction->clear();
    cbOutlet->setMenu(0); mOutlet->clear();
    cbDim->setMenu(0); mDim->clear();
    cbConst->setMenu(0); mConst->clear();
    cbEvent->setMenu(0); mEvent->clear();
    cbSignal->setMenu(0); mSignal->clear();
    cbSlot->setMenu(0); mSlot->clear();

    

    while (!actions.isEmpty()){
     delete actions.takeFirst();
    }

    QMap<QString, QVariant> data;

    QString sAllText = "\n" + code->toPlainText();

    QIcon *icon;
    QIcon iSub = QIcon(":/Resources/Sub.png");
    QIcon iFunction = QIcon(":/Resources/Function.png");
    QIcon iDim = QIcon(":/Resources/Dim.png");
    QIcon iConst = QIcon(":/Resources/Const.png");
    QIcon iEvent = QIcon(":/Resources/Event.png");
    QIcon iOutlet = QIcon(":/Resources/Outlet.png");
    QIcon iSignal = QIcon(":/Resources/Signal.png");
    QIcon iSlot = QIcon(":/Resources/Slot.png");
    QIcon iEnum = QIcon(":/Resources/Enum.png");
    QIcon iType = QIcon(":/Resources/Type.png");

    browser->clear();

    QMap<QString, QAction*> mapSub;
    QMap<QString, QAction*> mapFunction;
    QMap<QString, QAction*> mapDim;
    QMap<QString, QAction*> mapConst;
    QMap<QString, QAction*> mapEvent;
    QMap<QString, QAction*> mapOutlet;
    QMap<QString, QAction*> mapSignal;
    QMap<QString, QAction*> mapSlot;
    QMap<QString, QAction*> mapEnum;
    QMap<QString, QAction*> mapType;

    int nCount = 0;
    foreach(QString s, l){
      

      if (qApp->closingDown()) return;
      
      

    
    

      int nn = 0;
      QTextCursor c;
      
      QTextDocument *d = code->document();

      QToolButton *cb = 0;
      if (s == "@"){
        nCount = 0;
        continue;
      }
      
      do {
        
        if (qApp->closingDown()) return;
        
        

        QString www = s;
        QString hhhhhh = sAllText.mid(nn);
        nn = sAllText.indexOf(s, nn);
        if (nn == -1) break;
       
       
       
        
        int nn2 = sAllText.indexOf("\n", nn + 1);

        if (nn2 == -1){
          nn2 = sAllText.length();
        } else {
       
       
        }
 
       
       
        QString s = sAllText.mid(nn, nn2 - nn);
        QString k = "";
        c = code->textCursor();
        c.setPosition(nn2);
        nn = nn2;
 

        int n;
        QMenu *m;
        if ((n = s.indexOf("Sub ", 0, Qt::CaseInsensitive)) >= 0){ n += 4; icon = &iSub; m = mSub; }
        else if ((n = s.indexOf("Function ", 0, Qt::CaseInsensitive)) >= 0){ n += 9; icon = &iFunction; m = mFunction; }
        else if ((n = s.indexOf("Outlet ", 0, Qt::CaseInsensitive)) >= 0){ n += 7; icon = &iOutlet; m = mOutlet; }
        else if ((n = s.indexOf("Dim ", 0, Qt::CaseInsensitive)) >= 0){ n += 4; icon = &iDim; m = mDim; }
        else if ((n = s.indexOf("Const ", 0, Qt::CaseInsensitive)) >= 0){ 
          n += 6; icon = &iConst; m = mConst; 
        }
        else if ((n = s.indexOf("Event ", 0, Qt::CaseInsensitive)) >= 0){ n += 6; icon = &iEvent; m = mEvent; }
        else if ((n = s.indexOf("Signal ", 0, Qt::CaseInsensitive)) >= 0){ n += 7; icon = &iSignal; m = mSignal; }
        else if ((n = s.indexOf("Slot ", 0, Qt::CaseInsensitive)) >= 0){ n += 5; icon = &iSlot; m = mSlot; }
        else if ((n = s.indexOf("Enum ", 0, Qt::CaseInsensitive)) >= 0){ n += 5; icon = &iEnum; m = mEnum; }
        else if ((n = s.indexOf("Type ", 0, Qt::CaseInsensitive)) >= 0){ n += 5; icon = &iType; m = mType; }
        else break;

        nCount++;
        
        
        
        
        




       
        
        int nLineMark = c.blockNumber() - 1;
        QTextDocument *d = code->document();
        bool bLineMarkNeeded = false;
        for (int i = nLineMark; i >= 0; i--){
          QString s = d->findBlockByNumber(i).text();   
          if (s.simplified().isEmpty()){
            nLineMark = i + 1;
            bLineMarkNeeded = true;
            break;
          }
        }

        if (!bLineMarkNeeded){
          nLineMark = 0;
        }

          

          qint64 ll = ((c.blockNumber() + 0) * 1000000) + ((nLineMark) * 1); 
          
          

          QVariant v(ll);
  

          QString mm = s.mid(n);
          
            data[mm] = v;

            
            QAction *a = new QAction(*icon, mm, 0);
            a->setData(v);
            
            if (m == mSub){ mapSub[mm] = a; } 
            else if (m == mFunction){ mapFunction[mm] = a; } 
            else if (m == mDim){ mapDim[mm] = a; } 
            else if (m == mConst){ mapConst[mm] = a; } 
            else if (m == mEvent){ mapEvent[mm] = a; } 
            else if (m == mOutlet){ mapOutlet[mm] = a; } 
            else if (m == mSignal){ mapSignal[mm] = a; } 
            else if (m == mSlot){ mapSlot[mm] = a; } 
            else if (m == mEnum){ mapEnum[mm] = a; } 
            else if (m == mType){ mapType[mm] = a; } 
            
            
             
            
            actions.append(a);
            browser->addItem(*icon, mm, v); 

        
       
        

      } while (true);

       {
         QString o;
         QMapIterator<QString, QAction *> i(mapSub);
         while (i.hasNext()) {
             i.next();
             if (!o.isEmpty() && o != i.key().left(1)){
               mSub->addSeparator();
             }
             mSub->addAction(i.value()); 
             o = i.key().left(1);
         }
       }

       {
         QString o;
         QMapIterator<QString, QAction *> i(mapFunction);
         while (i.hasNext()) {
             i.next();
             if (!o.isEmpty() && o != i.key().left(1)){
               mFunction->addSeparator();
             }
             mFunction->addAction(i.value()); 
             o = i.key().left(1);
         }
       }

       {
         QString o;
         QMapIterator<QString, QAction *> i(mapDim);
         while (i.hasNext()) {
             i.next();
             if (!o.isEmpty() && o != i.key().left(1)){
               mDim->addSeparator();
             }
             mDim->addAction(i.value()); 
             o = i.key().left(1);
         }
       }

       {
         QString o;
         QMapIterator<QString, QAction *> i(mapConst);
         while (i.hasNext()) {
             i.next();
             if (!o.isEmpty() && o != i.key().left(1)){
               mConst->addSeparator();
             }
             mConst->addAction(i.value()); 
             o = i.key().left(1);
         }
       }

       {
         QString o;
         QMapIterator<QString, QAction *> i(mapEvent);
         while (i.hasNext()) {
             i.next();
             if (!o.isEmpty() && o != i.key().left(1)){
               mEvent->addSeparator();
             }
             mEvent->addAction(i.value()); 
             o = i.key().left(1);
         }
       }

       bool bMainWindow = sFilename.endsWith("MainWindow.QMainWindow");

       {
         QString o;
         QMapIterator<QString, QAction *> i(mapOutlet);
         while (i.hasNext()) {
             i.next();
             if (!o.isEmpty() && o != i.key().left(bMainWindow ? 7 : 1)){
               mOutlet->addSeparator();
             }
             mOutlet->addAction(i.value()); 
             o = i.key().left(bMainWindow ? 7 : 1);
         }
       }

       {
         QString o;
         QMapIterator<QString, QAction *> i(mapSignal);
         while (i.hasNext()) {
             i.next();
             if (!o.isEmpty() && o != i.key().left(bMainWindow ? 10 : 4)){
               mSignal->addSeparator();
             }
             mSignal->addAction(i.value()); 
             o = i.key().left(bMainWindow ? 10 : 4);
         }
       }

       {
         QString o;
         QMapIterator<QString, QAction *> i(mapSlot);
         while (i.hasNext()) {
             i.next();
             if (!o.isEmpty() && o != i.key().left(1)){
               mSlot->addSeparator();
             }
             mSlot->addAction(i.value()); 
             o = i.key().left(1);
         }
       }

       {
         QString o;
         QMapIterator<QString, QAction *> i(mapEnum);
         while (i.hasNext()) {
             i.next();
             if (!o.isEmpty() && o != i.key().left(1)){
               mEnum->addSeparator();
             }
             mEnum->addAction(i.value()); 
             o = i.key().left(1);
         }
       }

       {
         QString o;
         QMapIterator<QString, QAction *> i(mapType);
         while (i.hasNext()) {
             i.next();
             if (!o.isEmpty() && o != i.key().left(1)){
               mType->addSeparator();
             }
             mType->addAction(i.value()); 
             o = i.key().left(1);
         }
       }

      if (s == "\nSub"){ cbSub->setText(QString("Sub %1").arg(nCount)); if (nCount > 0) cbSub->setMenu(mSub); }
      else if (s == "\nFunction"){ cbFunction->setText(QString("Function %1").arg(nCount)); if (nCount > 0) cbFunction->setMenu(mFunction); }
      else if (s == "\nOutlet"){ cbOutlet->setText(QString("Outlet %1").arg(nCount)); if (nCount > 0) cbOutlet->setMenu(mOutlet); }
      else if (s == "\nDim"){ cbDim->setText(QString("Dim %1").arg(nCount)); if (nCount > 0) cbDim->setMenu(mDim); }
      else if (s == "\nConst"){ cbConst->setText(QString("Const %1").arg(nCount)); if (nCount > 0) cbConst->setMenu(mConst); }
      else if (s == "\nEvent"){ cbEvent->setText(QString("Event %1").arg(nCount)); if (nCount > 0) cbEvent->setMenu(mEvent); }
      else if (s == "\nSignal"){ cbSignal->setText(QString("Signal %1").arg(nCount)); if (nCount > 0) cbSignal->setMenu(mSignal); }
      else if (s == "\nSlot"){  cbSlot->setText(QString("Slot %1").arg(nCount)); if (nCount > 0) cbSlot->setMenu(mSlot); }
      else if (s == "\nEnum"){  cbEnum->setText(QString("Enum %1").arg(nCount)); if (nCount > 0) cbEnum->setMenu(mEnum); }
      else if (s == "\nType"){  cbType->setText(QString("Type %1").arg(nCount)); if (nCount > 0) cbType->setMenu(mType); }

     
    }

    

     browser->model()->sort(0);
    browser->insertItem(0, QString("All %1").arg(data.count()), QVariant(-1)); 
    browser->insertSeparator(1);

     code->bUpdateForChangedText = false;

     
     {
     
       code_cursorPositionChanged(); 
       code->viewport()->update();
     }
}

void Q7BCodeWindow::PerformUndo()
{
  code->undo();
}

void Q7BCodeWindow::PerformRedo()
{
  code->redo();
}

void Q7BCodeWindow::PerformCut()
{
  code->cut();
}

void Q7BCodeWindow::PerformCopy()
{
  code->copy();
}

void Q7BCodeWindow::PerformPaste()
{
  code->paste();
}

void Q7BCodeWindow::PerformDelete()
{
  QTextCursor c = code->textCursor();

  if (c.hasSelection()){

    c.beginEditBlock();

    c.insertText("");

    c.endEditBlock();

    code->setTextCursor(c);
    code->document()->setModified(true); 

  } 
}

void Q7BCodeWindow::PerformSelectAll()
{
  code->selectAll();
}

void Q7BCodeWindow::PerformComment()
{


  QTextCursor c = code->textCursor();

  if (c.hasSelection()){

    c.beginEditBlock();

    int a = c.selectionStart();
    int b = c.selectionEnd();

    int cpos = c.position();
    bool bAtStart = false;

    if (cpos == a){
      c.movePosition(QTextCursor::StartOfLine, QTextCursor::MoveAnchor);

      c.clearSelection();
      if (c.blockNumber() == 0){
        bAtStart = true;
        c.movePosition(QTextCursor::StartOfLine, QTextCursor::MoveAnchor);
      } else {
        c.movePosition(QTextCursor::Up, QTextCursor::MoveAnchor);
        c.movePosition(QTextCursor::EndOfLine, QTextCursor::MoveAnchor);
      }
      c.movePosition(QTextCursor::Right, QTextCursor::KeepAnchor, b - c.position());

    } else {
      c.movePosition(QTextCursor::Left, QTextCursor::MoveAnchor, b - a);
      c.movePosition(QTextCursor::StartOfLine, QTextCursor::MoveAnchor);

      c.clearSelection();
      if (c.blockNumber() == 0){
        bAtStart = true;
        c.movePosition(QTextCursor::StartOfLine, QTextCursor::MoveAnchor);
      } else {
        c.movePosition(QTextCursor::Up, QTextCursor::MoveAnchor);
        c.movePosition(QTextCursor::EndOfLine, QTextCursor::MoveAnchor);
      }
      c.movePosition(QTextCursor::Right, QTextCursor::KeepAnchor, b - c.position());

    }
    
    QString s = c.selectedText();

    QString cr = QString(QChar(0x2029));
    
 

    s.replace(cr, cr + "'");

    if (bAtStart){
      s = "'" + s;
    }
    c.insertText(s);

    c.clearSelection();

    
   

    c.endEditBlock();
    code->document()->setModified(true); 

    code->setTextCursor(c);

  } 
}

void Q7BCodeWindow::PerformUncomment()
{
  QTextCursor c = code->textCursor();

  if (c.hasSelection()){

    c.beginEditBlock();

    int a = c.selectionStart();
    int b = c.selectionEnd();
    
    c.movePosition(QTextCursor::Left, QTextCursor::MoveAnchor, b - a);
    c.movePosition(QTextCursor::StartOfLine, QTextCursor::MoveAnchor);
    c.clearSelection();
    bool bAtStart = false;
    if (c.blockNumber() == 0){
      bAtStart = true;
      c.movePosition(QTextCursor::StartOfLine, QTextCursor::MoveAnchor);
    } else {
      c.movePosition(QTextCursor::Up, QTextCursor::MoveAnchor);
      c.movePosition(QTextCursor::EndOfLine, QTextCursor::MoveAnchor);
    }
    c.movePosition(QTextCursor::Right, QTextCursor::KeepAnchor, b - c.position());

    QString s = c.selectedText();

    QString cr = QString(QChar(0x2029));
    
   

    if (s.contains(cr + "'")) s.replace(cr + "'", cr);
    else if (s.contains(cr + " '")) s.replace(cr + " '", cr + " ");
    else if (s.contains(cr + "  '")) s.replace(cr + "  '", cr + "  ");
    else if (s.contains(cr + "   '")) s.replace(cr + "   '", cr + "   ");
    else if (s.contains(cr + "    '")) s.replace(cr + "    '", cr + "    ");
    else if (s.contains(cr + "     '")) s.replace(cr + "     '", cr + "     ");
    else if (s.contains(cr + "      '")) s.replace(cr + "      '", cr + "      ");
    else if (s.contains(cr + "       '")) s.replace(cr + "       '", cr + "       ");
    else if (s.contains(cr + "        '")) s.replace(cr + "        '", cr + "        ");
    else if (s.contains(cr + "         '")) s.replace(cr + "         '", cr + "         ");
    else if (s.contains(cr + "          '")) s.replace(cr + "          '", cr + "          ");
    else if (s.contains(cr + "           '")) s.replace(cr + "           '", cr + "           ");
    else if (s.contains(cr + "            '")) s.replace(cr + "            '", cr + "            ");
    else if (s.contains(cr + "             '")) s.replace(cr + "             '", cr + "             ");
    else if (s.contains(cr + "              '")) s.replace(cr + "              '", cr + "              ");
    else if (s.contains(cr + "               '")) s.replace(cr + "               '", cr + "               ");
    else if (s.contains(cr + "                '")) s.replace(cr + "                '", cr + "                ");
    else if (s.contains(cr + "                 '")) s.replace(cr + "                 '", cr + "                 ");
    else if (s.contains(cr + "                  '")) s.replace(cr + "                  '", cr + "                  ");

    else if (bAtStart){
      if (s.startsWith("' ")) s = s.mid(2);
    }

    c.insertText(s);

    c.clearSelection();

    
    

    c.endEditBlock();

    code->setTextCursor(c);
    code->document()->setModified(true); 

  } 
}

void Q7BCodeWindow::PerformIndent()
{
  

  QTextCursor c = code->textCursor();

  if (c.hasSelection()){

    int a = c.selectionStart();
    int b = c.selectionEnd();
    int nn = 0;

    int cpos = c.position();

    if (cpos == a){

      c.beginEditBlock();

      c.movePosition(QTextCursor::StartOfLine, QTextCursor::MoveAnchor);
      c.clearSelection();
      c.movePosition(QTextCursor::Up, QTextCursor::MoveAnchor);
      c.movePosition(QTextCursor::EndOfLine, QTextCursor::MoveAnchor);
      nn = b - c.position();
      c.movePosition(QTextCursor::Right, QTextCursor::KeepAnchor, b - c.position());

    } else {
 
      c.beginEditBlock();

      c.movePosition(QTextCursor::Left, QTextCursor::MoveAnchor, b - a);
      c.movePosition(QTextCursor::StartOfLine, QTextCursor::MoveAnchor);
      c.clearSelection();
      c.movePosition(QTextCursor::Up, QTextCursor::MoveAnchor);
      c.movePosition(QTextCursor::EndOfLine, QTextCursor::MoveAnchor);
      nn = b - c.position();
      c.movePosition(QTextCursor::Right, QTextCursor::KeepAnchor, nn);
      
    }
    
    QString s = c.selectedText();

    QString cr = QString(QChar(0x2029));
    
   

    s.replace(cr, cr + "  ");

    c.insertText(s);

    c.clearSelection();

    
    

    c.endEditBlock();

    c.movePosition(QTextCursor::Left, QTextCursor::KeepAnchor, nn);

    code->setTextCursor(c);
    code->document()->setModified(true); 

  } else {

    c.beginEditBlock();

    c.insertText("  ");

    c.endEditBlock();

    code->setTextCursor(c);
    code->document()->setModified(true); 
  } 
}

void Q7BCodeWindow::PerformUnindent()
{
 

  QTextCursor c = code->textCursor();

  if (c.hasSelection()){

    c.beginEditBlock();

    int a = c.selectionStart();
    int b = c.selectionEnd();

    int nn = 0;
    
    int cpos = c.position();

    if (cpos == a){

      c.movePosition(QTextCursor::StartOfLine, QTextCursor::MoveAnchor);
      c.clearSelection();
      c.movePosition(QTextCursor::Up, QTextCursor::MoveAnchor);
      c.movePosition(QTextCursor::EndOfLine, QTextCursor::MoveAnchor);
      nn = b - c.position();
      c.movePosition(QTextCursor::Right, QTextCursor::KeepAnchor, b - c.position());

    } else {

      c.movePosition(QTextCursor::Left, QTextCursor::MoveAnchor, b - a);
      c.movePosition(QTextCursor::StartOfLine, QTextCursor::MoveAnchor);
      c.clearSelection();
      c.movePosition(QTextCursor::Up, QTextCursor::MoveAnchor);
      c.movePosition(QTextCursor::EndOfLine, QTextCursor::MoveAnchor);
      nn = b - c.position();
      c.movePosition(QTextCursor::Right, QTextCursor::KeepAnchor, b - c.position());

    }

    QString s = c.selectedText();

    QString cr = QString(QChar(0x2029));
    
    int n = s.count(cr);

    s.replace(cr + "  ", cr);

    c.insertText(s);

    c.clearSelection();

    
    

    c.endEditBlock();

    c.movePosition(QTextCursor::Left, QTextCursor::KeepAnchor, nn - n * 2);

    code->setTextCursor(c);
    code->document()->setModified(true); 

  } else {

    c.beginEditBlock();

    c.deletePreviousChar();
    c.deletePreviousChar();

    c.endEditBlock();

    code->setTextCursor(c);
    code->document()->setModified(true); 
  } 
}

void Q7BCodeWindow::PerformUpper()
{
  QTextCursor c = code->textCursor();

  if (c.hasSelection()){

    c.beginEditBlock();

    QString s = c.selectedText();

    QString cr = QString(QChar(0x2029));

    c.insertText(s.toUpper());

    c.clearSelection();

    c.endEditBlock();

    code->setTextCursor(c);
    code->document()->setModified(true); 

  } 
}

void Q7BCodeWindow::PerformLower()
{
  QTextCursor c = code->textCursor();

  if (c.hasSelection()){

    c.beginEditBlock();

    QString s = c.selectedText();

    QString cr = QString(QChar(0x2029));

    c.insertText(s.toLower());

    c.clearSelection();

    c.endEditBlock();

    code->setTextCursor(c);
    code->document()->setModified(true); 

  } 
}

void Q7BCodeWindow::PerformInsertFile()
{
  QString s = QFileDialog::getOpenFileName(this, tr("Open File"), QString::null, tr("Source Codes (*.class)"));
  if (!s.isEmpty()){

    QFile f(s);
    if (!f.open(QIODevice::ReadOnly)){
      QMessageBox::information(this, "QtBasic", QString("Could not read from %1").arg(s));
      return;
    }

	  QTextStream t(&f);
    
    t.setCodec("UTF-8");
    t.setAutoDetectUnicode(true);
    t.setGenerateByteOrderMark(true);

    s = t.readAll();
    s = s.replace("\r", "");
	  f.close();

    QTextCursor c = code->textCursor();

    c.beginEditBlock();

    c.insertText(s);
    c.endEditBlock();

    code->setTextCursor(c);
    code->document()->setModified(true); 
  
  }
}

void Q7BCodeWindow::PerformInsertText(const QString & s)
{
  QTextCursor c = code->textCursor();

  c.beginEditBlock();

  c.insertText(s);
  c.endEditBlock();

  code->setTextCursor(c);
  code->document()->setModified(true); 
}

void Q7BCodeWindow::PerformGotoLine()
{
  bool b;

  int min = 1;
  QTextCursor c = code->textCursor();
  int max = c.blockNumber() + 1;

  QString s = tr("Lines (%1 - %2):").arg(min).arg(max);

  s = QInputDialog::getText(this, tr("Go To Line"), s, QLineEdit::Normal, "", &b);
  if (b && !s.isEmpty()){
    int n = s.toInt();
    if (n >= min && n <= max){
      GotoLineAndSelectLine(n);
    }
  }
}

void Q7BCodeWindow::UndoRedoCut()
{
  emit CopyAvailable(bCopyAvailable);
  emit PasteAvailable(code->canPaste());
  emit RedoAvailable(bRedoAvailable);
  emit UndoAvailable(bUndoAvailable);
}

void Q7BCodeWindow::code_copyAvailable(bool b)
{
  bCopyAvailable = b;
  emit CopyAvailable(b);
}

void Q7BCodeWindow::code_pasteAvailable()
{
  emit PasteAvailable(code->canPaste());
}

void Q7BCodeWindow::code_redoAvailable(bool b)
{
  bRedoAvailable = b;
  emit RedoAvailable(b);
}

void Q7BCodeWindow::code_undoAvailable(bool b)
{
  bUndoAvailable = b;
  emit UndoAvailable(b);
}



QString Q7BCodeWindow::getCurrentCompletionTrigger()
{
  QTextCursor c = code->textCursor();
 
  
  int n = c.columnNumber();
  
  c.movePosition(QTextCursor::StartOfLine, QTextCursor::KeepAnchor);

  QString k = c.selectedText();
  
  for (int i = k.length() - 1; i >= 0; i--){
    QChar c = k.at(i);

    if ((!k.at(i).isLetterOrNumber() && k.at(i) != '_' && (i != k.length() - 1 && k.at(i) != '(')) || (i != k.length() - 1 && c == '(') || c == ')' || c == '[' || c == ']' || c == '!' || c == '.' || c == '\"' || c == '\''){

      k = k.mid(i + 1);
      break;
    }
  }

  return k;
}

QString Q7BCodeWindow::getBeforeCurrentLineAsString()
{
  QTextCursor c = code->textCursor();
  if (c.blockNumber() == 0) return "";
  c.movePosition(QTextCursor::Up, QTextCursor::MoveAnchor);
  c.movePosition(QTextCursor::EndOfLine, QTextCursor::MoveAnchor);
  c.movePosition(QTextCursor::StartOfLine, QTextCursor::KeepAnchor);

  return c.selectedText();
}

QString Q7BCodeWindow::getCurrentLineAsString(int nLineOffset)
{
  QTextCursor c = code->textCursor();
  if (nLineOffset < 0) c.movePosition(QTextCursor::Up, QTextCursor::MoveAnchor, nLineOffset * -1);
  else if (nLineOffset > 0) c.movePosition(QTextCursor::Down, QTextCursor::MoveAnchor, nLineOffset);
  c.movePosition(QTextCursor::StartOfLine, QTextCursor::MoveAnchor);
  c.movePosition(QTextCursor::EndOfLine, QTextCursor::KeepAnchor);

  return c.selectedText();
}

void Q7BCodeWindow::SetCompletion(QStringList l)
{
  lCompletion1 = l;
}

void Q7BCodeWindow::SetCompletion2(QString s)
{
  sCompletion2 = s;
}

int Q7BCodeWindow::getCurrentPosition()
{
  QTextCursor c = code->textCursor();

  return c.position();
}

int Q7BCodeWindow::getCurrentLine()
{
  QTextCursor c = code->textCursor();

  return c.blockNumber() + 1;
}

int Q7BCodeWindow::getCurrentColumn()
{
  QTextCursor c = code->textCursor();

  return c.columnNumber() + 1;
}

bool Q7BCodeWindow::PerformFind(const QString & sSearch)
{
  QTextCursor c = code->textCursor();
  c = code->document()->find(sSearch, c);
  if (!c.isNull()){
    code->setTextCursor(c);  
    return true;
  } else {
    c = code->textCursor();
    c.movePosition(QTextCursor::Start);
    code->setTextCursor(c);  
    c = code->textCursor();
    c = code->document()->find(sSearch, c);
    if (!c.isNull()){
      code->setTextCursor(c);  
      return true;
    }
  }
  return false;
}

void Q7BCodeWindow::PerformReplace()
{
}

bool Q7BCodeWindow::Save()
{  
  QFile f(sFilename);
  if (!f.open(QIODevice::WriteOnly )){
    return false;
  } else {
    QTextStream t(&f);
    
    t.setCodec("UTF-8");
    t.setAutoDetectUnicode(true);
    t.setGenerateByteOrderMark(true);

    QString s = code->toPlainText();
    t << s;
    f.close();
    
  }

  return true;
}

bool Q7BCodeWindow::Load(const QString & _sFilename)
{  

    QFile f(_sFilename);
    if (!f.open(QIODevice::ReadOnly)){
     
      
      return false;
    }

	    QTextStream t(&f);
      
      t.setCodec("UTF-8");
      t.setAutoDetectUnicode(true);
      t.setGenerateByteOrderMark(true);

      

	    QString s = t.readAll();
      s = s.replace("\r", "");
	    f.close();

      


  if (!s.isEmpty()){
   
  
    code->setPlainText(s);  
  }

  code->document()->setModified(false);
  sFilename = _sFilename;
  
  RefreshBrowser();
  

  


  return true;
}


void Q7BCodeWindow::setCurrentDebugPosition(int nLine)
{
 
  int nn = nCurrentDebugPosition;
  nCurrentDebugPosition = 0;

  if (nn != 1){
    this->GotoLine(1);
    this->GotoLine(nn);
  } else {
    this->GotoLine(2);
    this->GotoLine(nn);
  }

  nCurrentDebugPosition = nLine;

 

  if (nn != 1){
    this->GotoLine(1);
    this->GotoLine(nn);
  } else {
    this->GotoLine(2);
    this->GotoLine(nn);
  }
  

 
}

void Q7BCodeWindow::setUnsetBreaktpoint(int nLine)
{
  QTextBlock block = code->document()->findBlockByLineNumber(nLine);

  if (block.isValid()){
    aBreakpoint *ud = (aBreakpoint*)block.userData();
    if (ud && ud->nBreakpointLine > 0){
      block.setUserData(new aBreakpoint(0));
    } else {
      block.setUserData(new aBreakpoint(nLine));
    }
  }
  
  int nn = this->getCurrentLine();
  if (nn != 1){
    this->GotoLine(1);
    this->GotoLine(nn);
  } else {
    this->GotoLine(2);
    this->GotoLine(nn);
  }

  
  
       


  
}

QStringList Q7BCodeWindow::getAllBreakpoints()
{
  QStringList l;
  for (int i = 0; i < code->document()->lineCount(); i++){
    QTextBlock block = code->document()->findBlockByLineNumber(i);

    if (block.isValid()){
      aBreakpoint *ud = (aBreakpoint*)block.userData();
      if (ud && ud->nBreakpointLine > 0){
        l << QString("%1").arg(ud->nBreakpointLine);
      }
    }

  }
  return l;
  
}



void Q7BCodeWindow::closeEvent( QCloseEvent *e)
{
  
  
  
  e->accept();

  
    
    
 

  QFrame::closeEvent(e);
  
  

}



