
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/
 

#ifndef qtbasic_h
#define qtbasic_h

#include <QtGui>


#ifdef Q_WS_X11
  #include <phonon>
#else
  #include <Phonon>
#endif
#include <QWebView>

#include <QSvgWidget>

#include <QtSql>

#include <QSvgRenderer>

#include <QUdpSocket>

#include <QHttp>

#include <typeinfo>

extern QString Q7B_QtBL();

#define Q7B QSharedPointer<Q7B_id>
class Q7B_Label;
class Q7B_ToolButton;
class Q7B_Control;

class Q7B_id
{
public:
  Q7B_id()
  {
    type = 0;
    ref = 0;
    q7b_array = 0;
    q7b_type = 0;
    q7b_properties = 0;
    q7b_array_count = 0;
    gc_enabled = true;
  }

  Q7B_id(const char *t, void * r)
  {
    type = t;
    ref = r;
    q7b_array = 0;
    q7b_type = 0;
    q7b_properties = 0;
    q7b_array_count = 0;
    gc_enabled = true;
  }

  Q7B_id(const char *t, void * r, bool _gc_enabled)
  {
    type = t;
    ref = r;
    q7b_array = 0;
    q7b_type = 0;
    q7b_properties = 0;
    q7b_array_count = 0;
    gc_enabled = _gc_enabled;
  }

 



  ~Q7B_id();

  void setProperty(QString Name, QVariant Value)
  {
    if (q7b_properties == 0){
      q7b_properties = new QMap<QString, QVariant>;
    }

    q7b_properties->insert(Name, Value);
  }

  QVariant property(QString Name)
  {
    if (q7b_properties == 0){
      return QVariant();
    }

    return q7b_properties->value(Name);
  }

  bool isQObjectBased();

public:
  const char *type;
  void *ref;   
  

   

  

  qint32 array_indexes[4]; 
  qint32 q7b_array_count;

  QVector<Q7B> *q7b_array; 

  QVector<Q7B> *q7b_type;

  QMap<QString, QVariant> *q7b_properties;

  
  bool gc_enabled;
};

class Q7B_List;

extern const QPixmap &Q7B_loadPixmap(QString fn);

extern const QPixmap &Q7B_createPixmap(QString n);

struct Q7B_t_sound{
public:
QByteArray *bytearray;
QBuffer *buffer;
};

extern QString Q7B_PlaySound(QString FileName);

extern void Q7B_Control_constructor(QWidget *o);

extern void Q7B_toXML2(QXmlStreamWriter & xmlWriter, Q7B Object);

extern QString Q7B_toString2(Q7B Object);

extern qreal Q7B_toFloat2(Q7B Object);

extern qint64 Q7B_toInteger2(Q7B Object);

extern bool Q7B_bDebugBreak;

extern bool Q7B_bDebug;

extern bool Q7B_bStepInto;

extern bool Q7B_bStepOut;

extern bool Q7B_bStepOver;

extern bool Q7B_bRunToCursor;

extern QString Q7B_sRunToCursorFile;

extern QString Q7B_sRunToCursorLine;

extern QString Q7B_sStepOverScope;

extern QString Q7B_sDebugScope;

extern QMap<QString, QStringList> Q7B_breakpoints;

extern Q7B Q7B_IDNIL();

extern void *Q7B_connectSlotsByNameWithNewAndReturnIt(void *_Me, QObject *Parent);


class Q7B_List : public QObject
{
public:

  static Q7B init()
  {
    Q7B q (new Q7B_id(typeid(Q7B_List).name(), new Q7B_List( ))); 
    return q;
  }

  static Q7B init(Q7B o1, Q7B o2 = Q7B_IDNIL(), Q7B o3 = Q7B_IDNIL(), Q7B o4 = Q7B_IDNIL(), Q7B o5 = Q7B_IDNIL(), Q7B o6 = Q7B_IDNIL(), Q7B o7 = Q7B_IDNIL(), Q7B o8 = Q7B_IDNIL(), Q7B o9 = Q7B_IDNIL(), Q7B o10 = Q7B_IDNIL(), Q7B o11 = Q7B_IDNIL(), Q7B o12 = Q7B_IDNIL(), Q7B o13 = Q7B_IDNIL(), Q7B o14 = Q7B_IDNIL(), Q7B o15 = Q7B_IDNIL(), Q7B o16 = Q7B_IDNIL(), Q7B o17 = Q7B_IDNIL(), Q7B o18 = Q7B_IDNIL(), Q7B o19 = Q7B_IDNIL(), Q7B o20 = Q7B_IDNIL())
  {
    Q7B_List *a = new Q7B_List();
    Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

    a->me << o1;        
    if (o2->ref == 0 && o2->q7b_array == 0) return q; a->me << o2;       
    if (o3->ref == 0 && o3->q7b_array == 0) return q; a->me << o3;       
    if (o4->ref == 0 && o4->q7b_array == 0) return q; a->me << o4;       
    if (o5->ref == 0 && o5->q7b_array == 0) return q; a->me << o5;       
    if (o6->ref == 0 && o6->q7b_array == 0) return q; a->me << o6;       
    if (o7->ref == 0 && o7->q7b_array == 0) return q; a->me << o7;       
    if (o8->ref == 0 && o8->q7b_array == 0) return q; a->me << o8;       
    if (o9->ref == 0 && o9->q7b_array == 0) return q; a->me << o9;       
    if (o10->ref == 0 && o10->q7b_array == 0) return q; a->me << o10;       
    if (o11->ref == 0 && o11->q7b_array == 0) return q; a->me << o11;       
    if (o12->ref == 0 && o12->q7b_array == 0) return q; a->me << o12;       
    if (o13->ref == 0 && o13->q7b_array == 0) return q; a->me << o13;       
    if (o14->ref == 0 && o14->q7b_array == 0) return q; a->me << o14;       
    if (o15->ref == 0 && o15->q7b_array == 0) return q; a->me << o15;       
    if (o16->ref == 0 && o16->q7b_array == 0) return q; a->me << o16;       
    if (o17->ref == 0 && o17->q7b_array == 0) return q; a->me << o17;       
    if (o18->ref == 0 && o18->q7b_array == 0) return q; a->me << o18;       
    if (o19->ref == 0 && o19->q7b_array == 0) return q; a->me << o19;       
    if (o20->ref == 0 && o20->q7b_array == 0) return q; a->me << o20;       

    return q;
  }



  Q7B_List()
  {
  }

  Q7B_List(QStringList l) 
  {
    for (int i = 0; i < l.size(); i++)
    {
      Q7B q (new Q7B_id(typeid(QString).name(), new QString( l.at(i) ))); 
      me << q;
    }
  }


  QString join(QString sSeparator)
  {
    QString s;
    
    for (int i = 0; i < me.size(); i++){
      Q7B q = me.at(i);
      s += Q7B_toString2( q );
      s += sSeparator;
    }

    return s;
  }

  QStringList toStringList()
  {
    QStringList l;
    
    for (int i = 0; i < me.size(); i++){
      Q7B q = me.at(i);
      l << Q7B_toString2( q );
    }    

    return l;
  }

  QString toString()
  {
    QString s = "List {";
    
    for (int i = 0; i < me.size(); i++){
      if (i == 0) s += "\n";
      Q7B q = me.at(i);
      s += Q7B_toString2( q );
      s += (i + 1 < me.size() ? ",\n" : "\n");
    }

    s += "}";

    return s;
  }

  void toXML(QXmlStreamWriter & xmlWriter)
  {   
    xmlWriter.writeStartElement("list");

    for (int i = 0; i < me.size(); i++){
      Q7B q = me.at(i);
      Q7B_toXML2( xmlWriter, q );
    }

    xmlWriter.writeEndElement();
  }

  void append(Q7B Q7B_Object)
  {
    
    me << Q7B_Object;  

  }

  void removeAll()
  {
    me.clear(); 
  }

  void insert(Q7B Q7B_Object, qint64 Index)
  {
    if (Index < 0 || Index > me.count()) return; 

    me.insert(Index, Q7B_Object);
  }

  void replace(Q7B Q7B_Object, qint64 Index)
  {
    if (Index < 0 || Index > me.count()) return; 

    me.replace(Index, Q7B_Object); 
  }

  Q7B getObject(qint64 Index)
  {
    if (Index < 0 || Index > me.count()) return Q7B_IDNIL(); 

    return me.at(Index);
  }

  void remove(qint64 Index)
  {
    if (Index < 0 || Index > me.count()) return; 

    me.removeAt(Index); 
  }

  qint64 count()
  {
    return me.count();
  }

  QList<Q7B> & values()
  {
    return me;
  }

public:
  QList<Q7B>me;
};


class Q7B_Dictionary : public QObject
{
public:

  static Q7B init()
  {
    Q7B q (new Q7B_id(typeid(Q7B_Dictionary).name(), new Q7B_Dictionary( ))); 
    return q;
  }


  static Q7B init(Q7B values, Q7B keys);

  Q7B_Dictionary()
  {
  }

  QString toString()
  {
    QString s = "Dictionary {";
    
    bool bFirst = true;
    QMapIterator<QString, Q7B> i(me);
    while (i.hasNext()){
      i.next();
      if (bFirst){
        bFirst = false;
        s += "\n";
      }
      s += i.key() + " = ";
      Q7B q = i.value();
      s += Q7B_toString2( q );
      s += (i.hasNext() ? ",\n" : "\n");
    }

    s += "}";

    return s;
  }

  void toXML(QXmlStreamWriter & xmlWriter)
  {   
    xmlWriter.writeStartElement("dictionary");

    QMapIterator<QString, Q7B> i(me);
    while (i.hasNext()) {
       i.next();
       
       xmlWriter.writeTextElement("key", i.key());
       Q7B_toXML2(xmlWriter, i.value());
    }

    xmlWriter.writeEndElement();
  }

  QMap<QString, Q7B> & keysvalues()
  {
    return me;
  }

  qint64 count()
  {
    return me.count();
  }

  void removeAll()
  {
    me.clear(); 
  }

  Q7B keys()
  {
    QList<QString>k = me.keys();

    Q7B_List *a = new Q7B_List();
    Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

    for (int i = 0; i < k.size(); i++){
      Q7B m (new Q7B_id(typeid(QString).name(), new QString( k.at(i) ))); 
      a->append(m);
    }

    return q;
  }

  Q7B values()
  {
    QList<Q7B>v = me.values();

    Q7B_List *a = new Q7B_List();
    Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

    for (int i = 0; i < v.size(); i++){
      a->append( v.at(i) );
    }

    return q;
  }

  void remove(QString Key)
  {
    if (!me.contains(Key)) return; 

    me.remove(Key); 
  }

  bool contains(QString Key)
  {
    return me.contains(Key); 
  }

  Q7B getObject(QString Key)
  {
    if (!me.contains(Key)) return Q7B_IDNIL(); 

    return me.value(Key);
  }

  void setObject(QString Key, Q7B Q7B_Object)
  {
    me[Key] = Q7B_Object; 
  }

  QMap<QString, QString> toMap()
  {
    QMap<QString, QString>m;
    QList<QString>k = me.keys();
    
    for (int i = 0; i < k.size(); i++){
      m[k.at(i)] = Q7B_toString2( me[k.at(i)] );
    }    

    return m;
  }

public:
  QMap<QString, Q7B>me;
  
};


class Q7B_Data
{
public:
  Q7B_Data(){}

  
  QString toString()
  {
    return "";
  }
};


class Q7B_Decimal
{
public:

  Q7B_Decimal()
  {
    v = 0;
  }

  Q7B_Decimal(qint64 bc, qint64 ad)
  {
    v = bc * 10000;
    if (bc < 0) v -= ad; else v += ad;
  }

  Q7B_Decimal(qint64 l)
  {
    v = l * 10000;
  }

  Q7B_Decimal(QVariant q)
  {
    v = q.toLongLong();
  }

  Q7B_Decimal(qreal d)
  {
    qint64 bc = (qint64) d;
    qreal e;
   
    if (bc < 0){
      e = (d - bc);
    } else {
      e = (d + bc);
    }
    qint64 ad = e * 10000;

    v = bc * 10000 + ad;
  }

  Q7B_Decimal(QString s)
  {
    v = 0;

    qint64 bc = 0;
    qint64 ad = 0;

    int i = 0;
    int nLen = 0;
    int nLen2 = 0;
    int nDotPos = -1;
  
	  bool t;
    bool p;
  	
    t = false;
	  if (s[i] == '+' || s[i] == '-'){
		  i++;
		  nLen++;
    }
    while (s[i] >= '0' && s[i] <= '9'){
      i++;
		  nLen++;
      t = true;
    }
    if (p = (s[i] == '.')){
      nDotPos = i;
      i++;
		  nLen++;
      while (s[i] >= '0' && s[i] <= '9'){
        i++;
			  nLen++;
  		  nLen2++;
        t = true;
      }
    }
    if (!t) return;

	  if (p == true) goto ok;
	  else return;

    t = false;
    while (s[i] >= '0' && s[i] <= '9'){
      i++;
		  nLen++;
      t = true;
    }
    if (!t) return;

  ok:

    if (nLen2 > 4) {return; }

    if (nDotPos >= 0){
      bc = s.left(nDotPos).toLongLong();
      ad = s.mid(nDotPos + 1).toLongLong();
    } else bc = s.toLongLong();

    v = bc * 10000;
    if (bc < 0) v -= ad; else v += ad;
  }  

  qint64 ad()
  {
    qint64 m = v % 10000;
    if (m < 0) m = -m;
    return m;
  }

  qint64 bc()
  {
    return v / 10000;
  }

  void setValue(qint64 q)
  {
    v = q;
 }

  qint64 value()
  {
    return v;
  }

  QVariant toQVariant()
  {
    return QVariant(v);
  }

  Q7B_Decimal minus()
  {
    Q7B_Decimal d;

    d.v = -v;
    return d;
  }

  qint64 toInteger()
  {
    return v / 10000;
  }

  QString toString()
  {
    QString s;
    
    qint64 r = v;

    s = QString("%1").arg((qint64) r / 10000);
    if (r < 0) r = -r;
    s = s + QString(".%1").arg((qint64) r % 10000, -4, 10, QChar('0')); 

    return s;
  }

  qreal toFloat()
  {
    qint64 ad = v % 10000;
    if (ad < 0) ad = -ad;

    qint64 bc = v / 10000;

    qreal f = ad;
    f /= 10000;
    f += bc;
    return f;
  }

private:
  qint64 v;
};

Q7B Q7B_IDNIL();
void q7b_array_dimhelper(Q7B o, qint32 a0, qint32 a1, qint32 a2, qint32 a3);
qint64 q7b_array_offset(Q7B o, qint32 a0, qint32 a1, qint32 a2, qint32 a3, bool bCheck);
void q7b_array_dim(Q7B o, Q7B a0, Q7B a1, Q7B a2, Q7B a3);
void q7b_array_redim(Q7B o, Q7B Preserve, Q7B aa0, Q7B aa1, Q7B aa2, Q7B aa3);
Q7B *q7b_array_get(Q7B o, Q7B a0, Q7B a1, Q7B a2, Q7B a3);
Q7B *q7b_array_at(Q7B o, Q7B a0, Q7B a1, Q7B a2, Q7B a3) ;
Q7B q7b_array_ubound(Q7B o, Q7B i);
Q7B *q7b_type_get(Q7B o, Q7B index, Q7B a0, Q7B a1, Q7B a2, Q7B a3);
const QPixmap &Q7B_createPixmap(QString n);
const QPixmap &Q7B_loadPixmap(QString fn);
Q7B Q7B_EQUALEQUALEQUAL(Q7B l, Q7B r);
Q7B Q7B_EQUALEQUAL(Q7B l, Q7B r);
Q7B Q7B_EQUAL(Q7B l, Q7B r);
Q7B Q7B_UNEQUAL(Q7B l, Q7B r);
void Q7B_ASSIGNMENT(Q7B *l, Q7B *r);
Q7B Q7B_SMALLER(Q7B l, Q7B r);
Q7B Q7B_GREATER(Q7B l, Q7B r);
Q7B Q7B_SMALLEREQUAL(Q7B l, Q7B r);
Q7B Q7B_GREATEREQUAL(Q7B l, Q7B r);
Q7B Q7B_FLIP(Q7B l);
Q7B Q7B_NOT(Q7B l);
Q7B Q7B_MINUS(Q7B l);
Q7B Q7B_AND(Q7B l, Q7B r);
Q7B Q7B_OR(Q7B l, Q7B r);
Q7B Q7B_XOR(Q7B l, Q7B r);
Q7B Q7B_SHL(Q7B l, Q7B r);
Q7B Q7B_SHR(Q7B l, Q7B r);
Q7B Q7B_ADD(Q7B l, Q7B r);
Q7B Q7B_SUB(Q7B l, Q7B r);
Q7B Q7B_CONCAT(Q7B l, Q7B r);
Q7B Q7B_POWER(Q7B l, Q7B r);
Q7B Q7B_MUL(Q7B l, Q7B r);
Q7B Q7B_IDIV(Q7B l, Q7B r);
Q7B Q7B_DIV(Q7B l, Q7B r);
Q7B Q7B_MOD(Q7B l, Q7B r);
Q7B Q7B_VB6MsgBox(QString sMessage, int n, QString sTitle);
Q7B Q7B_MSGBOX(Q7B a, Q7B b, Q7B VB6MsgBox);
Q7B Q7B___MSGBOX(Q7B a, Q7B b, Q7B Buttons, Q7B VB6MsgBox);
Q7B Q7B__MSGBOX(Q7B Q7B_Object);
Q7B Q7B_INPUTBOX(Q7B Prompt, Q7B Title, Q7B Default);
bool Q7B_fileExists(QString & s);
Q7B Q7B_ISDIR(Q7B FilePath);
Q7B Q7B_FILE(Q7B FilePath);
Q7B Q7B_COPY(Q7B SourceFilePath, Q7B DestinationFilePath);
Q7B Q7B_COPYDIR(Q7B SourceFilePath, Q7B DestinationFilePath);
Q7B Q7B_MOVE(Q7B SourceFilePath, Q7B DestinationFilePath);
Q7B Q7B_DELETE(Q7B FilePath);
Q7B Q7B_DRIVES();
Q7B Q7B_DIR(Q7B FilePath, Q7B Create);
Q7B Q7B_CLASSNAME(Q7B Q7B_Object);
Q7B Q7B_MESSAGEBOX(Q7B Icon, Q7B Title, Q7B Text, Q7B InformativeText, Q7B DetailedText, Q7B o1, Q7B o2, Q7B o3, Q7B o4, Q7B o5, Q7B o6, Q7B o7, Q7B o8, Q7B o9, Q7B o10);
Q7B Q7B_QOBJECT() ;
Q7B Q7B_QOBJECT(QObject *o) ;
Q7B Q7B_QOBJECT(bool o) ;
Q7B Q7B_QOBJECT(char * o);
Q7B Q7B_QOBJECT(const char * o);
Q7B Q7B_QOBJECT(QString o);
Q7B Q7B_QOBJECT(qint8 o);
Q7B Q7B_QOBJECT(qint16 o);
Q7B Q7B_QOBJECT(qint32 o);
Q7B Q7B_QOBJECT(qint64 o);
Q7B Q7B_QOBJECT(quint8 o);
Q7B Q7B_QOBJECT(quint16 o);
Q7B Q7B_QOBJECT(quint32 o);
Q7B Q7B_QOBJECT(quint64 o);
Q7B Q7B_QOBJECT(float o);
Q7B Q7B_QOBJECT(double o);
Q7B Q7B_QOBJECT(QStringList o) ;
Q7B Q7B_QOBJECT(QIcon o);
Q7B Q7B_QOBJECT(QByteArray o);
Q7B Q7B_QOBJECTDECIMAL(qint64 bc, qint64 ad);
Q7B Q7B_QOBJECTNULL(qint64 *dummy);
Q7B Q7B_QOBJECT(QDateTime o) ;
Q7B Q7B_QOBJECT(Q7B_Decimal o) ;
Q7B Q7B_QOBJECT(QIcon *o);
Q7B Q7B_QOBJECT(QMenu *o);
Q7B Q7B_QOBJECT(QMdiArea *o);
Q7B Q7B_QOBJECT(QProgressBar *o);
Q7B Q7B_QOBJECT(QAction *o);
Q7B Q7B_QOBJECT(QPainter *o);
Q7B Q7B_QOBJECT(QWidget *o);
Q7B Q7B_QOBJECT(const char *name, QObject *o);
Q7B Q7B_BOOLEAN(Q7B o);
Q7B Q7B_QSTRING(Q7B Q7B_Object);
Q7B Q7B_INTEGER(Q7B o);
Q7B Q7B_FLOAT(Q7B o);
Q7B Q7B_DATETIME(Q7B o);
Q7B Q7B_DECIMAL(Q7B o);
Q7B Q7B_LIST(Q7B o);
Q7B Q7B_DICTIONARY(Q7B o);
Q7B Q7B_DATA(Q7B o);
Q7B Q7B_OS_ISWINDOWS(Q7B dummy);
Q7B Q7B_OS_ISMAC(Q7B dummy);
Q7B Q7B_OS_ISLINUX(Q7B dummy);
void Q7B_QPAINTER_DRAWLINE(Q7B qpainter, Q7B X1, Q7B Y1, Q7B X2, Q7B Y2);
Q7B Q7B_FILE_SIZE(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_RESIZE(Q7B dummy, Q7B FileName, Q7B NewSize);
Q7B Q7B_FILE_TRUNCATE(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_READSTRING(Q7B dummy, Q7B FileName, Q7B Codec, Q7B AutoDetectUnicode, Q7B GenerateByteOrderMark);
Q7B Q7B_FILE_READLINES(Q7B dummy, Q7B FileName, Q7B Codec, Q7B AutoDetectUnicode, Q7B GenerateByteOrderMark);
Q7B Q7B_FILE_WRITESTRING(Q7B dummy, Q7B Text, Q7B FileName, Q7B Append, Q7B Codec, Q7B AutoDetectUnicode, Q7B GenerateByteOrderMark);
Q7B Q7B_FILE_LINK(Q7B dummy, Q7B SourceFileName, Q7B DestinationFileName);
Q7B Q7B_FILE_CREATE(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_REMOVE(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_COPY(Q7B dummy, Q7B SourceFileName, Q7B DestinationFileName, Q7B Overwrite);
Q7B Q7B_FILE_MOVE(Q7B dummy, Q7B SourceFileName, Q7B DestinationFileName, Q7B Overwrite);
Q7B Q7B_FILE_RENAME(Q7B dummy, Q7B SourceFileName, Q7B DestinationFileName, Q7B Overwrite);
Q7B Q7B_FILE_EXISTS(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_DATETIMECREATED(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_DATETIMEUPDATED(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_DATETIMEREAD(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_WITHNATIVESEPARATORS(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_WITHOUTNATIVESEPARATORS(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_OWNER(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_GROUP(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_SYMLINKTARGET(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_ISRELATIVE(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_ISSYMLINK(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_ISREADABLE(Q7B dummy, Q7B FileName, Q7B Who);
Q7B Q7B_FILE_ISWRITABLE(Q7B dummy, Q7B FileName, Q7B Who);
Q7B Q7B_FILE_ISEXECUTABLE(Q7B dummy, Q7B FileName, Q7B Who);
Q7B Q7B_FILE_ISHIDDEN(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_ISFILE(Q7B dummy, Q7B FileName);
Q7B Q7B_FILE_ISDIR(Q7B dummy, Q7B FileName);
Q7B Q7B_PREFERENCES_IDS(Q7B dummy);
void Q7B_PREFERENCES_REMOVEALL(Q7B dummy);
Q7B Q7B_PREFERENCES_EXISTS(Q7B dummy, Q7B PreferenceId);
void Q7B_PREFERENCES_REMOVE(Q7B dummy, Q7B PreferenceId);
Q7B Q7B_PREFERENCES_BOOLEAN(Q7B dummy, Q7B PreferenceId);
Q7B Q7B_PREFERENCES_INTEGER(Q7B dummy, Q7B PreferenceId);
Q7B Q7B_PREFERENCES_STRING(Q7B dummy, Q7B PreferenceId);
Q7B Q7B_PREFERENCES_FLOAT(Q7B dummy, Q7B PreferenceId);
Q7B Q7B_PREFERENCES_DECIMAL(Q7B dummy, Q7B PreferenceId) ;
void Q7B_PREFERENCES_SETBOOLEAN(Q7B dummy, Q7B PreferenceId, Q7B Value);
void Q7B_PREFERENCES_SETINTEGER(Q7B dummy, Q7B PreferenceId, Q7B Value);
void Q7B_PREFERENCES_SETSTRING(Q7B dummy, Q7B PreferenceId, Q7B Value);
void Q7B_PREFERENCES_SETFLOAT(Q7B dummy, Q7B PreferenceId, Q7B Value);
void Q7B_PREFERENCES_SETDECIMAL(Q7B dummy, Q7B PreferenceId, Q7B Value) ;
Q7B Q7B_DESKTOP_DESKTOPLOCATION(Q7B dummy);
Q7B Q7B_DIR_ROOTPATH(Q7B Path);
Q7B Q7B_DIR_TEMPPATH(Q7B Path);
Q7B Q7B_DIR_APPLICATIONSPATH(Q7B dummy);
Q7B Q7B_DIR_HOMEPATH(Q7B dummy);
Q7B Q7B_DIR_DESKTOPPATH(Q7B dummy);
Q7B Q7B_DIR_CREATE(Q7B dummy, Q7B Path);
Q7B Q7B_DIR_RECURSIVECREATE(Q7B dummy, Q7B Path);
Q7B Q7B_DIR_REMOVE(Q7B dummy, Q7B Path);
Q7B Q7B_DIR_EXISTS(Q7B dummy, Q7B Path);
Q7B Q7B_DIR_RECURSIVEREMOVE(Q7B dummy, Q7B Path);
Q7B Q7B_DIR_FINDFILE(Q7B dummy, Q7B Path, Q7B NameFilter, Q7B Filter, Q7B Sorting);
Q7B Q7B_DIR_RECURSIVEFINDFILE(Q7B dummy, Q7B Path, Q7B NameFilter, Q7B Filter, Q7B Sorting);
Q7B Q7B_DIR_LIST(Q7B dummy, Q7B Path);
Q7B Q7B_DIR_RECURSIVELIST(Q7B dummy, Q7B Path);
Q7B Q7B_DIR_COPY(Q7B SourceFilePath, Q7B DestinationFilePath);
Q7B Q7B_DIR_MOVE(Q7B SourceFilePath, Q7B DestinationFilePath);
Q7B Q7B_DIR_ISDIR(Q7B FilePath);
Q7B Q7B_DIR_DATETIMECREATED(Q7B dummy, Q7B FileName);
Q7B Q7B_DIR_DATETIMEUPDATED(Q7B dummy, Q7B FileName);
Q7B Q7B_DIR_DATETIMEREAD(Q7B dummy, Q7B FileName);
Q7B Q7B_DIR_WITHNATIVESEPARATORS(Q7B dummy, Q7B FileName);
Q7B Q7B_DIR_WITHOUTNATIVESEPARATORS(Q7B dummy, Q7B FileName);
Q7B Q7B_DIR_OWNER(Q7B dummy, Q7B FileName);
Q7B Q7B_DIR_GROUP(Q7B dummy, Q7B FileName);
Q7B Q7B_DIR_SYMLINKTARGET(Q7B dummy, Q7B FileName);
Q7B Q7B_DIR_ISRELATIVE(Q7B dummy, Q7B FileName);
Q7B Q7B_DIR_ISSYMLINK(Q7B dummy, Q7B FileName);
Q7B Q7B_DIR_ISREADABLE(Q7B dummy, Q7B FileName, Q7B Who);
Q7B Q7B_DIR_ISWRITABLE(Q7B dummy, Q7B FileName, Q7B Who);
Q7B Q7B_DIR_ISEXECUTABLE(Q7B dummy, Q7B FileName, Q7B Who);
Q7B Q7B_DIR_ISHIDDEN(Q7B dummy, Q7B FileName);
Q7B Q7B_DIR_DRIVES();
Q7B Q7B_DIR_BUNDLENAME(Q7B dummy, Q7B FileName);
Q7B Q7B_DIR_ISROOT(Q7B dummy, Q7B FileName);
Q7B Q7B_DIR_ISBUNDLE(Q7B dummy, Q7B FileName);
Q7B Q7B_OPENFILEDIALOG_GETFILE(Q7B dummy);
Q7B Q7B_OPENFILEDIALOG_GETFILE2(Q7B dummy, Q7B WindowTitle, Q7B Directory, Q7B Filter);
Q7B Q7B_OPEFILENDIALOG_GETFILES(Q7B dummy);
Q7B Q7B_OPENFILEDIALOG_GETFILES2(Q7B dummy, Q7B WindowTitle, Q7B Directory, Q7B Filter);
Q7B Q7B_OPENFILEDIALOG_GETDIRECTORY(Q7B dummy);
Q7B Q7B_OPENFILEDIALOG_GETDIRECTORY2(Q7B dummy, Q7B WindowTitle, Q7B Directory);
Q7B Q7B_SAVEFILEDIALOG_GETFILE(Q7B dummy);
Q7B Q7B_SAVEFILEDIALOG_GETFILE2(Q7B dummy, Q7B WindowTitle, Q7B Directory, Q7B Filter);
Q7B Q7B_SAVEFILEDIALOG_GETDIRECTORY(Q7B dummy);
Q7B Q7B_SAVEFILEDIALOG_GETDIRECTORY2(Q7B dummy, Q7B WindowTitle, Q7B Directory);
Q7B Q7B_COLORDIALOG_GETCOLOR(Q7B dummy);
Q7B Q7B_COLORDIALOG_RED(Q7B dummy);
Q7B Q7B_COLORDIALOG_GREEN(Q7B dummy);
Q7B Q7B_COLORDIALOG_BLUE(Q7B dummy);
Q7B Q7B_COLORDIALOG_ALPHA(Q7B dummy);
Q7B Q7B_COLORDIALOG_GETCOLOR2(Q7B dummy, Q7B Red, Q7B Green, Q7B Blue, Q7B Alpha);
Q7B Q7B_FONTDIALOG_GETFONT(Q7B dummy);
Q7B Q7B_FONTDIALOG_NAME(Q7B dummy);
Q7B Q7B_FONTDIALOG_SIZE(Q7B dummy);
Q7B Q7B_FONTDIALOG_ITALIC(Q7B dummy);
Q7B Q7B_FONTDIALOG_BOLD(Q7B dummy);
Q7B Q7B_FONTDIALOG_UNDERLINE(Q7B dummy);
Q7B Q7B_FONTDIALOG_GETFONT2(Q7B dummy, Q7B Name, Q7B Size, Q7B Italic, Q7B Bold, Q7B Underline);
void Q7B_PROGRESSDIALOG_SHOW(Q7B dummy);
void Q7B_PROGRESSDIALOG_HIDE(Q7B dummy);
void Q7B_PROGRESSDIALOG_SHOW2(Q7B dummy, Q7B WindowTitle, Q7B CancelText);
Q7B Q7B_PROGRESSDIALOG_CANCELED(Q7B dummy);
void Q7B_PROGRESSDIALOG_WINDOWTITLE(Q7B dummy, Q7B _WindowTitle);
Q7B Q7B_PROGRESSDIALOG_WINDOWTITLE(Q7B dummy);
void Q7B_PROGRESSDIALOG_CANCELTEXT(Q7B dummy, Q7B _CancelText);
Q7B Q7B_PROGRESSDIALOG_CANCELTEXT(Q7B dummy);
void Q7B_PROGRESSDIALOG_VALUE(Q7B dummy, Q7B _Value);
Q7B Q7B_PROGRESSDIALOG_VALUE(Q7B dummy);
void Q7B_PROGRESSDIALOG_MINIMUM(Q7B dummy, Q7B _Minimum);
Q7B Q7B_PROGRESSDIALOG_MINIMUM(Q7B dummy);
void Q7B_PROGRESSDIALOG_MAXIMUM(Q7B dummy, Q7B _Maximum);
Q7B Q7B_PROGRESSDIALOG_MAXIMUM(Q7B dummy);
void Q7B_PROGRESSDIALOG_WAIT(Q7B dummy, Q7B _Wait);
Q7B Q7B_PROGRESSDIALOG_WAIT(Q7B dummy);
Q7B Q7B_INPUTDIALOG_GETFLOAT(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Value, Q7B Minimum, Q7B Maximum, Q7B Decimals);
Q7B Q7B_INPUTDIALOG_GETINTEGER(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Value, Q7B Minimum, Q7B Maximum, Q7B Step);
Q7B Q7B_INPUTDIALOG_GETSTRING(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Value, Q7B EchoMode);
Q7B Q7B_INPUTDIALOG_OK(Q7B dummy);
Q7B Q7B_DATABASE_MYSQL(Q7B dummy);
Q7B Q7B_DATABASE_POSTGRESQL(Q7B dummy);
Q7B Q7B_DATABASE_SQLITE(Q7B dummy);
Q7B Q7B_DATABASE_LOCALHOST(Q7B dummy);
Q7B Q7B_DATABASE_DEFAULTPORT(Q7B dummy);
Q7B Q7B_DATABASE_DEFAULTOPTIONS(Q7B dummy);
Q7B Q7B_DATABASE_SETCURRENTDATABASE(Q7B dummy, Q7B Name);
Q7B Q7B_DATABASE_SETCURRENTDATABASE(Q7B dummy);
Q7B Q7B_DATABASE_EXISTS(Q7B dummy, Q7B Driver, Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port);
Q7B Q7B_DATABASE_CREATE(Q7B dummy, Q7B Driver, Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port);
Q7B Q7B_DATABASE_TESTCONNECTION(Q7B dummy, Q7B Driver, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port);
Q7B Q7B_DATABASE_EMPTY(Q7B dummy, Q7B Driver, Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port);
Q7B Q7B_DATABASE_DROP(Q7B dummy, Q7B Driver, Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port);
Q7B Q7B_DATABASE_OPENSQLITE(Q7B dummy, Q7B Name);
Q7B Q7B_DATABASE_OPEN(Q7B dummy, Q7B Driver, Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port);
Q7B Q7B_DATABASE_CLOSE(Q7B dummy, Q7B Name);
Q7B Q7B_DATABASE_ISOPEN(Q7B dummy, Q7B Name);
Q7B Q7B_DATABASE_LASTSQLERROR(Q7B dummy, Q7B Name);
Q7B Q7B_DATABASE_LASTSQLCOMMANDS(Q7B dummy, Q7B Name);
Q7B Q7B_DATABASE_LASTSQLCOMMANDFAILED(Q7B dummy, Q7B Name);
Q7B Q7B_DATABASE_ISTRANSACTIONSUPPORTED(Q7B dummy, Q7B Name);
Q7B Q7B_DATABASE_TRANSACTION(Q7B dummy, Q7B Name);
Q7B Q7B_DATABASE_COMMIT(Q7B dummy, Q7B Name);
Q7B Q7B_DATABASE_ROLLBACK(Q7B dummy, Q7B Name);
Q7B Q7B_DATABASE_TABLES(Q7B dummy, Q7B Name);
Q7B Q7B_DATABASE_DRIVERS(Q7B dummy);
Q7B Q7B_TABLE_EXISTS(Q7B dummy, Q7B Table);
Q7B Q7B_TABLE_EXISTS2(Q7B dummy, Q7B Database, Q7B Table);
Q7B Q7B_TABLE_CREATE(Q7B dummy, Q7B Table, Q7B Fields);
Q7B Q7B_TABLE_CREATE2(Q7B dummy, Q7B Database, Q7B Table, Q7B Fields);
Q7B Q7B_TABLE_EMPTY(Q7B dummy, Q7B Table);
Q7B Q7B_TABLE_EMPTY2(Q7B dummy, Q7B Database, Q7B Table);
Q7B Q7B_TABLE_DROP(Q7B dummy, Q7B Table);
Q7B Q7B_TABLE_DROP2(Q7B dummy, Q7B Database, Q7B Table);
Q7B Q7B_TABLE_DELETE(Q7B dummy, Q7B Table, Q7B Where);
Q7B Q7B_TABLE_DELETE2(Q7B dummy, Q7B Database, Q7B Table, Q7B Where);
Q7B Q7B_TABLE_UPDATE(Q7B dummy, Q7B Table, Q7B Update, Q7B Where);
Q7B Q7B_TABLE_UPDATE2(Q7B dummy, Q7B Database, Q7B Table, Q7B Update, Q7B Where);
Q7B Q7B_TABLE_INSERT(Q7B dummy, Q7B Table, Q7B Insert);
Q7B Q7B_TABLE_INSERT2(Q7B dummy, Q7B Database, Q7B Table, Q7B Insert);
Q7B Q7B_TABLE_FIELDNAMES(Q7B dummy, Q7B Table);
Q7B Q7B_TABLE_FIELDNAMES2(Q7B dummy, Q7B Database, Q7B Table);
Q7B Q7B_TABLE_PRIMARYKEYNAME(Q7B dummy, Q7B Table);
Q7B Q7B_TABLE_PRIMARYKEYNAME2(Q7B dummy, Q7B Database, Q7B Table);
Q7B Q7B_RECORDS_OPEN(Q7B dummy, Q7B TableOrSql);
Q7B Q7B_RECORDS_OPEN2(Q7B dummy, Q7B Database, Q7B TableOrSql);
Q7B Q7B_RECORDS_OPEN3(Q7B dummy, Q7B TableOrSql, Q7B Where);
Q7B Q7B_RECORDS_OPEN4(Q7B dummy, Q7B Database, Q7B TableOrSql, Q7B Where);
Q7B Q7B_RECORDS_OPEN5(Q7B dummy, Q7B Table, Q7B Where, Q7B OrderBy);
Q7B Q7B_RECORDS_OPEN6(Q7B dummy, Q7B Database, Q7B Table, Q7B Where, Q7B OrderBy);
Q7B Q7B_RECORDS_CLOSE(Q7B dummy, Q7B RecordsId);
Q7B Q7B_RECORDS_REQUERY(Q7B dummy, Q7B RecordsId);
Q7B Q7B_RECORDS_FIRST(Q7B dummy, Q7B RecordsId);
Q7B Q7B_RECORDS_NEXT(Q7B dummy, Q7B RecordsId);
Q7B Q7B_RECORDS_PREVIOUS(Q7B dummy, Q7B RecordsId);
Q7B Q7B_RECORDS_LAST(Q7B dummy, Q7B RecordsId);
Q7B Q7B_RECORDS_GOTO(Q7B dummy, Q7B RecordsId, Q7B Position);
Q7B Q7B_RECORDS_LENGTH(Q7B dummy, Q7B RecordsId);
Q7B Q7B_RECORDS_POSITION(Q7B dummy, Q7B RecordsId);
Q7B Q7B_RECORDS_FIELDNAMES(Q7B dummy, Q7B RecordsId);
Q7B Q7B_RECORDS_VALUE(Q7B dummy, Q7B RecordsId, Q7B Field);
Q7B Q7B_QUERY_RUN(Q7B dummy, Q7B QueryNameOrSql);
Q7B Q7B_QUERY_RUN2(Q7B dummy, Q7B Database, Q7B QueryNameOrSql);
Q7B Q7B_QUERY_COMMAND(Q7B dummy, Q7B Command);
Q7B Q7B_QUERY_COMMAND2(Q7B dummy, Q7B Database, Q7B Command);
Q7B Q7B_MESSAGEBOX_CRITICAL(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Buttons, Q7B DefaultButton);
Q7B Q7B_MESSAGEBOX_INFORMATION(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Buttons, Q7B DefaultButton);
Q7B Q7B_MESSAGEBOX_QUESTION(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Buttons, Q7B DefaultButton);
Q7B Q7B_MESSAGEBOX_WARNING(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Buttons, Q7B DefaultButton);
void Q7B_SYSTEMTRAY_CONTEXTMENU(Q7B qsystemtray, Q7B v);
Q7B Q7B_SYSTEMTRAY_CONTEXTMENU(Q7B qsystemtray);
void Q7B_SYSTEMTRAY_ICON(Q7B qsystemtray, Q7B v);
Q7B Q7B_SYSTEMTRAY_ICON(Q7B qsystemtray);
void Q7B_SYSTEMTRAY_TOOLTIP(Q7B qsystemtray, Q7B v);
Q7B Q7B_SYSTEMTRAY_TOOLTIP(Q7B qsystemtray);
void Q7B_SYSTEMTRAY_VISIBLE(Q7B qsystemtray, Q7B v);
Q7B Q7B_SYSTEMTRAY_VISIBLE(Q7B qsystemtray);
Q7B Q7B_SYSTEMTRAY_ISSYSTEMTRAYAVAILABLE(Q7B qsystemtray);
Q7B Q7B_SYSTEMTRAY_ISMESSAGEBOXSUPPORTED(Q7B qsystemtray);
void Q7B_SYSTEMTRAY_SHOW(Q7B qsystemtray);
void Q7B_SYSTEMTRAY_HIDE(Q7B qsystemtray);
void Q7B_SYSTEMTRAY_SHOWORHIDE(Q7B qsystemtray);
void Q7B_SYSTEMTRAY_MESSAGEBOX(Q7B qsystemtray, Q7B Text);
void Q7B_SYSTEMTRAY_MESSAGEBOX2(Q7B qsystemtray, Q7B Title, Q7B Text);
void Q7B_SYSTEMTRAY_MESSAGEBOX3(Q7B qsystemtray, Q7B Title, Q7B Text, Q7B MessageBoxIcon);
void Q7B_SYSTEMTRAY_MESSAGEBOX4(Q7B qsystemtray, Q7B Title, Q7B Text, Q7B MessageBoxIcon, Q7B TimeOut);
void Q7B_TOOLBAR_ADDPERMANENTWIDGET(Q7B qstatusbar, Q7B Widget, Q7B Action);
Q7B Q7B_SOUNDS_PLAY(Q7B dummy, Q7B SoundId);
Q7B Q7B_SOUNDS_LOAD(Q7B dummy, Q7B SoundId, Q7B FileName);
Q7B Q7B_PIXMAPS_LOAD(Q7B dummy, Q7B PixmapId, Q7B FileName);
Q7B Q7B_COLORS_SET(Q7B dummy, Q7B ColorId, Q7B R, Q7B G, Q7B B, Q7B A);
Q7B Q7B_FONTS_SET(Q7B dummy, Q7B ColorId, Q7B R, Q7B G, Q7B B, Q7B A);
void Q7B_STATUSBAR_CLEARMESSAGE(Q7B qstatusbar);
void Q7B_STATUSBAR_SHOWMESSAGE(Q7B qstatusbar, Q7B Message);
void Q7B_STATUSBAR_SHOWMESSAGE(Q7B qstatusbar, Q7B Message, Q7B TimeOutInMilliSeconds);
void Q7B_STATUSBAR_ADDPERMANENTWIDGET(Q7B qstatusbar, Q7B Widget);
void Q7B_APPLICATION_PATH(Q7B qapplication, Q7B v);
Q7B Q7B_APPLICATION_PATH(Q7B qapplication);
void Q7B_APPLICATION_FILENAME(Q7B qapplication, Q7B v);
Q7B Q7B_APPLICATION_FILENAME(Q7B qapplication);
void Q7B_APPLICATION_PID(Q7B qapplication, Q7B v);
Q7B Q7B_APPLICATION_PID(Q7B qapplication);
void Q7B_APPLICATION_ARGUMENTS(Q7B qapplication, Q7B v);
Q7B Q7B_APPLICATION_ARGUMENTS(Q7B qapplication);
void Q7B_APPLICATION_APPLICATIONNAME(Q7B qapplication, Q7B v);
Q7B Q7B_APPLICATION_APPLICATIONNAME(Q7B qapplication);
void Q7B_APPLICATION_APPLICATIONVERSION(Q7B qapplication, Q7B v);
Q7B Q7B_APPLICATION_APPLICATIONVERSION(Q7B qapplication);
void Q7B_APPLICATION_ORGANIZATIONDOMAIN(Q7B qapplication, Q7B v);
Q7B Q7B_APPLICATION_ORGANIZATIONDOMAIN(Q7B qapplication);
void Q7B_APPLICATION_ORGANIZATIONNAME(Q7B qapplication, Q7B v);
Q7B Q7B_APPLICATION_ORGANIZATIONNAME(Q7B qapplication);
void Q7B_APPLICATION_QUIT(Q7B qapplication);
void Q7B_APPLICATION_CURSORSETWAIT(Q7B qapplication);
void Q7B_APPLICATION_CURSORUNSETWAIT(Q7B qapplication);
Q7B Q7B_APPLICATION_CLIPBOARDTEXT(Q7B qapplication);
Q7B Q7B_APPLICATION_QTVERSION(Q7B qapplication);
Q7B Q7B_APPLICATION_OPERATINGSYSTEMNAME(Q7B qapplication);
void Q7B_APPLICATION_SETDEFAULTWINDOWICON(Q7B qapplication, Q7B Icon);
void Q7B_APPLICATION_CLOSEALLWINDOWS(Q7B qapplication);
Q7B Q7B_APPLICATION_ISRIGHTTOLEFTLAYOUTDIRECTION(Q7B qapplication);
Q7B Q7B_APPLICATION_FOCUSWINDOW(Q7B qapplication);
Q7B Q7B_APPLICATION_FOCUS(Q7B qapplication);
Q7B Q7B_APPLICATION_AVAILABLEMIMETYPES(Q7B qapplication);
Q7B Q7B_APPLICATION_AVAILABLELANGUAGES(Q7B qapplication);
void Q7B_APPLICATION_ABOUTQT(Q7B qapplication);
void Q7B_APPLICATION_SETQUITONLASTWINDOWCLOSED(Q7B qapplication, Q7B Quit);
void Q7B_APPLICATION_SETSTYLE(Q7B qapplication, Q7B Quit);
void Q7B_APPLICATION_SETSTYLESHEET(Q7B qapplication, Q7B Quit);
void Q7B_APPLICATION_SETRIGHTTOLEFTLAYOUTDIRECTION(Q7B qapplication, Q7B Quit);
Q7B Q7B_APPLICATION_LOADPROJECTFILEASSTRING(Q7B qapplication, Q7B FileName);
Q7B Q7B_APPLICATION_LOADPROJECTFILEASDATA(Q7B qapplication, Q7B FileName);
Q7B Q7B_APPLICATION_LOADURLASSTRING(Q7B qapplication, Q7B FileName);
Q7B Q7B_APPLICATION_LOADURLASDATA(Q7B qapplication, Q7B FileName);
void Q7B_APPLICATION_SETCLIPBOARDTEXT(Q7B qapplication, Q7B Text);
Q7B Q7B_APPLICATION_ISMIMETYPEAVAILABLE(Q7B qapplication, Q7B MimeTyp);
void Q7B_APPLICATION_SETLANGUAGE(Q7B qapplication, Q7B Language);
void Q7B_APPLICATION_SETCOUNTRY(Q7B qapplication, Q7B Language);
Q7B Q7B_APPLICATION_TAKESCREENSHOT(Q7B qapplication);
Q7B Q7B_APPLICATION_STANDARDOPERATINGSYSTEMICON(Q7B qapplication);
Q7B Q7B_APPLICATION_AVAILABLEFONTNAMES(Q7B qapplication);
void Q7B_APPLICATION_PRINTHTML(Q7B qapplication, Q7B Html);
void Q7B_APPLICATION_WRITEHTMLASPDF(Q7B qapplication, Q7B Html, Q7B PDFFilePath);
Q7B Q7B_APPLICATION_DOWNLOADURLASFILE(Q7B qapplication, Q7B URL, Q7B DestinationPath);
void Q7B_APPLICATION_ALERT(Q7B qapplication, Q7B Widget, Q7B MSec);
Q7B Q7B_APPLICATION_WIDGETAT(Q7B qapplication, Q7B X, Q7B Y);
Q7B Q7B_QBUTTONGROUP_INIT(QObject *parent, const char *objectName);
void Q7B_QBUTTONGROUP_EXCLUSIVE(Q7B qbuttongroup, Q7B v);
Q7B Q7B_QBUTTONGROUP_EXCLUSIVE(Q7B qbuttongroup);
void Q7B_QBUTTONGROUP_ADDBUTTON(Q7B qbuttongroup, Q7B v);
void Q7B_QABSTRACTBUTTON_TEXT(Q7B qabstractbutton, Q7B v);
Q7B Q7B_QABSTRACTBUTTON_TEXT(Q7B qabstractbutton);
void Q7B_COMMANDBUTTON_CAPTION(Q7B qabstractbutton, Q7B v);
Q7B Q7B_COMMANDBUTTON_CAPTION(Q7B qabstractbutton);
void Q7B_QABSTRACTBUTTON_ICON(Q7B qabstractbutton, Q7B v);
Q7B Q7B_QABSTRACTBUTTON_ICON(Q7B qabstractbutton);
void Q7B_QABSTRACTBUTTON_CHECKED(Q7B qabstractbutton, Q7B v);
Q7B Q7B_QABSTRACTBUTTON_CHECKED(Q7B qabstractbutton);
void Q7B_QABSTRACTBUTTON_CHECKABLE(Q7B qabstractbutton, Q7B v);
Q7B Q7B_QABSTRACTBUTTON_CHECKABLE(Q7B qabstractbutton);
void Q7B_QABSTRACTBUTTON_KEY(Q7B qabstractbutton, Q7B v);
Q7B Q7B_QABSTRACTBUTTON_KEY(Q7B qabstractbutton);
Q7B Q7B_QDECLARATIVEVIEW_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QDIAL_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QFONTCOMBOBOX_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QFRAME_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QTOOLBOX_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QSCROLLAREA_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QGROUPBOX_INIT(QObject *parent, const char *objectName);
void Q7B_QGROUPBOX_TEXT(Q7B qgroupbox, Q7B v);
Q7B Q7B_QGROUPBOX_TEXT(Q7B qgroupbox);
void Q7B_QGROUPBOX_CAPTION(Q7B qgroupbox, Q7B v);
Q7B Q7B_QGROUPBOX_CAPTION(Q7B qgroupbox);
Q7B Q7B_QLCDNUMBER_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QCALENDARWIDGET_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QGRAPHICSVIEW_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QTABLEWIDGET_INIT(QObject *parent, const char *objectName);
void Q7B_QTABLEWIDGET_CLEARCONTENTS(Q7B qtablewidget);
void Q7B_QTABLEWIDGET_SETHORIZONTALHEADERAUTORESIZE(Q7B qtablewidget);
void Q7B_QTABLEWIDGET_ROWCOUNT(Q7B qtablewidget, Q7B v);
Q7B Q7B_QTABLEWIDGET_ROWCOUNT(Q7B qtablewidget);
void Q7B_QTABLEWIDGET_COLUMNCOUNT(Q7B qtablewidget, Q7B v);
Q7B Q7B_QTABLEWIDGET_COLUMNCOUNT(Q7B qtablewidget);
Q7B Q7B_QTABLEWIDGET_CURRENTROW(Q7B qtablewidget);
void Q7B_QTABLEWIDGET_SORTITEMS(Q7B qtablewidget, Q7B Column);
void Q7B_QTABLEWIDGET_REMOVEROW(Q7B qtablewidget, Q7B Row);
Q7B Q7B_QTABLEWIDGET_ITEMTEXT(Q7B qtablewidget, Q7B Row, Q7B Column);
void Q7B_QTABLEWIDGET_SETCURRENTCELL(Q7B qtablewidget, Q7B Row, Q7B Column);
void Q7B_QTABLEWIDGET_SETITEMFONTBOLD(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B Yes);
void Q7B_QTABLEWIDGET_SETITEMTEXT(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B Text);
void Q7B_QTABLEWIDGET_SETITEMSTEXT(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B aList);
Q7B Q7B_QTABLEWIDGET_ITEMSELECTED(Q7B qtablewidget, Q7B Row, Q7B Column);
void Q7B_QTABLEWIDGET_SETITEMSELECTED(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B Yes);
Q7B Q7B_QTABLEWIDGET_FINDITEMINCOLUMN(Q7B qtablewidget, Q7B Text, Q7B Column, Q7B StartRow, Q7B MatchFlags);
Q7B Q7B_QTABLEWIDGET_FINDITEMINROW(Q7B qtablewidget, Q7B Text, Q7B Row, Q7B StartColumn, Q7B MatchFlags);
Q7B Q7B_QTABLEWIDGET_ITEMCHECKSTATE(Q7B qtablewidget, Q7B Row, Q7B Column);
void Q7B_QTABLEWIDGET_SETITEMCHECKSTATE(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B CheckState);
void Q7B_QTABLEWIDGET_SETITEMFLAGS(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B Flags);
Q7B Q7B_QCOLUMNVIEW_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QTABLEVIEW_INIT(QObject *parent, const char *objectName);
void Q7B_QTABLEVIEW_SETCOLUMNWIDTH(Q7B qtableview, Q7B Column, Q7B Width);
Q7B Q7B_QTREEVIEW_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QLISTVIEW_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QDIALOGBUTTONBOX_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QVBOXLAYOUT_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QHBOXLAYOUT_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QGRIDLAYOUT_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QFORMLAYOUT_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QWEBVIEW_INIT(QObject *parent, const char *objectName);
void Q7B_QWEBVIEW_LOAD(Q7B qwebview, Q7B URL);
void Q7B_QWEBVIEW_SETHTML(Q7B qwebview, Q7B URL);
Q7B Q7B_QDIALOG_INIT(QObject *parent, const char *objectName);
void Q7B_QDIALOG_ACCEPT(Q7B qdialog);
void Q7B_QDIALOG_REJECT(Q7B qdialog);
void Q7B_QTOOLBOX_CURRENTINDEX(Q7B qtoolbox, Q7B v);
Q7B Q7B_QTOOLBOX_CURRENTINDEX(Q7B qtoolbox);
Q7B Q7B_QTABWIDGET_INIT(QObject *parent, const char *objectName);
void Q7B_QTABWIDGET_CURRENTINDEX(Q7B qtabwidget, Q7B v);
Q7B Q7B_QTABWIDGET_CURRENTINDEX(Q7B qtabwidget);
Q7B Q7B_QTABWIDGET_COUNT(Q7B qtabwidget);
Q7B Q7B_QTABWIDGET_WIDGET(Q7B qtabwidget, Q7B Index);
Q7B Q7B_QSTACKEDWIDGET_INIT(QObject *parent, const char *objectName);
void Q7B_QSTACKEDWIDGET_CURRENTINDEX(Q7B qstackedwidget, Q7B v);
Q7B Q7B_QSTACKEDWIDGET_CURRENTINDEX(Q7B qstackedwidget);
Q7B Q7B_QMAINWINDOW_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QCOMMANDLINKBUTTON_INIT(QObject *parent, const char *objectName);
void Q7B_QCOMMANDLINKBUTTON_DESCRIPTION(Q7B qcommandlinkbutton, Q7B v);
Q7B Q7B_QCOMMANDLINKBUTTON_DESCRIPTION(Q7B qcommandlinkbutton);
Q7B Q7B_QCHECKBOX_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QRADIOBUTTON_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QPUSHBUTTON_INIT(QObject *parent, const char *objectName);
void Q7B_QPUSHBUTTON_MENU(Q7B qpushbutton, Q7B v);
Q7B Q7B_QPUSHBUTTON_MENU(Q7B qpushbutton);
void Q7B_QPUSHBUTTON_AUTODEFAULT(Q7B qpushbutton, Q7B v);
Q7B Q7B_QPUSHBUTTON_AUTODEFAULT(Q7B qpushbutton);
void Q7B_QPUSHBUTTON_DEFAULT(Q7B qpushbutton, Q7B v);
Q7B Q7B_QPUSHBUTTON_DEFAULT(Q7B qpushbutton);
void Q7B_QPUSHBUTTON_FLAT(Q7B qpushbutton, Q7B v);
Q7B Q7B_QPUSHBUTTON_FLAT(Q7B qpushbutton);
Q7B Q7B_QOBJECT_INIT(QObject *parent, const char *objectName);
void Q7B_QOBJECT_OBJECTNAME(Q7B qobject, Q7B v);
Q7B Q7B_QOBJECT_OBJECTNAME(Q7B qobject);
Q7B Q7B_QOBJECT_SENDER(Q7B qobject);
Q7B Q7B_QOBJECT_CHILD(Q7B qobject, Q7B Q7B_ObjectName);
Q7B Q7B_QOBJECT_CHILDREN(Q7B qobject);
Q7B Q7B_Variant2id(QVariant v, bool bSQL, bool bSQLQByteArrayEncodeBase64);
QVariant Q7B_id2Variant(Q7B Q7B_Object, bool bSQL, bool bSQLQByteArrayEncodeBase64);
void Q7B_PROPERTY(Q7B qobject, QString sPropertyName, Q7B Q7B_Object);
Q7B Q7B_PROPERTY(Q7B qobject, QString sPropertyName);
void Q7B_LIST_REMOVEALL(Q7B aList);
Q7B Q7B_LIST_LENGTH(Q7B aList);
Q7B Q7B_LIST_OBJECT(Q7B aList, Q7B Index);
void Q7B_LIST_INSERT(Q7B aList, Q7B Index, Q7B Q7B_Object);
void Q7B_LIST_SETOBJECT(Q7B aList, Q7B Index, Q7B Q7B_Object);
void Q7B_LIST_REMOVE(Q7B aList, Q7B Index);
void Q7B_LIST_APPEND(Q7B aList, Q7B Q7B_Object);
Q7B Q7B_DICTIONARY_LENGTH(Q7B aDictionary);
void Q7B_DICTIONARY_REMOVEALL(Q7B aDictionary);
Q7B Q7B_DICTIONARY_KEYS(Q7B aDictionary);
Q7B Q7B_DICTIONARY_VALUES(Q7B aDictionary);
void Q7B_DICTIONARY_REMOVE(Q7B aDictionary, Q7B Key);
Q7B Q7B_DICTIONARY_CONTAINS(Q7B aDictionary, Q7B Key);
Q7B Q7B_DICTIONARY_OBJECT(Q7B aDictionary, Q7B Key);
void Q7B_DICTIONARY_SETOBJECT(Q7B aDictionary, Q7B Key, Q7B Value);
Q7B Q7B_QWIDGET_INIT(QObject *parent, const char *objectName);
void Q7B_QWIDGET_SHOWMAXIMIZED(Q7B qwidget);
void Q7B_QWIDGET_SHOWFULLSCREEN(Q7B qwidget);
void Q7B_QWIDGET_SHOWMINIMIZED(Q7B qwidget);
void Q7B_QWIDGET_TOGGLEVISIBLE(Q7B qwidget);
void Q7B_QWIDGET_SETATTRIBUTE(Q7B qwidget, Q7B Attribute, Q7B On);
void Q7B_QWIDGET_SHOWNORMAL(Q7B qwidget);
void Q7B_QWIDGET_SHOW(Q7B qwidget);
void Q7B_QWIDGET_HIDE(Q7B qwidget);
void Q7B_QWIDGET_ENABLED(Q7B qwidget, Q7B v);
Q7B Q7B_QWIDGET_ACTIONS(Q7B qwidget);
Q7B Q7B_QWIDGET_ENABLED(Q7B qwidget);
void Q7B_QWIDGET_VISIBLE(Q7B qwidget, Q7B v);
Q7B Q7B_QWIDGET_VISIBLE(Q7B qwidget);
void Q7B_QWIDGET_MINIMUMWIDTH(Q7B qwidget, Q7B v);
Q7B Q7B_QWIDGET_MINIMUMWIDTH(Q7B qwidget);
void Q7B_QWIDGET_MAXIMUMWIDTH(Q7B qwidget, Q7B v);
Q7B Q7B_QWIDGET_MAXIMUMWIDTH(Q7B qwidget);
void Q7B_QWIDGET_WINDOWTITLE(Q7B qwidget, Q7B v);
Q7B Q7B_QWIDGET_WINDOWTITLE(Q7B qwidget);
void Q7B_QWIDGET_WINDOWICON(Q7B qwidget, Q7B v);
Q7B Q7B_QWIDGET_WINDOWICON(Q7B qwidget);
void Q7B_QWIDGET_WINDOWFLAGS(Q7B qwidget, Q7B v);
Q7B Q7B_QWIDGET_WINDOWFLAGS(Q7B qwidget);
void Q7B_QWIDGET_CONTEXTMENUPOLICY(Q7B qwidget, Q7B v);
Q7B Q7B_QWIDGET_CONTEXTMENUPOLICY(Q7B qwidget);
Q7B Q7B_QICON_INIT(Q7B v);
Q7B Q7B_QDOUBLESPINBOX_INIT(QObject *parent, const char *objectName);
void Q7B_QDOUBLESPINBOX_MINIMUM(Q7B qdoublespinbox, Q7B Value);
Q7B Q7B_QDOUBLESPINBOX_MINIMUM(Q7B qdoublespinbox);
void Q7B_QDOUBLESPINBOX_MAXIMUM(Q7B qdoublespinbox, Q7B Value);
Q7B Q7B_QDOUBLESPINBOX_MAXIMUM(Q7B qdoublespinbox);
void Q7B_QDOUBLESPINBOX_VALUE(Q7B qdoublespinbox, Q7B Value);
Q7B Q7B_QDOUBLESPINBOX_VALUE(Q7B qdoublespinbox);
Q7B Q7B_QTEXTBROWSER_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QSLIDER_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QSCROLLBAR_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QDATETIMEEDIT_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QDATEEDIT_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QTIMEEDIT_INIT(QObject *parent, const char *objectName);
Q7B Q7B_PHONONVOLUMESLIDER_INIT(QObject *parent, const char *objectName);
Q7B Q7B_PHONONSEEKSLIDER_INIT(QObject *parent, const char *objectName);
Q7B Q7B_PHONONVIDEOPLAYER_INIT(QObject *parent, const char *objectName);
void Q7B_PHONONVIDEOPLAYER_PLAY(Q7B phononvideoplayer, Q7B Value);
Q7B Q7B_QSPINBOX_INIT(QObject *parent, const char *objectName);
void Q7B_QSPINBOX_MINIMUM(Q7B qspinbox, Q7B Value);
Q7B Q7B_QSPINBOX_MINIMUM(Q7B qspinbox);
void Q7B_QSPINBOX_MAXIMUM(Q7B qspinbox, Q7B Value);
Q7B Q7B_QSPINBOX_MAXIMUM(Q7B qspinbox);
void Q7B_QSPINBOX_VALUE(Q7B qspinbox, Q7B Value);
Q7B Q7B_QSPINBOX_VALUE(Q7B qspinbox);
Q7B Q7B_QPROGRESSBAR_INIT(QObject *parent, const char *objectName);
void Q7B_QPROGRESSBAR_MINIMUM(Q7B qprogressbar, Q7B Value);
Q7B Q7B_QPROGRESSBAR_MINIMUM(Q7B qprogressbar);
void Q7B_QPROGRESSBAR_MAXIMUM(Q7B qprogressbar, Q7B Value);
Q7B Q7B_QPROGRESSBAR_MAXIMUM(Q7B qprogressbar);
void Q7B_QPROGRESSBAR_VALUE(Q7B qprogressbar, Q7B Value);
Q7B Q7B_QPROGRESSBAR_VALUE(Q7B qprogressbar);
void Q7B_QPROGRESSBAR_TEXTVISIBLE(Q7B qprogressbar, Q7B v);
Q7B Q7B_QPROGRESSBAR_TEXTVISIBLE(Q7B qprogressbar);
Q7B Q7B_QMDIAREA_INIT(QObject *parent, const char *objectName);
void Q7B_QMDIAREA_ADDSUBWINDOW(Q7B qmdiarea, Q7B Widget);
void Q7B_QMDIAREA_VIEWMODE(Q7B qmdiarea, Q7B Value);
Q7B Q7B_QMDIAREA_VIEWMODE(Q7B qmdiarea);
Q7B Q7B__QMENUBAR_INIT(QObject *parent, const char *objectName);
Q7B Q7B__QTOOLBAR_INIT(QObject *parent, const char *objectName);
Q7B Q7B__QSTATUSBAR_INIT(QObject *parent, const char *objectName);
Q7B Q7B__QMENU_INIT(QObject *parent, const char *objectName, Q7B v);
Q7B Q7B_QMENU_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QMENU_ADDACTION(Q7B qmenu, Q7B Text);
void Q7B_QMENU_ADDACTION2(Q7B qmenu, Q7B theAction);
Q7B Q7B_QMENU_ADDMENU(Q7B qmenu, Q7B Text);
Q7B Q7B_QMENU_ADDSEPARATOR(Q7B qmenu);
void Q7B_QMENU_CLEAR(Q7B qmenu);
Q7B Q7B_QLABEL_INIT(QObject *parent, const char *objectName) ;
void Q7B_QLABEL_TEXT(Q7B qlabel, Q7B Value);
Q7B Q7B_QLABEL_TEXT(Q7B qlabel);
void Q7B_QLABEL_OPENEXTERNALLINKS(Q7B qlabel, Q7B Value);
Q7B Q7B_QLABEL_OPENEXTERNALLINKS(Q7B qlabel);
void Q7B_QLABEL_WORDWRAP(Q7B qlabel, Q7B Value);
Q7B Q7B_QLABEL_WORDWRAP(Q7B qlabel);
void Q7B_QLABEL_SCALEDCONTENTS(Q7B qlabel, Q7B Value);
Q7B Q7B_QLABEL_SCALEDCONTENTS(Q7B qlabel);
void Q7B_QLABEL_ALIGNMENT(Q7B qlabel, Q7B Value);
Q7B Q7B_QLABEL_ALIGNMENT(Q7B qlabel);
void Q7B_QLABEL_TEXTINTERACTIONFLAGS(Q7B qlabel, Q7B Value);
Q7B Q7B_QLABEL_TEXTINTERACTIONFLAGS(Q7B qlabel);
Q7B Q7B_QLINEEDIT_INIT(QObject *parent, const char *objectName);
void Q7B_QLINEEDIT_ALIGNMENT(Q7B qlineedit, Q7B Value);
Q7B Q7B_QLINEEDIT_ALIGNMENT(Q7B qlineedit);
void Q7B_QLINEEDIT_ECHOMODE(Q7B qlineedit, Q7B Value);
Q7B Q7B_QLINEEDIT_ECHOMODE(Q7B qlineedit);
void Q7B_QLINEEDIT_INPUTMASK(Q7B qlineedit, Q7B Value);
Q7B Q7B_QLINEEDIT_INPUTMASK(Q7B qlineedit);
void Q7B_QLINEEDIT_READONLY(Q7B qlineedit, Q7B Value);
Q7B Q7B_QLINEEDIT_READONLY(Q7B qlineedit);
void Q7B_QLINEEDIT_VALIDATORFLOAT(Q7B qlineedit, Q7B Value);
Q7B Q7B_QLINEEDIT_VALIDATORFLOAT(Q7B qlineedit);
void Q7B_QLINEEDIT_VALIDATORINTEGER(Q7B qlineedit, Q7B Value);
Q7B Q7B_QLINEEDIT_VALIDATORINTEGER(Q7B qlineedit);
void Q7B_QLINEEDIT_MAXIMUM(Q7B qlineedit, Q7B Value);
Q7B Q7B_QLINEEDIT_MAXIMUM(Q7B qlineedit);
void Q7B_QLINEEDIT_COMPLETER(Q7B qlineedit, Q7B Value);
Q7B Q7B_QLINEEDIT_COMPLETER(Q7B qlineedit);
void Q7B_QLINEEDIT_TEXT(Q7B qlineedit, Q7B Value);
Q7B Q7B_QLINEEDIT_TEXT(Q7B qlineedit);
Q7B Q7B_QLINEEDIT_ISVALID(Q7B qlineedit);
void Q7B_QLINEEDIT_SELECTALL(Q7B qlineedit);
Q7B Q7B_QTEXTEDIT_INIT(QObject *parent, const char *objectName);
void Q7B_QTEXTEDIT_HTML(Q7B qtextedit, Q7B Value);
Q7B Q7B_QTEXTEDIT_HTML(Q7B qtextedit);
Q7B Q7B_QPLAINTEXTEDIT_INIT(QObject *parent, const char *objectName);
void Q7B_QPLAINTEXTEDIT_PLAINTEXT(Q7B qplaintextedit, Q7B Value);
Q7B Q7B_QPLAINTEXTEDIT_PLAINTEXT(Q7B qplaintextedit);
void Q7B_QPLAINTEXTEDIT_READONLY(Q7B qplaintextedit, Q7B v);
Q7B Q7B_QPLAINTEXTEDIT_READONLY(Q7B qplaintextedit);
void Q7B_QPLAINTEXTEDIT_APPENDPLAINTEXT(Q7B qplaintextedit, Q7B v);
Q7B Q7B_QCOMBOBOX_INIT(QObject *parent, const char *objectName);
void Q7B_QCOMBOBOX_REMOVEALL(Q7B qcombobox);
void Q7B_QCOMBOBOX_SETNOCOMPLETER(Q7B qcombobox);
Q7B Q7B_QCOMBOBOX_TEXT(Q7B qcombobox);
void Q7B_QCOMBOBOX_APPEND(Q7B qcombobox, Q7B v);
Q7B Q7B_QCOMBOBOX_OBJECT(Q7B qcombobox, Q7B v);
void Q7B_QCOMBOBOX_CURRENTINDEX(Q7B qcombobox, Q7B v);
Q7B Q7B_QCOMBOBOX_LENGTH(Q7B qcombobox);
Q7B Q7B_QCOMBOBOX_CURRENTINDEX(Q7B qcombobox);
void Q7B_QCOMBOBOX_APPEND2(Q7B qcombobox, Q7B Icon, Q7B Text);
Q7B Q7B_QTREEWIDGET_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QTREEWIDGET_COLUMNCOUNT(Q7B qtreewidget);
Q7B Q7B_QTREEWIDGET_CURRENTCOLUMN(Q7B qtreewidget);
Q7B Q7B_QTREEWIDGET_CURRENTITEM(Q7B qtreewidget);
Q7B Q7B_QTREEWIDGET_HEADERITEM(Q7B qtreewidget);
Q7B Q7B_QTREEWIDGET_INVISIBLEROOTITEM(Q7B qtreewidget);
Q7B Q7B_QTREEWIDGET_SELECTEDITEMS(Q7B qtreewidget);
Q7B Q7B_QTREEWIDGET_SORTCOLUMN(Q7B qtreewidget);
Q7B Q7B_QTREEWIDGET_TOPLEVELITEMCOUNT(Q7B qtreewidget);
void Q7B_QTREEWIDGET_COLLAPSEALL(Q7B qtreewidget);
void Q7B_QTREEWIDGET_EXPANDALL(Q7B qtreewidget);
void Q7B_QTREEWIDGET_SELECTALL(Q7B qtreewidget);
void Q7B_QTREEWIDGET_SCROLLTOBOTTOM(Q7B qtreewidget);
void Q7B_QTREEWIDGET_SCROLLTOTOP(Q7B qtreewidget);
Q7B Q7B_QTREEWIDGET_APPENDCHILD(Q7B qtreewidget, Q7B Text);
Q7B Q7B_QTREEWIDGET_CHILDCOUNT(Q7B qtreewidget, Q7B ItemId);
Q7B Q7B_QTREEWIDGET_ISEXPANDED(Q7B qtreewidget, Q7B ItemId);
Q7B Q7B_QTREEWIDGET_ISHIDDEN(Q7B qtreewidget, Q7B ItemId);
Q7B Q7B_QTREEWIDGET_ISSELECTED(Q7B qtreewidget, Q7B ItemId);
Q7B Q7B_QTREEWIDGET_COLUMNCOUNT(Q7B qtreewidget, Q7B ItemId);
Q7B Q7B_QTREEWIDGET_APPEND(Q7B qtreewidget, Q7B Text);
Q7B Q7B_QTREEWIDGET_INDEXOFTOPLEVELITEM(Q7B qtreewidget, Q7B ItemId);
void Q7B_QTREEWIDGET_SETCOLUMNCOUNT(Q7B qtreewidget, Q7B Count);
void Q7B_QTREEWIDGET_SETCURRENTITEM(Q7B qtreewidget, Q7B ItemId);
void Q7B_QTREEWIDGET_SETHEADERLABEL(Q7B qtreewidget, Q7B Text);
void Q7B_QTREEWIDGET_REMOVETOPLEVELITEM(Q7B qtreewidget, Q7B Index);
Q7B Q7B_QTREEWIDGET_TOPLEVELITEM(Q7B qtreewidget, Q7B Index);
Q7B Q7B_QTREEWIDGET_ISCOLUMNHIDDEN(Q7B qtreewidget, Q7B Column);
Q7B Q7B_QTREEWIDGET_COLUMNWIDTH(Q7B qtreewidget, Q7B Column);
void Q7B_QTREEWIDGET_SHOWCOLUMN(Q7B qtreewidget, Q7B Column);
void Q7B_QTREEWIDGET_COLLAPSEITEM(Q7B qtreewidget, Q7B ItemId);
void Q7B_QTREEWIDGET_EXPANDITEM(Q7B qtreewidget, Q7B ItemId);
void Q7B_QTREEWIDGET_SCROLLTOITEM(Q7B qtreewidget, Q7B ItemId);
Q7B Q7B_QTREEWIDGET_FLAGS(Q7B qtreewidget, Q7B ItemId);
Q7B Q7B_QTREEWIDGET_APPENDCHILD2(Q7B qtreewidget, Q7B Icon, Q7B Text);
Q7B Q7B_QTREEWIDGET_APPENDCHILDTOID(Q7B qtreewidget, Q7B ItemId, Q7B Text);
Q7B Q7B_QTREEWIDGET_CHILD(Q7B qtreewidget, Q7B ItemId, Q7B Index);
Q7B Q7B_QTREEWIDGET_CHECKSTATE(Q7B qtreewidget, Q7B ItemId, Q7B Column);
Q7B Q7B_QTREEWIDGET_DATA(Q7B qtreewidget, Q7B ItemId, Q7B Column);
void Q7B_QTREEWIDGET_SETFLAGS(Q7B qtreewidget, Q7B ItemId, Q7B Flags);
Q7B Q7B_QTREEWIDGET_TEXT(Q7B qtreewidget, Q7B ItemId, Q7B Column);
Q7B Q7B_QTREEWIDGET_ICON(Q7B qtreewidget, Q7B ItemId, Q7B Column);
Q7B Q7B_QTREEWIDGET_INDEXOFCHILD(Q7B qtreewidget, Q7B ItemId, Q7B ChildId);
void Q7B_QTREEWIDGET_SETDISABLED(Q7B qtreewidget, Q7B ItemId, Q7B IsDisabled);
void Q7B_QTREEWIDGET_SETEXPANDED(Q7B qtreewidget, Q7B ItemId, Q7B IsExpanded);
void Q7B_QTREEWIDGET_SETHIDDEN(Q7B qtreewidget, Q7B ItemId, Q7B IsHidden);
void Q7B_QTREEWIDGET_SETSELECTED(Q7B qtreewidget, Q7B ItemId, Q7B IsSelected);
Q7B Q7B_QTREEWIDGET_STATUSTIP(Q7B qtreewidget, Q7B ItemId, Q7B Column);
Q7B Q7B_QTREEWIDGET_WHATSTHIS(Q7B qtreewidget, Q7B ItemId, Q7B Column);
Q7B Q7B_QTREEWIDGET_TOOLTIP(Q7B qtreewidget, Q7B ItemId, Q7B Column);
void Q7B_QTREEWIDGET_REMOVECHILD(Q7B qtreewidget, Q7B ItemId, Q7B Index);
Q7B Q7B_QTREEWIDGET_TEXTALIGNMENT(Q7B qtreewidget, Q7B ItemId, Q7B Column);
Q7B Q7B_QTREEWIDGET_APPEND2(Q7B qtreewidget, Q7B Icon, Q7B Text);
Q7B Q7B_QTREEWIDGET_INSERT2(Q7B qtreewidget, Q7B Index, Q7B Text);
Q7B Q7B_QTREEWIDGET_ITEMAT(Q7B qtreewidget, Q7B X, Q7B Y);
void Q7B_QTREEWIDGET_SETCURRENTITEM2(Q7B qtreewidget, Q7B ItemId, Q7B Column);
void Q7B_QTREEWIDGET_SETHEADERLABEL2(Q7B qtreewidget, Q7B Column, Q7B Text);
void Q7B_QTREEWIDGET_SORTITEMS(Q7B qtreewidget, Q7B Column, Q7B Descending);
void Q7B_QTREEWIDGET_SETCOLUMNHIDDEN(Q7B qtreewidget, Q7B Column, Q7B IsColumnHidden);
void Q7B_QTREEWIDGET_SETCOLUMNWIDTH(Q7B qtreewidget, Q7B Column, Q7B Width);
void Q7B_QTREEWIDGET_CLOSEPERSISTENTEDITOR(Q7B qtreewidget, Q7B ItemId, Q7B Column);
void Q7B_QTREEWIDGET_OPENPERSISTENTEDITOR(Q7B qtreewidget, Q7B ItemId, Q7B Column);
void Q7B_QTREEWIDGET_EDITITEM(Q7B qtreewidget, Q7B ItemId, Q7B Column);
Q7B Q7B_QTREEWIDGET_APPENDCHILDTOID2(Q7B qtreewidget, Q7B ItemId, Q7B Icon, Q7B Text);
void Q7B_QTREEWIDGET_SETCHECKSTATE(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B CheckState);
void Q7B_QTREEWIDGET_SETTEXT(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B Text);
void Q7B_QTREEWIDGET_SETICON(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B Icon);
Q7B Q7B_QTREEWIDGET_INSERTCHILD(Q7B qtreewidget, Q7B ItemId, Q7B Index, Q7B Text);
Q7B Q7B_QTREEWIDGET_INSERTCHILD2(Q7B qtreewidget, Q7B ItemId, Q7B Index, Q7B Icon, Q7B Text);
void Q7B_QTREEWIDGET_SETSTATUSTIP(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B StatusTip);
void Q7B_QTREEWIDGET_SETWHATSTHIS(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B WhatsThis);
void Q7B_QTREEWIDGET_SETTOOLTIP(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B ToolTip);
void Q7B_QTREEWIDGET_SETTEXTALIGNMENT(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B TextAlignment);
Q7B Q7B_QTREEWIDGET_INSERT3(Q7B qtreewidget, Q7B Index, Q7B Icon, Q7B Text);
Q7B Q7B_QDOCKWIDGET_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QDOCKWIDGET_WIDGET(Q7B qdockwidget);
Q7B Q7B_QLISTWIDGET_INIT(QObject *parent, const char *objectName);
Q7B Q7B_QLISTWIDGET_LENGTH(Q7B qlistwidget);
void Q7B_QLISTWIDGET_REMOVEALL(Q7B qlistwidget);
Q7B Q7B_QLISTWIDGET_SELECTED(Q7B qlistwidget);
Q7B Q7B_QLISTWIDGET_SELECTEDTEXT(Q7B qlistwidget);
void Q7B_QLISTWIDGET_SORT(Q7B qlistwidget, Q7B Descending);
void Q7B_QLISTWIDGET_APPEND(Q7B qlistwidget, Q7B Text);
void Q7B_QLISTWIDGET_REMOVE(Q7B qlistwidget, Q7B Index);
void Q7B_QLISTWIDGET_SELECT(Q7B qlistwidget, Q7B Index);
void Q7B_QLISTWIDGET_SELECTTEXT(Q7B qlistwidget, Q7B Text);
Q7B Q7B_QLISTWIDGET_TEXT(Q7B qlistwidget, Q7B Index);
Q7B Q7B_QLISTWIDGET_DATA(Q7B qlistwidget, Q7B Index);
Q7B Q7B_QLISTWIDGET_ICON(Q7B qlistwidget, Q7B Index);
Q7B Q7B_QLISTWIDGET_CHECKSTATE(Q7B qlistwidget, Q7B Index);
Q7B Q7B_QLISTWIDGET_FLAGS(Q7B qlistwidget, Q7B Index);
Q7B Q7B_QLISTWIDGET_ISHIDDEN(Q7B qlistwidget, Q7B Index);
Q7B Q7B_QLISTWIDGET_ISSELECTED(Q7B qlistwidget, Q7B Index);
Q7B Q7B_QLISTWIDGET_STATUSTIP(Q7B qlistwidget, Q7B Index);
Q7B Q7B_QLISTWIDGET_WHATSTHIS(Q7B qlistwidget, Q7B Index);
Q7B Q7B_QLISTWIDGET_TOOLTIP(Q7B qlistwidget, Q7B Index);
Q7B Q7B_QLISTWIDGET_TEXTALIGNMENT(Q7B qlistwidget, Q7B Index);
void Q7B_QLISTWIDGET_SETTEXT(Q7B qlistwidget, Q7B Index, Q7B Text);
void Q7B_QLISTWIDGET_SETICON(Q7B qlistwidget, Q7B Index, Q7B Icon);
void Q7B_QLISTWIDGET_SETDATA(Q7B qlistwidget, Q7B Index, Q7B d);
void Q7B_QLISTWIDGET_SETCHECKSTATE(Q7B qlistwidget, Q7B Index, Q7B CheckState);
void Q7B_QLISTWIDGET_SETFLAGS(Q7B qlistwidget, Q7B Index, Q7B Flag);
void Q7B_QLISTWIDGET_SETHIDDEN(Q7B qlistwidget, Q7B Index, Q7B IsHidden);
void Q7B_QLISTWIDGET_SETSELECTED(Q7B qlistwidget, Q7B Index, Q7B IsSelected);
void Q7B_QLISTWIDGET_SETSTATUSTIP(Q7B qlistwidget, Q7B Index, Q7B StatusTip);
void Q7B_QLISTWIDGET_SETWHATSTHIS(Q7B qlistwidget, Q7B Index, Q7B WhatsThis);
void Q7B_QLISTWIDGET_SETTOOLTIP(Q7B qlistwidget, Q7B Index, Q7B ToolTip);
void Q7B_QLISTWIDGET_SETTEXTALIGNMENT(Q7B qlistwidget, Q7B Index, Q7B TextAlignment);
void Q7B_QLISTWIDGET_INSERT(Q7B qlistwidget, Q7B Index, Q7B Text);
void Q7B_QLISTWIDGET_APPEND2(Q7B qlistwidget, Q7B Icon, Q7B Text);
void Q7B_QLISTWIDGET_INSERT2(Q7B qlistwidget, Q7B Index, Q7B Icon, Q7B Text);
Q7B Q7B_QTOOLBUTTON_INIT(QObject *parent, const char *objectName);
void Q7B_QTOOLBUTTON_MENU(Q7B qtoolbutton, Q7B v);
Q7B Q7B_QTOOLBUTTON_MENU(Q7B qtoolbutton);
Q7B Q7B_QACTION_INIT(QObject *parent, const char *objectName);
void Q7B_QACTION_TEXT(Q7B qaction, Q7B v);
Q7B Q7B_QACTION_TEXT(Q7B qaction);
void Q7B_QACTION_TAG(Q7B qaction, Q7B v) ;
Q7B Q7B_QACTION_TAG(Q7B qaction);
void Q7B_QACTION_VISIBLE(Q7B qaction, Q7B v);
Q7B Q7B_QACTION_VISIBLE(Q7B qaction);
void Q7B_QACTION_ENABLED(Q7B qaction, Q7B v);
Q7B Q7B_QACTION_ENABLED(Q7B qaction);
void Q7B_QACTION_CHECKABLE(Q7B qaction, Q7B v);
Q7B Q7B_QACTION_CHECKABLE(Q7B qaction);
void Q7B_QACTION_CHECKED(Q7B qaction, Q7B v);
Q7B Q7B_QACTION_CHECKED(Q7B qaction);
void Q7B_QACTION_ICON(Q7B qaction, Q7B v);
Q7B Q7B_QACTION_ICON(Q7B qaction);
Q7B Q7B_ADDDAYS(Q7B Q7B_Object, Q7B Days);
Q7B Q7B_ADDHOURS(Q7B Q7B_Object, Q7B Hours);
Q7B Q7B_ADDMINUTES(Q7B Q7B_Object, Q7B Minutes);
Q7B Q7B_ADDMONTHS(Q7B Q7B_Object, Q7B Months);
Q7B Q7B_ADDSECONDS(Q7B Q7B_Object, Q7B Seconds);
Q7B Q7B_SUBDAYS(Q7B Q7B_Object, Q7B Days);
Q7B Q7B_SUBHOURS(Q7B Q7B_Object, Q7B Hours);
Q7B Q7B_SUBMINUTES(Q7B Q7B_Object, Q7B Minutes);
Q7B Q7B_SUBMONTHS(Q7B Q7B_Object, Q7B Months);
Q7B Q7B_SUBSECONDS(Q7B Q7B_Object, Q7B Seconds);
Q7B Q7B_TIMEVALUE(Q7B Q7B_Object);
Q7B Q7B_TIMESERIAL(Q7B Q7B_Object, Q7B Hour, Q7B Minute, Q7B Second);
Q7B Q7B_DATESERIAL(Q7B Q7B_Object, Q7B Year, Q7B Month, Q7B Day);
Q7B Q7B_FORMATDATETIME(Q7B Q7B_Object, Q7B Format);
Q7B Q7B_DATEVALUE(Q7B Q7B_Object);
Q7B Q7B_DATEPART(Q7B Q7B_Object, Q7B Interval);
Q7B Q7B_DATEDIFF(Q7B Q7B_Object, Q7B dt, Q7B Interval);
Q7B Q7B_DATEADD(Q7B Q7B_Object, Q7B Interval, Q7B Number);
Q7B Q7B_DIFFSECONDS(Q7B Q7B_Object, Q7B dt);
Q7B Q7B_DIFFDAYS(Q7B Q7B_Object, Q7B dt);
Q7B Q7B_WEEKNUMBER(Q7B Q7B_Object);
Q7B Q7B_MONTHNAME(Q7B Q7B_Object, Q7B LongMonthName);
Q7B Q7B_DATETIME_INIT(Q7B Year, Q7B Month, Q7B Day, Q7B Hour, Q7B Minute, Q7B Second, Q7B MSecond);
Q7B Q7B_DAYSINYEAR(Q7B Q7B_Object);
Q7B Q7B_DAYSINMONTH(Q7B Q7B_Object);
Q7B Q7B_DAYOFYEAR(Q7B Q7B_Object);
Q7B Q7B_DAYOFWEEK(Q7B Q7B_Object);
Q7B Q7B_DAYNAME(Q7B Q7B_Object, Q7B LongDayName);
Q7B Q7B_SECOND(Q7B Q7B_Object);
Q7B Q7B_MINUTE(Q7B Q7B_Object);
Q7B Q7B_HOUR(Q7B Q7B_Object);
Q7B Q7B_MONTH(Q7B Q7B_Object);
Q7B Q7B_YEAR(Q7B Q7B_Object);
Q7B Q7B_DAY(Q7B Q7B_Object);
Q7B Q7B_ISLEAPYEAR(Q7B Q7B_Object);
Q7B Q7B_ISDATETIMEVALID(Q7B Q7B_Object);
Q7B Q7B_ISDATEVALID(Q7B Q7B_Object);
Q7B Q7B_ISTIMEVALID(Q7B Q7B_Object);
Q7B Q7B_STRREVERSE(Q7B Q7B_Object);
Q7B Q7B_FILL(Q7B Q7B_Object, Q7B Character, Q7B Size);
Q7B Q7B_INSERT(Q7B Q7B_Object, Q7B Position, Q7B Str);
Q7B Q7B_NZ(Q7B Q7B_Object, Q7B ReturnValue);
void Q7B_MIDASSIGNMENT(Q7B *l, Q7B Position, Q7B Length, Q7B r);
Q7B Q7B_LEFT(Q7B Q7B_Object, Q7B Position);
Q7B Q7B_TRUNCATE(Q7B Q7B_Object, Q7B Position);
Q7B Q7B_SECTION(Q7B Q7B_Object, Q7B Separator, Q7B Start, Q7B End, Q7B SectionFlags);
Q7B Q7B_LEFTJUSTIFIED(Q7B Q7B_Object, Q7B Width, Q7B Fill, Q7B Truncate);
Q7B Q7B_RIGHTJUSTIFIED(Q7B Q7B_Object, Q7B Width, Q7B Fill, Q7B Truncate);
Q7B Q7B_READSTRING(Q7B Q7B_Object, Q7B Encoding);
Q7B Q7B_READCSTRING(Q7B Q7B_Object);
Q7B Q7B_WRITECSTRING(Q7B Q7B_Object, Q7B FilePathOrURL);
Q7B Q7B_WRITESTRING(Q7B Q7B_Object, Q7B FilePathOrURL, Q7B Encoding);
Q7B Q7B_ISEMPTY(Q7B Q7B_Object);
Q7B Q7B_LEN(Q7B Q7B_Object);
Q7B Q7B_LTRIM(Q7B Q7B_Object);
Q7B Q7B_REVERSED(Q7B Q7B_Object);
Q7B Q7B_RTRIM(Q7B Q7B_Object);
Q7B Q7B_FILENAME(Q7B FilePath);
Q7B Q7B_FILEBASENAME(Q7B FilePath);
Q7B Q7B_FILEEXTENSION(Q7B FilePath);
Q7B Q7B_FILEPATH(Q7B FilePath);
Q7B Q7B_STRING(Q7B Q7B_Object);
Q7B Q7B_AT(Q7B Q7B_Object, Q7B Index);
Q7B Q7B_UNICODE(Q7B Q7B_Object, Q7B Index);
Q7B Q7B_MID(Q7B Q7B_Object, Q7B Index, Q7B Length);
Q7B Q7B_RIGHT(Q7B Q7B_Object, Q7B Position);
Q7B Q7B_SPLIT(Q7B Q7B_Object, Q7B Separator, Q7B CaseSensitive);
Q7B Q7B_SPACE(Q7B Q7B_Object, Q7B Count, Q7B FillWith);
Q7B Q7B_JOIN(Q7B Q7B_Object, Q7B Separator);
Q7B Q7B_SIMPLIFIED(Q7B Q7B_Object);
Q7B Q7B_TRIM(Q7B Q7B_Object);
Q7B Q7B_INSTR(Q7B Q7B_Object, Q7B Search, Q7B Index, Q7B CaseSensitive);
Q7B Q7B_INSTRREV(Q7B Q7B_Object, Q7B Search, Q7B Index, Q7B CaseSensitive);
Q7B Q7B_CONTAINS(Q7B Q7B_Object, Q7B Search, Q7B CaseSensitive);
Q7B Q7B_APPEND(Q7B Q7B_Object, Q7B Append);
Q7B Q7B_PREPEND(Q7B Q7B_Object, Q7B Prepend);
Q7B Q7B_LCASE(Q7B Q7B_Object);
Q7B Q7B_UCASE(Q7B Q7B_Object);
Q7B Q7B_COMPARE(Q7B Q7B_Object, Q7B Search, Q7B CaseSensitive);
Q7B Q7B_REPLACE(Q7B Q7B_Object, Q7B Search, Q7B Replace, Q7B CaseSensitive);
Q7B Q7B_REMOVE(Q7B Q7B_Object, Q7B Position, Q7B Length);
Q7B Q7B_COUNT(Q7B Q7B_Object, Q7B Search, Q7B CaseSensitive);
Q7B Q7B_STARTSWITH(Q7B Q7B_Object, Q7B Search, Q7B CaseSensitive);
Q7B Q7B_ENDSWITH(Q7B Q7B_Object, Q7B Search, Q7B CaseSensitive);
Q7B Q7B_CHARACTER(Q7B Unicode);
Q7B Q7B_VALUE(Q7B Str);
Q7B Q7B_BIN(Q7B Number);
Q7B Q7B_HEX(Q7B Number);
Q7B Q7B_FORMAT(Q7B Number, Q7B Locale);
Q7B Q7B_FORMATFLOAT(Q7B Number, Q7B Locale, Q7B DecimalPlaceLength);
Q7B Q7B_FORMATDECIMAL(Q7B Number, Q7B Locale, Q7B DecimalPlaceLength);
QWidget* Q7B_CREATE_FROM_UI_FILE(QString uiName, QWidget *parentWidget);
void Q7B_OPENTEXTWINDOW(Q7B Text);
void Q7B_OPENHTMLWINDOW(Q7B Text);
void Q7B_OPENWEBWINDOW(Q7B Text);
Q7B Q7B_LOADUI(Q7B uiName);
Q7B Q7B_UNLOADUI(Q7B uiWidget);
Q7B Q7B_OPENWINDOW(Q7B uiName);
Q7B Q7B_OPENTOOLWINDOW(Q7B uiName);
Q7B Q7B_OPENDOCKWIDGET(Q7B uiName);
Q7B Q7B_OPENMDI(Q7B uiName) ;
Q7B Q7B_OPENSDI(Q7B uiName);
Q7B Q7B_OPENDIALOG(Q7B uiName);
Q7B Q7B_CLOSEWINDOW(Q7B uiName);
Q7B Q7B_CLOSEMDI(Q7B Widget);
Q7B Q7B_CLOSEALLMDI();
Q7B Q7B_CLOSE(Q7B Widget);
Q7B Q7B_FOCUSWINDOW();
Q7B Q7B_FOCUS();
Q7B Q7B_LISTMDI();
void Q7B_SETFOCUSMDI(Q7B Widget);
Q7B Q7B_FOCUSMDI();
void Q7B_SETFOCUSWINDOW(Q7B Widget);
void Q7B_SETFOCUS(Q7B Widget);
void Q7B_HIDE(Q7B Widget);
void Q7B_SHOW(Q7B Widget);
void Q7B_SHOWNORMAL(Q7B Widget);
void Q7B_SHOWMAXIMIZED(Q7B Widget);
void Q7B_SHOWMINIMIZED(Q7B Widget);
void Q7B_SHOWORHIDE(Q7B Widget);
void Q7B_RANDOMIZE();
Q7B Q7B___RANDOM(bool bExpression, Q7B dValue);
Q7B Q7B__RANDOM();
Q7B Q7B_RANDOM(Q7B dValue);
Q7B Q7B_BITCLR(Q7B Value, Q7B Position);
Q7B Q7B_BITSET(Q7B Value, Q7B Position);
Q7B Q7B_BITTST(Q7B Value, Q7B Position);
Q7B Q7B__MIN(Q7B l, Q7B r);
Q7B Q7B__MAX(Q7B l, Q7B r);
Q7B Q7B_FACT(Q7B m);
Q7B Q7B_ROUND(Q7B l, Q7B r);
void Q7B_STDOUT(Q7B m);
void Q7B_STDERR(Q7B m);
Q7B Q7B_READREGISTRY(Q7B RegistryPath, Q7B RegistryKey);
Q7B Q7B_OPENURL(Q7B PathOrURL);
Q7B Q7B_OPENEMAIL(Q7B SenderEmail, Q7B Subject, Q7B Body);
Q7B Q7B_FLOAT(Q7B Expression, Q7B Locale);
Q7B Q7B_BOOLEAN(Q7B Expression, Q7B Locale);
Q7B Q7B_STRING(Q7B Expression, Q7B Locale);
Q7B Q7B_DECIMAL(Q7B Expression, Q7B Locale);
Q7B Q7B_DATETIME(Q7B Expression, Q7B Locale);
Q7B Q7B_INTEGER(Q7B Expression, Q7B Locale);
void Q7B_WAIT(Q7B MSec);
Q7B Q7B_FREEFILE(Q7B Range);
Q7B Q7B_EOF(Q7B FILEHANDLE);
void Q7B_LINEINPUT(Q7B FILEHANDLE, Q7B *Var);
void Q7B_CLOSEFILE(Q7B FILEHANDLE);
void Q7B_CLOSEALLFILES();
void Q7B_OPEN(Q7B FileName, Q7B Mode, Q7B FILEHANDLE, Q7B Len);
Q7B Q7B_RUN(Q7B FilePath, Q7B Arguments);
Q7B Q7B_LAUNCH(Q7B FilePath, Q7B Arguments, Q7B WorkingDirectory, Q7B Wait);
Q7B Q7B_SHELL(Q7B Command);
QString Q7B_PlaySound(QString sFilePath);
Q7B Q7B_PLAYSOUND(Q7B FileName);
Q7B Q7B_PLAYMOVIE(Q7B FileName);
void Q7B_fromXMLDictionary(QXmlStreamReader * xmlReader, Q7B_Dictionary *d, Q7B theArray2);
void Q7B_fromXMLList(QXmlStreamReader * xmlReader, Q7B_List *a, Q7B theArray2);
Q7B Q7B_READLIST(Q7B Q7B_Object);
Q7B Q7B_WRITELIST(Q7B Q7B_Object, Q7B FilePathOrURL);
Q7B Q7B_READDICTIONARY(Q7B Q7B_Object);
Q7B Q7B_WRITEDICTIONARY(Q7B Q7B_Object, Q7B FilePathOrURL);
Q7B Q7B_ISLIST(Q7B aList);
Q7B Q7B_ISFLOAT(Q7B v);
Q7B Q7B_ISINTEGER(Q7B v);
Q7B Q7B_ISBOOLEAN(Q7B v);
Q7B Q7B_ISSTRING(Q7B v);
Q7B Q7B_ISDATETIME(Q7B v);
Q7B Q7B_ISDECIMAL(Q7B v);
Q7B Q7B_PSQLCONNECT(Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B ConnectOptions, Q7B Port);
void Q7B_PSQLDISCONNECT();
Q7B Q7B_PSQLLASTINSERTID(Q7B Table);
Q7B Q7B_MD5(Q7B Argument);
Q7B Q7B_PSQL(Q7B SQL);
Q7B Q7B_MYSQLCONNECT(Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B ConnectOptions, Q7B Port);
void Q7B_MYSQLDISCONNECT();
Q7B Q7B_MYSQLLASTINSERTID();
Q7B Q7B_MYSQL(Q7B SQL);
Q7B Q7B_SQLITELASTINSERTID();
Q7B Q7B_SQLITE(Q7B SQL, Q7B FilePath);
void Q7B_CLOSEALLDATABASES();
Q7B Q7B_SQLBLOB(Q7B v);
Q7B Q7B_SQLTEXT(Q7B v);
Q7B Q7B_SQLBOOLEAN(Q7B v);
Q7B Q7B_SQLINTEGER(Q7B v);
Q7B Q7B_SQLFLOAT(Q7B v);
void Q7B_Control_constructor(QWidget *o);
Q7B Q7B_CONTROL_INIT(QObject *parent, const char *objectName);
void Q7B_CONTROL_ENABLED(Q7B q7b_control, Q7B v);
Q7B Q7B_CONTROL_ENABLED(Q7B q7b_control);
void Q7B_CONTROL_GROUP(Q7B q7b_control, Q7B v);
Q7B Q7B_CONTROL_GROUP(Q7B q7b_control);
Q7B Q7B_TIMER_INIT(QObject *parent, const char *objectName);
void Q7B_TIMER_ENABLED(Q7B q7b_timer, Q7B v);
Q7B Q7B_TIMER_ENABLED(Q7B q7b_timer);
Q7B Q7B_TIMER_ISRUNNING(Q7B q7b_timer);
void Q7B_TIMER_INTERVAL(Q7B q7b_timer, Q7B v);
Q7B Q7B_TIMER_INTERVAL(Q7B q7b_timer);
void Q7B_TIMER_START(Q7B q7b_timer);
void Q7B_TIMER_STOP(Q7B q7b_timer);
Q7B Q7B_IMAGEBUTTON_INIT(QObject *parent, const char *objectName);
void Q7B_IMAGEBUTTON_CHECKABLE(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_CHECKABLE(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_CHECKABLEEXCLUSIVE(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_CHECKABLEEXCLUSIVE(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_CHECKED(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_CHECKED(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_CAPTION(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_CAPTION(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_ENABLEDIMAGE(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_ENABLEDIMAGE(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_DISABLEDIMAGE(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_DISABLEDIMAGE(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_ENTERIMAGE(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_ENTERIMAGE(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_EXITIMAGE(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_EXITIMAGE(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_MOUSEDOWNIMAGE(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_MOUSEDOWNIMAGE(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_MOUSEUPIMAGE(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_MOUSEUPIMAGE(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_ENTERSOUND(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_ENTERSOUND(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_EXITSOUND(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_EXITSOUND(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_MOUSEDOWNSOUND(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_MOUSEDOWNSOUND(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_MOUSEUPSOUND(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_MOUSEUPSOUND(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_CHECKEDENABLEDIMAGE(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_CHECKEDENABLEDIMAGE(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_CHECKEDDISABLEDIMAGE(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_CHECKEDDISABLEDIMAGE(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_CHECKEDENTERIMAGE(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_CHECKEDENTERIMAGE(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_CHECKEDEXITIMAGE(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_CHECKEDEXITIMAGE(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_CHECKEDMOUSEDOWNIMAGE(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_CHECKEDMOUSEDOWNIMAGE(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_CHECKEDMOUSEUPIMAGE(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_CHECKEDMOUSEUPIMAGE(Q7B q7b_imagebutton);
void Q7B_IMAGEBUTTON_SCALE(Q7B q7b_imagebutton, Q7B v);
Q7B Q7B_IMAGEBUTTON_SCALE(Q7B q7b_imagebutton);
Q7B Q7B_TEXTBOX_INIT(QObject *parent, const char *objectName);
Q7B Q7B_COMMANDBUTTON_INIT(QObject *parent, const char *objectName);
void Q7B_COMMANDBUTTON_ICON(Q7B commandbutton, Q7B Value);
Q7B Q7B_COMMANDBUTTON_ICON(Q7B commandbutton);
Q7B Q7B_COMMANDLINKBUTTON_INIT(QObject *parent, const char *objectName);
void Q7B_COMMANDLINKBUTTON_ICON(Q7B commandlinkbutton, Q7B Value);
Q7B Q7B_COMMANDLINKBUTTON_ICON(Q7B commandlinkbutton);
Q7B Q7B_TOOLBUTTON_INIT(QObject *parent, const char *objectName);
void Q7B_TOOLBUTTON_ICON(Q7B toolbutton, Q7B Value);
Q7B Q7B_TOOLBUTTON_ICON(Q7B toolbutton);
Q7B Q7B_CHECKBOX_INIT(QObject *parent, const char *objectName);
void Q7B_CHECKBOX_ICON(Q7B checkbox, Q7B Value);
Q7B Q7B_CHECKBOX_ICON(Q7B checkbox);
Q7B Q7B_RADIOBUTTON_INIT(QObject *parent, const char *objectName);
void Q7B_RADIOBUTTON_ICON(Q7B radiobutton, Q7B Value);
Q7B Q7B_RADIOBUTTON_ICON(Q7B radiobutton);
Q7B Q7B_LABEL_INIT(QObject *parent, const char *objectName);
void Q7B_LABEL_SHAPE(Q7B q7b_label, Q7B v);
Q7B Q7B_LABEL_SHAPE(Q7B q7b_label);
void Q7B_LABEL_INPUTCONTROL(Q7B q7b_label, Q7B v);
Q7B Q7B_LABEL_INPUTCONTROL(Q7B q7b_label);
void Q7B_LABEL_ICON(Q7B q7b_label, Q7B Value);
Q7B Q7B_LABEL_ICON(Q7B q7b_label);
Q7B Q7B_FRAME_INIT(QObject *parent, const char *objectName);
Q7B Q7B_UICLASS_INIT(QObject *parent, const char *objectName);
Q7B Q7B_CLASS_INIT(QObject *parent, const char *objectName);
Q7B Q7B_MODULE_INIT(QObject *parent, const char *objectName);
Q7B Q7B_IMAGEBOX_INIT(QObject *parent, const char *objectName);
void Q7B_IMAGEBOX_VALUE(Q7B q7b_imagebox, Q7B v);
Q7B Q7B_IMAGEBOX_VALUE(Q7B q7b_imagebox);
void Q7B_IMAGEBOX_TEXT(Q7B q7b_imagebox, Q7B v);
Q7B Q7B_IMAGEBOX_TEXT(Q7B q7b_imagebox);
Q7B Q7B_UDPSOCKET_INIT(QObject *parent, const char *objectName);
Q7B Q7B_UDPSOCKET_OPEN(Q7B q7b_udpsocket);
Q7B Q7B_UDPSOCKET_BIND(Q7B q7b_udpsocket, Q7B Host, Q7B Port);
Q7B Q7B_UDPSOCKET_READDATA(Q7B q7b_udpsocket);
Q7B Q7B_UDPSOCKET_WRITEDATA(Q7B q7b_udpsocket, Q7B Data);
void Q7B_UDPSOCKET_CLOSE(Q7B q7b_udpsocket);
Q7B Q7B_UDPSOCKET_LASTERROR(Q7B q7b_udpsocket);
Q7B Q7B_UDPSOCKET_LASTERRORTEXT(Q7B q7b_udpsocket);
void Q7B_UDPSOCKET_HOST(Q7B q7b_udpsocket, Q7B v);
Q7B Q7B_UDPSOCKET_HOST(Q7B q7b_udpsocket);
void Q7B_UDPSOCKET_PORT(Q7B q7b_udpsocket, Q7B v);
Q7B Q7B_UDPSOCKET_PORT(Q7B q7b_udpsocket);
void Q7B_SHOWSCREEN();
void Q7B_HIDESCREEN();
void Q7B_CLOSESCREEN();
void Q7B_CLS();
void Q7B_LINE(Q7B x1, Q7B y1, Q7B x2, Q7B y2, Q7B bColor, Q7B color);
void Q7B_PSET(Q7B x1, Q7B y1, Q7B bColor, Q7B color);
Q7B Q7B_CSRLIN();
Q7B Q7B_POS();
void Q7B_COLOR(Q7B nFORE, Q7B nBACK);
void Q7B_PRINTSCREEN(Q7B bPrintDialog);
void Q7B_LOCATE(Q7B Y, Q7B X);
void Q7B_PRINT(Q7B Q7B_Object);
void Q7B_RECONNECTSIGNALS(Q7B Argument, QObject *Q7B_Parent);
void Q7BWriteDebugOutput(QString s);
QString Q7BReadDebugInput();
void Q7BE(QString sFile, QString sScope, QString sLine, int nType);
bool Q7BS(QString sFile, QString sScope, QString sLine, int nType) ;

QObject *Q7B_CQOBJECT(Q7B l);

bool Q7B_CBOOLEAN(Q7B l);

bool Q7B_CBOOLEAN(bool l);

qint64 Q7B_CINTEGER(Q7B l);

qreal Q7B_CFLOAT(Q7B l);

QString Q7B_CQSTRING(Q7B l);

QStringList Q7B_CQSTRINGLIST(Q7B l);




Q7B Q7B_QOBJECT(Q7B m);
Q7B Q7B_ID(Q7B m);
Q7B Q7B_TIMER(Q7B m);
Q7B Q7B_UDPSOCKET(Q7B m);
Q7B Q7B_CONTROL(Q7B m);
Q7B Q7B_QWIDGET(Q7B m);
Q7B Q7B_IMAGEBUTTON(Q7B m);
Q7B Q7B_COMMANDBUTTON(Q7B m);
Q7B Q7B_COMMANDLINKBUTTON(Q7B m);
Q7B Q7B_TOOLBUTTON(Q7B m);
Q7B Q7B_CHECKBOX(Q7B m);
Q7B Q7B_RADIOBUTTON(Q7B m);
Q7B Q7B_LABEL(Q7B m);
Q7B Q7B_FRAME(Q7B m);
Q7B Q7B_IMAGEBOX(Q7B m);
Q7B Q7B_TEXTBOX(Q7B m);
Q7B Q7B_QDIALOG(Q7B m);
Q7B Q7B_QABSTRACTBUTTON(Q7B m);
Q7B Q7B_QPUSHBUTTON(Q7B m);
Q7B Q7B_QRADIOBUTTON(Q7B m);
Q7B Q7B_QMAINWINDOW(Q7B m);
Q7B Q7B_QMDIAREA(Q7B m);
Q7B Q7B_QPROGRESSBAR(Q7B m);
Q7B Q7B_QCHECKBOX(Q7B m);
Q7B Q7B_QBUTTONGROUP(Q7B m);
Q7B Q7B_QCOMMANDLINKBUTTON(Q7B m);
Q7B Q7B_QLISTWIDGET(Q7B m);
Q7B Q7B_QTREEWIDGET(Q7B m);
Q7B Q7B_QCOMBOBOX(Q7B m);
Q7B Q7B_QWEBVIEW(Q7B m);
Q7B Q7B_QDECLARATIVEVIEW(Q7B m);
Q7B Q7B_QVBOXLAYOUT(Q7B m);
Q7B Q7B_QHBOXLAYOUT(Q7B m);
Q7B Q7B_QGRIDLAYOUT(Q7B m);
Q7B Q7B_QFORMLAYOUT(Q7B m);
Q7B Q7B_QDIALOGBUTTONBOX(Q7B m);
Q7B Q7B_QLISTVIEW(Q7B m);
Q7B Q7B_QTREEVIEW(Q7B m);
Q7B Q7B_QTABLEVIEW(Q7B m);
Q7B Q7B_QCOLUMNVIEW(Q7B m);
Q7B Q7B_QTABLEWIDGET(Q7B m);
Q7B Q7B_QGRAPHICSVIEW(Q7B m);
Q7B Q7B_QCALENDERWIDGET(Q7B m);
Q7B Q7B_QLCDNUMBER(Q7B m);
Q7B Q7B_QGROUPBOX(Q7B m);
Q7B Q7B_QSCROLLAREA(Q7B m);
Q7B Q7B_QTOOLBOX(Q7B m);
Q7B Q7B_QTABWIDGET(Q7B m);
Q7B Q7B_QSTACKEDWIDGET(Q7B m);
Q7B Q7B_QFRAME(Q7B m);
Q7B Q7B_QFONTCOMBOBOX(Q7B m);
Q7B Q7B_QPLAINTEXTEDIT(Q7B m);
Q7B Q7B_QDIAL(Q7B m);
Q7B Q7B_QDOCKWIDGET(Q7B m);
Q7B Q7B_QLINEEDIT(Q7B m);
Q7B Q7B_QTEXTEDIT(Q7B m);
Q7B Q7B_QSPINBOX(Q7B m);
Q7B Q7B_PHONONVIDEOPLAYER(Q7B m);
Q7B Q7B_PHONONSEEKSLIDER(Q7B m);
Q7B Q7B_PHONONVOLUMESLIDER(Q7B m);
Q7B Q7B_QDOUBLESPINBOX(Q7B m);
Q7B Q7B_QTIMEEDIT(Q7B m);
Q7B Q7B_QDATEEDIT(Q7B m);
Q7B Q7B_QDATETIMEEDIT(Q7B m);
Q7B Q7B_QSCROLLBAR(Q7B m);
Q7B Q7B_QSLIDER(Q7B m);
Q7B Q7B_QTEXTBROWSER(Q7B m);
Q7B Q7B_QTOOLBUTTON(Q7B m);
Q7B Q7B_QLABEL(Q7B m);
Q7B Q7B_QMENUBAR(Q7B m);
Q7B Q7B_QTOOLBAR(Q7B m);
Q7B Q7B_QSTATUSBAR(Q7B m);
Q7B Q7B_QACTION(Q7B m);
Q7B Q7B_QPAINTER(Q7B m);
Q7B Q7B_QICON(Q7B m);
Q7B Q7B_QLAYOUT(Q7B m);
Q7B Q7B_QMENU(Q7B m);
Q7B Q7B_COMBOBOX(Q7B m);
Q7B Q7B_LISTBOX(Q7B m);
Q7B Q7B_DATEBOX(Q7B m);
Q7B Q7B_TIMEBOX(Q7B m);
Q7B Q7B_DATETIMEBOX(Q7B m);
Q7B Q7B_MOVIEBOX(Q7B m);
Q7B Q7B_TABVIEW(Q7B m);
Q7B Q7B_TREEVIEW(Q7B m);
Q7B Q7B_LISTVIEW(Q7B m);
Q7B Q7B_BOX(Q7B m);
Q7B Q7B_PROGRESSBAR(Q7B m);
Q7B Q7B_RICHTEXTBOX(Q7B m);
Q7B Q7B_WEBVIEW(Q7B m);
Q7B Q7B_HTMLVIEW(Q7B m);
Q7B Q7B_SVGBOX(Q7B m);
Q7B Q7B_SLIDER(Q7B m);
Q7B Q7B_SCROLLBAR(Q7B m);
Q7B Q7B_SPINBOX(Q7B m);
Q7B Q7B_FORMVIEW(Q7B m);
Q7B Q7B_FORMSVIEW(Q7B m);
Q7B Q7B_TOOLBARVIEW(Q7B m);
Q7B Q7B_UICLASS(Q7B m);
Q7B Q7B_CLASS(Q7B m);
Q7B Q7B_MODULE(Q7B m);


Q7B Q7B__QOBJECT(bool o);

Q7B Q7B__QOBJECT(char * o);

Q7B Q7B__QOBJECT(const char * o);

Q7B Q7B__QOBJECT(QString o);

Q7B Q7B__QOBJECT(qint8 o);

Q7B Q7B__QOBJECT(qint16 o);

Q7B Q7B__QOBJECT(qint32 o);

Q7B Q7B__QOBJECT(qint64 o);

Q7B Q7B__QOBJECT(float o);

Q7B Q7B__QOBJECT(double o);

Q7B Q7B__QOBJECT(QStringList o);

Q7B Q7B__QOBJECT(QDateTime o);




Q7B Q7B__BOOLEAN(Q7B o);

Q7B Q7B__STRING(Q7B o);

Q7B Q7B__INTEGER(Q7B o);

Q7B Q7B__FLOAT(Q7B o);

Q7B Q7B__DATETIME(Q7B o);

Q7B Q7B__DECIMAL(Q7B o);

Q7B Q7B__ARRAY(Q7B o);

Q7B Q7B__DICTIONARY(Q7B o);

Q7B Q7B__DATA(Q7B o);

Q7B Q7B__QOBJECT(Q7B m);
Q7B Q7B__ID(Q7B m);
Q7B Q7B__TIMER(Q7B m);
Q7B Q7B__UDPSOCKET(Q7B m);
Q7B Q7B__CONTROL(Q7B m);
Q7B Q7B__QWIDGET(Q7B m);
Q7B Q7B__IMAGEBUTTON(Q7B m);
Q7B Q7B__COMMANDBUTTON(Q7B m);
Q7B Q7B__COMMANDLINKBUTTON(Q7B m);
Q7B Q7B__TOOLBUTTON(Q7B m);
Q7B Q7B__CHECKBOX(Q7B m);
Q7B Q7B__RADIOBUTTON(Q7B m);
Q7B Q7B__LABEL(Q7B m);
Q7B Q7B__FRAME(Q7B m);
Q7B Q7B__IMAGEBOX(Q7B m);
Q7B Q7B__TEXTBOX(Q7B m);
Q7B Q7B__QDIALOG(Q7B m);
Q7B Q7B__QABSTRACTBUTTON(Q7B m);
Q7B Q7B__QPUSHBUTTON(Q7B m);
Q7B Q7B__QRADIOBUTTON(Q7B m);
Q7B Q7B__QMAINWINDOW(Q7B m);
Q7B Q7B__QMDIAREA(Q7B m);
Q7B Q7B__QPROGRESSBAR(Q7B m);
Q7B Q7B__QCHECKBOX(Q7B m);
Q7B Q7B__QBUTTONGROUP(Q7B m);
Q7B Q7B__QCOMMANDLINKBUTTON(Q7B m);
Q7B Q7B__QLISTWIDGET(Q7B m);
Q7B Q7B__QTREEWIDGET(Q7B m);
Q7B Q7B__QCOMBOBOX(Q7B m);
Q7B Q7B__QWEBVIEW(Q7B m);
Q7B Q7B__QDECLARATIVEVIEW(Q7B m);
Q7B Q7B__QVBOXLAYOUT(Q7B m);
Q7B Q7B__QHBOXLAYOUT(Q7B m);
Q7B Q7B__QGRIDLAYOUT(Q7B m);
Q7B Q7B__QFORMLAYOUT(Q7B m);
Q7B Q7B__QDIALOGBUTTONBOX(Q7B m);
Q7B Q7B__QLISTVIEW(Q7B m);
Q7B Q7B__QTREEVIEW(Q7B m);
Q7B Q7B__QTABLEVIEW(Q7B m);
Q7B Q7B__QCOLUMNVIEW(Q7B m);
Q7B Q7B__QTABLEWIDGET(Q7B m);
Q7B Q7B__QGRAPHICSVIEW(Q7B m);
Q7B Q7B__QCALENDERWIDGET(Q7B m);
Q7B Q7B__QLCDNUMBER(Q7B m);
Q7B Q7B__QGROUPBOX(Q7B m);
Q7B Q7B__QSCROLLAREA(Q7B m);
Q7B Q7B__QTOOLBOX(Q7B m);
Q7B Q7B__QTABWIDGET(Q7B m);
Q7B Q7B__QSTACKEDWIDGET(Q7B m);
Q7B Q7B__QFRAME(Q7B m);
Q7B Q7B__QFONTCOMBOBOX(Q7B m);
Q7B Q7B__QPLAINTEXTEDIT(Q7B m);
Q7B Q7B__QDIAL(Q7B m);
Q7B Q7B__QDOCKWIDGET(Q7B m);
Q7B Q7B__QLINEEDIT(Q7B m);
Q7B Q7B__QTEXTEDIT(Q7B m);
Q7B Q7B__QSPINBOX(Q7B m);
Q7B Q7B__PHONONVIDEOPLAYER(Q7B m);
Q7B Q7B__PHONONSEEKSLIDER(Q7B m);
Q7B Q7B__PHONONVOLUMESLIDER(Q7B m);
Q7B Q7B__QDOUBLESPINBOX(Q7B m);
Q7B Q7B__QTIMEEDIT(Q7B m);
Q7B Q7B__QDATEEDIT(Q7B m);
Q7B Q7B__QDATETIMEEDIT(Q7B m);
Q7B Q7B__QSCROLLBAR(Q7B m);
Q7B Q7B__QSLIDER(Q7B m);
Q7B Q7B__QTEXTBROWSER(Q7B m);
Q7B Q7B__QTOOLBUTTON(Q7B m);
Q7B Q7B__QLABEL(Q7B m);
Q7B Q7B__QMENUBAR(Q7B m);
Q7B Q7B__QTOOLBAR(Q7B m);
Q7B Q7B__QSTATUSBAR(Q7B m);
Q7B Q7B__QACTION(Q7B m);
Q7B Q7B__QPAINTER(Q7B m);
Q7B Q7B__QICON(Q7B m);
Q7B Q7B__QLAYOUT(Q7B m);
Q7B Q7B__QMENU(Q7B m);
Q7B Q7B__COMBOBOX(Q7B m);
Q7B Q7B__LISTBOX(Q7B m);
Q7B Q7B__DATEBOX(Q7B m);
Q7B Q7B__TIMEBOX(Q7B m);
Q7B Q7B__DATETIMEBOX(Q7B m);
Q7B Q7B__MOVIEBOX(Q7B m);
Q7B Q7B__TABVIEW(Q7B m);
Q7B Q7B__TREEVIEW(Q7B m);
Q7B Q7B__LISTVIEW(Q7B m);
Q7B Q7B__BOX(Q7B m);
Q7B Q7B__PROGRESSBAR(Q7B m);
Q7B Q7B__RICHTEXTBOX(Q7B m);
Q7B Q7B__WEBVIEW(Q7B m);
Q7B Q7B__HTMLVIEW(Q7B m);
Q7B Q7B__SVGBOX(Q7B m);
Q7B Q7B__SLIDER(Q7B m);
Q7B Q7B__SCROLLBAR(Q7B m);
Q7B Q7B__SPINBOX(Q7B m);
Q7B Q7B__FORMVIEW(Q7B m);
Q7B Q7B__FORMSVIEW(Q7B m);
Q7B Q7B__TOOLBARVIEW(Q7B m);
Q7B Q7B__UICLASS(Q7B m);
Q7B Q7B__CLASS(Q7B m);
Q7B Q7B__MODULE(Q7B m);

class Q7B_Sounds : public QObject
{
  Q_OBJECT
public:
  Q7B_Sounds()
  {
    nTimer = 0;
  }

  ~Q7B_Sounds()
  {
    
    
     
    QMapIterator<Phonon::MediaObject*, Phonon::AudioOutput*> i(sounds_playing);
    while (i.hasNext()) {
        i.next();
        delete i.key();
        delete i.value();
     }

    foreach(Q7B_t_sound ts, sounds_map){
      delete ts.buffer;
      delete ts.bytearray;
    }
  }

  bool Load(const QString & SoundId, const QString & FileName)
  {    
    QString ff;
    if (!FileName.contains("/") && !FileName.contains("\\")){
      QString s;
      s = qApp->applicationDirPath();
      s += "/";
      s += FileName;
      ff = s;
    } else ff = FileName;

    QFile f(ff);
    if (f.open(QFile::ReadOnly)){
      Q7B_t_sound ts;
      ts.bytearray = new QByteArray(f.readAll());
      ts.buffer = new QBuffer(); ts.buffer->setData(*ts.bytearray);
      sounds_map[SoundId] = ts;
      f.close();
      return true;
    }    

    return false;
  }

  bool Play(const QString & SoundId)
  {
    if (sounds_map.contains(SoundId)){
      Q7B_t_sound ts = sounds_map[SoundId];
      Phonon::MediaObject *mediaObject = new Phonon::MediaObject();
      Phonon::AudioOutput *audioOutput = new Phonon::AudioOutput();

      sounds_playing[mediaObject] = audioOutput;
      sounds_playing2[mediaObject] = new Phonon::MediaSource(ts.buffer);
      mediaObject->setCurrentSource(*sounds_playing2[mediaObject]);
      sounds_playing3[mediaObject] = Phonon::createPath(mediaObject, audioOutput);
      
      QObject::connect(mediaObject, SIGNAL(finished()), this, SLOT(finished()));
      mediaObject->play();
      
      return true;
    }    

    return false;
  }

  void timerEvent(QTimerEvent *e)
  {
    killTimer(nTimer);

    int n = sounds_to_be_deleted.count();

    Phonon::MediaObject *mediaObject = sounds_to_be_deleted.takeFirst();

    bool b = sounds_playing3[mediaObject].disconnect();
    sounds_playing3.remove(mediaObject);

    delete mediaObject;
    delete sounds_playing[mediaObject];
  
    
    sounds_playing.remove(mediaObject);

    delete sounds_playing2[mediaObject];
    sounds_playing2.remove(mediaObject);
    
    if (n > 1) nTimer = startTimer(10000);
  }

public slots:
  void finished()
  {
    Phonon::MediaObject *mediaObject = qobject_cast<Phonon::MediaObject *>(sender());
    if (mediaObject){
      sounds_to_be_deleted.append(mediaObject);
      if (nTimer == 0) nTimer = startTimer(10000);        
    }
  }

private:
  int nTimer;

  
  

  QMap<QString, Q7B_t_sound>sounds_map;
  QMap<Phonon::MediaObject*, Phonon::AudioOutput*>sounds_playing;
  QList<Phonon::MediaObject*>sounds_to_be_deleted;
  QMap<Phonon::MediaObject*, Phonon::MediaSource*>sounds_playing2;
  QMap<Phonon::MediaObject*, Phonon::Path>sounds_playing3;
};


class Q7B_Pixmaps : public QObject
{
  Q_OBJECT
public:
  Q7B_Pixmaps()
  {
  }

  ~Q7B_Pixmaps()
  {
  }

  bool Load(const QString & PixmapId, const QString & FileName)
  {    
    QPixmap p = Q7B_loadPixmap(FileName.contains(".") ? FileName : FileName + ".png");
    if (p.isNull()) return false;
    pixmaps_map[PixmapId] = p.copy();
    return true;
  }

private:
  QMap<QString, QPixmap>pixmaps_map;
};


class Q7B_Colors : public QObject
{
  Q_OBJECT
public:
  Q7B_Colors()
  {
  }

  


  ~Q7B_Colors()
  {
  }

  bool Set(const QString & ColorId, qint64 R, qint64 G, qint64 B, qint64 A)
  {    
    colors_map[ColorId] = QColor(R, G, B, A);  
    return true;
  }

private:
  QMap<QString, QColor>colors_map;
};


class Q7B_ColorDialog : public QObject
{
  Q_OBJECT
public:
  Q7B_ColorDialog()
  {
  }

  ~Q7B_ColorDialog()
  {
  }

  bool GetColor()
  {    
    qcolor = QColorDialog::getColor(Qt::white, qApp->focusWidget());
    return qcolor.isValid();
  }

  bool GetColorLike(qint64 Red, qint64 Green, qint64 Blue, qint64 Alpha)
  {    
    qcolor = QColorDialog::getColor(QColor(Red, Green, Blue, Alpha), qApp->focusWidget());
    return qcolor.isValid();
  }

  qint64 Red()
  {    
    return qcolor.red();
  }

  qint64 Green()
  {    
    return qcolor.green();
  }
  
  qint64 Blue()
  {    
    return qcolor.blue();
  }
  
  qint64 Alpha()
  {    
    return qcolor.alpha();
  }

private:

  QColor qcolor;
};


class Q7B_FontDialog : public QObject
{
  Q_OBJECT
public:
  Q7B_FontDialog()
  {
  }

  ~Q7B_FontDialog()
  {
  }

  bool GetFont()
  {    
    bool ok;
    qfont = QFontDialog::getFont(&ok, qApp->focusWidget());
    return ok;  
  }

  bool GetFontLike(QString Name, qint64 Size, bool Italic, bool Bold, bool Underline)
  {    
    QFont f(Name);
    f.setPointSize(Size);
    f.setItalic(Italic);
    f.setBold(Bold);
    f.setUnderline(Underline);
    
    bool ok;
    qfont = QFontDialog::getFont(&ok, f, qApp->focusWidget());
    return ok;    
  }

  QString Name()
  {    
    return qfont.family();
  }

  qint64 Size()
  {    
    return qfont.pointSize();
  }

  bool Italic()
  {    
    return qfont.italic();
  }
  
  bool Bold()
  {    
    return qfont.bold();
  }
  
  bool Underline()
  {    
    return qfont.underline();
  }

private:

  QFont qfont;
};


class Q7B_ProgressDialog : public QObject
{
  Q_OBJECT
public:

  Q7B_ProgressDialog()
  {
    qprogressdialog = 0;
  }

  ~Q7B_ProgressDialog()
  {
  }

  void Show()
  {    
    if (qprogressdialog) delete qprogressdialog;
    qprogressdialog = new QProgressDialog(qApp->focusWidget());
    qprogressdialog->setAutoClose(false);
    qprogressdialog->setAutoReset(false);

    if (!WindowTitle.isEmpty()) qprogressdialog->setLabelText(WindowTitle); 
    if (!CancelText.isEmpty()) qprogressdialog->setCancelButtonText(CancelText); 
    qprogressdialog->setValue(Value); 
    qprogressdialog->setMinimum(Minimum); 
    qprogressdialog->setMaximum(Maximum); 
    qprogressdialog->setMinimumDuration(Wait); 

    qprogressdialog->show();
  }

  void ShowWith(QString _WindowTitle, QString _CancelText)
  {
    if (qprogressdialog) delete qprogressdialog;
    qprogressdialog = new QProgressDialog(qApp->focusWidget());
    qprogressdialog->setAutoClose(false);
    qprogressdialog->setAutoReset(false);

    if (!WindowTitle.isEmpty()) qprogressdialog->setLabelText(_WindowTitle); 
    if (!CancelText.isEmpty()) qprogressdialog->setCancelButtonText(_CancelText); 

    qprogressdialog->setValue(Value); 
    qprogressdialog->setMinimum(Minimum); 
    qprogressdialog->setMaximum(Maximum); 
    qprogressdialog->setMinimumDuration(Wait); 

    qprogressdialog->show();
  } 

  void Hide()
  {
    qprogressdialog->hide();

    delete qprogressdialog;
    qprogressdialog = 0;

    WindowTitle = ""; 
    CancelText = "";
    Value = 0;
    Minimum = 0;
    Maximum = 100;
    Wait = 4000;
  } 

  bool Canceled()
  {
    if (qprogressdialog == 0) return false;

    return qprogressdialog->wasCanceled();
  } 

public:
  QString WindowTitle;
  QString CancelText;
  qint64 Value;
  qint64 Minimum;
  qint64 Maximum;
  qint64 Wait;

private:
  QProgressDialog *qprogressdialog;
};


class Q7B_InputDialog : public QObject
{
  Q_OBJECT
public:

  Q7B_InputDialog()
  {
  }

  ~Q7B_InputDialog()
  {
  }

  qreal GetFloat(QString WindowTitle, QString Text, qreal Value, qreal Minimum, qreal Maximum, qint64 Decimals)
  {
    return QInputDialog::getDouble(qApp->focusWidget(), WindowTitle, Text, Value, Minimum, Maximum, Decimals, &_inputdialog_ok);
  } 

  qint64 GetInteger(QString WindowTitle, QString Text, qint64 Value, qint64 Minimum, qint64 Maximum, qint64 Step)
  {
    return QInputDialog::getInteger(qApp->focusWidget(), WindowTitle, Text, Value, Minimum, Maximum, Step, &_inputdialog_ok);
  } 

  QString GetString(QString WindowTitle, QString Text, QString Value, qint64 EchoMode)
  {
    return QInputDialog::getText(qApp->focusWidget(), WindowTitle, Text, (QLineEdit::EchoMode) EchoMode, Value, &_inputdialog_ok);
  } 

  bool Ok()
  {
    return _inputdialog_ok;
  } 

public:
  bool _inputdialog_ok;
};


class Q7B_MessageBox : public QObject
{
  Q_OBJECT
public:

  Q7B_MessageBox()
  {
  }

  ~Q7B_MessageBox()
  {
  }

  qint64 Critical(QString WindowTitle, QString Text, qint64 Buttons, qint64 DefaultButton)
  {
    QMessageBox::StandardButton b = QMessageBox::critical(qApp->focusWidget(), WindowTitle, Text, (QMessageBox::StandardButtons) Buttons, (QMessageBox::StandardButton) DefaultButton);
    return (qint64) b;
  } 

  qint64 Information(QString WindowTitle, QString Text, qint64 Buttons, qint64 DefaultButton)
  {
    QMessageBox::StandardButton b = QMessageBox::information(qApp->focusWidget(), WindowTitle, Text, (QMessageBox::StandardButtons) Buttons, (QMessageBox::StandardButton) DefaultButton);
    return (qint64) b;
  } 

  qint64 Question(QString WindowTitle, QString Text, qint64 Buttons, qint64 DefaultButton)
  {
    QMessageBox::StandardButton b = QMessageBox::question(qApp->focusWidget(), WindowTitle, Text, (QMessageBox::StandardButtons) Buttons, (QMessageBox::StandardButton) DefaultButton);
    return (qint64) b;
  } 

  qint64 Warning(QString WindowTitle, QString Text, qint64 Buttons, qint64 DefaultButton)
  {
    QMessageBox::StandardButton b = QMessageBox::warning(qApp->focusWidget(), WindowTitle, Text, (QMessageBox::StandardButtons) Buttons, (QMessageBox::StandardButton) DefaultButton);
    return (qint64) b;
  } 

private:
};


class Q7B_Database : public QObject
{
  Q_OBJECT
public:

  Q7B_Database()
  {
  }

  ~Q7B_Database()
  {
  }
  
  QString MySQL()
  {
    return "QMYSQL";
  }
  
  QString PostgreSQL()
  {
    return "QPSQL";
  }
  
  QString SQLite()
  {
    return "QSQLITE";
  }

  QString LocalHost()
  {
    return "localhost";
  }
  
  QString DefaultPort()
  {
    return "";
  }
  
  QString DefaultOptions()
  {
    return "";
  }
    
  bool Exists(QString Driver, QString Name, QString User, QString Password, QString Host, QString Options, QString Port)
  {
    if (!Driver.isEmpty()){
      QSqlDatabase db;
      db = QSqlDatabase::addDatabase(Driver, Name + User);
      db.setHostName(Host);
      db.setDatabaseName(Name);
      db.setUserName(User);
      db.setPassword(Password);
      if (!Port.isEmpty()) db.setPort(Port.toInt());
      db.setConnectOptions(Options);
      if (db.open()){    
                
        
        

        QString sSQL = "";
        if (Driver.contains("MYSQL", Qt::CaseInsensitive)){
          sSQL = "SHOW DATABASES;";
        } else if (Driver.contains("PSQL", Qt::CaseInsensitive)){
          sSQL = "SELECT * FROM pg_database;";
        } else if (Driver.contains("SQLITE", Qt::CaseInsensitive)){
          db.close();
          goto _false;
        } else {
          db.close();
          goto _false;
        }

        QSqlQuery rr(db);
        if (rr.exec(sSQL)){ sLastSQLError = ""; sLastSQLCommands[Name] += sSQL + "\n";
          if (rr.first()){
            do {
              QSqlRecord r = rr.record();
              QString k = rr.value(0).toString();
              if (Name.compare(k, Qt::CaseInsensitive) == 0){
                db.close();              
                goto _true;
              }
            } while (rr.next());
          }
        } else {
          sLastSQLError = rr.lastError().text();
          if (sLastSQLError.isEmpty()) sLastSQLError = "unknown error";
          sLastSQLCommandFailed[Name] = sSQL;
        }
        db.close();
        goto _false;
      }
      goto _false;
    }

    return false;
_false:
    QSqlDatabase::removeDatabase(Name + User); 
    return false;
_true:
    QSqlDatabase::removeDatabase(Name + User); 
    return true;
  }
  
  bool SetCurrentDatabase(QString Name)
  {
    if (Q7B_Database::databases.contains(Name)){
      _CurrentDatabase = Q7B_Database::databases[Name];
      return true;
    }
    return false;
  }

  QString CurrentDatabase()
  {
    return _CurrentDatabase.databaseName();
  }

  bool OpenSQLite(QString Name)
  {
    if (!Q7B_Database::databases.contains(Name)){
      QSqlDatabase db;
      db = QSqlDatabase::addDatabase("QSQLITE", Name);
      db.setDatabaseName(Name);
      if (db.open()){    
        Q7B_Database::databases[Name] = db;
        _CurrentDatabase = db;
        return true;
      } else {
        goto _false;
      }
    }

    return false;
_false:
    QSqlDatabase::removeDatabase(Name); 
    return false;
  }

  bool Open(QString Driver, QString Name, QString User, QString Password)
  {
    if (!Driver.isEmpty() && !Q7B_Database::databases.contains(Name)){
      QSqlDatabase db;
      db = QSqlDatabase::addDatabase(Driver, Name);
      db.setHostName("localhost");
      db.setDatabaseName(Name);
      db.setUserName(User);
      db.setPassword(Password);
      if (db.open()){    
        Q7B_Database::databases[Name] = db;
        _CurrentDatabase = db;
        return true;
      } else {
        goto _false;
      }
    }

    return false;
_false:
    QSqlDatabase::removeDatabase(Name); 
    return false;
  }

  bool Open(QString Driver, QString Name, QString User, QString Password, QString Host, QString Options, QString Port)
  {
    if (!Driver.isEmpty() && !Q7B_Database::databases.contains(Name)){
      QSqlDatabase db;
      db = QSqlDatabase::addDatabase(Driver, Name);
      db.setHostName(Host);
      db.setDatabaseName(Name);
      db.setUserName(User);
      db.setPassword(Password);
      if (!Port.isEmpty()) db.setPort(Port.toInt());
      if (!Options.isEmpty()) db.setConnectOptions(Options);
      if (db.open()){    
        Q7B_Database::databases[Name] = db;
        _CurrentDatabase = db;
        return true;
      } else {       
        QSqlDatabase::removeDatabase(Name);
      }
    }

    return false;
_false:
    QSqlDatabase::removeDatabase(Name); 
    return false;
  }

  bool Close(QString Name)
  {
    QString sRemove;
    if (Name.isEmpty()){
      _CurrentDatabase.close();  
      sRemove = _CurrentDatabase.databaseName();      
      sLastSQLCommands[Name] = "";
      sLastSQLCommandFailed[Name] = "";
      goto _true;
    }
    if (Q7B_Database::databases.contains(Name)){
      
      
      Q7B_Database::databases[Name].close();   
      sRemove = Name;            
      Q7B_Database::databases.remove(Name);
      sLastSQLCommands[Name] = "";
      sLastSQLCommandFailed[Name] = "";
      goto _true;
    }

    return false;
_true:
    QSqlDatabase::removeDatabase(sRemove);
    return true;
  }

  bool IsOpen(QString Name)
  {
    if (Name.isEmpty()){
      return _CurrentDatabase.isOpen();
    }
    if (Q7B_Database::databases.contains(Name)){    
      return Q7B_Database::databases[Name].isOpen();
    }
    return false;
  }

  bool Create(QString Driver, QString Name, QString User, QString Password, QString Host, QString Options, QString Port)
  {
    
    if (!Driver.isEmpty()){
      QSqlDatabase db;
      db = QSqlDatabase::addDatabase(Driver, Name + User);
      db.setHostName(Host);

      db.setUserName(User);
      db.setPassword(Password);
      if (!Port.isEmpty()) db.setPort(Port.toInt());
      db.setConnectOptions(Options);

      if (db.open()){

       

        QString sSQL = "";
        if (Driver.contains("MYSQL", Qt::CaseInsensitive)){
          sSQL = "CREATE DATABASE " + Name + ";";
        } else if (Driver.contains("PSQL", Qt::CaseInsensitive)){
        
          sSQL = "CREATE DATABASE " + Name + " ENCODING='utf-8';";
        } else {
         
          db.close();
          goto _false;
        }
        QSqlQuery rr(db);
        if (rr.exec(sSQL)){ sLastSQLError = ""; sLastSQLCommands[Name] += sSQL + "\n";
          db.close();
          goto _true;
        } else {
                  

          sLastSQLError = rr.lastError().text();
          if (sLastSQLError.isEmpty()) sLastSQLError = "unknown error";
          sLastSQLCommandFailed[Name] = sSQL;
        }
        db.close();
      } else {
        
      }
      goto _false;
    }

    return false;
_false:
    QSqlDatabase::removeDatabase(Name + User); 
    return false;
_true:
    QSqlDatabase::removeDatabase(Name + User); 
    return true;
  }

  QString TestConnection(QString Driver, QString User, QString Password, QString Host, QString Options, QString Port)
  {

 

    

    QString s; 
    if (!Driver.isEmpty()){
      QSqlDatabase db;
      db = QSqlDatabase::addDatabase(Driver, User);
      db.setHostName(Host);
      db.setUserName(User);
      db.setPassword(Password);
      if (!Port.isEmpty()){
        
        db.setPort(Port.toInt());
      }
      db.setConnectOptions(Options);
      if (!db.open()){ 
       
        goto _exit; 
        s = db.lastError().text();
        if (s.isEmpty()) s = "unknown error";
      }
      db.close();      
      s = "";
      goto _exit; 
      
    }
    s = "Driver not selected";

   

    return s;
_exit:
    QSqlDatabase::removeDatabase(User); 
    return s;
  }

  bool Empty(QString Driver, QString Name, QString User, QString Password, QString Host, QString Options, QString Port)
  {
    if (!Driver.isEmpty()){
      QSqlDatabase db;
      db = QSqlDatabase::addDatabase(Driver, Name + User);
      db.setHostName(Host);
      db.setDatabaseName(Name);
      db.setUserName(User);
      db.setPassword(Password);
      if (!Port.isEmpty()) db.setPort(Port.toInt());
      db.setConnectOptions(Options);
      if (db.open()){  
        foreach(QString s, db.tables(QSql::Tables)){
          QString sSQL = "DROP TABLE " + s + ";";
          QSqlQuery rr(db);
          sLastSQLError = "";
          if (!rr.exec(sSQL)){
            sLastSQLError = rr.lastError().text();
            if (sLastSQLError.isEmpty()) sLastSQLError = "unknown error";
            sLastSQLCommandFailed[Name] = sSQL;
            db.close();
            goto _false;
          } else {
            sLastSQLCommands[Name] += sSQL + "\n";
          }
        }
        db.close();
        goto _true;
      }
      goto _false;
    }

    return false;
_false:
    QSqlDatabase::removeDatabase(Name + User); 
    return false;
_true:
    QSqlDatabase::removeDatabase(Name + User); 
    return true;
  }

  bool Drop(QString Driver, QString Name, QString User, QString Password, QString Host, QString Options, QString Port)
  {
    

    if (!Driver.isEmpty()){
      QSqlDatabase db;
      db = QSqlDatabase::addDatabase(Driver, Name + User);
      db.setHostName(Host);
      db.setDatabaseName(Name);
      db.setUserName(User);
      db.setPassword(Password);
      if (!Port.isEmpty()) db.setPort(Port.toInt());
      db.setConnectOptions(Options);
      if (db.open()){  

        QString sSQL = "";
        if (Driver.contains("MYSQL", Qt::CaseInsensitive)){
          sSQL = "DROP DATABASE " + Name + ";";
        } else if (Driver.contains("PGconn", Qt::CaseInsensitive)){ 
          sSQL = "DROP DATABASE " + Name + ";";
        } else {
          db.close();
          goto _false;
        }

        QSqlQuery rr(db);
        if (rr.exec(sSQL)){ sLastSQLError = ""; sLastSQLCommands[Name] += sSQL + "\n";
          db.close();
          goto _true;
        } else {
          sLastSQLError = rr.lastError().text();
          if (sLastSQLError.isEmpty()) sLastSQLError = "unknown error";
          sLastSQLCommandFailed[Name] = sSQL;
        }
        db.close();
      }
      goto _false;
    }

    return false;
_false:
    QSqlDatabase::removeDatabase(Name + User); 
    return false;
_true:
    QSqlDatabase::removeDatabase(Name + User); 
    return true;
  }

  bool Copy(QString Source, QString Destination)
  {
    
    return false;
  }

  QString LastSQLError(QString Name)
  {
    if (Name.isEmpty()){
      QString k = _CurrentDatabase.lastError().text().trimmed();    
      if (!k.isEmpty()) return k;
      k = sLastSQLError;
      return k;
    }
    if (Q7B_Database::databases.contains(Name)){  
      QString k = Q7B_Database::databases[Name].lastError().text().trimmed();    
      if (!k.isEmpty()) return k;
      k = sLastSQLError;
      return k;
    }
    return "";
  }

  QString LastSQLCommands(QString Name)
  {
    if (Name.isEmpty()){
      QString k = sLastSQLCommands[_CurrentDatabase.databaseName()];
      sLastSQLCommands[_CurrentDatabase.databaseName()] = "";
      return k;
    }
    if (Q7B_Database::databases.contains(Name)){  
      QString k = sLastSQLCommands[Name];
      sLastSQLCommands[Name] = "";
      return k;
    }
    return "";
  }

  QString LastSQLCommandFailed(QString Name)
  {
    if (Name.isEmpty()){
      QString k = sLastSQLCommandFailed[_CurrentDatabase.databaseName()];
      sLastSQLCommandFailed[_CurrentDatabase.databaseName()] = "";
      return k;
    }
    if (Q7B_Database::databases.contains(Name)){  
      QString k = sLastSQLCommandFailed[Name];
      sLastSQLCommandFailed[Name] = "";
      return k;
    }
    return "";
  }

  bool IsTransactionSupported(QString Name)
  {
    if (Name.isEmpty()){
      return _CurrentDatabase.driver()->hasFeature(QSqlDriver::Transactions);
    }
    if (Q7B_Database::databases.contains(Name)){    
      return Q7B_Database::databases[Name].driver()->hasFeature(QSqlDriver::Transactions);
    }
    return false;
  }

  bool Transaction(QString Name)
  {
    if (Name.isEmpty()){
      return _CurrentDatabase.transaction();
    }
    if (Q7B_Database::databases.contains(Name)){    
      return Q7B_Database::databases[Name].transaction();
    }
    return false;
  }

  bool Commit(QString Name)
  {
    if (Name.isEmpty()){
      return _CurrentDatabase.commit();
    }
    if (Q7B_Database::databases.contains(Name)){    
      return Q7B_Database::databases[Name].commit();
    }
    return false;
  }

  bool Rollback(QString Name)
  {
    if (Name.isEmpty()){
      return _CurrentDatabase.rollback();
    }
    if (Q7B_Database::databases.contains(Name)){    
      return Q7B_Database::databases[Name].rollback();
    }
    return false;
  }

  QStringList Tables(QString Name)
  {
    QStringList ll;

    if (Q7B_Database::databases.contains(Name)){    
      foreach(QString s, Name.isEmpty() ? _CurrentDatabase.tables(QSql::Tables) : Q7B_Database::databases[Name].tables(QSql::Tables))
      {
        ll << s;
      } 
    }

    return ll;
  }

  QStringList Drivers()
  {
    QStringList ll;
        
    QStringList drivers = QSqlDatabase::drivers();
    for (int i = 0; i < drivers.size(); i++){
      QString k = drivers.at(i);
      if (!k.right(1).at(0).isDigit()){ 
        ll << k;      
      }
    }
    
    return ll;
  }
  
  static QString getPrimary(QSqlDatabase &db, QString sTable)
  {
    QString sPrimary = "";

    QSqlIndex i = db.driver()->primaryIndex(sTable);
    if (i.count() == 1){
      sPrimary = i.fieldName(0);
    } else {
      for (int n = 0; n < i.count(); n++){
        if (n > 0) sPrimary += " ";
        sPrimary += i.fieldName(n);
      }
    }
    return sPrimary;
  }

  static QString formatValue(QString Database, Q7B o)
  {
    QSqlDriver *driver = Q7B_Database::databases[Database].driver();

    
    QSqlField f;
    if (o->type == typeid(qint64).name()){
     
      f.setValue(QVariant(*((qint64*)o->ref)));
    } else if (o->type == typeid(qreal).name()){
     
      f.setValue(QVariant(*((qreal*)o->ref)));
    } else if (o->type == typeid(QDateTime).name()){
     
      f.setValue(QVariant(*((QDateTime*)o->ref)));
    } else {
     
      f.setValue(QVariant(Q7B_toString2(o)));
      return "\"" + driver->formatValue(f) + "\"";
    }
    
    return driver->formatValue(f);
  }
        
  static QString getOrderBy(QString Database, Q7B_Dictionary *OrderBy)
  {
    QString sOrderBy;

   if (OrderBy && Q7B_Database::databases.contains(Database)){

      QMapIterator<QString, Q7B> i(OrderBy->me);
      while (i.hasNext()){
        i.next();

        QString sName = i.key();

        if (!sOrderBy.isEmpty()) sOrderBy += ", ";
        sOrderBy += sName;
      }      
   }
   return sOrderBy;
  }

  static QString getInsertFields(QString Database, Q7B_Dictionary *Insert)
  {
    QString sInsert;

   if (Insert && Q7B_Database::databases.contains(Database)){
      
      QMapIterator<QString, Q7B> i(Insert->me);
      while (i.hasNext()){
        i.next();

        QString sName = i.key();

        if (!sInsert.isEmpty()) sInsert += ", ";
        sInsert += sName;
      }      
   }
   return sInsert;
  }   

  static QString getInsertValues(QString Database, Q7B_Dictionary *Insert)
  {
    QString sInsert;

   if (Insert && Q7B_Database::databases.contains(Database)){

      QMapIterator<QString, Q7B> i(Insert->me);
      while (i.hasNext()){
        i.next();

        QString sValue = formatValue(Database, i.value());

        if (!sInsert.isEmpty()) sInsert += ", ";
        sInsert += sValue;
      }      
   }
   return sInsert;
  }

  static QString getUpdate(QString Database, Q7B_Dictionary *Update)
  {
    QString sUpdate;

   if (Update && Q7B_Database::databases.contains(Database)){
      
      QMapIterator<QString, Q7B> i(Update->me);

      while (i.hasNext()){
        i.next();

        QString sName = i.key();

        QString sValue = formatValue(Database, i.value());

        if (!sUpdate.isEmpty()) sUpdate += ", ";
        sUpdate += sName + " = " + sValue;
      }      
   }
   return sUpdate;
  }

  static QString getWhere(QString Database, Q7B_Dictionary *Where)
  {
    QString sWhere;

   if (Where && Q7B_Database::databases.contains(Database)){
      

    
      QMapIterator<QString, Q7B> i(Where->me);

      

      while (i.hasNext()){
        i.next();


       

        
        QString sDefinition = i.key();



        

        sDefinition = sDefinition.replace("=", " = ");
        sDefinition = sDefinition.replace("<", " < ");
        sDefinition = sDefinition.replace(">", " > ");
        sDefinition = sDefinition.replace("<>", " <> ");

        QStringList ll = sDefinition.split(" ", QString::SkipEmptyParts);
        QString sName = ll.at(0);
        QString sOperator;

        QString sValue = formatValue(Database, i.value());

        if (ll.size() > 1){
          for (int i = 1; i < ll.size(); i++){
            sOperator += ll.at(i);
          }
        } else {          
          sOperator = "=";
        }

        if (!sWhere.isEmpty()) sWhere += ", ";
        sWhere += sName + " " + sOperator + " " + sValue;
      }      
   }
   return sWhere;
  }

public:
  static QMap<QString, QSqlDatabase> databases; 
  static QMap<QString, QSqlQuery *> records;
  static QMap<QString, QString> records_database;
  static QMap<QString, QString> records_table;

  static QSqlDatabase _CurrentDatabase;

  static QString sLastSQLError;

  static QMap<QString, QString> sLastSQLCommands;
  static QMap<QString, QString> sLastSQLCommandFailed;
};


class Q7B_Table : public QObject
{
  Q_OBJECT
public:

  Q7B_Table()
  {
  }

  ~Q7B_Table()
  {
  }

  bool Exists(QString Table)
  {
    return Exists(Q7B_Database::_CurrentDatabase.databaseName(), Table);
  }

  bool Exists(QString Database, QString Table)
  {
    if (Q7B_Database::databases.contains(Database)){
      foreach(QString s, Q7B_Database::databases[Database].tables(QSql::Tables))
      {
        if (s.compare(Table, Qt::CaseInsensitive) == 0) return true;
      } 
    }

    return false;
  }


  bool Create(QString Table, Q7B_Dictionary *Fields)
  {
    return Create(Q7B_Database::_CurrentDatabase.databaseName(), Table, Fields);
  }

  bool Create(QString Database, QString Table, Q7B_Dictionary *Fields)
  {
    
    if (Q7B_Database::databases.contains(Database)){

      QMapIterator<QString, Q7B> i(Fields->me);

     
     
     
     
    

      

      QString sSQL;
      QString sSQL2;
      
      QString sField;      

      QString driver = Q7B_Database::databases[Database].driver()->handle().typeName();

      bool bMYSQL = driver.contains("MYSQL", Qt::CaseInsensitive);
      bool bPSQL = driver.contains("PGconn", Qt::CaseInsensitive); 
      bool bSQLITE = driver.contains("SQLITE", Qt::CaseInsensitive);

      QString sPrimaryKey;
      QString sMYSQLUnique;

      
      while (i.hasNext()){
        if (i.hasPrevious()) sField = ", ";

        i.next();


        QString sName = i.key();
        QString sDefinition = Q7B_toString2(i.value());

        

        sDefinition = sDefinition.replace("NOT NULL", "NOTNULL");
        sDefinition = sDefinition.replace("PRIMARY KEY", "PRIMARYKEY");
        sDefinition = sDefinition.replace("AUTO INCREMENT", "AUTOINCREMENT");
        

        QStringList ll = sDefinition.split(" ", QString::SkipEmptyParts);
        QString sType = ll.at(0);
        
        sField += sName + " ";

        if (bMYSQL){      
          if (sType.contains("Boolean", Qt::CaseInsensitive)){ sType = "BOOLEAN";
          } else if (sType.contains("String", Qt::CaseInsensitive)){ sType = "LONGTEXT";
          } else if (sType.contains("Byte", Qt::CaseInsensitive) || sType.contains("Int8", Qt::CaseInsensitive)){ sType = "SMALLINT";
          } else if (sType.contains("Short", Qt::CaseInsensitive) || sType.contains("Int16", Qt::CaseInsensitive)){ sType = "SMALLINT";
          } else if (sType.contains("Integer", Qt::CaseInsensitive) || sType.contains("Int64", Qt::CaseInsensitive)){ sType = "BIGINT";
          } else if (sType.contains("Int32", Qt::CaseInsensitive)){ sType = "INT";
          } else if (sType.contains("Single", Qt::CaseInsensitive)){ sType = "FLOAT";
          } else if (sType.contains("Double", Qt::CaseInsensitive)){ sType = "DOUBLE";
          } else if (sType.contains("Float", Qt::CaseInsensitive)){ sType = "DOUBLE";
          } else if (sType.contains("Decimal", Qt::CaseInsensitive)){ sType = "DECIMAL(10,4)";
         
         
          } else if (sType.contains("DateTime", Qt::CaseInsensitive)){ sType = "DATETIME";
          } else if (sType.contains("Bytes", Qt::CaseInsensitive)){ sType = "LONGBLOB";
          } else sType = "BIGINT";
         

        } else if (bPSQL){
          if (sType.contains("Boolean", Qt::CaseInsensitive)){ sType = "BOOLEAN";
          } else if (sType.contains("String", Qt::CaseInsensitive)){ sType = "TEXT";
          } else if (sType.contains("Byte", Qt::CaseInsensitive) || sType.contains("Int8", Qt::CaseInsensitive)){ sType = "SMALLINT";
          } else if (sType.contains("Short", Qt::CaseInsensitive) || sType.contains("Int16", Qt::CaseInsensitive)){ sType = "SMALLINT";
          } else if (sType.contains("Integer", Qt::CaseInsensitive) || sType.contains("Int64", Qt::CaseInsensitive)){ sType = "BIGINT";
          } else if (sType.contains("Int32", Qt::CaseInsensitive)){ sType = "INT";
          } else if (sType.contains("Single", Qt::CaseInsensitive)){ sType = "REAL";
          } else if (sType.contains("Double", Qt::CaseInsensitive)){ sType = "DOUBLE PRECISION";
          } else if (sType.contains("Float", Qt::CaseInsensitive)){ sType = "DOUBLE PRECISION";
          } else if (sType.contains("Decimal", Qt::CaseInsensitive)){ sType = "DECIMAL";
        
        
          } else if (sType.contains("DateTime", Qt::CaseInsensitive)){ sType = "TIMESTAMP";
          } else if (sType.contains("Bytes", Qt::CaseInsensitive)){ sType = "BYTEA";
          } else sType = "BIGINT";
          

        } else if (bSQLITE){
          if (sType.contains("Boolean", Qt::CaseInsensitive)){ sType = "INTEGER";
          } else if (sType.contains("String", Qt::CaseInsensitive)){ sType = "TEXT";
          } else if (sType.contains("Single", Qt::CaseInsensitive)){ sType = "REAL";
          } else if (sType.contains("Double", Qt::CaseInsensitive)){ sType = "REAL";
          } else if (sType.contains("Float", Qt::CaseInsensitive)){ sType = "REAL";
          } else if (sType.contains("Decimal", Qt::CaseInsensitive)){ sType = "TEXT";
        
        
          } else if (sType.contains("DateTime", Qt::CaseInsensitive)){ sType = "TEXT";
          } else if (sType.contains("Bytes", Qt::CaseInsensitive)){ sType = "BLOB";
          } else sType = "INTEGER";
        }

        int nInsert = sField.length();

        if (ll.size() > 1){
          for (int i = 1; i < ll.size(); i++){


            

            if (ll.at(i).compare("NULL", Qt::CaseInsensitive) == 0){
              
              
              if (bMYSQL){  
                sField += ""; 
              } else if (bPSQL){
                sField += ""; 
              } else if (bSQLITE){
                sField += ""; 
              }
            }
            else if (ll.at(i).compare("NOTNULL", Qt::CaseInsensitive) == 0){ 
              
              
              if (!sField.contains(" NOT NULL")){
                if (bMYSQL){  
                  sField += " NOT NULL";
                } else if (bPSQL){
                  sField += " NOT NULL";
                } else if (bSQLITE){
                  sField += " NOT NULL";
                }
              }
            }
            else if (ll.at(i).compare("UNIQUE", Qt::CaseInsensitive) == 0){
              

              if (bMYSQL){                  
                if (!sMYSQLUnique.isEmpty()) sMYSQLUnique += ", ";
                sMYSQLUnique += sName;
                sType = "VARCHAR(255)"; 
              } else if (bPSQL){
                sField += " UNIQUE";
              } else if (bSQLITE){
                sField += " UNIQUE";
              }
            }
            else if (ll.at(i).compare("PRIMARYKEY", Qt::CaseInsensitive) == 0){
            

          

              if (bMYSQL){  
                
                if (!sPrimaryKey.isEmpty()) sPrimaryKey += ", ";
                sPrimaryKey += sName;

            
                
              } else if (bPSQL){
                
                if (!sPrimaryKey.isEmpty()) sPrimaryKey += ", ";
                sPrimaryKey += sName;
              } else if (bSQLITE){
                if (!sPrimaryKey.isEmpty()) sPrimaryKey += ", ";
                sPrimaryKey += sName;
                sField += " PRIMARY KEY";
              }
              
            }
            else if (ll.at(i).compare("AUTOINCREMENT", Qt::CaseInsensitive) == 0){

              if (bMYSQL && sType == "BIGINT"){  
                if (!sField.contains(" NOT NULL")){
                  sField += " UNSIGNED NOT NULL";
                } else {
                  sField += " UNSIGNED";
                }
                sField += " AUTO_INCREMENT";
              } else if (bPSQL && sType == "BIGINT"){
                sType = " BIGSERIAL";                
              } else if (bSQLITE && sType == "INTEGER"){
                sField += " AUTOINCREMENT"; 
              }

             
            } else {
              sField += " " + ll.at(i);
            }
          }
        }

        sField = sField.insert(nInsert, " " + sType + " ");
        
        sSQL += sField;
      }     

      if (bMYSQL){ 
        sSQL += ", PRIMARY KEY (" + sPrimaryKey + ")";
        if (!sMYSQLUnique.isEmpty()){
          sSQL += ", UNIQUE (" + sMYSQLUnique + ")";
        }
      } else if (bPSQL){
        sSQL += ", PRIMARY KEY (" + sPrimaryKey + ")";
        sSQL2 = " WITH OIDS";
      } else if (bPSQL){
        if (sPrimaryKey.count(",") > 0){
          sSQL = sSQL.replace(" PRIMARY KEY", "");
          sSQL += " CONSTRAINT q7b_primarykey PRIMARY KEY (" + sPrimaryKey + ")";
        }
      }           
                  

    

     
      
      
      QSqlQuery rr(Q7B_Database::databases[Database]);
  
      Q7B_Database::databases[Database].transaction();

      

      sSQL = sSQL.simplified().replace(" , ", ", ");
      sSQL = "CREATE TABLE " + Table + " (\n" + sSQL + "\n)" + sSQL2 + ";";

      Q7B_Database::sLastSQLError = "";
      
      
      if (!rr.exec(sSQL)){ 
        Q7B_Database::sLastSQLError = rr.lastError().text();
        Q7B_Database::sLastSQLCommandFailed[Database] = sSQL;
        Q7B_Database::databases[Database].rollback();
        return false;
      } else {
        Q7B_Database::sLastSQLCommands[Database] += sSQL + "\n";
      }
     
      
      Q7B_Database::databases[Database].commit();

      

      return true;    

    }

    

    return false;
  }

  QStringList FieldNames(QString Table)
  {
    return FieldNames(Q7B_Database::_CurrentDatabase.databaseName(), Table);
  }

  QStringList FieldNames(QString Database, QString Table)
  {
    QStringList ll;

    if (Q7B_Database::databases.contains(Database)){

      QString sSQL = "";
      QSqlQuery rr(Q7B_Database::databases[Database]);

      sSQL = "SELECT * FROM " + Table + ";";

      Q7B_Database::sLastSQLError = "";    
      if (!rr.exec(sSQL)){
        Q7B_Database::sLastSQLError = rr.lastError().text();
        Q7B_Database::sLastSQLCommandFailed[Database] = sSQL;
        return ll;
      } else {
        Q7B_Database::sLastSQLCommands[Database] += sSQL + "\n";

        QSqlRecord ri = rr.record();
        for (int i = 0; i < ri.count(); i++){
          ll << ri.fieldName(i);
        }
      }
      
    }

    return ll;
  }

  QString PrimaryKeyName(QString Table)
  {
    return PrimaryKeyName(Q7B_Database::_CurrentDatabase.databaseName(), Table);
  }

  QString PrimaryKeyName(QString Database, QString Table)
  {
    if (Q7B_Database::databases.contains(Database)){
      return Q7B_Database::getPrimary(Q7B_Database::databases[Database], Table);
    }

    return "";
  }

  bool Empty(QString Table)
  {
    return Empty(Q7B_Database::_CurrentDatabase.databaseName(), Table);
  }

  bool Empty(QString Database, QString Table)
  {
    if (Q7B_Database::databases.contains(Database)){

      QString sSQL = "";
      QSqlQuery rr(Q7B_Database::databases[Database]);

      sSQL = "DELETE FROM " + Table + ";";

      Q7B_Database::sLastSQLError = "";    
      if (!rr.exec(sSQL)){
        Q7B_Database::sLastSQLError = rr.lastError().text();
        Q7B_Database::sLastSQLCommandFailed[Database] = sSQL;
        return false;
      } else {
        Q7B_Database::sLastSQLCommands[Database] += sSQL + "\n";
      }

      return true;
    }

    return false;
  }

  bool Drop(QString Table)
  {
    return Drop(Q7B_Database::_CurrentDatabase.databaseName(), Table);
  }

  bool Drop(QString Database, QString Table)
  {
    if (Q7B_Database::databases.contains(Database)){

      QString sSQL = "";
      QSqlQuery rr(Q7B_Database::databases[Database]);

      sSQL = "DROP TABLE " + Table + ";";

      Q7B_Database::sLastSQLError = "";    
      if (!rr.exec(sSQL)){
        Q7B_Database::sLastSQLError = rr.lastError().text();
        Q7B_Database::sLastSQLCommandFailed[Database] = sSQL;
        return false;
      } else {
        Q7B_Database::sLastSQLCommands[Database] += sSQL + "\n";
      }

      return true;
    }

    return false;
  }


  bool Delete(QString Table, Q7B_Dictionary *Where)
  {
    return Delete(Q7B_Database::_CurrentDatabase.databaseName(), Table, Where);
  }

  bool Delete(QString Database, QString Table, Q7B_Dictionary *Where)
  {

   if (Q7B_Database::databases.contains(Database)){


      QString sWhere = Q7B_Database::getWhere(Database, Where);


      QString sSQL = "";
      QSqlQuery rr(Q7B_Database::databases[Database]);

      sSQL = "DELETE FROM " + Table + " WHERE " + sWhere + ";";

      Q7B_Database::sLastSQLError = "";    
      if (!rr.exec(sSQL)){
        Q7B_Database::sLastSQLError = rr.lastError().text();
        Q7B_Database::sLastSQLCommandFailed[Database] = sSQL;
        return false;
      } else {
        Q7B_Database::sLastSQLCommands[Database] += sSQL + "\n";
      }

      return true;
    }

    return false;
  }

  bool Update(QString Table, Q7B_Dictionary *_Update, Q7B_Dictionary *Where)
  {
    return Update(Q7B_Database::_CurrentDatabase.databaseName(), Table, _Update, Where);
  }

  bool Update(QString Database, QString Table, Q7B_Dictionary *Update, Q7B_Dictionary *Where)
  {
   if (Q7B_Database::databases.contains(Database)){

      QString sUpdate = Q7B_Database::getUpdate(Database, Update);
      QString sWhere = Q7B_Database::getWhere(Database, Where);

      QSqlDriver *driver = Q7B_Database::databases[Database].driver();

      QString sSQL;
      QSqlQuery rr(Q7B_Database::databases[Database]);

      sSQL = "UPDATE " + Table + " SET " + sUpdate + (!sWhere.isEmpty() ? " WHERE " + sWhere : "") + ";";

      Q7B_Database::sLastSQLError = "";    
      if (!rr.exec(sSQL)){
        Q7B_Database::sLastSQLError = rr.lastError().text();
        Q7B_Database::sLastSQLCommandFailed[Database] = sSQL;
        return false;
      } else {
        Q7B_Database::sLastSQLCommands[Database] += sSQL + "\n";
      }

      return true;
    }

    return false;
  }

  bool Insert(QString Table, Q7B_Dictionary *_Insert)
  {
    return Insert(Q7B_Database::_CurrentDatabase.databaseName(), Table, _Insert);
  }

  bool Insert(QString Database, QString Table, Q7B_Dictionary *Insert)
  {

   if (Q7B_Database::databases.contains(Database)){

      QString sFields = Q7B_Database::getInsertFields(Database, Insert);
      QString sValues = Q7B_Database::getInsertValues(Database, Insert);

      QSqlQuery rr(Q7B_Database::databases[Database]);      
      
      QString sSQL = "INSERT INTO " + Table + " (" + sFields + ") VALUES (" + sValues + ");";

      Q7B_Database::sLastSQLError = "";    
      if (!rr.exec(sSQL)){
        Q7B_Database::sLastSQLError = rr.lastError().text();
        Q7B_Database::sLastSQLCommandFailed[Database] = sSQL;
        return false;
      } else {
        Q7B_Database::sLastSQLCommands[Database] += sSQL + "\n";
      }

      return true;
    }

    return false;
  }

};


class Q7B_Records : public QObject
{
  Q_OBJECT
public:

  Q7B_Records()
  {
  }

  ~Q7B_Records()
  {
  }

  QString Open(QString Database, QString TableOrSql)
  {
    return Open(Database, TableOrSql, 0, 0);
  } 

  QString Open(QString Database, QString TableOrSql, Q7B_Dictionary *Where, Q7B_Dictionary *OrderBy)
  {
    if (!Q7B_Database::databases.contains(Database)) return "";

    QString sOrderBy = Q7B_Database::getOrderBy(Database, OrderBy);

    QString sWhere = Q7B_Database::getWhere(Database, Where);

    QSqlQuery *rr = new QSqlQuery(Q7B_Database::databases[Database]);
    QString sSQL = TableOrSql;
    if (!TableOrSql.contains(" ")){
      QString sPrimaryKey = Q7B_Database::getPrimary(Q7B_Database::databases[Database], sSQL);

      QString sOrderBy2;
      if (sOrderBy.isEmpty()){
        sOrderBy2 = " ORDER BY " + sPrimaryKey + " ASC";
      } else {
        sOrderBy2 = " ORDER BY " + sOrderBy;
      }

      if (sWhere.isEmpty()){
        sSQL = "SELECT * FROM " + TableOrSql + sOrderBy2 + ";";
      } else {
        sSQL = "SELECT * FROM " + TableOrSql + " WHERE " + sWhere + sOrderBy2 + ";";
      }
    }

    static qint64 nQueryId = 0;

    nQueryId++;

    QString QueryId = QString("%1").arg(nQueryId);
    Q7B_Database::records[QueryId] = rr;
    Q7B_Database::records_database[QueryId] = Database;

    if (Q7B_Database::records[QueryId]->exec(sSQL)){
      Q7B_Database::sLastSQLCommands[Q7B_Database::records_database[QueryId]] += sSQL + "\n";    
    } else {
      Q7B_Database::sLastSQLError = Q7B_Database::records[QueryId]->lastError().text();
      Q7B_Database::sLastSQLCommandFailed[Q7B_Database::records_database[QueryId]] = sSQL;
      return "";
    }

    int n = Q7B_Database::records[QueryId]->size();

    return QueryId;
  } 

  

  QString Open(QString TableOrSql)
  {
    return Open(Q7B_Database::_CurrentDatabase.databaseName(), TableOrSql);
  } 

  QString Open(QString Table, Q7B_Dictionary *Where)
  {
    return Open(Q7B_Database::_CurrentDatabase.databaseName(), Table, Where, 0);
  } 

  QString Open(QString Table, Q7B_Dictionary *Where, Q7B_Dictionary *OrderBy)
  {
    return Open(Q7B_Database::_CurrentDatabase.databaseName(), Table, Where, OrderBy);
  } 

  QString Open(QString Database, QString Table, Q7B_Dictionary *Where)
  {
    return Open(Database, Table, Where, 0);
  } 
  

  bool Close(QString QueryId)
  {
    if (!Q7B_Database::records.contains(QueryId)) return false;

    delete Q7B_Database::records[QueryId];
    Q7B_Database::records.remove(QueryId);

    Q7B_Database::records_database.remove(QueryId);
    Q7B_Database::records_table.remove(QueryId);


    return true;
  } 

  bool Requery(QString QueryId)
  {
    if (!Q7B_Database::records.contains(QueryId)) return false;

    QString sSQL = Q7B_Database::records[QueryId]->executedQuery();
    if (Q7B_Database::records[QueryId]->exec(sSQL)){
      Q7B_Database::sLastSQLCommands[Q7B_Database::records_database[QueryId]] += sSQL + "\n";
      return true;
    }
    Q7B_Database::sLastSQLError = Q7B_Database::records[QueryId]->lastError().text();
    Q7B_Database::sLastSQLCommandFailed[Q7B_Database::records_database[QueryId]] = sSQL;
    return false;
  } 

  bool First(QString QueryId)
  {
    if (!Q7B_Database::records.contains(QueryId)) return false;

    return Q7B_Database::records[QueryId]->first();
  } 

  bool Next(QString QueryId)
  {
    if (!Q7B_Database::records.contains(QueryId)) return false;

    return Q7B_Database::records[QueryId]->next();
  } 

  bool Previous(QString QueryId)
  {
    if (!Q7B_Database::records.contains(QueryId)) return false;

    return Q7B_Database::records[QueryId]->previous();
  } 

  bool Last(QString QueryId)
  {
    if (!Q7B_Database::records.contains(QueryId)) return false;

    return Q7B_Database::records[QueryId]->last();
  } 

  bool GoTo(QString QueryId, qint64 Position)
  {
    if (!Q7B_Database::records.contains(QueryId)) return false;

    return Q7B_Database::records[QueryId]->seek(Position + 1);
  } 

  qint64 Length(QString QueryId)
  {
    if (!Q7B_Database::records.contains(QueryId)) return false;

    return Q7B_Database::records[QueryId]->size();
  } 

  qint64 Position(QString QueryId)
  {
    if (!Q7B_Database::records.contains(QueryId)) return false;

    return Q7B_Database::records[QueryId]->at() + 1;
  } 


  


  Q7B Value(QString QueryId, QString Field)
  {
     
    if (!Q7B_Database::records.contains(QueryId)) return Q7B_IDNIL();

   
    QSqlRecord ri = Q7B_Database::records[QueryId]->record();
    int n = ri.indexOf(Field);
    if (Q7B_Database::records[QueryId]->isValid() && n >= 0){

      switch(ri.value(n).type()){
        case QVariant::Bool:
          return Q7B_QOBJECT((bool) ri.value(n).toBool());
          break;
        case QVariant::Date: 
        case QVariant::Time: 
        case QVariant::DateTime:  
          return Q7B_QOBJECT(ri.value(n).toDateTime());         
          break;
        case QVariant::Double:
          return Q7B_QOBJECT(ri.value(n).toDouble());
          break;
        case QVariant::Int:
          return Q7B_QOBJECT(ri.value(n).toInt());
          break;
        case QVariant::LongLong:
          return Q7B_QOBJECT(ri.value(n).toLongLong());
          break;
        case QVariant::UInt:
          return Q7B_QOBJECT(ri.value(n).toUInt());
          break;
        case QVariant::ULongLong:
          return Q7B_QOBJECT(ri.value(n).toULongLong());
          break;

        case QVariant::String: 
        default:
          return Q7B_QOBJECT(ri.value(n).toString());
          break;
      }
      
    }

    return Q7B_IDNIL();    
  } 

  QStringList FieldNames(QString QueryId)
  {
    QStringList ll;

    if (!Q7B_Database::records.contains(QueryId)) return ll;
    QSqlRecord ri = Q7B_Database::records[QueryId]->record();
    
    if (!Q7B_Database::records[QueryId]->isActive()) return ll;

    for (int i = 0; i < ri.count(); i++){
      ll << ri.fieldName(i);
    }
    
    return ll;
  }

  

};


class Q7B_Query : public QObject
{
  Q_OBJECT
public:

  Q7B_Query()
  {
  }

  ~Q7B_Query()
  {
  }

  Q7B Command(QString _Command)
  {
    return Command(Q7B_Database::_CurrentDatabase.databaseName(), _Command);
  }

  Q7B Command(QString Database, QString Command)
  {

    QString sSQL = "";
    sSQL = Command;  

    Q7B_Database::sLastSQLError = "";
    QSqlQuery rr(Q7B_Database::databases[Database]);
    if (rr.exec(sSQL)){
      Q7B_Database::sLastSQLCommands[Database] += sSQL + "\n";

      Q7B_Dictionary *dd = new Q7B_Dictionary();
      Q7B q (new Q7B_id(typeid(Q7B_Dictionary).name(), dd));   
      
      int nCount = 0;
      if (rr.first()){

        QSqlRecord r = rr.record();

        do {          
      
          for (int i = 0; i < r.count(); i++){
            
            
            QString ss = QString("%1/%2").arg(nCount + 1).arg(i + 1);
            QString sss = rr.value(i).toString();
            dd->setObject(ss, Q7B_QOBJECT(sss));
          }

          nCount++;
        } while (rr.next());
      }      
        
      return q;
      
    } else {
      Q7B_Database::sLastSQLError = rr.lastError().text();
      Q7B_Database::sLastSQLCommandFailed[Database] = sSQL;    
    }

    return Q7B_IDNIL();  
  }

  bool Run(QString QueryNameOrSql)
  {
    return Run(Q7B_Database::_CurrentDatabase.databaseName(), QueryNameOrSql);
  }

  bool Run(QString Database, QString QueryNameOrSql)
  {
    QString sSQL = "";
   
   
   
      sSQL = QueryNameOrSql;
   

    Q7B_Database::sLastSQLError = "";
    QSqlQuery rr(Q7B_Database::databases[Database]);
    if (rr.exec(sSQL)){
      Q7B_Database::sLastSQLCommands[Database] += sSQL + "\n";
      return true;
    } else {
      Q7B_Database::sLastSQLError = rr.lastError().text();
      Q7B_Database::sLastSQLCommandFailed[Database] = sSQL;
      return false;
    }

    return false;
  }

};


class Q7B_QObject : public QObject
{
  Q_OBJECT
public:
Q7B_QObject(QObject *parent = 0) : QObject (parent)
{  
}

QObject *Sender(){
  return this->sender();
}

};


class Line : public QFrame
{
  Q_OBJECT
public:
Line(QWidget *parent = 0) : QFrame (parent)
{  
}
};


class Q7BMovie : public Phonon::VideoWidget
{
public:
  Q7BMovie(QWidget *parent = 0) : Phonon::VideoWidget(parent)
  {
  }

  void mousePressEvent ( QMouseEvent * e )
  {
    close();
  }

  void keyPressEvent ( QKeyEvent * e ) 
  {
    close();
  }

};


class Q7B_ControlHelper: public QObject
{

  Q_OBJECT
 
public:

Q7B_ControlHelper(Q7B_Control *q7b_su)
{
  q7b_super = q7b_su;
}

public slots:
void frameChanged(int);

private:
  Q7B_Control *q7b_super;

};


class Q7B_Control
{
 
public:

Q7B_Control(QWidget *q7b_su)
{  
  q7b_super = q7b_su;

  movie = 0; moviea = 0; movieb = 0;
  cursoranimation_movie = 0; cursoranimation_moviea = 0; cursoranimation_movieb = 0;  

  Q7B_ControlPrivate = new Q7B_ControlHelper(this);
}

~Q7B_Control()
{
  if (movie) delete movie; if (moviea) delete moviea; if (movieb) delete movieb;
  if (cursoranimation_movie) delete cursoranimation_movie; if (cursoranimation_moviea) delete cursoranimation_moviea; if (cursoranimation_movieb) delete cursoranimation_movieb;

  delete Q7B_ControlPrivate;
}

bool setMyMovie(QWidget *control, QMovie **movie, QByteArray **moviea, QBuffer **movieb, QString n)
{

   if (!(n.contains("/") || n.contains("\\"))){      
     n = qApp->applicationDirPath()+ "/" + n;
   }
   
   
   {
     if (*movie) delete *movie;
     *movie = new QMovie(n);
     if (control && qobject_cast<QLabel *>(control)){
       (*movie)->setScaledSize(control->size());
     } else if (control && qobject_cast<QPushButton *>(control)){
         (*movie)->jumpToFrame(0);
         QPixmap p = (*movie)->currentPixmap();
         (*movie)->jumpToFrame(-1);
         if (!p.isNull()){
           ((QPushButton *)control)->setIconSize(p.size());         
         }
     } else {
       (*movie)->setScaledSize(QSize(32, 32));
     }
   }

   if ((*movie)->isValid()){
      return true;
     
   }
   return false;
}

void setMyIcon(QString n);

void setMyIcon2();

protected:
  QMovie *movie; QByteArray *moviea; QBuffer *movieb;
  QMovie *cursoranimation_movie; QByteArray *cursoranimation_moviea; QBuffer *cursoranimation_movieb;

  Q7B_ControlHelper *Q7B_ControlPrivate;
  QPixmap qpixmap;

private:
  QWidget *q7b_super;
};


class Q7B_Timer : public QObject, public Q7B_Control
{
  Q_OBJECT

public:

  Q7B_Timer() : Q7B_Control(0)
  {        
    

    setProperty("Enabled", true);

  
    

    connect(&t, SIGNAL(timeout()), this, SLOT(_Event()));
    connect(&t, SIGNAL(timeout()), this, SLOT(_SoundEvent()));
  }

  ~Q7B_Timer()
  {
    t.stop();
  }

signals:
  void Event();

public slots:
  
  void _Event()
  {
    emit Event();
  }

  void _SoundEvent()
  {    
    
  }

public:  
 

  QTimer t;
};


class Q7B_ImageButton : public QWidget, public Q7B_Control
{
  Q_OBJECT
public:

Q7B_ImageButton(QWidget *parent = 0) : QWidget (parent), Q7B_Control(this)
{
  Q7B_Control_constructor((QWidget *) this);

  setAutoFillBackground(true);
  QPalette p = palette();
  p.setColor(QPalette::Window, Qt::white);  
  setPalette(p);

  setProperty("Value", ""); setProperty("OldValue", "");

  setProperty("Caption", "");
  setProperty("Icon", "");
  
 

  
  setProperty("Checkable", false);
  setProperty("CheckableExclusive", true);
  setProperty("Checked", false);
  

  setProperty("CheckEnterImage", "");
  setProperty("CheckExitImage", "");
  setProperty("CheckMouseDownImage", "");
  setProperty("CheckMouseUpImage", "");
  setProperty("CheckEnabledImage", "");
  setProperty("CheckDisabledImage", "");

  setProperty("EnterImage", "");
  setProperty("ExitImage", "");
  setProperty("MouseDownImage", "");
  setProperty("MouseUpImage", "");
  setProperty("EnabledImage", "");
  setProperty("DisabledImage", "");

  setProperty("EnterSound", "");
  setProperty("ExitSound", "");
  setProperty("MouseDownSound", "");
  setProperty("MouseUpSound", "");

  setProperty("Scale", false);


  setFocusPolicy(Qt::TabFocus);

  qfocusframe = 0;

  bEventClick = false;


}

void setImageButtonBooleanValue(QString sGroup, Q7B_ImageButton *control, bool b)
{
  if (sGroup.isEmpty()) return;

  if (!b) b = true;

  QObjectList ol = control->parentWidget()->children();

  for (int q = 0; q < ol.size(); q++){

    Q7B_ImageButton *ib = qobject_cast<Q7B_ImageButton *>(ol.at(q));
    if (ib && ib != control){

        bool bb = ib->property("CheckableExclusive").toBool();      

        QString ss = control->property("Group").toString();      

        if (bb == false && ss == sGroup){
          ib->setProperty("Checked", false);

          if (ib->property("Enabled").toBool()){
            ib->setImage(property("EnabledImage").toString());

            
          } else {
            ib->setImage(property("DisabledImage").toString());

            
          }          
        }     
    }
  }
 
  control->setProperty("Checked", b);
}

void setChecked(bool b)
{  
  QString s = this->property("Group").toString();
  if (!s.isEmpty()){
    this->setImageButtonBooleanValue(s, this, b);
  }        

  this->setProperty("Checked", b);

  if (this->property("Checked") == true){
    if (this->property("Enabled") == true){
      
      this->setImage(this->property("CheckedEnabledImage").toString());
    } else {
      
      this->setImage(this->property("CheckedDisabledImage").toString());
    }
  } else {
    if (this->property("Enabled") == true){
      this->setImage(this->property("EnabledImage").toString());
      
    } else {
      this->setImage(this->property("DisabledImage").toString());
      
    }
  }
}

void setImage(QString n)
{  
  setAutoFillBackground(!n.isEmpty());

  QPixmap qpixmap = Q7B_createPixmap(n);

   QBrush b(qpixmap);
   QPalette p = palette();
   p.setBrush(QPalette::Window, b);  
   setPalette(p);



   repaint();
}


void mousePressEvent ( QMouseEvent * e )
{    

  if (property("Enabled") == true){
    QString s = property("MouseDownSound").toString();
    if (!s.isEmpty()){
      Q7B_PlaySound(s);
    }
  }

  QString fn;
  if (property("Enabled") == true){
    

    if (property("Checked") == true){
      fn = property("CheckedMouseDownImage").toString(); 
    } else {
      fn = property("MouseDownImage").toString(); 
    }
  }    



  if (!fn.isEmpty()){
    setImage(fn);
  }

  bEventClick = true;
  Qt::MouseButton bu = e->button();
  emit MouseDown(e->x(), e->y(), e->globalX(), e->globalY(), bu == Qt::LeftButton, bu == Qt::RightButton, bu == Qt::MidButton);
}

void mouseReleaseEvent ( QMouseEvent * e ) 
{
  

  if (property("Enabled") == true){
    QString s = property("MouseUpSound").toString();
    if (!s.isEmpty()){
      Q7B_PlaySound(s);
    }
  }
    
  QString fn;
  if (property("Enabled") == true){
    if (property("Checked") == true){
      fn = property("CheckedMouseUpImage").toString(); 
      if (fn.isEmpty()) fn = property("CheckedEnterImage").toString(); 
    } else {
      fn = property("MouseUpImage").toString();
      if (fn.isEmpty()) fn = property("EnterImage").toString(); 
    }     
  }

  if (!fn.isEmpty()){
    setImage(fn);
  }

  Qt::MouseButton bu = e->button();
  int x = e->x();
  int y = e->y();
  int gx = e->globalX();
  int gy = e->globalY();
  if (bEventClick){
    bEventClick = false;      
    emit Click(x, y, gx, gy, bu == Qt::LeftButton, bu == Qt::RightButton, bu == Qt::MidButton);

    if (property("Enabled") == true){
      if (property("Checkable") == true){
        setChecked(!property("Checked").toBool());
        
      }

      QString s = property("SoundOnEvent").toString();
      if (!s.isEmpty()){
        Q7B_PlaySound(s);
      }

      setFocus(); 
      emit Event();
    }

  }

  emit MouseUp(x, y, gx, gy, bu == Qt::LeftButton, bu == Qt::RightButton, bu == Qt::MidButton);

}

void focusInEvent ( QFocusEvent * e)
{
  if (e->reason() == Qt::TabFocusReason || e->reason() == Qt::BacktabFocusReason){
    qfocusframe = new QFocusFrame(this->parentWidget());
    qfocusframe->setWidget(this);
    qfocusframe->show();
  }
  
  emit GotFocus();
}

void focusOutEvent ( QFocusEvent * e)
{
  if (qfocusframe){
    delete qfocusframe;
    qfocusframe = 0;
  }

  emit LostFocus();

}

void enterEvent ( QEvent * e)
{
  

  QString s = property("EnterSound").toString();

  

  if (!s.isEmpty()){
   
    Q7B_PlaySound(s);
  }

  QString fn;
  if (property("Enabled") == true){
    if (property("Checked") == true){
      fn = property("CheckedEnterImage").toString();         
    } else {
      fn = property("EnterImage").toString();        
    }     
  }

  if (!fn.isEmpty()){
    setImage(fn);
  }

  emit Enter();
}

void leaveEvent ( QEvent * e)
{
  QString s = property("ExitSound").toString();
  if (!s.isEmpty()){
   Q7B_PlaySound(s);
  }

  QString fn;
  if (property("Enabled") == true){
    if (property("Checked") == true){
      fn = property("CheckedeXITImage").toString(); 
      if (!fn.length()) fn = property("CheckedEnabledImage").toString(); 
    } else {
      fn = property("ExitImage").toString();
      if (!fn.length()) fn = property("EnabledImage").toString(); 
    }     
  }

  if (!fn.isEmpty()){
    setImage(fn);
  }

  emit Exit();  
}

void resizeEvent( QResizeEvent *e)
{  
  if (property("Scale") == true){
     setAutoFillBackground(true);
     QPalette p = palette();
     QPixmap pi = p.brush(QPalette::Window).texture();  
     if (!pi.isNull()){
       pi = pi.scaled(width(), height());
       QBrush b(pi);
       p.setBrush(QPalette::Window, b);  
       setPalette(p);
     }
  }

  emit Resize(e->size().width(), e->size().height(), e->oldSize().width(), e->oldSize().height()); 
}


void paintEvent ( QPaintEvent * e)
{
  
  if (property("DrawOnPaint") == true){
    
    QString s = property("Caption").toString();
    QString s2 = property("Icon").toString();
    if (!s.isEmpty() && !s2.isEmpty()){
      QPainter p(this);
      p.setPen(palette().color(QPalette::ButtonText));
      p.setFont(font());
      p.drawText(0, 0, width(), height(), Qt::AlignCenter, s);
      int x = (width() / 4) - qpixmap.width() * 2;
      if (x - 5 < 0) x = 5;
      p.drawPixmap(x, (height() / 2) - (qpixmap.height() / 2), qpixmap);
    } else if (!s.isEmpty()){
      QPainter p(this);
      p.setPen(palette().color(QPalette::ButtonText));
      p.setFont(font());
      p.drawText(0, 0, width(), height(), Qt::AlignCenter, s);
    } else if (!s2.isEmpty()){
      QPainter p(this);
      p.drawPixmap((width() / 2) - (qpixmap.width() / 2), (height() / 2) - (qpixmap.height() / 2), qpixmap);
    }

  }

}

void mouseDoubleClickEvent ( QMouseEvent * e )
{
  Qt::MouseButton bu = e->button();
  emit DblClick(e->x(), e->y(), e->globalX(), e->globalY(), bu == Qt::LeftButton, bu == Qt::RightButton, bu == Qt::MidButton);
}


signals:

void MouseDown(int, int, int, int, bool, bool, bool);
void Click(int, int, int, int, bool, bool, bool);
void Event();
void MouseUp(int, int, int, int, bool, bool, bool);
void GotFocus();
void LostFocus();
void Enter();
void Exit();  
void Resize(int, int, int, int);
void DblClick(int, int, int, int, bool, bool, bool);





private:



QFocusFrame *qfocusframe;
bool bEventClick;

};


class Q7B_TextBox : public QLineEdit, public Q7B_Control
{
  Q_OBJECT
public:

Q7B_TextBox(QWidget *parent = 0) : QLineEdit (parent), Q7B_Control(this)
{
  Q7B_Control_constructor((QWidget *) this);
}

private:

};


class Q7B_CommandButton : public QPushButton, public Q7B_Control
{
  Q_OBJECT
public:

Q7B_CommandButton(QWidget *parent = 0) : QPushButton (parent), Q7B_Control(this)
{
  Q7B_Control_constructor((QWidget *) this);

  setProperty("Caption", "");
  setProperty("Key", "");

  connect(this, SIGNAL(clicked(bool)), this, SLOT(_Event(bool)));
}

public slots:
  
  void _Event(bool)
  {
    emit Event();
  }

signals:

void Event();

private:
  

};


class Q7B_CommandLinkButton : public QCommandLinkButton, public Q7B_Control
{
  Q_OBJECT
public:

Q7B_CommandLinkButton(QWidget *parent = 0) : QCommandLinkButton (parent), Q7B_Control(this)
{
  Q7B_Control_constructor((QWidget *) this);

  connect(this, SIGNAL(clicked(bool)), this, SLOT(_Event(bool)));
}

public slots:
  
  void _Event(bool)
  {
    emit Event();
  }

signals:

void Event();

private:
  

};


class Q7B_ToolButton : public QToolButton, public Q7B_Control
{
  Q_OBJECT
public:

Q7B_ToolButton(QWidget *parent = 0) : QToolButton (parent), Q7B_Control(this)
{
  Q7B_Control_constructor((QWidget *) this);

  connect(this, SIGNAL(clicked(bool)), this, SLOT(_Event(bool)));
}

public slots:
  
  void _Event(bool)
  {
    emit Event();
  }

signals:

void Event();

private:
  

};


class Q7B_CheckBox : public QCheckBox, public Q7B_Control
{
  Q_OBJECT
public:

Q7B_CheckBox(QWidget *parent = 0) : QCheckBox (parent), Q7B_Control(this)
{
  Q7B_Control_constructor((QWidget *) this);

  connect(this, SIGNAL(clicked(bool)), this, SLOT(_Event(bool)));
}

public slots:
  
  void _Event(bool)
  {
    emit Event();
  }

signals:

void Event();

private:
  

};


class Q7B_RadioButton : public QRadioButton, public Q7B_Control
{
  Q_OBJECT
public:

Q7B_RadioButton(QWidget *parent = 0) : QRadioButton (parent), Q7B_Control(this)
{
  Q7B_Control_constructor((QWidget *) this);

  connect(this, SIGNAL(clicked(bool)), this, SLOT(_Event(bool)));
}

public slots:
  
  void _Event(bool)
  {
    emit Event();
  }

signals:

void Event();

private:
  

};


class Q7B_Label : public QLabel, public Q7B_Control
{
  Q_OBJECT
public:

Q7B_Label(QWidget *parent = 0) : QLabel (parent), Q7B_Control(this)
{
  Q7B_Control_constructor((QWidget *) this);
}

private:
  

};


class Q7B_Frame : public QGroupBox, public Q7B_Control
{
  Q_OBJECT
public:

Q7B_Frame(QWidget *parent = 0) : QGroupBox (parent), Q7B_Control(this)
{
  Q7B_Control_constructor((QWidget *) this);
}

private:
  
};


class Q7B_uiClass : public QWidget
{
  Q_OBJECT
public:

Q7B_uiClass(QWidget *parent = 0) : QWidget (parent)
{  
}

private:
  
};


class Q7B_Class : public QObject
{
  Q_OBJECT
public:

Q7B_Class(QObject *parent = 0) : QObject (parent)
{  
}

private:
  
};


class Q7B_Module : public QObject
{
  Q_OBJECT
public:

Q7B_Module(QObject *parent = 0) : QObject (parent)
{  
}

private:
  
};


class Q7B_ImageBox : public QFrame, public Q7B_Control
{
  Q_OBJECT
public:

Q7B_ImageBox(QWidget *parent = 0) : QFrame (parent), Q7B_Control(this)
{
  Q7B_Control_constructor((QWidget *) this);
}

private:
  
};


class Q7B_UdpSocket: public QObject 
{
  Q_OBJECT

public:

  Q7B_UdpSocket()
  {        
  
  

    t = new QUdpSocket(this);
    nPort = 0;
    a = 0; a2 = 0;
   
    connect(t, SIGNAL(readyRead()), this, SLOT(_Event()));
    connect(t, SIGNAL(readyRead()), this, SLOT(_SoundEvent()));
    connect(t, SIGNAL(connected()), this, SLOT(_Open()));
    connect(t, SIGNAL(disconnected()), this, SLOT(_Close()));
    connect(t, SIGNAL(error(QAbstractSocket::SocketError)), this, SLOT(_Error()));
  }

  ~Q7B_UdpSocket()
  {
    delete t;    
  }

signals:
  void Event();
  void Error();
  void Open();
  void Close();

public slots:
  
  void _SoundOnEvent()
  {
    
  }

  void _Event()
  {
    emit Event();
  }

  void _Error()
  {
    emit Error();
  }

  void _Open()
  {
    emit Open();
  }

  void _Close()
  {
    emit Close();
  }

public:  
  

  QUdpSocket *t;
  QHostAddress *a;
  qint64 nPort;

  QHostAddress *a2;
  qint64 nPort2;

  QString sHost;
  
};


class Q7B_Screen: public QWidget
{
    Q_OBJECT
public:
  
Q7B_Screen(QWidget *parent = 0);
~Q7B_Screen();

void focusInEvent (QFocusEvent *e);
void focusOutEvent (QFocusEvent *e);
void hideEvent (QHideEvent *e);

void setWindowIcon2();

void activate();
void deactivate();

void setActiveW();
bool isActivated();

void pressAnyKey(bool bPrintText = true);
void clearLastLine();

void line(bool step, int x1, int y1, 
         bool step2, bool expression, int x2, int y2, 
         bool bColor, int color, bool b, bool bf, bool bStyle, int style);
void color(int forecolor, int backcolor);
void cls(int no);
void beep();
char *inkey(int *nKeyPressed);
void print(const char *s);
void print(const QString & s);
char *input();
int pos();
void locate(int y, int x);
int csrlin();
void setActivated(bool b);


void circle(bool step, int x, int y, int radius, int color, int start, int end, int aspect);
void paint(bool step, int x, int y, int color, char *pattern, int bordercolor, int backcolor);
void viewprint(int no);
void viewscreen(int no);
void window(int no);
void pmap(int no);
void point(int no);
void draw(int no);
void get(int no);
void put(int no);
void key(int no);

void preset(bool step, int x, int y, int color);
void pset(bool step, int x, int y, bool bColor, int color);
void palette(int no);
void sound(int no);
void play(int no);
void view(int no);

void printScreen(bool bDialog);


void test1();
void test2();

bool bHide;

void captureScreen();


public slots:
void aboutToQuit();


private:


QPixmap m2;


void paintEvent(QPaintEvent *);
void timerEvent( QTimerEvent * );

int nCurrentScreen;
int nForecolor;
int nBackcolor;





void incCursorX();
void incCursorY();
void decCursorX();
void decCursorY();


void setCursorX(int n);
void setCursorY(int n);



void keyPressEvent( QKeyEvent * e);
void keyReleaseEvent ( QKeyEvent * e );

void closeEvent ( QCloseEvent * e );

static int abs(int n);


int getCursorX();
int getCursorY();

int nCursorX;
int nCursorY;
bool bCursor;
QFont font;

int nFontWidth;
int nFontHeight;

bool bActivated;
bool bWasActivated;

bool bCTRL;
bool bSHIFT;

int nTimerId;
int nInput;
int nInput2;
QString sInput;
bool bInputted;

int getWidth;
int getHeight;
int getColumn;
int getLine;

QColor colors[256];

QPainter p2;

qreal PI;

};


class Q7BDebugListener : public QObject
{   
  Q_OBJECT

public:

Q7BDebugListener(QObject *parent = 0) : QObject (parent)
{  
}

void init()
{
  static bool bConnected = false;

  if (bConnected) return;
  if (!Q7B_bDebug) return;

  if (QFile::exists(QDir::tempPath() + "/Q7Basic/" + "/q7b_out.txt")){

    bConnected = true;

    QObject::connect(&watch, SIGNAL(fileChanged(const QString &)), this, SLOT(fileChanged(const QString &)));

    while (!QFile::exists(QDir::tempPath() + "/Q7Basic/" + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt")){ qApp->processEvents(QEventLoop::WaitForMoreEvents); }

    watch.addPath(QDir::tempPath() + "/Q7Basic/" + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt");


    QString s;

    QFile f( QDir::tempPath() + "/Q7Basic/" + "/q7b_out.txt");
    if (f.open(QIODevice::ReadOnly)){

     
      QTextStream t(&f);
      s = t.readAll();
      f.close();

      QFile::remove(QDir::tempPath() + "/Q7Basic/" + "/q7b_out.txt");
    }

    if (s.startsWith("breakpoints\n")){
      Q7B_breakpoints.clear();
      s = s.mid(12);

      QStringList l = s.split("\n");
      for (int i = 0; i < l.count() / 2; i++){
      
        QStringList ll = l.at((i * 2 + 1)).split(";");
        Q7B_breakpoints[l.at(i * 2)] = ll;
      }

    }
 
  }

 
  


}

public slots:

  void fileChanged ( const QString  & path)
  {
 

    
    QString s;
    if (QFile::exists(QDir::tempPath() + "/Q7Basic/" + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt")){
      QFile f( QDir::tempPath() + "/Q7Basic/" + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt");
      if (f.open(QIODevice::ReadOnly)){
        QTextStream t(&f);
        s = t.readAll();
        f.close();

        

        
      }
    }

    
    if (!s.isEmpty()){

      if (s.startsWith("Continue")){
        Q7B_bDebugBreak = false;
        return;
      }

      if (s.startsWith("StepInto")){
        Q7B_bStepInto = true;
        Q7B_bDebugBreak = false;
        return;
      }

      if (s.startsWith("StepOut")){
        Q7B_bStepOut = true;
        Q7B_bDebugBreak = false;
        return;
      }

      if (s.startsWith("StepOver")){
        Q7B_bStepOver = true;
        Q7B_bDebugBreak = false;        
        Q7B_sStepOverScope = Q7B_sDebugScope;
        return;
      }

      if (s.startsWith("RunToCursor\n")){

        s = s.mid(12);

        QStringList l = s.split("\n");

 

        if (l.count() == 2){

          Q7B_bRunToCursor = true;
          Q7B_sRunToCursorFile = l.at(0);
          Q7B_sRunToCursorLine = l.at(1);
          Q7B_bDebugBreak = false;
        }

        return;
      }

      if (s.startsWith("Breakpoint\n")){

        s = s.mid(11);

        QStringList l = s.split("\n");

 

        if (l.count() == 2){
          
          if (Q7B_breakpoints.contains(l.at(0))){

            if (Q7B_breakpoints[l.at(0)].contains(l.at(1))){

          

              Q7B_breakpoints[l.at(0)].removeAll(l.at(1));
            } else {
           

              Q7B_breakpoints[l.at(0)].append(l.at(1));
            }

          } else {
           

              Q7B_breakpoints[l.at(0)].append(l.at(1));

          }

        }

        return;
      }


     
    

    
      
      
      
      

    }
  }
  
public:
 QFileSystemWatcher watch;

};

#endif
