
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/
 



#ifndef compiler_h
#define compiler_h








#define QTBASIC






#include <QObject> 




#include <QStringList>
#include <QProcess>
#include <QThread>
#include <QFile>
#include <QFileSystemWatcher>



  #define SLOTESCAPE QString("Q7B_")

  #define DEFAULTTYPE "id"



class Dummy : public QObject
{
Q_OBJECT
public:

Dummy(QObject *parent = 0) : QObject (parent)
{  
  if (file.open(stdout, QIODevice::WriteOnly)){
  }
}

public slots:
  void readyReadStandardOutput();
 
 
  

  void directoryChanged( const QString  & path);
  
public:
QProcess p;
QFile file;

QFileSystemWatcher watch;





};









#ifdef Q_OS_WIN32
  #define WINDOWS

  
    
  

#endif


    extern QString *e;


#ifdef GUIOUTPUT
#include <QtGui>

#else
#include <QtCore>

#endif













#define _BEGIN_ int nSaveTokenPos = nTokenPos; 
#define _BEGIN3_ int nSaveTokenPos3 = nTokenPos; 
#define _DONE_ return true;
#define _END_ nTokenPos = nSaveTokenPos;  return false;
#define _END2_ nTokenPos = nSaveTokenPos; 
#define _END3_ nTokenPos = nSaveTokenPos3; 

#define Q7B_MAX_ARRAYDIM 4

struct _method
{
  QString sScope;
  QString sFileName;
  QString sName;
  QString sRealName; 
  QString sType;
  QString sNativeType;
  QStringList ArgumentsName;
  QStringList ArgumentsType;
  QList<bool> ArgumentsPointer;
  QList<int> ArgumentsArrayCount;   
  QStringList ArrayExpression;

  QString sStatements; 
  QString sNative;   
  QString sDeclareDelegateCall;   
  QString sDeclareClass;   
  bool bClass;
  bool bCallAble;  
  bool bDeclareStatic;    
  bool bDeclareContainsPointer;      
};

struct _pluginmethod
{
  
  QString sFileName;
  QString sPlugin;
  QString sName;
  QString sType;
  QStringList ArgumentsName;
  QStringList ArgumentsType;
  bool bGlobal;
  bool bProperty;
  bool bEvent;  
  
};


struct _pluginconstant
{
  QString sFileName;
  QString sPlugin;
  QString sName;
  bool bGlobal;
};




struct _variable
{
  QString sScope;
  QString sFileName;
  QString sName;
  QString sType;
  QString sConst;
  QString sExpression; 
  int nArrayCount;

};




extern QMap<QString, QString> sFileCachedSource;
extern QMap<QString, QString> sFileCachedDestination;


extern QStringList DeclareEnumValues;
extern QStringList DeclareConst;

extern QMap<QString, QString> sFileCachedSource;

extern QMap<QString, QStringList> EnumTypes;
extern QMap<QString, QString> EnumTypesPrivatePublicGlobal;
extern QMap<QString, QString> EnumTypesExpressions;
extern QMap<QString, QString> EnumTypesFileNames;
extern QString sParsingEnumConst;


extern QStringList TypeTypes;
extern QMap<QString, QString> TypeTypesPrivatePublicGlobal;
extern QMap<QString, QStringList> TypeTypesNames;
extern QMap<QString, QList<QStringList> > TypeTypesArrayExpressions;
extern QMap<QString, QStringList> TypeTypesTypes;
extern QMap<QString, QList<int> > TypeTypesSizes;
extern QMap<QString, QStringList> TypeTypesEncodings;


extern QString sObjCAdditional;

extern QStringList DeclareEnumTypes;

extern bool bArgumentRelease; 
extern bool bArgumentDebug; 



extern bool bCompileItself; 

extern QStringList pluginDirs;

extern QMap<QString, QString> pluginsObjC;
extern QMap<QString, QString> pluginsObjB;

extern QStringList inputFiles;
extern QStringList allTypes;
extern QStringList allFrameworks;

extern QStringList DeclareTypes;
extern QMap<QString, QString> sInput;
extern QString sCurrentFileName;
extern QString sCurrentSub;
extern QString sGlobalObjectPath;
extern int nCurrentLine;
extern int nBlock;


extern QString sGlobalVariable;

extern QMap<QString, bool> inputFilesScannerNotCached;

extern QMap<QString, QString> sPath;
extern QMap<QString, QString> sFileNameForClass;
extern QMap<QString, QString> sClassName;
extern QMap<QString, QString> sSuperClass;



extern QMap<QString, QMap<QString, QMap<QString, QString> > > toolbar_properties;


extern bool bApplication_stdin;

extern bool bOnlyFunction;
extern bool bError;
extern int nPass;

extern bool bLocalSignal;
extern bool bLocalDelegateOrEvent;
extern bool bLocalSub;
extern bool bLocalLoop;
 
extern int nStringPos;
extern int nTokenPos;




extern QStringList objc_keywords;


extern QMap<QString, QString> PluginTypes;
extern QMap<QString, QStringList> PluginAppendix;
extern QMap<QString, QString> PluginSuperClass;

extern QStringList PluginViews;


extern QString sScanner;


extern QMap<QString, QString> sReferences;
extern QMap<QString, QString> sImplementation;
extern QMap<QString, QString> sImplementationVariables;
extern QMap<QString, QString> sGlobalVariables;
extern QMap<QString, QString> sEnumConsts;
extern QMap<QString, QString> sImplementationTypes;
extern QMap<QString, QString> sImplementationMethods;
extern QMap<QString, int> nMYINIT;
extern QMap<QString, QString> sMYINIT;
extern QMap<QString, QString> sMYINIT2;

extern QMap<QString, QStringList> sImplementationVariablesGetterSetter;
extern QMap<QString, QStringList> sImplementationVariablesGetterSetterType;

extern QMap<QString, QString> sInterface;
extern QMap<QString, QString> sInterfacePublicVariables;
extern QMap<QString, QString> sInterfaceGlobalVariables;
extern QMap<QString, QString> sInterfaceEnumConsts;
extern QMap<QString, QString> sInterfaceTypes;
extern QMap<QString, QString> sInterfacePrivateVariables;
extern QMap<QString, QStringList> sOutletsName;
extern QMap<QString, QStringList> sOutletsType;
extern QMap<QString, QStringList> sOutletsSet;

extern QMap<QString, QString> sInterfacePublicMethods;
extern QMap<QString, QString> sInterfacePublicSlots;
extern QMap<QString, QString> sInterfacePrivateMethods;
extern QMap<QString, QString> sInterfacePrivateMethodsSignatures;
extern QMap<QString, QStringList> sInterfaceVariablesGetterSetter;

extern QStringList LocalVariablesName;
extern QStringList LocalVariablesType;
extern QStringList LocalVariablesConst;
extern QStringList LocalVariablesExpression;
extern QList<int> LocalVariablesBlock;
extern QList<int> LocalVariablesArrayCount;
extern QList<int> LocalVariablesLine;

extern QStringList LocalArgumentsName;
extern QStringList LocalArgumentsType;
extern QList<bool> LocalArgumentsPointer;
extern QList<int> LocalArgumentsArrayCount;

extern QMap<QString, QStringList> tokens;


extern QMap<QString, _method>Methods;
extern QMap<QString, _method>DeclareMethods;



extern _method currentMethod;

extern QMap<QString, _pluginmethod>PluginMethods;

extern _pluginmethod currentPluginMethod;


extern QMap<QString, _pluginconstant>PluginConstants;

extern _pluginconstant currentPluginConstant;

extern QStringList scalarTypes;

extern QString sVarNameForOnAction;


extern QMap<QString, int> keywords;
extern QMap<int, QString> keywords2;

extern QMap<QString, _variable>Variables;
extern _variable currentVariable;


extern QMap<QString, QString> transformedTypes;

extern bool bCheckArrayDimension;

extern QString q7b_this;














bool parseConst(QString *sReturnStatements, QString *sReturnType);


bool parseEvents(QString sFileName, QString sName, _method method);



bool Variables_contains(QString sFileName, QString sName);

bool Variables_contains(QString sFileName, QString sName, QString *sType, bool bConstAllowed = true, bool bMustBePublic = false);

bool Methods_contains(QString sFileName, QString sName, QStringList ArgumentsName = QStringList(), bool bMustBePublic = false);

void removeLocalVariables(int nBlock);

void addLocalVariable(QString sName, QString sType, bool bConst, QString sExpression, QStringList ArrayExpression, bool bStatic);

void addScalarType(QString s);

QString getSuperClassName(QString s);

QString convertDeclareTypeToObjB(QString s);

QString convertDeclareTypeFromObjC(QString sCast, bool *bPointer, bool bCalledForCast);

QString getParentClassOfType(QString s);

QString getTransformedBaseType(QString a);

void addTransformedType(QString a, QString b = "");

void addType(QString a);

QString transformType(QString sType);

void addKeyword(QString s);

void addReference(QString sFileName);

void addDeclareEnumValue(QString sName);

void addDeclareEnumType(QString sName);

void addDeclareConst(QString sName);

void addEnumType(QString sFileName, QString sName, QString sPrivatePublicGlobal, QStringList enumconsts, QStringList expressions);

void addTypeType(QString sFileName, QString sName, QString sPrivatePublicGlobal, QStringList names, QStringList types, QList<QStringList>ArrayExpressions, QList<int> sizes, QStringList encodings);

QString getTypeInit(QString sFileName, QString sType, QStringList names, QStringList types, QList<QStringList>ArrayExpressions, bool bDimStatement);

void addVariable(QString sFileName, QString sName, QString sType, QString sPrivatePublicGlobal, bool bConst, QString sExpression, QString sSignalConnect, bool bIBOutlet, bool bSet = false, QStringList ArrayExpression = QStringList(), bool bType = false);

void addSub(QString sFileName, QString sName, QString sStatements, QString sPrivatePublicGlobal, bool bSub = true, QString sType = "", bool bIBAction = false, bool bEvent = false, bool bAction = false, bool bDelegate = false, QStringList ArrayExpression = QStringList());

void addFunction(QString sFileName, QString sSub, QString sStatements, QString sPrivatePublicGlobal, QString sType, bool bDelegate = false, QStringList ArrayExpression = QStringList());

void addDeclareSub(QString sFileName, QString sClass, QString sName, QString sType, QString sNative, bool bDelegate, bool bEvent, bool bStatic, bool bSignal, QString sRealName, bool bContainsPointer, QString sDeclareDelegateCall, QString sNativeType, QString sDeclareDelegateSignature);

bool typeCompatible(QString l, QString r, QString o = "");

QString convertType(QString s);



void scan(QString s);



bool parseStatements(QString *sReturnStatements, bool bOnlyOneStatement = false);



bool parseBuiltin(QString *sReturnStatements, bool bReturn, QString *sReturnType);



QString autoInitForType(QString t, bool bMustMatch = false);



bool parseMulDivMod(QString *sReturnStatements, bool bReturn, QString *sReturnType);

bool parseAddSub(QString *sReturnStatements, bool bReturn, QString *sReturnType);

bool parseExponent(QString *sReturnStatements, bool bReturn, QString *sReturnType);

bool parseShift(QString *sReturnStatements, bool bReturn, QString *sReturnType);

bool parseComparision(QString *sReturnStatements, bool bReturn, QString *sReturnType);

bool parseAnd(QString *sReturnStatements, bool bReturn, QString *sReturnType);

bool parseOr(QString *sReturnStatements, bool bReturn, QString *sReturnType);

bool parseAndAlso(QString *sReturnStatements, bool bReturn, QString *sReturnType);

bool parseOrElse(QString *sReturnStatements, bool bReturn, QString *sReturnType);



bool parseFactor(QString *sReturnStatements, bool bReturn, QString *sReturnType);



bool parseAssignmentOrPropertyCallOrMethodCall(QString *sReturnStatements, QString *sReturnVariable, QString *sReturnType, bool bbRecursive);



bool parseBuiltinPropertyOrMethod(QString *sType, QString *sPropertyOrMethod, QString *sMethodCallExpression, bool bReturn, QString *sReturnType, bool *bPlugin, bool *bProperty, bool *bDeclare);

bool isDesignerClass(QString s);

bool isUiClass(QString s);

bool parseStaticClassIdentifier(const char **sVariable, const char **sType);



bool peekReturn(int nOffset);

bool peekIdentifier(int nOffset, QString s = "");

bool peekTerm(QString s, int nOffset = 0);

bool parseTerm(QString s, bool bAllowSingleDotDot = false);

bool parseTerm(QString *s);

bool parseUntil(QString s, QString s2 = "", QString *s3 = 0);

bool parseUntilNextProcecureHelper();

bool parseUntilNextProcecure(QString s, QString s2 = "");

bool parseString(QString *sString);

bool parseIntegerOrFloat(QString *sNumber);

bool parseDecimal(QString *bc, QString *ad);

bool parseReturn(bool bDotDotOnly = false);

void parseMultiLine();

bool parseIdentifier(QString *sIdentifier, bool bEscape = false);

bool parseIdentifierWithoutEscape(QString *sIdentifier);

bool parseIdentifier(QString sIdentifier);

QString getInitType(QString sIdentifier, QString sType);

bool parseType(QString *sType, QString *sTypeL, QString *sTypeR);

bool parseVariable(QString *sName, QString *sType, QStringList *ArrayExpression, int *nArrayCount, int *nTypeIndex, bool bConstAllowed = true, QString sDontParseUseThis = "");

bool parseTypeType(QString *sName, QString *sType);

bool parseCall(QString sFileName, QString sIdentifier, QString *sReturnStatements, QString sVariable, QString *sReturnType, bool bPlugin, bool bDeclare, bool bFunctionCall = false, bool bDeclareStatic = false, bool bCallCall = false);

bool parseCall(QString sFileName, QString sIdentifier, QString *sReturnStatements, QString *sReturnType, QString sVariable = "", bool bFunctionCall = false, bool bCallCall = false);

bool parseDeclareStaticCall(QString sFileName, QString *sReturnStatements, QString *sReturnType);

bool parseKVC(QString sFileName, QString sIdentifier, QString *sReturnStatements, QString sVariable = "", bool bFunctionCall = false);

bool parseCallCall(QString sFileName, QString sIdentifier, QString *sReturnStatements, QString sVariable = "", bool bFunctionCall = false);

QStringList procedure(QString sReturnType, QString a = "", QString b = "", QString c = "", QString d = "", QString e = "", QString f = "", QString g = "", QString h = "", QString i = "", QString j = "", QString k = "");

bool parseProcedures(QString *sMethodCallExpression, QStringList & expressionTypes);

bool parseOtherClassMethodOrVariable(QString sType, QString *sReturnStatements, bool *bVariable, QString sVariable, QString *sReturnType);

bool parseAssignmentOrPropertyCallOrMethodCall(QString *sReturnStatements);

bool parseExpression(QString *sExpression, bool bReturn, QString *sReturnType, bool bAllowNamedArguments = true);

bool parseExpression(QString *sExpression, QString *sReturnType, bool bAllowNamedArguments = true);

bool parseExpressionBoolean(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionInteger(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionFloat(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionString(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionid(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionList(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionDictionary(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionQWidget(QString *sExpression, bool bAllowNamedArguments = true);

bool parseExpressionDecimal(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionDateTime(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionData(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionRect(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionPoint(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionLong(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionByte(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionSingle(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionDouble(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionNSImage(QString *sExpression, bool bAllowNamedArguments = true);


bool parseExpressionNSView(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionNSWindow(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionNSDrawer(QString *sExpression, bool bAllowNamedArguments = true);
bool parseExpressionNSMenuItem(QString *sExpression, bool bAllowNamedArguments = true);



bool parseCondition(QString *sExpression, bool bReturn, QString *sReturnType);

bool parseCondition(QString *sExpression, QString *sReturnType);

bool parseClassPropertyProcedures(QString NewType, QString *sType, QString *sPropertyOrMethod, QString *sMethodCallExpression, bool bReturn, QString *sReturnType, QMap<QString, QString> & properties, QMap<QString, QStringList> & procedures);

bool parseClass(QString *sReturnStatements, bool bReturn, QString *sReturnType);

bool parseClass(QString *sReturnStatements);

bool parseBuiltin(QString *sReturnStatements);

bool parseDeclareSub(bool bDelegate, bool bEvent, bool bSignal);

QStringList parseArrayDimReDim(bool bEmptyAllowed);



int compile(int argc, char *argv[]);

int make(QString sOverrideMakePath);

QString build(const QString & sPath, bool bBuildForCompiler);

void compiler_Started();
void compiler_Error(const QString & sError);
void compiler_Finished();
void mystdout(QString s);



bool PluginMethods_contains(QString sFileName, QString sName, QStringList ArgumentsName, bool bGlobalAllowedOnly, bool bProperty);

void addPluginSub(QString sFileName, QString sName, QStringList LocalArgumentsName, QStringList LocalArgumentsType, QString sType, bool bGlobal, bool bProperty, bool bEvent);

bool PluginConstants_contains(QString sPlugin, QString sName, bool bGlobalAllowedOnly);

void addPluginConstant(QString sFileName, QString sName, bool bGlobal);

QString getPluginChangeExtension(QString sFilename);

QString getPluginName(QString sFilename, bool bDontAppendDotAndClassName = true);

QString getPluginFileName(QString sFilename);

QString getPluginNameObjB(QString sFilename);

QString getPluginGlobalNameObjB(QString sPluginName);

void errorPlugin(QString sCurrentFileName, QString sPluginCode, int nPos, QString s);

void loadPlugin(QString sPath);

bool parsePlugin(QString & sPlugin, int *nPos, QString *sIdentifier);

bool parsePluginType(QString & sPlugin, int *nPos, QString *sIdentifier);

bool parsePlugin(QString & sPlugin, int *nPos, QString sMatch);

bool parsePluginConstantOrMethodOrProperty(QString *sName, bool bOnlyMethod, QString sObjectVariable, bool *bProperty);



bool copyDir (const QString& from, const QString& to);

void copyResourceFolder(QString & sResourceFiles, QString sPath, QString sPathTo, QString sPrefix);

QString Cast(QString sType, QString & sCast2);

QString Escape(QString s, QString sEscape);

QString Unescape(QString s);

QString getPath(QString s);

QString getFileName(QString s);

QString getName(QString s);

QString getExtension(QString s);

QString getFileNameForClass(QString s);

QString getClassName(QString s);

QString cocoaType2objb(QString sType);

QString LoadFile(QString sFile);

QStringList LoadFileAsStringList(QString sFile);

void SaveFile(QString sFile, QString s, bool bUTF8);

void SaveFile(QString sFile, QStringList sl);

void error(QString s, bool bDetailedInfo = true);

void CreateImportForObjCAdditional(QString sPath);

QString plainString(QString s);

QString addINFO();

bool copyIfNeeded(QString s, QString s2, bool bContentOnly = false);

QString POINTER(QString s);

QString NOTPOINTER(QString s);

#endif
