
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/
 

#ifndef UI_FINDREPLACEFILE_H
#define UI_FINDREPLACEFILE_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QCheckBox>
#include <QtGui/QComboBox>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QHBoxLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>
#include <QtGui/QSpacerItem>
#include <QtGui/QTableWidget>
#include <QtGui/QVBoxLayout>

QT_BEGIN_NAMESPACE

class Ui_FindReplaceFile
{
public:
    QVBoxLayout *verticalLayout_3;
    QGridLayout *gridLayout;
    QVBoxLayout *verticalLayout_2;
    QHBoxLayout *horizontalLayout;
    QLabel *label;
    QComboBox *cbFind;
    QHBoxLayout *horizontalLayout_3;
    QLabel *label_2;
    QComboBox *cbReplace;
    QCheckBox *cbIgnoreCase;
    QCheckBox *cbIgnoreCommentLines;
    QCheckBox *cbCurrentFileOnly;
    QVBoxLayout *verticalLayout;
    QPushButton *FindInFile;
    QPushButton *ReplaceInFile;
    QPushButton *Close;
    QSpacerItem *verticalSpacer;
    QLabel *lInfo;
    QSpacerItem *horizontalSpacer;
    QTableWidget *tableWidget;

    void setupUi(QDialog *Dialog)
    {
        if (Dialog->objectName().isEmpty())
            Dialog->setObjectName(QString::fromUtf8("Dialog"));
        Dialog->resize(417, 425);
        Dialog->setMinimumSize(QSize(257, 120));
        Dialog->setMaximumSize(QSize(16777215, 600));
        verticalLayout_3 = new QVBoxLayout(Dialog);
        verticalLayout_3->setSpacing(0);
        verticalLayout_3->setContentsMargins(6, 6, 6, 6);
        verticalLayout_3->setObjectName(QString::fromUtf8("verticalLayout_3"));
        gridLayout = new QGridLayout();
        gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
        verticalLayout_2 = new QVBoxLayout();
        verticalLayout_2->setObjectName(QString::fromUtf8("verticalLayout_2"));
        horizontalLayout = new QHBoxLayout();
        horizontalLayout->setObjectName(QString::fromUtf8("horizontalLayout"));
        label = new QLabel(Dialog);
        label->setObjectName(QString::fromUtf8("label"));
        QSizePolicy sizePolicy(QSizePolicy::Fixed, QSizePolicy::Preferred);
        sizePolicy.setHorizontalStretch(0);
        sizePolicy.setVerticalStretch(0);
        sizePolicy.setHeightForWidth(label->sizePolicy().hasHeightForWidth());
        label->setSizePolicy(sizePolicy);

        horizontalLayout->addWidget(label);

        cbFind = new QComboBox(Dialog);
        cbFind->setObjectName(QString::fromUtf8("cbFind"));
        cbFind->setEditable(true);

        horizontalLayout->addWidget(cbFind);


        verticalLayout_2->addLayout(horizontalLayout);

        horizontalLayout_3 = new QHBoxLayout();
        horizontalLayout_3->setObjectName(QString::fromUtf8("horizontalLayout_3"));
        label_2 = new QLabel(Dialog);
        label_2->setObjectName(QString::fromUtf8("label_2"));
        sizePolicy.setHeightForWidth(label_2->sizePolicy().hasHeightForWidth());
        label_2->setSizePolicy(sizePolicy);

        horizontalLayout_3->addWidget(label_2);

        cbReplace = new QComboBox(Dialog);
        cbReplace->setObjectName(QString::fromUtf8("cbReplace"));
        cbReplace->setEditable(true);

        horizontalLayout_3->addWidget(cbReplace);


        verticalLayout_2->addLayout(horizontalLayout_3);

        cbIgnoreCase = new QCheckBox(Dialog);
        cbIgnoreCase->setObjectName(QString::fromUtf8("cbIgnoreCase"));

        verticalLayout_2->addWidget(cbIgnoreCase);

        cbIgnoreCommentLines = new QCheckBox(Dialog);
        cbIgnoreCommentLines->setObjectName(QString::fromUtf8("cbIgnoreCommentLines"));

        verticalLayout_2->addWidget(cbIgnoreCommentLines);

        cbCurrentFileOnly = new QCheckBox(Dialog);
        cbCurrentFileOnly->setObjectName(QString::fromUtf8("cbCurrentFileOnly"));

        verticalLayout_2->addWidget(cbCurrentFileOnly);


        gridLayout->addLayout(verticalLayout_2, 0, 0, 1, 1);

        verticalLayout = new QVBoxLayout();
        verticalLayout->setObjectName(QString::fromUtf8("verticalLayout"));
        FindInFile = new QPushButton(Dialog);
        FindInFile->setObjectName(QString::fromUtf8("FindInFile"));
        QSizePolicy sizePolicy1(QSizePolicy::Fixed, QSizePolicy::Fixed);
        sizePolicy1.setHorizontalStretch(0);
        sizePolicy1.setVerticalStretch(0);
        sizePolicy1.setHeightForWidth(FindInFile->sizePolicy().hasHeightForWidth());
        FindInFile->setSizePolicy(sizePolicy1);
        FindInFile->setMinimumSize(QSize(100, 0));

        verticalLayout->addWidget(FindInFile);

        ReplaceInFile = new QPushButton(Dialog);
        ReplaceInFile->setObjectName(QString::fromUtf8("ReplaceInFile"));
        sizePolicy1.setHeightForWidth(ReplaceInFile->sizePolicy().hasHeightForWidth());
        ReplaceInFile->setSizePolicy(sizePolicy1);
        ReplaceInFile->setMinimumSize(QSize(100, 0));

        verticalLayout->addWidget(ReplaceInFile);

        Close = new QPushButton(Dialog);
        Close->setObjectName(QString::fromUtf8("Close"));
        sizePolicy1.setHeightForWidth(Close->sizePolicy().hasHeightForWidth());
        Close->setSizePolicy(sizePolicy1);
        Close->setMinimumSize(QSize(100, 0));

        verticalLayout->addWidget(Close);

        verticalSpacer = new QSpacerItem(20, 40, QSizePolicy::Minimum, QSizePolicy::Expanding);

        verticalLayout->addItem(verticalSpacer);


        gridLayout->addLayout(verticalLayout, 0, 2, 1, 1);

        lInfo = new QLabel(Dialog);
        lInfo->setObjectName(QString::fromUtf8("lInfo"));

        gridLayout->addWidget(lInfo, 1, 0, 1, 1);

        horizontalSpacer = new QSpacerItem(40, 20, QSizePolicy::Minimum, QSizePolicy::Minimum);

        gridLayout->addItem(horizontalSpacer, 0, 1, 1, 1);


        verticalLayout_3->addLayout(gridLayout);

        tableWidget = new QTableWidget(Dialog);
        if (tableWidget->columnCount() < 3)
            tableWidget->setColumnCount(3);
        QTableWidgetItem *__qtablewidgetitem = new QTableWidgetItem();
        tableWidget->setHorizontalHeaderItem(0, __qtablewidgetitem);
        QTableWidgetItem *__qtablewidgetitem1 = new QTableWidgetItem();
        tableWidget->setHorizontalHeaderItem(1, __qtablewidgetitem1);
        QTableWidgetItem *__qtablewidgetitem2 = new QTableWidgetItem();
        tableWidget->setHorizontalHeaderItem(2, __qtablewidgetitem2);
        tableWidget->setObjectName(QString::fromUtf8("tableWidget"));
        tableWidget->setFrameShape(QFrame::StyledPanel);
        tableWidget->setAlternatingRowColors(true);

        verticalLayout_3->addWidget(tableWidget);


        retranslateUi(Dialog);
        QObject::connect(Close, SIGNAL(clicked()), Dialog, SLOT(accept()));

        QMetaObject::connectSlotsByName(Dialog);
    } 

    void retranslateUi(QDialog *Dialog)
    {
        Dialog->setWindowTitle(QApplication::translate("FindReplaceFile", "Find File / Replace File", 0, QApplication::UnicodeUTF8));
        label->setText(QApplication::translate("FindReplaceFile", "Search for:    ", 0, QApplication::UnicodeUTF8));
        label_2->setText(QApplication::translate("FindReplaceFile", "Replace with:", 0, QApplication::UnicodeUTF8));
        cbIgnoreCase->setText(QApplication::translate("FindReplaceFile", "Match case", 0, QApplication::UnicodeUTF8));
        cbIgnoreCommentLines->setText(QApplication::translate("FindReplaceFile", "Ignore Comment Lines", 0, QApplication::UnicodeUTF8));
        cbCurrentFileOnly->setText(QApplication::translate("FindReplaceFile", "Current File Only ", 0, QApplication::UnicodeUTF8));
        FindInFile->setText(QApplication::translate("FindReplaceFile", "Find In File", 0, QApplication::UnicodeUTF8));
        ReplaceInFile->setText(QApplication::translate("FindReplaceFile", "Replace In File", 0, QApplication::UnicodeUTF8));
        Close->setText(QApplication::translate("FindReplaceFile", "Close", 0, QApplication::UnicodeUTF8));
        lInfo->setText(QString());
        QTableWidgetItem *___qtablewidgetitem = tableWidget->horizontalHeaderItem(0);
        ___qtablewidgetitem->setText(QApplication::translate("FindReplaceFile", "Match", 0, QApplication::UnicodeUTF8));
        QTableWidgetItem *___qtablewidgetitem1 = tableWidget->horizontalHeaderItem(1);
        ___qtablewidgetitem1->setText(QApplication::translate("FindReplaceFile", "File", 0, QApplication::UnicodeUTF8));
        QTableWidgetItem *___qtablewidgetitem2 = tableWidget->horizontalHeaderItem(2);
        ___qtablewidgetitem2->setText(QApplication::translate("FindReplaceFile", "Line", 0, QApplication::UnicodeUTF8));
    } 

};

namespace Ui {
    class FindReplaceFile: public Ui_FindReplaceFile {};
} 

QT_END_NAMESPACE

#endif 
