
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/
 #include "Q7BRuntime.h"

#include "Global.h"
#include "Q7BCodeView.h"

#include "Q7BCompiler.h"

#include <typeinfo>
#include "Application.h"

#include "MainWindow.h"

MainWindow *q7b_MainWindow_sharedSingleton = 0;
Q7B q7b_MainWindow_sharedSingletonQ7B;
bool q7b_MainWindow_sharedSingletonFinalized = false;
bool q7b_MainWindow_sharedSingletonInit = false;
extern Q7B Q7B_idGLOBAL;
extern Q7B Q7B_idAPPLICATION;
extern Q7B Q7B_idSTATUSBAR;
extern Q7B Q7B_idSOUNDS;
extern Q7B Q7B_idDATABASE;
extern Q7B Q7B_idTABLE;
extern Q7B Q7B_idRECORDS;
extern Q7B Q7B_idQUERY;
extern Q7B Q7B_idPIXMAPS;
extern Q7B Q7B_idCOLORS;
extern Q7B Q7B_idFONTS;
extern Q7B Q7B_idTOOLBAR;
extern Q7B Q7B_idSYSTEMTRAY;
extern Q7B Q7B_idMAINWINDOW;
extern Q7B Q7B_idDEBUG;
extern Q7B Q7B_idFILE;
extern Q7B Q7B_idPREFERENCES;
extern Q7B Q7B_idDIR;
extern Q7B Q7B_idDESKTOP;
extern Q7B Q7B_idOPENFILEDIALOG;
extern Q7B Q7B_idSAVEFILEDIALOG;
extern Q7B Q7B_idCOLORDIALOG;
extern Q7B Q7B_idFONTDIALOG;
extern Q7B Q7B_idPROGRESSDIALOG;
extern Q7B Q7B_idINPUTDIALOG;
extern Q7B Q7B_idMESSAGEBOX;
extern Q7B Q7B_idOS;
#define CommandButton Q7B_CommandButton
#define CommandLinkButton Q7B_CommandLinkButton
#define ImageButton Q7B_ImageButton
#define ToolButton Q7B_ToolButton
#define CheckBox Q7B_CheckBox
#define RadioButton Q7B_RadioButton
#define Label Q7B_Label
#define Frame Q7B_Frame
#define ImageBox Q7B_ImageBox
#define TextBox Q7B_TextBox
#define uiClass Q7B_uiClass
#define Class Q7B_Class
#define Module Q7B_Module
#define Control QWidget
#include "Project.h"

#include "ui_MainWindow.h"

MainWindow::MainWindow(Q7B _q7b_this, QWidget *parent)
 : QMainWindow(parent), ui(new Ui::MainWindow)
{
q7b_this = _q7b_this;
  ui->setupUi(this);
  Q7B q;
  QObject *o;
  o = findChild<QObject *>("toolBar"); if (o){ q = Q7B(new Q7B_id(typeid(QToolBar).name(), o)); toolBar = q; }
  o = findChild<QObject *>("menuRecent_Projects"); if (o){ q = Q7B(new Q7B_id(typeid(QMenu).name(), o)); menuRecent_Projects = q; }
  o = findChild<QObject *>("actionLast_Error"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionLast_Error = q; }
  o = findChild<QObject *>("menuExamples"); if (o){ q = Q7B(new Q7B_id(typeid(QMenu).name(), o)); menuExamples = q; }
  o = findChild<QObject *>("menuWindows"); if (o){ q = Q7B(new Q7B_id(typeid(QMenu).name(), o)); menuWindows = q; }
  o = findChild<QObject *>("menuConfiguration"); if (o){ q = Q7B(new Q7B_id(typeid(QMenu).name(), o)); menuConfiguration = q; }
  o = findChild<QObject *>("actionMainWindow_ui_2"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionMainWindow_ui_2 = q; }
  o = findChild<QObject *>("menuUi_Files"); if (o){ q = Q7B(new Q7B_id(typeid(QMenu).name(), o)); menuUi_Files = q; }
  o = findChild<QObject *>("actionCopy"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionCopy = q; }
  o = findChild<QObject *>("actionCut"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionCut = q; }
  o = findChild<QObject *>("actionUndo"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionUndo = q; }
  o = findChild<QObject *>("actionRedo"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionRedo = q; }
  o = findChild<QObject *>("actionDelete"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionDelete = q; }
  o = findChild<QObject *>("actionPaste"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionPaste = q; }
  o = findChild<QObject *>("actionTo_UPPERCASE"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionTo_UPPERCASE = q; }
  o = findChild<QObject *>("actionTo_lowercase"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionTo_lowercase = q; }
  o = findChild<QObject *>("actionComment"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionComment = q; }
  o = findChild<QObject *>("actionUncomment"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionUncomment = q; }
  o = findChild<QObject *>("actionShift_Left"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionShift_Left = q; }
  o = findChild<QObject *>("actionShift_Right"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionShift_Right = q; }
  o = findChild<QObject *>("actionRun"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionRun = q; }
  o = findChild<QObject *>("actionBuild"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionBuild = q; }
  o = findChild<QObject *>("actionStop"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionStop = q; }
  o = findChild<QObject *>("actionClean_RebuildAll"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionClean_RebuildAll = q; }
  o = findChild<QObject *>("actionDebug"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionDebug = q; }
  o = findChild<QObject *>("actionDeploy"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionDeploy = q; }
  o = findChild<QObject *>("actionStep_Into"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionStep_Into = q; }
  o = findChild<QObject *>("actionStep_Over"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionStep_Over = q; }
  o = findChild<QObject *>("actionStep_Out"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionStep_Out = q; }
  o = findChild<QObject *>("actionRun_To_Cursor"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionRun_To_Cursor = q; }
  o = findChild<QObject *>("dockDebug"); if (o){ q = Q7B(new Q7B_id(typeid(QDockWidget).name(), o)); dockDebug = q; }
  o = findChild<QObject *>("dockLog"); if (o){ q = Q7B(new Q7B_id(typeid(QDockWidget).name(), o)); dockLog = q; }
  o = findChild<QObject *>("dockCompiler"); if (o){ q = Q7B(new Q7B_id(typeid(QDockWidget).name(), o)); dockCompiler = q; }
  o = findChild<QObject *>("plainTextEditLog"); if (o){ q = Q7B(new Q7B_id(typeid(QPlainTextEdit).name(), o)); plainTextEditLog = q; }
  o = findChild<QObject *>("plainTextEditCompiler"); if (o){ q = Q7B(new Q7B_id(typeid(QPlainTextEdit).name(), o)); plainTextEditCompiler = q; }
if (q7b_MainWindow_sharedSingletonInit){ q7b_MainWindow_sharedSingletonInit = false; Q7B_idMAINWINDOW = q7b_MainWindow_sharedSingletonQ7B = q7b_this = Q7B(new Q7B_id(typeid(MainWindow).name(), this)); } else q7b_this = Q7B(new Q7B_id(typeid(MainWindow).name(), this)); 
aRecentProjects = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
_nCountFilesToCompile = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
sQtVersion = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT("4.7.0")));
sMingwQtVersion = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT("2010.05")));
sVCDir = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
sQtMINGWDir = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
sQtDir = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
statusBar = Q7B__QLABEL(Q7B_QLABEL_INIT(this, "statusBar"));
progressBar = Q7B__QPROGRESSBAR(Q7B_QPROGRESSBAR_INIT(this, "progressBar"));
tb_uilist = Q7B__QTOOLBUTTON(Q7B_QTOOLBUTTON_INIT(this, "tb_uilist"));
mUIFiles = Q7B__QMENU(Q7B_QMENU_INIT(this, "mUIFiles"));
lUIFiles = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
myDebugWindow = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
DebugStack = Q7B__QCOMBOBOX(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
DebugGlobal = Q7B__QTABLEWIDGET(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
DebugLocal = Q7B__QTABLEWIDGET(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
DebugMe = Q7B__QTABLEWIDGET(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
testList = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
sFind = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
Compiler = Q7B__QOBJECT(Q7B_QOBJECT("Q7BCompiler", new Q7BCompiler()));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(Started(int)), this, SLOT(Q7B_on_Compiler_Started_(int)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(Compiled(const QString&, int)), this, SLOT(Q7B_on_Compiler_Compiled_(const QString&, int)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(Finished(int)), this, SLOT(Q7B_on_Compiler_Finished_(int)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(Error(const QString&)), this, SLOT(Q7B_on_Compiler_Error_(const QString&)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(BreakpointReached(QString, QString)), this, SLOT(Q7B_on_Compiler_BreakpointReached_(QString, QString)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(ReadyForDebugging()), this, SLOT(Q7B_on_Compiler_ReadyForDebugging_()));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(StandardOutput(QString)), this, SLOT(Q7B_on_Compiler_StandardOutput_(QString)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(StandardError(QString)), this, SLOT(Q7B_on_Compiler_StandardError_(QString)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(StandardOutputOfCompiler(QString)), this, SLOT(Q7B_on_Compiler_StandardOutputOfCompiler_(QString)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(StandardErrorOfCompiler(QString)), this, SLOT(Q7B_on_Compiler_StandardErrorOfCompiler_(QString)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(CompilerOrApplicationFinished(bool)), this, SLOT(Q7B_on_Compiler_CompilerOrApplicationFinished_(bool)));
bCompilerError = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
bBlockLastPosition = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
sLastPositionFile = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
nLastPositionLine = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
sLastErrorText = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT("")));
sLastErrorFile = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
nLastErrorLine = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
bDebug = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
bRunOrBuild = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
bBuildOnly = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
gcc = Q7B__QACTION(Q7B_QACTION_INIT(this, "gcc"));
vs = Q7B__QACTION(Q7B_QACTION_INIT(this, "vs"));
                      Q7BS("MainWindow.QMainWindow", "Init", "94", 0);
                      Q7BS("MainWindow.QMainWindow", "Init", "101", 1);
this->UpdateRecentProjects(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(""))));
                      Q7BS("MainWindow.QMainWindow", "Init", "103", 1);
this->DoActions();
                      Q7BS("MainWindow.QMainWindow", "Init", "105", 1);
Q7B_QPLAINTEXTEDIT_READONLY(plainTextEditLog, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "Init", "107", 1);
Q7B_ASSIGNMENT(&gcc, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(menuConfiguration, Q7B_QOBJECT("GCC C/C++ Compiler")))));
                      Q7BS("MainWindow.QMainWindow", "Init", "108", 1);
Q7B_QACTION_TAG(gcc, Q7B_QOBJECT("gcc"));
                      Q7BS("MainWindow.QMainWindow", "Init", "109", 1);
Q7B_QACTION_CHECKABLE(gcc, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "Init", "110", 1);
Q7B_QACTION_CHECKED(gcc, Q7B_QOBJECT((Q7B_CBOOLEAN(Q7B_PREFERENCES_BOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("gcc"))) || Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_PREFERENCES_BOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("vs"))))))));
                      Q7BS("MainWindow.QMainWindow", "Init", "111", 1);
Q7B_PREFERENCES_SETBOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("gcc"), Q7B_QOBJECT(Q7B_QACTION_CHECKED(gcc)));
                      Q7BS("MainWindow.QMainWindow", "Init", "113", 1);
Q7B_ASSIGNMENT(&vs, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(menuConfiguration, Q7B_QOBJECT("VS C/C++ Compiler")))));
                      Q7BS("MainWindow.QMainWindow", "Init", "114", 1);
Q7B_QACTION_TAG(vs, Q7B_QOBJECT("vs"));
                      Q7BS("MainWindow.QMainWindow", "Init", "115", 1);
Q7B_QACTION_CHECKABLE(vs, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "Init", "116", 1);
Q7B_QACTION_CHECKED(vs, Q7B_QOBJECT(Q7B_PREFERENCES_BOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("vs"))));
                      Q7BS("MainWindow.QMainWindow", "Init", "117", 1);
Q7B_PREFERENCES_SETBOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("vs"), Q7B_QOBJECT(Q7B_QACTION_CHECKED(vs)));
                      Q7BS("MainWindow.QMainWindow", "Init", "119", 1);
if (Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_OS_ISWINDOWS(Q7B_idOS))))){
                      Q7BS("MainWindow.QMainWindow", "Init", "120", 1);
Q7B_QACTION_ENABLED(vs, Q7B_QOBJECT(false));
}
                      Q7BS("MainWindow.QMainWindow", "Init", "125", 1);
QTimer::singleShot(Q7B_toInteger2(Q7B_QOBJECT(10)), this, SLOT(Q7B_on_ProjectOpen()));
                      Q7BS("MainWindow.QMainWindow", "Init", "127", 1);
return;
                      Q7BS("MainWindow.QMainWindow", "Init", "132", 2);
}
MainWindow::MainWindow(QWidget *parent)
 : QMainWindow(parent), ui(new Ui::MainWindow)
{
q7b_this = Q7B(new Q7B_id(typeid(MainWindow).name(), this, false));
  ui->setupUi(this);
  Q7B q;
  QObject *o;
  o = findChild<QObject *>("toolBar"); if (o){ q = Q7B(new Q7B_id(typeid(QToolBar).name(), o)); toolBar = q; }
  o = findChild<QObject *>("menuRecent_Projects"); if (o){ q = Q7B(new Q7B_id(typeid(QMenu).name(), o)); menuRecent_Projects = q; }
  o = findChild<QObject *>("actionLast_Error"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionLast_Error = q; }
  o = findChild<QObject *>("menuExamples"); if (o){ q = Q7B(new Q7B_id(typeid(QMenu).name(), o)); menuExamples = q; }
  o = findChild<QObject *>("menuWindows"); if (o){ q = Q7B(new Q7B_id(typeid(QMenu).name(), o)); menuWindows = q; }
  o = findChild<QObject *>("menuConfiguration"); if (o){ q = Q7B(new Q7B_id(typeid(QMenu).name(), o)); menuConfiguration = q; }
  o = findChild<QObject *>("actionMainWindow_ui_2"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionMainWindow_ui_2 = q; }
  o = findChild<QObject *>("menuUi_Files"); if (o){ q = Q7B(new Q7B_id(typeid(QMenu).name(), o)); menuUi_Files = q; }
  o = findChild<QObject *>("actionCopy"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionCopy = q; }
  o = findChild<QObject *>("actionCut"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionCut = q; }
  o = findChild<QObject *>("actionUndo"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionUndo = q; }
  o = findChild<QObject *>("actionRedo"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionRedo = q; }
  o = findChild<QObject *>("actionDelete"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionDelete = q; }
  o = findChild<QObject *>("actionPaste"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionPaste = q; }
  o = findChild<QObject *>("actionTo_UPPERCASE"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionTo_UPPERCASE = q; }
  o = findChild<QObject *>("actionTo_lowercase"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionTo_lowercase = q; }
  o = findChild<QObject *>("actionComment"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionComment = q; }
  o = findChild<QObject *>("actionUncomment"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionUncomment = q; }
  o = findChild<QObject *>("actionShift_Left"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionShift_Left = q; }
  o = findChild<QObject *>("actionShift_Right"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionShift_Right = q; }
  o = findChild<QObject *>("actionRun"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionRun = q; }
  o = findChild<QObject *>("actionBuild"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionBuild = q; }
  o = findChild<QObject *>("actionStop"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionStop = q; }
  o = findChild<QObject *>("actionClean_RebuildAll"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionClean_RebuildAll = q; }
  o = findChild<QObject *>("actionDebug"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionDebug = q; }
  o = findChild<QObject *>("actionDeploy"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionDeploy = q; }
  o = findChild<QObject *>("actionStep_Into"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionStep_Into = q; }
  o = findChild<QObject *>("actionStep_Over"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionStep_Over = q; }
  o = findChild<QObject *>("actionStep_Out"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionStep_Out = q; }
  o = findChild<QObject *>("actionRun_To_Cursor"); if (o){ q = Q7B(new Q7B_id(typeid(QAction).name(), o)); actionRun_To_Cursor = q; }
  o = findChild<QObject *>("dockDebug"); if (o){ q = Q7B(new Q7B_id(typeid(QDockWidget).name(), o)); dockDebug = q; }
  o = findChild<QObject *>("dockLog"); if (o){ q = Q7B(new Q7B_id(typeid(QDockWidget).name(), o)); dockLog = q; }
  o = findChild<QObject *>("dockCompiler"); if (o){ q = Q7B(new Q7B_id(typeid(QDockWidget).name(), o)); dockCompiler = q; }
  o = findChild<QObject *>("plainTextEditLog"); if (o){ q = Q7B(new Q7B_id(typeid(QPlainTextEdit).name(), o)); plainTextEditLog = q; }
  o = findChild<QObject *>("plainTextEditCompiler"); if (o){ q = Q7B(new Q7B_id(typeid(QPlainTextEdit).name(), o)); plainTextEditCompiler = q; }
if (q7b_MainWindow_sharedSingletonInit){ q7b_MainWindow_sharedSingletonInit = false; Q7B_idMAINWINDOW = q7b_MainWindow_sharedSingletonQ7B = q7b_this = Q7B(new Q7B_id(typeid(MainWindow).name(), this)); } else q7b_this = Q7B(new Q7B_id(typeid(MainWindow).name(), this)); 
aRecentProjects = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
_nCountFilesToCompile = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
sQtVersion = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT("4.7.0")));
sMingwQtVersion = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT("2010.05")));
sVCDir = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
sQtMINGWDir = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
sQtDir = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
statusBar = Q7B__QLABEL(Q7B_QLABEL_INIT(this, "statusBar"));
progressBar = Q7B__QPROGRESSBAR(Q7B_QPROGRESSBAR_INIT(this, "progressBar"));
tb_uilist = Q7B__QTOOLBUTTON(Q7B_QTOOLBUTTON_INIT(this, "tb_uilist"));
mUIFiles = Q7B__QMENU(Q7B_QMENU_INIT(this, "mUIFiles"));
lUIFiles = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
myDebugWindow = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
DebugStack = Q7B__QCOMBOBOX(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
DebugGlobal = Q7B__QTABLEWIDGET(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
DebugLocal = Q7B__QTABLEWIDGET(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
DebugMe = Q7B__QTABLEWIDGET(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
testList = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
sFind = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
Compiler = Q7B__QOBJECT(Q7B_QOBJECT("Q7BCompiler", new Q7BCompiler()));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(Started(int)), this, SLOT(Q7B_on_Compiler_Started_(int)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(Compiled(const QString&, int)), this, SLOT(Q7B_on_Compiler_Compiled_(const QString&, int)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(Finished(int)), this, SLOT(Q7B_on_Compiler_Finished_(int)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(Error(const QString&)), this, SLOT(Q7B_on_Compiler_Error_(const QString&)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(BreakpointReached(QString, QString)), this, SLOT(Q7B_on_Compiler_BreakpointReached_(QString, QString)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(ReadyForDebugging()), this, SLOT(Q7B_on_Compiler_ReadyForDebugging_()));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(StandardOutput(QString)), this, SLOT(Q7B_on_Compiler_StandardOutput_(QString)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(StandardError(QString)), this, SLOT(Q7B_on_Compiler_StandardError_(QString)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(StandardOutputOfCompiler(QString)), this, SLOT(Q7B_on_Compiler_StandardOutputOfCompiler_(QString)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(StandardErrorOfCompiler(QString)), this, SLOT(Q7B_on_Compiler_StandardErrorOfCompiler_(QString)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(CompilerOrApplicationFinished(bool)), this, SLOT(Q7B_on_Compiler_CompilerOrApplicationFinished_(bool)));
bCompilerError = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
bBlockLastPosition = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
sLastPositionFile = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
nLastPositionLine = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
sLastErrorText = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT("")));
sLastErrorFile = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
nLastErrorLine = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
bDebug = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
bRunOrBuild = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
bBuildOnly = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
gcc = Q7B__QACTION(Q7B_QACTION_INIT(this, "gcc"));
vs = Q7B__QACTION(Q7B_QACTION_INIT(this, "vs"));
                      Q7BS("MainWindow.QMainWindow", "Init", "94", 0);
                      Q7BS("MainWindow.QMainWindow", "Init", "101", 1);
this->UpdateRecentProjects(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(""))));
                      Q7BS("MainWindow.QMainWindow", "Init", "103", 1);
this->DoActions();
                      Q7BS("MainWindow.QMainWindow", "Init", "105", 1);
Q7B_QPLAINTEXTEDIT_READONLY(plainTextEditLog, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "Init", "107", 1);
Q7B_ASSIGNMENT(&gcc, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(menuConfiguration, Q7B_QOBJECT("GCC C/C++ Compiler")))));
                      Q7BS("MainWindow.QMainWindow", "Init", "108", 1);
Q7B_QACTION_TAG(gcc, Q7B_QOBJECT("gcc"));
                      Q7BS("MainWindow.QMainWindow", "Init", "109", 1);
Q7B_QACTION_CHECKABLE(gcc, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "Init", "110", 1);
Q7B_QACTION_CHECKED(gcc, Q7B_QOBJECT((Q7B_CBOOLEAN(Q7B_PREFERENCES_BOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("gcc"))) || Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_PREFERENCES_BOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("vs"))))))));
                      Q7BS("MainWindow.QMainWindow", "Init", "111", 1);
Q7B_PREFERENCES_SETBOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("gcc"), Q7B_QOBJECT(Q7B_QACTION_CHECKED(gcc)));
                      Q7BS("MainWindow.QMainWindow", "Init", "113", 1);
Q7B_ASSIGNMENT(&vs, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(menuConfiguration, Q7B_QOBJECT("VS C/C++ Compiler")))));
                      Q7BS("MainWindow.QMainWindow", "Init", "114", 1);
Q7B_QACTION_TAG(vs, Q7B_QOBJECT("vs"));
                      Q7BS("MainWindow.QMainWindow", "Init", "115", 1);
Q7B_QACTION_CHECKABLE(vs, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "Init", "116", 1);
Q7B_QACTION_CHECKED(vs, Q7B_QOBJECT(Q7B_PREFERENCES_BOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("vs"))));
                      Q7BS("MainWindow.QMainWindow", "Init", "117", 1);
Q7B_PREFERENCES_SETBOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("vs"), Q7B_QOBJECT(Q7B_QACTION_CHECKED(vs)));
                      Q7BS("MainWindow.QMainWindow", "Init", "119", 1);
if (Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_OS_ISWINDOWS(Q7B_idOS))))){
                      Q7BS("MainWindow.QMainWindow", "Init", "120", 1);
Q7B_QACTION_ENABLED(vs, Q7B_QOBJECT(false));
}
                      Q7BS("MainWindow.QMainWindow", "Init", "125", 1);
QTimer::singleShot(Q7B_toInteger2(Q7B_QOBJECT(10)), this, SLOT(Q7B_on_ProjectOpen()));
                      Q7BS("MainWindow.QMainWindow", "Init", "127", 1);
return;
                      Q7BS("MainWindow.QMainWindow", "Init", "132", 2);
}

MainWindow::~MainWindow()
{
  delete ui;
  q7b_this->ref = 0;
}


void MainWindow::Q7B_on_actionQt_Quick_Manual_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Quick_Manual_triggered", "16", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Quick_Manual_triggered", "16", 1);
Q7B_OPENURL(Q7B_QOBJECT("http://doc.qt.nokia.com/4.7/qtquick.html"));
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Quick_Manual_triggered", "17", 2);

}

void MainWindow::Q7B_on_actionQt_Quick_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Quick_triggered", "20", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Quick_triggered", "20", 1);
Q7B_OPENURL(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT("/Qt Quick.pdf"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Quick_triggered", "21", 2);

}

void MainWindow::Q7B_on_actionNew_uiCode_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_uiCode_triggered", "24", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_uiCode_triggered", "25", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_uiCode_triggered", "26", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_uiCode_triggered", "27", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_uiCode_triggered", "30", 1);
Q7B sClass; sClass = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_uiCode_triggered", "31", 1);
Q7B_ASSIGNMENT(&sClass, &Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT("Class.uiCode"), Q7B_QOBJECT("New File With Super Class uiCode"), Q7B_QOBJECT("myClass"))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_uiCode_triggered", "32", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sClass), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_uiCode_triggered", "33", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_uiCode_triggered", "36", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sClass))), Q7B_QOBJECT(".uiCode")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_uiCode_triggered", "37", 1);
Q7B_WRITESTRING(Q7B_QOBJECT(" 'just created this file"), Q7B_QOBJECT(s), Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_uiCode_triggered", "38", 1);
Project::q7b_sharedSingleton()->OpenCodeView(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_uiCode_triggered", "39", 2);

}

void MainWindow::Q7B_on_menuRecent_Projects_triggered(Q7B Action)
{
                      Q7BS("MainWindow.QMainWindow", "on_menuRecent_Projects_triggered", "51", 0);
                      Q7BS("MainWindow.QMainWindow", "on_menuRecent_Projects_triggered", "51", 1);
Project::q7b_sharedSingleton()->Open(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QACTION_TAG(Action)))));
                      Q7BS("MainWindow.QMainWindow", "on_menuRecent_Projects_triggered", "52", 2);

}

void MainWindow::UpdateRecentProjects(Q7B sNewlyOpenedProject)
{
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "55", 0);
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "56", 1);
Q7B m; m = Q7B__QMENU(Q7B_QOBJECT(menuRecent_Projects));
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "58", 1);
if (Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(sNewlyOpenedProject), Q7B_QOBJECT("")))){
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "59", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LIST_LENGTH(aRecentProjects)), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "60", 1);
if (Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(Q7B_LIST_OBJECT(aRecentProjects, Q7B_QOBJECT(0))), Q7B_QOBJECT(sNewlyOpenedProject)))){
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "61", 1);
Q7B_LIST_INSERT(aRecentProjects, Q7B_QOBJECT(0), Q7B_QOBJECT(sNewlyOpenedProject));
} else {
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "63", 1);
return;
}
} else {
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "66", 1);
Q7B_LIST_INSERT(aRecentProjects, Q7B_QOBJECT(0), Q7B_QOBJECT(sNewlyOpenedProject));
}
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "69", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LIST_LENGTH(aRecentProjects)), Q7B_QOBJECT(5)))){
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "70", 1);
Q7B_LIST_REMOVE(aRecentProjects, Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(aRecentProjects)), Q7B_QOBJECT(1))));
}
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "72", 1);
Q7B_WRITELIST(Q7B_QOBJECT(aRecentProjects), Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_DIR_TEMPPATH(Q7B_idDIR)), Q7B_QOBJECT("/Q7Basic/RecentProjects.txt"))));
} else {
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "74", 1);
if (Q7B_CBOOLEAN(Q7B_FILE_EXISTS(Q7B_idFILE, Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_DIR_TEMPPATH(Q7B_idDIR)), Q7B_QOBJECT("/Q7Basic/RecentProjects.txt")))))){
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "75", 1);
Q7B_ASSIGNMENT(&aRecentProjects, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_READLIST(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_DIR_TEMPPATH(Q7B_idDIR)), Q7B_QOBJECT("/Q7Basic/RecentProjects.txt"))))))));
}
}
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "79", 1);
Q7B_QMENU_CLEAR(m);
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "81", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "82", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(aRecentProjects)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "82", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "83", 1);
Q7B a; a = Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(m, Q7B_QOBJECT(Q7B_LIST_OBJECT(aRecentProjects, Q7B_QOBJECT(i))))));
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "84", 1);
Q7B_QACTION_TAG(a, Q7B_QOBJECT(Q7B_LIST_OBJECT(aRecentProjects, Q7B_QOBJECT(i))));
}
                      Q7BS("MainWindow.QMainWindow", "UpdateRecentProjects", "87", 2);

}

MainWindow::MainWindow(Q7B _q7b_this) : QMainWindow()
{
q7b_this = _q7b_this;
if (q7b_MainWindow_sharedSingletonInit){ q7b_MainWindow_sharedSingletonInit = false; Q7B_idMAINWINDOW = q7b_MainWindow_sharedSingletonQ7B = q7b_this = Q7B(new Q7B_id(typeid(MainWindow).name(), this)); } else q7b_this = Q7B(new Q7B_id(typeid(MainWindow).name(), this)); 
aRecentProjects = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
_nCountFilesToCompile = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
sQtVersion = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT("4.7.0")));
sMingwQtVersion = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT("2010.05")));
sVCDir = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
sQtMINGWDir = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
sQtDir = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
statusBar = Q7B__QLABEL(Q7B_QLABEL_INIT(this, "statusBar"));
progressBar = Q7B__QPROGRESSBAR(Q7B_QPROGRESSBAR_INIT(this, "progressBar"));
tb_uilist = Q7B__QTOOLBUTTON(Q7B_QTOOLBUTTON_INIT(this, "tb_uilist"));
mUIFiles = Q7B__QMENU(Q7B_QMENU_INIT(this, "mUIFiles"));
lUIFiles = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
myDebugWindow = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
DebugStack = Q7B__QCOMBOBOX(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
DebugGlobal = Q7B__QTABLEWIDGET(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
DebugLocal = Q7B__QTABLEWIDGET(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
DebugMe = Q7B__QTABLEWIDGET(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
testList = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
sFind = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
Compiler = Q7B__QOBJECT(Q7B_QOBJECT("Q7BCompiler", new Q7BCompiler()));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(Started(int)), this, SLOT(Q7B_on_Compiler_Started_(int)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(Compiled(const QString&, int)), this, SLOT(Q7B_on_Compiler_Compiled_(const QString&, int)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(Finished(int)), this, SLOT(Q7B_on_Compiler_Finished_(int)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(Error(const QString&)), this, SLOT(Q7B_on_Compiler_Error_(const QString&)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(BreakpointReached(QString, QString)), this, SLOT(Q7B_on_Compiler_BreakpointReached_(QString, QString)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(ReadyForDebugging()), this, SLOT(Q7B_on_Compiler_ReadyForDebugging_()));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(StandardOutput(QString)), this, SLOT(Q7B_on_Compiler_StandardOutput_(QString)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(StandardError(QString)), this, SLOT(Q7B_on_Compiler_StandardError_(QString)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(StandardOutputOfCompiler(QString)), this, SLOT(Q7B_on_Compiler_StandardOutputOfCompiler_(QString)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(StandardErrorOfCompiler(QString)), this, SLOT(Q7B_on_Compiler_StandardErrorOfCompiler_(QString)));
if (Compiler->ref) connect(((Q7BCompiler*)Compiler->ref), SIGNAL(CompilerOrApplicationFinished(bool)), this, SLOT(Q7B_on_Compiler_CompilerOrApplicationFinished_(bool)));
bCompilerError = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
bBlockLastPosition = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
sLastPositionFile = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
nLastPositionLine = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
sLastErrorText = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT("")));
sLastErrorFile = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
nLastErrorLine = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
bDebug = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
bRunOrBuild = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
bBuildOnly = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
gcc = Q7B__QACTION(Q7B_QACTION_INIT(this, "gcc"));
vs = Q7B__QACTION(Q7B_QACTION_INIT(this, "vs"));
                      Q7BS("MainWindow.QMainWindow", "Init", "94", 0);
                      Q7BS("MainWindow.QMainWindow", "Init", "101", 1);
this->UpdateRecentProjects(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(""))));
                      Q7BS("MainWindow.QMainWindow", "Init", "103", 1);
this->DoActions();
                      Q7BS("MainWindow.QMainWindow", "Init", "105", 1);
Q7B_QPLAINTEXTEDIT_READONLY(plainTextEditLog, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "Init", "107", 1);
Q7B_ASSIGNMENT(&gcc, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(menuConfiguration, Q7B_QOBJECT("GCC C/C++ Compiler")))));
                      Q7BS("MainWindow.QMainWindow", "Init", "108", 1);
Q7B_QACTION_TAG(gcc, Q7B_QOBJECT("gcc"));
                      Q7BS("MainWindow.QMainWindow", "Init", "109", 1);
Q7B_QACTION_CHECKABLE(gcc, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "Init", "110", 1);
Q7B_QACTION_CHECKED(gcc, Q7B_QOBJECT((Q7B_CBOOLEAN(Q7B_PREFERENCES_BOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("gcc"))) || Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_PREFERENCES_BOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("vs"))))))));
                      Q7BS("MainWindow.QMainWindow", "Init", "111", 1);
Q7B_PREFERENCES_SETBOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("gcc"), Q7B_QOBJECT(Q7B_QACTION_CHECKED(gcc)));
                      Q7BS("MainWindow.QMainWindow", "Init", "113", 1);
Q7B_ASSIGNMENT(&vs, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(menuConfiguration, Q7B_QOBJECT("VS C/C++ Compiler")))));
                      Q7BS("MainWindow.QMainWindow", "Init", "114", 1);
Q7B_QACTION_TAG(vs, Q7B_QOBJECT("vs"));
                      Q7BS("MainWindow.QMainWindow", "Init", "115", 1);
Q7B_QACTION_CHECKABLE(vs, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "Init", "116", 1);
Q7B_QACTION_CHECKED(vs, Q7B_QOBJECT(Q7B_PREFERENCES_BOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("vs"))));
                      Q7BS("MainWindow.QMainWindow", "Init", "117", 1);
Q7B_PREFERENCES_SETBOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("vs"), Q7B_QOBJECT(Q7B_QACTION_CHECKED(vs)));
                      Q7BS("MainWindow.QMainWindow", "Init", "119", 1);
if (Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_OS_ISWINDOWS(Q7B_idOS))))){
                      Q7BS("MainWindow.QMainWindow", "Init", "120", 1);
Q7B_QACTION_ENABLED(vs, Q7B_QOBJECT(false));
}
                      Q7BS("MainWindow.QMainWindow", "Init", "125", 1);
QTimer::singleShot(Q7B_toInteger2(Q7B_QOBJECT(10)), this, SLOT(Q7B_on_ProjectOpen()));
                      Q7BS("MainWindow.QMainWindow", "Init", "127", 1);
return;
                      Q7BS("MainWindow.QMainWindow", "Init", "132", 2);

}

void MainWindow::Q7B_on_actionOpen_Single_File_Project_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Single_File_Project_triggered", "135", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Single_File_Project_triggered", "136", 1);
Q7B_MSGBOX(Q7B_QOBJECT("Open Single Project File..."), Q7B_QOBJECT("Please select the file (*.q7basic) you want to open in the following dialog."), Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Single_File_Project_triggered", "138", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_OPENFILEDIALOG_GETFILE2(Q7B_idOPENFILEDIALOG, Q7B_QOBJECT("Open Single Project File..."), Q7B_QOBJECT(""), Q7B_QOBJECT("*.q7basic")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Single_File_Project_triggered", "139", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(s), Q7B_QOBJECT(Q7B_QOBJECTNULL(0)))) || Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(s), Q7B_QOBJECT("")))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Single_File_Project_triggered", "140", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Single_File_Project_triggered", "145", 1);
if (Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_ENDSWITH(Q7B_QOBJECT(s), Q7B_QOBJECT(".q7basic"), Q7B_QOBJECT(false)))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Single_File_Project_triggered", "146", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Selected file has no valid file extension (*.q7basic)"));
}
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Single_File_Project_triggered", "149", 1);
this->myStop();
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Single_File_Project_triggered", "152", 1);
Project::q7b_sharedSingleton()->Open(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))));
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Single_File_Project_triggered", "155", 2);

}

void MainWindow::Q7B_on_Compiler_Started(Q7B nCountFilesToCompile)
{
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Started", "159", 0);
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Started", "162", 1);
Q7B_QPROGRESSBAR_MINIMUM(progressBar, Q7B_QOBJECT(0));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Started", "163", 1);
Q7B_QPROGRESSBAR_MAXIMUM(progressBar, Q7B_QOBJECT(100));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Started", "164", 1);
Q7B_QPROGRESSBAR_VALUE(progressBar, Q7B_QOBJECT(100));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Started", "165", 1);
Q7B_QPROGRESSBAR_MAXIMUM(progressBar, Q7B_QOBJECT(0));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Started", "169", 1);
Q7B_ASSIGNMENT(&_nCountFilesToCompile, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(nCountFilesToCompile))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Started", "170", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(nCountFilesToCompile), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Started", "171", 1);
Q7B_ASSIGNMENT(&_nCountFilesToCompile, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(nCountFilesToCompile))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Started", "172", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QACTION_CHECKED(vs)), Q7B_QOBJECT(true)))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Started", "173", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT("About to compile "), Q7B_QOBJECT(_nCountFilesToCompile))), Q7B_QOBJECT(" file(s) estimated"))))));
} else {
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Started", "175", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT("About to compile "), Q7B_QOBJECT(_nCountFilesToCompile))), Q7B_QOBJECT(" file(s)"))))));
}
}
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Started", "179", 2);

}

void MainWindow::Q7B_on_actionTo_UPPERCASE_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionTo_UPPERCASE_triggered", "182", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionTo_UPPERCASE_triggered", "182", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionTo_UPPERCASE_triggered", "183", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionTo_UPPERCASE_triggered", "184", 1);
((Q7BCodeView *) (cb)->ref)->PerformUpper();
                      Q7BS("MainWindow.QMainWindow", "on_actionTo_UPPERCASE_triggered", "185", 2);

}

void MainWindow::SetWindowTitle(Q7B s)
{
                      Q7BS("MainWindow.QMainWindow", "SetWindowTitle", "211", 0);
                      Q7BS("MainWindow.QMainWindow", "SetWindowTitle", "211", 1);
Q7B_QWIDGET_WINDOWTITLE(q7b_this, Q7B_QOBJECT(s));
                      Q7BS("MainWindow.QMainWindow", "SetWindowTitle", "212", 2);

}

void MainWindow::Q7B_on_menuUi_Files_aboutToShow()
{
                      Q7BS("MainWindow.QMainWindow", "on_menuUi_Files_aboutToShow", "224", 0);
                      Q7BS("MainWindow.QMainWindow", "on_menuUi_Files_aboutToShow", "224", 1);
this->RequeryUIFiles();
                      Q7BS("MainWindow.QMainWindow", "on_menuUi_Files_aboutToShow", "225", 2);

}

void MainWindow::RequeryUIFiles()
{
                      Q7BS("MainWindow.QMainWindow", "RequeryUIFiles", "232", 0);
                      Q7BS("MainWindow.QMainWindow", "RequeryUIFiles", "232", 1);
Q7B_QMENU_CLEAR(mUIFiles);
                      Q7BS("MainWindow.QMainWindow", "RequeryUIFiles", "233", 1);
Q7B_QMENU_CLEAR(menuUi_Files);
                      Q7BS("MainWindow.QMainWindow", "RequeryUIFiles", "235", 1);
Q7B q; q = Q7B__QACTION(Q7B_QACTION_INIT(this, "q"));
                      Q7BS("MainWindow.QMainWindow", "RequeryUIFiles", "238", 1);
Q7B ll; ll = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT("*.ui")))));
                      Q7BS("MainWindow.QMainWindow", "RequeryUIFiles", "241", 1);
Q7B_ASSIGNMENT(&lUIFiles, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DIR_FINDFILE(Q7B_idDIR, Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT(ll), Q7B_QOBJECT((qint64) QDir::NoFilter), Q7B_QOBJECT((qint64) QDir::NoSort))))));
                      Q7BS("MainWindow.QMainWindow", "RequeryUIFiles", "243", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "RequeryUIFiles", "244", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(lUIFiles)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "RequeryUIFiles", "244", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "RequeryUIFiles", "245", 1);
Q7B_ASSIGNMENT(&q, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(mUIFiles, Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Q7B_LIST_OBJECT(lUIFiles, Q7B_QOBJECT(i)))))))));
                      Q7BS("MainWindow.QMainWindow", "RequeryUIFiles", "245", 1);
Q7B_QACTION_TAG(q, Q7B_QOBJECT(Q7B_LIST_OBJECT(lUIFiles, Q7B_QOBJECT(i))));
                      Q7BS("MainWindow.QMainWindow", "RequeryUIFiles", "245", 1);
Q7B_QMENU_ADDACTION2(menuUi_Files, Q7B_QOBJECT(q));
}
                      Q7BS("MainWindow.QMainWindow", "RequeryUIFiles", "248", 2);

}

void MainWindow::Q7B_on_tb_uilist_clicked(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_tb_uilist_clicked", "251", 0);
                      Q7BS("MainWindow.QMainWindow", "on_tb_uilist_clicked", "252", 1);
this->RequeryUIFiles();
                      Q7BS("MainWindow.QMainWindow", "on_tb_uilist_clicked", "254", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_LIST_LENGTH(lUIFiles)), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_tb_uilist_clicked", "255", 1);
Q7B__MSGBOX(Q7B_QOBJECT("No ui files in the project yet"));
                      Q7BS("MainWindow.QMainWindow", "on_tb_uilist_clicked", "256", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_tb_uilist_clicked", "259", 1);
Q7B_QTOOLBUTTON_MENU(tb_uilist, Q7B_QOBJECT(mUIFiles));
                      Q7BS("MainWindow.QMainWindow", "on_tb_uilist_clicked", "260", 1);
((QToolButton *) (tb_uilist)->ref)->showMenu();
                      Q7BS("MainWindow.QMainWindow", "on_tb_uilist_clicked", "261", 1);
Q7B_QTOOLBUTTON_MENU(tb_uilist, Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("MainWindow.QMainWindow", "on_tb_uilist_clicked", "263", 2);

}

void MainWindow::Q7B_on_mUIFiles_triggered(Q7B Action)
{
                      Q7BS("MainWindow.QMainWindow", "on_mUIFiles_triggered", "266", 0);
                      Q7BS("MainWindow.QMainWindow", "on_mUIFiles_triggered", "266", 1);
this->OpenUI(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT("MainWindow.QMainWindow"))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QACTION_TAG(Action)))));
                      Q7BS("MainWindow.QMainWindow", "on_mUIFiles_triggered", "267", 2);

}

void MainWindow::Q7B_on_ProjectOpen()
{
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "272", 0);
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "290", 1);
Q7B_APPLICATION_APPLICATIONNAME(Application::q7b_sharedSingletonQ7B(), Q7B_QOBJECT("Q7Basic"));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "298", 1);
Q7B_QPROGRESSBAR_VALUE(progressBar, Q7B_QOBJECT(0));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "299", 1);
Q7B_QWIDGET_MINIMUMWIDTH(progressBar, Q7B_QOBJECT(100));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "300", 1);
Q7B_QWIDGET_MAXIMUMWIDTH(progressBar, Q7B_QOBJECT(100));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "301", 1);
Q7B_QPROGRESSBAR_TEXTVISIBLE(progressBar, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "302", 1);
Q7B_TOOLBAR_ADDPERMANENTWIDGET(Q7B_idTOOLBAR, Q7B_QOBJECT(progressBar), Q7B_QOBJECT(actionLast_Error));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "304", 1);
Q7B_QWIDGET_MINIMUMWIDTH(statusBar, Q7B_QOBJECT(400));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "305", 1);
Q7B_QWIDGET_MAXIMUMWIDTH(statusBar, Q7B_QOBJECT(800));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "306", 1);
Q7B_TOOLBAR_ADDPERMANENTWIDGET(Q7B_idTOOLBAR, Q7B_QOBJECT(statusBar), Q7B_QOBJECT(actionLast_Error));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "309", 1);
Q7B_PROPERTY(tb_uilist, "autoRaise", Q7B_QOBJECT(Q7B_QOBJECT(true)));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "310", 1);
Q7B_PROPERTY(tb_uilist, "popupMode", Q7B_QOBJECT(Q7B_QOBJECT(2)));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "311", 1);
Q7B_QABSTRACTBUTTON_TEXT(tb_uilist, Q7B_QOBJECT("*.ui"));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "315", 1);
Q7B_TOOLBAR_ADDPERMANENTWIDGET(Q7B_idTOOLBAR, Q7B_QOBJECT(tb_uilist), Q7B_QOBJECT(actionMainWindow_ui_2));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "321", 1);
Q7B_QWIDGET_SHOWMAXIMIZED(MainWindow::q7b_sharedSingletonQ7B());
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "325", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_PREFERENCES_STRING(Q7B_idPREFERENCES, Q7B_QOBJECT("Project.sProjectPath")))));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "329", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(s))), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "330", 1);
Project::q7b_sharedSingleton()->Open(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))));
}
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "336", 1);
if (Q7B_CBOOLEAN(Q7B_OS_ISMAC(Q7B_idOS))){
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "337", 1);
if (Q7B_CBOOLEAN(Q7B_CONTAINS(Q7B_QOBJECT(Q7B_RUN(Q7B_QOBJECT("gcc"), Q7B_QOBJECT(Q7B_List::init()))), Q7B_QOBJECT("command not found"), Q7B_QOBJECT(true)))){
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "338", 1);
Q7B_MSGBOX(Q7B_QOBJECT("Installation incomplete"), Q7B_QOBJECT("You must have the Xcode Developer Tools (GCC C/C++ Compiler) installed as described on the download page on www.q7basic.org."), Q7B_QOBJECT(false));
}
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "340", 1);
if (Q7B_CBOOLEAN(Q7B_CONTAINS(Q7B_QOBJECT(Q7B_RUN(Q7B_QOBJECT("qmake"), Q7B_QOBJECT(Q7B_List::init()))), Q7B_QOBJECT("command not found"), Q7B_QOBJECT(true)))){
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "341", 1);
Q7B_MSGBOX(Q7B_QOBJECT("Installation incomplete"), Q7B_QOBJECT("You must have Qt installed as described on the download page on www.q7basic.org."), Q7B_QOBJECT(false));
}
}
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "346", 1);
if (Q7B_CBOOLEAN(Q7B_OS_ISWINDOWS(Q7B_idOS))){
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "348", 1);
Q7B_ASSIGNMENT(&s, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_PREFERENCES_STRING(Q7B_idPREFERENCES, Q7B_QOBJECT("QtMINGWDir"))))));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "349", 1);
if (Q7B_CBOOLEAN(Q7B_AND(Q7B_QOBJECT(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(s))), Q7B_QOBJECT(0))), Q7B_QOBJECT(Q7B_FILE(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(s), Q7B_QOBJECT("/bin/qmake.exe")))))))){
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "350", 1);
((Q7BCompiler *) (Compiler)->ref)->setMINGWDir(Q7B_CQSTRING(Q7B_QOBJECT(s)));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "351", 1);
Q7B_ASSIGNMENT(&sQtMINGWDir, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))));
} else {
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "366", 1);
Q7B bManual; bManual = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true)));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "367", 1);
Q7B locations; locations = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "369", 1);
Q7B drives; drives = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DRIVES())));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "370", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "371", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(drives)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "371", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "372", 1);
Q7B_LIST_APPEND(locations, Q7B_QOBJECT(Q7B_LIST_OBJECT(drives, Q7B_QOBJECT(i))));
}
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "374", 1);
Q7B_LIST_APPEND(locations, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT("C:/Program Files"), Q7B_QOBJECT("/"))));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "375", 1);
Q7B_LIST_APPEND(locations, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_DIR_APPLICATIONSPATH(Q7B_idDIR)), Q7B_QOBJECT("/"))));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "376", 1);
Q7B_LIST_APPEND(locations, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_DIR_HOMEPATH(Q7B_idDIR)), Q7B_QOBJECT("/"))));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "377", 1);
Q7B_LIST_APPEND(locations, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_DIR_DESKTOPPATH(Q7B_idDIR)), Q7B_QOBJECT("/"))));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "381", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(locations)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "381", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "385", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_LIST_OBJECT(locations, Q7B_QOBJECT(i))), Q7B_QOBJECT("Qt/"))), Q7B_QOBJECT(sMingwQtVersion))), Q7B_QOBJECT("/qt/bin/qmake.exe")))))){
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "386", 1);
Q7B_ASSIGNMENT(&sQtMINGWDir, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_LIST_OBJECT(locations, Q7B_QOBJECT(i))), Q7B_QOBJECT("Qt/"))), Q7B_QOBJECT(sMingwQtVersion))), Q7B_QOBJECT("/qt"))))));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "387", 1);
Q7B_PREFERENCES_SETSTRING(Q7B_idPREFERENCES, Q7B_QOBJECT("QtMINGWDir"), Q7B_QOBJECT(sQtMINGWDir));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "388", 1);
((Q7BCompiler *) (Compiler)->ref)->setMINGWDir(Q7B_CQSTRING(Q7B_QOBJECT(sQtMINGWDir)));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "389", 1);
Q7B_ASSIGNMENT(&bManual, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "390", 1);
break;
}
}
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "394", 1);
if (Q7B_CBOOLEAN(bManual)){
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "396", 1);
Q7B_MSGBOX(Q7B_QOBJECT("Configuration"), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT("Please select the Qt SDK directory in which the directory "), Q7B_QOBJECT(sMingwQtVersion))), Q7B_QOBJECT(" is located."))), Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "398", 1);
Q7B_ASSIGNMENT(&sQtMINGWDir, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_OPENFILEDIALOG_GETDIRECTORY(Q7B_idOPENFILEDIALOG)))));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "401", 1);
if (Q7B_CBOOLEAN(Q7B_DIR(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sQtMINGWDir), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sMingwQtVersion))), Q7B_QOBJECT("/qt"))), Q7B_QOBJECT(false)))){
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "402", 1);
Q7B_ASSIGNMENT(&sQtMINGWDir, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sQtMINGWDir), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sMingwQtVersion))), Q7B_QOBJECT("/qt"))))));
}
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "406", 1);
Q7B_PREFERENCES_SETSTRING(Q7B_idPREFERENCES, Q7B_QOBJECT("QtMINGWDir"), Q7B_QOBJECT(sQtMINGWDir));
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "407", 1);
((Q7BCompiler *) (Compiler)->ref)->setMINGWDir(Q7B_CQSTRING(Q7B_QOBJECT(sQtMINGWDir)));
}
}
}
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "413", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_PREFERENCES_BOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("vs"))), Q7B_QOBJECT(true)))){
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "414", 1);
this->Configuration(Q7B_QACTION(Q7B_QOBJECT(vs)), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
}
                      Q7BS("MainWindow.QMainWindow", "on_ProjectOpen", "421", 2);

}

void MainWindow::Q7B_on_actionNew_Single_File_Project_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Single_File_Project_triggered", "432", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Single_File_Project_triggered", "433", 1);
Q7B sProjectName; sProjectName = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Single_File_Project_triggered", "434", 1);
Q7B_ASSIGNMENT(&sProjectName, &Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT("Please enter the file name."), Q7B_QOBJECT("New Single Project File..."), Q7B_QOBJECT("MyFile"))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Single_File_Project_triggered", "436", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sProjectName), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Single_File_Project_triggered", "437", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Single_File_Project_triggered", "440", 1);
this->myStop();
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Single_File_Project_triggered", "442", 1);
Q7B sFile; sFile = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_DESKTOP_DESKTOPLOCATION(Q7B_idDESKTOP)), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sProjectName))), Q7B_QOBJECT(".q7basic")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Single_File_Project_triggered", "444", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(sFile)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Single_File_Project_triggered", "445", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT("Delete existing file?"), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT("There is already a file with the selected name. Should the existing file be replaced in\n"), Q7B_QOBJECT(sFile))), Q7B_QOBJECT(" ?"))), Q7B_QOBJECT(sProjectName)))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Single_File_Project_triggered", "446", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(s), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Single_File_Project_triggered", "447", 1);
return;
}
}
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Single_File_Project_triggered", "454", 1);
Q7B_WRITESTRING(Q7B_QOBJECT("' this is the global scope\n\nSub Main()\n  MsgBox(\"Init\")\n\nEnd Sub\n"), Q7B_QOBJECT(sFile), Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Single_File_Project_triggered", "456", 1);
Project::q7b_sharedSingleton()->Open(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Single_File_Project_triggered", "457", 2);

}

void MainWindow::Q7B_on_actionNew_Project_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Project_triggered", "460", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Project_triggered", "460", 1);
Q7B sProjectName; sProjectName = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Project_triggered", "461", 1);
Q7B_ASSIGNMENT(&sProjectName, &Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT("Please enter the project name."), Q7B_QOBJECT("New Project..."), Q7B_QOBJECT("MyProject"))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Project_triggered", "463", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sProjectName), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Project_triggered", "464", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Project_triggered", "467", 1);
this->myStop();
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Project_triggered", "470", 1);
Q7B sDir; sDir = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_DESKTOP_DESKTOPLOCATION(Q7B_idDESKTOP)), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sProjectName)))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Project_triggered", "473", 1);
if (Q7B_CBOOLEAN(Q7B_DIR(Q7B_QOBJECT(sDir), Q7B_QOBJECT(false)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Project_triggered", "474", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT("Delete existing project?"), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT("There is already a directory with the selected name. Should existing files be replaced in\n"), Q7B_QOBJECT(sDir))), Q7B_QOBJECT(" ?"))), Q7B_QOBJECT(sProjectName)))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Project_triggered", "475", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(s), Q7B_QOBJECT(Q7B_QOBJECTNULL(0)))) || Q7B_CBOOLEAN(Q7B_ISEMPTY(Q7B_QOBJECT(s)))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Project_triggered", "476", 1);
return;
}
}
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Project_triggered", "481", 1);
Q7B_DIR(Q7B_QOBJECT(sDir), Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Project_triggered", "486", 1);
Q7B_WRITESTRING(Q7B_QOBJECT("' this is the global scope\n\nEvent Init()\n  MsgBox(\"Init\")\n\nEnd Event\n"), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sDir), Q7B_QOBJECT("/Global.QObject"))), Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Project_triggered", "487", 1);
Q7B_WRITESTRING(Q7B_QOBJECT("' this is the mainwindow scope"), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sDir), Q7B_QOBJECT("/MainWindow.QMainWindow"))), Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Project_triggered", "489", 1);
Project::q7b_sharedSingleton()->Open(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sDir))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Project_triggered", "491", 2);

}

Q7B MainWindow::ExampleMenuIsProjectDir(Q7B s)
{
                      Q7BS("MainWindow.QMainWindow", "ExampleMenuIsProjectDir", "495", 0);
                      Q7BS("MainWindow.QMainWindow", "ExampleMenuIsProjectDir", "495", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "ExampleMenuIsProjectDir", "496", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
                      Q7BS("MainWindow.QMainWindow", "ExampleMenuIsProjectDir", "498", 1);
Q7B_ASSIGNMENT(&a, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DIR_LIST(Q7B_idDIR, Q7B_QOBJECT(s))))));
                      Q7BS("MainWindow.QMainWindow", "ExampleMenuIsProjectDir", "500", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "ExampleMenuIsProjectDir", "500", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "ExampleMenuIsProjectDir", "501", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN((Q7B_CBOOLEAN((Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_DIR_EXISTS(Q7B_idDIR, Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))))) && Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_ENDSWITH(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))), Q7B_QOBJECT("/Copy"), Q7B_QOBJECT(true))))))) && Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_ENDSWITH(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))), Q7B_QOBJECT("/cpp"), Q7B_QOBJECT(true))))))) && Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_ENDSWITH(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))), Q7B_QOBJECT("/gcc"), Q7B_QOBJECT(true))))))) && Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_ENDSWITH(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))), Q7B_QOBJECT("/Resources"), Q7B_QOBJECT(true)))))))){
                      Q7BS("MainWindow.QMainWindow", "ExampleMenuIsProjectDir", "502", 1);
return Q7B_QOBJECT(false);
}
}
                      Q7BS("MainWindow.QMainWindow", "ExampleMenuIsProjectDir", "506", 1);
return Q7B_QOBJECT(true);
                      Q7BS("MainWindow.QMainWindow", "ExampleMenuIsProjectDir", "508", 2);
return Q7B_IDNIL();

}

void MainWindow::BuildExampleMenu(Q7B menu, Q7B s)
{
                      Q7BS("MainWindow.QMainWindow", "BuildExampleMenu", "511", 0);
                      Q7BS("MainWindow.QMainWindow", "BuildExampleMenu", "511", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "BuildExampleMenu", "512", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
                      Q7BS("MainWindow.QMainWindow", "BuildExampleMenu", "514", 1);
Q7B_ASSIGNMENT(&a, &Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DIR_LIST(Q7B_idDIR, Q7B_QOBJECT(s))))));
                      Q7BS("MainWindow.QMainWindow", "BuildExampleMenu", "516", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "BuildExampleMenu", "516", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "BuildExampleMenu", "518", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_DIR_EXISTS(Q7B_idDIR, Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))))) && Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(this->ExampleMenuIsProjectDir(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i)))))))))))){
                      Q7BS("MainWindow.QMainWindow", "BuildExampleMenu", "520", 1);
Q7B menu2; menu2 = Q7B__QMENU(Q7B_QOBJECT(Q7B_QMENU_ADDMENU(menu, Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))))))));
                      Q7BS("MainWindow.QMainWindow", "BuildExampleMenu", "521", 1);
this->BuildExampleMenu(Q7B_QMENU(Q7B_QOBJECT(menu2)), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))))));
} else {
                      Q7BS("MainWindow.QMainWindow", "BuildExampleMenu", "524", 1);
Q7B exampleitem; exampleitem = Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(menu, Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))))))));
                      Q7BS("MainWindow.QMainWindow", "BuildExampleMenu", "525", 1);
Q7B_QACTION_TAG(exampleitem, Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))));
                      Q7BS("MainWindow.QMainWindow", "BuildExampleMenu", "526", 1);
Q7B_QACTION_ENABLED(exampleitem, Q7B_QOBJECT(true));
}
}
                      Q7BS("MainWindow.QMainWindow", "BuildExampleMenu", "534", 2);

}

void MainWindow::Q7B_on_menuExamples_aboutToShow()
{
                      Q7BS("MainWindow.QMainWindow", "on_menuExamples_aboutToShow", "537", 0);
                      Q7BS("MainWindow.QMainWindow", "on_menuExamples_aboutToShow", "537", 1);
Q7B_QMENU_CLEAR(menuExamples);
                      Q7BS("MainWindow.QMainWindow", "on_menuExamples_aboutToShow", "539", 1);
this->BuildExampleMenu(Q7B_QMENU(Q7B_QOBJECT(menuExamples)), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT("/Examples"))))));
                      Q7BS("MainWindow.QMainWindow", "on_menuExamples_aboutToShow", "541", 2);

}

void MainWindow::Q7B_on_menuExamples_triggered(Q7B Action)
{
                      Q7BS("MainWindow.QMainWindow", "on_menuExamples_triggered", "544", 0);
                      Q7BS("MainWindow.QMainWindow", "on_menuExamples_triggered", "544", 1);
this->myStop();
                      Q7BS("MainWindow.QMainWindow", "on_menuExamples_triggered", "545", 1);
Project::q7b_sharedSingleton()->Open(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QACTION_TAG(Action)))));
                      Q7BS("MainWindow.QMainWindow", "on_menuExamples_triggered", "547", 2);

}

void MainWindow::Q7B_on_menuWindows_aboutToShow()
{
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "550", 0);
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "550", 1);
Q7B_QMENU_CLEAR(menuWindows);
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "551", 1);
Q7B a; a = Q7B__QACTION(Q7B_QACTION_INIT(this, "a"));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "556", 1);
Q7B_ASSIGNMENT(&a, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(menuWindows, Q7B_QOBJECT("Log Window")))));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "557", 1);
Q7B_QACTION_TAG(a, Q7B_QOBJECT("Log Window"));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "558", 1);
Q7B_QACTION_ICON(a, Q7B_QOBJECT(Q7B_QICON_INIT(Q7B_QOBJECT(":/Icons/Resources/ti_log.png"))));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "559", 1);
Q7B_QACTION_ENABLED(a, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "561", 1);
Q7B_ASSIGNMENT(&a, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(menuWindows, Q7B_QOBJECT("Screen Window")))));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "562", 1);
Q7B_QACTION_TAG(a, Q7B_QOBJECT("Screen Window"));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "563", 1);
Q7B_QACTION_ICON(a, Q7B_QOBJECT(Q7B_QICON_INIT(Q7B_QOBJECT(":/Icons/Resources/ti_screen.png"))));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "564", 1);
Q7B_QACTION_ENABLED(a, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "566", 1);
Q7B_ASSIGNMENT(&a, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(menuWindows, Q7B_QOBJECT("Debug Window")))));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "567", 1);
Q7B_QACTION_TAG(a, Q7B_QOBJECT("Debug Window"));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "568", 1);
Q7B_QACTION_ENABLED(a, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "569", 1);
Q7B_ASSIGNMENT(&a, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(menuWindows, Q7B_QOBJECT("Compiler Window")))));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "570", 1);
Q7B_QACTION_TAG(a, Q7B_QOBJECT("Compiler Window"));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "571", 1);
Q7B_QACTION_ENABLED(a, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "573", 1);
Q7B aa; aa = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_aProjectFiles()))));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "575", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LIST_LENGTH(aa)), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "576", 1);
Q7B_QMENU_ADDSEPARATOR(menuWindows);
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "578", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "579", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(aa)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "579", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "580", 1);
Q7B_ASSIGNMENT(&a, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(menuWindows, Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Q7B_LIST_OBJECT(aa, Q7B_QOBJECT(i)))))))));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "581", 1);
Q7B_QACTION_TAG(a, Q7B_QOBJECT(Q7B_LIST_OBJECT(aa, Q7B_QOBJECT(i))));
}
}
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "585", 1);
Q7B_QMENU_ADDSEPARATOR(menuWindows);
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "586", 1);
Q7B_ASSIGNMENT(&a, &Q7B__QACTION(Q7B_QOBJECT(Q7B_QMENU_ADDACTION(menuWindows, Q7B_QOBJECT("Global")))));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "587", 1);
Q7B_QACTION_TAG(a, Q7B_QOBJECT("Global"));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "588", 1);
Q7B_QACTION_ICON(a, Q7B_QOBJECT(Q7B_QICON_INIT(Q7B_QOBJECT(":/Icons/Resources/ti_global.png"))));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_aboutToShow", "589", 2);

}

void MainWindow::ReopenCode(Q7B PathFileName, Q7B nGoto)
{
                      Q7BS("MainWindow.QMainWindow", "ReopenCode", "598", 0);
                      Q7BS("MainWindow.QMainWindow", "ReopenCode", "599", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LISTMDI())));
                      Q7BS("MainWindow.QMainWindow", "ReopenCode", "600", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "ReopenCode", "602", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "ReopenCode", "602", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "ReopenCode", "603", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))));
                      Q7BS("MainWindow.QMainWindow", "ReopenCode", "604", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName"))), Q7B_QOBJECT(PathFileName)))){
                      Q7BS("MainWindow.QMainWindow", "ReopenCode", "605", 1);
Q7B_SETFOCUSMDI(Q7B_QOBJECT(w));
                      Q7BS("MainWindow.QMainWindow", "ReopenCode", "607", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(nGoto), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "ReopenCode", "608", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "ReopenCode", "609", 1);
((Q7BCodeView *) (cb)->ref)->GotoLineAndSelectLine((int) Q7B_CINTEGER(Q7B_QOBJECT(nGoto)));
}
                      Q7BS("MainWindow.QMainWindow", "ReopenCode", "612", 1);
return;
}
}
                      Q7BS("MainWindow.QMainWindow", "ReopenCode", "616", 2);

}

void MainWindow::ReopenCodeAndLoadBefore(Q7B PathFileName, Q7B nGoto)
{
                      Q7BS("MainWindow.QMainWindow", "ReopenCodeAndLoadBefore", "619", 0);
                      Q7BS("MainWindow.QMainWindow", "ReopenCodeAndLoadBefore", "620", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LISTMDI())));
                      Q7BS("MainWindow.QMainWindow", "ReopenCodeAndLoadBefore", "621", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "ReopenCodeAndLoadBefore", "623", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "ReopenCodeAndLoadBefore", "623", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "ReopenCodeAndLoadBefore", "624", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))));
                      Q7BS("MainWindow.QMainWindow", "ReopenCodeAndLoadBefore", "625", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName"))), Q7B_QOBJECT(PathFileName)))){
                      Q7BS("MainWindow.QMainWindow", "ReopenCodeAndLoadBefore", "628", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "ReopenCodeAndLoadBefore", "629", 1);
((Q7BCodeView *) (cb)->ref)->Load(Q7B_CQSTRING(Q7B_QOBJECT(PathFileName)));
                      Q7BS("MainWindow.QMainWindow", "ReopenCodeAndLoadBefore", "630", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(nGoto), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "ReopenCodeAndLoadBefore", "631", 1);
((Q7BCodeView *) (cb)->ref)->GotoLineAndSelectLine((int) Q7B_CINTEGER(Q7B_QOBJECT(nGoto)));
}
                      Q7BS("MainWindow.QMainWindow", "ReopenCodeAndLoadBefore", "634", 1);
return;
}
}
                      Q7BS("MainWindow.QMainWindow", "ReopenCodeAndLoadBefore", "638", 2);

}

void MainWindow::Q7B_on_menuWindows_triggered(Q7B Action)
{
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "641", 0);
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "642", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QACTION_TAG(Action)), Q7B_QOBJECT("Debug Window")))){
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "644", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Sorry. Not implemented yet."));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "650", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_QDOCKWIDGET_WIDGET(dockDebug)));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "654", 1);
Q7B_ASSIGNMENT(&DebugStack, &Q7B__QCOMBOBOX(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("DebugStack")))));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "655", 1);
Q7B_ASSIGNMENT(&DebugGlobal, &Q7B__QTABLEWIDGET(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("DebugGlobal")))));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "656", 1);
Q7B_ASSIGNMENT(&DebugLocal, &Q7B__QTABLEWIDGET(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("DebugLocal")))));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "657", 1);
Q7B_ASSIGNMENT(&DebugMe, &Q7B__QTABLEWIDGET(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("DebugMe")))));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "660", 1);
Q7B_QCOMBOBOX_APPEND(DebugStack, Q7B_QOBJECT("Hello"));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "664", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "667", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QACTION_TAG(Action)), Q7B_QOBJECT("Log Window")))){
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "668", 1);
Q7B_QWIDGET_VISIBLE(dockLog, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "669", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "672", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QACTION_TAG(Action)), Q7B_QOBJECT("Screen Window")))){
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "673", 1);
Q7B_SHOWSCREEN();
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "674", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "677", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QACTION_TAG(Action)), Q7B_QOBJECT("Compiler Window")))){
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "678", 1);
Q7B_QWIDGET_VISIBLE(dockCompiler, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "679", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "682", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LISTMDI())));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "683", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "684", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QACTION_TAG(Action)), Q7B_QOBJECT("Global")))){
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "685", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "685", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "686", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "687", 1);
if (Q7B_CBOOLEAN(Q7B_ENDSWITH(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName"))), Q7B_QOBJECT("Global.QObject"), Q7B_QOBJECT(true)))){
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "688", 1);
Q7B_SETFOCUSMDI(Q7B_QOBJECT(w));
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "690", 1);
return;
}
}
} else {
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "694", 1);
this->ReopenCode(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QACTION_TAG(Action)))), Q7B_QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(-1))));
}
                      Q7BS("MainWindow.QMainWindow", "on_menuWindows_triggered", "706", 2);

}

void MainWindow::Q7B_on_actionOpen_Project_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Project_triggered", "716", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Project_triggered", "716", 1);
Q7B_MSGBOX(Q7B_QOBJECT("Open Project..."), Q7B_QOBJECT("Please select the project directory you want to open in the following dialog."), Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Project_triggered", "718", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_OPENFILEDIALOG_GETDIRECTORY(Q7B_idOPENFILEDIALOG))));
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Project_triggered", "719", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(s), Q7B_QOBJECT(Q7B_QOBJECTNULL(0)))) || Q7B_CBOOLEAN(Q7B_ISEMPTY(Q7B_QOBJECT(s)))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Project_triggered", "720", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Project_triggered", "723", 1);
this->myStop();
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Project_triggered", "724", 1);
Project::q7b_sharedSingleton()->Open(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))));
                      Q7BS("MainWindow.QMainWindow", "on_actionOpen_Project_triggered", "726", 2);

}

void MainWindow::Q7B_on_actionApplication_QApplication_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionApplication_QApplication_triggered", "731", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionApplication_QApplication_triggered", "732", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionApplication_QApplication_triggered", "733", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "on_actionApplication_QApplication_triggered", "734", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionApplication_QApplication_triggered", "737", 1);
if (Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_FILE(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/Application.QApplication")))))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionApplication_QApplication_triggered", "738", 1);
Q7B_WRITESTRING(Q7B_QOBJECT(" ' this is for the application"), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/Application.QApplication"))), Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionApplication_QApplication_triggered", "739", 1);
Project::q7b_sharedSingleton()->OpenCodeView(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/Application.QApplication"))))));
}
                      Q7BS("MainWindow.QMainWindow", "on_actionApplication_QApplication_triggered", "741", 2);

}

void MainWindow::Q7B_on_actionSystemTray_QSystemTrayIcon_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionSystemTray_QSystemTrayIcon_triggered", "744", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionSystemTray_QSystemTrayIcon_triggered", "745", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionSystemTray_QSystemTrayIcon_triggered", "746", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "on_actionSystemTray_QSystemTrayIcon_triggered", "747", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionSystemTray_QSystemTrayIcon_triggered", "750", 1);
if (Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_FILE(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/SystemTray.QSystemTrayIcon")))))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionSystemTray_QSystemTrayIcon_triggered", "751", 1);
Q7B_WRITESTRING(Q7B_QOBJECT(" ' this is for the systemtray"), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/SystemTray.QSystemTrayIcon"))), Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionSystemTray_QSystemTrayIcon_triggered", "752", 1);
Project::q7b_sharedSingleton()->OpenCodeView(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/SystemTray.QSystemTrayIcon"))))));
}
                      Q7BS("MainWindow.QMainWindow", "on_actionSystemTray_QSystemTrayIcon_triggered", "754", 2);

}

void MainWindow::Q7B_on_actionResources_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionResources_triggered", "757", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionResources_triggered", "758", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionResources_triggered", "759", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "on_actionResources_triggered", "760", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionResources_triggered", "763", 1);
if (Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_DIR(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/Resources"))), Q7B_QOBJECT(false)))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionResources_triggered", "764", 1);
Q7B_DIR(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/Resources"))), Q7B_QOBJECT(true));
}
                      Q7BS("MainWindow.QMainWindow", "on_actionResources_triggered", "767", 2);

}

void MainWindow::Q7B_on_actionCpp_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionCpp_triggered", "770", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionCpp_triggered", "771", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionCpp_triggered", "772", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "on_actionCpp_triggered", "773", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionCpp_triggered", "776", 1);
if (Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_DIR(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/cpp"))), Q7B_QOBJECT(false)))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionCpp_triggered", "777", 1);
Q7B_DIR(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/cpp"))), Q7B_QOBJECT(true));
}
                      Q7BS("MainWindow.QMainWindow", "on_actionCpp_triggered", "780", 2);

}

void MainWindow::Q7B_on_actionCopy_2_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionCopy_2_triggered", "783", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionCopy_2_triggered", "784", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionCopy_2_triggered", "785", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "on_actionCopy_2_triggered", "786", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionCopy_2_triggered", "789", 1);
if (Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_DIR(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/Copy"))), Q7B_QOBJECT(false)))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionCopy_2_triggered", "790", 1);
Q7B_DIR(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/Copy"))), Q7B_QOBJECT(true));
}
                      Q7BS("MainWindow.QMainWindow", "on_actionCopy_2_triggered", "793", 2);

}

void MainWindow::Q7B_on_actionQuit_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionQuit_triggered", "797", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionQuit_triggered", "797", 1);
Q7B_APPLICATION_QUIT(Application::q7b_sharedSingletonQ7B());
                      Q7BS("MainWindow.QMainWindow", "on_actionQuit_triggered", "798", 2);

}

void MainWindow::Q7B_on_actionUndo_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionUndo_triggered", "801", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionUndo_triggered", "801", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionUndo_triggered", "803", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionUndo_triggered", "804", 1);
((Q7BCodeView *) (cb)->ref)->PerformUndo();
                      Q7BS("MainWindow.QMainWindow", "on_actionUndo_triggered", "805", 2);

}

void MainWindow::Q7B_on_actionRedo_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionRedo_triggered", "808", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionRedo_triggered", "808", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionRedo_triggered", "809", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionRedo_triggered", "810", 1);
((Q7BCodeView *) (cb)->ref)->PerformRedo();
                      Q7BS("MainWindow.QMainWindow", "on_actionRedo_triggered", "811", 2);

}

void MainWindow::Q7B_on_actionCut_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionCut_triggered", "814", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionCut_triggered", "814", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionCut_triggered", "815", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionCut_triggered", "816", 1);
((Q7BCodeView *) (cb)->ref)->PerformCut();
                      Q7BS("MainWindow.QMainWindow", "on_actionCut_triggered", "817", 2);

}

void MainWindow::Q7B_on_actionCopy_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionCopy_triggered", "820", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionCopy_triggered", "820", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionCopy_triggered", "821", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionCopy_triggered", "822", 1);
((Q7BCodeView *) (cb)->ref)->PerformCopy();
                      Q7BS("MainWindow.QMainWindow", "on_actionCopy_triggered", "823", 2);

}

void MainWindow::Q7B_on_actionPaste_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionPaste_triggered", "826", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionPaste_triggered", "826", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionPaste_triggered", "827", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionPaste_triggered", "828", 1);
((Q7BCodeView *) (cb)->ref)->PerformPaste();
                      Q7BS("MainWindow.QMainWindow", "on_actionPaste_triggered", "829", 2);

}

void MainWindow::Q7B_on_actionDelete_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_triggered", "832", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_triggered", "832", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_triggered", "833", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_triggered", "834", 1);
((Q7BCodeView *) (cb)->ref)->PerformDelete();
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_triggered", "835", 2);

}

void MainWindow::Q7B_on_actionSelect_All_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionSelect_All_triggered", "838", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionSelect_All_triggered", "838", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionSelect_All_triggered", "839", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionSelect_All_triggered", "840", 1);
((Q7BCodeView *) (cb)->ref)->PerformSelectAll();
                      Q7BS("MainWindow.QMainWindow", "on_actionSelect_All_triggered", "841", 2);

}

void MainWindow::Q7B_on_actionFind_Replace_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_Replace_triggered", "845", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_Replace_triggered", "845", 1);
Q7B_ASSIGNMENT(&sFind, &Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT(""), Q7B_QOBJECT("Find..."), Q7B_QOBJECT(sFind))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_Replace_triggered", "846", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sFind), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_Replace_triggered", "847", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_Replace_triggered", "850", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_Replace_triggered", "851", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_Replace_triggered", "853", 1);
Q7B b; b = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCodeView *) (cb)->ref)->PerformFind(Q7B_CQSTRING(Q7B_QOBJECT(sFind)))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_Replace_triggered", "854", 2);

}

void MainWindow::Q7B_on_actionFind_Next_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_Next_triggered", "857", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_Next_triggered", "857", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_Next_triggered", "858", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_Next_triggered", "860", 1);
Q7B b; b = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCodeView *) (cb)->ref)->PerformFind(Q7B_CQSTRING(Q7B_QOBJECT(sFind)))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_Next_triggered", "861", 2);

}

void MainWindow::Q7B_on_actionFind_File_Replace_File_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_File_Replace_File_triggered", "864", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_File_Replace_File_triggered", "865", 1);
Q7B_OPENTOOLWINDOW(Q7B_QOBJECT("FindReplaceFile"));
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_File_Replace_File_triggered", "867", 2);

}

void MainWindow::Q7B_on_actionReplace_File_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionReplace_File_triggered", "870", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionReplace_File_triggered", "871", 1);
Q7B_MSGBOX(Q7B_QOBJECT("Replace In File"), Q7B_QOBJECT("File Replacement\n  \nWatch out! There is no way to undo file replacements. So be sure about what you are doing\n  \nor what you want to replace. All project files will be searched and if the searched string is found, \n  \nit will modify the matched file and replace the occurance of that string.\n"), Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "on_actionReplace_File_triggered", "873", 1);
Q7B_OPENTOOLWINDOW(Q7B_QOBJECT("FindReplaceFile"));
                      Q7BS("MainWindow.QMainWindow", "on_actionReplace_File_triggered", "875", 2);

}

void MainWindow::Q7B_on_actionGo_To_Line_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionGo_To_Line_triggered", "878", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionGo_To_Line_triggered", "878", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT("Go To Line..."), Q7B_QOBJECT(""), Q7B_QOBJECT("")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionGo_To_Line_triggered", "879", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(s), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionGo_To_Line_triggered", "880", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionGo_To_Line_triggered", "883", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(s))), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionGo_To_Line_triggered", "884", 1);
Q7B n; n = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(s), Q7B_QOBJECT(false)))));
                      Q7BS("MainWindow.QMainWindow", "on_actionGo_To_Line_triggered", "885", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(n), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionGo_To_Line_triggered", "886", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionGo_To_Line_triggered", "887", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionGo_To_Line_triggered", "888", 1);
((Q7BCodeView *) (cb)->ref)->GotoLineAndSelectLine((int) Q7B_CINTEGER(Q7B_QOBJECT(n)));
}
}
                      Q7BS("MainWindow.QMainWindow", "on_actionGo_To_Line_triggered", "892", 2);

}

void MainWindow::Q7B_on_actionGlobal_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionGlobal_triggered", "895", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionGlobal_triggered", "895", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "on_actionGlobal_triggered", "896", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LISTMDI())));
                      Q7BS("MainWindow.QMainWindow", "on_actionGlobal_triggered", "897", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "on_actionGlobal_triggered", "897", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionGlobal_triggered", "898", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))));
                      Q7BS("MainWindow.QMainWindow", "on_actionGlobal_triggered", "899", 1);
if (Q7B_CBOOLEAN(Q7B_ENDSWITH(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName"))), Q7B_QOBJECT("Global.QObject"), Q7B_QOBJECT(true)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionGlobal_triggered", "900", 1);
Q7B_SETFOCUSMDI(Q7B_QOBJECT(w));
                      Q7BS("MainWindow.QMainWindow", "on_actionGlobal_triggered", "901", 1);
return;
}
}
                      Q7BS("MainWindow.QMainWindow", "on_actionGlobal_triggered", "904", 2);

}

void MainWindow::Q7B_on_actionFind_Definition_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_Definition_triggered", "907", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_Definition_triggered", "907", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Sorry. Not implemented yet."));
                      Q7BS("MainWindow.QMainWindow", "on_actionFind_Definition_triggered", "908", 2);

}

void MainWindow::Q7B_on_actionLog_Window_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionLog_Window_triggered", "911", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionLog_Window_triggered", "911", 1);
Q7B_QWIDGET_VISIBLE(dockLog, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "on_actionLog_Window_triggered", "912", 2);

}

void MainWindow::Q7B_on_actionCompiler_Window_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionCompiler_Window_triggered", "915", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionCompiler_Window_triggered", "915", 1);
Q7B_QWIDGET_VISIBLE(dockCompiler, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "on_actionCompiler_Window_triggered", "916", 2);

}

void MainWindow::Q7B_on_actionShift_Left_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionShift_Left_triggered", "919", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionShift_Left_triggered", "919", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionShift_Left_triggered", "920", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionShift_Left_triggered", "921", 1);
((Q7BCodeView *) (cb)->ref)->PerformUnindent();
                      Q7BS("MainWindow.QMainWindow", "on_actionShift_Left_triggered", "922", 2);

}

void MainWindow::Q7B_on_actionShift_Right_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionShift_Right_triggered", "925", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionShift_Right_triggered", "925", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionShift_Right_triggered", "926", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionShift_Right_triggered", "927", 1);
((Q7BCodeView *) (cb)->ref)->PerformIndent();
                      Q7BS("MainWindow.QMainWindow", "on_actionShift_Right_triggered", "928", 2);

}

void MainWindow::Q7B_on_actionComment_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionComment_triggered", "931", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionComment_triggered", "931", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionComment_triggered", "933", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionComment_triggered", "936", 1);
((Q7BCodeView *) (cb)->ref)->PerformComment();
                      Q7BS("MainWindow.QMainWindow", "on_actionComment_triggered", "939", 2);

}

void MainWindow::Q7B_on_actionUncomment_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionUncomment_triggered", "942", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionUncomment_triggered", "942", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionUncomment_triggered", "943", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionUncomment_triggered", "944", 1);
((Q7BCodeView *) (cb)->ref)->PerformUncomment();
                      Q7BS("MainWindow.QMainWindow", "on_actionUncomment_triggered", "945", 2);

}

void MainWindow::Q7B_on_actionTo_lowercase_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionTo_lowercase_triggered", "948", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionTo_lowercase_triggered", "948", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionTo_lowercase_triggered", "949", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionTo_lowercase_triggered", "950", 1);
((Q7BCodeView *) (cb)->ref)->PerformLower();
                      Q7BS("MainWindow.QMainWindow", "on_actionTo_lowercase_triggered", "951", 2);

}

void MainWindow::Q7B_on_Compiler_Compiled(Q7B sPathFileName, Q7B nCountFilesCompiled)
{
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Compiled", "958", 0);
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Compiled", "959", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(nCountFilesCompiled), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(2)))))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Compiled", "960", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT("Linking..."))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Compiled", "961", 1);
Q7B_QPROGRESSBAR_MAXIMUM(progressBar, Q7B_QOBJECT(0));
} else if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(nCountFilesCompiled), Q7B_QOBJECT(-1)))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Compiled", "964", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QPROGRESSBAR_VALUE(progressBar)), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Compiled", "965", 1);
Q7B_QPROGRESSBAR_VALUE(progressBar, Q7B_QOBJECT(1));
}
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Compiled", "967", 1);
Q7B_QPROGRESSBAR_MAXIMUM(progressBar, Q7B_QOBJECT(_nCountFilesToCompile));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Compiled", "968", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT("Compiling "), Q7B_QOBJECT(sPathFileName))))));
} else if (Q7B_CBOOLEAN((Q7B_CBOOLEAN((Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(nCountFilesCompiled), Q7B_QOBJECT(10000))) || Q7B_CBOOLEAN(Q7B_SMALLER(Q7B_QOBJECT(nCountFilesCompiled), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(10000))))))) || Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(_nCountFilesToCompile), Q7B_QOBJECT(10000))))) || Q7B_CBOOLEAN(Q7B_SMALLER(Q7B_QOBJECT(_nCountFilesToCompile), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(10000)))))))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Compiled", "972", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT("Compiling..."))));
} else {
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Compiled", "975", 1);
Q7B_QPROGRESSBAR_VALUE(progressBar, Q7B_QOBJECT(nCountFilesCompiled));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Compiled", "976", 1);
Q7B_QPROGRESSBAR_MAXIMUM(progressBar, Q7B_QOBJECT(_nCountFilesToCompile));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Compiled", "977", 1);
if (Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(nCountFilesCompiled), Q7B_QOBJECT(_nCountFilesToCompile)))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Compiled", "978", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT("Compiling "), Q7B_QOBJECT(sPathFileName))), Q7B_QOBJECT(" - "))), Q7B_QOBJECT(nCountFilesCompiled))), Q7B_QOBJECT(" of "))), Q7B_QOBJECT(_nCountFilesToCompile))), Q7B_QOBJECT(" file(s)"))))));
}
}
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Compiled", "981", 2);

}

void MainWindow::PrintStatusBar(Q7B s)
{
                      Q7BS("MainWindow.QMainWindow", "PrintStatusBar", "984", 0);
                      Q7BS("MainWindow.QMainWindow", "PrintStatusBar", "984", 1);
if (Q7B_CBOOLEAN(Q7B_CONTAINS(Q7B_QOBJECT(s), Q7B_QOBJECT("\n"), Q7B_QOBJECT(true)))){
                      Q7BS("MainWindow.QMainWindow", "PrintStatusBar", "984", 1);
Q7B_ASSIGNMENT(&s, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(s), Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(s), Q7B_QOBJECT("\n"), Q7B_QOBJECT(0), Q7B_QOBJECT(true))))))));
}
                      Q7BS("MainWindow.QMainWindow", "PrintStatusBar", "986", 1);
Q7B_QLABEL_TEXT(statusBar, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(" "), Q7B_QOBJECT(s))));
                      Q7BS("MainWindow.QMainWindow", "PrintStatusBar", "987", 2);

}

void MainWindow::Q7B_on_Compiler_Finished(Q7B nCountFilesCompiled)
{
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "990", 0);
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "992", 1);
this->DoActions();
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "994", 1);
Q7B_QPROGRESSBAR_MINIMUM(progressBar, Q7B_QOBJECT(0));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "995", 1);
Q7B_QPROGRESSBAR_MAXIMUM(progressBar, Q7B_QOBJECT(100));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "996", 1);
Q7B_QPROGRESSBAR_VALUE(progressBar, Q7B_QOBJECT(100));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "998", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(nCountFilesCompiled), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(1)))))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "999", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT("Ready. Made Q7Basic Only "))));
} else if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(nCountFilesCompiled), Q7B_QOBJECT(-999999)))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "1002", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT("Ready. Deployment ready"))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "1004", 1);
if (Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "1006", 1);
if (Q7B_CBOOLEAN(Q7B_OS_ISWINDOWS(Q7B_idOS))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "1007", 1);
Q7B_OPENURL(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/gcc/Build/release"))));
} else {
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "1009", 1);
Q7B_OPENURL(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())));
}
}
} else if (Q7B_CBOOLEAN((Q7B_CBOOLEAN((Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(nCountFilesCompiled), Q7B_QOBJECT(10000))) || Q7B_CBOOLEAN(Q7B_SMALLER(Q7B_QOBJECT(nCountFilesCompiled), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(10000))))))) || Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(_nCountFilesToCompile), Q7B_QOBJECT(10000))))) || Q7B_CBOOLEAN(Q7B_SMALLER(Q7B_QOBJECT(_nCountFilesToCompile), Q7B_QOBJECT(Q7B_MINUS(Q7B_QOBJECT(10000)))))))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "1015", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT("Ready. Compilation finished"))));
} else {
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "1017", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT("Ready. Compiled "), Q7B_QOBJECT(nCountFilesCompiled))), Q7B_QOBJECT(" file(s)"))))));
}
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "1021", 1);
if (Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "1023", 1);
if (Q7B_CBOOLEAN(Q7B_OS_ISWINDOWS(Q7B_idOS))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "1024", 1);
Q7B_WRITESTRING(Q7B_QOBJECT("Windows"), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/gcc/Platform.txt"))), Q7B_QOBJECT(""));
} else if (Q7B_CBOOLEAN(Q7B_OS_ISMAC(Q7B_idOS))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "1026", 1);
Q7B_WRITESTRING(Q7B_QOBJECT("Mac"), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/gcc/Platform.txt"))), Q7B_QOBJECT(""));
} else if (Q7B_CBOOLEAN(Q7B_OS_ISLINUX(Q7B_idOS))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "1028", 1);
Q7B_WRITESTRING(Q7B_QOBJECT("Linux"), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/gcc/Platform.txt"))), Q7B_QOBJECT(""));
}
}
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Finished", "1033", 2);

}

void MainWindow::Q7B_on_actionLast_Error_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Error_triggered", "1038", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Error_triggered", "1038", 1);
if (Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(sLastErrorFile), Q7B_QOBJECT("")))){
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Error_triggered", "1040", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LISTMDI())));
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Error_triggered", "1041", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Error_triggered", "1042", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "on_actionLast_Error_triggered", "1042", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Error_triggered", "1043", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))));
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Error_triggered", "1045", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sLastErrorFile), Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Error_triggered", "1047", 1);
Q7B_SETFOCUSMDI(Q7B_QOBJECT(w));
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Error_triggered", "1049", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Error_triggered", "1050", 1);
((Q7BCodeView *) (cb)->ref)->GotoLineAndSelectLine((int) Q7B_CINTEGER(Q7B_QOBJECT(nLastErrorLine)));
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Error_triggered", "1052", 1);
break;
}
}
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Error_triggered", "1057", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sLastErrorText))));
}
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Error_triggered", "1059", 2);

}

void MainWindow::Q7B_on_actionLast_Position_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Position_triggered", "1067", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Position_triggered", "1070", 1);
Q7B_ASSIGNMENT(&bBlockLastPosition, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Position_triggered", "1072", 1);
if (Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(sLastPositionFile), Q7B_QOBJECT("")))){
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Position_triggered", "1074", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LISTMDI())));
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Position_triggered", "1075", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Position_triggered", "1076", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "on_actionLast_Position_triggered", "1076", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Position_triggered", "1077", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))));
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Position_triggered", "1080", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sLastPositionFile), Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Position_triggered", "1082", 1);
Q7B_SETFOCUSMDI(Q7B_QOBJECT(w));
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Position_triggered", "1084", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Position_triggered", "1086", 1);
((Q7BCodeView *) (cb)->ref)->GotoLineAndSelectLine((int) Q7B_CINTEGER(Q7B_QOBJECT(nLastPositionLine)));
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Position_triggered", "1088", 1);
break;
}
}
}
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Position_triggered", "1095", 1);
Q7B_ASSIGNMENT(&bBlockLastPosition, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("MainWindow.QMainWindow", "on_actionLast_Position_triggered", "1096", 2);

}

void MainWindow::ShowLastError(Q7B Text, Q7B sFileName, Q7B nLine)
{
                      Q7BS("MainWindow.QMainWindow", "ShowLastError", "1103", 0);
                      Q7BS("MainWindow.QMainWindow", "ShowLastError", "1104", 1);
Q7B_ASSIGNMENT(&sLastErrorText, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Text))));
                      Q7BS("MainWindow.QMainWindow", "ShowLastError", "1105", 1);
Q7B_ASSIGNMENT(&sLastErrorFile, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFileName))));
                      Q7BS("MainWindow.QMainWindow", "ShowLastError", "1107", 1);
Q7B_ASSIGNMENT(&nLastErrorLine, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(nLine))));
                      Q7BS("MainWindow.QMainWindow", "ShowLastError", "1108", 2);

}

void MainWindow::ShowError(Q7B sError)
{
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1111", 0);
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1111", 1);
if (Q7B_CBOOLEAN(Q7B_STARTSWITH(Q7B_QOBJECT(sError), Q7B_QOBJECT("Q7Basic: "), Q7B_QOBJECT(true)))){
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1112", 1);
Q7B_ASSIGNMENT(&sError, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(sError), Q7B_QOBJECT(9), Q7B_QOBJECT(-1))))));
}
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1115", 1);
this->myStop();
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1116", 1);
Q7B_ASSIGNMENT(&bCompilerError, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1118", 1);
Q7B_QWIDGET_VISIBLE(dockCompiler, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1122", 1);
Q7B n; n = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sError), Q7B_QOBJECT("\n"), Q7B_QOBJECT(0), Q7B_QOBJECT(true)))));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1124", 1);
if (Q7B_CBOOLEAN(Q7B_GREATEREQUAL(Q7B_QOBJECT(n), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1125", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(sError), Q7B_QOBJECT(n))))));
} else {
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1127", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sError))));
}
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1133", 1);
if (Q7B_CBOOLEAN(Q7B_STARTSWITH(Q7B_QOBJECT(sError), Q7B_QOBJECT("syntax error or parser error in line "), Q7B_QOBJECT(true)))){
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1134", 1);
Q7B m; m = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sError), Q7B_QOBJECT(" in line "), Q7B_QOBJECT(0), Q7B_QOBJECT(true)))));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1135", 1);
Q7B_ASSIGNMENT(&m, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(m), Q7B_QOBJECT(9))))));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1136", 1);
Q7B m2; m2 = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sError), Q7B_QOBJECT(" in file "), Q7B_QOBJECT(0), Q7B_QOBJECT(true)))));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1137", 1);
Q7B sLine; sLine = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_TRIM(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(sError), Q7B_QOBJECT(m), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(m2), Q7B_QOBJECT(m)))))))));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1141", 1);
Q7B_ASSIGNMENT(&m, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sError), Q7B_QOBJECT(" in file "), Q7B_QOBJECT(0), Q7B_QOBJECT(true))))));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1142", 1);
Q7B_ASSIGNMENT(&m, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(m), Q7B_QOBJECT(9))))));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1143", 1);
Q7B_ASSIGNMENT(&m2, &Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INSTR(Q7B_QOBJECT(sError), Q7B_QOBJECT("\n"), Q7B_QOBJECT(0), Q7B_QOBJECT(true))))));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1144", 1);
Q7B sFile; sFile = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_TRIM(Q7B_QOBJECT(Q7B_MID(Q7B_QOBJECT(sError), Q7B_QOBJECT(m), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(m2), Q7B_QOBJECT(m)))))))));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1146", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LISTMDI())));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1147", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1148", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "ShowError", "1148", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1149", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1153", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sFile), Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))))))){
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1155", 1);
Q7B_SETFOCUSMDI(Q7B_QOBJECT(w));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1157", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1158", 1);
((Q7BCodeView *) (cb)->ref)->GotoLineAndSelectLine((int) Q7B_CINTEGER(Q7B_QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(sLine), Q7B_QOBJECT(false)))));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1161", 1);
break;
}
}
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1166", 1);
Q7B_ASSIGNMENT(&sError, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT((Q7B_QOBJECT(Q7B_LEFT(Q7B_QOBJECT(sError), Q7B_QOBJECT(n))))))));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1168", 1);
this->ShowLastError(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sError))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sFile))), Q7B_QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(sLine), Q7B_QOBJECT(false))))));
}
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1172", 1);
Q7B_MSGBOX(Q7B_QOBJECT("Error"), Q7B_QOBJECT(sError), Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "ShowError", "1175", 2);

}

void MainWindow::Q7B_on_Compiler_Error(Q7B sError)
{
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Error", "1178", 0);
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Error", "1178", 1);
this->ShowError(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(sError))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_Error", "1179", 2);

}

void MainWindow::Q7B_on_Compiler_BreakpointReached(Q7B sFile, Q7B sLine)
{
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_BreakpointReached", "1182", 0);
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_BreakpointReached", "1183", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sFile), Q7B_QOBJECT(""))) && Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sLine), Q7B_QOBJECT("")))))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_BreakpointReached", "1184", 1);
this->ResetDebugPosition();
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_BreakpointReached", "1185", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_BreakpointReached", "1188", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LISTMDI())));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_BreakpointReached", "1189", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_BreakpointReached", "1190", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "on_Compiler_BreakpointReached", "1190", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_BreakpointReached", "1191", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_BreakpointReached", "1195", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sFile), Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))))))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_BreakpointReached", "1197", 1);
Q7B_SETFOCUSMDI(Q7B_QOBJECT(w));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_BreakpointReached", "1199", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_BreakpointReached", "1200", 1);
((Q7BCodeView *) (cb)->ref)->setCurrentDebugPosition((int) Q7B_CINTEGER(Q7B_QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(sLine), Q7B_QOBJECT(false)))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_BreakpointReached", "1201", 1);
((Q7BCodeView *) (cb)->ref)->GotoLine((int) Q7B_CINTEGER(Q7B_QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(sLine), Q7B_QOBJECT(false)))));
}
}
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_BreakpointReached", "1210", 2);

}

Q7B MainWindow::CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary()
{
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1262", 0);
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1263", 1);
Q7B sdf; sdf = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1265", 1);
if (Q7B_CBOOLEAN(Q7B_OS_ISMAC(Q7B_idOS))){
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1266", 1);
Q7B_ASSIGNMENT(&sdf, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT("Q7BCompiler"))));
} else if (Q7B_CBOOLEAN(Q7B_OS_ISWINDOWS(Q7B_idOS))){
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1268", 1);
Q7B_ASSIGNMENT(&sdf, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT("Q7BCompiler.exe"))));
} else {
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1270", 1);
Q7B_ASSIGNMENT(&sdf, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT("Q7BCompiler"))));
}
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1276", 1);
if (Q7B_CBOOLEAN(Q7B_DIR_EXISTS(Q7B_idDIR, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/gcc")))))){
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1277", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_DIFFDAYS(Q7B_QOBJECT(Q7B_DATEVALUE(Q7B_QOBJECT(Q7B_DIR_DATETIMECREATED(Q7B_idDIR, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/gcc"))))))), Q7B_QOBJECT(Q7B_DATEVALUE(Q7B_QOBJECT(Q7B_FILE_DATETIMECREATED(Q7B_idFILE, Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sdf))))))))), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1278", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Compiler is newer than project compiler files. Therefore, perform a 'Clean & Rebuild All' first."));
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1279", 1);
this->cleanandrebuildall(Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1280", 1);
return Q7B_QOBJECT(true);
}
}
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1285", 1);
if (Q7B_CBOOLEAN(Q7B_DIR_EXISTS(Q7B_idDIR, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT("/Q7BRuntime.obj")))))){
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1286", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_DIFFDAYS(Q7B_QOBJECT(Q7B_DATEVALUE(Q7B_QOBJECT(Q7B_DIR_DATETIMECREATED(Q7B_idDIR, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT("/Q7BRuntime.obj"))))))), Q7B_QOBJECT(Q7B_DATEVALUE(Q7B_QOBJECT(Q7B_FILE_DATETIMECREATED(Q7B_idFILE, Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sdf))))))))), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1287", 1);
Q7B_DELETE(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT("/Q7BRuntime.obj"))));
}
}
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1291", 1);
if (Q7B_CBOOLEAN(Q7B_DIR_EXISTS(Q7B_idDIR, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT("/Q7BRuntime.o")))))){
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1292", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_DIFFDAYS(Q7B_QOBJECT(Q7B_DATEVALUE(Q7B_QOBJECT(Q7B_DIR_DATETIMECREATED(Q7B_idDIR, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT("/Q7BRuntime.o"))))))), Q7B_QOBJECT(Q7B_DATEVALUE(Q7B_QOBJECT(Q7B_FILE_DATETIMECREATED(Q7B_idFILE, Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sdf))))))))), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1293", 1);
Q7B_DELETE(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT("/Q7BRuntime.o"))));
}
}
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1298", 1);
if (Q7B_CBOOLEAN(Q7B_FILE_EXISTS(Q7B_idFILE, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/gcc/Platform.txt")))))){
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1299", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_READSTRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/gcc/Platform.txt"))), Q7B_QOBJECT("")))));
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1301", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_OS_ISWINDOWS(Q7B_idOS)) && Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(s), Q7B_QOBJECT("Windows")))))){
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1302", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Files have been compiled on different platform. Therefore, perform a 'Clean & Rebuild All' first."));
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1303", 1);
this->cleanandrebuildall(Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1304", 1);
return Q7B_QOBJECT(true);
} else if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_OS_ISMAC(Q7B_idOS)) && Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(s), Q7B_QOBJECT("Mac")))))){
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1306", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Files have been compiled on different platform. Therefore, perform a 'Clean & Rebuild All' first."));
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1307", 1);
this->cleanandrebuildall(Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1308", 1);
return Q7B_QOBJECT(true);
} else if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_OS_ISLINUX(Q7B_idOS)) && Q7B_CBOOLEAN(Q7B_UNEQUAL(Q7B_QOBJECT(s), Q7B_QOBJECT("Linux")))))){
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1310", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Files have been compiled on different platform. Therefore, perform a 'Clean & Rebuild All' first."));
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1311", 1);
this->cleanandrebuildall(Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1312", 1);
return Q7B_QOBJECT(true);
}
}
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1316", 1);
return Q7B_QOBJECT(false);
                      Q7BS("MainWindow.QMainWindow", "CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary", "1317", 2);
return Q7B_IDNIL();

}

void MainWindow::Q7B_on_actionRun_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_triggered", "1320", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_triggered", "1321", 1);
if (Q7B_CBOOLEAN(this->CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary())){
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_triggered", "1321", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_triggered", "1323", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())))), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_triggered", "1324", 1);
Project::q7b_sharedSingleton()->SaveAll();
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_triggered", "1325", 1);
this->myStop();
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_triggered", "1326", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT("Run..."))));
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_triggered", "1328", 1);
Q7B_QPLAINTEXTEDIT_PLAINTEXT(plainTextEditLog, Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_triggered", "1329", 1);
Q7B_QPLAINTEXTEDIT_PLAINTEXT(plainTextEditCompiler, Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_triggered", "1330", 1);
Q7B_ASSIGNMENT(&bCompilerError, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_triggered", "1334", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCompiler *) (Compiler)->ref)->Run(Q7B_CQSTRING(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))), Q7B_CQSTRING(Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_triggered", "1335", 1);
Q7B_ASSIGNMENT(&bRunOrBuild, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_triggered", "1336", 1);
this->DoActions();
}
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_triggered", "1339", 2);

}

void MainWindow::Q7B_on_actionBuild_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionBuild_triggered", "1342", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionBuild_triggered", "1343", 1);
if (Q7B_CBOOLEAN(this->CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary())){
                      Q7BS("MainWindow.QMainWindow", "on_actionBuild_triggered", "1343", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionBuild_triggered", "1345", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())))), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionBuild_triggered", "1346", 1);
Project::q7b_sharedSingleton()->SaveAll();
                      Q7BS("MainWindow.QMainWindow", "on_actionBuild_triggered", "1347", 1);
this->myStop();
                      Q7BS("MainWindow.QMainWindow", "on_actionBuild_triggered", "1349", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT("Build..."))));
                      Q7BS("MainWindow.QMainWindow", "on_actionBuild_triggered", "1352", 1);
Q7B_QPLAINTEXTEDIT_PLAINTEXT(plainTextEditCompiler, Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionBuild_triggered", "1353", 1);
Q7B_ASSIGNMENT(&bCompilerError, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("MainWindow.QMainWindow", "on_actionBuild_triggered", "1357", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCompiler *) (Compiler)->ref)->Build(Q7B_CQSTRING(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionBuild_triggered", "1358", 1);
Q7B_ASSIGNMENT(&bRunOrBuild, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
                      Q7BS("MainWindow.QMainWindow", "on_actionBuild_triggered", "1359", 1);
Q7B_ASSIGNMENT(&bBuildOnly, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
                      Q7BS("MainWindow.QMainWindow", "on_actionBuild_triggered", "1360", 1);
this->DoActions();
}
                      Q7BS("MainWindow.QMainWindow", "on_actionBuild_triggered", "1367", 2);

}

void MainWindow::cleanandrebuildall(Q7B bDeployment)
{
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1372", 0);
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1373", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())))), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1374", 1);
Project::q7b_sharedSingleton()->SaveAll();
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1375", 1);
this->myStop();
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1377", 1);
if (Q7B_CBOOLEAN(bDeployment)){
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1378", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT("Deploy..."))));
} else {
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1380", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT("Clean & Rebuild All..."))));
}
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1383", 1);
if (Q7B_CBOOLEAN(Q7B_OS_ISMAC(Q7B_idOS))){
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1384", 1);
Q7B_DELETE(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/gcc/Build/"))), Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())))))), Q7B_QOBJECT(".app/Contents/MacOS/plugins"))));
}
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1388", 1);
Q7B_DIR_RECURSIVEREMOVE(Q7B_idDIR, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/gcc"))));
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1393", 1);
Q7B_QPLAINTEXTEDIT_PLAINTEXT(plainTextEditCompiler, Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1394", 1);
Q7B_ASSIGNMENT(&bCompilerError, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1396", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1397", 1);
if (Q7B_CBOOLEAN(bDeployment)){
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1398", 1);
Q7B_ASSIGNMENT(&s, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCompiler *) (Compiler)->ref)->Deploy(Q7B_CQSTRING(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())))))))));
} else {
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1400", 1);
Q7B_ASSIGNMENT(&s, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCompiler *) (Compiler)->ref)->Build(Q7B_CQSTRING(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())))))))));
}
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1402", 1);
Q7B_ASSIGNMENT(&bRunOrBuild, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1403", 1);
Q7B_ASSIGNMENT(&bBuildOnly, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1404", 1);
this->DoActions();
}
                      Q7BS("MainWindow.QMainWindow", "cleanandrebuildall", "1407", 2);

}

void MainWindow::Q7B_on_actionClean_RebuildAll_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionClean_RebuildAll_triggered", "1410", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionClean_RebuildAll_triggered", "1410", 1);
this->cleanandrebuildall(Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("MainWindow.QMainWindow", "on_actionClean_RebuildAll_triggered", "1411", 2);

}

void MainWindow::DoActions()
{
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1449", 0);
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1449", 1);
Q7B bDefault; bDefault = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false)));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1450", 1);
if (Q7B_CBOOLEAN(bDebug)){
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1451", 1);
Q7B_QACTION_TEXT(actionDebug, Q7B_QOBJECT("Continue"));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1452", 1);
Q7B_QACTION_ENABLED(actionDebug, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1454", 1);
Q7B_ASSIGNMENT(&bDefault, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1456", 1);
Q7B_QACTION_ENABLED(actionStep_Into, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1457", 1);
Q7B_QACTION_ENABLED(actionStep_Over, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1458", 1);
Q7B_QACTION_ENABLED(actionStep_Out, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1459", 1);
Q7B_QACTION_ENABLED(actionRun_To_Cursor, Q7B_QOBJECT(true));
} else if (Q7B_CBOOLEAN(bRunOrBuild)){
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1462", 1);
Q7B_QACTION_TEXT(actionDebug, Q7B_QOBJECT("Debug"));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1463", 1);
Q7B_QACTION_ENABLED(actionDebug, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1465", 1);
Q7B_ASSIGNMENT(&bDefault, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1467", 1);
Q7B_QWIDGET_VISIBLE(dockDebug, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1468", 1);
Q7B_QWIDGET_VISIBLE(dockLog, Q7B_QOBJECT(Q7B_NOT(Q7B_QOBJECT(bBuildOnly))));
} else {
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1471", 1);
Q7B_QACTION_TEXT(actionDebug, Q7B_QOBJECT("Debug"));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1472", 1);
Q7B_QACTION_ENABLED(actionDebug, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1474", 1);
Q7B_QWIDGET_VISIBLE(dockDebug, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1475", 1);
Q7B_QWIDGET_VISIBLE(dockLog, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1476", 1);
Q7B_QWIDGET_VISIBLE(dockCompiler, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1479", 1);
Q7B_QACTION_ENABLED(actionRun, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1480", 1);
Q7B_QACTION_ENABLED(actionBuild, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1481", 1);
Q7B_QACTION_ENABLED(actionStop, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1482", 1);
Q7B_QACTION_ENABLED(actionClean_RebuildAll, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1483", 1);
Q7B_QACTION_ENABLED(actionDebug, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1484", 1);
Q7B_QACTION_ENABLED(actionDeploy, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1485", 1);
Q7B_QACTION_ENABLED(gcc, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1486", 1);
Q7B_QACTION_ENABLED(vs, Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(Q7B_OR(Q7B_QOBJECT(true), Q7B_QOBJECT(Q7B_OS_ISWINDOWS(Q7B_idOS)))), Q7B_QOBJECT(false))));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1488", 1);
Q7B_QACTION_ENABLED(actionStep_Into, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1489", 1);
Q7B_QACTION_ENABLED(actionStep_Over, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1490", 1);
Q7B_QACTION_ENABLED(actionStep_Out, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1491", 1);
Q7B_QACTION_ENABLED(actionRun_To_Cursor, Q7B_QOBJECT(false));
}
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1495", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(bDefault), Q7B_QOBJECT(true)))){
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1497", 1);
Q7B_QWIDGET_VISIBLE(dockCompiler, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1498", 1);
Q7B_QACTION_ENABLED(actionRun, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1499", 1);
Q7B_QACTION_ENABLED(actionBuild, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1500", 1);
Q7B_QACTION_ENABLED(actionStop, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1501", 1);
Q7B_QACTION_ENABLED(actionClean_RebuildAll, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1502", 1);
Q7B_QACTION_ENABLED(actionDeploy, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1503", 1);
Q7B_QACTION_ENABLED(gcc, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1504", 1);
Q7B_QACTION_ENABLED(vs, Q7B_QOBJECT(false));
}
                      Q7BS("MainWindow.QMainWindow", "DoActions", "1510", 2);

}

void MainWindow::ResetDebugPosition()
{
                      Q7BS("MainWindow.QMainWindow", "ResetDebugPosition", "1513", 0);
                      Q7BS("MainWindow.QMainWindow", "ResetDebugPosition", "1513", 1);
if (Q7B_CBOOLEAN(bDebug)){
                      Q7BS("MainWindow.QMainWindow", "ResetDebugPosition", "1514", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LISTMDI())));
                      Q7BS("MainWindow.QMainWindow", "ResetDebugPosition", "1515", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "ResetDebugPosition", "1516", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "ResetDebugPosition", "1516", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "ResetDebugPosition", "1517", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))));
                      Q7BS("MainWindow.QMainWindow", "ResetDebugPosition", "1518", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "ResetDebugPosition", "1519", 1);
((Q7BCodeView *) (cb)->ref)->setCurrentDebugPosition((int) Q7B_CINTEGER(Q7B_QOBJECT(0)));
}
}
                      Q7BS("MainWindow.QMainWindow", "ResetDebugPosition", "1522", 2);

}

void MainWindow::myStop()
{
                      Q7BS("MainWindow.QMainWindow", "myStop", "1525", 0);
                      Q7BS("MainWindow.QMainWindow", "myStop", "1526", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())))), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "myStop", "1528", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCompiler *) (Compiler)->ref)->Stop(Q7B_CQSTRING(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))))));
                      Q7BS("MainWindow.QMainWindow", "myStop", "1529", 1);
this->ResetDebugPosition();
                      Q7BS("MainWindow.QMainWindow", "myStop", "1531", 1);
Q7B_QPROGRESSBAR_VALUE(progressBar, Q7B_QOBJECT(0));
                      Q7BS("MainWindow.QMainWindow", "myStop", "1533", 1);
Q7B_ASSIGNMENT(&bDebug, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("MainWindow.QMainWindow", "myStop", "1534", 1);
Q7B_ASSIGNMENT(&bRunOrBuild, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("MainWindow.QMainWindow", "myStop", "1535", 1);
Q7B_ASSIGNMENT(&bBuildOnly, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("MainWindow.QMainWindow", "myStop", "1536", 1);
Q7B_QWIDGET_VISIBLE(progressBar, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "myStop", "1538", 1);
this->DoActions();
}
                      Q7BS("MainWindow.QMainWindow", "myStop", "1541", 2);

}

void MainWindow::Q7B_on_Compiler_ReadyForDebugging()
{
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1544", 0);
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1546", 1);
Q7B_QWIDGET_VISIBLE(dockCompiler, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1547", 1);
Q7B_QWIDGET_VISIBLE(dockLog, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1549", 1);
Q7B_QPROGRESSBAR_MINIMUM(progressBar, Q7B_QOBJECT(0));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1550", 1);
Q7B_QPROGRESSBAR_MAXIMUM(progressBar, Q7B_QOBJECT(100));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1551", 1);
Q7B_QPROGRESSBAR_VALUE(progressBar, Q7B_QOBJECT(100));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1552", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(""))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1554", 1);
((Q7BCompiler *) (Compiler)->ref)->clearBreakpoints();
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1556", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LISTMDI())));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1557", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1558", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1558", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1559", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_LIST_OBJECT(a, Q7B_QOBJECT(i))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1560", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1562", 1);
Q7B k; k = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1563", 1);
Q7B kk; kk = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCodeView *) (cb)->ref)->getAllBreakpoints()))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1564", 1);
((Q7BCompiler *) (Compiler)->ref)->setBreakpoints(Q7B_CQSTRING(Q7B_QOBJECT(k)), Q7B_CQSTRINGLIST(Q7B_QOBJECT(kk)));
}
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_ReadyForDebugging", "1567", 2);

}

void MainWindow::Q7B_on_actionStop_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionStop_triggered", "1570", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionStop_triggered", "1570", 1);
this->myStop();
                      Q7BS("MainWindow.QMainWindow", "on_actionStop_triggered", "1571", 2);

}

void MainWindow::Q7B_on_actionDebug_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionDebug_triggered", "1578", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionDebug_triggered", "1581", 1);
if (Q7B_CBOOLEAN(this->CheckCompilerWithGCCDirVersionDateTimeAndRebuildIfNeccessary())){
                      Q7BS("MainWindow.QMainWindow", "on_actionDebug_triggered", "1581", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionDebug_triggered", "1583", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())))), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionDebug_triggered", "1584", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(bDebug), Q7B_QOBJECT(false)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionDebug_triggered", "1585", 1);
Project::q7b_sharedSingleton()->SaveAll();
                      Q7BS("MainWindow.QMainWindow", "on_actionDebug_triggered", "1586", 1);
this->myStop();
                      Q7BS("MainWindow.QMainWindow", "on_actionDebug_triggered", "1587", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT("Debug..."))));
}
                      Q7BS("MainWindow.QMainWindow", "on_actionDebug_triggered", "1591", 1);
Q7B_QPLAINTEXTEDIT_PLAINTEXT(plainTextEditLog, Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionDebug_triggered", "1592", 1);
Q7B_QPLAINTEXTEDIT_PLAINTEXT(plainTextEditCompiler, Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionDebug_triggered", "1593", 1);
Q7B_ASSIGNMENT(&bCompilerError, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("MainWindow.QMainWindow", "on_actionDebug_triggered", "1597", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCompiler *) (Compiler)->ref)->Debug(Q7B_CQSTRING(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))), Q7B_CQSTRING(Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionDebug_triggered", "1599", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(bDebug), Q7B_QOBJECT(false)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionDebug_triggered", "1600", 1);
Q7B_ASSIGNMENT(&bDebug, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
                      Q7BS("MainWindow.QMainWindow", "on_actionDebug_triggered", "1601", 1);
this->DoActions();
}
}
                      Q7BS("MainWindow.QMainWindow", "on_actionDebug_triggered", "1605", 2);

}

void MainWindow::Q7B_on_Compiler_StandardOutput(Q7B s)
{
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_StandardOutput", "1608", 0);
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_StandardOutput", "1608", 1);
Q7B_QPLAINTEXTEDIT_APPENDPLAINTEXT(plainTextEditLog, Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(s), Q7B_QOBJECT("\n"))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_StandardOutput", "1609", 2);

}

void MainWindow::Q7B_on_Compiler_StandardError(Q7B s)
{
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_StandardError", "1612", 0);
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_StandardError", "1612", 1);
Q7B_QPLAINTEXTEDIT_APPENDPLAINTEXT(plainTextEditLog, Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(s), Q7B_QOBJECT("\n"))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_StandardError", "1613", 2);

}

void MainWindow::Q7B_on_Compiler_StandardOutputOfCompiler(Q7B s)
{
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_StandardOutputOfCompiler", "1616", 0);
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_StandardOutputOfCompiler", "1616", 1);
Q7B_QPLAINTEXTEDIT_APPENDPLAINTEXT(plainTextEditCompiler, Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(s), Q7B_QOBJECT("\n"))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_StandardOutputOfCompiler", "1617", 2);

}

void MainWindow::ShowInternalError(Q7B s)
{
                      Q7BS("MainWindow.QMainWindow", "ShowInternalError", "1620", 0);
                      Q7BS("MainWindow.QMainWindow", "ShowInternalError", "1620", 1);
this->myStop();
                      Q7BS("MainWindow.QMainWindow", "ShowInternalError", "1621", 1);
Q7B_ASSIGNMENT(&bCompilerError, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
                      Q7BS("MainWindow.QMainWindow", "ShowInternalError", "1623", 1);
this->ShowLastError(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(""))), Q7B_QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))));
                      Q7BS("MainWindow.QMainWindow", "ShowInternalError", "1624", 1);
this->PrintStatusBar(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))));
                      Q7BS("MainWindow.QMainWindow", "ShowInternalError", "1625", 1);
Q7B_MSGBOX(Q7B_QOBJECT("Internal Error. Please report back to us."), Q7B_QOBJECT(s), Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "ShowInternalError", "1627", 1);
Q7B_QWIDGET_VISIBLE(dockCompiler, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "ShowInternalError", "1628", 2);

}

void MainWindow::Q7B_on_Compiler_StandardErrorOfCompiler(Q7B s)
{
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_StandardErrorOfCompiler", "1632", 0);
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_StandardErrorOfCompiler", "1632", 1);
if (Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(Q7B_STARTSWITH(Q7B_QOBJECT(s), Q7B_QOBJECT("Q7Basic: "), Q7B_QOBJECT(true)))))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_StandardErrorOfCompiler", "1632", 1);
this->ShowInternalError(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))));
}
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_StandardErrorOfCompiler", "1633", 1);
Q7B_QPLAINTEXTEDIT_APPENDPLAINTEXT(plainTextEditCompiler, Q7B_QOBJECT(Q7B_CONCAT(Q7B_QOBJECT(s), Q7B_QOBJECT("\n"))));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_StandardErrorOfCompiler", "1634", 2);

}

void MainWindow::Q7B_on_Compiler_CompilerOrApplicationFinished(Q7B bApplication)
{
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_CompilerOrApplicationFinished", "1637", 0);
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_CompilerOrApplicationFinished", "1638", 1);
this->myStop();
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_CompilerOrApplicationFinished", "1639", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(bApplication))) && Q7B_CBOOLEAN(Q7B_NOT(Q7B_QOBJECT(bCompilerError)))))){
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_CompilerOrApplicationFinished", "1640", 1);
Q7B_QPROGRESSBAR_MINIMUM(progressBar, Q7B_QOBJECT(0));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_CompilerOrApplicationFinished", "1641", 1);
Q7B_QPROGRESSBAR_MAXIMUM(progressBar, Q7B_QOBJECT(100));
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_CompilerOrApplicationFinished", "1642", 1);
Q7B_QPROGRESSBAR_VALUE(progressBar, Q7B_QOBJECT(100));
}
                      Q7BS("MainWindow.QMainWindow", "on_Compiler_CompilerOrApplicationFinished", "1644", 2);

}

void MainWindow::Q7B_on_actionStep_Into_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionStep_Into_triggered", "1647", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionStep_Into_triggered", "1647", 1);
((Q7BCompiler *) (Compiler)->ref)->StepInto();
                      Q7BS("MainWindow.QMainWindow", "on_actionStep_Into_triggered", "1648", 2);

}

void MainWindow::Q7B_on_actionStep_Over_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionStep_Over_triggered", "1651", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionStep_Over_triggered", "1651", 1);
((Q7BCompiler *) (Compiler)->ref)->StepOver();
                      Q7BS("MainWindow.QMainWindow", "on_actionStep_Over_triggered", "1652", 2);

}

void MainWindow::Q7B_on_actionStep_Out_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionStep_Out_triggered", "1655", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionStep_Out_triggered", "1655", 1);
((Q7BCompiler *) (Compiler)->ref)->StepOut();
                      Q7BS("MainWindow.QMainWindow", "on_actionStep_Out_triggered", "1656", 2);

}

void MainWindow::Q7B_on_actionRun_To_Cursor_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_To_Cursor_triggered", "1659", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_To_Cursor_triggered", "1659", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())))), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_To_Cursor_triggered", "1660", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_To_Cursor_triggered", "1661", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_To_Cursor_triggered", "1663", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_To_Cursor_triggered", "1664", 1);
Q7B ss; ss = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCodeView *) (cb)->ref)->getCurrentLine())), Q7B_QOBJECT(false)))));
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_To_Cursor_triggered", "1665", 1);
((Q7BCompiler *) (Compiler)->ref)->RunToCursor(Q7B_CQSTRING(Q7B_QOBJECT(s)), Q7B_CQSTRING(Q7B_QOBJECT(ss)));
}
                      Q7BS("MainWindow.QMainWindow", "on_actionRun_To_Cursor_triggered", "1667", 2);

}

void MainWindow::Q7B_on_actionToggle_Breakpoint_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionToggle_Breakpoint_triggered", "1670", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionToggle_Breakpoint_triggered", "1670", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())))), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionToggle_Breakpoint_triggered", "1671", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionToggle_Breakpoint_triggered", "1672", 1);
Q7B cb; cb = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT_CHILD(w, Q7B_QOBJECT("Q7BCodeBox"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionToggle_Breakpoint_triggered", "1673", 1);
Q7B n; n = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCodeView *) (cb)->ref)->getCurrentLine()))));
                      Q7BS("MainWindow.QMainWindow", "on_actionToggle_Breakpoint_triggered", "1674", 1);
((Q7BCodeView *) (cb)->ref)->setUnsetBreaktpoint((int) Q7B_CINTEGER(Q7B_QOBJECT(n)));
                      Q7BS("MainWindow.QMainWindow", "on_actionToggle_Breakpoint_triggered", "1677", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionToggle_Breakpoint_triggered", "1678", 1);
Q7B ss; ss = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(((Q7BCodeView *) (cb)->ref)->getCurrentLine())), Q7B_QOBJECT(false)))));
                      Q7BS("MainWindow.QMainWindow", "on_actionToggle_Breakpoint_triggered", "1679", 1);
((Q7BCompiler *) (Compiler)->ref)->Breakpoint(Q7B_CQSTRING(Q7B_QOBJECT(s)), Q7B_CQSTRING(Q7B_QOBJECT(ss)));
}
                      Q7BS("MainWindow.QMainWindow", "on_actionToggle_Breakpoint_triggered", "1682", 2);

}

void MainWindow::Q7B_on_actionDeploy_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionDeploy_triggered", "1685", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionDeploy_triggered", "1685", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_PREFERENCES_STRING(Q7B_idPREFERENCES, Q7B_QOBJECT("Serial")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionDeploy_triggered", "1686", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(s))), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionDeploy_triggered", "1687", 1);
this->cleanandrebuildall(Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
} else {
                      Q7BS("MainWindow.QMainWindow", "on_actionDeploy_triggered", "1689", 1);
Q7B__MSGBOX(Q7B_QOBJECT("This feature is for registered Q7Basic versions available only."));
}
                      Q7BS("MainWindow.QMainWindow", "on_actionDeploy_triggered", "1691", 2);

}

void MainWindow::Q7B_on_actionQObject_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionQObject_triggered", "1694", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionQObject_triggered", "1696", 1);
if (Q7B_CBOOLEAN(Project::q7b_sharedSingleton()->IsSingleFileProject())){
}
                      Q7BS("MainWindow.QMainWindow", "on_actionQObject_triggered", "1700", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionQObject_triggered", "1701", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "on_actionQObject_triggered", "1702", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionQObject_triggered", "1705", 1);
Q7B sClass; sClass = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("MainWindow.QMainWindow", "on_actionQObject_triggered", "1706", 1);
Q7B_ASSIGNMENT(&sClass, &Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT("Class.QObject"), Q7B_QOBJECT("New File With Super Class QObject"), Q7B_QOBJECT("myClass"))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionQObject_triggered", "1707", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sClass), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionQObject_triggered", "1708", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionQObject_triggered", "1711", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sClass))), Q7B_QOBJECT(".QObject")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionQObject_triggered", "1712", 1);
Q7B_WRITESTRING(Q7B_QOBJECT("' just created this file"), Q7B_QOBJECT(s), Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionQObject_triggered", "1713", 1);
Project::q7b_sharedSingleton()->OpenCodeView(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))));
                      Q7BS("MainWindow.QMainWindow", "on_actionQObject_triggered", "1714", 2);

}

void MainWindow::Q7B_on_actionQWidget_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionQWidget_triggered", "1717", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionQWidget_triggered", "1718", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionQWidget_triggered", "1719", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "on_actionQWidget_triggered", "1720", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionQWidget_triggered", "1723", 1);
Q7B sClass; sClass = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("MainWindow.QMainWindow", "on_actionQWidget_triggered", "1724", 1);
Q7B_ASSIGNMENT(&sClass, &Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT("Class.QWidget"), Q7B_QOBJECT("New File With Super Class QWidget"), Q7B_QOBJECT("myClass"))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionQWidget_triggered", "1725", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sClass), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionQWidget_triggered", "1726", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionQWidget_triggered", "1729", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sClass))), Q7B_QOBJECT(".QWidget")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionQWidget_triggered", "1730", 1);
Q7B_WRITESTRING(Q7B_QOBJECT(" 'just created this file"), Q7B_QOBJECT(s), Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionQWidget_triggered", "1731", 1);
Project::q7b_sharedSingleton()->OpenCodeView(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))));
                      Q7BS("MainWindow.QMainWindow", "on_actionQWidget_triggered", "1732", 2);

}

void MainWindow::Q7B_on_actionNew_Class_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Class_triggered", "1735", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Class_triggered", "1736", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Class_triggered", "1737", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Class_triggered", "1738", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Class_triggered", "1741", 1);
Q7B sClass; sClass = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Class_triggered", "1742", 1);
Q7B_ASSIGNMENT(&sClass, &Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT("Class"), Q7B_QOBJECT("New File As Class"), Q7B_QOBJECT("myClass"))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Class_triggered", "1743", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sClass), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Class_triggered", "1744", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Class_triggered", "1747", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sClass))), Q7B_QOBJECT(".Class")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Class_triggered", "1748", 1);
Q7B_WRITESTRING(Q7B_QOBJECT(" 'just created this file"), Q7B_QOBJECT(s), Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Class_triggered", "1749", 1);
Project::q7b_sharedSingleton()->OpenCodeView(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Class_triggered", "1750", 2);

}

void MainWindow::Q7B_on_actionNew_Module_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Module_triggered", "1753", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Module_triggered", "1754", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Module_triggered", "1755", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Module_triggered", "1756", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Module_triggered", "1759", 1);
Q7B sClass; sClass = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Module_triggered", "1760", 1);
Q7B_ASSIGNMENT(&sClass, &Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT("Module"), Q7B_QOBJECT("New File As Module"), Q7B_QOBJECT("myModule"))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Module_triggered", "1761", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sClass), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Module_triggered", "1762", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Module_triggered", "1765", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sClass))), Q7B_QOBJECT(".Module")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Module_triggered", "1766", 1);
Q7B_WRITESTRING(Q7B_QOBJECT(" 'just created this file"), Q7B_QOBJECT(s), Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Module_triggered", "1767", 1);
Project::q7b_sharedSingleton()->OpenCodeView(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_Module_triggered", "1768", 2);

}

void MainWindow::Q7B_on_actionQDialog_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionQDialog_triggered", "1771", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionQDialog_triggered", "1772", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionQDialog_triggered", "1773", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "on_actionQDialog_triggered", "1774", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionQDialog_triggered", "1777", 1);
Q7B sClass; sClass = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("MainWindow.QMainWindow", "on_actionQDialog_triggered", "1778", 1);
Q7B_ASSIGNMENT(&sClass, &Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT("Class.QDialog"), Q7B_QOBJECT("New File With Super Class QDialog"), Q7B_QOBJECT("myClass"))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionQDialog_triggered", "1779", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sClass), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionQDialog_triggered", "1780", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionQDialog_triggered", "1783", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sClass))), Q7B_QOBJECT(".QDialog")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionQDialog_triggered", "1784", 1);
Q7B_WRITESTRING(Q7B_QOBJECT(" 'just created this file"), Q7B_QOBJECT(s), Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionQDialog_triggered", "1785", 1);
Project::q7b_sharedSingleton()->OpenCodeView(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))));
                      Q7BS("MainWindow.QMainWindow", "on_actionQDialog_triggered", "1786", 2);

}

void MainWindow::Q7B_on_actionNew_File_With_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_File_With_triggered", "1789", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_File_With_triggered", "1790", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_File_With_triggered", "1791", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_File_With_triggered", "1792", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_File_With_triggered", "1795", 1);
Q7B sClass; sClass = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_File_With_triggered", "1796", 1);
Q7B_ASSIGNMENT(&sClass, &Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT("Class.SuperClass"), Q7B_QOBJECT("New File With..."), Q7B_QOBJECT("myClass.QObject"))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_File_With_triggered", "1797", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sClass), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_File_With_triggered", "1798", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_File_With_triggered", "1801", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sClass)))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_File_With_triggered", "1802", 1);
Q7B_WRITESTRING(Q7B_QOBJECT(" 'just created this file"), Q7B_QOBJECT(s), Q7B_QOBJECT(""));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_File_With_triggered", "1803", 1);
Project::q7b_sharedSingleton()->OpenCodeView(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))));
                      Q7BS("MainWindow.QMainWindow", "on_actionNew_File_With_triggered", "1804", 2);

}

void MainWindow::Q7B_on_actionDelete_Current_File_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1807", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1808", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1809", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1810", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1813", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LISTMDI())));
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1814", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1815", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1818", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1819", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1820", 1);
if (Q7B_CBOOLEAN(Q7B_ENDSWITH(Q7B_QOBJECT(s), Q7B_QOBJECT("Global.QObject"), Q7B_QOBJECT(true)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1821", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Global.QObject must not be deleted."));
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1822", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1824", 1);
if (Q7B_CBOOLEAN(Q7B_ENDSWITH(Q7B_QOBJECT(s), Q7B_QOBJECT("MainWindow.QMainWindow"), Q7B_QOBJECT(true)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1825", 1);
Q7B__MSGBOX(Q7B_QOBJECT("MainWindow.QMainWindow must not be deleted."));
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1826", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1832", 1);
Q7B sYes; sYes = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1833", 1);
Q7B_ASSIGNMENT(&sYes, &Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT("Should be the following file deleted?"), Q7B_QOBJECT("Delete Current File"), Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(s))))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1834", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sYes), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1835", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1837", 1);
Q7B_CLOSEMDI(Q7B_QOBJECT(w));
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1839", 1);
Q7B_DELETE(Q7B_QOBJECT(s));
                      Q7BS("MainWindow.QMainWindow", "on_actionDelete_Current_File_triggered", "1840", 2);

}

void MainWindow::Q7B_on_actionDuplicate_Current_File_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1843", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1844", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1845", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1846", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1849", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LISTMDI())));
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1850", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1851", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1854", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1855", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1858", 1);
Q7B sYes; sYes = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1859", 1);
Q7B_ASSIGNMENT(&sYes, &Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT("Enter the duplicate name for "), Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(s))))), Q7B_QOBJECT("Duplicate Current File"), Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(s))))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1860", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sYes), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1861", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1863", 1);
Q7B s2; s2 = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_FILEPATH(Q7B_QOBJECT(s))), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sYes)))));
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1864", 1);
Q7B_COPY(Q7B_QOBJECT(s), Q7B_QOBJECT(s2));
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1865", 1);
Project::q7b_sharedSingleton()->OpenCodeView(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s2))));
                      Q7BS("MainWindow.QMainWindow", "on_actionDuplicate_Current_File_triggered", "1866", 2);

}

Q7B MainWindow::getCurrentFileName()
{
                      Q7BS("MainWindow.QMainWindow", "getCurrentFileName", "1869", 0);
                      Q7BS("MainWindow.QMainWindow", "getCurrentFileName", "1869", 1);
Q7B a; a = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_LISTMDI())));
                      Q7BS("MainWindow.QMainWindow", "getCurrentFileName", "1870", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_LIST_LENGTH(a)), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "getCurrentFileName", "1871", 1);
return Q7B_QOBJECT("");
}
                      Q7BS("MainWindow.QMainWindow", "getCurrentFileName", "1874", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "getCurrentFileName", "1875", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PROPERTY(w, "PathFileName")))));
                      Q7BS("MainWindow.QMainWindow", "getCurrentFileName", "1876", 1);
return Q7B_QOBJECT(s);
                      Q7BS("MainWindow.QMainWindow", "getCurrentFileName", "1877", 2);
return Q7B_IDNIL();

}

void MainWindow::Q7B_on_actionRename_Current_File_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1880", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1881", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1882", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1883", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1886", 1);
Q7B w; w = Q7B__QWIDGET(Q7B_QOBJECT(Q7B_FOCUSMDI()));
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1887", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(this->getCurrentFileName())));
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1889", 1);
if (Q7B_CBOOLEAN(Q7B_ENDSWITH(Q7B_QOBJECT(s), Q7B_QOBJECT("Global.QObject"), Q7B_QOBJECT(true)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1890", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Global.QObject must not be renamed."));
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1891", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1893", 1);
if (Q7B_CBOOLEAN(Q7B_ENDSWITH(Q7B_QOBJECT(s), Q7B_QOBJECT("MainWindow.QMainWindow"), Q7B_QOBJECT(true)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1894", 1);
Q7B__MSGBOX(Q7B_QOBJECT("MainWindow.QMainWindow must not be renamed."));
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1895", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1899", 1);
Q7B sYes; sYes = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1900", 1);
Q7B_ASSIGNMENT(&sYes, &Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT("Enter the new name for "), Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(s))))), Q7B_QOBJECT("Rename Current File"), Q7B_QOBJECT(Q7B_FILENAME(Q7B_QOBJECT(s))))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1901", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sYes), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1902", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1904", 1);
Q7B_CLOSEMDI(Q7B_QOBJECT(w));
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1905", 1);
Q7B s2; s2 = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_FILEPATH(Q7B_QOBJECT(s))), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sYes)))));
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1906", 1);
Q7B_MOVE(Q7B_QOBJECT(s), Q7B_QOBJECT(s2));
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1907", 1);
Project::q7b_sharedSingleton()->OpenCodeView(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s2))));
                      Q7BS("MainWindow.QMainWindow", "on_actionRename_Current_File_triggered", "1908", 2);

}

void MainWindow::OpenUI(Q7B s, Q7B s2)
{
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1911", 0);
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1915", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1916", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1917", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1920", 1);
if (Q7B_CBOOLEAN((Q7B_CBOOLEAN((Q7B_CBOOLEAN((Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_FILEEXTENSION(Q7B_QOBJECT(s))), Q7B_QOBJECT("QObject"))) || Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_FILEBASENAME(Q7B_QOBJECT(s))), Q7B_QOBJECT("Global"))))) || Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_FILEBASENAME(Q7B_QOBJECT(s))), Q7B_QOBJECT("Application"))))) || Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_FILEBASENAME(Q7B_QOBJECT(s))), Q7B_QOBJECT("SystemTray")))))){
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1921", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Creating a GUI ui file for the current code file is not allowed and makes no sense.\nNormally, you would open the MainWindow.QMainWindow code file and hit the Qt Designer button."));
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1922", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1931", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(s2)))){
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1935", 1);
if (Q7B_CBOOLEAN(Q7B_OS_ISMAC(Q7B_idOS))){
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1936", 1);
Q7B_LAUNCH(Q7B_QOBJECT("/Developer/Applications/Qt/Designer.app/Contents/MacOS/Designer"), Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT(s2))), Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT(false));
} else if (Q7B_CBOOLEAN(Q7B_OS_ISWINDOWS(Q7B_idOS))){
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1938", 1);
Q7B_LAUNCH(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sQtMINGWDir), Q7B_QOBJECT("/bin/designer"))), Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT(s2))), Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT(false));
} else {
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1940", 1);
Q7B_LAUNCH(Q7B_QOBJECT("/usr/bin/designer"), Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT(s2))), Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT(false));
}
} else {
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1945", 1);
Q7B s3; s3 = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(QString(""))));
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1948", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_FILEEXTENSION(Q7B_QOBJECT(s))), Q7B_QOBJECT("QMainWindow")))){
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1949", 1);
Q7B_ASSIGNMENT(&s3, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT("QMainWindow.ui"))));
} else if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_FILEEXTENSION(Q7B_QOBJECT(s))), Q7B_QOBJECT("QDialog")))){
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1951", 1);
Q7B_ASSIGNMENT(&s3, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT("QDialog.ui"))));
} else {
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1953", 1);
Q7B_ASSIGNMENT(&s3, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT("QWidget.ui"))));
}
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1956", 1);
Q7B_COPY(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT("/Templates/"))), Q7B_QOBJECT(s3))), Q7B_QOBJECT(s2));
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1958", 1);
if (Q7B_CBOOLEAN(Q7B_OS_ISMAC(Q7B_idOS))){
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1959", 1);
Q7B_LAUNCH(Q7B_QOBJECT("/Developer/Applications/Qt/Designer.app/Contents/MacOS/Designer"), Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT(s2))), Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT(false));
} else if (Q7B_CBOOLEAN(Q7B_OS_ISWINDOWS(Q7B_idOS))){
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1961", 1);
Q7B_LAUNCH(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sQtMINGWDir), Q7B_QOBJECT("/bin/designer"))), Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT(s2))), Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT(false));
} else {
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1963", 1);
Q7B_LAUNCH(Q7B_QOBJECT("/usr/bin/designer"), Q7B_QOBJECT(Q7B_List::init(Q7B_QOBJECT(s2))), Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT(false));
}
}
                      Q7BS("MainWindow.QMainWindow", "OpenUI", "1967", 2);

}

void MainWindow::Q7B_on_actionMainWindow_ui_2_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionMainWindow_ui_2_triggered", "1970", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionMainWindow_ui_2_triggered", "1970", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())), Q7B_QOBJECT("/"))), Q7B_QOBJECT("MainWindow.QMainWindow")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionMainWindow_ui_2_triggered", "1971", 1);
Q7B s2; s2 = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_FILEPATH(Q7B_QOBJECT(s))), Q7B_QOBJECT("/"))), Q7B_QOBJECT("MainWindow.ui")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionMainWindow_ui_2_triggered", "1973", 1);
this->OpenUI(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s2))));
                      Q7BS("MainWindow.QMainWindow", "on_actionMainWindow_ui_2_triggered", "1974", 2);

}

void MainWindow::Q7B_on_actionQt_Designer_for_MainWindow_ui_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Designer_for_MainWindow_ui_triggered", "1977", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Designer_for_MainWindow_ui_triggered", "1977", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(this->getCurrentFileName())));
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Designer_for_MainWindow_ui_triggered", "1978", 1);
Q7B s2; s2 = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_FILEPATH(Q7B_QOBJECT(s))), Q7B_QOBJECT("/"))), Q7B_QOBJECT(Q7B_FILEBASENAME(Q7B_QOBJECT(s))))), Q7B_QOBJECT(".ui")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Designer_for_MainWindow_ui_triggered", "1980", 1);
this->OpenUI(Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))), Q7B_QOBJECT(Q7B_STRING(Q7B_QOBJECT(s2))));
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Designer_for_MainWindow_ui_triggered", "1981", 2);

}

void MainWindow::Q7B_on_actionShow_Project_Folder_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionShow_Project_Folder_triggered", "1984", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionShow_Project_Folder_triggered", "1985", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath()))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionShow_Project_Folder_triggered", "1986", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Current project is a single file project, therefore this feature is not available now. "));
                      Q7BS("MainWindow.QMainWindow", "on_actionShow_Project_Folder_triggered", "1987", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionShow_Project_Folder_triggered", "1990", 1);
Q7B_OPENURL(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())));
                      Q7BS("MainWindow.QMainWindow", "on_actionShow_Project_Folder_triggered", "1991", 2);

}

void MainWindow::Q7B_on_actionLanguage_Reference_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionLanguage_Reference_triggered", "1996", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionLanguage_Reference_triggered", "1996", 1);
Q7B_OPENURL(Q7B_QOBJECT("Language Reference.html"));
                      Q7BS("MainWindow.QMainWindow", "on_actionLanguage_Reference_triggered", "1998", 2);

}

void MainWindow::Q7B_on_actionQt_DesignerHelp_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_DesignerHelp_triggered", "2001", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_DesignerHelp_triggered", "2001", 1);
Q7B_OPENURL(Q7B_QOBJECT("http://doc.qt.nokia.com/4.7/designer-manual.html"));
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_DesignerHelp_triggered", "2002", 2);

}

void MainWindow::Q7B_on_actionContribute_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionContribute_triggered", "2006", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionContribute_triggered", "2006", 1);
Q7B_OPENURL(Q7B_QOBJECT("http://www.q7basic.org/forum/viewtopic.php?f=5&t=18"));
                      Q7BS("MainWindow.QMainWindow", "on_actionContribute_triggered", "2007", 2);

}

void MainWindow::Q7B_on_actionBug_Report_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionBug_Report_triggered", "2010", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionBug_Report_triggered", "2011", 1);
Q7B_OPENURL(Q7B_QOBJECT("http://www.q7basic.org/forum/viewforum.php?f=4"));
                      Q7BS("MainWindow.QMainWindow", "on_actionBug_Report_triggered", "2013", 1);
Q7B_MSGBOX(Q7B_QOBJECT("How to Report A Bug"), Q7B_QOBJECT("If you think you have found a bug, we would like To hear about it so that we can fix it. Before reporting a bug, please check If the issue Is already known.\n   \nAlways include the following information in your bug report:\n\n+ The version \n+ The name and version number of your operating system\n\nIf the problem you are reporting is only visible at run-time, try to create a small test program that shows the problem when run. Often, such a program can be created with some minor changes. \n\nThanks! \nThe following (and probably many others) have provided bug reports, suggestions, patches, beta testing, or done us other favors. We thank you all:\n\nF Maurice Butler, Christoph Engelbert, Mark Goossens, Serge Dejardin, ScreenHunter, Dr.Kaiser, C.Michael Levy PhD., Reiner Goerlach, Francis Hineman, Michael Nix, Christopher Scott Wyatt, Laverne Dietzel, Klaus Lengfeld, Pete Baker, J?rgen Putzmann, Gerald Veurink, Joe Johnson, Ad Verburg, Ben Jimenez, Muhammed Cotwal, Donald Darden, Achim Rogalski, Peter Bially, Wolfgang Praxl, Michel Krommenaker, Rolf Henning, Joost van Zijl, Egan Saunders, Stuart Galloway\n\nWe hope there are not too many omissions from the list."), Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "on_actionBug_Report_triggered", "2015", 2);

}

void MainWindow::Q7B_on_actionQt_Reference_Documentation_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Reference_Documentation_triggered", "2019", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Reference_Documentation_triggered", "2021", 1);
Q7B_OPENURL(Q7B_QOBJECT("http://doc.qt.nokia.com/4.7/"));
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Reference_Documentation_triggered", "2022", 2);

}

void MainWindow::Q7B_on_actionSQLite_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionSQLite_triggered", "2025", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionSQLite_triggered", "2025", 1);
Q7B_OPENURL(Q7B_QOBJECT("http://www.sqlite.org/docs.html"));
                      Q7BS("MainWindow.QMainWindow", "on_actionSQLite_triggered", "2026", 2);

}

void MainWindow::Q7B_on_actionMySQL_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionMySQL_triggered", "2029", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionMySQL_triggered", "2029", 1);
Q7B_OPENURL(Q7B_QOBJECT("http://dev.mysql.com/doc/refman/5.1/en/index.html"));
                      Q7BS("MainWindow.QMainWindow", "on_actionMySQL_triggered", "2030", 2);

}

void MainWindow::Q7B_on_actionPostgreSQL_2_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionPostgreSQL_2_triggered", "2033", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionPostgreSQL_2_triggered", "2033", 1);
Q7B_OPENURL(Q7B_QOBJECT("http://www.postgresql.org/docs/8.4/interactive/index.html"));
                      Q7BS("MainWindow.QMainWindow", "on_actionPostgreSQL_2_triggered", "2034", 2);

}

void MainWindow::Q7B_on_actionQ7Basic_Essentials_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionQ7Basic_Essentials_triggered", "2037", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionQ7Basic_Essentials_triggered", "2037", 1);
Q7B_OPENURL(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT("/Q7Basic_essentials.pdf"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionQ7Basic_Essentials_triggered", "2038", 2);

}

void MainWindow::Q7B_on_actionGeneral_Manual_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionGeneral_Manual_triggered", "2041", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionGeneral_Manual_triggered", "2041", 1);
Q7B_OPENURL(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT("/Q7Basic_General Manual.pdf"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionGeneral_Manual_triggered", "2042", 2);

}

void MainWindow::Q7B_on_actionQuick_Start_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionQuick_Start_triggered", "2045", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionQuick_Start_triggered", "2045", 1);
Q7B_OPENURL(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT("/Q7Basic_Quick Start.pdf"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionQuick_Start_triggered", "2046", 2);

}

void MainWindow::Q7B_on_actionQt_Designer_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Designer_triggered", "2049", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Designer_triggered", "2049", 1);
Q7B_OPENURL(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_APPLICATION_PATH(Application::q7b_sharedSingletonQ7B())), Q7B_QOBJECT("/Qt Designer.pdf"))));
                      Q7BS("MainWindow.QMainWindow", "on_actionQt_Designer_triggered", "2050", 2);

}

void MainWindow::Q7B_on_actionRegister_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionRegister_triggered", "2053", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionRegister_triggered", "2053", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_PREFERENCES_STRING(Q7B_idPREFERENCES, Q7B_QOBJECT("Serial")))));
                      Q7BS("MainWindow.QMainWindow", "on_actionRegister_triggered", "2054", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(s), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionRegister_triggered", "2055", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionRegister_triggered", "2057", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(s))), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionRegister_triggered", "2058", 1);
Q7B__MSGBOX(Q7B_QOBJECT("Q7Basic is already successfully registered."));
                      Q7BS("MainWindow.QMainWindow", "on_actionRegister_triggered", "2059", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionRegister_triggered", "2062", 1);
Q7B sSerial; sSerial = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECTNULL(0)));
                      Q7BS("MainWindow.QMainWindow", "on_actionRegister_triggered", "2063", 1);
Q7B_ASSIGNMENT(&sSerial, &Q7B__QOBJECT(Q7B_QOBJECT(Q7B_QOBJECT(Q7B_INPUTBOX(Q7B_QOBJECT("Please enter the serial number to unlock Q7Basic."), Q7B_QOBJECT("Register..."), Q7B_QOBJECT(""))))));
                      Q7BS("MainWindow.QMainWindow", "on_actionRegister_triggered", "2064", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(sSerial), Q7B_QOBJECT(Q7B_QOBJECTNULL(0))))){
                      Q7BS("MainWindow.QMainWindow", "on_actionRegister_triggered", "2065", 1);
return;
}
                      Q7BS("MainWindow.QMainWindow", "on_actionRegister_triggered", "2067", 1);
Q7B_PREFERENCES_SETSTRING(Q7B_idPREFERENCES, Q7B_QOBJECT("Serial"), Q7B_QOBJECT(sSerial));
                      Q7BS("MainWindow.QMainWindow", "on_actionRegister_triggered", "2069", 2);

}

void MainWindow::Q7B_on_actionSave_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionSave_triggered", "2073", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionSave_triggered", "2073", 1);
if (Q7B_CBOOLEAN(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())))), Q7B_QOBJECT(0)))){
                      Q7BS("MainWindow.QMainWindow", "on_actionSave_triggered", "2074", 1);
Project::q7b_sharedSingleton()->SaveAll();
}
                      Q7BS("MainWindow.QMainWindow", "on_actionSave_triggered", "2076", 2);

}

void MainWindow::Q7B_on_actionReadme_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionReadme_triggered", "2079", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionReadme_triggered", "2079", 1);
Q7B_OPENTEXTWINDOW(Q7B_QOBJECT(Q7B_READSTRING(Q7B_QOBJECT(":/Resources/Readme.txt"), Q7B_QOBJECT(""))));
                      Q7BS("MainWindow.QMainWindow", "on_actionReadme_triggered", "2080", 2);

}

void MainWindow::Q7B_on_actionLicense_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionLicense_triggered", "2083", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionLicense_triggered", "2083", 1);
Q7B_OPENTEXTWINDOW(Q7B_QOBJECT(Q7B_READSTRING(Q7B_QOBJECT(":/Resources/License.txt"), Q7B_QOBJECT(""))));
                      Q7BS("MainWindow.QMainWindow", "on_actionLicense_triggered", "2084", 2);

}

void MainWindow::Q7B_on_actionAbout_Q7Basic_triggered(Q7B Checked)
{
                      Q7BS("MainWindow.QMainWindow", "on_actionAbout_Q7Basic_triggered", "2087", 0);
                      Q7BS("MainWindow.QMainWindow", "on_actionAbout_Q7Basic_triggered", "2087", 1);
Q7B_OPENDIALOG(Q7B_QOBJECT("About"));
                      Q7BS("MainWindow.QMainWindow", "on_actionAbout_Q7Basic_triggered", "2088", 2);

}

void MainWindow::Q7B_on_menuConfiguration_triggered(Q7B Action)
{
                      Q7BS("MainWindow.QMainWindow", "on_menuConfiguration_triggered", "2095", 0);
                      Q7BS("MainWindow.QMainWindow", "on_menuConfiguration_triggered", "2095", 1);
this->Configuration(Q7B_QACTION(Q7B_QOBJECT(Action)), Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true))));
                      Q7BS("MainWindow.QMainWindow", "on_menuConfiguration_triggered", "2096", 2);

}

void MainWindow::Configuration(Q7B Action, Q7B bRebuild)
{
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2099", 0);
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2101", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QACTION_TAG(Action)), Q7B_QOBJECT("vs")))){
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2102", 1);
Q7B_PREFERENCES_SETBOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("vs"), Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2103", 1);
Q7B_PREFERENCES_SETBOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("gcc"), Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2104", 1);
Q7B_QACTION_CHECKED(vs, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2105", 1);
Q7B_QACTION_CHECKED(gcc, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2107", 1);
Q7B s; s = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_PREFERENCES_STRING(Q7B_idPREFERENCES, Q7B_QOBJECT("VCDir")))));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2108", 1);
if (Q7B_CBOOLEAN(Q7B_AND(Q7B_QOBJECT(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(s))), Q7B_QOBJECT(0))), Q7B_QOBJECT(Q7B_FILE(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(s), Q7B_QOBJECT("/bin/cl.exe")))))))){
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2109", 1);
((Q7BCompiler *) (Compiler)->ref)->setVCDir(Q7B_CQSTRING(Q7B_QOBJECT(s)));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2110", 1);
Q7B_ASSIGNMENT(&sVCDir, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))));
} else {
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2113", 1);
Q7B sreg; sreg = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_READREGISTRY(Q7B_QOBJECT("HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\VCExpress\\9.0"), Q7B_QOBJECT("installdir")))));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2115", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sreg), Q7B_QOBJECT("/bin/cl.exe")))))){
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2116", 1);
Q7B_ASSIGNMENT(&sVCDir, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(sreg))));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2117", 1);
Q7B_PREFERENCES_SETSTRING(Q7B_idPREFERENCES, Q7B_QOBJECT("VCDir"), Q7B_QOBJECT(sVCDir));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2118", 1);
((Q7BCompiler *) (Compiler)->ref)->setVCDir(Q7B_CQSTRING(Q7B_QOBJECT(sVCDir)));
} else {
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2121", 1);
Q7B_MSGBOX(Q7B_QOBJECT("Configuration"), Q7B_QOBJECT("Please select the Visual Studio C++ directory.\nNormally, for VS 2008 it would be C:\\Program Files\\Microsoft Visual Studio 9.0\\VC"), Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2123", 1);
Q7B sVCDir; sVCDir = Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_OPENFILEDIALOG_GETDIRECTORY(Q7B_idOPENFILEDIALOG))));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2125", 1);
Q7B_PREFERENCES_SETSTRING(Q7B_idPREFERENCES, Q7B_QOBJECT("VCDir"), Q7B_QOBJECT(sVCDir));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2126", 1);
((Q7BCompiler *) (Compiler)->ref)->setVCDir(Q7B_CQSTRING(Q7B_QOBJECT(sVCDir)));
}
}
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2131", 1);
Q7B_ASSIGNMENT(&s, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_PREFERENCES_STRING(Q7B_idPREFERENCES, Q7B_QOBJECT("QtDir"))))));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2132", 1);
if (Q7B_CBOOLEAN(Q7B_AND(Q7B_QOBJECT(Q7B_GREATER(Q7B_QOBJECT(Q7B_LEN(Q7B_QOBJECT(s))), Q7B_QOBJECT(0))), Q7B_QOBJECT(Q7B_FILE(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(s), Q7B_QOBJECT("/bin/qmake.exe")))))))){
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2133", 1);
((Q7BCompiler *) (Compiler)->ref)->setQtDir(Q7B_CQSTRING(Q7B_QOBJECT(s)));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2134", 1);
Q7B_ASSIGNMENT(&sQtDir, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(s))));
} else {
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2142", 1);
Q7B bManual; bManual = Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(true)));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2143", 1);
Q7B locations; locations = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_List::init())));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2145", 1);
Q7B drives; drives = Q7B__QOBJECT(Q7B_LIST(Q7B_QOBJECT(Q7B_DRIVES())));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2146", 1);
Q7B i; i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT((qint64) 0)));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2147", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(drives)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "Configuration", "2147", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2148", 1);
Q7B_LIST_APPEND(locations, Q7B_QOBJECT(Q7B_LIST_OBJECT(drives, Q7B_QOBJECT(i))));
}
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2150", 1);
Q7B_LIST_APPEND(locations, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT("C:/Program Files"), Q7B_QOBJECT("/"))));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2151", 1);
Q7B_LIST_APPEND(locations, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_DIR_APPLICATIONSPATH(Q7B_idDIR)), Q7B_QOBJECT("/"))));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2152", 1);
Q7B_LIST_APPEND(locations, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_DIR_HOMEPATH(Q7B_idDIR)), Q7B_QOBJECT("/"))));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2153", 1);
Q7B_LIST_APPEND(locations, Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_DIR_DESKTOPPATH(Q7B_idDIR)), Q7B_QOBJECT("/"))));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2155", 1);
for (i = Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(0))); Q7B_CBOOLEAN(Q7B_SMALLEREQUAL(Q7B_QOBJECT(i), Q7B_QOBJECT(Q7B_SUB(Q7B_QOBJECT(Q7B_LIST_LENGTH(locations)), Q7B_QOBJECT(1))))); Q7BS("MainWindow.QMainWindow", "Configuration", "2155", 1),i = Q7B__QOBJECT(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(i), Q7B__QOBJECT(Q7B_INTEGER(Q7B_QOBJECT(1))))))){
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2159", 1);
if (Q7B_CBOOLEAN(Q7B_FILE(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_LIST_OBJECT(locations, Q7B_QOBJECT(i))), Q7B_QOBJECT("Qt/"))), Q7B_QOBJECT(sQtVersion))), Q7B_QOBJECT("/bin/qmake.exe")))))){
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2160", 1);
Q7B_ASSIGNMENT(&sQtDir, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_LIST_OBJECT(locations, Q7B_QOBJECT(i))), Q7B_QOBJECT("Qt/"))), Q7B_QOBJECT(sQtVersion))))));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2161", 1);
Q7B_PREFERENCES_SETSTRING(Q7B_idPREFERENCES, Q7B_QOBJECT("QtDir"), Q7B_QOBJECT(sQtDir));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2162", 1);
((Q7BCompiler *) (Compiler)->ref)->setQtDir(Q7B_CQSTRING(Q7B_QOBJECT(sQtDir)));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2163", 1);
Q7B_ASSIGNMENT(&bManual, &Q7B__QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2164", 1);
break;
}
}
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2168", 1);
if (Q7B_CBOOLEAN(bManual)){
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2170", 1);
Q7B_MSGBOX(Q7B_QOBJECT("Configuration"), Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT("Please select the Qt library directory for VS in which the directory "), Q7B_QOBJECT(sQtVersion))), Q7B_QOBJECT(" is located."))), Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2172", 1);
Q7B_ASSIGNMENT(&sQtDir, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_OPENFILEDIALOG_GETDIRECTORY(Q7B_idOPENFILEDIALOG)))));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2174", 1);
if (Q7B_CBOOLEAN(Q7B_DIR(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sQtDir), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sQtVersion))), Q7B_QOBJECT(false)))){
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2175", 1);
Q7B_ASSIGNMENT(&sQtDir, &Q7B__QOBJECT(Q7B_STRING(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(Q7B_ADD(Q7B_QOBJECT(sQtDir), Q7B_QOBJECT("/"))), Q7B_QOBJECT(sQtVersion))))));
}
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2178", 1);
Q7B_PREFERENCES_SETSTRING(Q7B_idPREFERENCES, Q7B_QOBJECT("QtDir"), Q7B_QOBJECT(sQtDir));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2179", 1);
((Q7BCompiler *) (Compiler)->ref)->setQtDir(Q7B_CQSTRING(Q7B_QOBJECT(sQtDir)));
}
}
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2184", 1);
((Q7BCompiler *) (Compiler)->ref)->setMINGWDir(Q7B_CQSTRING(Q7B_QOBJECT("")));
} else if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(Q7B_QACTION_TAG(Action)), Q7B_QOBJECT("gcc")))){
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2187", 1);
Q7B_QACTION_CHECKED(gcc, Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2188", 1);
Q7B_QACTION_CHECKED(vs, Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2189", 1);
Q7B_PREFERENCES_SETBOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("gcc"), Q7B_QOBJECT(true));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2190", 1);
Q7B_PREFERENCES_SETBOOLEAN(Q7B_idPREFERENCES, Q7B_QOBJECT("vs"), Q7B_QOBJECT(false));
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2192", 1);
((Q7BCompiler *) (Compiler)->ref)->setMINGWDir(Q7B_CQSTRING(Q7B_QOBJECT(Q7B_PREFERENCES_STRING(Q7B_idPREFERENCES, Q7B_QOBJECT("QtMINGWDir")))));
}
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2196", 1);
if (Q7B_CBOOLEAN(Q7B_EQUAL(Q7B_QOBJECT(bRebuild), Q7B_QOBJECT(true)))){
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2197", 1);
this->cleanandrebuildall(Q7B_QOBJECT(Q7B_BOOLEAN(Q7B_QOBJECT(false))));
}
                      Q7BS("MainWindow.QMainWindow", "Configuration", "2201", 2);

}

void MainWindow::CloseEvent(Q7B e)
{
                      Q7BS("MainWindow.QMainWindow", "CloseEvent", "2211", 0);
                      Q7BS("MainWindow.QMainWindow", "CloseEvent", "2211", 1);
Q7B_PREFERENCES_SETSTRING(Q7B_idPREFERENCES, Q7B_QOBJECT("Project.sProjectPath"), Q7B_QOBJECT(Q7B_QOBJECT(((Project *) Project::q7b_sharedSingleton())->Get_sProjectPath())));
                      Q7BS("MainWindow.QMainWindow", "CloseEvent", "2212", 2);

}


