
/*
'***************************************************************************
'Copyright (C) 2010-2011 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher sales@kbasic.com 
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published 
'by the Free Software Foundation. 
'
'If you are interested in using the source codes for other licenses or 
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/
 

#include "Q7BRuntime.h"




#ifndef Q7Basic_h
#define Q7Basic_h

#include <typeinfo> 

#include <QtGui>



#define Q7B_IDQString(V) *((QString*)V->ref)  
#define Q7B_IDqint64(V) *((qint64*)V->ref)
#define Q7B_IDqreal(V) *((qreal*)V->ref)
#define Q7B_IDbool(V) *((bool*)V->ref)
#define Q7B_IDQDateTime(V) *((QDateTime*)V->ref)

#define Q7B_IDQ7B_Dictionary(V) ((Q7B_Dictionary*)V->ref)
#define Q7B_IDQ7B_List(V) ((Q7B_List*)V->ref)







#ifdef Q_WS_X11
  #include <phonon>
  
#else
  
#ifdef Q_WS_X11
  #include <phonon>
#else
  #include <Phonon>
#endif

#endif

#include <QWebView>
#include <QSvgWidget>
#include <QtSql>
#include <QSvgRenderer>

#include <QUdpSocket>
#include <QHttp>

#ifndef Q7BPLUGINS
  #include <QtUiTools>
#endif










Q7B_id::~Q7B_id()
{


  if (!gc_enabled) return;

  if (q7b_array){
    delete q7b_array;
    q7b_array = 0;
  }

  if (q7b_type){
    delete q7b_type;
    q7b_type = 0;
  }

  if (q7b_properties){
    delete q7b_properties;
    q7b_properties = 0;
  }

  if (ref == 0) return;



  
  if (type == typeid(qint64).name()){
    delete (qint64 *) ref;

  } else if (type == typeid(bool).name()){
    delete (bool *) ref;

  } else if (type == typeid(QString).name()){
    delete (QString *) ref;

  } else if (type == typeid(qreal).name()){
    delete (qreal *) ref;

  } else if (type == typeid(QDateTime).name()){
    delete (QDateTime *) ref;

  } else if (type == typeid(Q7B_Decimal).name()){
    delete (Q7B_Decimal *) ref;

  } else if (type == typeid(Q7B_List).name()){
    delete (Q7B_List *) ref;

  } else if (type == typeid(Q7B_Dictionary).name()){
     delete (Q7B_Dictionary *) ref;

  } else if (type == typeid(QIcon).name()){
     delete (QIcon *) ref;

  } else if (type == typeid(QSystemTrayIcon).name()){
     

  } else if (type == typeid(QApplication).name()){
     

  } else {
   

 
 




    QObject *o = (QObject *) ref;

    

    


    if (o->isWidgetType()){
      ref = 0;
      return; 

      
    }


   
   
   
    if (o->parent()){
        ref = 0;
        return;
    }
    
    o->deleteLater();
    ref = 0;
  
  }
}

bool Q7B_id::isQObjectBased()
{
  if (type == typeid(qint64).name()){
    return false;

  } else if (type == typeid(bool).name()){
    return false;

  } else if (type == typeid(QString).name()){
    return false;

  } else if (type == typeid(qreal).name()){
    return false;

  } else if (type == typeid(QDateTime).name()){
    return false;

  } else if (type == typeid(Q7B_Decimal).name()){
    return false;

  } else if (type == typeid(Q7B_List).name()){
    return false;

  } else if (type == typeid(Q7B_Dictionary).name()){
     return false;

  } else if (type == typeid(QIcon).name()){
     return false;
  }

  return true;
}

Q7B Q7B_idnil(new Q7B_id());
Q7B Q7B_IDNIL(){ return Q7B_idnil; }



QString Q7B_META_sCurrentLine = "";
QString Q7B_META_sCurrentFile = "";
QString Q7B_META_sCurrentScope = "";



QString Q7B_QtBL()
{
  return QString("%1").arg(Q7B_META_sCurrentLine);
}

QString Q7B_QtBF()
{
  return QString(Q7B_META_sCurrentFile);  
}

QString Q7B_QtBS()
{
  return QString(Q7B_META_sCurrentScope);
}

bool Q7B_bException = false;

void Q7B_EXCEPTION(QString a = "")
{
  if (Q7B_bException) return;
  Q7B_bException = true;

  QString s = QString("%1\n file '%2'\n at '%3'\n line '%4'").arg(a).arg(Q7B_QtBF()).arg(Q7B_QtBS()).arg(Q7B_QtBL());
  QMessageBox::warning(0, "Runtime Exception", s);
}

void Q7B_NULLPOINTEREXCEPTION(QString a = "")
{
  if (Q7B_bException) return;
  Q7B_bException = true;

  QString s = QString("%1\n file '%2'\n at '%3'\n line '%4'").arg(a).arg(Q7B_QtBF()).arg(Q7B_QtBS()).arg(Q7B_QtBL());
  QMessageBox::warning(0, "Null Pointer Exception", s);
}

void Q7B_CASTEXCEPTION(QString a = "")
{
  if (Q7B_bException) return;
  Q7B_bException = true;

  QString s = QString("%1\n file '%2'\n at '%3'\n line '%4'").arg(a).arg(Q7B_QtBF()).arg(Q7B_QtBS()).arg(Q7B_QtBL());
  QMessageBox::warning(0, "Cast Exception", s);
}

void Q7B_INVALIDARGUMENTEXCEPTION(QString a = "")
{
  if (Q7B_bException) return;
  Q7B_bException = true;

  QString s = QString("%1\n file '%2'\n at '%3'\n line '%4'").arg(a).arg(Q7B_QtBF()).arg(Q7B_QtBS()).arg(Q7B_QtBL());
  QMessageBox::warning(0, "InvalQ7B Argument Exception", s);
}



void q7b_array_dimhelper(Q7B o, qint32 a0, qint32 a1, qint32 a2, qint32 a3)
{ 
  
  if (a0 >= 0){


   

    

    o->array_indexes[0] = a0;

    

   
  
  }
  
  else { o->array_indexes[0] = -1; o->array_indexes[1] = -1; o->array_indexes[2] = -1; o->array_indexes[3] = -1; o->q7b_array_count = 0; return; }
 
  if (a1 >= 0) o->array_indexes[1] = a1; else { o->array_indexes[1] = -1; o->array_indexes[2] = -1; o->array_indexes[3] = -1; o->q7b_array_count = 1; return; }
 
  if (a2 >= 0) o->array_indexes[2] = a2; else { o->array_indexes[2] = -1; o->array_indexes[3] = -1;o->q7b_array_count = 2; return; }
 
  if (a3 >= 0) o->array_indexes[3] = a3; else { o->array_indexes[3] = -1;o->q7b_array_count = 3; return; }
 

  o->q7b_array_count = 4;
}

qint64 q7b_array_offset(Q7B o, qint32 a0, qint32 a1, qint32 a2, qint32 a3, bool bCheck)
{
  
  
  qint64 f0 = o->array_indexes[0]; 
  qint64 f1 = o->array_indexes[1]; 
  qint64 f2 = o->array_indexes[2]; 
  qint64 f3 = o->array_indexes[3]; 

  if (bCheck){
    if (!(a0 >= 0 && a0 < o->array_indexes[0]) && a0 != -1 && o->array_indexes[0] >= 0) return -1;
    if (!(a1 >= 0 && a1 < o->array_indexes[1]) && a1 != -1 && o->array_indexes[1] >= 0) return -1;
    if (!(a2 >= 0 && a2 < o->array_indexes[2]) && a2 != -1 && o->array_indexes[2] >= 0){
       
      

      return -1;
    }
    if (!(a3 >= 0 && a3 < o->array_indexes[3]) && a3 != -1 && o->array_indexes[3] >= 0) return -1;
  }

  qint64 nSize = o->array_indexes[0];
  qint64 n = a0;
 
   
  
    
  if (o->array_indexes[1] >= 0 && a1 > 0){ n += a1 * nSize; nSize = nSize * o->array_indexes[1]; }
  if (o->array_indexes[2] >= 0 && a2 > 0){ n += a2 * nSize; nSize = nSize * o->array_indexes[2]; }
  if (o->array_indexes[3] >= 0 && a3 > 0){ n += a3 * nSize; nSize = nSize * o->array_indexes[3]; }

  if (o->q7b_array && !(n < o->q7b_array->size())){
    if (o->q7b_array->size() > 0){
      Q7B_EXCEPTION(QString("%1 %2 array internal offset error %3 %4 %5 %6").arg(n).arg(o->q7b_array->size()) .arg(a0) .arg(a1) .arg(a2) .arg(a3) ); 
    }
    return -1; 
  }

  return n;
}


void q7b_array_dim(Q7B o, Q7B a0, Q7B a1, Q7B a2, Q7B a3)
{

  

 

  


  
  o->q7b_array = new QVector<Q7B>;
 
  q7b_array_dimhelper(o, Q7B_IDqint64(a0), Q7B_IDqint64(a1), Q7B_IDqint64(a2), Q7B_IDqint64(a3));  
  
  
  qint64 m = o->array_indexes[0] * (o->array_indexes[1] > 0 ? o->array_indexes[1] : 1) * (o->array_indexes[2] > 0 ? o->array_indexes[2] : 1) * (o->array_indexes[3] > 0 ? o->array_indexes[3] : 1);
  if (m > 0) o->q7b_array->resize(m);
   

 


}

void q7b_array_redim(Q7B o, Q7B Preserve, Q7B aa0, Q7B aa1, Q7B aa2, Q7B aa3)
{
  
  
 

  qint64 a0 = Q7B_IDqint64(aa0);
  qint64 a1 = Q7B_IDqint64(aa1);
  qint64 a2 = Q7B_IDqint64(aa2);
  qint64 a3 = Q7B_IDqint64(aa3);

  if (Q7B_IDbool(Preserve) && o->q7b_array){
  

    Q7B newcopy ( new Q7B_id());

    q7b_array_dimhelper(newcopy, a0 == 0 ? -1 : a0, a1 == 0 ? -1 : a1, a2 == 0 ? -1 : a2, a3 == 0 ? -1 : a3);

  

    QVector<Q7B> *q7b_array = new QVector<Q7B>;
    q7b_array->resize(a0 * (a1 > 0 ? a1 : 1) * (a2 > 0 ? a2 : 1) * (a3 > 0 ? a3 : 1));

   

         
            
   for (qint64 b3 = -1; b3 <= o->array_indexes[3]; b3++){ 
     for (qint64 b2 = -1; b2 <= o->array_indexes[2]; b2++){   
       for (qint64 b1 = -1; b1 <= o->array_indexes[1]; b1++){
         for (qint64 b0 = -1; b0 <= o->array_indexes[0]; b0++){


            if (b0 + 1 >= o->array_indexes[0] + 0 && b0 > -1) continue;
            if (b1 + 1 >= o->array_indexes[1] + 0 && b1 > -1) continue;
            if (b2 + 1 >= o->array_indexes[2] + 0 && b2 > -1 ) continue;
            if (b3 + 1 >= o->array_indexes[3] + 0 && b3 > -1 ) continue;


            qint64 n = q7b_array_offset(o, b0 + 1, b1 + 1, b2 + 1, b3 + 1, false);

           

            if (n >= 0 && (a0 == -1 || b0 + 1 <= a0) && (a1 == -1 || b1 + 1 <= a1) && (a2 == -1 || b2 + 1 <= a2) && (a3 == -1 || b3 + 1 <= a3)){
             

             
              if (!(*o->q7b_array)[n].isNull()){
             
                

            if (b1 + 1 == 9){
              b1 = b1;
            
             
            }
            int k = q7b_array_offset(newcopy, b0 + 1, b1 + 1, b2 + 1, b3 + 1, true);
            if (k >= 0)
            {
 
            
                
           

                q7b_array->replace(k, (*o->q7b_array)[n]);

                
            }

              }
            }
              
          }      
        }            
      }      
    }

    

    

    delete o->q7b_array;

    o->q7b_array = q7b_array;

    q7b_array_dimhelper(o, (a0), (a1), (a2), (a3));
    

    
  

    


  } else {
    if (o->q7b_array) delete o->q7b_array;
    q7b_array_dim(o, (aa0), (aa1), (aa2), (aa3));
  }


}



Q7B *q7b_array_get(Q7B o, Q7B a0, Q7B a1, Q7B a2, Q7B a3)
{
  if (o->q7b_array == 0){ Q7B_EXCEPTION("array has not been declared with Dim"); return &Q7B_idnil; }

  
   

  qint64 nOffset = q7b_array_offset(o, Q7B_IDqint64(a0), Q7B_IDqint64(a1), Q7B_IDqint64(a2), Q7B_IDqint64(a3), true);
  if (nOffset == -1){ Q7B_EXCEPTION("array offset out of bounds"); return &Q7B_idnil; }

 
  
 
  
  
  


  if ((*o->q7b_array)[nOffset].isNull()) return &Q7B_IDNIL(); 

  return &(*o->q7b_array)[nOffset];
}

Q7B *q7b_array_at(Q7B o, Q7B a0, Q7B a1, Q7B a2, Q7B a3) 
{
  if (o->q7b_array == 0){ Q7B_EXCEPTION("array has not been declared with Dim"); return &Q7B_idnil; }

  qint64 nOffset = q7b_array_offset(o, Q7B_IDqint64(a0), Q7B_IDqint64(a1), Q7B_IDqint64(a2), Q7B_IDqint64(a3), true);
  if (nOffset == -1){ Q7B_EXCEPTION("array offset out of bounds"); return &Q7B_idnil; }

  
  
  

  if ((*o->q7b_array)[nOffset].isNull()){
    
    
    (*o->q7b_array)[nOffset] = Q7B_QOBJECT();
    return &(*o->q7b_array)[nOffset];
  }
  
  return &(*o->q7b_array)[nOffset];
}

Q7B q7b_array_ubound(Q7B o, Q7B i)
{
  

  qint64 ii = Q7B_IDqint64(i);

  if (ii == -1){

    return Q7B_QOBJECT(o->q7b_array_count);   

  } else if (ii < o->q7b_array_count){

    return Q7B_QOBJECT(o->array_indexes[ii]);
  
  }

  { Q7B_EXCEPTION("UBound: array dimension index out of bounds"); return Q7B_idnil; }
}

Q7B *q7b_type_get(Q7B o, Q7B index, Q7B a0, Q7B a1, Q7B a2, Q7B a3)
{
  if (o->q7b_type == 0 ){ Q7B_EXCEPTION(QString("q7b_array == 0 variable has not been set as a type %1").arg((int)Q7B_IDqint64(index))); return &Q7B_idnil; }
  if (o->q7b_type == 0){ Q7B_EXCEPTION(QString("variable has not been set as a type %1").arg((int)Q7B_IDqint64(index))); return &Q7B_idnil; }
  
  

  

  if ((*o->q7b_type)[Q7B_IDqint64(index)].isNull()){
    
    
   
    
    (*o->q7b_type)[Q7B_IDqint64(index)] = Q7B_QOBJECT();
    return &(*o->q7b_type)[Q7B_IDqint64(index)];

    
  } 

  if ((*o->q7b_type)[Q7B_IDqint64(index)]->q7b_array && Q7B_IDqint64(a0) >= 0){ 

    qint64 nOffset = q7b_array_offset((*o->q7b_type)[Q7B_IDqint64(index)], Q7B_IDqint64(a0), Q7B_IDqint64(a1), Q7B_IDqint64(a2), Q7B_IDqint64(a3), true);
    if (nOffset == -1){ Q7B_EXCEPTION("array offset out of bounds"); return &Q7B_idnil; }      

    QVector<Q7B> *q7b_array = (*o->q7b_type)[Q7B_IDqint64(index)]->q7b_array;

    if ((*q7b_array)[nOffset].isNull()){
  
      
      
      (*q7b_array)[nOffset] = Q7B_QOBJECT();

      return &(*q7b_array)[nOffset];      
    } 


    
        
  }  

  return &(*o->q7b_type)[Q7B_IDqint64(index)];
}

bool Q7B_connect(QObject *a, const char * _signal, QObject *b, QString _slot)
{
  QString signal = QString("2") + _signal;
  QString slot = QString("1") + _slot;

  if (QObject::connect((QObject *) a, signal.toAscii().constData(), (QObject *) b, slot.toAscii().constData())){
    return true;
  }
  return false;
}

void Q7B_connectSlotsByName(QObject *Me, QObject *Parent)
{
  
  QObject *SAVE = Me->parent();

  QString sObjectName = QString("on_") + Me->objectName() + "_";

  const QMetaObject* metaObject = Me->metaObject();
  const QMetaObject* metaObject2 = Parent->metaObject();

  QHash<QString, bool> connected; 

  do {

    for(int i = metaObject->methodOffset(); i < metaObject->methodCount(); i++){
      QByteArray baSignal = metaObject->normalizedSignature(metaObject->method(i).signature());
      if (metaObject->indexOfSignal(baSignal) >= 0){

        QByteArray baSlot = metaObject2->normalizedSignature(QString(sObjectName + metaObject->method(i).signature()).toAscii().constData());

        QString sSlot = QString::fromAscii(baSlot);
        int n = sSlot.indexOf("(");
        sSlot = sSlot.left(n);

        if (metaObject2->indexOfSlot(baSlot) >= 0){
          if (QMetaObject::checkConnectArgs(baSignal.constData(), baSlot.constData())){          

            if (!connected.contains(sSlot) && Q7B_connect(Me, baSignal.constData(), Parent, baSlot.constData())){

              connected[sSlot] = true;

           
            }
          }
        }

      }

    }
  } while ((metaObject = metaObject->superClass()));
  
}

void *Q7B_connectSlotsByNameWithNewAndReturnIt(void *_Me, QObject *Parent)
{
  
  Q7B_connectSlotsByName((QObject *) _Me, Parent);
  
  return _Me;
}

const QPixmap &Q7B_createPixmap(QString n)
{
  static QPixmap qpixmap;

   if (n.length() > 200){ 

      if (n.left(200).contains("<svg ", Qt::CaseInsensitive)){
        QString m = n;
        m = m.trimmed();
        QSvgWidget w(0);
        w.resize(100, 100);
        QSvgRenderer *r = w.renderer();
        if (r->load(m.toLatin1())){

          QPixmap p(100, 100);
          QPainter painter(&p);
          r->render(&painter);
          qpixmap = p;       
        }
      } else {
         QPixmap pi; pi.loadFromData(n.toLatin1());
         qpixmap = pi;
      }

   } else {
     qpixmap = Q7B_loadPixmap(n.contains(".") ? n : n + ".png");
   }

   return qpixmap;
}

const QPixmap &Q7B_loadPixmap(QString fn)
{
  static QPixmap p;

 
  
    

  if (!fn.contains("/") && !fn.contains("\\")){
    fn = qApp->applicationDirPath() + "/" + fn;

    



  }

    {
      p = QPixmap(fn);
    }
    
  

  return p;
  
}





QIcon Q7B_QByteArray2QIcon(QByteArray ba)
{
  QDataStream d(ba);

  QIcon icon;

  d >> icon;
  return icon;
}

QByteArray Q7B_QIcon2QByteArray(QIcon icon)
{
  QByteArray ba;
  QDataStream d(&ba, QIODevice::WriteOnly);
  d << icon;
  return ba;
}









QMap<QString, QSqlDatabase> Q7B_Database::databases; 
QMap<QString, QSqlQuery *> Q7B_Database::records;
QMap<QString, QString> Q7B_Database::records_database;
QMap<QString, QString> Q7B_Database::records_table;

QSqlDatabase Q7B_Database::_CurrentDatabase;

QString Q7B_Database::sLastSQLError;

QMap<QString, QString> Q7B_Database::sLastSQLCommands;
QMap<QString, QString> Q7B_Database::sLastSQLCommandFailed;








QString Q7B_toString2(Q7B Q7B_Object)
{
  if (Q7B_Object->q7b_array){

   QString k = "Array[] = {";

   bool bFirst = true;
            
   for (qint64 b3 = -1; b3 <= Q7B_Object->array_indexes[3]; b3++){ 
     for (qint64 b2 = -1; b2 <= Q7B_Object->array_indexes[2]; b2++){   
       for (qint64 b1 = -1; b1 <= Q7B_Object->array_indexes[1]; b1++){
         for (qint64 b0 = -1; b0 <= Q7B_Object->array_indexes[0]; b0++){

            if (b0 + 1 >= Q7B_Object->array_indexes[0] + 0 && b0 > -1) continue;
            if (b1 + 1 >= Q7B_Object->array_indexes[1] + 0 && b1 > -1) continue;
            if (b2 + 1 >= Q7B_Object->array_indexes[2] + 0 && b2 > -1 ) continue;
            if (b3 + 1 >= Q7B_Object->array_indexes[3] + 0 && b3 > -1 ) continue;

            qint64 n = q7b_array_offset(Q7B_Object, b0 + 1, b1 + 1, b2 + 1, b3 + 1, false);

            if (n >= 0){
              Q7B Value = Q7B_Object->q7b_array->at(n);

              if (!bFirst){
                k += ", ";                
              }
              bFirst = false;

              if (!Value.isNull()){
                k += Q7B_toString2(Value);
              } else {
                k += "Null";
              }
            }
         }
       }
     }
   }
   k += "}";
   return k;

  } else if (Q7B_Object->q7b_type){

     QString k = "Type = {";

     bool bFirst = true;
            
     for (qint64 n = 0; n < Q7B_Object->q7b_type->size(); n++){   

      Q7B Value = Q7B_Object->q7b_type->at(n);

      if (!bFirst){
        k += ", ";                
      }
      bFirst = false;

      if (!Value.isNull()){
        k += Q7B_toString2(Value);
      } else {
        k += "Null";
      }   

      


    }
    k += "}";
    return k;

  } else {

   
    if (Q7B_Object->type == typeid(qint64).name()){
      return QString("%1").arg( Q7B_IDqint64(Q7B_Object) );

    } else if (Q7B_Object->type == typeid(qreal).name()){
      return QString("%1").arg( *((qreal *) Q7B_Object->ref) );

    } else if (Q7B_Object->type == typeid(bool).name()){
      return QString("%1").arg( *((bool *) Q7B_Object->ref) );


    } else if (Q7B_Object->type == typeid(QDateTime).name()){
      return QString("%1").arg( ((QDateTime *) Q7B_Object->ref)->toString("yyyy-MM-dd hh:mm:ss") );

    } else if (Q7B_Object->type == typeid(Q7B_Decimal).name()){
      return QString("%1").arg( ((Q7B_Decimal *) Q7B_Object->ref)->toString() );      

    } else if (Q7B_Object->type == typeid(Q7B_List).name()){
      return ((Q7B_List *) Q7B_Object->ref)->toString();

    } else if (Q7B_Object->type == typeid(Q7B_Dictionary).name()){
      return ((Q7B_Dictionary *) Q7B_Object->ref)->toString();

    
  

    } else if (Q7B_Object->type == typeid(QString).name()){
      return *((QString *) Q7B_Object->ref);

    }

    
    if (Q7B_Object->ref == 0){
      return QString("Null");
    } else {
      return QString("%1: %2").arg(QString(Q7B_Object->type)).arg((qint64) Q7B_Object->ref);
    }
  }
}


void Q7B_toXML2(QXmlStreamWriter & xmlWriter, Q7B Q7B_Object)
{

  if (Q7B_Object->q7b_array){

  xmlWriter.writeStartElement("array2");

  xmlWriter.writeTextElement("count", QString::number( Q7B_Object->q7b_array_count ));
  xmlWriter.writeTextElement("index0", QString::number( Q7B_Object->array_indexes[0] ));
  xmlWriter.writeTextElement("index1", QString::number( Q7B_Object->array_indexes[1] ));
  xmlWriter.writeTextElement("index2", QString::number( Q7B_Object->array_indexes[2] ));
  xmlWriter.writeTextElement("index3", QString::number( Q7B_Object->array_indexes[3] ));

   for (qint64 b3 = -1; b3 <= Q7B_Object->array_indexes[3]; b3++){ 
     for (qint64 b2 = -1; b2 <= Q7B_Object->array_indexes[2]; b2++){   
       for (qint64 b1 = -1; b1 <= Q7B_Object->array_indexes[1]; b1++){
         for (qint64 b0 = -1; b0 <= Q7B_Object->array_indexes[0]; b0++){

            if (b0 + 1 >= Q7B_Object->array_indexes[0] + 0 && b0 > -1) continue;
            if (b1 + 1 >= Q7B_Object->array_indexes[1] + 0 && b1 > -1) continue;
            if (b2 + 1 >= Q7B_Object->array_indexes[2] + 0 && b2 > -1 ) continue;
            if (b3 + 1 >= Q7B_Object->array_indexes[3] + 0 && b3 > -1 ) continue;

            qint64 n = q7b_array_offset(Q7B_Object, b0 + 1, b1 + 1, b2 + 1, b3 + 1, false);

            if (n >= 0){
              Q7B Value = Q7B_Object->q7b_array->at(n);

              if (!Value.isNull()){
                Q7B_toXML2(xmlWriter, Value);
              } else {
                xmlWriter.writeTextElement("null", "");
             
              }
            }
         }
       }
     }
   }      
   
   xmlWriter.writeEndElement();

  } else {

    
    if (Q7B_Object->type == typeid(qint64).name()){
      xmlWriter.writeTextElement("integer", QString::number( *((qint64 *) Q7B_Object->ref) ));

    } else if (Q7B_Object->type == typeid(qreal).name()){
      xmlWriter.writeTextElement("float", QString::number( *((qreal *) Q7B_Object->ref) ));      

    } else if (Q7B_Object->type == typeid(QDateTime).name()){
      xmlWriter.writeTextElement("datetime", ((QDateTime *) Q7B_Object->ref)->toString("yyyy-MM-dd hh:mm:ss") );

    } else if (Q7B_Object->type == typeid(Q7B_Decimal).name()){
      xmlWriter.writeTextElement("decimal", ((QDateTime *) Q7B_Object->ref)->toString() );

    } else if (Q7B_Object->type == typeid(bool).name()){
      xmlWriter.writeTextElement("boolean", QString::number( *((bool *) Q7B_Object->ref) ));

    } else if (Q7B_Object->type == typeid(Q7B_List).name()){
      return ((Q7B_List *) Q7B_Object->ref)->toXML(xmlWriter);

    } else if (Q7B_Object->type == typeid(Q7B_Dictionary).name()){
      return ((Q7B_Dictionary *) Q7B_Object->ref)->toXML(xmlWriter);

    } else if (Q7B_Object->type == typeid(QByteArray).name()){    
      QByteArray ba = *((QByteArray *) Q7B_Object->ref);
      xmlWriter.writeTextElement("QByteArray", QString(ba.toBase64()) );

    } else if (Q7B_Object->type == typeid(QIcon).name()){    
      QByteArray ba = Q7B_QIcon2QByteArray(*((QIcon *) Q7B_Object->ref));
      xmlWriter.writeTextElement("QIcon", QString(ba.toBase64()) );

    
  

    } else if (Q7B_Object->type == typeid(QString).name()){
      xmlWriter.writeTextElement("string", *((QString *) Q7B_Object->ref) );

    } else {
      
      xmlWriter.writeTextElement("string", QString("%1: %2").arg(QString(Q7B_Object->type)).arg((qint64) Q7B_Object->ref) );
    }
  }
  return ;
}




QList<Q7B> Q7B_binds;



bool Q7B_nil(Q7B o){
 
 

  return (o->type == 0 || o->ref == 0) && o->q7b_array == 0;
}




qreal Q7B_toFloat2(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return 0; }

  if (Q7B_Object->type == typeid(qreal).name()){
    return *((qreal *) Q7B_Object->ref);

  } else if (Q7B_Object->type == typeid(qint64).name()){
    return *((qint64 *) Q7B_Object->ref);

  } else if (Q7B_Object->type == typeid(Q7B_Decimal).name()){
    return ((Q7B_Decimal *) Q7B_Object->ref)->toFloat();

  }

  Q7B_EXCEPTION("Float expected");
  return 0;
}

qint64 Q7B_toInteger2(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return 0; }

  if (Q7B_Object->type == typeid(qint64).name()){
    return *((qint64 *) Q7B_Object->ref);

  } else if (Q7B_Object->type == typeid(qreal).name()){
    return *((qreal *) Q7B_Object->ref);

  } else if (Q7B_Object->type == typeid(Q7B_Decimal).name()){
    return ((Q7B_Decimal *) Q7B_Object->ref)->toInteger();

  }

  Q7B_EXCEPTION("Integer expected");
  return 0;
}



Q7B Q7B_Dictionary::init(Q7B values, Q7B keys)
{
  Q7B_Dictionary *d = new Q7B_Dictionary();
  Q7B q (new Q7B_id(typeid(Q7B_Dictionary).name(), d));   

  if (Q7B_nil(Q7B_LIST(values))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_LIST(keys))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }

  QList<Q7B> v = ((Q7B_List *) values->ref)->values();
  QList<Q7B> k = ((Q7B_List *) keys->ref)->values();    

  if (v.length() != k.length()){ Q7B_EXCEPTION(QString("Dictionary init: Count of keys and values are different %1 %2").arg(v.length()).arg(k.length())); return Q7B_idnil; }

  for (qint64 i = 0; i < v.length(); i++){
    d->me[Q7B_toString2(k.at(i))] = v.at(i);  
  }

  return q;
}




Q7B Q7B_EQUALEQUALEQUAL(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_QOBJECT(l->type == r->type);
}

Q7B Q7B_EQUALEQUAL(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_QOBJECT(l->ref == r->ref);
}

Q7B Q7B_EQUAL(Q7B l, Q7B r)
{
  if (Q7B_nil(l) && Q7B_nil(r)){ return Q7B_QOBJECT(true); }
  
  if (!Q7B_nil(l) && !Q7B_nil(r)){
    if (l->type == typeid(QString).name()){
      if (r->type == typeid(QString).name()){
        return Q7B_QOBJECT( *((QString *) l->ref) == *((QString *) r->ref) );
      }

      QString s = Q7B_toString2(r);
      return Q7B_QOBJECT( *((QString *) l->ref) == s );

    }
    
    if (l->type == typeid(qint64).name()){
      if (r->type == typeid(qint64).name()){
        return Q7B_QOBJECT( *((qint64 *) l->ref) == *((qint64 *) r->ref) );
      }
      if (r->type == typeid(qreal).name()){
        return Q7B_QOBJECT( *((qint64 *) l->ref) == *((qreal *) r->ref) );
      }
      if (r->type == typeid(Q7B_Decimal).name()){
        return Q7B_QOBJECT( *((qint64 *) l->ref) == ((Q7B_Decimal *) r->ref)->toInteger() );
      }
      if (r->type == typeid(bool).name()){
        return Q7B_QOBJECT( *((qint64 *) l->ref) == *((bool *) r->ref) );
      }
    }

    if (l->type == typeid(qreal).name()){
      if (r->type == typeid(qreal).name()){
        return Q7B_QOBJECT( *((qreal *) l->ref) == *((qreal *) r->ref) );
      }
      if (r->type == typeid(qint64).name()){
        return Q7B_QOBJECT( *((qreal *) l->ref) == *((qint64 *) r->ref) );
      }
      if (r->type == typeid(Q7B_Decimal).name()){
        return Q7B_QOBJECT( *((qreal *) l->ref) == ((Q7B_Decimal *) r->ref)->toFloat() );
      }
      if (r->type == typeid(bool).name()){
        return Q7B_QOBJECT( *((qreal *) l->ref) == *((bool *) r->ref) );
      }
    }
 
    if (l->type == typeid(Q7B_Decimal).name()){
      if (r->type == typeid(Q7B_Decimal).name()){
        return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->value() == ((Q7B_Decimal *) r->ref)->value() );
      }
      if (r->type == typeid(qint64).name()){
        return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->toInteger() == *((qint64 *) r->ref) );
      }
      if (r->type == typeid(qreal).name()){
        return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->toFloat() == *((qreal *) r->ref) );
      }
      if (r->type == typeid(bool).name()){
        return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->value() == *((bool *) r->ref) );
      }
    }

    if (l->type == typeid(bool).name()){
      if (r->type == typeid(bool).name()){
        return Q7B_QOBJECT( *((bool *) l->ref) == *((bool *) r->ref) );
      }
      if (r->type == typeid(qint64).name()){
        return Q7B_QOBJECT( *((bool *) l->ref) == *((qint64 *) r->ref) );
      }
      if (r->type == typeid(qreal).name()){
        return Q7B_QOBJECT( *((bool *) l->ref) == *((qreal *) r->ref) );
      }
      if (r->type == typeid(Q7B_Decimal).name()){
        return Q7B_QOBJECT( *((bool *) l->ref) == ((Q7B_Decimal *) r->ref)->toInteger() );
      }

    }


    

    

  }

  QString a = Q7B_toString2(l);
  QString b = Q7B_toString2(r);
  return Q7B_QOBJECT( a == b );
}

Q7B Q7B_UNEQUAL(Q7B l, Q7B r)
{ 
  if (Q7B_nil(l) && Q7B_nil(r)){ return Q7B_QOBJECT(false); }
  
  if (!Q7B_nil(l) && !Q7B_nil(r)){
    if (l->type == typeid(QString).name()){
      if (r->type == typeid(QString).name()){
        return Q7B_QOBJECT( *((QString *) l->ref) != *((QString *) r->ref) );
      }

      QString s = Q7B_toString2(r);
      return Q7B_QOBJECT( *((QString *) l->ref) != s );
    }
    
    if (l->type == typeid(qint64).name()){
      if (r->type == typeid(qint64).name()){
        return Q7B_QOBJECT( *((qint64 *) l->ref) != *((qint64 *) r->ref) );
      }
      if (r->type == typeid(qreal).name()){
        return Q7B_QOBJECT( *((qint64 *) l->ref) != *((qreal *) r->ref) );
      }
      if (r->type == typeid(Q7B_Decimal).name()){
        return Q7B_QOBJECT( *((qint64 *) l->ref) != ((Q7B_Decimal *) r->ref)->toInteger() );
      }
      if (r->type == typeid(bool).name()){
        return Q7B_QOBJECT( *((qint64 *) l->ref) != *((bool *) r->ref) );
      }
    }

    if (l->type == typeid(qreal).name()){
      if (r->type == typeid(qreal).name()){
        return Q7B_QOBJECT( *((qreal *) l->ref) != *((qreal *) r->ref) );
      }
      if (r->type == typeid(qint64).name()){
        return Q7B_QOBJECT( *((qreal *) l->ref) != *((qint64 *) r->ref) );
      }
      if (r->type == typeid(Q7B_Decimal).name()){
        return Q7B_QOBJECT( *((qreal *) l->ref) != ((Q7B_Decimal *) r->ref)->toFloat() );
      }
      if (r->type == typeid(bool).name()){
        return Q7B_QOBJECT( *((qreal *) l->ref) != *((bool *) r->ref) );
      }
    }

    if (l->type == typeid(Q7B_Decimal).name()){
      if (r->type == typeid(Q7B_Decimal).name()){
        return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->value() != ((Q7B_Decimal *) r->ref)->value() );
      }
      if (r->type == typeid(qint64).name()){
        return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->toInteger() != *((qint64 *) r->ref) );
      }
      if (r->type == typeid(qreal).name()){
        return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->toFloat() != *((qreal *) r->ref) );
      }
      if (r->type == typeid(bool).name()){
        return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->value() != *((bool *) r->ref) );
      }
    }

    if (l->type == typeid(bool).name()){
      if (r->type == typeid(bool).name()){
        return Q7B_QOBJECT( *((bool *) l->ref) != *((bool *) r->ref) );
      }
      if (r->type == typeid(qint64).name()){
        return Q7B_QOBJECT( *((bool *) l->ref) != *((qint64 *) r->ref) );
      }
      if (r->type == typeid(qreal).name()){
        return Q7B_QOBJECT( *((bool *) l->ref) != *((qreal *) r->ref) );
      }
      if (r->type == typeid(Q7B_Decimal).name()){
        return Q7B_QOBJECT( *((bool *) l->ref) != ((Q7B_Decimal *) r->ref)->toInteger() );
      }
    }
  }

  QString a = Q7B_toString2(l);
  QString b = Q7B_toString2(r);
  return Q7B_QOBJECT( a != b );  
}

void Q7B_ASSIGNMENT(Q7B *l, Q7B *r)
{  
  *l = *r;
  
}

Q7B Q7B_SMALLER(Q7B l, Q7B r)
{  
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) < *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) < *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) < ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) < *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) < *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) < *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) < ((Q7B_Decimal *) r->ref)->toFloat() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) < *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->value() < ((Q7B_Decimal *) r->ref)->value() );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->toInteger() < *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->toFloat() < *((qreal *) r->ref) );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->value() < *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( *((bool *) l->ref) < *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((bool *) l->ref) < *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((bool *) l->ref) < *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((bool *) l->ref) < ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_QOBJECT(false);
} 

Q7B Q7B_GREATER(Q7B l, Q7B r)
{  
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) > *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) > *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) > ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) > *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) > *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) > *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) > ((Q7B_Decimal *) r->ref)->toFloat() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) > *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->value() > ((Q7B_Decimal *) r->ref)->value() );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->toInteger() > *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->toFloat() > *((qreal *) r->ref) );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->value() > *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( *((bool *) l->ref) > *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((bool *) l->ref) > *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((bool *) l->ref) > *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((bool *) l->ref) > ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_QOBJECT(false);
} 

Q7B Q7B_SMALLEREQUAL(Q7B l, Q7B r)
{  
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) <= *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) <= *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) <= ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) <= *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) <= *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) <= *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) <= ((Q7B_Decimal *) r->ref)->toFloat() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) <= *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->value() <= ((Q7B_Decimal *) r->ref)->value() );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->toInteger() <= *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->toFloat() <= *((qreal *) r->ref) );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->value() <= *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( *((bool *) l->ref) <= *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((bool *) l->ref) <= *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((bool *) l->ref) <= *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((bool *) l->ref) <= ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_QOBJECT(false);
} 

Q7B Q7B_GREATEREQUAL(Q7B l, Q7B r)
{  
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) >= *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) >= *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) >= ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) >= *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) >= *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) >= *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) >= ((Q7B_Decimal *) r->ref)->toFloat() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) >= *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->value() >= ((Q7B_Decimal *) r->ref)->value() );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->toInteger() >= *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->toFloat() >= *((qreal *) r->ref) );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->value() >= *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( *((bool *) l->ref) >= *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((bool *) l->ref) >= *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((bool *) l->ref) >= *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((bool *) l->ref) >= ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_QOBJECT(false);
} 

Q7B Q7B_FLIP(Q7B l)
{
  if (Q7B_nil(l)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

    
  if (l->type == typeid(qint64).name()){
    return Q7B_QOBJECT( ~ *((qint64 *) l->ref) );
  }  
  
  Q7B_CASTEXCEPTION("Integer expected");
  return Q7B_QOBJECT(false);
} 


Q7B Q7B_NOT(Q7B l)
{
  if (Q7B_nil(l)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    return Q7B_QOBJECT( ! *((qint64 *) l->ref) );
  }
  if (l->type == typeid(bool).name()){
    return Q7B_QOBJECT( ! *((bool *) l->ref) );
  }
  if (l->type == typeid(qreal).name()){
    return Q7B_QOBJECT( ! *((qreal *) l->ref) );
  }
  if (l->type == typeid(Q7B_Decimal).name()){
    return Q7B_QOBJECT( ! ((Q7B_Decimal *) l->ref)->toInteger() );
  }  
  if (l->type == typeid(QString).name()){ 
    return Q7B_QOBJECT( ((QString *) l->ref)->isEmpty() );
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_QOBJECT(false);
} 

Q7B Q7B_MINUS(Q7B l)
{
  if (Q7B_nil(l)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    return Q7B_QOBJECT( - *((qint64 *) l->ref) );
  }
  if (l->type == typeid(qreal).name()){
    return Q7B_QOBJECT( - *((qreal *) l->ref) );
  }
  if (l->type == typeid(Q7B_Decimal).name()){
    return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->minus() );
  }
  
  Q7B_CASTEXCEPTION("Number expected");
  return Q7B_QOBJECT(false);
} 

Q7B Q7B_AND(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) & *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) & (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) & (qint64) ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) & (qint64) *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) & (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) & *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) & (qint64) ((Q7B_Decimal *) r->ref)->toFloat() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) & (qint64) *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() & ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_QOBJECT( d );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->toInteger() & *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( (qint64) ((Q7B_Decimal *) l->ref)->toFloat() & (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(bool).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() & *((bool *) r->ref) );
      return Q7B_QOBJECT( d );
    }
  }

  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( (qint64) *((bool *) l->ref) & (qint64) *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( (qint64) *((bool *) l->ref) & *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( (qint64) *((bool *) l->ref) & (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( (qint64) *((bool *) l->ref) & ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_QOBJECT(false);
} 

Q7B Q7B_OR(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) | *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) | (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) | ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) | (qint64) *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) | (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) | *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) | (qint64) ((Q7B_Decimal *) r->ref)->toFloat() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) | (qint64) *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() | ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_QOBJECT( d );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->toInteger() | *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( (qint64) ((Q7B_Decimal *) l->ref)->toFloat() | (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(bool).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() | *((bool *) r->ref) );
      return Q7B_QOBJECT( d );
    }
  }

  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( (qint64) *((bool *) l->ref) | (qint64) *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( (qint64) *((bool *) l->ref) | *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( (qint64) *((bool *) l->ref) | (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( (qint64) *((bool *) l->ref) | (qint64) ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_QOBJECT(false);
} 

Q7B Q7B_XOR(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) ^ *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) ^ (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) ^ ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) ^ (qint64) *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) ^ (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) ^ *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) ^ (qint64) ((Q7B_Decimal *) r->ref)->toFloat() );
    }
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) ^ (qint64) *((bool *) r->ref) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() ^ ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_QOBJECT( d );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( ((Q7B_Decimal *) l->ref)->toInteger() ^ *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( (qint64) ((Q7B_Decimal *) l->ref)->toFloat() ^ (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(bool).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() ^ *((bool *) r->ref) );
      return Q7B_QOBJECT( d );
    }
  }

  if (l->type == typeid(bool).name()){
    if (r->type == typeid(bool).name()){
      return Q7B_QOBJECT( (qint64) *((bool *) l->ref) ^ (qint64) *((bool *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( (qint64) *((bool *) l->ref) ^ *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( (qint64) *((bool *) l->ref) ^ (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( (qint64) *((bool *) l->ref) ^ (qint64) ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  Q7B_CASTEXCEPTION("'Boolean' or number expected");
  return Q7B_QOBJECT(false);
} 

Q7B Q7B_SHL(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name() && r->type == typeid(qint64).name()){
    return Q7B_QOBJECT( *((qint64 *) l->ref) << *((qint64 *) r->ref) );
  }
  
  Q7B_CASTEXCEPTION("Integer expected");
  return Q7B_QOBJECT(false);
} 

Q7B Q7B_SHR(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name() && r->type == typeid(qint64).name()){
    return Q7B_QOBJECT( *((qint64 *) l->ref) >> *((qint64 *) r->ref) );
  }

  Q7B_CASTEXCEPTION("Integer expected");
  return Q7B_QOBJECT(false);
} 

Q7B Q7B_ADD(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  
  
  if (l->type == typeid(QString).name()){
    if (r->type == typeid(QString).name()){
      return Q7B_QOBJECT( *((QString *) l->ref) + *((QString *) r->ref) );
    }

    QString s = Q7B_toString2(r);
    return Q7B_QOBJECT( *((QString *) l->ref) + s );
  }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) + *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) + *((qreal *) r->ref) );
    }
  
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) + ((Q7B_Decimal *) r->ref)->toInteger() );
    }
    if (r->type == typeid(QString).name()){
      Q7B_CASTEXCEPTION("'String' not allowed with + on the right side. Use & instead.");
      return Q7B_QOBJECT(false);      
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) + *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) + *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) + ((Q7B_Decimal *) r->ref)->toFloat() );
    }
   
    if (r->type == typeid(QString).name()){
      Q7B_CASTEXCEPTION("'String' not allowed with + on the right side. Use & instead.");
      return Q7B_QOBJECT(false);      
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() + ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_QOBJECT( d );
    }
    if (r->type == typeid(qint64).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() + (*((qint64 *) r->ref) * 10000) );
      return Q7B_QOBJECT( d );
    }
    if (r->type == typeid(qreal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() + (*((qreal *) r->ref) * 10000) );
      return Q7B_QOBJECT( d );
    }
  
  }


  
  
  Q7B_CASTEXCEPTION("'String' or number expected");
  return Q7B_QOBJECT(false);
}

Q7B Q7B_SUB(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) - *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) - *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) - ((Q7B_Decimal *) r->ref)->toInteger() );
    }
 
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) - *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) - *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) - ((Q7B_Decimal *) r->ref)->toFloat() );
    }
  
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() - ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_QOBJECT( d );
    }
    if (r->type == typeid(qint64).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() - (*((qint64 *) r->ref) * 10000) );
      return Q7B_QOBJECT( d );
    }
    if (r->type == typeid(qreal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() - (*((qreal *) r->ref) * 10000) );
      return Q7B_QOBJECT( d );
    }
  
  }


  
  
  Q7B_CASTEXCEPTION("Number expected");
  return Q7B_QOBJECT(false);
}

Q7B Q7B_CONCAT(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(QString).name()){
    if (r->type == typeid(QString).name()){
      return Q7B_QOBJECT( *((QString *) l->ref) + *((QString *) r->ref) );
    }

    QString s = Q7B_toString2(r);
    return Q7B_QOBJECT( *((QString *) l->ref) + s );
  }

  QString ss = Q7B_toString2(l);
  
  if (r->type == typeid(QString).name()){
    return Q7B_QOBJECT( ss + *((QString *) r->ref) );
  }

  QString s = Q7B_toString2(r);
  return Q7B_QOBJECT( ss + s );
}

Q7B Q7B_POWER(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( pow((qreal) (Q7B_IDqint64(l)), (int) Q7B_IDqint64((r))) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( pow((qreal) (Q7B_IDqint64(l)), Q7B_IDqreal((r))) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( pow((qreal) (Q7B_IDqint64(l)), (int) ((Q7B_Decimal *) r->ref)->toInteger()) );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( pow(Q7B_IDqreal((l)), Q7B_IDqreal((r))) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( pow(Q7B_IDqreal((l)), (int) Q7B_IDqint64((r))) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( pow(Q7B_IDqreal((l)), (int) ((Q7B_Decimal *) r->ref)->toFloat()) );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( pow(((Q7B_Decimal *) l->ref)->toFloat(), (int) ((Q7B_Decimal *) r->ref)->toInteger()) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( pow(((Q7B_Decimal *) l->ref)->toFloat(), (int) Q7B_IDqint64((r))) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( pow(((Q7B_Decimal *) l->ref)->toFloat(), Q7B_IDqreal((r))) );
    }
  }

  Q7B_CASTEXCEPTION("Number expected");
  return Q7B_QOBJECT(false);
}

Q7B Q7B_MUL(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) * *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) * *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) * ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) * *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) * *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) * ((Q7B_Decimal *) r->ref)->toFloat() );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() * ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_QOBJECT( d );
    }
    if (r->type == typeid(qint64).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() * (*((qint64 *) r->ref) * 10000) );
      return Q7B_QOBJECT( d );
    }
    if (r->type == typeid(qreal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() * (*((qreal *) r->ref) * 10000) );
      return Q7B_QOBJECT( d );
    }    
  }

  Q7B_CASTEXCEPTION("Number expected");
  return Q7B_QOBJECT(false);
}

Q7B Q7B_IDIV(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) / *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) / (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) / ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) / (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) / *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) / (qint64) ((Q7B_Decimal *) r->ref)->toFloat() );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() / ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_QOBJECT( d );
    }
    if (r->type == typeid(qint64).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() / (*((qint64 *) r->ref) * 10000) );
      return Q7B_QOBJECT( d );
    }
    if (r->type == typeid(qreal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() / (qint64) (*((qreal *) r->ref) * 10000) );
      return Q7B_QOBJECT( d );
    }
  }

  Q7B_CASTEXCEPTION("Number expected");
  return Q7B_QOBJECT(false);
}

Q7B Q7B_DIV(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( (qreal) (*((qint64 *) l->ref)) / *((qint64 *) r->ref) ); 
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( (qreal) (*((qint64 *) l->ref)) / *((qreal *) r->ref) ); 
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( (qreal) (*((qint64 *) l->ref)) / ((Q7B_Decimal *) r->ref)->toFloat() ); 
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) / *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) / *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qreal *) l->ref) / ((Q7B_Decimal *) r->ref)->toFloat() );
    }
  }
  
  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() / ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_QOBJECT( d );
    }
    if (r->type == typeid(qint64).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() / (*((qint64 *) r->ref) * 10000) );
      return Q7B_QOBJECT( d );
    }
    if (r->type == typeid(qreal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() / (*((qreal *) r->ref) * 10000) );
      return Q7B_QOBJECT( d );
    }
  }

  Q7B_CASTEXCEPTION("Number expected");
  return Q7B_QOBJECT(false);
}

Q7B Q7B_MOD(Q7B l, Q7B r)
{
  if (Q7B_nil(l) || Q7B_nil(r)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (l->type == typeid(qint64).name()){
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) % *((qint64 *) r->ref) );
    }
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) % (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( *((qint64 *) l->ref) % ((Q7B_Decimal *) r->ref)->toInteger() );
    }
  }

  if (l->type == typeid(qreal).name()){
    if (r->type == typeid(qreal).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) % (qint64) *((qreal *) r->ref) );
    }
    if (r->type == typeid(qint64).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) % *((qint64 *) r->ref) );
    }
    if (r->type == typeid(Q7B_Decimal).name()){
      return Q7B_QOBJECT( (qint64) *((qreal *) l->ref) % (qint64) ((Q7B_Decimal *) r->ref)->toFloat() );
    }
  }

  if (l->type == typeid(Q7B_Decimal).name()){
    if (r->type == typeid(Q7B_Decimal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() % ((Q7B_Decimal *) r->ref)->value() );
      return Q7B_QOBJECT( d );
    }
    if (r->type == typeid(qint64).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() % (*((qint64 *) r->ref) * 10000) );
      return Q7B_QOBJECT( d );
    }
    if (r->type == typeid(qreal).name()){
      Q7B_Decimal d;
      d.setValue( ((Q7B_Decimal *) l->ref)->value() % (qint64) (*((qreal *) r->ref) * 10000) );
      return Q7B_QOBJECT( d );
    }
  }

  Q7B_CASTEXCEPTION("Number expected");
  return Q7B_QOBJECT(false);
}



Q7B Q7B_VB6MsgBox(QString sMessage, int n, QString sTitle)
{
    
    bool kbOKCancel = (n & 1) == 1;
    bool kbAbortRetryIgnore = (n & 2) == 2;
    bool kbYesNoCancel = (n & 3) == 3;
    bool kbYesNo = (n & 4) == 4;
    bool kbRetryCancel = (n & 5) == 5;

    bool kbOKOnly = !kbOKCancel && !kbAbortRetryIgnore && !kbYesNoCancel && !kbYesNo && !kbRetryCancel;

    bool kbInformation = (n & 64) == 64;
    bool kbExclamation = kbInformation ? false : (n & 48) == 48;
    bool kbQuestion = kbExclamation | kbInformation ? false : (n & 32) == 32;
    bool kbCritical = kbExclamation | kbInformation | kbQuestion ? false : (n & 16) == 16;

    bool kbDefaultButton1 = n & 0;
    bool kbDefaultButton2 = (n & 256) == 256;
    bool kbDefaultButton3 = (n & 512) == 512;

    int k0 = QMessageBox::NoIcon;
    int k1 = QMessageBox::Yes | QMessageBox::Default;
    int k2 = QMessageBox::NoButton;
    int k3 = QMessageBox::NoButton;

    if (kbCritical) k0 = QMessageBox::Critical;
    else if (kbQuestion) k0 = QMessageBox::Question;
    else if (kbExclamation) k0 = QMessageBox::Warning;
    else if (kbInformation) k0 = QMessageBox::Information;
    
    if (kbOKOnly){
      k1 = QMessageBox::Ok | QMessageBox::Escape;
    } else if (kbOKCancel){
      k1 = QMessageBox::Ok;
      k2 = QMessageBox::Cancel | QMessageBox::Escape;
    } else if (kbAbortRetryIgnore){
      k1 = QMessageBox::Abort;
      k2 = QMessageBox::Retry | QMessageBox::Escape;
      k3 = QMessageBox::Ignore;
    } else if (kbYesNoCancel){
      k1 = QMessageBox::Yes;
      k2 = QMessageBox::No;
      k3 = QMessageBox::Cancel | QMessageBox::Escape;
    } else if (kbYesNo){
      k1 = QMessageBox::Yes;
      k2 = QMessageBox::No | QMessageBox::Escape;
    } else if (kbRetryCancel){
      k1 = QMessageBox::Retry;
      k2 = QMessageBox::Cancel | QMessageBox::Escape;
    }

    if (kbDefaultButton1) k1 = k1 | QMessageBox::Default;
    else if (kbDefaultButton2) k2 = k2 | QMessageBox::Default;
    else if (kbDefaultButton3) k3 = k3 | QMessageBox::Default;    
    
    QMessageBox mb((QMessageBox::Icon) k0, !sTitle.isEmpty() ? sTitle : qApp->applicationName().isEmpty() ? "Q7Basic" : qApp->applicationName(), 
      sMessage, (QMessageBox::StandardButton) (k1| k2 | k3), 0); 


    if (kbOKOnly){
      mb.setButtonText( QMessageBox::Yes, QObject::tr("&OK") );
    } else if (kbOKCancel){
      mb.setButtonText( QMessageBox::Yes, QObject::tr("&OK") );
      mb.setButtonText( QMessageBox::No, QObject::tr("&Cancel") );
    } else if (kbAbortRetryIgnore){
      mb.setButtonText( QMessageBox::Yes, QObject::tr("&Abort") );
      mb.setButtonText( QMessageBox::No, QObject::tr("&Retry") );
      mb.setButtonText( QMessageBox::Cancel, QObject::tr("&Ignore") );
    } else if (kbYesNoCancel){
      mb.setButtonText( QMessageBox::Yes, QObject::tr("&Yes") );
      mb.setButtonText( QMessageBox::No, QObject::tr("&No") );
      mb.setButtonText( QMessageBox::Cancel, QObject::tr("&Cancel") );
    } else if (kbYesNo){
      mb.setButtonText( QMessageBox::Yes, QObject::tr("&Yes") );
      mb.setButtonText( QMessageBox::No, QObject::tr("&No") );
    } else if (kbRetryCancel){
      mb.setButtonText( QMessageBox::Yes, QObject::tr("&Retry") );
      mb.setButtonText( QMessageBox::No, QObject::tr("&Cancel") );
    }

    switch( mb.exec() ) {
    case QMessageBox::Ok:
        return Q7B_QOBJECT(1);
    case QMessageBox::Cancel:
        return Q7B_QOBJECT(2);
    case QMessageBox::Abort:
        return Q7B_QOBJECT(3);
    case QMessageBox::Retry:
        return Q7B_QOBJECT(4);
    case QMessageBox::Ignore:
        return Q7B_QOBJECT(5);
    case QMessageBox::Yes:
        return Q7B_QOBJECT(6);
        break;
    case QMessageBox::No:
        return Q7B_QOBJECT(7);
    default:
      return Q7B_QOBJECT(0);
    }
}



Q7B Q7B_MSGBOX(Q7B a, Q7B b, Q7B VB6MsgBox)
{
  QString s = Q7B_toString2(a); if (Q7B_bException){ return Q7B_idnil; }

  bool bVB6MsgBox = Q7B_IDbool(VB6MsgBox);

  if (bVB6MsgBox){
    return Q7B_QOBJECT( Q7B_VB6MsgBox(s, Q7B_IDqint64(b), "" ) );

  } else {
    QString ss = Q7B_toString2(b); if (Q7B_bException){ return Q7B_idnil; }

    return Q7B_QOBJECT( QMessageBox::information(0, s, ss) );
  }
}

Q7B Q7B___MSGBOX(Q7B a, Q7B b, Q7B Buttons, Q7B VB6MsgBox)
{
  QString s = Q7B_toString2(a); if (Q7B_bException){ return Q7B_idnil; }

  bool bVB6MsgBox = Q7B_IDbool(VB6MsgBox);

  if (bVB6MsgBox){

    QString ss = Q7B_toString2(Buttons); if (Q7B_bException){ return Q7B_idnil; }

    return Q7B_QOBJECT( Q7B_VB6MsgBox(s, Q7B_IDqint64(b), Q7B_IDQString(Buttons) ) );

  } else {
    QString ss = Q7B_toString2(b); if (Q7B_bException){ return Q7B_idnil; }
    if (Q7B_nil(Q7B_INTEGER(Buttons))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

    return Q7B_QOBJECT( QMessageBox::information(0, s, ss, (QMessageBox::StandardButton) *((qint64 *) Buttons->ref ) ) );
  }
}

Q7B Q7B__MSGBOX(Q7B Q7B_Object)
{
  QString s = Q7B_toString2(Q7B_Object); if (Q7B_bException){ return Q7B_idnil; }

  return Q7B_QOBJECT( QMessageBox::information(0, "", s) ); 
}

Q7B Q7B_INPUTBOX(Q7B Prompt, Q7B Title, Q7B Default)
{
  if (Q7B_nil(Q7B_QSTRING(Prompt))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Title->ref != 0 && Q7B_nil(Q7B_QSTRING(Title))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Default->ref != 0 && Q7B_nil(Q7B_QSTRING(Default))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  bool ok;
  QString text;
  
  text = QInputDialog::getText(qApp->focusWidget(), Title->ref != 0 ? *((QString *) Title->ref) : qApp->applicationName(), *((QString *) Prompt->ref), QLineEdit::Normal, Default->ref == 0 ? "" : *((QString *) Default->ref), &ok, 0);

  if (ok && !text.isEmpty()){
    return Q7B_QOBJECT(text);
  }    

  return Q7B_idnil;
}     

bool Q7B_fileExists(QString & s)
{

  bool b = false;
  
  b = QFile::exists(qApp->applicationDirPath() + "/" + s); 

  if (b == false){
    b = QFile::exists( s );
  }

  if (b){ 
    QDir d(s);
    b = !d.exists(); 
  }

  return b;
}

Q7B Q7B_ISDIR(Q7B FilePath)
{
  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_QOBJECT( QFileInfo( *((QString *) FilePath->ref)).isDir() );
}    

Q7B Q7B_FILE(Q7B FilePath)
{
  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_QOBJECT( Q7B_fileExists( *((QString *) FilePath->ref) ) );
}    

bool Q7B_copyFile (const QString& from, const QString& to)
{
  QString TO = to;
  if (from.toLower() != TO.toLower()){
    QFile file(from);
    if (file.exists()){
      QFile file2(TO);  
      file2.remove();
      
      if (QDir(TO).exists()){
        QFileInfo fi(from);
        QFileInfo fi2(TO);
        TO = fi2.absoluteFilePath(); 
        TO += QString("/") + fi.fileName();        
      }
      return file.copy(TO);
    }
  }
  return false;
} 

bool Q7B_copyDir (const QString& from, const QString& to, bool bFirst)
{
  if (QDir(from).exists()){

    QFileInfo fi(from);
    QString TO = to;
    if (bFirst){
      TO += "/" + fi.fileName(); 
    }

    QDir d;
    d.mkpath(TO);

    QDir thisDir( from );	
    QFileInfoList files = thisDir.entryInfoList();

    if ( files.size() ) {

      QFileInfo fi;
      for (int i = 0; i < files.size(); ++i) {
        fi = files.at(i);

        

        QString ss = fi.absoluteFilePath();

		    if (fi.fileName() == "." || fi.fileName() == ".."){
		        ; 
		    } else if ( fi.isSymLink()){
            ; 
		    } else if ( fi.isDir() ){

          if (!Q7B_copyDir(fi.absoluteFilePath(), TO + "/" + fi.fileName(), false)) return false;

        } else {

          if (!Q7B_copyFile(fi.absoluteFilePath(), TO + "/" + fi.fileName())) return false;

        }		    
	    }
    
    }    
    return true;
  }
  return false;
}

  



Q7B Q7B_COPY(Q7B SourceFilePath, Q7B DestinationFilePath)
{
  if (Q7B_nil(Q7B_QSTRING(SourceFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo fi(*((QString *) SourceFilePath->ref));  

  if (fi.isDir()){
    return Q7B_QOBJECT( Q7B_copyDir(*((QString *) SourceFilePath->ref), *((QString *) DestinationFilePath->ref), false) );
  } else {
    return Q7B_QOBJECT( Q7B_copyFile(*((QString *) SourceFilePath->ref), *((QString *) DestinationFilePath->ref)) );
  }
}    



Q7B Q7B_COPYDIR(Q7B SourceFilePath, Q7B DestinationFilePath)
{
  if (Q7B_nil(Q7B_QSTRING(SourceFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo fi(*((QString *) SourceFilePath->ref));  

  if (fi.isDir()){
    return Q7B_QOBJECT( Q7B_copyDir(*((QString *) SourceFilePath->ref), *((QString *) DestinationFilePath->ref), true) );
  } else {
    return Q7B_QOBJECT( Q7B_copyFile(*((QString *) SourceFilePath->ref), *((QString *) DestinationFilePath->ref)) );
  }
}    

Q7B Q7B_MOVE(Q7B SourceFilePath, Q7B DestinationFilePath)
{
  if (Q7B_nil(Q7B_QSTRING(SourceFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo fi(*((QString *) SourceFilePath->ref));  

  if (fi.isDir()){
    QDir d;
    return Q7B_QOBJECT( d.rename(*((QString *) SourceFilePath->ref), *((QString *) DestinationFilePath->ref)) );
  } else {
    if (Q7B_copyFile(*((QString *) SourceFilePath->ref), *((QString *) DestinationFilePath->ref))){
      return Q7B_QOBJECT(QFile::remove(*((QString *) SourceFilePath->ref)));      
    }
  }
  return Q7B_QOBJECT(false);
}    

Q7B Q7B_DELETE(Q7B FilePath)
{
  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo fi(*((QString *) FilePath->ref));  

  if (fi.isDir()){
    QDir d;
    return Q7B_QOBJECT( d.rmpath( *((QString *) FilePath->ref) ));
  } else {
    return Q7B_QOBJECT(QFile::remove( *((QString *) FilePath->ref) ));
  }
}    

Q7B Q7B_DRIVES()
{
  QFileInfoList l = QDir::drives();

  Q7B_List *a = new Q7B_List();
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

  for (int i = 0; i < l.size(); i++){
     a->append(Q7B_QOBJECT( l.at(i).absoluteFilePath()));
  }

  return q;
}     

Q7B Q7B_DIR(Q7B FilePath, Q7B Create)
{
  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Create))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (*((bool *) Create->ref)){ 
    QDir d;

    return Q7B_QOBJECT( d.mkpath( *((QString *) FilePath->ref) ) );
  } else {

    QDir d;
    return Q7B_QOBJECT( d.exists( *((QString *) FilePath->ref) ) );
  }
}     

Q7B Q7B_CLASSNAME(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }  

  
  if (Q7B_Object->type == typeid(qint64).name()){
    return Q7B_QOBJECT("Integer");

  } else if (Q7B_Object->type == typeid(qreal).name()){
    return Q7B_QOBJECT("Float");

  } else if (Q7B_Object->type == typeid(bool).name()){
    return Q7B_QOBJECT("Boolean");

  } else if (Q7B_Object->type == typeid(QDateTime).name()){
    return Q7B_QOBJECT("DateTime");

  } else if (Q7B_Object->type == typeid(Q7B_Decimal).name()){
    return Q7B_QOBJECT("Decimal");

  } else if (Q7B_Object->type == typeid(QString).name()){    
    return Q7B_QOBJECT("String");

  } else if (Q7B_Object->type == typeid(Q7B_List).name()){    
    return Q7B_QOBJECT("List");

  } else if (Q7B_Object->type == typeid(Q7B_Dictionary).name()){    
    return Q7B_QOBJECT("Dictionary");

  } else if (Q7B_Object->type == typeid(QIcon).name()){    
    return Q7B_QOBJECT("QIcon");

  } 

  QObject *o = ((QObject *) Q7B_Object->ref);
  return Q7B_QOBJECT( o->metaObject()->className() );

  
}     

Q7B Q7B_MESSAGEBOX(Q7B Icon, Q7B Title, Q7B Text, Q7B InformativeText, Q7B DetailedText, Q7B o1, Q7B o2, Q7B o3, Q7B o4, Q7B o5, Q7B o6, Q7B o7, Q7B o8, Q7B o9, Q7B o10)
{
  qint64 nIcon = Q7B_toInteger2(Icon);
  QMessageBox *qmessagebox = new QMessageBox(qApp->focusWidget());
  if (nIcon == 999999){ 
#ifdef Q_WS_MAC
    qmessagebox->setWindowModality(Qt::WindowModal);
    nIcon = QMessageBox::NoIcon;
#endif
  }
  qmessagebox->setIcon((QMessageBox::Icon) nIcon);
  qmessagebox->setWindowTitle(Q7B_toString2(Title));
  qmessagebox->setText(Q7B_toString2(Text));
  
  for (qint64 i = 0; i < 10; i++){
    Q7B o; 
    switch(i){
      case 0: o = o1; break;
      case 1: o = o2; break;
      case 2: o = o3; break;
      case 3: o = o4; break;
      case 4: o = o5; break;
      case 5: o = o6; break;
      case 6: o = o7; break;
      case 7: o = o8; break;
      case 8: o = o9; break;
      case 9: o = o10; break;
    }
    if (i > 0 && o->ref == 0) goto _exec;
    if (o->type == typeid(Q7B_List).name()){
      Q7B_List *a = (Q7B_List *) o->ref;
      if (a->me.size() < 2){ Q7B_INVALIDARGUMENTEXCEPTION("List contains not enough values"); return Q7B_QOBJECT(0); }
      qmessagebox->addButton(Q7B_toString2(a->me.at(0)), (QMessageBox::ButtonRole) Q7B_toInteger2(a->me.at(1)));
    } else {
      qmessagebox->addButton((QMessageBox::StandardButton) Q7B_toInteger2(o));
    }
  }


_exec:

  qmessagebox->setInformativeText(Q7B_toString2(InformativeText));
  qmessagebox->setDetailedText(Q7B_toString2(DetailedText));

  qint64 n = qmessagebox->exec();
  if (n < (qint64) QMessageBox::Ok){
    if (qmessagebox->clickedButton() != 0){
      QList<QAbstractButton *> buttons = qmessagebox->buttons();
      for (qint64 i = 0; i < buttons.size(); i++){
        if (buttons.at(i) == qmessagebox->clickedButton()){
          return Q7B_QOBJECT(i);
        }
      }
    }     
  } else {
    return Q7B_QOBJECT(n);
  }
  return Q7B_QOBJECT(0);
}








Q7B Q7B_QOBJECT() 
{
  Q7B q (new Q7B_id()); 
  return q;
}

Q7B Q7B_QOBJECT(QObject *o) 
{
  Q7B q (new Q7B_id(typeid(QObject).name(), o)); 
  return q;
}

Q7B Q7B_QOBJECT(bool o) 
{
  Q7B q (new Q7B_id(typeid(bool).name(), new bool(o))); 
  return q;
}

Q7B Q7B_QOBJECT(char * o)
{
  Q7B q (new Q7B_id(typeid(QString).name(), new QString(o))); 
  return q;
}

Q7B Q7B_QOBJECT(const char * o)
{
  Q7B q (new Q7B_id(typeid(QString).name(), new QString(o))); 
  return q;
}

Q7B Q7B_QOBJECT(QString o)
{
  Q7B q (new Q7B_id(typeid(QString).name(), new QString(o))); 
  return q;
}

Q7B Q7B_QOBJECT(qint8 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B_QOBJECT(qint16 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B_QOBJECT(qint32 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B_QOBJECT(qint64 o)
{
  

  

  Q7B q;


 

  q = Q7B(new Q7B_id(typeid(qint64).name(), new qint64(o))); 

 


  return q;
}

Q7B Q7B_QOBJECT(quint8 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B_QOBJECT(quint16 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B_QOBJECT(quint32 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B_QOBJECT(quint64 o)
{
  Q7B q;
  
  q = Q7B(new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B_QOBJECT(float o)
{
  

  qreal r = 0;

  Q7B q;


  
  q = Q7B (new Q7B_id(typeid(qreal).name(), new qreal(o))); 
 



  return q;
}

Q7B Q7B_QOBJECT(double o)
{
 

  qreal r = 0;

  Q7B q;


  
  q = Q7B (new Q7B_id(typeid(qreal).name(), new qreal(o))); 
 


  return q;
}

Q7B Q7B_QOBJECT(QStringList o) 
{
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), new Q7B_List(o))); 
  return q;
}

Q7B Q7B_QOBJECT(QIcon o)
{
  Q7B q (new Q7B_id(typeid(QIcon).name(), new QIcon(o))); 
  return q;
}

Q7B Q7B_QOBJECT(QByteArray o)
{
  Q7B q (new Q7B_id(typeid(QByteArray).name(), new QByteArray(o))); 
  return q;
}





Q7B Q7B_QOBJECTDECIMAL(qint64 bc, qint64 ad)
{
  Q7B q (new Q7B_id(typeid(Q7B_Decimal).name(), new Q7B_Decimal(bc, ad))); 
  return q;
}

Q7B Q7B_QOBJECTNULL(qint64 *dummy)
{
  return Q7B_IDNIL();
}

Q7B Q7B_QOBJECT(QDateTime o) 
{
  Q7B q (new Q7B_id(typeid(QDateTime).name(), new QDateTime(o))); 
  return q;
}

Q7B Q7B_QOBJECT(Q7B_Decimal o) 
{
  Q7B q (new Q7B_id(typeid(Q7B_Decimal).name(), new Q7B_Decimal(o))); 
  return q;
}


Q7B Q7B_QOBJECT(QIcon *o)
{
  Q7B q (new Q7B_id(typeid(QIcon).name(), o));  
  return q;
}

Q7B Q7B_QOBJECT(QMenu *o)
{
  Q7B q (new Q7B_id(typeid(QMenu).name(), o));  
  return q;
}

Q7B Q7B_QOBJECT(QMdiArea *o)
{
  Q7B q (new Q7B_id(typeid(QMdiArea).name(), o)); 
  return q;
}

Q7B Q7B_QOBJECT(QProgressBar *o)
{
  Q7B q (new Q7B_id(typeid(QProgressBar).name(), o)); 
  return q;
}

Q7B Q7B_QOBJECT(QAction *o)
{
  Q7B q (new Q7B_id(typeid(QAction).name(), o));  
  return q;
}

Q7B Q7B_QOBJECT(QPainter *o)
{
  Q7B q (new Q7B_id(typeid(QPainter).name(), o));  
  return q;
}

Q7B Q7B_QOBJECT(QWidget *o)
{
  Q7B q (new Q7B_id(typeid(QWidget).name(), o));  
  return q;
}

Q7B Q7B_QOBJECT(const char *name, QObject *o)
{
  static QMap<QString, QString> user_types;

  if (!user_types.contains(name)){
    user_types[name] = QString("class ") + name;
  }
  Q7B q (new Q7B_id(user_types[name].toAscii().constData(), o)); 
  return q;
}


Q7B Q7B_idGLOBAL = Q7B_idnil;



Q7B Q7B_idMAINWINDOW = Q7B_idnil;


Q7B Q7B_idAPPLICATION = Q7B_idnil;


Q7B Q7B_idSYSTEMTRAY = Q7B_idnil;






Q7B Q7B_BOOLEAN(Q7B o)
{
  if (o->type == typeid(bool).name()){
    return o;
  }

  Q7B_CASTEXCEPTION("'Boolean' expected");

  return Q7B_idnil;
}

Q7B Q7B_QSTRING(Q7B Q7B_Object)
{
  if (Q7B_Object->type == typeid(QString).name()){
    return Q7B_Object;
  }

  Q7B_CASTEXCEPTION("'String' expected");

  return Q7B_idnil;
}

Q7B Q7B_INTEGER(Q7B o)
{
  if (o->type == typeid(qint64).name()){
    return o;
  }
  if (o->type == typeid(qreal).name()){
    return Q7B_QOBJECT( (qint64) (*((qreal *) o->ref)) );  
  }

  Q7B_CASTEXCEPTION("Number expected");

  return Q7B_idnil;
}

Q7B Q7B_FLOAT(Q7B o)
{
  

  if (o->type == typeid(qreal).name()){
    return o;
  }
  if (o->type == typeid(qint64).name()){
    return Q7B_QOBJECT( (qreal) (*((qint64 *) o->ref)) );  
  }

  Q7B_CASTEXCEPTION("Number expected");

  return Q7B_idnil;
}

Q7B Q7B_DATETIME(Q7B o)
{
  if (o->type == typeid(QDateTime).name()){
    return o;
  }
  return Q7B_idnil;
}

Q7B Q7B_DECIMAL(Q7B o)
{
  if (o->type == typeid(Q7B_Decimal).name()){
    return o;
  }
  return Q7B_idnil;
}

Q7B Q7B_LIST(Q7B o)
{
  if (o->type == typeid(Q7B_List).name()){
    return o;
  }
  return Q7B_idnil;
}

Q7B Q7B_DICTIONARY(Q7B o)
{
  if (o->type == typeid(Q7B_Dictionary).name()){
    return o;
  }
  return Q7B_idnil;
}


Q7B Q7B_DATA(Q7B o)
{
  if (o->type == typeid(Q7B_Data).name()){
    return o;
  }
  return Q7B_idnil;
}












Q7B Q7B_idOS = Q7B_idnil;

Q7B Q7B_OS_ISWINDOWS(Q7B dummy)
{  
#ifdef Q_WS_WIN
  return Q7B_QOBJECT( true );
#endif
  return Q7B_QOBJECT( false );
}

Q7B Q7B_OS_ISMAC(Q7B dummy)
{  
#ifdef Q_WS_MAC
  return Q7B_QOBJECT( true );
#endif
  return Q7B_QOBJECT( false );
}

Q7B Q7B_OS_ISLINUX(Q7B dummy)
{  
#ifdef Q_WS_X11
  return Q7B_QOBJECT( true );
#endif
  return Q7B_QOBJECT( false );
}




void Q7B_QPAINTER_DRAWLINE(Q7B qpainter, Q7B X1, Q7B Y1, Q7B X2, Q7B Y2)
{  
  if (Q7B_nil(Q7B_QPAINTER(qpainter))){ Q7B_EXCEPTION("QPainter expected"); return; }

  if (Q7B_nil(Q7B_INTEGER(X1))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Y1))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(X2))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Y2))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QPainter *) qpainter->ref)->drawLine( *((qint64 *) X1->ref), *((qint64 *) Y1->ref), *((qint64 *) X2->ref), *((qint64 *) Y2->ref));  
}



Q7B Q7B_idFILE = Q7B_idnil;

QFile Q7B_qfile;

Q7B Q7B_FILE_SIZE(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  Q7B_qfile.setFileName(Q7B_IDQString(FileName));
  return Q7B_QOBJECT( Q7B_qfile.size() );
}

Q7B Q7B_FILE_RESIZE(Q7B dummy, Q7B FileName, Q7B NewSize)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(NewSize))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  Q7B_qfile.setFileName(Q7B_IDQString(FileName));
  return Q7B_QOBJECT( Q7B_qfile.resize(Q7B_IDqint64(NewSize)) );
}

Q7B Q7B_FILE_TRUNCATE(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  Q7B_qfile.setFileName(Q7B_IDQString(FileName));
  if (Q7B_qfile.open(QIODevice::Truncate | QIODevice::WriteOnly)){
    Q7B_qfile.close();
    return Q7B_QOBJECT(true);
  }
  return Q7B_QOBJECT(false);
}

Q7B Q7B_FILE_READSTRING(Q7B dummy, Q7B FileName, Q7B Codec, Q7B AutoDetectUnicode, Q7B GenerateByteOrderMark)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Codec))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(AutoDetectUnicode))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(GenerateByteOrderMark))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  QString sFileName = Q7B_IDQString(FileName);
  QFile f(sFileName);
  bool b = false;

  if (sFileName.compare("stderr", Qt::CaseInsensitive) == 0) b = f.open(stderr, QIODevice::ReadOnly);
  else if (sFileName.compare("stdin", Qt::CaseInsensitive) == 0) b = f.open(stdin, QIODevice::ReadOnly);
  else if (sFileName.compare("stdout", Qt::CaseInsensitive) == 0) b = f.open(stdout, QIODevice::ReadOnly);
  else b = f.open(QIODevice::ReadOnly);

  if (b){
    QTextStream t(&f);
    
    QString sCodec = Q7B_IDQString(Codec);
    t.setCodec(QTextCodec::codecForName(sCodec.toLatin1().data()));
    t.setAutoDetectUnicode(Q7B_IDbool(AutoDetectUnicode));
    t.setGenerateByteOrderMark(Q7B_IDbool(GenerateByteOrderMark));

    QString s = t.readAll();
    f.close();
    return Q7B_QOBJECT(s);
  }

  return Q7B_QOBJECT("");
}

Q7B Q7B_FILE_READLINES(Q7B dummy, Q7B FileName, Q7B Codec, Q7B AutoDetectUnicode, Q7B GenerateByteOrderMark)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Codec))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(AutoDetectUnicode))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(GenerateByteOrderMark))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  QString sFileName = Q7B_IDQString(FileName);
  QFile f(sFileName);
  bool b = false;

  if (sFileName.compare("stderr", Qt::CaseInsensitive) == 0) b = f.open(stderr, QIODevice::ReadOnly);
  else if (sFileName.compare("stdin", Qt::CaseInsensitive) == 0) b = f.open(stdin, QIODevice::ReadOnly);
  else if (sFileName.compare("stdout", Qt::CaseInsensitive) == 0) b = f.open(stdout, QIODevice::ReadOnly);
  else b = f.open(QIODevice::ReadOnly);

  if (b){
    QTextStream t(&f);
    
    QString sCodec = Q7B_IDQString(Codec);
    t.setCodec(QTextCodec::codecForName(sCodec.toLatin1().data()));
    t.setAutoDetectUnicode(Q7B_IDbool(AutoDetectUnicode));
    t.setGenerateByteOrderMark(Q7B_IDbool(GenerateByteOrderMark));

    QString s = t.readAll();
    f.close();

    Q7B_List *a = new Q7B_List();
    Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

    QStringList l = s.split("\n");
    for (int i = 0; i < l.size(); i++){
      QString k = l.at(i);
      k = k.replace("\r", "");
       a->append( Q7B_QOBJECT( k ) );
    }

    return q;    
  }

  return Q7B_QOBJECT(Q7B_idnil);
}

Q7B Q7B_FILE_WRITESTRING(Q7B dummy, Q7B Text, Q7B FileName, Q7B Append, Q7B Codec, Q7B AutoDetectUnicode, Q7B GenerateByteOrderMark)
{  
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Append))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Codec))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(AutoDetectUnicode))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(GenerateByteOrderMark))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  QString sFileName = Q7B_IDQString(FileName);
  QFile f(sFileName);
  bool b = false;

  if (sFileName.compare("stderr", Qt::CaseInsensitive) == 0) b = f.open(stderr, QIODevice::ReadOnly);
  else if (sFileName.compare("stdin", Qt::CaseInsensitive) == 0) b = f.open(stdin, QIODevice::ReadOnly);
  else if (sFileName.compare("stdout", Qt::CaseInsensitive) == 0) b = f.open(stdout, QIODevice::ReadOnly);
  else b = f.open(QIODevice::WriteOnly | (Q7B_IDbool(Append) ? QIODevice::Append : QIODevice::Truncate));

  if (b){
    QTextStream t(&f);

    QString sCodec = Q7B_IDQString(Codec);

    if (sCodec == "Locale"){
    } else if (sCodec == ""){
      t.setCodec("UTF-8");
    } else {
      t.setCodec(sCodec.toAscii());
    }

    
    t.setAutoDetectUnicode(Q7B_IDbool(AutoDetectUnicode));
    t.setGenerateByteOrderMark(Q7B_IDbool(GenerateByteOrderMark));

    t << Q7B_IDQString(Text);
    f.close();

    return Q7B_QOBJECT( true );
  }

  return Q7B_QOBJECT( false );
}

Q7B Q7B_FILE_LINK(Q7B dummy, Q7B SourceFileName, Q7B DestinationFileName)
{  
  if (Q7B_nil(Q7B_QSTRING(SourceFileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  Q7B_qfile.setFileName(Q7B_IDQString(SourceFileName));
  if (QFile::exists(Q7B_IDQString(SourceFileName))) return Q7B_QOBJECT( Q7B_qfile.link(Q7B_IDQString(DestinationFileName)) );
  return Q7B_QOBJECT( false );
}

Q7B Q7B_FILE_CREATE(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (QFile::exists(Q7B_IDQString(FileName))) return Q7B_QOBJECT( true );

  QFile f(Q7B_IDQString(FileName));
  if (f.open(QIODevice::WriteOnly)){
    f.close();
    return Q7B_QOBJECT( true );
  }
  
  return Q7B_QOBJECT( false );
}

Q7B Q7B_FILE_REMOVE(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (QFile::exists(Q7B_IDQString(FileName))) return Q7B_QOBJECT( QFile::remove(Q7B_IDQString(FileName)) );
  
  return Q7B_QOBJECT( false );
}

Q7B Q7B_FILE_COPY(Q7B dummy, Q7B SourceFileName, Q7B DestinationFileName, Q7B Overwrite)
{  
  if (Q7B_nil(Q7B_QSTRING(SourceFileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Overwrite))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Q7B_IDbool(Overwrite)){
    return Q7B_QOBJECT( Q7B_copyFile(Q7B_IDQString(SourceFileName), Q7B_IDQString(DestinationFileName)) );
  } else {
    return Q7B_QOBJECT( QFile::copy(Q7B_IDQString(SourceFileName), Q7B_IDQString(DestinationFileName)) );
  }
}

Q7B Q7B_FILE_MOVE(Q7B dummy, Q7B SourceFileName, Q7B DestinationFileName, Q7B Overwrite)
{  
  if (Q7B_nil(Q7B_QSTRING(SourceFileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Overwrite))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Q7B_IDbool(Overwrite)){
    if (Q7B_copyFile(Q7B_IDQString(SourceFileName), Q7B_IDQString(DestinationFileName))){
      QFile::remove(Q7B_IDQString(SourceFileName));
      return Q7B_QOBJECT( true );
    }
  } else {
    if (QFile::copy(Q7B_IDQString(SourceFileName), Q7B_IDQString(DestinationFileName))){
      QFile::remove(Q7B_IDQString(SourceFileName));
      return Q7B_QOBJECT( true );
    }
  }
  return Q7B_QOBJECT( false );
}

Q7B Q7B_FILE_RENAME(Q7B dummy, Q7B SourceFileName, Q7B DestinationFileName, Q7B Overwrite)
{  
  if (Q7B_nil(Q7B_QSTRING(SourceFileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Overwrite))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Q7B_IDbool(Overwrite) && QFile::exists(Q7B_IDQString(DestinationFileName))){
    QFile::remove(Q7B_IDQString(DestinationFileName));
  }
  return Q7B_QOBJECT( QFile::rename(Q7B_IDQString(SourceFileName), Q7B_IDQString(DestinationFileName)) );
}

Q7B Q7B_FILE_EXISTS(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QFile::exists(Q7B_IDQString(FileName)) );
}

Q7B Q7B_FILE_DATETIMECREATED(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.created().toString("yyyy-MM-dd hh:mm:ss") );      
  return Q7B_QOBJECT( "" );
}

Q7B Q7B_FILE_DATETIMEUPDATED(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.lastModified().toString("yyyy-MM-dd hh:mm:ss") );      
  return Q7B_QOBJECT( "" );
}

Q7B Q7B_FILE_DATETIMEREAD(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.lastRead().toString("yyyy-MM-dd hh:mm:ss") );      
  return Q7B_QOBJECT( "" );
}

Q7B Q7B_FILE_WITHNATIVESEPARATORS(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QDir::toNativeSeparators(Q7B_IDQString(FileName)) );
}

Q7B Q7B_FILE_WITHOUTNATIVESEPARATORS(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QDir::fromNativeSeparators(Q7B_IDQString(FileName)) );
}

Q7B Q7B_FILE_OWNER(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.owner() );      
  return Q7B_QOBJECT( "" );
}

Q7B Q7B_FILE_GROUP(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.group() );      
  return Q7B_QOBJECT( "" );
}

Q7B Q7B_FILE_SYMLINKTARGET(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.symLinkTarget() );      
  return Q7B_QOBJECT( false );
}

Q7B Q7B_FILE_ISRELATIVE(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.isRelative() );      
  return Q7B_QOBJECT( false );
}

Q7B Q7B_FILE_ISSYMLINK(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.isSymLink() );      
  return Q7B_QOBJECT( false );
}

Q7B Q7B_FILE_ISREADABLE(Q7B dummy, Q7B FileName, Q7B Who)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Who))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWho = Q7B_IDQString(Who);
  if (sWho.isEmpty() || sWho.contains("User", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.isReadable() );      
  } else if (sWho.contains("Owner", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::ReadOwner) );   
  } else if (sWho.contains("Group", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::ReadGroup) );   
  } else if (sWho.contains("Other", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::ReadOther) );   
  }
  return Q7B_QOBJECT( false );
}

Q7B Q7B_FILE_ISWRITABLE(Q7B dummy, Q7B FileName, Q7B Who)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Who))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWho = Q7B_IDQString(Who);
  if (sWho.isEmpty() || sWho.contains("User", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.isWritable() );      
  } else if (sWho.contains("Owner", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::WriteOwner) );   
  } else if (sWho.contains("Group", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::WriteGroup) );   
  } else if (sWho.contains("Other", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::WriteOther) );   
  }
  return Q7B_QOBJECT( false );
}

Q7B Q7B_FILE_ISEXECUTABLE(Q7B dummy, Q7B FileName, Q7B Who)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Who))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWho = Q7B_IDQString(Who);
  if (sWho.isEmpty() || sWho.contains("User", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.isExecutable() );      
  } else if (sWho.contains("Owner", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::ExeOwner) );   
  } else if (sWho.contains("Group", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::ExeGroup) );   
  } else if (sWho.contains("Other", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::ExeOther) );   
  }
  return Q7B_QOBJECT( false );
}

Q7B Q7B_FILE_ISHIDDEN(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.isHidden() );      
  return Q7B_QOBJECT( false );
}

Q7B Q7B_FILE_ISFILE(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.isFile() );      
  return Q7B_QOBJECT( false );
}

Q7B Q7B_FILE_ISDIR(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( !f.isFile() );      
  return Q7B_QOBJECT( false );
}



Q7B Q7B_idPREFERENCES = Q7B_idnil;

Q7B Q7B_PREFERENCES_IDS(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }

  return Q7B_QOBJECT( ((QSettings *) Q7B_idPREFERENCES->ref)->allKeys() );
}

void Q7B_PREFERENCES_REMOVEALL(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }

  ((QSettings *) Q7B_idPREFERENCES->ref)->clear();
}

Q7B Q7B_PREFERENCES_EXISTS(Q7B dummy, Q7B PreferenceId)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QStringList l = ((QSettings *) Q7B_idPREFERENCES->ref)->allKeys();
  return Q7B_QOBJECT( l.indexOf( *((QString *) PreferenceId->ref) ) >= 0 );
}

void Q7B_PREFERENCES_REMOVE(Q7B dummy, Q7B PreferenceId)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return; }

  ((QSettings *) Q7B_idPREFERENCES->ref)->remove( *((QString *) PreferenceId->ref) );
}

Q7B Q7B_PREFERENCES_BOOLEAN(Q7B dummy, Q7B PreferenceId)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QSettings *) Q7B_idPREFERENCES->ref)->value( *((QString *) PreferenceId->ref) ).toBool());  
}

Q7B Q7B_PREFERENCES_INTEGER(Q7B dummy, Q7B PreferenceId)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }


  return Q7B_QOBJECT( ((QSettings *) Q7B_idPREFERENCES->ref)->value( *((QString *) PreferenceId->ref) ).toLongLong());  
}

Q7B Q7B_PREFERENCES_STRING(Q7B dummy, Q7B PreferenceId)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QSettings *) Q7B_idPREFERENCES->ref)->value( *((QString *) PreferenceId->ref) ).toString());  
}

Q7B Q7B_PREFERENCES_FLOAT(Q7B dummy, Q7B PreferenceId)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QSettings *) Q7B_idPREFERENCES->ref)->value( *((QString *) PreferenceId->ref) ).toDouble());  
}



Q7B Q7B_PREFERENCES_DECIMAL(Q7B dummy, Q7B PreferenceId) 
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QSettings *) Q7B_idPREFERENCES->ref)->value( *((QString *) PreferenceId->ref) ).toDouble());
}

void Q7B_PREFERENCES_SETBOOLEAN(Q7B dummy, Q7B PreferenceId, Q7B Value)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return; }

  ((QSettings *) Q7B_idPREFERENCES->ref)->setValue( *((QString *) PreferenceId->ref), *((bool *) Value->ref) );
}

void Q7B_PREFERENCES_SETINTEGER(Q7B dummy, Q7B PreferenceId, Q7B Value)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return; }

  ((QSettings *) Q7B_idPREFERENCES->ref)->setValue( *((QString *) PreferenceId->ref), *((qint64 *) Value->ref) );
}

void Q7B_PREFERENCES_SETSTRING(Q7B dummy, Q7B PreferenceId, Q7B Value)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return; }

  ((QSettings *) Q7B_idPREFERENCES->ref)->setValue( *((QString *) PreferenceId->ref), *((QString *) Value->ref) );
}

void Q7B_PREFERENCES_SETFLOAT(Q7B dummy, Q7B PreferenceId, Q7B Value)
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return; }

  ((QSettings *) Q7B_idPREFERENCES->ref)->setValue( *((QString *) PreferenceId->ref), *((qreal *) Value->ref) );
}



void Q7B_PREFERENCES_SETDECIMAL(Q7B dummy, Q7B PreferenceId, Q7B Value) 
{  
  if (Q7B_nil(Q7B_idPREFERENCES)){ Q7B_idPREFERENCES = Q7B(new Q7B_id(typeid(QSettings).name(), new QSettings(QSettings::NativeFormat , QSettings::UserScope, qApp->applicationName()))); }
  if (Q7B_nil(Q7B_QSTRING(PreferenceId))){ Q7B_EXCEPTION("String expected"); return; }

  ((QSettings *) Q7B_idPREFERENCES->ref)->setValue( *((QString *) PreferenceId->ref), *((qreal *) Value->ref) );
}



Q7B Q7B_idDESKTOP = Q7B_idnil;

Q7B Q7B_DESKTOP_DESKTOPLOCATION(Q7B dummy)
{  
  return Q7B_QOBJECT( QDesktopServices::storageLocation(QDesktopServices::DesktopLocation) );
}



Q7B Q7B_idDIR = Q7B_idnil;

Q7B Q7B_DIR_ROOTPATH(Q7B Path)
{  
  return Q7B_QOBJECT( QDir::rootPath() );
}

Q7B Q7B_DIR_TEMPPATH(Q7B Path)
{  
  return Q7B_QOBJECT( QDir::tempPath() );
}

Q7B Q7B_DIR_APPLICATIONSPATH(Q7B dummy)
{  
  return Q7B_QOBJECT( QDesktopServices::storageLocation(QDesktopServices::ApplicationsLocation) );
}

Q7B Q7B_DIR_HOMEPATH(Q7B dummy)
{  
  return Q7B_QOBJECT( QDesktopServices::storageLocation(QDesktopServices::HomeLocation) );
}

Q7B Q7B_DIR_DESKTOPPATH(Q7B dummy)
{  
  return Q7B_QOBJECT( QDesktopServices::storageLocation(QDesktopServices::DesktopLocation) );
}

Q7B Q7B_DIR_CREATE(Q7B dummy, Q7B Path)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QDir().mkdir(*((QString *) Path->ref)) );
}

Q7B Q7B_DIR_RECURSIVECREATE(Q7B dummy, Q7B Path)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QDir().mkpath(*((QString *) Path->ref)) );
}

Q7B Q7B_DIR_REMOVE(Q7B dummy, Q7B Path)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QDir().rmdir(*((QString *) Path->ref)) );
}

bool Q7B_RemoveDirectory(QDir aDir)
{
  bool has_err = false;
  if (aDir.exists())
  {
    QFileInfoList entries = aDir.entryInfoList(QDir::NoDotAndDotDot | QDir::Dirs | QDir::Files);
    int count = entries.size();
    for (int idx = 0; ((idx < count) && (true != has_err)); idx++)
    {
      QFileInfo entryInfo = entries[idx];
      QString path = entryInfo.absoluteFilePath();
    
      if (entryInfo.isDir())
      {
        has_err = Q7B_RemoveDirectory(QDir(path));
       
      }
      else if (entryInfo.isSymLink())
      {
        if (QFileInfo(entryInfo.symLinkTarget()).isDir()){
          has_err = Q7B_RemoveDirectory(QDir(path));
       
        }
        else {
          QFile file(path);
          if (!file.remove()){
            has_err = true;
        
          }
        }
      }
        else
      {

        

        QFile file(path);
        if (!file.remove()){
        
          has_err = true;
        }
        


      }
    }
    
    if (!aDir.rmdir(aDir.absolutePath())){
       

      has_err = true;
    }

    

  }
 
   
 

  return(has_err);
}

Q7B Q7B_DIR_EXISTS(Q7B dummy, Q7B Path)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QDir d( *((QString *) Path->ref) );
  return Q7B_QOBJECT( d.exists() && QFileInfo( *((QString *) Path->ref)).isDir() );
}

Q7B Q7B_DIR_RECURSIVEREMOVE(Q7B dummy, Q7B Path)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

 

  QDir d( *((QString *) Path->ref) );
  return Q7B_QOBJECT( ! Q7B_RemoveDirectory( d ));
}

QStringList Q7B_FindFile(QString Path, QStringList NameFilter, qint64 Filter, qint64 Sorting, bool bRecursive, bool bRecursiveCall, bool bbb)
{  
  bool b = bbb;
  if (bRecursive && !(Filter & QDir::AllDirs)){
    b = true;
    Filter |= QDir::AllDirs | QDir::Files;
  }
  
  QFileInfoList l;
  QDir dir;

  if (bRecursiveCall){    

    dir.setPath(Path);
    
    
    
    
      l = dir.entryInfoList(NameFilter, (QDir::Filters) Filter, (QDir::SortFlags) Sorting);
   

  } else {

    dir.setPath(Path);
    
   
   
   
      l = dir.entryInfoList(NameFilter, (QDir::Filters) Filter, (QDir::SortFlags) Sorting);
   

  }

  QStringList ll;
  int size = l.size();

  foreach(QFileInfo f, l){

    bool bb = bRecursive && f.isDir();

    if (!bb || (bb && b == false)){
      ll << f.absoluteFilePath();
    }

    if (bb){

		  if (f.fileName() == "." || f.fileName() == ".."){
		      ; 
		  } else {

        QStringList ll2 = Q7B_FindFile(f.absoluteFilePath(), NameFilter, Filter, Sorting, bRecursive, true, b);
        
        ll << ll2;        
      }
    }

  }
  return ll;
}

Q7B Q7B_DIR_FINDFILE(Q7B dummy, Q7B Path, Q7B NameFilter, Q7B Filter, Q7B Sorting)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_LIST(NameFilter))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Filter))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Sorting))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( Q7B_FindFile( Q7B_IDQString(Path), ((Q7B_List*)NameFilter->ref)->toStringList(), Q7B_IDqint64(Filter), Q7B_IDqint64(Sorting), false, false, false) );
}

Q7B Q7B_DIR_RECURSIVEFINDFILE(Q7B dummy, Q7B Path, Q7B NameFilter, Q7B Filter, Q7B Sorting)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_LIST(NameFilter))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Filter))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Sorting))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( Q7B_FindFile( Q7B_IDQString(Path), ((Q7B_List*)NameFilter->ref)->toStringList(), Q7B_IDqint64(Filter), Q7B_IDqint64(Sorting), true, false, false) );
}

Q7B Q7B_DIR_LIST(Q7B dummy, Q7B Path)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QDir dir;

  dir.setPath(*((QString *) Path->ref));
    
  QFileInfoList l = dir.entryInfoList();
  QStringList ll;  

  foreach(QFileInfo f, l){

    if (f.fileName() == "." || f.fileName() == ".."){
		      ; 
		} else {
      ll << f.absoluteFilePath();
    }
  }

  return Q7B_QOBJECT( ll );
}

Q7B Q7B_DIR_RECURSIVELIST(Q7B dummy, Q7B Path)
{  
  if (Q7B_nil(Q7B_QSTRING(Path))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( Q7B_FindFile( Q7B_IDQString(Path), QStringList(), QDir::NoFilter, QDir::NoSort, true, false, false) );
}


Q7B Q7B_DIR_COPY(Q7B SourceFilePath, Q7B DestinationFilePath)
{
  if (Q7B_nil(Q7B_QSTRING(SourceFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo fi(*((QString *) SourceFilePath->ref));  

  if (fi.isDir()){
    return Q7B_QOBJECT( Q7B_copyDir(*((QString *) SourceFilePath->ref), *((QString *) DestinationFilePath->ref), true) );
  }

  return Q7B_QOBJECT( false );
}    

Q7B Q7B_DIR_MOVE(Q7B SourceFilePath, Q7B DestinationFilePath)
{
  if (Q7B_nil(Q7B_QSTRING(SourceFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(DestinationFilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo fi(*((QString *) SourceFilePath->ref));  

  if (fi.isDir()){
    QDir d;
    return Q7B_QOBJECT( d.rename(*((QString *) SourceFilePath->ref), *((QString *) DestinationFilePath->ref)) );
  }

  return Q7B_QOBJECT( false );
}    

Q7B Q7B_DIR_ISDIR(Q7B FilePath)
{
  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_QOBJECT( QFileInfo( *((QString *) FilePath->ref)).isDir() );
}    

Q7B Q7B_DIR_DATETIMECREATED(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.created().toString("yyyy-MM-dd hh:mm:ss") );      
  return Q7B_QOBJECT( "" );
}

Q7B Q7B_DIR_DATETIMEUPDATED(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.lastModified().toString("yyyy-MM-dd hh:mm:ss") );      
  return Q7B_QOBJECT( "" );
}

Q7B Q7B_DIR_DATETIMEREAD(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.lastRead().toString("yyyy-MM-dd hh:mm:ss") );      
  return Q7B_QOBJECT( "" );
}

Q7B Q7B_DIR_WITHNATIVESEPARATORS(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QDir::toNativeSeparators(Q7B_IDQString(FileName)) );
}

Q7B Q7B_DIR_WITHOUTNATIVESEPARATORS(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QDir::fromNativeSeparators(Q7B_IDQString(FileName)) );
}

Q7B Q7B_DIR_OWNER(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.owner() );      
  return Q7B_QOBJECT( "" );
}

Q7B Q7B_DIR_GROUP(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.group() );      
  return Q7B_QOBJECT( "" );
}

Q7B Q7B_DIR_SYMLINKTARGET(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.symLinkTarget() );      
  return Q7B_QOBJECT( false );
}

Q7B Q7B_DIR_ISRELATIVE(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.isRelative() );      
  return Q7B_QOBJECT( false );
}

Q7B Q7B_DIR_ISSYMLINK(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.isSymLink() );      
  return Q7B_QOBJECT( false );
}

Q7B Q7B_DIR_ISREADABLE(Q7B dummy, Q7B FileName, Q7B Who)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Who))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWho = Q7B_IDQString(Who);
  if (sWho.isEmpty() || sWho.contains("User", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.isReadable() );      
  } else if (sWho.contains("Owner", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::ReadOwner) );   
  } else if (sWho.contains("Group", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::ReadGroup) );   
  } else if (sWho.contains("Other", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::ReadOther) );   
  }
  return Q7B_QOBJECT( false );
}

Q7B Q7B_DIR_ISWRITABLE(Q7B dummy, Q7B FileName, Q7B Who)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Who))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWho = Q7B_IDQString(Who);
  if (sWho.isEmpty() || sWho.contains("User", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.isWritable() );      
  } else if (sWho.contains("Owner", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::WriteOwner) );   
  } else if (sWho.contains("Group", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::WriteGroup) );   
  } else if (sWho.contains("Other", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::WriteOther) );   
  }
  return Q7B_QOBJECT( false );
}

Q7B Q7B_DIR_ISEXECUTABLE(Q7B dummy, Q7B FileName, Q7B Who)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Who))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWho = Q7B_IDQString(Who);
  if (sWho.isEmpty() || sWho.contains("User", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.isExecutable() );      
  } else if (sWho.contains("Owner", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::ExeOwner) );   
  } else if (sWho.contains("Group", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::ExeGroup) );   
  } else if (sWho.contains("Other", Qt::CaseInsensitive)){
    QFileInfo f(Q7B_IDQString(FileName));
    if (f.exists()) return Q7B_QOBJECT( f.permission(QFile::ExeOther) );   
  }
  return Q7B_QOBJECT( false );
}

Q7B Q7B_DIR_ISHIDDEN(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.isHidden() );      
  return Q7B_QOBJECT( false );
}

Q7B Q7B_DIR_DRIVES()
{
  QFileInfoList l = QDir::drives();

  Q7B_List *a = new Q7B_List();
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

  for (int i = 0; i < l.size(); i++){
     a->append(Q7B_QOBJECT( l.at(i).absoluteFilePath()));
  }

  return q;
}     

Q7B Q7B_DIR_BUNDLENAME(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.bundleName() );      
  return Q7B_QOBJECT( false );
}

Q7B Q7B_DIR_ISROOT(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.isRoot() );      
  return Q7B_QOBJECT( false );
}

Q7B Q7B_DIR_ISBUNDLE(Q7B dummy, Q7B FileName)
{  
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QFileInfo f(Q7B_IDQString(FileName));
  if (f.exists()) return Q7B_QOBJECT( f.isBundle() );      
  return Q7B_QOBJECT( false );
}



Q7B Q7B_idOPENFILEDIALOG = Q7B_idnil;

Q7B Q7B_OPENFILEDIALOG_GETFILE(Q7B dummy)
{  
  return Q7B_QOBJECT( QFileDialog::getOpenFileName(qApp->focusWidget()) );
}

Q7B Q7B_OPENFILEDIALOG_GETFILE2(Q7B dummy, Q7B WindowTitle, Q7B Directory, Q7B Filter)
{  
  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Directory))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Filter))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QFileDialog::getOpenFileName(qApp->focusWidget(), *((QString *) WindowTitle->ref), *((QString *) Directory->ref), *((QString *) Filter->ref)) );
}

Q7B Q7B_OPEFILENDIALOG_GETFILES(Q7B dummy)
{  
  return Q7B_QOBJECT( QFileDialog::getOpenFileNames(qApp->focusWidget()) );
}

Q7B Q7B_OPENFILEDIALOG_GETFILES2(Q7B dummy, Q7B WindowTitle, Q7B Directory, Q7B Filter)
{  
  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Directory))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Filter))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QFileDialog::getOpenFileNames(qApp->focusWidget(), *((QString *) WindowTitle->ref), *((QString *) Directory->ref), *((QString *) Filter->ref)) );
}

Q7B Q7B_OPENFILEDIALOG_GETDIRECTORY(Q7B dummy)
{  
  return Q7B_QOBJECT( QFileDialog::getExistingDirectory(qApp->focusWidget()) );
}

Q7B Q7B_OPENFILEDIALOG_GETDIRECTORY2(Q7B dummy, Q7B WindowTitle, Q7B Directory)
{  
  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Directory))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QFileDialog::getExistingDirectory(qApp->focusWidget(), *((QString *) WindowTitle->ref), *((QString *) Directory->ref)) );
}



Q7B Q7B_idSAVEFILEDIALOG = Q7B_idnil;

Q7B Q7B_SAVEFILEDIALOG_GETFILE(Q7B dummy)
{  
  return Q7B_QOBJECT( QFileDialog::getSaveFileName(qApp->focusWidget()) );
}

Q7B Q7B_SAVEFILEDIALOG_GETFILE2(Q7B dummy, Q7B WindowTitle, Q7B Directory, Q7B Filter)
{  
  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Directory))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Filter))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QFileDialog::getSaveFileName(qApp->focusWidget(), *((QString *) WindowTitle->ref), *((QString *) Directory->ref), *((QString *) Filter->ref)) );
}

Q7B Q7B_SAVEFILEDIALOG_GETDIRECTORY(Q7B dummy)
{  
  return Q7B_QOBJECT( QFileDialog::getExistingDirectory(qApp->focusWidget()) );
}

Q7B Q7B_SAVEFILEDIALOG_GETDIRECTORY2(Q7B dummy, Q7B WindowTitle, Q7B Directory)
{  
  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Directory))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QFileDialog::getExistingDirectory(qApp->focusWidget(), *((QString *) WindowTitle->ref), *((QString *) Directory->ref)) );
}



Q7B Q7B_idCOLORDIALOG = Q7B_idnil;

Q7B Q7B_COLORDIALOG_GETCOLOR(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idCOLORDIALOG)){ Q7B_idCOLORDIALOG = Q7B(new Q7B_id(typeid(Q7B_ColorDialog).name(), new Q7B_ColorDialog())); }

  return Q7B_QOBJECT( ((Q7B_ColorDialog *) Q7B_idCOLORDIALOG->ref)->GetColor() );
}

Q7B Q7B_COLORDIALOG_RED(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idCOLORDIALOG)){ Q7B_idCOLORDIALOG = Q7B(new Q7B_id(typeid(Q7B_ColorDialog).name(), new Q7B_ColorDialog())); }

  return Q7B_QOBJECT( ((Q7B_ColorDialog *) Q7B_idCOLORDIALOG->ref)->Red() );
}

Q7B Q7B_COLORDIALOG_GREEN(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idCOLORDIALOG)){ Q7B_idCOLORDIALOG = Q7B(new Q7B_id(typeid(Q7B_ColorDialog).name(), new Q7B_ColorDialog())); }

  return Q7B_QOBJECT( ((Q7B_ColorDialog *) Q7B_idCOLORDIALOG->ref)->Green() );
}

Q7B Q7B_COLORDIALOG_BLUE(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idCOLORDIALOG)){ Q7B_idCOLORDIALOG = Q7B(new Q7B_id(typeid(Q7B_ColorDialog).name(), new Q7B_ColorDialog())); }

  return Q7B_QOBJECT( ((Q7B_ColorDialog *) Q7B_idCOLORDIALOG->ref)->Blue() );
}

Q7B Q7B_COLORDIALOG_ALPHA(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idCOLORDIALOG)){ Q7B_idCOLORDIALOG = Q7B(new Q7B_id(typeid(Q7B_ColorDialog).name(), new Q7B_ColorDialog())); }

  return Q7B_QOBJECT( ((Q7B_ColorDialog *) Q7B_idCOLORDIALOG->ref)->Alpha() );
}

Q7B Q7B_COLORDIALOG_GETCOLOR2(Q7B dummy, Q7B Red, Q7B Green, Q7B Blue, Q7B Alpha)
{  
  if (Q7B_nil(Q7B_idCOLORDIALOG)){ Q7B_idCOLORDIALOG = Q7B(new Q7B_id(typeid(Q7B_ColorDialog).name(), new Q7B_ColorDialog())); }

  if (Q7B_nil(Q7B_INTEGER(Red))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Green))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Blue))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Alpha))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ColorDialog *) Q7B_idCOLORDIALOG->ref)->GetColorLike( Q7B_IDqint64(Red), Q7B_IDqint64(Green), Q7B_IDqint64(Blue), Q7B_IDqint64(Alpha) ) );
}



Q7B Q7B_idFONTDIALOG = Q7B_idnil;

Q7B Q7B_FONTDIALOG_GETFONT(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idFONTDIALOG)){ Q7B_idFONTDIALOG = Q7B(new Q7B_id(typeid(Q7B_FontDialog).name(), new Q7B_FontDialog())); }

  return Q7B_QOBJECT( ((Q7B_FontDialog *) Q7B_idFONTDIALOG->ref)->GetFont() );
}

Q7B Q7B_FONTDIALOG_NAME(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idFONTDIALOG)){ Q7B_idFONTDIALOG = Q7B(new Q7B_id(typeid(Q7B_FontDialog).name(), new Q7B_FontDialog())); }

  return Q7B_QOBJECT( ((Q7B_FontDialog *) Q7B_idFONTDIALOG->ref)->Name() );
}

Q7B Q7B_FONTDIALOG_SIZE(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idFONTDIALOG)){ Q7B_idFONTDIALOG = Q7B(new Q7B_id(typeid(Q7B_FontDialog).name(), new Q7B_FontDialog())); }

  return Q7B_QOBJECT( ((Q7B_FontDialog *) Q7B_idFONTDIALOG->ref)->Size() );
}

Q7B Q7B_FONTDIALOG_ITALIC(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idFONTDIALOG)){ Q7B_idFONTDIALOG = Q7B(new Q7B_id(typeid(Q7B_FontDialog).name(), new Q7B_FontDialog())); }

  return Q7B_QOBJECT( ((Q7B_FontDialog *) Q7B_idFONTDIALOG->ref)->Italic() );
}

Q7B Q7B_FONTDIALOG_BOLD(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idFONTDIALOG)){ Q7B_idFONTDIALOG = Q7B(new Q7B_id(typeid(Q7B_FontDialog).name(), new Q7B_FontDialog())); }

  return Q7B_QOBJECT( ((Q7B_FontDialog *) Q7B_idFONTDIALOG->ref)->Bold() );
}

Q7B Q7B_FONTDIALOG_UNDERLINE(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idFONTDIALOG)){ Q7B_idFONTDIALOG = Q7B(new Q7B_id(typeid(Q7B_FontDialog).name(), new Q7B_FontDialog())); }

  return Q7B_QOBJECT( ((Q7B_FontDialog *) Q7B_idFONTDIALOG->ref)->Underline() );
}

Q7B Q7B_FONTDIALOG_GETFONT2(Q7B dummy, Q7B Name, Q7B Size, Q7B Italic, Q7B Bold, Q7B Underline)
{  
  if (Q7B_nil(Q7B_idFONTDIALOG)){ Q7B_idFONTDIALOG = Q7B(new Q7B_id(typeid(Q7B_FontDialog).name(), new Q7B_FontDialog())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Size))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Italic))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Bold))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Underline))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_FontDialog *) Q7B_idFONTDIALOG->ref)->GetFontLike( Q7B_IDQString(Name), Q7B_IDqint64(Size), Q7B_IDbool(Italic), Q7B_IDbool(Bold), Q7B_IDbool(Underline) ) );
}



Q7B Q7B_idPROGRESSDIALOG = Q7B_idnil;

void Q7B_PROGRESSDIALOG_SHOW(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Show();
}

void Q7B_PROGRESSDIALOG_HIDE(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Hide();
}

void Q7B_PROGRESSDIALOG_SHOW2(Q7B dummy, Q7B WindowTitle, Q7B CancelText)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->ShowWith( Q7B_IDQString(WindowTitle), Q7B_IDQString(CancelText) );
}

Q7B Q7B_PROGRESSDIALOG_CANCELED(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  return Q7B_QOBJECT( ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Canceled() );
}

void Q7B_PROGRESSDIALOG_WINDOWTITLE(Q7B dummy, Q7B _WindowTitle)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  if (Q7B_nil(Q7B_QSTRING(_WindowTitle))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->WindowTitle = Q7B_IDQString(_WindowTitle);
}

Q7B Q7B_PROGRESSDIALOG_WINDOWTITLE(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  return Q7B_QOBJECT( ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->WindowTitle );
}

void Q7B_PROGRESSDIALOG_CANCELTEXT(Q7B dummy, Q7B _CancelText)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  if (Q7B_nil(Q7B_QSTRING(_CancelText))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->CancelText = Q7B_IDQString(_CancelText);
}

Q7B Q7B_PROGRESSDIALOG_CANCELTEXT(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  return Q7B_QOBJECT( ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->CancelText );
}

void Q7B_PROGRESSDIALOG_VALUE(Q7B dummy, Q7B _Value)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  if (Q7B_nil(Q7B_INTEGER(_Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Value = Q7B_IDqint64(_Value);
}

Q7B Q7B_PROGRESSDIALOG_VALUE(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  return Q7B_QOBJECT( ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Value );
}

void Q7B_PROGRESSDIALOG_MINIMUM(Q7B dummy, Q7B _Minimum)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  if (Q7B_nil(Q7B_INTEGER(_Minimum))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Minimum = Q7B_IDqint64(_Minimum);
}

Q7B Q7B_PROGRESSDIALOG_MINIMUM(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  return Q7B_QOBJECT( ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Minimum );
}

void Q7B_PROGRESSDIALOG_MAXIMUM(Q7B dummy, Q7B _Maximum)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  if (Q7B_nil(Q7B_INTEGER(_Maximum))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Maximum = Q7B_IDqint64(_Maximum);
}

Q7B Q7B_PROGRESSDIALOG_MAXIMUM(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  return Q7B_QOBJECT( ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Maximum );
}

void Q7B_PROGRESSDIALOG_WAIT(Q7B dummy, Q7B _Wait)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  if (Q7B_nil(Q7B_INTEGER(_Wait))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Wait = Q7B_IDqint64(_Wait);
}

Q7B Q7B_PROGRESSDIALOG_WAIT(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idPROGRESSDIALOG)){ Q7B_idPROGRESSDIALOG = Q7B(new Q7B_id(typeid(Q7B_ProgressDialog).name(), new Q7B_ProgressDialog())); }

  return Q7B_QOBJECT( ((Q7B_ProgressDialog *) Q7B_idPROGRESSDIALOG->ref)->Wait );
}



Q7B Q7B_idINPUTDIALOG = Q7B_idnil;


Q7B Q7B_INPUTDIALOG_GETFLOAT(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Value, Q7B Minimum, Q7B Maximum, Q7B Decimals)
{  
  if (Q7B_nil(Q7B_idINPUTDIALOG)){ Q7B_idINPUTDIALOG = Q7B(new Q7B_id(typeid(Q7B_InputDialog).name(), new Q7B_InputDialog())); }

  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_FLOAT(Value))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_FLOAT(Minimum))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_FLOAT(Maximum))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Decimals))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_InputDialog *) Q7B_idINPUTDIALOG->ref)->GetFloat( Q7B_IDQString(WindowTitle), Q7B_IDQString(Text), Q7B_IDqreal(Value), Q7B_IDqreal(Minimum), Q7B_IDqreal(Maximum), Q7B_IDqint64(Decimals) ) );
}

Q7B Q7B_INPUTDIALOG_GETINTEGER(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Value, Q7B Minimum, Q7B Maximum, Q7B Step)
{  
  if (Q7B_nil(Q7B_idINPUTDIALOG)){ Q7B_idINPUTDIALOG = Q7B(new Q7B_id(typeid(Q7B_InputDialog).name(), new Q7B_InputDialog())); }

  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Minimum))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Maximum))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Step))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_InputDialog *) Q7B_idINPUTDIALOG->ref)->GetInteger( Q7B_IDQString(WindowTitle), Q7B_IDQString(Text), Q7B_IDqreal(Value), Q7B_IDqreal(Minimum), Q7B_IDqreal(Maximum), Q7B_IDqint64(Step) ) );
}

Q7B Q7B_INPUTDIALOG_GETSTRING(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Value, Q7B EchoMode)
{  
  if (Q7B_nil(Q7B_idINPUTDIALOG)){ Q7B_idINPUTDIALOG = Q7B(new Q7B_id(typeid(Q7B_InputDialog).name(), new Q7B_InputDialog())); }

  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(EchoMode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_InputDialog *) Q7B_idINPUTDIALOG->ref)->GetString( Q7B_IDQString(WindowTitle), Q7B_IDQString(Text), Q7B_IDQString(Value), Q7B_IDqint64(EchoMode) ) );
}

Q7B Q7B_INPUTDIALOG_OK(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idINPUTDIALOG)){ Q7B_idINPUTDIALOG = Q7B(new Q7B_id(typeid(Q7B_InputDialog).name(), new Q7B_InputDialog())); }

  return Q7B_QOBJECT( ((Q7B_InputDialog *) Q7B_idINPUTDIALOG->ref)->Ok() );
}



Q7B Q7B_idDATABASE = Q7B_idnil;

Q7B Q7B_DATABASE_MYSQL(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->MySQL() );
}

Q7B Q7B_DATABASE_POSTGRESQL(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->PostgreSQL() );
}

Q7B Q7B_DATABASE_SQLITE(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->SQLite() );
}

Q7B Q7B_DATABASE_LOCALHOST(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->LocalHost() );
}

Q7B Q7B_DATABASE_DEFAULTPORT(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->DefaultPort() );
}

Q7B Q7B_DATABASE_DEFAULTOPTIONS(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->DefaultOptions() );
}

Q7B Q7B_DATABASE_SETCURRENTDATABASE(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->SetCurrentDatabase( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_SETCURRENTDATABASE(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->CurrentDatabase( ) );
}

Q7B Q7B_DATABASE_EXISTS(Q7B dummy, Q7B Driver, Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Driver))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Options))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Port))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->Exists( Q7B_IDQString(Driver), Q7B_IDQString(Name), Q7B_IDQString(User), Q7B_IDQString(Password), Q7B_IDQString(Host), Q7B_IDQString(Options), Q7B_IDQString(Port)) );
}

Q7B Q7B_DATABASE_CREATE(Q7B dummy, Q7B Driver, Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Driver))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Options))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Port))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->Create( Q7B_IDQString(Driver), Q7B_IDQString(Name), Q7B_IDQString(User), Q7B_IDQString(Password), Q7B_IDQString(Host), Q7B_IDQString(Options), Q7B_IDQString(Port)) );
}

Q7B Q7B_DATABASE_TESTCONNECTION(Q7B dummy, Q7B Driver, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Driver))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Options))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Port))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->TestConnection( Q7B_IDQString(Driver), Q7B_IDQString(User), Q7B_IDQString(Password), Q7B_IDQString(Host), Q7B_IDQString(Options), Q7B_IDQString(Port)) );
}

Q7B Q7B_DATABASE_EMPTY(Q7B dummy, Q7B Driver, Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Driver))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Options))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Port))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->Empty( Q7B_IDQString(Driver), Q7B_IDQString(Name), Q7B_IDQString(User), Q7B_IDQString(Password), Q7B_IDQString(Host), Q7B_IDQString(Options), Q7B_IDQString(Port)) );
}

Q7B Q7B_DATABASE_DROP(Q7B dummy, Q7B Driver, Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Driver))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Options))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Port))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->Drop( Q7B_IDQString(Driver), Q7B_IDQString(Name), Q7B_IDQString(User), Q7B_IDQString(Password), Q7B_IDQString(Host), Q7B_IDQString(Options), Q7B_IDQString(Port)) );
}

Q7B Q7B_DATABASE_OPENSQLITE(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->OpenSQLite( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_OPEN(Q7B dummy, Q7B Driver, Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B Options, Q7B Port)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Driver))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Options))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Port))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->Open( Q7B_IDQString(Driver), Q7B_IDQString(Name), Q7B_IDQString(User), Q7B_IDQString(Password), Q7B_IDQString(Host), Q7B_IDQString(Options), Q7B_IDQString(Port)) );
}

Q7B Q7B_DATABASE_CLOSE(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->Close( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_ISOPEN(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->IsOpen( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_LASTSQLERROR(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->LastSQLError( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_LASTSQLCOMMANDS(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->LastSQLCommands( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_LASTSQLCOMMANDFAILED(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->LastSQLCommandFailed( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_ISTRANSACTIONSUPPORTED(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->IsTransactionSupported( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_TRANSACTION(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->Transaction( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_COMMIT(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->Commit( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_ROLLBACK(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->Rollback( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_TABLES(Q7B dummy, Q7B Name)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->Tables( Q7B_IDQString(Name) ) );
}

Q7B Q7B_DATABASE_DRIVERS(Q7B dummy)
{  
  if (Q7B_nil(Q7B_idDATABASE)){ Q7B_idDATABASE = Q7B(new Q7B_id(typeid(Q7B_Database).name(), new Q7B_Database())); }

  return Q7B_QOBJECT( ((Q7B_Database *) Q7B_idDATABASE->ref)->Drivers( ) );
}



Q7B Q7B_idTABLE = Q7B_idnil;


Q7B Q7B_TABLE_EXISTS(Q7B dummy, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->Exists( Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_EXISTS2(Q7B dummy, Q7B Database, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->Exists( Q7B_IDQString(Database), Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_CREATE(Q7B dummy, Q7B Table, Q7B Fields)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Fields))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->Create( Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Fields) ) );
}

Q7B Q7B_TABLE_CREATE2(Q7B dummy, Q7B Database, Q7B Table, Q7B Fields)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Fields))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->Create( Q7B_IDQString(Database), Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Fields) ) );
}

Q7B Q7B_TABLE_EMPTY(Q7B dummy, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->Empty( Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_EMPTY2(Q7B dummy, Q7B Database, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->Empty( Q7B_IDQString(Database), Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_DROP(Q7B dummy, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->Drop( Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_DROP2(Q7B dummy, Q7B Database, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->Drop( Q7B_IDQString(Database), Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_DELETE(Q7B dummy, Q7B Table, Q7B Where)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Where))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }
  
  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->Delete( Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Where) ) );
}

Q7B Q7B_TABLE_DELETE2(Q7B dummy, Q7B Database, Q7B Table, Q7B Where)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Where))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->Delete( Q7B_IDQString(Database), Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Where) ) );
}

Q7B Q7B_TABLE_UPDATE(Q7B dummy, Q7B Table, Q7B Update, Q7B Where)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Update))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Where))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->Update( Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Update), Q7B_IDQ7B_Dictionary(Where) ) );
}

Q7B Q7B_TABLE_UPDATE2(Q7B dummy, Q7B Database, Q7B Table, Q7B Update, Q7B Where)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Update))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Where))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->Update( Q7B_IDQString(Database), Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Update), Q7B_IDQ7B_Dictionary(Where) ) );
}

Q7B Q7B_TABLE_INSERT(Q7B dummy, Q7B Table, Q7B Insert)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Insert))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->Insert( Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Insert) ) );
}

Q7B Q7B_TABLE_INSERT2(Q7B dummy, Q7B Database, Q7B Table, Q7B Insert)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Insert))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->Insert( Q7B_IDQString(Database), Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Insert) ) );
}

Q7B Q7B_TABLE_FIELDNAMES(Q7B dummy, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->FieldNames( Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_FIELDNAMES2(Q7B dummy, Q7B Database, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->FieldNames( Q7B_IDQString(Database), Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_PRIMARYKEYNAME(Q7B dummy, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->PrimaryKeyName( Q7B_IDQString(Table) ) );
}

Q7B Q7B_TABLE_PRIMARYKEYNAME2(Q7B dummy, Q7B Database, Q7B Table)
{  
  if (Q7B_nil(Q7B_idTABLE)){ Q7B_idTABLE = Q7B(new Q7B_id(typeid(Q7B_Table).name(), new Q7B_Table())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Table *) Q7B_idTABLE->ref)->PrimaryKeyName( Q7B_IDQString(Database), Q7B_IDQString(Table) ) );
}



Q7B Q7B_idRECORDS = Q7B_idnil;


Q7B Q7B_RECORDS_OPEN(Q7B dummy, Q7B TableOrSql)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(TableOrSql))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->Open( Q7B_IDQString(TableOrSql) ) );
}

Q7B Q7B_RECORDS_OPEN2(Q7B dummy, Q7B Database, Q7B TableOrSql)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(TableOrSql))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->Open( Q7B_IDQString(Database), Q7B_IDQString(TableOrSql) ) );
}

Q7B Q7B_RECORDS_OPEN3(Q7B dummy, Q7B TableOrSql, Q7B Where)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(TableOrSql))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Where))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->Open( Q7B_IDQString(TableOrSql), Q7B_IDQ7B_Dictionary(Where) ) );
}

Q7B Q7B_RECORDS_OPEN4(Q7B dummy, Q7B Database, Q7B TableOrSql, Q7B Where)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(TableOrSql))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Where))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->Open( Q7B_IDQString(Database), Q7B_IDQString(TableOrSql), Q7B_IDQ7B_Dictionary(Where) ) );
}

Q7B Q7B_RECORDS_OPEN5(Q7B dummy, Q7B Table, Q7B Where, Q7B OrderBy)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Where))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(OrderBy))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->Open( Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Where), Q7B_IDQ7B_Dictionary(OrderBy) ) );
}

Q7B Q7B_RECORDS_OPEN6(Q7B dummy, Q7B Database, Q7B Table, Q7B Where, Q7B OrderBy)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(Where))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DICTIONARY(OrderBy))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->Open( Q7B_IDQString(Database), Q7B_IDQString(Table), Q7B_IDQ7B_Dictionary(Where), Q7B_IDQ7B_Dictionary(OrderBy) ) );
}

Q7B Q7B_RECORDS_CLOSE(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->Close( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_REQUERY(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->Requery( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_FIRST(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->First( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_NEXT(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->Next( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_PREVIOUS(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->Previous( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_LAST(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->Last( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_GOTO(Q7B dummy, Q7B RecordsId, Q7B Position)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->GoTo( Q7B_IDQString(RecordsId), Q7B_IDqint64(Position) ) );
}

Q7B Q7B_RECORDS_LENGTH(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->Length( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_POSITION(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->Position( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_FIELDNAMES(Q7B dummy, Q7B RecordsId)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->FieldNames( Q7B_IDQString(RecordsId) ) );
}

Q7B Q7B_RECORDS_VALUE(Q7B dummy, Q7B RecordsId, Q7B Field)
{  
  if (Q7B_nil(Q7B_idRECORDS)){ Q7B_idRECORDS = Q7B(new Q7B_id(typeid(Q7B_Records).name(), new Q7B_Records())); }

  if (Q7B_nil(Q7B_QSTRING(RecordsId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Field))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Records *) Q7B_idRECORDS->ref)->Value( Q7B_IDQString(RecordsId), Q7B_IDQString(Field) ) );
}



Q7B Q7B_idQUERY = Q7B_idnil;


Q7B Q7B_QUERY_RUN(Q7B dummy, Q7B QueryNameOrSql)
{  
  if (Q7B_nil(Q7B_idQUERY)){ Q7B_idQUERY = Q7B(new Q7B_id(typeid(Q7B_Query).name(), new Q7B_Query())); }

  if (Q7B_nil(Q7B_QSTRING(QueryNameOrSql))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Query *) Q7B_idQUERY->ref)->Run( Q7B_IDQString(QueryNameOrSql) ) );
}

Q7B Q7B_QUERY_RUN2(Q7B dummy, Q7B Database, Q7B QueryNameOrSql)
{  
  if (Q7B_nil(Q7B_idQUERY)){ Q7B_idQUERY = Q7B(new Q7B_id(typeid(Q7B_Query).name(), new Q7B_Query())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(QueryNameOrSql))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Query *) Q7B_idQUERY->ref)->Run( Q7B_IDQString(Database), Q7B_IDQString(QueryNameOrSql) ) );
}

Q7B Q7B_QUERY_COMMAND(Q7B dummy, Q7B Command)
{  
  if (Q7B_nil(Q7B_idQUERY)){ Q7B_idQUERY = Q7B(new Q7B_id(typeid(Q7B_Query).name(), new Q7B_Query())); }

  if (Q7B_nil(Q7B_QSTRING(Command))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Query *) Q7B_idQUERY->ref)->Command( Q7B_IDQString(Command) ) );
}

Q7B Q7B_QUERY_COMMAND2(Q7B dummy, Q7B Database, Q7B Command)
{  
  if (Q7B_nil(Q7B_idQUERY)){ Q7B_idQUERY = Q7B(new Q7B_id(typeid(Q7B_Query).name(), new Q7B_Query())); }

  if (Q7B_nil(Q7B_QSTRING(Database))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Command))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Query *) Q7B_idQUERY->ref)->Command( Q7B_IDQString(Database), Q7B_IDQString(Command) ) );
}



Q7B Q7B_idMESSAGEBOX = Q7B_idnil;


Q7B Q7B_MESSAGEBOX_CRITICAL(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Buttons, Q7B DefaultButton)
{  
  if (Q7B_nil(Q7B_idMESSAGEBOX)){ Q7B_idMESSAGEBOX = Q7B(new Q7B_id(typeid(Q7B_MessageBox).name(), new Q7B_MessageBox())); }

  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Buttons))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(DefaultButton))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_MessageBox *) Q7B_idMESSAGEBOX->ref)->Critical( Q7B_IDQString(WindowTitle), Q7B_IDQString(Text), Q7B_IDqint64(Buttons), Q7B_IDqint64(DefaultButton) ) );
}

Q7B Q7B_MESSAGEBOX_INFORMATION(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Buttons, Q7B DefaultButton)
{  
  if (Q7B_nil(Q7B_idMESSAGEBOX)){ Q7B_idMESSAGEBOX = Q7B(new Q7B_id(typeid(Q7B_MessageBox).name(), new Q7B_MessageBox())); }

  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Buttons))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(DefaultButton))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_MessageBox *) Q7B_idMESSAGEBOX->ref)->Information( Q7B_IDQString(WindowTitle), Q7B_IDQString(Text), Q7B_IDqint64(Buttons), Q7B_IDqint64(DefaultButton) ) );
}

Q7B Q7B_MESSAGEBOX_QUESTION(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Buttons, Q7B DefaultButton)
{  
  if (Q7B_nil(Q7B_idMESSAGEBOX)){ Q7B_idMESSAGEBOX = Q7B(new Q7B_id(typeid(Q7B_MessageBox).name(), new Q7B_MessageBox())); }

  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Buttons))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(DefaultButton))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_MessageBox *) Q7B_idMESSAGEBOX->ref)->Question( Q7B_IDQString(WindowTitle), Q7B_IDQString(Text), Q7B_IDqint64(Buttons), Q7B_IDqint64(DefaultButton) ) );
}

Q7B Q7B_MESSAGEBOX_WARNING(Q7B dummy, Q7B WindowTitle, Q7B Text, Q7B Buttons, Q7B DefaultButton)
{  
  if (Q7B_nil(Q7B_idMESSAGEBOX)){ Q7B_idMESSAGEBOX = Q7B(new Q7B_id(typeid(Q7B_MessageBox).name(), new Q7B_MessageBox())); }

  if (Q7B_nil(Q7B_QSTRING(WindowTitle))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Buttons))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(DefaultButton))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_MessageBox *) Q7B_idMESSAGEBOX->ref)->Warning( Q7B_IDQString(WindowTitle), Q7B_IDQString(Text), Q7B_IDqint64(Buttons), Q7B_IDqint64(DefaultButton) ) );
}





void Q7B_SYSTEMTRAY_CONTEXTMENU(Q7B qsystemtray, Q7B v)
{
  if (Q7B_nil(Q7B_QMENU(v))){ Q7B_EXCEPTION("QMenu expected"); return; }

  Q7B_idSYSTEMTRAY = qsystemtray;

  ((QSystemTrayIcon *) qsystemtray->ref)->setContextMenu( ((QMenu *) v->ref) );
}

Q7B Q7B_SYSTEMTRAY_CONTEXTMENU(Q7B qsystemtray)
{
  Q7B_idSYSTEMTRAY = qsystemtray;

  return Q7B_QOBJECT( ((QSystemTrayIcon *) qsystemtray->ref)->contextMenu() );
}

void Q7B_SYSTEMTRAY_ICON(Q7B qsystemtray, Q7B v)
{
  if (Q7B_nil(Q7B_QICON(v))){ Q7B_EXCEPTION("QIcon expected"); return; }

  Q7B_idSYSTEMTRAY = qsystemtray;

   QIcon icon;
  icon = *((QIcon *) v->ref);
  ((QSystemTrayIcon *) qsystemtray->ref)->setIcon( icon );
}

Q7B Q7B_SYSTEMTRAY_ICON(Q7B qsystemtray)
{  
  Q7B_idSYSTEMTRAY = qsystemtray;

  return Q7B_QOBJECT( ((QSystemTrayIcon *) qsystemtray->ref)->icon() );
}

void Q7B_SYSTEMTRAY_TOOLTIP(Q7B qsystemtray, Q7B v)
{
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  Q7B_idSYSTEMTRAY = qsystemtray;

  ((QSystemTrayIcon *) qsystemtray->ref)->setToolTip( *((QString *) v->ref) );
}

Q7B Q7B_SYSTEMTRAY_TOOLTIP(Q7B qsystemtray)
{  
  Q7B_idSYSTEMTRAY = qsystemtray;

  return Q7B_QOBJECT( ((QSystemTrayIcon *) qsystemtray->ref)->toolTip() );
}

void Q7B_SYSTEMTRAY_VISIBLE(Q7B qsystemtray, Q7B v)
{
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  Q7B_idSYSTEMTRAY = qsystemtray;

  ((QSystemTrayIcon *) qsystemtray->ref)->setVisible( *((bool *) v->ref) );
}

Q7B Q7B_SYSTEMTRAY_VISIBLE(Q7B qsystemtray)
{  
  Q7B_idSYSTEMTRAY = qsystemtray;

  return Q7B_QOBJECT( ((QSystemTrayIcon *) qsystemtray->ref)->isVisible() );
}

Q7B Q7B_SYSTEMTRAY_ISSYSTEMTRAYAVAILABLE(Q7B qsystemtray)
{  
  Q7B_idSYSTEMTRAY = qsystemtray;

  return Q7B_QOBJECT( QSystemTrayIcon::isSystemTrayAvailable() );
}

Q7B Q7B_SYSTEMTRAY_ISMESSAGEBOXSUPPORTED(Q7B qsystemtray)
{  
  Q7B_idSYSTEMTRAY = qsystemtray;

  return Q7B_QOBJECT( QSystemTrayIcon::supportsMessages() );
}

void Q7B_SYSTEMTRAY_SHOW(Q7B qsystemtray)
{
  Q7B_idSYSTEMTRAY = qsystemtray;

  ((QSystemTrayIcon *) qsystemtray->ref)->show();
}

void Q7B_SYSTEMTRAY_HIDE(Q7B qsystemtray)
{
  Q7B_idSYSTEMTRAY = qsystemtray;

  ((QSystemTrayIcon *) qsystemtray->ref)->hide();
}

void Q7B_SYSTEMTRAY_SHOWORHIDE(Q7B qsystemtray)
{
  Q7B_idSYSTEMTRAY = qsystemtray;

  ((QSystemTrayIcon *) qsystemtray->ref)->setVisible(((QSystemTrayIcon *) qsystemtray->ref)->isVisible());
}

void Q7B_SYSTEMTRAY_MESSAGEBOX(Q7B qsystemtray, Q7B Text)
{
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  Q7B_idSYSTEMTRAY = qsystemtray;

  if (((QSystemTrayIcon *) qsystemtray->ref)->icon().isNull()){
    ((QSystemTrayIcon *) qsystemtray->ref)->setIcon(qApp->windowIcon());
  }
  ((QSystemTrayIcon *) qsystemtray->ref)->show();
  ((QSystemTrayIcon *) qsystemtray->ref)->showMessage(qApp->applicationName(), *((QString *) Text->ref) );
}

void Q7B_SYSTEMTRAY_MESSAGEBOX2(Q7B qsystemtray, Q7B Title, Q7B Text)
{
  if (Q7B_nil(Q7B_QSTRING(Title))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  Q7B_idSYSTEMTRAY = qsystemtray;

  if (((QSystemTrayIcon *) qsystemtray->ref)->icon().isNull()){
    ((QSystemTrayIcon *) qsystemtray->ref)->setIcon(qApp->windowIcon());
  }
  ((QSystemTrayIcon *) qsystemtray->ref)->show();
  ((QSystemTrayIcon *) qsystemtray->ref)->showMessage( *((QString *) Title->ref), *((QString *) Text->ref) );
}

void Q7B_SYSTEMTRAY_MESSAGEBOX3(Q7B qsystemtray, Q7B Title, Q7B Text, Q7B MessageBoxIcon)
{
  if (Q7B_nil(Q7B_QSTRING(Title))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(MessageBoxIcon))){ Q7B_EXCEPTION("Integer expected"); return; }

  Q7B_idSYSTEMTRAY = qsystemtray;

  if (((QSystemTrayIcon *) qsystemtray->ref)->icon().isNull()){
    ((QSystemTrayIcon *) qsystemtray->ref)->setIcon(qApp->windowIcon());
  }
  ((QSystemTrayIcon *) qsystemtray->ref)->show();
  ((QSystemTrayIcon *) qsystemtray->ref)->showMessage( *((QString *) Title->ref), *((QString *) Text->ref), (QSystemTrayIcon::MessageIcon) *((qint64 *) MessageBoxIcon->ref) );
}

void Q7B_SYSTEMTRAY_MESSAGEBOX4(Q7B qsystemtray, Q7B Title, Q7B Text, Q7B MessageBoxIcon, Q7B TimeOut)
{
  if (Q7B_nil(Q7B_QSTRING(Title))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(MessageBoxIcon))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(TimeOut))){ Q7B_EXCEPTION("Integer expected"); return; }
 
  Q7B_idSYSTEMTRAY = qsystemtray;

  if (((QSystemTrayIcon *) qsystemtray->ref)->icon().isNull()){
    ((QSystemTrayIcon *) qsystemtray->ref)->setIcon(qApp->windowIcon());
  }
  ((QSystemTrayIcon *) qsystemtray->ref)->show();
  ((QSystemTrayIcon *) qsystemtray->ref)->showMessage( *((QString *) Title->ref), *((QString *) Text->ref), (QSystemTrayIcon::MessageIcon) *((qint64 *) MessageBoxIcon->ref), *((qint64 *) TimeOut->ref) );
}



QToolBar *Q7B_getDefaultToolBar()
{
  QWidget *cw = ((QMainWindow *) Q7B_idMAINWINDOW->ref);
  if (cw){
    QObjectList ol = cw->children();  
  
    for (int q = 0; q < ol.size(); q++){

      QToolBar *tb = qobject_cast<QToolBar *>(ol.at(q));
      if (tb){
        return tb;
      }
    }
  }
  return 0;
}

Q7B Q7B_idTOOLBAR = Q7B_idnil;

void Q7B_TOOLBAR_ADDPERMANENTWIDGET(Q7B qstatusbar, Q7B Widget, Q7B Action)
{
  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_QACTION(Action))){ Q7B_EXCEPTION("QAction expected"); return; }

  QMainWindow *mw = ((QMainWindow *) Q7B_idMAINWINDOW->ref);


  if (mw){
    
    QToolBar *tb = Q7B_getDefaultToolBar();
    if (tb){
      
      QAction *a = ((QAction *) Action->ref);

      if (a){
     
        tb->insertWidget(a, ((QWidget *) Widget->ref));
        
      }
    }
  }

}



Q7B Q7B_idSOUNDS = Q7B_idnil;


Q7B Q7B_SOUNDS_PLAY(Q7B dummy, Q7B SoundId)
{
  if (Q7B_nil(Q7B_idSOUNDS)){ Q7B_idSOUNDS = Q7B(new Q7B_id(typeid(Q7B_Sounds).name(), new Q7B_Sounds())); }

  if (Q7B_nil(Q7B_QSTRING(SoundId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Sounds *) Q7B_idSOUNDS->ref)->Play( *((QString *) SoundId->ref) ) );
}

Q7B Q7B_SOUNDS_LOAD(Q7B dummy, Q7B SoundId, Q7B FileName)
{
  if (Q7B_nil(Q7B_idSOUNDS)){ Q7B_idSOUNDS = Q7B(new Q7B_id(typeid(Q7B_Sounds).name(), new Q7B_Sounds())); }

  if (Q7B_nil(Q7B_QSTRING(SoundId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Sounds *) Q7B_idSOUNDS->ref)->Load( *((QString *) SoundId->ref), *((QString *) FileName->ref) ) );
}



Q7B Q7B_idPIXMAPS = Q7B_idnil;


Q7B Q7B_PIXMAPS_LOAD(Q7B dummy, Q7B PixmapId, Q7B FileName)
{
  if (Q7B_nil(Q7B_idPIXMAPS)){ Q7B_idPIXMAPS = Q7B(new Q7B_id(typeid(Q7B_Pixmaps).name(), new Q7B_Pixmaps())); }

  if (Q7B_nil(Q7B_QSTRING(PixmapId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Pixmaps *) Q7B_idPIXMAPS->ref)->Load( *((QString *) PixmapId->ref), *((QString *) FileName->ref) ) );
}



Q7B Q7B_idCOLORS = Q7B_idnil;


Q7B Q7B_COLORS_SET(Q7B dummy, Q7B ColorId, Q7B R, Q7B G, Q7B B, Q7B A)
{
  if (Q7B_nil(Q7B_idCOLORS)){ Q7B_idCOLORS = Q7B(new Q7B_id(typeid(Q7B_Colors).name(), new Q7B_Colors())); }

  if (Q7B_nil(Q7B_QSTRING(ColorId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(R))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(G))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(B))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(A))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Colors *) Q7B_idCOLORS->ref)->Set( *((QString *) ColorId->ref), Q7B_IDqint64(R), Q7B_IDqint64(G), Q7B_IDqint64(B), Q7B_IDqint64(A) ) );
}



Q7B Q7B_idFONTS = Q7B_idnil;


Q7B Q7B_FONTS_SET(Q7B dummy, Q7B ColorId, Q7B R, Q7B G, Q7B B, Q7B A)
{
  if (Q7B_nil(Q7B_idCOLORS)){ Q7B_idCOLORS = Q7B(new Q7B_id(typeid(Q7B_Colors).name(), new Q7B_Colors())); }

  if (Q7B_nil(Q7B_QSTRING(ColorId))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(R))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(G))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(B))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(A))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Colors *) Q7B_idCOLORS->ref)->Set( *((QString *) ColorId->ref), Q7B_IDqint64(R), Q7B_IDqint64(G), Q7B_IDqint64(B), Q7B_IDqint64(A) ) );
}



Q7B Q7B_idSTATUSBAR = Q7B_idnil;


void Q7B_STATUSBAR_CLEARMESSAGE(Q7B qstatusbar)
{
  ((QMainWindow *) Q7B_idMAINWINDOW->ref)->statusBar()->clearMessage( );
}

void Q7B_STATUSBAR_SHOWMESSAGE(Q7B qstatusbar, Q7B Message)
{
  if (Q7B_nil(Q7B_QSTRING(Message))){ Q7B_EXCEPTION("String expected"); return; }

  ((QMainWindow *) Q7B_idMAINWINDOW->ref)->statusBar()->showMessage( *((QString *) Message->ref) );
}

void Q7B_STATUSBAR_SHOWMESSAGE(Q7B qstatusbar, Q7B Message, Q7B TimeOutInMilliSeconds)
{
  if (Q7B_nil(Q7B_QSTRING(Message))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(TimeOutInMilliSeconds))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QMainWindow *) Q7B_idMAINWINDOW->ref)->statusBar()->showMessage( *((QString *) Message->ref), *((qint64 *) TimeOutInMilliSeconds->ref) );
}

void Q7B_STATUSBAR_ADDPERMANENTWIDGET(Q7B qstatusbar, Q7B Widget)
{
  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QMainWindow *) Q7B_idMAINWINDOW->ref)->statusBar()->addPermanentWidget( ((QWidget *) Widget->ref));
}






void Q7B_APPLICATION_PATH(Q7B qapplication, Q7B v)
{
}

Q7B Q7B_APPLICATION_PATH(Q7B qapplication)
{
  return Q7B_QOBJECT( qApp->applicationDirPath() );
}

void Q7B_APPLICATION_FILENAME(Q7B qapplication, Q7B v)
{
}

Q7B Q7B_APPLICATION_FILENAME(Q7B qapplication)
{
  return Q7B_QOBJECT( qApp->applicationFilePath() );
}

void Q7B_APPLICATION_PID(Q7B qapplication, Q7B v)
{
}

Q7B Q7B_APPLICATION_PID(Q7B qapplication)
{
  return Q7B_QOBJECT( qApp->applicationPid() );
}

void Q7B_APPLICATION_ARGUMENTS(Q7B qapplication, Q7B v)
{
}

Q7B Q7B_APPLICATION_ARGUMENTS(Q7B qapplication)
{
  return Q7B_QOBJECT( qApp->arguments() );
}

void Q7B_APPLICATION_APPLICATIONNAME(Q7B qapplication, Q7B v)
{
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  qApp->setApplicationName( *((QString *) v->ref) );
}

Q7B Q7B_APPLICATION_APPLICATIONNAME(Q7B qapplication)
{
  return Q7B_QOBJECT( qApp->applicationName() );
}

void Q7B_APPLICATION_APPLICATIONVERSION(Q7B qapplication, Q7B v)
{
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  qApp->setApplicationVersion( *((QString *) v->ref) );
}

Q7B Q7B_APPLICATION_APPLICATIONVERSION(Q7B qapplication)
{
  return Q7B_QOBJECT( qApp->applicationVersion() );
}

void Q7B_APPLICATION_ORGANIZATIONDOMAIN(Q7B qapplication, Q7B v)
{
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  qApp->setOrganizationDomain( *((QString *) v->ref) );
}

Q7B Q7B_APPLICATION_ORGANIZATIONDOMAIN(Q7B qapplication)
{
  return Q7B_QOBJECT( qApp->organizationDomain() );
}

void Q7B_APPLICATION_ORGANIZATIONNAME(Q7B qapplication, Q7B v)
{
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  qApp->setOrganizationName( *((QString *) v->ref) );
}

Q7B Q7B_APPLICATION_ORGANIZATIONNAME(Q7B qapplication)
{
  return Q7B_QOBJECT( qApp->organizationName() );
}

void Q7B_APPLICATION_QUIT(Q7B qapplication)
{
  
  qApp->quit();
}

void Q7B_APPLICATION_CURSORSETWAIT(Q7B qapplication)
{
  qApp->setOverrideCursor(QCursor(Qt::WaitCursor));
}

void Q7B_APPLICATION_CURSORUNSETWAIT(Q7B qapplication)
{
  qApp->restoreOverrideCursor();
}

Q7B Q7B_APPLICATION_CLIPBOARDTEXT(Q7B qapplication)
{
  QClipboard *p = qApp->clipboard();
  return Q7B_QOBJECT( p->text() );
}

Q7B Q7B_APPLICATION_QTVERSION(Q7B qapplication)
{
  return Q7B_QOBJECT( qVersion() );
}

Q7B Q7B_APPLICATION_OPERATINGSYSTEMNAME(Q7B qapplication)
{
#ifdef Q_OS_WIN32
  return Q7B_QOBJECT( "Windows" );
#endif

#ifdef Q_WS_MAC
  return Q7B_QOBJECT( "Mac OS X" );
#endif

#ifdef Q_WS_X11
  return Q7B_QOBJECT( "X11" );
#endif  

  return Q7B_QOBJECT( "Unspecified" );
}

void Q7B_APPLICATION_SETDEFAULTWINDOWICON(Q7B qapplication, Q7B Icon)
{ 
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return; }
  
  qApp->setWindowIcon( *((QIcon *) Icon->ref) );
  
}

void Q7B_APPLICATION_CLOSEALLWINDOWS(Q7B qapplication)
{
  qApp->closeAllWindows();
}

Q7B Q7B_APPLICATION_ISRIGHTTOLEFTLAYOUTDIRECTION(Q7B qapplication)
{
  return Q7B_QOBJECT( qApp->layoutDirection() == Qt::RightToLeft );
}


Q7B Q7B_APPLICATION_FOCUSWINDOW(Q7B qapplication)
{
  return Q7B_QOBJECT( qApp->activeWindow() );
}

Q7B Q7B_APPLICATION_FOCUS(Q7B qapplication)
{
  return Q7B_QOBJECT( qApp->focusWidget() );
}

Q7B Q7B_APPLICATION_AVAILABLEMIMETYPES(Q7B qapplication)
{ 
  return Q7B_QOBJECT( "" );
}

Q7B Q7B_APPLICATION_AVAILABLELANGUAGES(Q7B qapplication)
{ 
  return Q7B_QOBJECT( "" );
}

void Q7B_APPLICATION_ABOUTQT(Q7B qapplication)
{
  qApp->aboutQt();
}

void Q7B_APPLICATION_SETQUITONLASTWINDOWCLOSED(Q7B qapplication, Q7B Quit)
{
  if (Q7B_nil(Q7B_BOOLEAN(Quit))){ Q7B_EXCEPTION("Boolean expected"); return; }

  qApp->setQuitOnLastWindowClosed( *((bool *) Quit->ref) );
}

void Q7B_APPLICATION_SETSTYLE(Q7B qapplication, Q7B Quit)
{ 
  
}

void Q7B_APPLICATION_SETSTYLESHEET(Q7B qapplication, Q7B Quit)
{ 


}

void Q7B_APPLICATION_SETRIGHTTOLEFTLAYOUTDIRECTION(Q7B qapplication, Q7B Quit)
{
  if (Q7B_nil(Q7B_BOOLEAN(Quit))){ Q7B_EXCEPTION("Boolean expected"); return; }

  qApp->setLayoutDirection( *((bool *) Quit->ref) ? Qt::RightToLeft : Qt::LeftToRight );
}

Q7B Q7B_APPLICATION_LOADPROJECTFILEASSTRING(Q7B qapplication, Q7B FileName)
{ 
  return Q7B_QOBJECT( "" );
}

Q7B Q7B_APPLICATION_LOADPROJECTFILEASDATA(Q7B qapplication, Q7B FileName)
{ 
  return Q7B_QOBJECT( "" );
}

Q7B Q7B_APPLICATION_LOADURLASSTRING(Q7B qapplication, Q7B FileName)
{ 
  return Q7B_QOBJECT( "" );
}

Q7B Q7B_APPLICATION_LOADURLASDATA(Q7B qapplication, Q7B FileName)
{ 
  return Q7B_QOBJECT( "" );
}

void Q7B_APPLICATION_SETCLIPBOARDTEXT(Q7B qapplication, Q7B Text)
{ 
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  static QString sBuffer;
  sBuffer = *((QString *) Text->ref);
  QClipboard *p = qApp->clipboard();
  p->setText(sBuffer);
}

Q7B Q7B_APPLICATION_ISMIMETYPEAVAILABLE(Q7B qapplication, Q7B MimeTyp)
{ 
  return Q7B_QOBJECT( "" );
}

void Q7B_APPLICATION_SETLANGUAGE(Q7B qapplication, Q7B Language)
{ 
  
}

void Q7B_APPLICATION_SETCOUNTRY(Q7B qapplication, Q7B Language)
{ 
  
}

Q7B Q7B_APPLICATION_TAKESCREENSHOT(Q7B qapplication)
{ 
  
  return Q7B_QOBJECT( "" );
}

Q7B Q7B_APPLICATION_STANDARDOPERATINGSYSTEMICON(Q7B qapplication)
{ 
  return Q7B_QOBJECT( "" );
}

Q7B Q7B_APPLICATION_AVAILABLEFONTNAMES(Q7B qapplication)
{ 
  return Q7B_QOBJECT( "" );
}

void Q7B_APPLICATION_PRINTHTML(Q7B qapplication, Q7B Html)
{ 
  if (Q7B_nil(Q7B_QSTRING(Html))){ Q7B_EXCEPTION("String expected"); return; }

  QTextDocument *document = new QTextDocument();
  document->setHtml( *((QString *) Html->ref) );
  QPrinter printer;
  QPrintDialog *dialog = new QPrintDialog(&printer, qApp->activeWindow());
  if (dialog->exec() != QDialog::Accepted){
     delete document;     
     return;
  }
  document->print(&printer);
  delete document;     
}

void Q7B_APPLICATION_WRITEHTMLASPDF(Q7B qapplication, Q7B Html, Q7B PDFFilePath)
{ 
  if (Q7B_nil(Q7B_QSTRING(Html))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(PDFFilePath))){ Q7B_EXCEPTION("String expected"); return; }

  QTextDocument *document = new QTextDocument();
  document->setHtml( *((QString *) Html->ref) );
  QPrinter printer;
  printer.setOutputFormat(QPrinter::PdfFormat);
  printer.setOutputFileName( *((QString *) PDFFilePath->ref) );

  QPrintDialog *dialog = new QPrintDialog(&printer, qApp->activeWindow());
  if (dialog->exec() != QDialog::Accepted){
     delete document;     
     return;
  }
  document->print(&printer);
  delete document;     
}

Q7B Q7B_APPLICATION_DOWNLOADURLASFILE(Q7B qapplication, Q7B URL, Q7B DestinationPath)
{ 
  if (Q7B_nil(Q7B_QSTRING(URL))){ Q7B_EXCEPTION("String expected"); return Q7B_QOBJECT( false ); }
  if (Q7B_nil(Q7B_QSTRING(DestinationPath))){ Q7B_EXCEPTION("String expected"); return Q7B_QOBJECT( false ); }
  
  

  return Q7B_QOBJECT( false );
}

void Q7B_APPLICATION_ALERT(Q7B qapplication, Q7B Widget, Q7B MSec)
{ 
  
}

Q7B Q7B_APPLICATION_WIDGETAT(Q7B qapplication, Q7B X, Q7B Y)
{ 
  
  return Q7B_QOBJECT( "" );
}






Q7B Q7B_QBUTTONGROUP_INIT(QObject *parent, const char *objectName)
{
  QButtonGroup *o = new QButtonGroup( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QButtonGroup).name(), o)); 
  return q;
}

void Q7B_QBUTTONGROUP_EXCLUSIVE(Q7B qbuttongroup, Q7B v)
{
  if (Q7B_nil(qbuttongroup)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QBUTTONGROUP(qbuttongroup))){ Q7B_EXCEPTION("QButtonGroup expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QButtonGroup *) qbuttongroup->ref)->setExclusive( *((bool *) v->ref) );
}

Q7B Q7B_QBUTTONGROUP_EXCLUSIVE(Q7B qbuttongroup)
{
  if (Q7B_nil(qbuttongroup)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QBUTTONGROUP(qbuttongroup))){ Q7B_EXCEPTION("QButtonGroup expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QButtonGroup *) qbuttongroup->ref)->exclusive() );
}

void Q7B_QBUTTONGROUP_ADDBUTTON(Q7B qbuttongroup, Q7B v)
{
  if (Q7B_nil(qbuttongroup)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QBUTTONGROUP(qbuttongroup))){ Q7B_EXCEPTION("QButtonGroup expected"); return; }
  if (Q7B_nil(Q7B_QABSTRACTBUTTON(v))){ Q7B_EXCEPTION("QAbstractButton expected"); return; }

  ((QButtonGroup *) qbuttongroup->ref)->addButton( ((QAbstractButton *) v->ref) );
}





void Q7B_QABSTRACTBUTTON_TEXT(Q7B qabstractbutton, Q7B v)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

 

  ((QAbstractButton *) qabstractbutton->ref)->setText( *((QString *) v->ref) );
}

Q7B Q7B_QABSTRACTBUTTON_TEXT(Q7B qabstractbutton)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QAbstractButton *) qabstractbutton->ref)->text() );
}

void Q7B_COMMANDBUTTON_CAPTION(Q7B qabstractbutton, Q7B v)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

 

  ((QAbstractButton *) qabstractbutton->ref)->setText( *((QString *) v->ref) );
}

Q7B Q7B_COMMANDBUTTON_CAPTION(Q7B qabstractbutton)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QAbstractButton *) qabstractbutton->ref)->text() );
}

void Q7B_QABSTRACTBUTTON_ICON(Q7B qabstractbutton, Q7B v)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return; }
  if (Q7B_nil(Q7B_QICON(v))){ Q7B_EXCEPTION("QIcon expected"); return; }

  QIcon icon;
  icon = *((QIcon *) v->ref);

   
   
  ((QAbstractButton *) qabstractbutton->ref)->setIcon( icon );
}

Q7B Q7B_QABSTRACTBUTTON_ICON(Q7B qabstractbutton)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QAbstractButton *) qabstractbutton->ref)->icon() );
}

void Q7B_QABSTRACTBUTTON_CHECKED(Q7B qabstractbutton, Q7B v)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QAbstractButton *) qabstractbutton->ref)->setChecked( *((bool *) v->ref) );
}

Q7B Q7B_QABSTRACTBUTTON_CHECKED(Q7B qabstractbutton)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QAbstractButton *) qabstractbutton->ref)->isChecked() );
}

void Q7B_QABSTRACTBUTTON_CHECKABLE(Q7B qabstractbutton, Q7B v)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QAbstractButton *) qabstractbutton->ref)->setCheckable( *((bool *) v->ref) );
}

Q7B Q7B_QABSTRACTBUTTON_CHECKABLE(Q7B qabstractbutton)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QAbstractButton *) qabstractbutton->ref)->isCheckable() );
}

void Q7B_QABSTRACTBUTTON_KEY(Q7B qabstractbutton, Q7B v)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  QAbstractButton *ab = ((QAbstractButton *) qabstractbutton->ref);

  QString n = *((QString *) v->ref);

  if (n.compare("HelpContents", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::HelpContents);
  else if (n.compare("WhatsThis", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::WhatsThis);
  else if (n.compare("Open", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Open);
  else if (n.compare("Close", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Close);
  else if (n.compare("Save", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Save);
  else if (n.compare("New", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::New);
  else if (n.compare("Delete", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Delete);
  else if (n.compare("Cut", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Cut);
  else if (n.compare("Copy", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Copy);
  else if (n.compare("Paste", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Paste);
  else if (n.compare("Undo", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Undo);
  else if (n.compare("Redo", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Redo);
  else if (n.compare("Back", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Back);
  else if (n.compare("Forward", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Forward);
  else if (n.compare("Refresh", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Refresh);
  else if (n.compare("ZoomIn", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::ZoomIn);
  else if (n.compare("ZoomOut", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::ZoomOut);
  else if (n.compare("Print", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Print);
  else if (n.compare("AddTab", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::AddTab);
  else if (n.compare("NextChild", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::NextChild);
  else if (n.compare("PreviousChild", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::PreviousChild);
  else if (n.compare("Find", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Find);
  else if (n.compare("FindNext", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::FindNext);
  else if (n.compare("FindPrevious", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::FindPrevious);
  else if (n.compare("Replace", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Replace);
  else if (n.compare("SelectAll", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectAll);
  else if (n.compare("Bold", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Bold);
  else if (n.compare("Italic", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Italic);
  else if (n.compare("Underline", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::Underline);
  else if (n.compare("MoveToNextChar", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToNextChar);
  else if (n.compare("MoveToPreviousChar", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToPreviousChar);
  else if (n.compare("MoveToNextWord", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToNextWord);
  else if (n.compare("MoveToPreviousWord", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToPreviousWord);
  else if (n.compare("MoveToNextLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToNextLine);
  else if (n.compare("MoveToPreviousLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToPreviousLine);
  else if (n.compare("MoveToNextPage", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToNextPage);
  else if (n.compare("MoveToPreviousPage", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToPreviousPage);
  else if (n.compare("MoveToStartOfLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToStartOfLine);
  else if (n.compare("MoveToEndOfLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToEndOfLine);
  else if (n.compare("MoveToStartOfBlock", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToStartOfBlock);
  else if (n.compare("MoveToEndOfBlock", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToEndOfBlock);
  else if (n.compare("MoveToStartOfDocument", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToStartOfDocument);
  else if (n.compare("MoveToEndOfDocument", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::MoveToEndOfDocument);
  else if (n.compare("SelectNextChar", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectNextChar);
  else if (n.compare("SelectPreviousChar", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectPreviousChar);
  else if (n.compare("SelectNextWord", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectNextWord);
  else if (n.compare("SelectPreviousWord", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectPreviousWord);
  else if (n.compare("SelectNextLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectNextLine);
  else if (n.compare("SelectPreviousLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectPreviousLine);
  else if (n.compare("SelectNextPage", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectNextPage);
  else if (n.compare("SelectPreviousPage", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectPreviousPage);
  else if (n.compare("SelectStartOfLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectStartOfLine);
  else if (n.compare("SelectEndOfLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectEndOfLine);
  else if (n.compare("SelectStartOfBlock", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectStartOfBlock);
  else if (n.compare("SelectEndOfBlock", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectEndOfBlock);
  else if (n.compare("SelectStartOfDocument", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectStartOfDocument);
  else if (n.compare("SelectEndOfBlock", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectEndOfBlock);
  else if (n.compare("SelectStartOfDocument", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectStartOfDocument);
  else if (n.compare("SelectEndOfDocument", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::SelectEndOfDocument);
  else if (n.compare("DeleteStartOfWord", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::DeleteStartOfWord);
  else if (n.compare("DeleteEndOfWord", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::DeleteEndOfWord);
  else if (n.compare("DeleteEndOfLine", Qt::CaseInsensitive) == 0) ab->setShortcut(QKeySequence::DeleteEndOfLine);
  
  else ab->setShortcut(QKeySequence(n));  
}

Q7B Q7B_QABSTRACTBUTTON_KEY(Q7B qabstractbutton)
{
  if (Q7B_nil(qabstractbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QABSTRACTBUTTON(qabstractbutton))){ Q7B_EXCEPTION("QAbstractButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QAbstractButton *) qabstractbutton->ref)->shortcut().toString() );
}



Q7B Q7B_QDECLARATIVEVIEW_INIT(QObject *parent, const char *objectName)
{
  
    QWidget* o = new QWidget( );
    o->setProperty("Parent", (qint64) parent);
    o->setObjectName(objectName);

    Q7B_connectSlotsByName((QObject *) o, parent);

    Q7B q (new Q7B_id(typeid(QWidget).name(), o)); 
    return q;
 
}



Q7B Q7B_QDIAL_INIT(QObject *parent, const char *objectName)
{
  QDial* o = new QDial( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QDial).name(), o)); 
  return q;
}



Q7B Q7B_QFONTCOMBOBOX_INIT(QObject *parent, const char *objectName)
{
  QFontComboBox* o = new QFontComboBox( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QFontComboBox).name(), o)); 
  return q;
}



Q7B Q7B_QFRAME_INIT(QObject *parent, const char *objectName)
{
  QFrame* o = new QFrame( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QFrame).name(), o)); 
  return q;
}



Q7B Q7B_QTOOLBOX_INIT(QObject *parent, const char *objectName)
{
  QToolBox* o = new QToolBox( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QToolBox).name(), o)); 
  return q;
}



Q7B Q7B_QSCROLLAREA_INIT(QObject *parent, const char *objectName)
{
  QScrollArea* o = new QScrollArea( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QScrollArea).name(), o)); 
  return q;
}



Q7B Q7B_QGROUPBOX_INIT(QObject *parent, const char *objectName)
{
  QGroupBox* o = new QGroupBox( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QGroupBox).name(), o)); 
  return q;
}

void Q7B_QGROUPBOX_TEXT(Q7B qgroupbox, Q7B v)
{
  if (Q7B_nil(qgroupbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QGROUPBOX(qgroupbox))){ Q7B_EXCEPTION("QGroupBox expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((QGroupBox *) qgroupbox->ref)->setTitle( *((QString *) v->ref) );
}

Q7B Q7B_QGROUPBOX_TEXT(Q7B qgroupbox)
{
  if (Q7B_nil(qgroupbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QGROUPBOX(qgroupbox))){ Q7B_EXCEPTION("QGroupBox expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QGroupBox *) qgroupbox->ref)->title() );
}

void Q7B_QGROUPBOX_CAPTION(Q7B qgroupbox, Q7B v)
{
  if (Q7B_nil(qgroupbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QGROUPBOX(qgroupbox))){ Q7B_EXCEPTION("QGroupBox expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((QGroupBox *) qgroupbox->ref)->setTitle( *((QString *) v->ref) );
}

Q7B Q7B_QGROUPBOX_CAPTION(Q7B qgroupbox)
{
  if (Q7B_nil(qgroupbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QGROUPBOX(qgroupbox))){ Q7B_EXCEPTION("QGroupBox expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QGroupBox *) qgroupbox->ref)->title() );
}



Q7B Q7B_QLCDNUMBER_INIT(QObject *parent, const char *objectName)
{
  QLCDNumber* o = new QLCDNumber( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QLCDNumber).name(), o)); 
  return q;
}



Q7B Q7B_QCALENDARWIDGET_INIT(QObject *parent, const char *objectName)
{
  QCalendarWidget* o = new QCalendarWidget( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QCalendarWidget).name(), o)); 
  return q;
}



Q7B Q7B_QGRAPHICSVIEW_INIT(QObject *parent, const char *objectName)
{
  QGraphicsView* o = new QGraphicsView( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QGraphicsView).name(), o)); 
  return q;
}



Q7B Q7B_QTABLEWIDGET_INIT(QObject *parent, const char *objectName)
{
  QTableWidget* o = new QTableWidget( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);  

  Q7B q (new Q7B_id(typeid(QTableWidget).name(), o)); 
  return q;
}

void Q7B_QTABLEWIDGET_CLEARCONTENTS(Q7B qtablewidget)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }

  ((QTableWidget *) qtablewidget->ref)->clearContents();
}

void Q7B_QTABLEWIDGET_SETHORIZONTALHEADERAUTORESIZE(Q7B qtablewidget)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }

  ((QTableWidget *) qtablewidget->ref)->horizontalHeader()->setResizeMode(QHeaderView::ResizeToContents);
  ((QTableWidget *) qtablewidget->ref)->setAlternatingRowColors(true); 
}

void Q7B_QTABLEWIDGET_ROWCOUNT(Q7B qtablewidget, Q7B v)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }
  
  ((QTableWidget *) qtablewidget->ref)->setRowCount( *((qint64 *) v->ref) );
}

Q7B Q7B_QTABLEWIDGET_ROWCOUNT(Q7B qtablewidget)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QTableWidget *) qtablewidget->ref)->rowCount() );
}

void Q7B_QTABLEWIDGET_COLUMNCOUNT(Q7B qtablewidget, Q7B v)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }
  
  ((QTableWidget *) qtablewidget->ref)->setColumnCount( *((qint64 *) v->ref) );
}

Q7B Q7B_QTABLEWIDGET_COLUMNCOUNT(Q7B qtablewidget)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QTableWidget *) qtablewidget->ref)->columnCount() );
}

Q7B Q7B_QTABLEWIDGET_CURRENTROW(Q7B qtablewidget)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QTableWidget *) qtablewidget->ref)->currentRow() );
}

void Q7B_QTABLEWIDGET_SORTITEMS(Q7B qtablewidget, Q7B Column)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTableWidget *) qtablewidget->ref)->sortItems( *((qint64 *) Column->ref), Qt::DescendingOrder );
  ((QTableWidget *) qtablewidget->ref)->setColumnHidden(0, true); 
}

void Q7B_QTABLEWIDGET_REMOVEROW(Q7B qtablewidget, Q7B Row)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTableWidget *) qtablewidget->ref)->removeRow( *((qint64 *) Row->ref) );
}

Q7B Q7B_QTABLEWIDGET_ITEMTEXT(Q7B qtablewidget, Q7B Row, Q7B Column)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTableWidgetItem *twi = ((QTableWidget *) qtablewidget->ref)->item( *((qint64 *) Row->ref), *((qint64 *) Column->ref) );
  if (twi == 0) ((QTableWidget *) qtablewidget->ref)->setItem( *((qint64 *) Row->ref), *((qint64 *) Column->ref), new QTableWidgetItem() );

  return Q7B_QOBJECT( twi->text() );
}

void Q7B_QTABLEWIDGET_SETCURRENTCELL(Q7B qtablewidget, Q7B Row, Q7B Column)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTableWidget *) qtablewidget->ref)->setFocus();
  ((QTableWidget *) qtablewidget->ref)->setCurrentCell( *((qint64 *) Row->ref), *((qint64 *) Column->ref));
}

void Q7B_QTABLEWIDGET_SETITEMFONTBOLD(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B Yes)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Yes))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  QTableWidgetItem *twi = ((QTableWidget *) qtablewidget->ref)->item( *((qint64 *) Row->ref), *((qint64 *) Column->ref) );
  if (twi == 0) ((QTableWidget *) qtablewidget->ref)->setItem( *((qint64 *) Row->ref), *((qint64 *) Column->ref), new QTableWidgetItem() );

  QFont f = twi->font();
  f.setBold( Q7B_IDbool(Yes) );
  twi->setFont( f );
}

void Q7B_QTABLEWIDGET_SETITEMTEXT(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B Text)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_STRING(Text))){ Q7B_EXCEPTION("String expected"); return; }
  
  ((QTableWidget *) qtablewidget->ref)->setItem( *((qint64 *) Row->ref), *((qint64 *) Column->ref), new QTableWidgetItem( Q7B_IDQString(Text) ) );
}

void Q7B_QTABLEWIDGET_SETITEMSTEXT(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B aList)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return; }
  
  int r = *((qint64 *) Row->ref);
  int c = *((qint64 *) Column->ref);

  for (int i = 0; i < ((Q7B_List *) aList->ref)->count(); i++){    
    ((QTableWidget *) qtablewidget->ref)->setItem( r, c + i, new QTableWidgetItem( Q7B_IDQString(((Q7B_List *) aList->ref)->getObject(i)) ) );
  }
}

Q7B Q7B_QTABLEWIDGET_ITEMSELECTED(Q7B qtablewidget, Q7B Row, Q7B Column)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTableWidgetItem *twi = ((QTableWidget *) qtablewidget->ref)->item( *((qint64 *) Row->ref), *((qint64 *) Column->ref) );
  if (twi == 0) ((QTableWidget *) qtablewidget->ref)->setItem( *((qint64 *) Row->ref), *((qint64 *) Column->ref), new QTableWidgetItem() );

  return Q7B_QOBJECT( twi->isSelected() );
}

void Q7B_QTABLEWIDGET_SETITEMSELECTED(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B Yes)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Yes))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  QTableWidgetItem *twi = ((QTableWidget *) qtablewidget->ref)->item( *((qint64 *) Row->ref), *((qint64 *) Column->ref) );
  if (twi == 0) ((QTableWidget *) qtablewidget->ref)->setItem( *((qint64 *) Row->ref), *((qint64 *) Column->ref), new QTableWidgetItem() );

  twi->setSelected( (Qt::ItemFlag) Q7B_IDbool(Yes) );
}

Q7B Q7B_QTABLEWIDGET_FINDITEMINCOLUMN(Q7B qtablewidget, Q7B Text, Q7B Column, Q7B StartRow, Q7B MatchFlags)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_STRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(StartRow))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(MatchFlags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QList<QTableWidgetItem *> l = ((QTableWidget *) qtablewidget->ref)->findItems( Q7B_IDQString(Text), (Qt::MatchFlags) Q7B_IDqint64(MatchFlags) );

  if (l.count()){
    for (int i = 0; i < l.count(); i++){
      QTableWidgetItem *twi = l.at(i);

      if (twi->column() == Q7B_IDqint64(Column) && twi->row() >= Q7B_IDqint64(StartRow)){
        return Q7B_QOBJECT( (qint64) twi->row() );
      }
    }
  }

  return Q7B_QOBJECT( (qint64) -1 );
}

Q7B Q7B_QTABLEWIDGET_FINDITEMINROW(Q7B qtablewidget, Q7B Text, Q7B Row, Q7B StartColumn, Q7B MatchFlags)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_STRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(StartColumn))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(MatchFlags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QList<QTableWidgetItem *> l = ((QTableWidget *) qtablewidget->ref)->findItems( Q7B_IDQString(Text), (Qt::MatchFlags) Q7B_IDqint64(MatchFlags) );

  if (l.count()){
    for (int i = 0; i < l.count(); i++){
      QTableWidgetItem *twi = l.at(i);

      if (twi->row() == Q7B_IDqint64(Row) && twi->column() >= Q7B_IDqint64(StartColumn)){
        return Q7B_QOBJECT( (qint64) twi->column() );
      }
    }
  }

  return Q7B_QOBJECT( (qint64) -1 );
}

Q7B Q7B_QTABLEWIDGET_ITEMCHECKSTATE(Q7B qtablewidget, Q7B Row, Q7B Column)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTableWidgetItem *twi = ((QTableWidget *) qtablewidget->ref)->item( *((qint64 *) Row->ref), *((qint64 *) Column->ref) );
  if (twi == 0) ((QTableWidget *) qtablewidget->ref)->setItem( *((qint64 *) Row->ref), *((qint64 *) Column->ref), new QTableWidgetItem() );

  return Q7B_QOBJECT( (qint64) twi->checkState() );
}

void Q7B_QTABLEWIDGET_SETITEMCHECKSTATE(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B CheckState)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(CheckState))){ Q7B_EXCEPTION("Integer expected"); return; }
  
  QTableWidgetItem *twi = ((QTableWidget *) qtablewidget->ref)->item( *((qint64 *) Row->ref), *((qint64 *) Column->ref) );
  if (twi == 0) ((QTableWidget *) qtablewidget->ref)->setItem( *((qint64 *) Row->ref), *((qint64 *) Column->ref), new QTableWidgetItem() );

  twi->setCheckState( (Qt::CheckState) Q7B_IDqint64(CheckState) );
}

void Q7B_QTABLEWIDGET_SETITEMFLAGS(Q7B qtablewidget, Q7B Row, Q7B Column, Q7B Flags)
{
  if (Q7B_nil(qtablewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEWIDGET(qtablewidget))){ Q7B_EXCEPTION("QTableWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Row))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Flags))){ Q7B_EXCEPTION("String expected"); return; }
  
  QTableWidgetItem *twi = ((QTableWidget *) qtablewidget->ref)->item( *((qint64 *) Row->ref), *((qint64 *) Column->ref) );
  if (twi == 0) ((QTableWidget *) qtablewidget->ref)->setItem( *((qint64 *) Row->ref), *((qint64 *) Column->ref), new QTableWidgetItem() );

  twi->setFlags( (Qt::ItemFlag) Q7B_IDqint64(Flags) );
}



Q7B Q7B_QCOLUMNVIEW_INIT(QObject *parent, const char *objectName)
{
  QColumnView* o = new QColumnView( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QColumnView).name(), o)); 
  return q;
}



Q7B Q7B_QTABLEVIEW_INIT(QObject *parent, const char *objectName)
{
  QTableView* o = new QTableView( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QTableView).name(), o)); 
  return q;
}

void Q7B_QTABLEVIEW_SETCOLUMNWIDTH(Q7B qtableview, Q7B Column, Q7B Width)
{
  if (Q7B_nil(qtableview)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTABLEVIEW(qtableview))){ Q7B_EXCEPTION("QTableView expected"); return; }

  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Width))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTableView *) qtableview->ref)->setColumnWidth( *((qint64 *) Column->ref), *((qint64 *) Width->ref) );
}



Q7B Q7B_QTREEVIEW_INIT(QObject *parent, const char *objectName)
{
  QTreeView* o = new QTreeView( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QTreeView).name(), o)); 
  return q;
}



Q7B Q7B_QLISTVIEW_INIT(QObject *parent, const char *objectName)
{
  QListView* o = new QListView( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QListView).name(), o)); 
  return q;
}



Q7B Q7B_QDIALOGBUTTONBOX_INIT(QObject *parent, const char *objectName)
{
  QDialogButtonBox* o = new QDialogButtonBox( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QDialogButtonBox).name(), o)); 
  return q;
}



Q7B Q7B_QVBOXLAYOUT_INIT(QObject *parent, const char *objectName)
{
  QVBoxLayout* o = new QVBoxLayout( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  

  Q7B q (new Q7B_id(typeid(QVBoxLayout).name(), o)); 
  return q;
}



Q7B Q7B_QHBOXLAYOUT_INIT(QObject *parent, const char *objectName)
{
  QHBoxLayout* o = new QHBoxLayout( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  

  Q7B q (new Q7B_id(typeid(QHBoxLayout).name(), o)); 
  return q;
}



Q7B Q7B_QGRIDLAYOUT_INIT(QObject *parent, const char *objectName)
{
  QGridLayout* o = new QGridLayout( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  

  Q7B q (new Q7B_id(typeid(QGridLayout).name(), o)); 
  return q;
}



Q7B Q7B_QFORMLAYOUT_INIT(QObject *parent, const char *objectName)
{
  QFormLayout* o = new QFormLayout( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  

  Q7B q (new Q7B_id(typeid(QFormLayout).name(), o)); 
  return q;
}



Q7B Q7B_QWEBVIEW_INIT(QObject *parent, const char *objectName)
{
  QWebView* o = new QWebView( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QWebView).name(), o)); 
  return q;
}

void Q7B_QWEBVIEW_LOAD(Q7B qwebview, Q7B URL)
{
  if (Q7B_nil(qwebview)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QWEBVIEW(qwebview))){ Q7B_EXCEPTION("QWebView expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(URL))){ Q7B_EXCEPTION("String expected"); return; }

  ((QWebView *) qwebview->ref)->load( QUrl(Q7B_IDQString(URL)) );
}

void Q7B_QWEBVIEW_SETHTML(Q7B qwebview, Q7B URL)
{
  if (Q7B_nil(qwebview)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QWEBVIEW(qwebview))){ Q7B_EXCEPTION("QWebView expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(URL))){ Q7B_EXCEPTION("String expected"); return; }

  ((QWebView *) qwebview->ref)->setHtml( Q7B_IDQString(URL) );
}



Q7B Q7B_QDIALOG_INIT(QObject *parent, const char *objectName)
{
  QDialog *o = new QDialog( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QDialog).name(), o)); 
  return q;
}

void Q7B_QDIALOG_ACCEPT(Q7B qdialog)
{
  if (Q7B_nil(qdialog)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QDIALOG(qdialog))){ Q7B_EXCEPTION("QDialog expected"); return; }

  ((QDialog *) qdialog->ref)->accept();
}

void Q7B_QDIALOG_REJECT(Q7B qdialog)
{
  if (Q7B_nil(qdialog)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QDIALOG(qdialog))){ Q7B_EXCEPTION("QDialog expected"); return; }

  ((QDialog *) qdialog->ref)->reject();
}



void Q7B_QTOOLBOX_CURRENTINDEX(Q7B qtoolbox, Q7B v)
{
  if (Q7B_nil(qtoolbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QTOOLBOX(qtoolbox))){ Q7B_EXCEPTION("QToolBox expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QToolBox *) qtoolbox->ref)->setCurrentIndex( Q7B_IDqint64(v) );
}

Q7B Q7B_QTOOLBOX_CURRENTINDEX(Q7B qtoolbox)
{
  if (Q7B_nil(qtoolbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QTOOLBOX(qtoolbox))){ Q7B_EXCEPTION("QToolBox expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QToolBox *) qtoolbox->ref)->currentIndex() );
}



Q7B Q7B_QTABWIDGET_INIT(QObject *parent, const char *objectName)
{
  QTabWidget* o = new QTabWidget( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QTabWidget).name(), o)); 
  return q;
}

void Q7B_QTABWIDGET_CURRENTINDEX(Q7B qtabwidget, Q7B v)
{
  if (Q7B_nil(qtabwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QTABWIDGET(qtabwidget))){ Q7B_EXCEPTION("QTabWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTabWidget *) qtabwidget->ref)->setCurrentIndex( Q7B_IDqint64(v) );
}

Q7B Q7B_QTABWIDGET_CURRENTINDEX(Q7B qtabwidget)
{
  if (Q7B_nil(qtabwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QTABWIDGET(qtabwidget))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QTabWidget *) qtabwidget->ref)->currentIndex() );
}

Q7B Q7B_QTABWIDGET_COUNT(Q7B qtabwidget)
{
  if (Q7B_nil(qtabwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QTABWIDGET(qtabwidget))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QTabWidget *) qtabwidget->ref)->count() );
}

Q7B Q7B_QTABWIDGET_WIDGET(Q7B qtabwidget, Q7B Index)
{
  if (Q7B_nil(qtabwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QTABWIDGET(qtabwidget))){ Q7B_EXCEPTION("QTabWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QTabWidget *) qtabwidget->ref)->widget( Q7B_IDqint64(Index) ) );
}



Q7B Q7B_QSTACKEDWIDGET_INIT(QObject *parent, const char *objectName)
{
  QStackedWidget* o = new QStackedWidget( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QStackedWidget).name(), o)); 
  return q;
}

void Q7B_QSTACKEDWIDGET_CURRENTINDEX(Q7B qstackedwidget, Q7B v)
{
  if (Q7B_nil(qstackedwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QSTACKEDWIDGET(qstackedwidget))){ Q7B_EXCEPTION("QStackWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QStackedWidget *) qstackedwidget->ref)->setCurrentIndex( Q7B_IDqint64(v) );
}

Q7B Q7B_QSTACKEDWIDGET_CURRENTINDEX(Q7B qstackedwidget)
{
  if (Q7B_nil(qstackedwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QSTACKEDWIDGET(qstackedwidget))){ Q7B_EXCEPTION("QStackWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QStackedWidget *) qstackedwidget->ref)->currentIndex() );
}



Q7B Q7B_QMAINWINDOW_INIT(QObject *parent, const char *objectName)
{
  QMainWindow *o = new QMainWindow( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QMainWindow).name(), o)); 
  return q;
}



Q7B Q7B_QCOMMANDLINKBUTTON_INIT(QObject *parent, const char *objectName)
{
  QCommandLinkButton *o = new QCommandLinkButton( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QCommandLinkButton).name(), o)); 
  return q;
}

void Q7B_QCOMMANDLINKBUTTON_DESCRIPTION(Q7B qcommandlinkbutton, Q7B v)
{
  if (Q7B_nil(qcommandlinkbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QCOMMANDLINKBUTTON(qcommandlinkbutton))){ Q7B_EXCEPTION("QCommandLinkButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((QCommandLinkButton *) qcommandlinkbutton->ref)->setDescription( *((QString *) v->ref) );
}

Q7B Q7B_QCOMMANDLINKBUTTON_DESCRIPTION(Q7B qcommandlinkbutton)
{
  if (Q7B_nil(qcommandlinkbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCOMMANDLINKBUTTON(qcommandlinkbutton))){ Q7B_EXCEPTION("QCommandLinkButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QCommandLinkButton *) qcommandlinkbutton->ref)->description() );
}



Q7B Q7B_QCHECKBOX_INIT(QObject *parent, const char *objectName)
{
  QCheckBox *o = new QCheckBox( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QCheckBox).name(), o)); 
  return q;
}



Q7B Q7B_QRADIOBUTTON_INIT(QObject *parent, const char *objectName)
{
  QRadioButton *o = new QRadioButton( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QRadioButton).name(), o)); 
  return q;
}



Q7B Q7B_QPUSHBUTTON_INIT(QObject *parent, const char *objectName)
{
  QPushButton *o = new QPushButton( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QPushButton).name(), o)); 
  return q;
}

void Q7B_QPUSHBUTTON_MENU(Q7B qpushbutton, Q7B v)
{
  if (Q7B_nil(qpushbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QPUSHBUTTON(qpushbutton))){ Q7B_EXCEPTION("QPushButton expected"); return; }
  if (Q7B_nil(Q7B_QMENU(v))){ Q7B_EXCEPTION("QMenu expected"); return; }

  ((QPushButton *) qpushbutton->ref)->setMenu( ((QMenu *) v->ref) );
}

Q7B Q7B_QPUSHBUTTON_MENU(Q7B qpushbutton)
{
  if (Q7B_nil(qpushbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QPUSHBUTTON(qpushbutton))){ Q7B_EXCEPTION("QPushButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QPushButton *) qpushbutton->ref)->menu() );
}

void Q7B_QPUSHBUTTON_AUTODEFAULT(Q7B qpushbutton, Q7B v)
{
  if (Q7B_nil(qpushbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QPUSHBUTTON(qpushbutton))){ Q7B_EXCEPTION("QPushButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QPushButton *) qpushbutton->ref)->setAutoDefault( ((bool *) v->ref) );
}

Q7B Q7B_QPUSHBUTTON_AUTODEFAULT(Q7B qpushbutton)
{
  if (Q7B_nil(qpushbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QPUSHBUTTON(qpushbutton))){ Q7B_EXCEPTION("QPushButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QPushButton *) qpushbutton->ref)->autoDefault() );
}

void Q7B_QPUSHBUTTON_DEFAULT(Q7B qpushbutton, Q7B v)
{
  if (Q7B_nil(qpushbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QPUSHBUTTON(qpushbutton))){ Q7B_EXCEPTION("QPushButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QPushButton *) qpushbutton->ref)->setDefault( ((bool *) v->ref) );
}

Q7B Q7B_QPUSHBUTTON_DEFAULT(Q7B qpushbutton)
{
  if (Q7B_nil(qpushbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QPUSHBUTTON(qpushbutton))){ Q7B_EXCEPTION("QPushButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QPushButton *) qpushbutton->ref)->isDefault() );
}

void Q7B_QPUSHBUTTON_FLAT(Q7B qpushbutton, Q7B v)
{
  if (Q7B_nil(qpushbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QPUSHBUTTON(qpushbutton))){ Q7B_EXCEPTION("QPushButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QPushButton *) qpushbutton->ref)->setFlat( ((bool *) v->ref) );
}

Q7B Q7B_QPUSHBUTTON_FLAT(Q7B qpushbutton)
{
  if (Q7B_nil(qpushbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QPUSHBUTTON(qpushbutton))){ Q7B_EXCEPTION("QPushButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QPushButton *) qpushbutton->ref)->isFlat() );
}



Q7B Q7B_QOBJECT_INIT(QObject *parent, const char *objectName)
{
  QObject *o = new QObject( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QObject).name(), o)); 
  return q;
}

void Q7B_QOBJECT_OBJECTNAME(Q7B qobject, Q7B v)
{
  if (Q7B_nil(qobject)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  if (Q7B_nil(Q7B_QOBJECT(qobject))){ Q7B_EXCEPTION("QObject expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((QObject *) qobject->ref)->setObjectName( Q7B_IDQString(v) );
}

Q7B Q7B_QOBJECT_OBJECTNAME(Q7B qobject)
{
  if (Q7B_nil(qobject)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QOBJECT(qobject))){ Q7B_EXCEPTION("QObject expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QObject *) qobject->ref)->objectName() );
}

Q7B Q7B_QOBJECT_SENDER(Q7B qobject)
{
  if (Q7B_nil(qobject)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
 
  if (Q7B_nil(Q7B_QOBJECT(qobject))){ Q7B_EXCEPTION("QObject expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_QObject *) qobject->ref)->Sender() ); 
}

Q7B Q7B_QOBJECT_CHILD(Q7B qobject, Q7B Q7B_ObjectName)
{
  if (Q7B_nil(qobject)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QOBJECT(qobject))){ Q7B_EXCEPTION("QObject expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Q7B_ObjectName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString s = *((QString *) Q7B_ObjectName->ref);

  QObjectList ol = ((QObject *) qobject->ref)->children();

  for (int q = 0; q < ol.size(); q++){
     

      if (ol.at(q)->objectName() == s){

   
      return Q7B_QOBJECT( (QObject *) ol.at(q) ) ;
    }    
  }

  return Q7B_idnil;


}

Q7B Q7B_QOBJECT_CHILDREN(Q7B qobject)
{
  if (Q7B_nil(qobject)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QOBJECT(qobject))){ Q7B_EXCEPTION("QObject expected"); return Q7B_idnil; }

  QObjectList ol = ((QObject *) qobject->ref)->children();

  Q7B_List *a = new Q7B_List();
  Q7B qq (new Q7B_id(typeid(Q7B_List).name(), a)); 

  for (int i = 0; i < ol.size(); i++){     

  

    Q7B q (new Q7B_id(typeid(QObject).name(), ol.at(i) )); 
    a->me << q;    
    
  }

  return qq;
}

Q7B Q7B_Variant2id(QVariant v, bool bSQL, bool bSQLQByteArrayEncodeBase64)
{
  if (v.isValid()){
    switch(v.type()){
      case QVariant::String:
        return Q7B_QOBJECT( v.toString() );
        break;
      case QVariant::Int:
      case QVariant::LongLong:
      case QVariant::UInt:
      case QVariant::ULongLong:
        return Q7B_QOBJECT( v.toLongLong() );
        break;      
      case QVariant::Double:
        return Q7B_QOBJECT( v.toDouble() );
        break;
      case QVariant::DateTime:
        return Q7B_QOBJECT( v.toDateTime() );
        break;
      case QVariant::Bool:
        return Q7B_QOBJECT( v.toBool() );
        break;

        
      case QVariant::ByteArray:
        {
          QByteArray ba = bSQLQByteArrayEncodeBase64 ? QByteArray::fromBase64(v.toByteArray()) : v.toByteArray();

          if (bSQL){
            int n = ba.indexOf((char ) 0);
            if (n >= 0){
              QByteArray bba = ba.left(n);
              QString s(bba);
              ba = ba.mid(n);
              if (s == "QIcon"){
                return Q7B_QOBJECT(Q7B_QByteArray2QIcon(ba));
              }
              
            }
          }

          return Q7B_QOBJECT( ba );
        }
        break;      

      default:
        

      
        break;
    }
  }

  return Q7B_idnil;
}

QVariant Q7B_id2Variant(Q7B Q7B_Object, bool bSQL, bool bSQLQByteArrayEncodeBase64)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return QVariant(); }  

  
  

  if (Q7B_Object->type == typeid(qint64).name()){
    return QVariant( *((qint64 *) Q7B_Object->ref) );

  } else if (Q7B_Object->type == typeid(qreal).name()){
    return QVariant( *((qreal *) Q7B_Object->ref) );

  } else if (Q7B_Object->type == typeid(bool).name()){
    return QVariant( *((bool *) Q7B_Object->ref) );

  } else if (Q7B_Object->type == typeid(QDateTime).name()){
    return QVariant( *((QDateTime *) Q7B_Object->ref) );

  } else if (Q7B_Object->type == typeid(QString).name()){    
    return QVariant( *((QString *) Q7B_Object->ref) );

  } else if (Q7B_Object->type == typeid(QByteArray).name()){    
    QByteArray ba = *((QByteArray *) Q7B_Object->ref);

    if (bSQL) ba.prepend("QByteArray");        
    return QVariant( bSQLQByteArrayEncodeBase64 ? ba.toBase64() : ba );

  } else if (Q7B_Object->type == typeid(QIcon).name()){ 
    QByteArray ba = Q7B_QIcon2QByteArray(*((QIcon *) Q7B_Object->ref));

    if (bSQL) ba.prepend("QIcon");            
    return QVariant( bSQLQByteArrayEncodeBase64 ? ba.toBase64() : ba );
  }

  return QVariant();  
}

void Q7B_PROPERTY(Q7B qobject, QString sPropertyName, Q7B Q7B_Object)
{
  if (Q7B_nil(qobject)){ Q7B_NULLPOINTEREXCEPTION(); return; }
 
  QVariant v = Q7B_id2Variant(Q7B_Object, false, false);
  if (qobject->isQObjectBased()){
    ((QObject *) qobject->ref)->setProperty(sPropertyName.toAscii().constData(), v);
  } else {
    qobject->setProperty(sPropertyName, v);
  }
}

Q7B Q7B_PROPERTY(Q7B qobject, QString sPropertyName)
{
  if (Q7B_nil(qobject)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  QVariant v;
  if (qobject->isQObjectBased()){
    v = ((QObject *) qobject->ref)->property(sPropertyName.toAscii().constData());
  } else {
    v = qobject->property(sPropertyName);
  }
  if (v.isNull()){
    return Q7B_idnil; 
  }
  return Q7B_Variant2id(v, false, false);

}





void Q7B_LIST_REMOVEALL(Q7B aList)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return; }

  ((Q7B_List *) aList->ref)->removeAll();
}

Q7B Q7B_LIST_LENGTH(Q7B aList)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_List *) aList->ref)->count() );
}

Q7B Q7B_LIST_OBJECT(Q7B aList, Q7B Index)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_List *) aList->ref)->getObject( *((qint64 *) Index->ref) ) );
}

void Q7B_LIST_INSERT(Q7B aList, Q7B Index, Q7B Q7B_Object)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((Q7B_List *) aList->ref)->insert( Q7B_Object, *((qint64 *) Index->ref) );
}

void Q7B_LIST_SETOBJECT(Q7B aList, Q7B Index, Q7B Q7B_Object)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((Q7B_List *) aList->ref)->replace( Q7B_Object, *((qint64 *) Index->ref) );
}

void Q7B_LIST_REMOVE(Q7B aList, Q7B Index)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((Q7B_List *) aList->ref)->remove( *((qint64 *) Index->ref) );
}

void Q7B_LIST_APPEND(Q7B aList, Q7B Q7B_Object)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LIST(aList))){ Q7B_EXCEPTION("List expected"); return; }

  ((Q7B_List *) aList->ref)->append(Q7B_Object);
}





Q7B Q7B_DICTIONARY_LENGTH(Q7B aDictionary)
{
  if (Q7B_nil(aDictionary)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DICTIONARY(aDictionary))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Dictionary *) aDictionary->ref)->count() );
}

void Q7B_DICTIONARY_REMOVEALL(Q7B aDictionary)
{
  if (Q7B_nil(aDictionary)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_DICTIONARY(aDictionary))){ Q7B_EXCEPTION("Dictionary expected"); return; }

  ((Q7B_Dictionary *) aDictionary->ref)->removeAll();
}

Q7B Q7B_DICTIONARY_KEYS(Q7B aDictionary)
{
  if (Q7B_nil(aDictionary)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DICTIONARY(aDictionary))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Dictionary *) aDictionary->ref)->keys() );
}

Q7B Q7B_DICTIONARY_VALUES(Q7B aDictionary)
{
  if (Q7B_nil(aDictionary)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DICTIONARY(aDictionary))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Dictionary *) aDictionary->ref)->values() );
}

void Q7B_DICTIONARY_REMOVE(Q7B aDictionary, Q7B Key)
{
  if (Q7B_nil(aDictionary)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_DICTIONARY(aDictionary))){ Q7B_EXCEPTION("Dictionary expected"); return; }
  if (Q7B_nil(Q7B_STRING(Key))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_Dictionary *) aDictionary->ref)->remove( Q7B_IDQString(Key) );
}

Q7B Q7B_DICTIONARY_CONTAINS(Q7B aDictionary, Q7B Key)
{
  if (Q7B_nil(aDictionary)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DICTIONARY(aDictionary))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_STRING(Key))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Dictionary *) aDictionary->ref)->contains( Q7B_IDQString(Key) ) );
}

Q7B Q7B_DICTIONARY_OBJECT(Q7B aDictionary, Q7B Key)
{
  if (Q7B_nil(aDictionary)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DICTIONARY(aDictionary))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_STRING(Key))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Dictionary *) aDictionary->ref)->getObject( Q7B_IDQString(Key) ) );
}

void Q7B_DICTIONARY_SETOBJECT(Q7B aDictionary, Q7B Key, Q7B Value)
{
  if (Q7B_nil(aDictionary)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_DICTIONARY(aDictionary))){ Q7B_EXCEPTION("Dictionary expected"); return; }
  if (Q7B_nil(Q7B_STRING(Key))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_Dictionary *) aDictionary->ref)->setObject( Q7B_IDQString(Key), Value );
}



Q7B Q7B_QWIDGET_INIT(QObject *parent, const char *objectName)
{
  QWidget *o = new QWidget( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QWidget).name(), o)); 
  return q;
}

void Q7B_QWIDGET_SHOWMAXIMIZED(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) qwidget->ref)->showMaximized();
}

void Q7B_QWIDGET_SHOWFULLSCREEN(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) qwidget->ref)->showFullScreen();
}

void Q7B_QWIDGET_SHOWMINIMIZED(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) qwidget->ref)->showMinimized();
}

void Q7B_QWIDGET_TOGGLEVISIBLE(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  QWidget *w = ((QWidget *) qwidget->ref);
  w->setVisible(!w->isVisible());
}

void Q7B_QWIDGET_SETATTRIBUTE(Q7B qwidget, Q7B Attribute, Q7B On)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Attribute))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(On))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QWidget *) qwidget->ref)->setAttribute( (Qt::WidgetAttribute) *((qint64 *) Attribute->ref), *((bool *) On->ref));
}

void Q7B_QWIDGET_SHOWNORMAL(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) qwidget->ref)->showNormal();
}

void Q7B_QWIDGET_SHOW(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) qwidget->ref)->show();
}

void Q7B_QWIDGET_HIDE(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) qwidget->ref)->hide();
}

void Q7B_QWIDGET_ENABLED(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  ((QWidget *) qwidget->ref)->setEnabled( *((bool *) v->ref) );
}

Q7B Q7B_QWIDGET_ACTIONS(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  Q7B_List *a = new Q7B_List();
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

  QList<QAction *> l = ((QWidget *) qwidget->ref)->actions();

 

  for (int i = 0; i < l.size(); i++){
     a->append( Q7B_QOBJECT( l.at(i) ) );
  }



  return q;
}

Q7B Q7B_QWIDGET_ENABLED(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QWidget *) qwidget->ref)->isEnabled() );
}

void Q7B_QWIDGET_VISIBLE(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  ((QWidget *) qwidget->ref)->setVisible( *((bool *) v->ref) );
}



Q7B Q7B_QWIDGET_VISIBLE(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QWidget *) qwidget->ref)->isVisible() );
}


void Q7B_QWIDGET_MINIMUMWIDTH(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }
  
  ((QWidget *) qwidget->ref)->setMinimumWidth( *((qint64 *) v->ref) );
}

Q7B Q7B_QWIDGET_MINIMUMWIDTH(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }
  return Q7B_QOBJECT( ((QWidget *) qwidget->ref)->minimumWidth() );
}

void Q7B_QWIDGET_MAXIMUMWIDTH(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }
  
  ((QWidget *) qwidget->ref)->setMaximumWidth( *((qint64 *) v->ref) );
}

Q7B Q7B_QWIDGET_MAXIMUMWIDTH(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QWidget *) qwidget->ref)->maximumWidth() );
}

void Q7B_QWIDGET_WINDOWTITLE(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }
  
  ((QWidget *) qwidget->ref)->setWindowTitle( *((QString *) v->ref) );
}

Q7B Q7B_QWIDGET_WINDOWTITLE(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QWidget *) qwidget->ref)->windowTitle() );
}

void Q7B_QWIDGET_WINDOWICON(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_QICON(v))){ Q7B_EXCEPTION("QIcon expected"); return; }
  
  ((QWidget *) qwidget->ref)->setWindowIcon( *((QIcon *) v->ref) );
}

Q7B Q7B_QWIDGET_WINDOWICON(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QWidget *) qwidget->ref)->windowIcon() );
}

void Q7B_QWIDGET_WINDOWFLAGS(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }
  
  ((QWidget *) qwidget->ref)->setWindowFlags( (Qt::WindowFlags) *((qint64 *) v->ref) );
}

Q7B Q7B_QWIDGET_WINDOWFLAGS(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QWidget *) qwidget->ref)->windowFlags() );
}

void Q7B_QWIDGET_CONTEXTMENUPOLICY(Q7B qwidget, Q7B v)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }
  
  ((QWidget *) qwidget->ref)->setContextMenuPolicy( (Qt::ContextMenuPolicy) *((qint64 *) v->ref) );
}

Q7B Q7B_QWIDGET_CONTEXTMENUPOLICY(Q7B qwidget)
{
  if (Q7B_nil(qwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(qwidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QWidget *) qwidget->ref)->contextMenuPolicy() );
}



Q7B Q7B_QICON_INIT(Q7B v)
{
  if (v->type == typeid(QString).name()){
    return Q7B_QOBJECT( QIcon(*((QString *) v->ref)) );

  } else if (v->type == typeid(QByteArray).name()){
    return Q7B_QOBJECT( Q7B_QByteArray2QIcon(*((QByteArray *) v->ref)) );
  } else if (v->type == typeid(QIcon).name()){
    return Q7B_QOBJECT( QIcon(*((QIcon *) v->ref)) );
  } else {
    return Q7B_idnil; 
  }
}










Q7B Q7B_QDOUBLESPINBOX_INIT(QObject *parent, const char *objectName)
{
  QDoubleSpinBox* o = new QDoubleSpinBox( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QDoubleSpinBox).name(), o)); 
  return q;
}

void Q7B_QDOUBLESPINBOX_MINIMUM(Q7B qdoublespinbox, Q7B Value)
{
  if (Q7B_nil(qdoublespinbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QDOUBLESPINBOX(qdoublespinbox))){ Q7B_EXCEPTION("QDoubleSpinBox expected"); return; }
  if (Q7B_nil(Q7B_FLOAT(Value))){ Q7B_EXCEPTION("Float expected"); return; }

  ((QDoubleSpinBox *) qdoublespinbox->ref)->setMinimum( *((qreal *) Value->ref) );
}

Q7B Q7B_QDOUBLESPINBOX_MINIMUM(Q7B qdoublespinbox)
{
  if (Q7B_nil(qdoublespinbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDOUBLESPINBOX(qdoublespinbox))){ Q7B_EXCEPTION("QDoubleSpinBox expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDoubleSpinBox *) qdoublespinbox->ref)->minimum() );
}

void Q7B_QDOUBLESPINBOX_MAXIMUM(Q7B qdoublespinbox, Q7B Value)
{
  if (Q7B_nil(qdoublespinbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QDOUBLESPINBOX(qdoublespinbox))){ Q7B_EXCEPTION("QDoubleSpinBox expected"); return; }
  if (Q7B_nil(Q7B_FLOAT(Value))){ Q7B_EXCEPTION("Float expected"); return; }

  ((QDoubleSpinBox *) qdoublespinbox->ref)->setMaximum( *((qreal *) Value->ref) );
}

Q7B Q7B_QDOUBLESPINBOX_MAXIMUM(Q7B qdoublespinbox)
{
  if (Q7B_nil(qdoublespinbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDOUBLESPINBOX(qdoublespinbox))){ Q7B_EXCEPTION("QDoubleSpinBox expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDoubleSpinBox *) qdoublespinbox->ref)->maximum() );
}

void Q7B_QDOUBLESPINBOX_VALUE(Q7B qdoublespinbox, Q7B Value)
{
  if (Q7B_nil(qdoublespinbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QDOUBLESPINBOX(qdoublespinbox))){ Q7B_EXCEPTION("QDoubleSpinBox expected"); return; }
  if (Q7B_nil(Q7B_FLOAT(Value))){ Q7B_EXCEPTION("Float expected"); return; }

  ((QDoubleSpinBox *) qdoublespinbox->ref)->setValue( *((qreal *) Value->ref) );
}

Q7B Q7B_QDOUBLESPINBOX_VALUE(Q7B qdoublespinbox)
{
  if (Q7B_nil(qdoublespinbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDOUBLESPINBOX(qdoublespinbox))){ Q7B_EXCEPTION("QDoubleSpinBox expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDoubleSpinBox *) qdoublespinbox->ref)->value() );
}



Q7B Q7B_QTEXTBROWSER_INIT(QObject *parent, const char *objectName)
{
  QTextBrowser* o = new QTextBrowser( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QTextBrowser).name(), o)); 
  return q;
}



Q7B Q7B_QSLIDER_INIT(QObject *parent, const char *objectName)
{
  QSlider* o = new QSlider( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QSlider).name(), o)); 
  return q;
}



Q7B Q7B_QSCROLLBAR_INIT(QObject *parent, const char *objectName)
{
  QScrollBar* o = new QScrollBar( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QScrollBar).name(), o)); 
  return q;
}



Q7B Q7B_QDATETIMEEDIT_INIT(QObject *parent, const char *objectName)
{
  QDateTimeEdit* o = new QDateTimeEdit( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QDateTimeEdit).name(), o)); 
  return q;
}



Q7B Q7B_QDATEEDIT_INIT(QObject *parent, const char *objectName)
{
  QDateEdit* o = new QDateEdit( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QDateEdit).name(), o)); 
  return q;
}



Q7B Q7B_QTIMEEDIT_INIT(QObject *parent, const char *objectName)
{
  QTimeEdit* o = new QTimeEdit( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QTimeEdit).name(), o)); 
  return q;
}



Q7B Q7B_PHONONVOLUMESLIDER_INIT(QObject *parent, const char *objectName)
{  
  Phonon::VolumeSlider* o = new Phonon::VolumeSlider( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Phonon::VolumeSlider).name(), o)); 
  return q; 
}



Q7B Q7B_PHONONSEEKSLIDER_INIT(QObject *parent, const char *objectName)
{
  Phonon::SeekSlider* o = new Phonon::SeekSlider( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Phonon::SeekSlider).name(), o)); 
  return q;
}



Q7B Q7B_PHONONVIDEOPLAYER_INIT(QObject *parent, const char *objectName)
{
  Phonon::VideoPlayer* o = new Phonon::VideoPlayer( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Phonon::VideoPlayer).name(), o)); 
  return q;
}

void Q7B_PHONONVIDEOPLAYER_PLAY(Q7B phononvideoplayer, Q7B Value)
{
  if (Q7B_nil(phononvideoplayer)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_PHONONVIDEOPLAYER(phononvideoplayer))){ Q7B_EXCEPTION("PhononVideoPlayer expected"); return; }
  if (Q7B_nil(Q7B_STRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  static Phonon::MediaSource ms;
  ms = Phonon::MediaSource( Q7B_IDQString(Value) );
  ((Phonon::VideoPlayer *) phononvideoplayer->ref)->play( ms );  
}



Q7B Q7B_QSPINBOX_INIT(QObject *parent, const char *objectName)
{
  QSpinBox* o = new QSpinBox( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QSpinBox).name(), o)); 
  return q;
}

void Q7B_QSPINBOX_MINIMUM(Q7B qspinbox, Q7B Value)
{
  if (Q7B_nil(qspinbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QSPINBOX(qspinbox))){ Q7B_EXCEPTION("QSpinBox expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QSpinBox *) qspinbox->ref)->setMinimum( *((qint64 *) Value->ref) );
}

Q7B Q7B_QSPINBOX_MINIMUM(Q7B qspinbox)
{
  if (Q7B_nil(qspinbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSPINBOX(qspinbox))){ Q7B_EXCEPTION("QSpinBox expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QSpinBox *) qspinbox->ref)->minimum() );
}

void Q7B_QSPINBOX_MAXIMUM(Q7B qspinbox, Q7B Value)
{
  if (Q7B_nil(qspinbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QSPINBOX(qspinbox))){ Q7B_EXCEPTION("QSpinBox expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QSpinBox *) qspinbox->ref)->setMaximum( *((qint64 *) Value->ref) );
}

Q7B Q7B_QSPINBOX_MAXIMUM(Q7B qspinbox)
{
  if (Q7B_nil(qspinbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSPINBOX(qspinbox))){ Q7B_EXCEPTION("QSpinBox expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QSpinBox *) qspinbox->ref)->maximum() );
}

void Q7B_QSPINBOX_VALUE(Q7B qspinbox, Q7B Value)
{
  if (Q7B_nil(qspinbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QSPINBOX(qspinbox))){ Q7B_EXCEPTION("QSpinBox expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QSpinBox *) qspinbox->ref)->setValue( *((qint64 *) Value->ref) );
}

Q7B Q7B_QSPINBOX_VALUE(Q7B qspinbox)
{
  if (Q7B_nil(qspinbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSPINBOX(qspinbox))){ Q7B_EXCEPTION("QSpinBox expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QSpinBox *) qspinbox->ref)->value() );
}




Q7B Q7B_QPROGRESSBAR_INIT(QObject *parent, const char *objectName)
{
  QProgressBar* o = new QProgressBar( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  

  Q7B q (new Q7B_id(typeid(QProgressBar).name(), o)); 
  return q;
}

void Q7B_QPROGRESSBAR_MINIMUM(Q7B qprogressbar, Q7B Value)
{
  if (Q7B_nil(qprogressbar)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(qprogressbar))){ Q7B_EXCEPTION("QProgressBar expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QProgressBar *) qprogressbar->ref)->setMinimum( *((qint64 *) Value->ref) );
}

Q7B Q7B_QPROGRESSBAR_MINIMUM(Q7B qprogressbar)
{
  if (Q7B_nil(qprogressbar)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(qprogressbar))){ Q7B_EXCEPTION("QProgressBar expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QProgressBar *) qprogressbar->ref)->minimum() );
}

void Q7B_QPROGRESSBAR_MAXIMUM(Q7B qprogressbar, Q7B Value)
{
  if (Q7B_nil(qprogressbar)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(qprogressbar))){ Q7B_EXCEPTION("QProgressBar expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QProgressBar *) qprogressbar->ref)->setMaximum( *((qint64 *) Value->ref) );
}

Q7B Q7B_QPROGRESSBAR_MAXIMUM(Q7B qprogressbar)
{
  if (Q7B_nil(qprogressbar)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(qprogressbar))){ Q7B_EXCEPTION("QProgressBar expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QProgressBar *) qprogressbar->ref)->maximum() );
}

void Q7B_QPROGRESSBAR_VALUE(Q7B qprogressbar, Q7B Value)
{
  if (Q7B_nil(qprogressbar)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(qprogressbar))){ Q7B_EXCEPTION("QProgressBar expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QProgressBar *) qprogressbar->ref)->setValue( *((qint64 *) Value->ref) );
}

Q7B Q7B_QPROGRESSBAR_VALUE(Q7B qprogressbar)
{
  if (Q7B_nil(qprogressbar)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(qprogressbar))){ Q7B_EXCEPTION("QProgressBar expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QProgressBar *) qprogressbar->ref)->value() );
}

void Q7B_QPROGRESSBAR_TEXTVISIBLE(Q7B qprogressbar, Q7B v)
{
  if (Q7B_nil(qprogressbar)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(qprogressbar))){ Q7B_EXCEPTION("QProgressBar expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QProgressBar *) qprogressbar->ref)->setTextVisible( *((bool *) v->ref) );
}

Q7B Q7B_QPROGRESSBAR_TEXTVISIBLE(Q7B qprogressbar)
{  
  if (Q7B_nil(qprogressbar)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPROGRESSBAR(qprogressbar))){ Q7B_EXCEPTION("QProgressBar expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QProgressBar *) qprogressbar->ref)->isTextVisible() );
}




Q7B Q7B_QMDIAREA_INIT(QObject *parent, const char *objectName)
{
  QMdiArea* o = new QMdiArea( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  

  Q7B q (new Q7B_id(typeid(QMdiArea).name(), o)); 
  return q;
}

void Q7B_QMDIAREA_ADDSUBWINDOW(Q7B qmdiarea, Q7B Widget)
{
  if (Q7B_nil(qmdiarea)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QMDIAREA(qmdiarea))){ Q7B_EXCEPTION("QMdiArea expected"); return; }
  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }
  
 QMdiSubWindow  *sw = ((QMdiArea *) qmdiarea->ref)->addSubWindow( ((QWidget *) Widget->ref) );    
 sw->showNormal();

}

void Q7B_QMDIAREA_VIEWMODE(Q7B qmdiarea, Q7B Value)
{
  if (Q7B_nil(qmdiarea)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QMDIAREA(qmdiarea))){ Q7B_EXCEPTION("QMdiArea expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QMdiArea *) qmdiarea->ref)->setViewMode( (QMdiArea::ViewMode) *((qint64 *) Value->ref) );
}

Q7B Q7B_QMDIAREA_VIEWMODE(Q7B qmdiarea)
{
  if (Q7B_nil(qmdiarea)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMDIAREA(qmdiarea))){ Q7B_EXCEPTION("QMdiArea expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QMdiArea *) qmdiarea->ref)->viewMode() );
}



Q7B Q7B__QMENUBAR_INIT(QObject *parent, const char *objectName)
{
  QMenuBar* o = new QMenuBar( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QMenuBar).name(), o)); 
  return q;
}



Q7B Q7B__QTOOLBAR_INIT(QObject *parent, const char *objectName)
{
  QToolBar* o = new QToolBar( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QToolBar).name(), o)); 
  return q;
}



Q7B Q7B__QSTATUSBAR_INIT(QObject *parent, const char *objectName)
{
  QStatusBar* o = new QStatusBar( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QStatusBar).name(), o)); 
  return q;
}




Q7B Q7B__QMENU_INIT(QObject *parent, const char *objectName, Q7B v)
{
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QMenu* o = new QMenu( *((QString *) v->ref) );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  

  Q7B q (new Q7B_id(typeid(QMenu).name(), o)); 
  return q;
}

Q7B Q7B_QMENU_INIT(QObject *parent, const char *objectName)
{
  QMenu* o = new QMenu( "" );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  

  Q7B q (new Q7B_id(typeid(QMenu).name(), o)); 
  return q;
}

Q7B Q7B_QMENU_ADDACTION(Q7B qmenu, Q7B Text)
{
  if (Q7B_nil(qmenu)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMENU(qmenu))){ Q7B_EXCEPTION("QMenu expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }  

  return Q7B_QOBJECT( ((QMenu *) qmenu->ref)->addAction( *((QString *) Text->ref) ) );
}

void Q7B_QMENU_ADDACTION2(Q7B qmenu, Q7B theAction)
{
  if (Q7B_nil(qmenu)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QMENU(qmenu))){ Q7B_EXCEPTION("QMenu expected"); return; }
  if (Q7B_nil(Q7B_QACTION(theAction))){ Q7B_EXCEPTION("QAction expected"); return; }  

  ((QMenu *) qmenu->ref)->addAction( ((QAction *) theAction->ref) );
}

Q7B Q7B_QMENU_ADDMENU(Q7B qmenu, Q7B Text)
{
  if (Q7B_nil(qmenu)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }
  
  if (Q7B_nil(Q7B_QMENU(qmenu))){ Q7B_EXCEPTION("QMenu expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_QOBJECT( ((QMenu *) qmenu->ref)->addMenu( *((QString *) Text->ref) ) );
}

Q7B Q7B_QMENU_ADDSEPARATOR(Q7B qmenu)
{
  if (Q7B_nil(qmenu)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QMENU(qmenu))){ Q7B_EXCEPTION("QMenu expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QMenu *) qmenu->ref)->addSeparator( ) );
}

void Q7B_QMENU_CLEAR(Q7B qmenu)
{
  if (Q7B_nil(qmenu)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QMENU(qmenu))){ Q7B_EXCEPTION("QMenu expected"); return; }

  ((QMenu *) qmenu->ref)->clear( );
}








Q7B Q7B_QLABEL_INIT(QObject *parent, const char *objectName) 
{
  QLabel* o = new QLabel();

  o->setProperty("Parent", (qlonglong) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  

  Q7B q (new Q7B_id(typeid(QLabel).name(), o)); 
  return q;
}

void Q7B_QLABEL_TEXT(Q7B qlabel, Q7B Value)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((QLabel *) qlabel->ref)->setText( *((QString *) Value->ref) );
}

Q7B Q7B_QLABEL_TEXT(Q7B qlabel)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QLabel *) qlabel->ref)->text() );
}

void Q7B_QLABEL_OPENEXTERNALLINKS(Q7B qlabel, Q7B Value)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Value))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QLabel *) qlabel->ref)->setOpenExternalLinks( Q7B_IDbool(Value) );
}

Q7B Q7B_QLABEL_OPENEXTERNALLINKS(Q7B qlabel)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QLabel *) qlabel->ref)->openExternalLinks() );
}

void Q7B_QLABEL_WORDWRAP(Q7B qlabel, Q7B Value)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Value))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QLabel *) qlabel->ref)->setWordWrap( Q7B_IDbool(Value) );
}

Q7B Q7B_QLABEL_WORDWRAP(Q7B qlabel)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QLabel *) qlabel->ref)->wordWrap() );
}

void Q7B_QLABEL_SCALEDCONTENTS(Q7B qlabel, Q7B Value)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Value))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QLabel *) qlabel->ref)->setScaledContents( Q7B_IDbool(Value) );
}

Q7B Q7B_QLABEL_SCALEDCONTENTS(Q7B qlabel)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QLabel *) qlabel->ref)->hasScaledContents() );
}

void Q7B_QLABEL_ALIGNMENT(Q7B qlabel, Q7B Value)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QLabel *) qlabel->ref)->setAlignment( (Qt::Alignment) Q7B_IDqint64(Value) );
}

Q7B Q7B_QLABEL_ALIGNMENT(Q7B qlabel)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( (qint64) ((QLabel *) qlabel->ref)->alignment() );
}

void Q7B_QLABEL_TEXTINTERACTIONFLAGS(Q7B qlabel, Q7B Value)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QLabel *) qlabel->ref)->setTextInteractionFlags( (Qt::TextInteractionFlags) Q7B_IDqint64(Value) );
}

Q7B Q7B_QLABEL_TEXTINTERACTIONFLAGS(Q7B qlabel)
{
  if (Q7B_nil(qlabel)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLABEL(qlabel))){ Q7B_EXCEPTION("QLabel expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( (qint64) ((QLabel *) qlabel->ref)->textInteractionFlags() );
}



Q7B Q7B_QLINEEDIT_INIT(QObject *parent, const char *objectName)
{
  QLineEdit* o = new QLineEdit( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QLineEdit).name(), o)); 
  return q;
}

void Q7B_QLINEEDIT_ALIGNMENT(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QLineEdit *) qlineedit->ref)->setAlignment( (Qt::Alignment) Q7B_IDqint64(Value) );
}

Q7B Q7B_QLINEEDIT_ALIGNMENT(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QLineEdit *) qlineedit->ref)->alignment() );
}

void Q7B_QLINEEDIT_ECHOMODE(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QLineEdit *) qlineedit->ref)->setEchoMode( (QLineEdit::EchoMode) Q7B_IDqint64(Value) );
}

Q7B Q7B_QLINEEDIT_ECHOMODE(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QLineEdit *) qlineedit->ref)->echoMode() );
}

void Q7B_QLINEEDIT_INPUTMASK(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((QLineEdit *) qlineedit->ref)->setInputMask( *((QString *) Value->ref) );
}

Q7B Q7B_QLINEEDIT_INPUTMASK(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QLineEdit *) qlineedit->ref)->inputMask() );
}

void Q7B_QLINEEDIT_READONLY(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Value))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QLineEdit *) qlineedit->ref)->setReadOnly( Q7B_IDbool(Value) );
}

Q7B Q7B_QLINEEDIT_READONLY(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QLineEdit *) qlineedit->ref)->isReadOnly() );
}

void Q7B_QLINEEDIT_VALIDATORFLOAT(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Value))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  ((QLineEdit *) qlineedit->ref)->setProperty("ValidatorFloat", true);
  ((QLineEdit *) qlineedit->ref)->setValidator(Q7B_IDbool(Value) ? new QDoubleValidator(((QLineEdit *) qlineedit->ref)) : 0);
}

Q7B Q7B_QLINEEDIT_VALIDATORFLOAT(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QLineEdit *) qlineedit->ref)->property("ValidatorFloat").toBool() );
}

void Q7B_QLINEEDIT_VALIDATORINTEGER(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Value))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  ((QLineEdit *) qlineedit->ref)->setProperty("ValidatorInteger", true);
  ((QLineEdit *) qlineedit->ref)->setValidator(Q7B_IDbool(Value) ? new QIntValidator(((QLineEdit *) qlineedit->ref)) : 0);
}

Q7B Q7B_QLINEEDIT_VALIDATORINTEGER(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QLineEdit *) qlineedit->ref)->property("ValidatorInteger").toBool() );
}

void Q7B_QLINEEDIT_MAXIMUM(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QLineEdit *) qlineedit->ref)->setMaxLength( Q7B_IDqint64(Value) );
}

Q7B Q7B_QLINEEDIT_MAXIMUM(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QLineEdit *) qlineedit->ref)->maxLength () );
}

void Q7B_QLINEEDIT_COMPLETER(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_LIST(Value))){ Q7B_EXCEPTION("List expected"); return; }

  QLineEdit *le = ((QLineEdit *) qlineedit->ref);

  le->setCompleter( new QCompleter( Q7B_IDQ7B_List(Value)->toStringList(), le) );
}

Q7B Q7B_QLINEEDIT_COMPLETER(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_idnil; 
}

void Q7B_QLINEEDIT_TEXT(Q7B qlineedit, Q7B Value)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((QLineEdit *) qlineedit->ref)->setText( *((QString *) Value->ref) );
}

Q7B Q7B_QLINEEDIT_TEXT(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QLineEdit *) qlineedit->ref)->text() );
}

Q7B Q7B_QLINEEDIT_ISVALID(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QLineEdit *) qlineedit->ref)->hasAcceptableInput() );
}

void Q7B_QLINEEDIT_SELECTALL(Q7B qlineedit)
{
  if (Q7B_nil(qlineedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLINEEDIT(qlineedit))){ Q7B_EXCEPTION("QLineEdit expected"); return; }

  ((QLineEdit *) qlineedit->ref)->selectAll();
}



Q7B Q7B_QTEXTEDIT_INIT(QObject *parent, const char *objectName)
{
  QTextEdit* o = new QTextEdit( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QTextEdit).name(), o)); 
  return q;
}

void Q7B_QTEXTEDIT_HTML(Q7B qtextedit, Q7B Value)
{
  if (Q7B_nil(qtextedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTEXTEDIT(qtextedit))){ Q7B_EXCEPTION("QTextEdit expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((QTextEdit *) qtextedit->ref)->setHtml( *((QString *) Value->ref) );
}

Q7B Q7B_QTEXTEDIT_HTML(Q7B qtextedit)
{
  if (Q7B_nil(qtextedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTEXTEDIT(qtextedit))){ Q7B_EXCEPTION("QTextEdit expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QTextEdit *) qtextedit->ref)->toHtml() );
}



Q7B Q7B_QPLAINTEXTEDIT_INIT(QObject *parent, const char *objectName)
{
  QPlainTextEdit* o = new QPlainTextEdit( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QPlainTextEdit).name(), o)); 
  return q;
}

void Q7B_QPLAINTEXTEDIT_PLAINTEXT(Q7B qplaintextedit, Q7B Value)
{
  if (Q7B_nil(qplaintextedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(qplaintextedit))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((QPlainTextEdit *) qplaintextedit->ref)->setPlainText( *((QString *) Value->ref) );
}

Q7B Q7B_QPLAINTEXTEDIT_PLAINTEXT(Q7B qplaintextedit)
{
  if (Q7B_nil(qplaintextedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(qplaintextedit))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QPlainTextEdit *) qplaintextedit->ref)->toPlainText() );
}

void Q7B_QPLAINTEXTEDIT_READONLY(Q7B qplaintextedit, Q7B v)
{
  if (Q7B_nil(qplaintextedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(qplaintextedit))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return; }

  ((QPlainTextEdit *) qplaintextedit->ref)->setReadOnly( *((bool *) v->ref) );
}

Q7B Q7B_QPLAINTEXTEDIT_READONLY(Q7B qplaintextedit)
{  
  if (Q7B_nil(qplaintextedit)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(qplaintextedit))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QPlainTextEdit *) qplaintextedit->ref)->isReadOnly() );
}

void Q7B_QPLAINTEXTEDIT_APPENDPLAINTEXT(Q7B qplaintextedit, Q7B v)
{
  if (Q7B_nil(qplaintextedit)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QPLAINTEXTEDIT(qplaintextedit))){ Q7B_EXCEPTION("QPlainTextEdit expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }  

  ((QPlainTextEdit *) qplaintextedit->ref)->appendPlainText( *((QString *) v->ref) );
}







Q7B Q7B_QCOMBOBOX_INIT(QObject *parent, const char *objectName)
{
  QComboBox* o = new QComboBox( 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  

  Q7B q (new Q7B_id(typeid(QComboBox).name(), o)); 
  return q;
}

void Q7B_QCOMBOBOX_REMOVEALL(Q7B qcombobox)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return; }

  ((QComboBox *) qcombobox->ref)->clear();
}

void Q7B_QCOMBOBOX_SETNOCOMPLETER(Q7B qcombobox)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return; }

  ((QComboBox *) qcombobox->ref)->setCompleter(0);
}

Q7B Q7B_QCOMBOBOX_TEXT(Q7B qcombobox)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QComboBox *) qcombobox->ref)->currentText() );
}

void Q7B_QCOMBOBOX_APPEND(Q7B qcombobox, Q7B v)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }
  
  ((QComboBox *) qcombobox->ref)->addItem( *((QString *) v->ref) );
}

Q7B Q7B_QCOMBOBOX_OBJECT(Q7B qcombobox, Q7B v)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QComboBox *) qcombobox->ref)->itemText( Q7B_IDqint64(v) ) );
}

void Q7B_QCOMBOBOX_CURRENTINDEX(Q7B qcombobox, Q7B v)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QComboBox *) qcombobox->ref)->setCurrentIndex( Q7B_IDqint64(v) );
}

Q7B Q7B_QCOMBOBOX_LENGTH(Q7B qcombobox)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QComboBox *) qcombobox->ref)->count() );
}

Q7B Q7B_QCOMBOBOX_CURRENTINDEX(Q7B qcombobox)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QComboBox *) qcombobox->ref)->currentIndex() );
}

void Q7B_QCOMBOBOX_APPEND2(Q7B qcombobox, Q7B Icon, Q7B Text)
{
  if (Q7B_nil(qcombobox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QCOMBOBOX(qcombobox))){ Q7B_EXCEPTION("QComboBox expected"); return; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }
  
  QIcon icon;
  icon = *((QIcon *) Icon->ref);

  ((QComboBox *) qcombobox->ref)->addItem(icon, Q7B_IDQString(Text));
}




Q7B Q7B_QTREEWIDGET_INIT(QObject *parent, const char *objectName)
{
  QTreeWidget* o = new QTreeWidget( 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  

  Q7B q (new Q7B_id(typeid(QTreeWidget).name(), o)); 
  return q;
}

Q7B Q7B_QTREEWIDGET_COLUMNCOUNT(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QTreeWidget *) qtreewidget->ref)->columnCount() );
}

Q7B Q7B_QTREEWIDGET_CURRENTCOLUMN(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QTreeWidget *) qtreewidget->ref)->currentColumn() );
}

Q7B Q7B_QTREEWIDGET_CURRENTITEM(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( (qint64) ((QTreeWidget *) qtreewidget->ref)->currentItem() );
}

Q7B Q7B_QTREEWIDGET_HEADERITEM(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( (qint64) ((QTreeWidget *) qtreewidget->ref)->headerItem() );
}

Q7B Q7B_QTREEWIDGET_INVISIBLEROOTITEM(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( (qint64) ((QTreeWidget *) qtreewidget->ref)->invisibleRootItem() );
}

Q7B Q7B_QTREEWIDGET_SELECTEDITEMS(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  QList<QTreeWidgetItem *>l =((QTreeWidget *) qtreewidget->ref)->selectedItems();

  Q7B_List *a = new Q7B_List();
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

  for (int i = 0; i < l.size(); i++){
     a->append(Q7B_QOBJECT( (qint64) l.at(i)));
  }

  return q;
}

Q7B Q7B_QTREEWIDGET_SORTCOLUMN(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( (qint64) ((QTreeWidget *) qtreewidget->ref)->sortColumn() );
}

Q7B Q7B_QTREEWIDGET_TOPLEVELITEMCOUNT(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( (qint64) ((QTreeWidget *) qtreewidget->ref)->topLevelItemCount() );
}

void Q7B_QTREEWIDGET_COLLAPSEALL(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->collapseAll() ;
}

void Q7B_QTREEWIDGET_EXPANDALL(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->expandAll() ;
}

void Q7B_QTREEWIDGET_SELECTALL(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->selectAll() ;
}

void Q7B_QTREEWIDGET_SCROLLTOBOTTOM(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->scrollToBottom() ;
}

void Q7B_QTREEWIDGET_SCROLLTOTOP(Q7B qtreewidget)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->scrollToTop() ;
}

Q7B Q7B_QTREEWIDGET_APPENDCHILD(Q7B qtreewidget, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = new QTreeWidgetItem(((QTreeWidget *) qtreewidget->ref));
  l->setText(0, Q7B_IDQString(Text));

  return Q7B_QOBJECT( (qint64) l );
}

Q7B Q7B_QTREEWIDGET_CHILDCOUNT(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_QOBJECT( l->childCount() );
}

Q7B Q7B_QTREEWIDGET_ISEXPANDED(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_QOBJECT( l->isExpanded() );
}

Q7B Q7B_QTREEWIDGET_ISHIDDEN(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_QOBJECT( l->isHidden() );
}

Q7B Q7B_QTREEWIDGET_ISSELECTED(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_QOBJECT( l->isSelected() );
}

Q7B Q7B_QTREEWIDGET_COLUMNCOUNT(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_QOBJECT( l->columnCount() );
}

Q7B Q7B_QTREEWIDGET_APPEND(Q7B qtreewidget, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = new QTreeWidgetItem();
  l->setText(0, Q7B_IDQString(Text));
  ((QTreeWidget *) qtreewidget->ref)->addTopLevelItem(l);
  return Q7B_QOBJECT( (qint64) l );
}

Q7B Q7B_QTREEWIDGET_INDEXOFTOPLEVELITEM(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_QOBJECT( ((QTreeWidget *) qtreewidget->ref)->indexOfTopLevelItem(l) );
}
  
void Q7B_QTREEWIDGET_SETCOLUMNCOUNT(Q7B qtreewidget, Q7B Count)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Count))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->setColumnCount( Q7B_IDqint64(Count) ) ;
}

void Q7B_QTREEWIDGET_SETCURRENTITEM(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  ((QTreeWidget *) qtreewidget->ref)->setCurrentItem( l ) ;
}

void Q7B_QTREEWIDGET_SETHEADERLABEL(Q7B qtreewidget, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->setHeaderLabel( Q7B_IDQString(Text) );
  ((QTreeWidget *) qtreewidget->ref)->headerItem()->setHidden(false);
}

void Q7B_QTREEWIDGET_REMOVETOPLEVELITEM(Q7B qtreewidget, Q7B Index)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->takeTopLevelItem( Q7B_IDqint64(Index) );
}

Q7B Q7B_QTREEWIDGET_TOPLEVELITEM(Q7B qtreewidget, Q7B Index)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( (qint64) ((QTreeWidget *) qtreewidget->ref)->topLevelItem( Q7B_IDqint64(Index) ) );
}

Q7B Q7B_QTREEWIDGET_ISCOLUMNHIDDEN(Q7B qtreewidget, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QTreeWidget *) qtreewidget->ref)->isColumnHidden( Q7B_IDqint64(Column) ) );
}

Q7B Q7B_QTREEWIDGET_COLUMNWIDTH(Q7B qtreewidget, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QTreeWidget *) qtreewidget->ref)->columnWidth( Q7B_IDqint64(Column) ) );
}

void Q7B_QTREEWIDGET_SHOWCOLUMN(Q7B qtreewidget, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->showColumn( Q7B_IDqint64(Column) ) ;
}

void Q7B_QTREEWIDGET_COLLAPSEITEM(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  ((QTreeWidget *) qtreewidget->ref)->collapseItem( l ) ;
}

void Q7B_QTREEWIDGET_EXPANDITEM(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  ((QTreeWidget *) qtreewidget->ref)->expandItem( l ) ;
}

void Q7B_QTREEWIDGET_SCROLLTOITEM(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  ((QTreeWidget *) qtreewidget->ref)->scrollToItem( l ) ;
}

Q7B Q7B_QTREEWIDGET_FLAGS(Q7B qtreewidget, Q7B ItemId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_QOBJECT( (qint64) l->flags ( ) );
}

Q7B Q7B_QTREEWIDGET_APPENDCHILD2(Q7B qtreewidget, Q7B Icon, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = new QTreeWidgetItem(((QTreeWidget *) qtreewidget->ref));
  l->setText(0, Q7B_IDQString(Text));

   QIcon icon;
  icon = *((QIcon *) Icon->ref);
  l->setIcon(0, icon);

  return Q7B_QOBJECT( (qint64) l );
}

Q7B Q7B_QTREEWIDGET_APPENDCHILDTOID(Q7B qtreewidget, Q7B ItemId, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *ll = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  QTreeWidgetItem *l = new QTreeWidgetItem(ll);
  l->setText(0, Q7B_IDQString(Text));
  return Q7B_QOBJECT( (qint64) l );
}

Q7B Q7B_QTREEWIDGET_CHILD(Q7B qtreewidget, Q7B ItemId, Q7B Index)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_QOBJECT( (qint64) l->child( Q7B_IDqint64(Index) ) );
}

Q7B Q7B_QTREEWIDGET_CHECKSTATE(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);  
  return Q7B_QOBJECT( (qint64) l->checkState ( Q7B_IDqint64(Column) ) );
}

Q7B Q7B_QTREEWIDGET_DATA(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_Variant2id( l->data ( Q7B_IDqint64(Column), Qt::UserRole ), false, false );
}

void Q7B_QTREEWIDGET_SETFLAGS(Q7B qtreewidget, Q7B ItemId, Q7B Flags)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Flags))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setFlags( (Qt::ItemFlags) Q7B_IDqint64(Flags) );
}

Q7B Q7B_QTREEWIDGET_TEXT(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_QOBJECT( l->text ( Q7B_IDqint64(Column) ) );
}

Q7B Q7B_QTREEWIDGET_ICON(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_QOBJECT( l->icon ( Q7B_IDqint64(Column) ) );
}

Q7B Q7B_QTREEWIDGET_INDEXOFCHILD(Q7B qtreewidget, Q7B ItemId, Q7B ChildId)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ChildId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_QOBJECT( l->indexOfChild ( (QTreeWidgetItem *) Q7B_IDqint64(ChildId) ) );
}

void Q7B_QTREEWIDGET_SETDISABLED(Q7B qtreewidget, Q7B ItemId, Q7B IsDisabled)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(IsDisabled))){ Q7B_EXCEPTION("Boolean expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setDisabled( Q7B_IDbool(IsDisabled) );
}

void Q7B_QTREEWIDGET_SETEXPANDED(Q7B qtreewidget, Q7B ItemId, Q7B IsExpanded)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(IsExpanded))){ Q7B_EXCEPTION("Boolean expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setExpanded( Q7B_IDbool(IsExpanded) );
}

void Q7B_QTREEWIDGET_SETHIDDEN(Q7B qtreewidget, Q7B ItemId, Q7B IsHidden)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(IsHidden))){ Q7B_EXCEPTION("Boolean expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setHidden( Q7B_IDbool(IsHidden) );
}

void Q7B_QTREEWIDGET_SETSELECTED(Q7B qtreewidget, Q7B ItemId, Q7B IsSelected)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(IsSelected))){ Q7B_EXCEPTION("Boolean expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setSelected( Q7B_IDbool(IsSelected) );
}

Q7B Q7B_QTREEWIDGET_STATUSTIP(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_QOBJECT( l->statusTip ( Q7B_IDqint64(Column) ) );
}

Q7B Q7B_QTREEWIDGET_WHATSTHIS(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_QOBJECT( l->whatsThis ( Q7B_IDqint64(Column) ) );
}

Q7B Q7B_QTREEWIDGET_TOOLTIP(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_QOBJECT( l->toolTip ( Q7B_IDqint64(Column) ) );
}

void Q7B_QTREEWIDGET_REMOVECHILD(Q7B qtreewidget, Q7B ItemId, Q7B Index)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->takeChild( Q7B_IDqint64(Index) );
}

Q7B Q7B_QTREEWIDGET_TEXTALIGNMENT(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  return Q7B_QOBJECT( (qint64) l->textAlignment ( Q7B_IDqint64(Column) ) );
}

Q7B Q7B_QTREEWIDGET_APPEND2(Q7B qtreewidget, Q7B Icon, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = new QTreeWidgetItem();
  l->setText(0, Q7B_IDQString(Text));

   QIcon icon;
  icon = *((QIcon *) Icon->ref);
  l->setIcon(0, icon);

  ((QTreeWidget *) qtreewidget->ref)->addTopLevelItem(l);
  return Q7B_QOBJECT( (qint64) l );
}

Q7B Q7B_QTREEWIDGET_INSERT2(Q7B qtreewidget, Q7B Index, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = new QTreeWidgetItem();
  l->setText(0, Q7B_IDQString(Text));

  ((QTreeWidget *) qtreewidget->ref)->insertTopLevelItem(Q7B_IDqint64(Index), l);
  return Q7B_QOBJECT( (qint64) l );
}

Q7B Q7B_QTREEWIDGET_ITEMAT(Q7B qtreewidget, Q7B X, Q7B Y)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(X))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Y))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( (qint64) ((QTreeWidget *) qtreewidget->ref)->itemAt( Q7B_IDqint64(X), Q7B_IDqint64(Y) ) );
}

void Q7B_QTREEWIDGET_SETCURRENTITEM2(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  ((QTreeWidget *) qtreewidget->ref)->setCurrentItem ( l, Q7B_IDqint64(Column) ) ;
}

void Q7B_QTREEWIDGET_SETHEADERLABEL2(Q7B qtreewidget, Q7B Column, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  QTreeWidgetItem *l = ((QTreeWidget *) qtreewidget->ref)->headerItem();
  l->setText( Q7B_IDqint64(Column), Q7B_IDQString(Text) );
  l->setHidden(false);  
}

void Q7B_QTREEWIDGET_SORTITEMS(Q7B qtreewidget, Q7B Column, Q7B Descending)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Descending))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->sortItems( Q7B_IDqint64(Column), Q7B_IDbool(Descending) ? Qt::DescendingOrder : Qt::AscendingOrder );
}

void Q7B_QTREEWIDGET_SETCOLUMNHIDDEN(Q7B qtreewidget, Q7B Column, Q7B IsColumnHidden)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(IsColumnHidden))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->setColumnHidden( Q7B_IDqint64(Column), Q7B_IDbool(IsColumnHidden) );
}

void Q7B_QTREEWIDGET_SETCOLUMNWIDTH(Q7B qtreewidget, Q7B Column, Q7B Width)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Width))){ Q7B_EXCEPTION("Integer expected"); return; }

  ((QTreeWidget *) qtreewidget->ref)->setColumnWidth( Q7B_IDqint64(Column), Q7B_IDqint64(Width) );
}

void Q7B_QTREEWIDGET_CLOSEPERSISTENTEDITOR(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  ((QTreeWidget *) qtreewidget->ref)->closePersistentEditor(l, Q7B_IDqint64(Column));
}

void Q7B_QTREEWIDGET_OPENPERSISTENTEDITOR(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  ((QTreeWidget *) qtreewidget->ref)->openPersistentEditor(l, Q7B_IDqint64(Column));
}

void Q7B_QTREEWIDGET_EDITITEM(Q7B qtreewidget, Q7B ItemId, Q7B Column)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  ((QTreeWidget *) qtreewidget->ref)->editItem(l, Q7B_IDqint64(Column));
}

Q7B Q7B_QTREEWIDGET_APPENDCHILDTOID2(Q7B qtreewidget, Q7B ItemId, Q7B Icon, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *ll = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  QTreeWidgetItem *l = new QTreeWidgetItem(ll);
  l->setText(0, Q7B_IDQString(Text));

   QIcon icon;
  icon = *((QIcon *) Icon->ref);
  l->setIcon(0, icon);

  return Q7B_QOBJECT( (qint64) l );
}

void Q7B_QTREEWIDGET_SETCHECKSTATE(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B CheckState)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(CheckState))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setCheckState( Q7B_IDqint64(Column), (Qt::CheckState) Q7B_IDqint64(CheckState) );
}

void Q7B_QTREEWIDGET_SETTEXT(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setText( Q7B_IDqint64(Column), Q7B_IDQString(Text) );
}

void Q7B_QTREEWIDGET_SETICON(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B Icon)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);

   QIcon icon;
  icon = *((QIcon *) Icon->ref);
  l->setIcon( Q7B_IDqint64(Column), icon);
}

Q7B Q7B_QTREEWIDGET_INSERTCHILD(Q7B qtreewidget, Q7B ItemId, Q7B Index, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *ll = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  QTreeWidgetItem *l = new QTreeWidgetItem(ll);
  l->setText(0, Q7B_IDQString(Text));
  ll->insertChild( Q7B_IDqint64(Index), l);

  return Q7B_QOBJECT( (qint64) l );
}

Q7B Q7B_QTREEWIDGET_INSERTCHILD2(Q7B qtreewidget, Q7B ItemId, Q7B Index, Q7B Icon, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *ll = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  QTreeWidgetItem *l = new QTreeWidgetItem(ll);
  l->setText(0, Q7B_IDQString(Text));

   QIcon icon;
  icon = *((QIcon *) Icon->ref);
  l->setIcon(0, icon);

  ll->insertChild( Q7B_IDqint64(Index), l);

  return Q7B_QOBJECT( (qint64) l );
}
 
void Q7B_QTREEWIDGET_SETSTATUSTIP(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B StatusTip)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(StatusTip))){ Q7B_EXCEPTION("String expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setStatusTip( Q7B_IDqint64(Column), Q7B_IDQString(StatusTip));
}

void Q7B_QTREEWIDGET_SETWHATSTHIS(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B WhatsThis)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(WhatsThis))){ Q7B_EXCEPTION("String expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setWhatsThis( Q7B_IDqint64(Column), Q7B_IDQString(WhatsThis));
}

void Q7B_QTREEWIDGET_SETTOOLTIP(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B ToolTip)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(ToolTip))){ Q7B_EXCEPTION("String expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setToolTip( Q7B_IDqint64(Column), Q7B_IDQString(ToolTip));
}

void Q7B_QTREEWIDGET_SETTEXTALIGNMENT(Q7B qtreewidget, Q7B ItemId, Q7B Column, Q7B TextAlignment)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(ItemId))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Column))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(TextAlignment))){ Q7B_EXCEPTION("Integer expected"); return; }

  QTreeWidgetItem *l = (QTreeWidgetItem *) Q7B_IDqint64(ItemId);
  l->setTextAlignment( Q7B_IDqint64(Column), (Qt::AlignmentFlag) Q7B_IDqint64(TextAlignment) );
}


Q7B Q7B_QTREEWIDGET_INSERT3(Q7B qtreewidget, Q7B Index, Q7B Icon, Q7B Text)
{
  if (Q7B_nil(qtreewidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTREEWIDGET(qtreewidget))){ Q7B_EXCEPTION("QTreeWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QTreeWidgetItem *l = new QTreeWidgetItem();
  l->setText(0, Q7B_IDQString(Text));

   QIcon icon;
  icon = *((QIcon *) Icon->ref);
  l->setIcon(0, icon);

  ((QTreeWidget *) qtreewidget->ref)->insertTopLevelItem(Q7B_IDqint64(Index), l);
  return Q7B_QOBJECT( (qint64) l );
}



Q7B Q7B_QDOCKWIDGET_INIT(QObject *parent, const char *objectName)
{
  QDockWidget* o = new QDockWidget( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QDockWidget).name(), o)); 
  return q;
}

Q7B Q7B_QDOCKWIDGET_WIDGET(Q7B qdockwidget)
{
  if (Q7B_nil(qdockwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QDOCKWIDGET(qdockwidget))){ Q7B_EXCEPTION("QDockWidget expected"); return Q7B_idnil; }
  
  return Q7B_QOBJECT( ((QDockWidget *) qdockwidget->ref)->widget() );
}




Q7B Q7B_QLISTWIDGET_INIT(QObject *parent, const char *objectName)
{
  QListWidget* o = new QListWidget( 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  

  Q7B q (new Q7B_id(typeid(QListWidget).name(), o)); 
  return q;
}

Q7B Q7B_QLISTWIDGET_LENGTH(Q7B qlistwidget)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QListWidget *) qlistwidget->ref)->count() );
}

void Q7B_QLISTWIDGET_REMOVEALL(Q7B qlistwidget)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }

  ((QListWidget *) qlistwidget->ref)->clear();
}

Q7B Q7B_QLISTWIDGET_SELECTED(Q7B qlistwidget)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QListWidget *) qlistwidget->ref)->currentRow() );
}

Q7B Q7B_QLISTWIDGET_SELECTEDTEXT(Q7B qlistwidget)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->currentItem();
  return Q7B_QOBJECT( l->text() );
}

void Q7B_QLISTWIDGET_SORT(Q7B qlistwidget, Q7B Descending)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(Descending))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QListWidget *) qlistwidget->ref)->sortItems ( Q7B_IDbool(Descending) ? Qt::DescendingOrder : Qt::AscendingOrder );
}

void Q7B_QLISTWIDGET_APPEND(Q7B qlistwidget, Q7B Text)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  ((QListWidget *) qlistwidget->ref)->addItem  ( Q7B_IDQString(Text) );
}

void Q7B_QLISTWIDGET_REMOVE(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) ((QListWidget *) qlistwidget->ref)->removeItemWidget ( l ) ;
}

void Q7B_QLISTWIDGET_SELECT(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) ((QListWidget *) qlistwidget->ref)->setCurrentRow ( Q7B_IDqint64(Index) );
}

void Q7B_QLISTWIDGET_SELECTTEXT(Q7B qlistwidget, Q7B Text)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  QList<QListWidgetItem *>l = ((QListWidget *) qlistwidget->ref)->findItems (Q7B_IDQString(Text), Qt::MatchExactly);
  if (l.count()) ((QListWidget *) qlistwidget->ref)->setCurrentItem (l.at(0));
}

Q7B Q7B_QLISTWIDGET_TEXT(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_QOBJECT( l->text() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_DATA(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_Variant2id( l->data(Qt::UserRole), false, false );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_ICON(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_QOBJECT( l->icon() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_CHECKSTATE(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_QOBJECT( l->checkState() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_FLAGS(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_QOBJECT( l->flags() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_ISHIDDEN(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_QOBJECT( l->isHidden() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_ISSELECTED(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_QOBJECT( l->isSelected() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_STATUSTIP(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_QOBJECT( l->statusTip() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_WHATSTHIS(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_QOBJECT( l->whatsThis() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_TOOLTIP(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_QOBJECT( l->toolTip() );

  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET_TEXTALIGNMENT(Q7B qlistwidget, Q7B Index)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) return Q7B_QOBJECT( l->textAlignment() );

  return Q7B_idnil;
}

void Q7B_QLISTWIDGET_SETTEXT(Q7B qlistwidget, Q7B Index, Q7B Text)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setText( Q7B_IDQString(Text) );
}

void Q7B_QLISTWIDGET_SETICON(Q7B qlistwidget, Q7B Index, Q7B Icon)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l){
     QIcon icon;
    icon = *((QIcon *) Icon->ref);
    l->setIcon( icon );
  }
}

void Q7B_QLISTWIDGET_SETDATA(Q7B qlistwidget, Q7B Index, Q7B d)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }  

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l){
    QVariant v = Q7B_id2Variant(d, false, false);
    l->setData(Qt::UserRole, v);
  }
}

void Q7B_QLISTWIDGET_SETCHECKSTATE(Q7B qlistwidget, Q7B Index, Q7B CheckState)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(CheckState))){ Q7B_EXCEPTION("Integer expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setCheckState( (Qt::CheckState) Q7B_IDqint64(CheckState) );  
}

void Q7B_QLISTWIDGET_SETFLAGS(Q7B qlistwidget, Q7B Index, Q7B Flag)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Flag))){ Q7B_EXCEPTION("Integer expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setFlags( (Qt::ItemFlags) Q7B_IDqint64(Flag) );  
}

void Q7B_QLISTWIDGET_SETHIDDEN(Q7B qlistwidget, Q7B Index, Q7B IsHidden)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(IsHidden))){ Q7B_EXCEPTION("Boolean expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setHidden( Q7B_IDbool(IsHidden) );  
}

void Q7B_QLISTWIDGET_SETSELECTED(Q7B qlistwidget, Q7B Index, Q7B IsSelected)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(IsSelected))){ Q7B_EXCEPTION("Boolean expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setSelected( Q7B_IDbool(IsSelected) );  
}

void Q7B_QLISTWIDGET_SETSTATUSTIP(Q7B qlistwidget, Q7B Index, Q7B StatusTip)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(StatusTip))){ Q7B_EXCEPTION("String expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setStatusTip( Q7B_IDQString(StatusTip) );  
}

void Q7B_QLISTWIDGET_SETWHATSTHIS(Q7B qlistwidget, Q7B Index, Q7B WhatsThis)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(WhatsThis))){ Q7B_EXCEPTION("String expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setWhatsThis( Q7B_IDQString(WhatsThis) );  
}

void Q7B_QLISTWIDGET_SETTOOLTIP(Q7B qlistwidget, Q7B Index, Q7B ToolTip)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(ToolTip))){ Q7B_EXCEPTION("String expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setToolTip( Q7B_IDQString(ToolTip) );  
}

void Q7B_QLISTWIDGET_SETTEXTALIGNMENT(Q7B qlistwidget, Q7B Index, Q7B TextAlignment)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(TextAlignment))){ Q7B_EXCEPTION("Integer expected"); return; }

  QListWidgetItem *l = ((QListWidget *) qlistwidget->ref)->item( Q7B_IDqint64(Index) );
  if (l) l->setTextAlignment( (Qt::Alignment) Q7B_IDqint64(TextAlignment) );  
}

void Q7B_QLISTWIDGET_INSERT(Q7B qlistwidget, Q7B Index, Q7B Text)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  ((QListWidget *) qlistwidget->ref)->insertItem ( Q7B_IDqint64(Index), Q7B_IDQString(Text) );
}

void Q7B_QLISTWIDGET_APPEND2(Q7B qlistwidget, Q7B Icon, Q7B Text)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  QIcon icon;
  icon = *((QIcon *) Icon->ref);
  QListWidgetItem *l = new QListWidgetItem(icon, Q7B_IDQString(Text));
  ((QListWidget *) qlistwidget->ref)->addItem( l );
}

void Q7B_QLISTWIDGET_INSERT2(Q7B qlistwidget, Q7B Index, Q7B Icon, Q7B Text)
{
  if (Q7B_nil(qlistwidget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QLISTWIDGET(qlistwidget))){ Q7B_EXCEPTION("QListWidget expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QICON(Icon))){ Q7B_EXCEPTION("QIcon expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  QIcon icon;
  icon = *((QIcon *) Icon->ref);
  QListWidgetItem *l = new QListWidgetItem(icon, Q7B_IDQString(Text));
  ((QListWidget *) qlistwidget->ref)->insertItem ( Q7B_IDqint64(Index), l );

}



Q7B Q7B_QTOOLBUTTON_INIT(QObject *parent, const char *objectName)
{
  QToolButton* o = new QToolButton( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(QToolButton).name(), o)); 
  return q;
}

void Q7B_QTOOLBUTTON_MENU(Q7B qtoolbutton, Q7B v)
{
  if (Q7B_nil(qtoolbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QTOOLBUTTON(qtoolbutton))){ Q7B_EXCEPTION("QToolButton expected"); return; }
  

  ((QToolButton *) qtoolbutton->ref)->setMenu( ((QMenu *) v->ref) );
}

Q7B Q7B_QTOOLBUTTON_MENU(Q7B qtoolbutton)
{
  if (Q7B_nil(qtoolbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QTOOLBUTTON(qtoolbutton))){ Q7B_EXCEPTION("QToolButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QToolButton *) qtoolbutton->ref)->menu() );
}




Q7B Q7B_QACTION_INIT(QObject *parent, const char *objectName)
{
  QAction* o = new QAction( 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  

  Q7B q (new Q7B_id(typeid(QAction).name(), o)); 
  return q;
}

void Q7B_QACTION_TEXT(Q7B qaction, Q7B v)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }
  
  ((QAction *) qaction->ref)->setText( *((QString *) v->ref) );
}

Q7B Q7B_QACTION_TEXT(Q7B qaction)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  
  return Q7B_QOBJECT( ((QAction *) qaction->ref)->text() );
}

void Q7B_QACTION_TAG(Q7B qaction, Q7B v) 
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }
  
  ((QAction *) qaction->ref)->setProperty("Tag", *((QString *) v->ref) );
}

Q7B Q7B_QACTION_TAG(Q7B qaction)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QAction *) qaction->ref)->property("Tag").toString() );
}

void Q7B_QACTION_VISIBLE(Q7B qaction, Q7B v)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  ((QAction *) qaction->ref)->setVisible( *((bool *) v->ref) );
}

Q7B Q7B_QACTION_VISIBLE(Q7B qaction)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QAction *) qaction->ref)->isVisible() );
}

void Q7B_QACTION_ENABLED(Q7B qaction, Q7B v)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  ((QAction *) qaction->ref)->setEnabled( *((bool *) v->ref) );
}

Q7B Q7B_QACTION_ENABLED(Q7B qaction)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QAction *) qaction->ref)->isEnabled() );
}

void Q7B_QACTION_CHECKABLE(Q7B qaction, Q7B v)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  ((QAction *) qaction->ref)->setCheckable( *((bool *) v->ref) );
}

Q7B Q7B_QACTION_CHECKABLE(Q7B qaction)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QAction *) qaction->ref)->isCheckable() );
}

void Q7B_QACTION_CHECKED(Q7B qaction, Q7B v)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }
  
  ((QAction *) qaction->ref)->setChecked( *((bool *) v->ref) );
}

Q7B Q7B_QACTION_CHECKED(Q7B qaction)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QAction *) qaction->ref)->isChecked() );
}

void Q7B_QACTION_ICON(Q7B qaction, Q7B v)
{
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return; }
  if (Q7B_nil(Q7B_QICON(v))){ Q7B_EXCEPTION("QIcon expected"); return; }

   QIcon icon;
  icon = *((QIcon *) v->ref);
  ((QAction *) qaction->ref)->setIcon( icon );
}

Q7B Q7B_QACTION_ICON(Q7B qaction)
{  
  if (Q7B_nil(qaction)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QACTION(qaction))){ Q7B_EXCEPTION("QAction expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QAction *) qaction->ref)->icon() );
}











































Q7B Q7B_ADDDAYS(Q7B Q7B_Object, Q7B Days)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Days))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->addDays( *((qint64 *) Days->ref ) ) );
}

Q7B Q7B_ADDHOURS(Q7B Q7B_Object, Q7B Hours)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Hours))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->addSecs(60 * 60 * *((qint64 *) Hours->ref ) ) );
}

Q7B Q7B_ADDMINUTES(Q7B Q7B_Object, Q7B Minutes)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Minutes))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->addSecs(60 * *((qint64 *) Minutes->ref ) ) );
}

Q7B Q7B_ADDMONTHS(Q7B Q7B_Object, Q7B Months)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Months))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->addMonths( *((qint64 *) Months->ref ) ) );
}

Q7B Q7B_ADDSECONDS(Q7B Q7B_Object, Q7B Seconds)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Seconds))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->addSecs( *((qint64 *) Seconds->ref ) ) );
}

Q7B Q7B_SUBDAYS(Q7B Q7B_Object, Q7B Days)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Days))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->addDays(- *((qint64 *) Days->ref ) ) );
}

Q7B Q7B_SUBHOURS(Q7B Q7B_Object, Q7B Hours)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Hours))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->addSecs(- 60 * 60 * *((qint64 *) Hours->ref ) ) );
}

Q7B Q7B_SUBMINUTES(Q7B Q7B_Object, Q7B Minutes)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Minutes))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->addSecs(- 60 * *((qint64 *) Minutes->ref ) ) );
}

Q7B Q7B_SUBMONTHS(Q7B Q7B_Object, Q7B Months)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Months))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->addMonths(- *((qint64 *) Months->ref ) ) );
}

Q7B Q7B_SUBSECONDS(Q7B Q7B_Object, Q7B Seconds)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Seconds))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->addSecs(- *((qint64 *) Seconds->ref ) ) );
}

Q7B Q7B_TIMEVALUE(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString s = Q7B_IDQString(Q7B_Object);
  QDateTime dt = QDateTime::fromString(s, "hh:mm:ss");

  return Q7B_QOBJECT( dt );
}

Q7B Q7B_TIMESERIAL(Q7B Q7B_Object, Q7B Hour, Q7B Minute, Q7B Second)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Hour))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Minute))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Second))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QDateTime dt = QDateTime::currentDateTime();

  dt.setTime( QTime ( Q7B_IDqint64(Hour), Q7B_IDqint64(Minute), Q7B_IDqint64(Second) ) );

  return Q7B_QOBJECT( dt );
}

Q7B Q7B_DATESERIAL(Q7B Q7B_Object, Q7B Year, Q7B Month, Q7B Day)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Year))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Month))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Day))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QDateTime dt;

  dt.setDate( QDate ( Q7B_IDqint64(Year), Q7B_IDqint64(Month), Q7B_IDqint64(Day) ) );

  return Q7B_QOBJECT( dt );
}

Q7B Q7B_FORMATDATETIME(Q7B Q7B_Object, Q7B Format)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Format))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->toString( Q7B_IDQString(Format) ) );
}

Q7B Q7B_DATEVALUE(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString s = Q7B_IDQString(Q7B_Object);
  QDateTime dt = QDateTime::fromString(s, "yyyy-MM-dd hh:mm:ss");
  if (!dt.isValid()){
    dt = QDateTime::fromString(s, "yyyy-MM-dd");      
    if (!dt.isValid()){   
      dt = QDateTime::fromString(s, "hh:mm:ss");
    }
  }

  return Q7B_QOBJECT( dt );
}

Q7B Q7B_DATEPART(Q7B Q7B_Object, Q7B Interval)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Interval))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  QDateTime t = *((QDateTime *) Q7B_Object->ref);

  QString sMode = Q7B_IDQString(Interval);
  
  qint64 y = 0;

  if (sMode == "yyyy"){ 
    y = t.date().year();
  } else if (sMode == "w"){ 
    y = t.date().dayOfWeek();
    
  } else if (sMode == "q"){ 
    y = t.date().month() / 4 + 1;  
  } else if (sMode == "ww"){ 
    y = t.date().weekNumber();  
  } else if (sMode == "m"){ 
    y = t.date().month();  
  } else if (sMode == "h"){ 
    y = t.time().hour();        
  } else if (sMode == "y"){ 
    y = t.date().dayOfYear();  
  } else if (sMode == "n"){ 
    y = t.time().minute();        
  } else if (sMode == "d"){ 
    y = t.date().day();  
  } else if (sMode == "s"){ 
    y = t.time().second();        
  }

  return Q7B_QOBJECT( y );
}

Q7B Q7B_DATEDIFF(Q7B Q7B_Object, Q7B dt, Q7B Interval)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DATETIME(dt))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Interval))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  QDateTime t = *((QDateTime *) Q7B_Object->ref);
  QDateTime t2 = *((QDateTime *) dt->ref);
  QString sMode = Q7B_IDQString(Interval);
  
  qint64 y = 0;

  if (sMode == "yyyy"){ 
    y = t2.daysTo(t) / 365;
  } else if (sMode == "w"){ 
     Q7B_EXCEPTION("Sorry! \"w\" not supported yet. Try to change the data calculation.");
  } else if (sMode == "q"){ 
    y = t2.daysTo(t) / (3 * 30);        
  } else if (sMode == "ww"){ 
     Q7B_EXCEPTION("Sorry! \"ww\" not supported yet. Try to change the data calculation.");    
  } else if (sMode == "m"){ 
    y = t2.daysTo(t) / 30;    
  } else if (sMode == "h"){ 
    y = t2.secsTo(t) * 3600;            
  } else if (sMode == "y"){ 
     Q7B_EXCEPTION("Sorry! \"y\" not supported yet. Try to change the data calculation.");        
  } else if (sMode == "n"){ 
    y = t2.secsTo(t) * 60;        
  } else if (sMode == "d"){ 
    y = t2.daysTo(t);
  } else if (sMode == "s"){ 
    y = t2.secsTo(t);    
  }

  return Q7B_QOBJECT( y );
}

Q7B Q7B_DATEADD(Q7B Q7B_Object, Q7B Interval, Q7B Number)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Interval))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Number))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  
  QDateTime t = *((QDateTime *) Q7B_Object->ref);
  QString sMode = Q7B_IDQString(Interval);
  qint64 n = Q7B_IDqint64(Number);

  QDateTime k;

  if (sMode == "yyyy"){ 
    k = t.addMonths(n * 12);
  } else if (sMode == "w"){ 
    k = t.addDays(n);
  } else if (sMode == "q"){ 
    k = t.addMonths(n * 4);
  } else if (sMode == "ww"){ 
    k = t.addDays(n * 7);
  } else if (sMode == "m"){ 
    k = t.addMonths(n);
  } else if (sMode == "h"){ 
    k = t.addSecs(n * 3600);
  } else if (sMode == "y"){ 
    k = t.addDays(n);
  } else if (sMode == "n"){ 
    k = t.addSecs(n * 60);
  } else if (sMode == "d"){ 
    k = t.addDays(n);
  } else if (sMode == "s"){ 
    k = t.addSecs(n);     
  }

  return Q7B_QOBJECT( k );
}

Q7B Q7B_DIFFSECONDS(Q7B Q7B_Object, Q7B dt)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DATETIME(dt))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  
  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->secsTo( *((QDateTime *) dt->ref) ) );
}

Q7B Q7B_DIFFDAYS(Q7B Q7B_Object, Q7B dt)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_DATETIME(dt))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  
  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->daysTo( *((QDateTime *) dt->ref) ) );
}

Q7B Q7B_WEEKNUMBER(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->date().weekNumber() );
}   

Q7B Q7B_MONTHNAME(Q7B Q7B_Object, Q7B LongMonthName)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  qint64 nMonth;

   
  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ 
    if (Q7B_nil(Q7B_INTEGER(Q7B_Object))){ 
      Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; 
    } else {
      nMonth = Q7B_IDqint64(Q7B_Object);
    }
  } else {
    nMonth = ((QDateTime *) Q7B_Object->ref)->date().month();
  }

  if (Q7B_nil(Q7B_BOOLEAN(LongMonthName))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Q7B_IDbool(LongMonthName)){
    return Q7B_QOBJECT( QDate::longMonthName ( nMonth ) );
  } else {
    return Q7B_QOBJECT( QDate::shortMonthName( nMonth ) );
  }
}

Q7B Q7B_DATETIME_INIT(Q7B Year, Q7B Month, Q7B Day, Q7B Hour, Q7B Minute, Q7B Second, Q7B MSecond)
{
  QDateTime* o;

  if (Q7B_IDqint64(MSecond) != -1){
    o = new QDateTime( QDate( Q7B_IDqint64(Year), Q7B_IDqint64(Month), Q7B_IDqint64(Day) ), QTime( Q7B_IDqint64(Hour), Q7B_IDqint64(Minute), Q7B_IDqint64(Second), Q7B_IDqint64(MSecond) ) );
  } else  if (Q7B_IDqint64(Hour) != -1){
    o = new QDateTime( QDate::currentDate(), QTime( Q7B_IDqint64(Hour), Q7B_IDqint64(Minute), Q7B_IDqint64(Second), Q7B_IDqint64(MSecond) ) );
  } else {
    o = new QDateTime( QDate( Q7B_IDqint64(Year), Q7B_IDqint64(Month), Q7B_IDqint64(Day) ) );
  }

  Q7B q (new Q7B_id(typeid(QDateTime).name(), o)); 
  return q;
}

Q7B Q7B_DAYSINYEAR(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->date().daysInYear() );
}   

Q7B Q7B_DAYSINMONTH(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->date().daysInMonth() );
}   

Q7B Q7B_DAYOFYEAR(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->date().dayOfYear() );
}   

Q7B Q7B_DAYOFWEEK(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->date().dayOfWeek() );
}   

Q7B Q7B_DAYNAME(Q7B Q7B_Object, Q7B LongDayName)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(LongDayName))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Q7B_IDbool(LongDayName)){
    return Q7B_QOBJECT( QDate::longDayName( ((QDateTime *) Q7B_Object->ref)->date().dayOfWeek() ) );
  } else {
    return Q7B_QOBJECT( QDate::shortDayName( ((QDateTime *) Q7B_Object->ref)->date().dayOfWeek() ) );
  }
}

Q7B Q7B_SECOND(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->time().second() );
}   

Q7B Q7B_MINUTE(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->time().minute() );
}   

Q7B Q7B_HOUR(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->time().hour() );
}   

Q7B Q7B_MONTH(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->date().month() );
}   

Q7B Q7B_YEAR(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->date().year() );
}   

Q7B Q7B_DAY(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->date().day() );
}   

Q7B Q7B_ISLEAPYEAR(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QDate::isLeapYear( ((QDateTime *) Q7B_Object->ref)->date().day() ) );
}   

Q7B Q7B_ISDATETIMEVALID(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->isValid() );
}   

Q7B Q7B_ISDATEVALID(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->date().isValid() );
}    

Q7B Q7B_ISTIMEVALID(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DATETIME(Q7B_Object))){ Q7B_EXCEPTION("DateTime expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QDateTime *) Q7B_Object->ref)->time().isValid() );
}    



Q7B Q7B_STRREVERSE(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString t;
  for (qint64 i = 0; i < ((QString *) Q7B_Object->ref)->length(); i++){
    t = ((QString *) Q7B_Object->ref)->at(i) + t;
  }
  return Q7B_QOBJECT(t);
}

Q7B Q7B_FILL(Q7B Q7B_Object, Q7B Character, Q7B Size)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Character))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Size))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT(((QString *) Q7B_Object->ref)->fill(((QString *) Character->ref)->at(0), Q7B_IDqint64(Size)));
}

Q7B Q7B_INSERT(Q7B Q7B_Object, Q7B Position, Q7B Str)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT(((QString *) Q7B_Object->ref)->insert(Q7B_IDqint64(Position), *((QString *) Str->ref)));
}

Q7B Q7B_NZ(Q7B Q7B_Object, Q7B ReturnValue)
{
  if (Q7B_nil(Q7B_Object)){ 
    return ReturnValue;
  }

  return Q7B_Object;
}

void Q7B_MIDASSIGNMENT(Q7B *l, Q7B Position, Q7B Length, Q7B r)
{  
  if (Q7B_nil(*l)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QSTRING(*l))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Length))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(r))){ Q7B_EXCEPTION("String expected"); return; }

  QString rr = Q7B_IDQString(r);
  Q7B a = *l;
  ((QString *) a->ref)->replace(Q7B_IDqint64(Position), Q7B_IDqint64(Length), rr.left(Q7B_IDqint64(Length)));
}

Q7B Q7B_LEFT(Q7B Q7B_Object, Q7B Position)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->left( *((qint64 *) Position->ref ) ) );
}

Q7B Q7B_TRUNCATE(Q7B Q7B_Object, Q7B Position)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  ((QString *) Q7B_Object->ref)->truncate( *((qint64 *) Position->ref ) );
  return Q7B_QOBJECT( Q7B_Object );
}

Q7B Q7B_SECTION(Q7B Q7B_Object, Q7B Separator, Q7B Start, Q7B End, Q7B SectionFlags)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Separator))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Start))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(End))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(SectionFlags))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->section( Q7B_IDQString(Separator), Q7B_IDqint64(Start), Q7B_IDqint64(End), (QString::SectionFlags) Q7B_IDqint64(SectionFlags) ) );
}

Q7B Q7B_LEFTJUSTIFIED(Q7B Q7B_Object, Q7B Width, Q7B Fill, Q7B Truncate)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Width))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Fill))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Truncate))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  QChar c = ' ';
  QString s = Q7B_IDQString(Fill);
  if (!s.isEmpty()) c = s[0];
  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->leftJustified( Q7B_IDqint64(Width), c, Q7B_IDbool(Truncate) ) );
}

Q7B Q7B_RIGHTJUSTIFIED(Q7B Q7B_Object, Q7B Width, Q7B Fill, Q7B Truncate)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Width))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Fill))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Truncate))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  QChar c = ' ';
  QString s = Q7B_IDQString(Fill);
  if (!s.isEmpty()) c = s[0];
  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->rightJustified( Q7B_IDqint64(Width), c, Q7B_IDbool(Truncate) ) );
}

QString Q7B_LoadString(Q7B Q7B_Object, QString sEncoding)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return ""; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return ""; }

  QString sWhere = *((QString *) Q7B_Object->ref);
  if (sWhere.startsWith("www.")){
    sWhere = "http://" + sWhere;
  }
  QString s;

  if (sWhere.startsWith("file:///")){
    sWhere = sWhere.mid(QString("file:///").length());
  }

  QUrl url(sWhere); 
  if (url.isValid() && !Q7B_fileExists(sWhere)){

    QHttp http;
    http.setHost(url.host());     

    QString q = url.encodedQuery();
    if (!q.isEmpty()){
      q = q.prepend("?");
    }
    QString z = QString(url.encodedPath()) + q;
    http.get(z);

    while(http.currentId() > 0 && http.error() == QHttp::NoError){
      qApp->processEvents();
    }
    if (http.error() != QHttp::NoError){
    } else {
      if (http.bytesAvailable()){
        QByteArray a = http.readAll();
        s = QString::fromUtf8(a.data(), a.size());
      }
    }

  } else {
    
    
    QFile f;

    

    if (QFile::exists(qApp->applicationDirPath() + "/" + sWhere)){ 
      f.setFileName(qApp->applicationDirPath() + "/" + sWhere);
    } else {
      f.setFileName(sWhere);
    }

    
    if (!f.open(QIODevice::ReadOnly)){
    } else {
      QTextStream t(&f);
      if (sEncoding == "Locale"){
      } else if (sEncoding == ""){
        t.setCodec("UTF-8");
      } else {
        t.setCodec(sEncoding.toAscii());
      }
      t.setAutoDetectUnicode(true);
      t.setGenerateByteOrderMark(true);
      s = t.readAll();      
      f.close();
    }
  }

  return s;
}

Q7B Q7B_READSTRING(Q7B Q7B_Object, Q7B Encoding)
{
  if (Q7B_nil(Q7B_QSTRING(Encoding))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( Q7B_LoadString(Q7B_Object, Q7B_IDQString(Encoding) ) );
}

Q7B Q7B_READCSTRING(Q7B Q7B_Object)
{
  return Q7B_QOBJECT( Q7B_LoadString(Q7B_Object, "ISO 8859-1" ) );
}

Q7B Q7B_WRITECSTRING(Q7B Q7B_Object, Q7B FilePathOrURL)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FilePathOrURL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWhere = *((QString *) FilePathOrURL->ref);
 
  if (sWhere.startsWith("file:///")){
    sWhere = sWhere.mid(QString("file:///").length());
  }  
  
  QFile f(sWhere);
  if (!f.open(QIODevice::Truncate | QIODevice::WriteOnly)){
  } else {
    QTextStream t(&f);
    t.setCodec("ISO 8859-1");
   
   
    t << *((QString *) Q7B_Object->ref);      
    f.close();

    return Q7B_QOBJECT( true );
  }
  
  return Q7B_QOBJECT( false );
}

Q7B Q7B_WRITESTRING(Q7B Q7B_Object, Q7B FilePathOrURL, Q7B Encoding)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FilePathOrURL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Encoding))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sEncoding = Q7B_IDQString(Encoding);

  QString sWhere = *((QString *) FilePathOrURL->ref);
 
  if (sWhere.startsWith("file:///")){
    sWhere = sWhere.mid(QString("file:///").length());
  }  
  
  QFile f(sWhere);
  if (!f.open(QIODevice::Truncate | QIODevice::WriteOnly)){
  } else {
    QTextStream t(&f);

    if (sEncoding == "Locale"){
    } else if (sEncoding == ""){
      t.setCodec("UTF-8");
    } else {
      t.setCodec(sEncoding.toAscii());
    }

    t.setAutoDetectUnicode(true);
    t.setGenerateByteOrderMark(true);
    t << *((QString *) Q7B_Object->ref);      
    f.close();

    return Q7B_QOBJECT( true );
  }
  
  return Q7B_QOBJECT( false );
}

Q7B Q7B_ISEMPTY(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->isEmpty() );
}

Q7B Q7B_LEN(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->length() );
}

Q7B Q7B_LTRIM(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (((QString *) Q7B_Object->ref)->isEmpty()) return Q7B_Object;

  int i = 0;
  while (i < ((QString *) Q7B_Object->ref)->length() && ((QString *) Q7B_Object->ref)->at(i).isSpace()) i++;

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->mid(i) );
}

Q7B Q7B_REVERSED(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString s;

  for (int i = ((QString *) Q7B_Object->ref)->length() - 1; i >= 0; i--){
    s += ((QString *) Q7B_Object->ref)->at(i);
  }

  return Q7B_QOBJECT( s );
}

Q7B Q7B_RTRIM(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  if (((QString *) Q7B_Object->ref)->isEmpty()) return Q7B_Object;

  int i = ((QString *) Q7B_Object->ref)->length();
  while (((QString *) Q7B_Object->ref)->at(i - 1).isSpace()) i--;

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->left(i) );
}

Q7B Q7B_FILENAME(Q7B FilePath)
{
  if (Q7B_nil(FilePath)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_QOBJECT( QFileInfo( *((QString *) FilePath->ref)).fileName()  );
}

Q7B Q7B_FILEBASENAME(Q7B FilePath)
{
  if (Q7B_nil(FilePath)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_QOBJECT( QFileInfo( *((QString *) FilePath->ref)).baseName()  );
}

Q7B Q7B_FILEEXTENSION(Q7B FilePath)
{
  if (Q7B_nil(FilePath)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_QOBJECT( QFileInfo( *((QString *) FilePath->ref)).completeSuffix()  );
}

Q7B Q7B_FILEPATH(Q7B FilePath)
{
  if (Q7B_nil(FilePath)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
  return Q7B_QOBJECT( QFileInfo( *((QString *) FilePath->ref)).absolutePath()  );
}

Q7B Q7B_STRING(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_QOBJECT(Q7B_toString2(Q7B_Object));  
}

Q7B Q7B_AT(Q7B Q7B_Object, Q7B Index)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  
  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->at( *((qint64 *) Index->ref ) ) );
}

Q7B Q7B_UNICODE(Q7B Q7B_Object, Q7B Index)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  
  QChar c = ((QString *) Q7B_Object->ref)->at( *((qint64 *) Index->ref ) );
  return Q7B_QOBJECT( c.unicode() );
}

Q7B Q7B_MID(Q7B Q7B_Object, Q7B Index, Q7B Length)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Length))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  
  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->mid( *((qint64 *) Index->ref ), *((qint64 *) Length->ref ) ) );
}

Q7B Q7B_RIGHT(Q7B Q7B_Object, Q7B Position)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->right( *((qint64 *) Position->ref ) ) );
}

Q7B Q7B_SPLIT(Q7B Q7B_Object, Q7B Separator, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Separator))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->split( *((QString *) Separator->ref), QString::KeepEmptyParts, (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_SPACE(Q7B Q7B_Object, Q7B Count, Q7B FillWith)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Count))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FillWith))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sResult = Q7B_IDQString(FillWith); sResult.repeated( Q7B_IDqint64(Count) );
  
  return Q7B_QOBJECT( sResult );
}

Q7B Q7B_JOIN(Q7B Q7B_Object, Q7B Separator)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_LIST(Q7B_Object))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Separator))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_List *) Q7B_Object->ref)->join( *((QString *) Separator->ref) ) );
}

Q7B Q7B_SIMPLIFIED(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->simplified() );
}

Q7B Q7B_TRIM(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->trimmed() );
}

Q7B Q7B_INSTR(Q7B Q7B_Object, Q7B Search, Q7B Index, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->indexOf( *((QString *) Search->ref), *((qint64 *) Index->ref), (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_INSTRREV(Q7B Q7B_Object, Q7B Search, Q7B Index, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Index))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->lastIndexOf( *((QString *) Search->ref), *((qint64 *) Index->ref), (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_CONTAINS(Q7B Q7B_Object, Q7B Search, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->contains( *((QString *) Search->ref), (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_APPEND(Q7B Q7B_Object, Q7B Append)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Append))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->append( *((QString *) Append->ref) ) );
}

Q7B Q7B_PREPEND(Q7B Q7B_Object, Q7B Prepend)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Prepend))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->prepend( *((QString *) Prepend->ref) ) );
}

Q7B Q7B_LCASE(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->toLower() );
}

Q7B Q7B_UCASE(Q7B Q7B_Object)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->toUpper() );
}

Q7B Q7B_COMPARE(Q7B Q7B_Object, Q7B Search, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->compare( *((QString *) Search->ref), (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_REPLACE(Q7B Q7B_Object, Q7B Search, Q7B Replace, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Replace))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->replace( *((QString *) Search->ref), *((QString *) Replace->ref), (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_REMOVE(Q7B Q7B_Object, Q7B Position, Q7B Length)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Length))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->remove( Q7B_IDqint64(Position), Q7B_IDqint64(Length) ) );
}

Q7B Q7B_COUNT(Q7B Q7B_Object, Q7B Search, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->count( *((QString *) Search->ref), (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_STARTSWITH(Q7B Q7B_Object, Q7B Search, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->startsWith( *((QString *) Search->ref), (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_ENDSWITH(Q7B Q7B_Object, Q7B Search, Q7B CaseSensitive)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Search))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(CaseSensitive))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QString *) Q7B_Object->ref)->endsWith( *((QString *) Search->ref), (*((bool *) CaseSensitive->ref) ?  Qt::CaseSensitive :  Qt::CaseInsensitive) ) );
}

Q7B Q7B_CHARACTER(Q7B Unicode)
{
  if (Q7B_nil(Unicode)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Unicode))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  QChar c( (int) *((qint64 *) Unicode->ref) );

  return Q7B_QOBJECT( QString(c) );
}

Q7B Q7B_VALUE(Q7B Str)
{
  if (Q7B_nil(Str)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Str))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  bool ok;
  qreal r = ((QString *) Str->ref)->toDouble(&ok);
  
  if (ok) return Q7B_QOBJECT(r);

  return Q7B_idnil;
}

Q7B Q7B_BIN(Q7B Number)
{
  if (Q7B_nil(Number)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Number))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QString::number(*((qint64 *) Number->ref), 2) );
}

Q7B Q7B_HEX(Q7B Number)
{
  if (Q7B_nil(Number)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Number))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QString::number(*((qint64 *) Number->ref), 16) );
}

Q7B Q7B_FORMAT(Q7B Number, Q7B Locale)
{
  if (Q7B_nil(Number)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOLEAN(Locale))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( Q7B_toString2(Number) );
}

Q7B Q7B_FORMATFLOAT(Q7B Number, Q7B Locale, Q7B DecimalPlaceLength)
{
  if (Q7B_nil(Number)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_FLOAT(Number))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Locale))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(DecimalPlaceLength))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( Q7B_toString2(Number) );
}

Q7B Q7B_FORMATDECIMAL(Q7B Number, Q7B Locale, Q7B DecimalPlaceLength)
{
  if (Q7B_nil(Number)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DECIMAL(Number))){ Q7B_EXCEPTION("Decimal expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Locale))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(DecimalPlaceLength))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( Q7B_toString2(Number) );
}



#ifndef Q7BPLUGINS

QMap<QString, Q7B>q7b_ui;

QWidget* Q7B_CREATE_FROM_UI_FILE(QString uiName, QWidget *parentWidget)
{
   QUiLoader loader;

   loader.clearPluginPaths(); 

   QFile file(uiName);
   if (file.open(QFile::ReadOnly)){
     QWidget *formWidget = loader.load(&file, parentWidget);
     file.close();
     return formWidget;
   }

   return 0;
}

extern Q7B Q7B_GLOBAL_LOADUI(QString uiName);

void Q7B_OPENTEXTWINDOW(Q7B Text)
{
  if (Q7B_nil(Text)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

  QString s = *((QString *) Text->ref);
  s = s.replace("\n", "<br>");
	QTextEdit *e = new QTextEdit( s ); 

  e->setAttribute(Qt::WA_DeleteOnClose);
  e->setReadOnly(true);
  e->showMaximized();
}

void Q7B_OPENHTMLWINDOW(Q7B Text)
{
  if (Q7B_nil(Text)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

	QTextEdit *e = new QTextEdit( *((QString *) Text->ref) ); 
  e->setAttribute(Qt::WA_DeleteOnClose);
  e->setReadOnly(true);
  e->showMaximized();
}

void Q7B_OPENWEBWINDOW(Q7B Text)
{
  if (Q7B_nil(Text)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QSTRING(Text))){ Q7B_EXCEPTION("String expected"); return; }

	QWebView *e = new QWebView( ); 
  e->setAttribute(Qt::WA_DeleteOnClose);
  e->setHtml( *((QString *) Text->ref) );
  e->showMaximized();
}

Q7B Q7B_LOADUI(Q7B uiName)
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

	return Q7B_QOBJECT( Q7B_GLOBAL_LOADUI( *((QString *) uiName->ref) ) );
}

Q7B Q7B_UNLOADUI(Q7B uiWidget)
{
  if (Q7B_nil(uiWidget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(uiWidget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QWidget *) uiWidget->ref)->close() );
}

extern Q7B Q7B_GLOBAL_OPENWINDOW(QString uiName);

Q7B Q7B_OPENWINDOW(Q7B uiName)
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

	return Q7B_QOBJECT( Q7B_GLOBAL_OPENWINDOW( *((QString *) uiName->ref) ) );
}

extern Q7B Q7B_GLOBAL_OPENTOOLWINDOW(QString uiName);

Q7B Q7B_OPENTOOLWINDOW(Q7B uiName)
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( Q7B_GLOBAL_OPENTOOLWINDOW( *((QString *) uiName->ref) ) );

}

Q7B Q7B_OPENDOCKWIDGET(Q7B uiName)
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  Q7B q7b_this = Q7B_GLOBAL_LOADUI( *((QString *) uiName->ref) );
  QWidget *w = ((QWidget *) q7b_this->ref);

  if (w){
    QDockWidget *dw = qobject_cast<QDockWidget *>(w);
    if (dw){
      
      int n = dw->allowedAreas();
      if (n > 0x8) n = Qt::LeftDockWidgetArea;
      ((QMainWindow *) Q7B_idMAINWINDOW->ref)->addDockWidget((Qt::DockWidgetArea) ((n & Qt::LeftDockWidgetArea) | (n & Qt::RightDockWidgetArea) | (n & Qt::TopDockWidgetArea) | (n & Qt::BottomDockWidgetArea)), dw);


      return q7b_this;
    }
  }

  return Q7B_idnil;
}

QMdiArea *Q7B_getDefaultMDI()
{
  QWidget *cw = ((QMainWindow *) Q7B_idMAINWINDOW->ref)->centralWidget();
  if (cw){
    QObjectList ol = cw->children();
  
    for (int q = 0; q < ol.size(); q++){

      QMdiArea *mdi = qobject_cast<QMdiArea *>(ol.at(q));
      if (mdi){
        return mdi;
      }
    }
  }
  return 0;
}

Q7B Q7B_OPENMDI(Q7B uiName) 
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  Q7B q7b_this = Q7B_GLOBAL_LOADUI( *((QString *) uiName->ref) );

 
  QWidget *w = ((QWidget *) q7b_this->ref);

  
  


  if (w){
    QMdiArea *mdi = Q7B_getDefaultMDI();

    if (mdi){
       QMdiSubWindow  *sw = mdi->addSubWindow(w, Qt::Window | Qt::CustomizeWindowHint | Qt::WindowTitleHint);    
 
   
   
       sw->showNormal();

       return q7b_this;
    }   
  }

  return Q7B_idnil;
}

Q7B Q7B_OPENSDI(Q7B uiName)
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  Q7B q7b_this = Q7B_GLOBAL_LOADUI( *((QString *) uiName->ref) );
  QWidget *w = ((QWidget *) q7b_this->ref);

  if (w){
    QWidget *cw = ((QMainWindow *) Q7B_idMAINWINDOW->ref)->centralWidget();
    if (cw){
      cw->hide();
    }
    ((QMainWindow *) Q7B_idMAINWINDOW->ref)->setCentralWidget( w );

    return q7b_this;

  }

  return Q7B_idnil;
}

extern Q7B Q7B_GLOBAL_OPENDIALOG(QString uiName);

Q7B Q7B_OPENDIALOG(Q7B uiName)
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  Q7B q7b_this = Q7B_GLOBAL_OPENDIALOG( *((QString *) uiName->ref) );
	QWidget *w = ((QWidget *) q7b_this->ref);

  QDialog *d = qobject_cast<QDialog *>(w);
  if (d){

    int n = d->windowFlags();
    d->setParent(((QMainWindow *) Q7B_idMAINWINDOW->ref));
    d->setWindowFlags((Qt::WindowFlags) n);

    bool b = d->testAttribute(Qt::WA_DeleteOnClose);

    int dd = d->exec();

    q7b_ui.remove( *((QString *) uiName->ref) );
  

    q7b_this->ref = 0;
   

    if (!b){
      d->deleteLater();
     
    }
    
   

    q7b_this = Q7B_IDNIL();
    
    return Q7B_QOBJECT( dd );
  }

  { Q7B_EXCEPTION("QDialog expected (= Null)"); return Q7B_idnil; }

 
}

extern bool Q7B_GLOBAL_CLOSEWINDOW(QString uiName);

Q7B Q7B_CLOSEWINDOW(Q7B uiName)
{
  if (Q7B_nil(uiName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(uiName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

	return Q7B_QOBJECT( Q7B_GLOBAL_CLOSEWINDOW( *((QString *) uiName->ref) ) );
}

Q7B Q7B_CLOSEMDI(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  QMdiArea *mdi = Q7B_getDefaultMDI(); 
  QList<QMdiSubWindow *>l = mdi->subWindowList();

  for (int i = 0; i < l.size(); i++){
    if (l.at(i) == ((QWidget *) Widget->ref)->parentWidget()){
      ((QWidget *) Widget->ref)->parentWidget()->close();
      return Q7B_QOBJECT( true );
    }
  }

	return Q7B_QOBJECT( false );
}

Q7B Q7B_CLOSEALLMDI()
{
  QMdiArea *mdi = Q7B_getDefaultMDI(); 
  mdi->closeAllSubWindows();

  QList<QMdiSubWindow *>l = mdi->subWindowList();
	return Q7B_QOBJECT( l.size() == 0 );
}

Q7B Q7B_CLOSE(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QWidget *) Widget->ref)->close() );
}

Q7B Q7B_FOCUSWINDOW()
{
  return Q7B_QOBJECT( qApp->activeWindow() );
}

Q7B Q7B_FOCUS()
{
  return Q7B_QOBJECT( qApp->focusWidget() );
}

Q7B Q7B_LISTMDI()
{
  QMdiArea *mdi = Q7B_getDefaultMDI();  
  QList<QMdiSubWindow *>l = mdi->subWindowList();

  Q7B_List *a = new Q7B_List();
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), a)); 

  for (int i = 0; i < l.size(); i++){

    

     a->append(Q7B_QOBJECT(l.at(i)->widget()));
  }

  return q;
}

  

void Q7B_SETFOCUSMDI(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  QMdiArea *mdi = Q7B_getDefaultMDI();  
  QMdiSubWindow *sw = qobject_cast<QMdiSubWindow *>( ((QWidget *) Widget->ref)->parentWidget() );

  if (mdi && sw){
    mdi->setActiveSubWindow(sw);
    ((QWidget *) Widget->ref)->setFocus(Qt::ActiveWindowFocusReason);
  }
}

Q7B Q7B_FOCUSMDI()
{
  QMdiArea *mdi = Q7B_getDefaultMDI();  

  if (mdi){
    QMdiSubWindow *sw = mdi->currentSubWindow();
    
    if (sw){
      return Q7B_QOBJECT( sw->widget() );
      
          
    }
  }
  return Q7B_idnil;
}



void Q7B_SETFOCUSWINDOW(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) Widget->ref)->show();
  ((QWidget *) Widget->ref)->activateWindow();
  ((QWidget *) Widget->ref)->setFocus(Qt::ActiveWindowFocusReason);
}

void Q7B_SETFOCUS(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) Widget->ref)->show();
  ((QWidget *) Widget->ref)->setFocus(Qt::OtherFocusReason);
}

void Q7B_HIDE(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) Widget->ref)->hide();
}

void Q7B_SHOW(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) Widget->ref)->show();
}

void Q7B_SHOWNORMAL(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) Widget->ref)->showNormal();
}

void Q7B_SHOWMAXIMIZED(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) Widget->ref)->showMaximized();
}

void Q7B_SHOWMINIMIZED(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) Widget->ref)->showMinimized();
}

void Q7B_SHOWORHIDE(Q7B Widget)
{
  if (Q7B_nil(Widget)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QWIDGET(Widget))){ Q7B_EXCEPTION("QWidget expected"); return; }

  ((QWidget *) Widget->ref)->setVisible(((QWidget *) Widget->ref)->isVisible());
}

#endif



#include <cmath>
#include <math.h>

#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <ctype.h>

qint64 Q7B_lStartValue = 0;
qreal Q7B_dLastRND = 0;
  
void Q7B_RANDOMIZE()
{	
  Q7B_lStartValue = 0;

  static  struct tm *timep;
  static  time_t atime;

  time(&atime); timep=localtime(&atime);

  Q7B_lStartValue = timep->tm_sec + (qint64) timep;

  
  Q7B_lStartValue = 16807L * (Q7B_lStartValue % 127773L) - 2836L * (Q7B_lStartValue / 127773L);
  if (Q7B_lStartValue <= 0) Q7B_lStartValue += 2147483647;
  Q7B_dLastRND = (qreal) Q7B_lStartValue / 2147483648.0;

  Q7B_lStartValue = 16807L * (Q7B_lStartValue % 127773L) - 2836L * (Q7B_lStartValue / 127773L);
  if (Q7B_lStartValue <= 0) Q7B_lStartValue += 2147483647;
  Q7B_dLastRND = (qreal) Q7B_lStartValue / 2147483648.0;

}

Q7B Q7B___RANDOM(bool bExpression, Q7B dValue)
{
  if (Q7B_nil(dValue)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_FLOAT(dValue))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }

  qreal dVALUE = 0;

  if (bExpression && dValue->ref != 0){
    dVALUE = *((qint64 *) dValue->ref);
  }

  if (Q7B_dLastRND == 0){ 
     Q7B_RANDOMIZE();
  }

	if (bExpression){
    if (dVALUE == 0) return Q7B_QOBJECT( Q7B_dLastRND );

    if (dVALUE < 0){
      Q7B_lStartValue = dVALUE * 10000;

      Q7B_lStartValue = 16807L * (Q7B_lStartValue % 127773L) - 2836L * (Q7B_lStartValue / 127773L);
      if (Q7B_lStartValue <= 0) Q7B_lStartValue += 2147483647;
      Q7B_dLastRND = (qreal) Q7B_lStartValue / 2147483648.0;

      return Q7B_QOBJECT( Q7B_dLastRND );
    }
	}

  Q7B_lStartValue = 16807L * (Q7B_lStartValue % 127773L) - 2836L * (Q7B_lStartValue / 127773L);
  if (Q7B_lStartValue <= 0) Q7B_lStartValue += 2147483647;
  Q7B_dLastRND = (qreal) Q7B_lStartValue / 2147483648.0;

  if (bExpression && dVALUE > 0){
    Q7B_dLastRND *= dVALUE;
  }

	return Q7B_QOBJECT( Q7B_dLastRND );

}

Q7B Q7B__RANDOM()
{
  return  Q7B___RANDOM(false, Q7B_idnil);
}

Q7B Q7B_RANDOM(Q7B dValue)
{
  if (Q7B_nil(dValue)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_FLOAT(dValue))){ Q7B_EXCEPTION("Float expected"); return Q7B_idnil; }

  return  Q7B___RANDOM(true, dValue);
}

Q7B Q7B_BITCLR(Q7B Value, Q7B Position)
{
  if (Q7B_nil(Value)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  qint64 n = *((qint64 *) Value->ref);
  qint64 b = ~(1 << *((qint64 *) Position->ref));
  n &= b; 

	return Q7B_QOBJECT(n);
}

Q7B Q7B_BITSET(Q7B Value, Q7B Position)
{
  if (Q7B_nil(Value)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  qint64 n = *((qint64 *) Value->ref);
  qint64 b = 1 << *((qint64 *) Position->ref);
  n |= b; 

	return Q7B_QOBJECT(n);
}

Q7B Q7B_BITTST(Q7B Value, Q7B Position)
{
  if (Q7B_nil(Value)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Value))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Position))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  qint64 n = (*((qint64 *) Value->ref)) >> (*((qint64 *) Position->ref));
  qint64 b = 1;
  n &= b; 

  return Q7B_QOBJECT(n != 0);
}

Q7B Q7B__MIN(Q7B l, Q7B r)
{
  qreal _l = Q7B_toFloat2(l); if (Q7B_bException){ return Q7B_idnil; }
  qreal _r = Q7B_toFloat2(r); if (Q7B_bException){ return Q7B_idnil; }

	return Q7B_QOBJECT((_l <= _r)? _l : _r);
}

Q7B Q7B__MAX(Q7B l, Q7B r)
{
  qreal _l = Q7B_toFloat2(l); if (Q7B_bException){ return Q7B_idnil; }
  qreal _r = Q7B_toFloat2(r); if (Q7B_bException){ return Q7B_idnil; }

  return Q7B_QOBJECT((_l >= _r)? _l : _r);
}

Q7B Q7B_FACT(Q7B m)
{
  qreal _m = Q7B_toFloat2(m); if (Q7B_bException){ return Q7B_idnil; }



  
  qreal x;
  qreal y;
  y = 1;
  for (x = 1; x <= _m; x++){
       y = y * x;
  }  
	return Q7B_QOBJECT(y);
}

Q7B Q7B_ROUND(Q7B l, Q7B r)
{
  qreal _l = Q7B_toFloat2(l); if (Q7B_bException){ return Q7B_idnil; }
  qreal _r = Q7B_toFloat2(r); if (Q7B_bException){ return Q7B_idnil; }

  
 
 

  
  
  qreal m = 1;
  for (qint64 i = 0; i < _r; i++){
    m = m * 10;
  }

  
  bool b = _l < 0;
  if (b) _l = -_l;
  _l = (_l * m + 0.5) / m;
  if (b) _l = -_l;
  qint64 g = _l * m;
  _l = g / m;

  return Q7B_QOBJECT(_l);
}



void Q7B_STDOUT(Q7B m)
{
 
  
  QFile file;
  if (file.open(stdout, QIODevice::WriteOnly)){
    const char *ac = (QDateTime::currentDateTime().toString(Qt::ISODate) + " " + Q7B_toString2(m) + QString("\n")).toLocal8Bit().constData();
    file.write(ac, qstrlen(ac)); 
    file.flush();
    file.close();
  }
}

void Q7B_STDERR(Q7B m)
{


  QFile file;
  if (file.open(stderr, QIODevice::WriteOnly)){
    const char *ac = (QDateTime::currentDateTime().toString(Qt::ISODate) + " " + Q7B_toString2(m) + QString("\n")).toLocal8Bit().constData();
    file.write(ac, qstrlen(ac)); 
    file.flush();
    file.close();
  }
  
}

Q7B Q7B_READREGISTRY(Q7B RegistryPath, Q7B RegistryKey)
{
  if (Q7B_nil(RegistryPath)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(RegistryPath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(RegistryKey))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QSettings settings(*((QString *) RegistryPath->ref), QSettings::NativeFormat);

  return Q7B_QOBJECT( settings.value(*((QString *) RegistryKey->ref)).toString()); 
}



Q7B Q7B_OPENURL(Q7B PathOrURL)
{
  if (Q7B_nil(PathOrURL)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(PathOrURL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString k = *((QString *) PathOrURL->ref);
  
  if (QFile::exists(qApp->applicationDirPath() + "/" + k)){ 
    return Q7B_QOBJECT( QDesktopServices::openUrl( QUrl("file:///" + qApp->applicationDirPath() + "/" + k) ) );
  }

  if (QFile::exists(k)){
    return Q7B_QOBJECT( QDesktopServices::openUrl( QUrl("file:///" + k) ) );
  }



  if (QFile::exists(qApp->applicationDirPath() + "/" + k)){
    return Q7B_QOBJECT( QDesktopServices::openUrl( QUrl("file:///" + qApp->applicationDirPath() + "/" + k) ) );
  }

  return Q7B_QOBJECT( QDesktopServices::openUrl( QUrl(k) ) );  	
}

Q7B Q7B_OPENEMAIL(Q7B SenderEmail, Q7B Subject, Q7B Body)
{
  if (Q7B_nil(SenderEmail)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(SenderEmail))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Subject))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Body))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QDesktopServices::openUrl( QUrl( QString("mailto:") + *((QString *) SenderEmail->ref) + "?subject=" + *((QString *) Subject->ref) + "&body=" + *((QString *) Body->ref)) ) );  	
}

Q7B Q7B_FLOAT(Q7B Expression, Q7B Locale)
{
  

  if (Q7B_nil(Expression)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  
  if (Q7B_nil(Q7B_BOOLEAN(Locale))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  

  if (Expression->type == typeid(qreal).name()){
    return Expression;
  }

  if (Expression->type == typeid(qint64).name()){
    return Q7B_QOBJECT( (qreal) (*((qint64 *) Expression->ref)) );  
  }

  if (Expression->type == typeid(Q7B_Decimal).name()){
    return Q7B_QOBJECT( (qreal) (((Q7B_Decimal *) Expression->ref)->toFloat()) );  
  }

  if (Expression->type == typeid(QString).name()){
    bool ok;
    qreal f = ((QString *) Expression->ref)->toDouble(&ok); 
    if (ok) return Q7B_QOBJECT( f );
  }

  

  return Q7B_QOBJECT((qreal) 0);  
}

Q7B Q7B_BOOLEAN(Q7B Expression, Q7B Locale)
{
  if (Q7B_nil(Expression)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  
  if (Q7B_nil(Q7B_BOOLEAN(Locale))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  

  if (Expression->type == typeid(bool).name()){
    return Expression;
  }

  if (Expression->type == typeid(qreal).name()){
    return Q7B_QOBJECT( (bool) (*((qreal *) Expression->ref)) );  
  }
  
  if (Expression->type == typeid(qint64).name()){
    return Q7B_QOBJECT( (bool) (*((qint64 *) Expression->ref)) );  
  }

  if (Expression->type == typeid(Q7B_Decimal).name()){
    return Q7B_QOBJECT( (bool) (((Q7B_Decimal *) Expression->ref)->toFloat()) );  
  }

  bool ok;
  if (Expression->type == typeid(QString).name()){    
    bool b = ((QString *) Expression->ref)->toInt(&ok) != 0; 
    if (ok) return Q7B_QOBJECT( b );
  }

  bool b = Q7B_toString2( Expression ).toInt(&ok) != 0; 
  if (ok) return Q7B_QOBJECT( b );

  return Q7B_QOBJECT(false);  
}

Q7B Q7B_STRING(Q7B Expression, Q7B Locale)
{
  if (Q7B_nil(Expression)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_BOOLEAN(Locale))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Expression->type == typeid(QString).name()){
    return Expression;
  }

  return Q7B_QOBJECT( Q7B_toString2( Expression ) );
}

Q7B Q7B_DECIMAL(Q7B Expression, Q7B Locale)
{
  if (Q7B_nil(Expression)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  
  if (Q7B_nil(Q7B_BOOLEAN(Locale))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }


  if (Expression->type == typeid(qint64).name()){
    return Q7B_QOBJECT( Q7B_Decimal( (*((qint64 *) Expression->ref) )));
  }

  if (Expression->type == typeid(qreal).name()){
    return Q7B_QOBJECT( Q7B_Decimal( (*((qreal *) Expression->ref) )));    
  }

  if (Expression->type == typeid(QString).name()){
    return Q7B_QOBJECT( Q7B_Decimal( (*((QString *) Expression->ref) )));    
  }

  if (Expression->type == typeid(Q7B_Decimal).name()){
    Q7B_Decimal d;
    d.setValue( ((Q7B_Decimal *) Expression->ref)->value() );
    
    return Q7B_QOBJECT( d );  
  }
  
  return Q7B_QOBJECT( Q7B_Decimal( Q7B_toString2( Expression ) ) );
}

Q7B Q7B_DATETIME(Q7B Expression, Q7B Locale)
{
  if (Q7B_nil(Expression)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  
  if (Q7B_nil(Q7B_BOOLEAN(Locale))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( QDateTime::fromString( Q7B_toString2( Expression ), "yyyy-MM-dd hh:mm:ss" ) );
}

Q7B Q7B_INTEGER(Q7B Expression, Q7B Locale)
{
  if (Q7B_nil(Expression)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  
  if (Q7B_nil(Q7B_BOOLEAN(Locale))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  if (Expression->type == typeid(qint64).name()){
    return Expression;
  }

  if (Expression->type == typeid(qreal).name()){
    return Q7B_QOBJECT( (qint64) (*((qreal *) Expression->ref)) );  
  }

  if (Expression->type == typeid(Q7B_Decimal).name()){
    return Q7B_QOBJECT( (qint64) (((Q7B_Decimal *) Expression->ref)->toInteger()) );  
  }

  if (Expression->type == typeid(QString).name()){
    bool ok;
    qint64 n = ((QString *) Expression->ref)->toInt(&ok); 
    if (ok) return Q7B_QOBJECT( n );
  }

  return Q7B_QOBJECT((qint64) 0);  
}

void Q7B_WAIT(Q7B MSec)
{
  if (Q7B_nil(MSec)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_INTEGER(MSec))){ Q7B_EXCEPTION("Integer expected"); return; }

  QThread::currentThread()->wait( Q7B_IDqint64(MSec) );
}



const int Q7B_MAX_FILEHANDLE = 512;

const qint64 Q7B_pcode__INPUT = 1;
const qint64 Q7B_pcode__BINARY = 2;
const qint64 Q7B_pcode__RANDOM = 3;
const qint64 Q7B_pcode__OUTPUT = 4;
const qint64 Q7B_pcode__APPEND = 5;


struct Q7B_t_file2
{
  QFile f;
  qint64 nMode;
  qint64 nAccess;  
  qint64 nRecordLen;
  qint64 nRecordPos;
};

Q7B_t_file2 Q7B_file[Q7B_MAX_FILEHANDLE];

Q7B Q7B_FREEFILE(Q7B Range)
{
  if (Q7B_nil(Range)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(Range))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  int i;
  i = 0;
  if (Q7B_IDqint64(Range) == 0){
    i = 1;
  } else {
    i = 256;
  }

  for (; i < Q7B_MAX_FILEHANDLE; i++){
    if (!Q7B_file[i].f.isOpen()){
      return Q7B_QOBJECT((qint64) i);        
    }
  }

  return Q7B_QOBJECT((qint64) 0);  
}

Q7B Q7B_EOF(Q7B FILEHANDLE)
{
  if (Q7B_nil(FILEHANDLE)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_INTEGER(FILEHANDLE))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  qint64 nFILEHANDLE = Q7B_IDqint64(FILEHANDLE);

  if (!Q7B_file[nFILEHANDLE].f.isOpen()){  Q7B_EXCEPTION(QString("%1 (file) is not open").arg(nFILEHANDLE)); return Q7B_idnil; }
  
  return Q7B_QOBJECT( Q7B_file[nFILEHANDLE].f.atEnd() );
}

void Q7B_LINEINPUT(Q7B FILEHANDLE, Q7B *Var)
{
  if (Q7B_nil(FILEHANDLE)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_INTEGER(FILEHANDLE))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(*Var)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  qint64 nFILEHANDLE = Q7B_IDqint64(FILEHANDLE);

  if (!(nFILEHANDLE > 0 && nFILEHANDLE < Q7B_MAX_FILEHANDLE)){ Q7B_EXCEPTION(QString("%1 (file handle) is too big or too small").arg(nFILEHANDLE)); return; }  

  char ac[0xffff];

  if (Q7B_file[nFILEHANDLE].f.isOpen()){
    switch(Q7B_file[nFILEHANDLE].nMode){
   	  case Q7B_pcode__INPUT:
		  case Q7B_pcode__BINARY:
		  case Q7B_pcode__RANDOM:
        break;
      default:
        { Q7B_EXCEPTION(QString("%1 (file) is not open in the correct mode").arg(nFILEHANDLE)); return; }
    }

    int n = Q7B_file[nFILEHANDLE].f.readLine((char *) &ac, 0xffff - 1);			

    if (n == -1){ Q7B_EXCEPTION(QString("%1 (file) could not be read").arg(nFILEHANDLE)); return; }
    

    
    if (n > 0){
      if (ac[n - 2] == 0xd) ac[n - 2] = 0; 
      else ac[n - 1] = 0;
    }

  } else { Q7B_EXCEPTION(QString("%1 (file) not open").arg(nFILEHANDLE)); return; }  

  QString s = QString::fromLocal8Bit(ac);

  *Var = Q7B_QOBJECT( s ); 
  
  
}	

void Q7B_CLOSEFILE(Q7B FILEHANDLE)
{
  if (Q7B_nil(FILEHANDLE)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_INTEGER(FILEHANDLE))){ Q7B_EXCEPTION("Integer expected"); return; }

  qint64 nFILEHANDLE = Q7B_IDqint64(FILEHANDLE);

  if (!(nFILEHANDLE > 0 && nFILEHANDLE < Q7B_MAX_FILEHANDLE)){ Q7B_EXCEPTION(QString("%1 (file handle) too big or too small").arg(nFILEHANDLE)); return; }  

  if (Q7B_file[nFILEHANDLE].f.isOpen()){
    Q7B_file[nFILEHANDLE].f.close();		
  }
}	

void Q7B_CLOSEALLFILES()
{
	for (int i = 1; i < Q7B_MAX_FILEHANDLE; i++){
 		if (Q7B_file[i].f.isOpen()) Q7B_file[i].f.close();		
	}
}

void Q7B_OPEN(Q7B FileName, Q7B Mode, Q7B FILEHANDLE, Q7B Len)
{  
  if (Q7B_nil(FileName)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(FILEHANDLE))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(Len))){ Q7B_EXCEPTION("Integer expected"); return; }

  qint64 nFILEHANDLE = Q7B_IDqint64(FILEHANDLE);

  if (!(nFILEHANDLE > 0 && nFILEHANDLE < Q7B_MAX_FILEHANDLE)){ Q7B_EXCEPTION(QString("%1 (file handle) too big or too small").arg(nFILEHANDLE)); return; }  

  int nMode = 0;
  QString sMode = Q7B_IDQString(Mode);

  if (sMode == "Input") nMode = Q7B_pcode__INPUT;
  else if (sMode == "Output") nMode = Q7B_pcode__OUTPUT;
  else if (sMode == "Append") nMode = Q7B_pcode__APPEND;
  else if (sMode == "Binary") nMode = Q7B_pcode__BINARY;
  else if (sMode == "Random") nMode = Q7B_pcode__RANDOM;

  Q7B_file[nFILEHANDLE].nMode = nMode; 
  Q7B_file[nFILEHANDLE].nRecordPos = 1;

  QIODevice::OpenMode n;
  n = 0;
	switch(nMode){
		case Q7B_pcode__OUTPUT:
			n = QFile::WriteOnly;
      Q7B_file[nFILEHANDLE].nRecordLen = 512;
			break;				
 		case Q7B_pcode__INPUT:
			n = QFile::ReadOnly;
      Q7B_file[nFILEHANDLE].nRecordLen = 512;
			break;
		case Q7B_pcode__APPEND:
			n = QFile::Append | QFile::WriteOnly; 
      Q7B_file[nFILEHANDLE].nRecordLen = 512;
			break;
		case Q7B_pcode__BINARY:
			n = QFile::ReadWrite;
      Q7B_file[nFILEHANDLE].nRecordLen = 512;
			break;
		case Q7B_pcode__RANDOM:
			n = QFile::ReadWrite;
      Q7B_file[nFILEHANDLE].nRecordLen = 128;
			break;
   default:
     { Q7B_EXCEPTION(QString("%1 (file handle) OPEN: wrong file mode").arg(nFILEHANDLE)); return; }
     break;
	}

  if (Q7B_IDqint64(Len) >= 0) Q7B_file[nFILEHANDLE].nRecordLen = Q7B_IDqint64(Len);

  QString s2 = Q7B_IDQString(FileName);
  if (!s2.contains("/") && !s2.contains("\\")){
    QString s = Q7B_IDQString(FileName);
    s2 = qApp->applicationDirPath();
    s2 += "/";
    s2 += s;
  }

  Q7B_file[nFILEHANDLE].f.setFileName(s2);
  bool b = Q7B_file[nFILEHANDLE].f.open(n);

  QFile::FileError er = Q7B_file[nFILEHANDLE].f.error();

  if (!b){ Q7B_EXCEPTION(QString("%1 (file) could not be open").arg(nFILEHANDLE)); return; }  

  if (nMode == Q7B_pcode__APPEND){
    qint64 u;
    u = Q7B_file[nFILEHANDLE].f.size();
    Q7B_file[nFILEHANDLE].f.seek( u ); 
  } 

}



Q7B Q7B_RUN(Q7B FilePath, Q7B Arguments)
{
  if (Q7B_nil(FilePath)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_LIST(Arguments))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }

  QStringList l = ((Q7B_List *) Arguments->ref)->toStringList();
  QProcess p;
  p.start(*((QString *) FilePath->ref), l);

  p.waitForFinished(-1);

  QString s = p.readAllStandardError();
  s += p.readAllStandardOutput();

  return Q7B_QOBJECT( s );
}

Q7B Q7B_LAUNCH(Q7B FilePath, Q7B Arguments, Q7B WorkingDirectory, Q7B Wait)
{
  if (Q7B_nil(FilePath)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_LIST(Arguments))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(WorkingDirectory))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_BOOLEAN(Wait))){ Q7B_EXCEPTION("Boolean expected"); return Q7B_idnil; }

  QString workingDirectory = *((QString *) WorkingDirectory->ref);
  qint64 pid = 0;
  QStringList l = ((Q7B_List *) Arguments->ref)->toStringList();

  if (Q7B_IDbool(Wait)){
    return Q7B_QOBJECT( QProcess::execute(*((QString *) FilePath->ref), l) );
  } else {
    if (QProcess::startDetached(*((QString *) FilePath->ref), l, workingDirectory, &pid)){
      return Q7B_QOBJECT(pid);
    }
    return Q7B_QOBJECT((qint64)0);
  }
}

Q7B Q7B_SHELL(Q7B Command)
{
  if (Q7B_nil(Command)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Command))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString s = Q7B_IDQString(Command);
  
  return Q7B_QOBJECT( system(s.toLocal8Bit().data()) );
}

QString Q7B_PlaySound(QString sFilePath)
{
  if (!sFilePath.contains("/") && !sFilePath.contains("\\")){
    sFilePath = qApp->applicationDirPath() + "/" + sFilePath; 
  }  

  static Phonon::MediaObject *mediaObject = 0; 
  static Phonon::AudioOutput *audioOutput = 0; 

  if (mediaObject) delete mediaObject; 
  if (audioOutput) delete audioOutput; 

  mediaObject = new Phonon::MediaObject();
  audioOutput = new Phonon::AudioOutput(Phonon::MusicCategory);

  mediaObject->setCurrentSource(Phonon::MediaSource( sFilePath ));   
  Phonon::createPath(mediaObject, audioOutput);
  mediaObject->seek(0);
  mediaObject->play();

  
  
  return ( mediaObject->state() == Phonon::ErrorState ? mediaObject->errorString() : "" );
}

Q7B Q7B_PLAYSOUND(Q7B FileName)
{
  if (Q7B_nil(FileName)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
   
  return Q7B_QOBJECT( Q7B_PlaySound(Q7B_IDQString(FileName)) );
}

Q7B Q7B_PLAYMOVIE(Q7B FileName)
{
  return Q7B_QOBJECT("Sorry. Qt Bug in Qt 4.7.0 prevents this function working with Q7Basic yet.");

  if (Q7B_nil(Q7B_QSTRING(FileName))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  
    


  QWidget *my_movie = new Q7BMovie(0);
  my_movie->setWindowFlags(Qt::Window);


  my_movie->setWindowFlags(Qt::Window);

  QPixmap p(1, 1);
  p.fill(QColor(0, 0, 0, 0));
  my_movie->setCursor(p);
  
  my_movie->showMaximized();

 return Q7B_QOBJECT("");


}

void Q7B_fromXMLDictionary(QXmlStreamReader * xmlReader, Q7B_Dictionary *d, Q7B theArray2)
{
   QString sKey;

   while(!xmlReader->atEnd()){

      

     if (xmlReader->isStartElement()){

        if (xmlReader->name() == "key")       
        {
          sKey = xmlReader->readElementText(); 
        }
        else if (xmlReader->name() == "integer")       
        {
          if (theArray2.isNull()){
            d->me[sKey] = Q7B_QOBJECT( xmlReader->readElementText().toInt() );   
          } else {
            theArray2->q7b_array->append(Q7B_QOBJECT( xmlReader->readElementText().toInt() ));
          }                        
        }
        else if (xmlReader->name() == "float")
        {
          if (theArray2.isNull()){
            d->me[sKey] = Q7B_QOBJECT( xmlReader->readElementText().toDouble() );   
          } else {
            theArray2->q7b_array->append(Q7B_QOBJECT( xmlReader->readElementText().toDouble() ));
          }          
        }
        else if (xmlReader->name() == "boolean")
        {
          if (theArray2.isNull()){
            d->me[sKey] = Q7B_QOBJECT( xmlReader->readElementText() == "0" ? false : true );   
          } else {
            theArray2->q7b_array->append(Q7B_QOBJECT( xmlReader->readElementText() == "0" ? false : true ));
          }      
        }
        else if (xmlReader->name() == "string")
        {
          if (theArray2.isNull()){
            d->me[sKey] = Q7B_QOBJECT( xmlReader->readElementText() );   
          } else {
            theArray2->q7b_array->append(Q7B_QOBJECT( xmlReader->readElementText() ));
          }     
        }
        else if (xmlReader->name() == "datetime")
        {
          if (theArray2.isNull()){           
            d->me[sKey] = Q7B_QOBJECT( QDateTime::fromString(xmlReader->readElementText(), "yyyy-MM-dd hh:mm:ss") );   
          } else {
            theArray2->q7b_array->append(Q7B_QOBJECT( QDateTime::fromString(xmlReader->readElementText(), "yyyy-MM-dd hh:mm:ss") ));
          }     
        }
        else if (xmlReader->name() == "decimal")
        {
          if (theArray2.isNull()){           
            d->me[sKey] = Q7B_QOBJECT( Q7B_Decimal(xmlReader->readElementText()) );   
          } else {
            theArray2->q7b_array->append(Q7B_QOBJECT( Q7B_Decimal(xmlReader->readElementText()) ));
          }     
        }
        else if (xmlReader->name() == "null")
        {
          xmlReader->readElementText();

          if (theArray2.isNull()){
            d->me[sKey] = Q7B_idnil;   
          } else {
            theArray2->q7b_array->append(Q7B_idnil);
          }
        }
        else if (xmlReader->name() == "QByteArray")
        {
          QByteArray ba = QByteArray::fromBase64(xmlReader->readElementText().toAscii());
          if (theArray2.isNull()){
            d->me[sKey] = Q7B_QOBJECT(ba); 
          } else {
            theArray2->q7b_array->append(Q7B_QOBJECT(ba));
          }               
        }
        else if (xmlReader->name() == "QIcon")
        {
          QByteArray ba = QByteArray::fromBase64(xmlReader->readElementText().toAscii());
          if (theArray2.isNull()){
            d->me[sKey] = Q7B_QOBJECT(Q7B_QByteArray2QIcon(ba)); 
          } else {
            theArray2->q7b_array->append(Q7B_QOBJECT(Q7B_QByteArray2QIcon(ba)));
          }                         
        }
        else if (xmlReader->name() == "list" || xmlReader->name() == "array") 
        {
          Q7B_List *aa = new Q7B_List();
          Q7B q (new Q7B_id(typeid(Q7B_List).name(), aa));   

          if (theArray2.isNull()){
            d->me[sKey] = q; 
          } else {
            theArray2->q7b_array->append(q);
          }                   

          xmlReader->readNext();

          Q7B theArray;
          Q7B_fromXMLList(xmlReader, aa, theArray);

          xmlReader->readNext();

          

        }
        else if (xmlReader->name() == "dictionary")
        {
          if (d == 0) return;

          Q7B_Dictionary *dd = new Q7B_Dictionary();
          Q7B q (new Q7B_id(typeid(Q7B_Dictionary).name(), dd));   


          if (theArray2.isNull()){
            d->me[sKey] = q; 
          } else {
            theArray2->q7b_array->append(q);
          }       
          
          xmlReader->readNext();

          Q7B theArray;
          Q7B_fromXMLDictionary(xmlReader, dd, theArray);

          xmlReader->readNext();
        
        }
        else if (xmlReader->name() == "array2")
        {

          Q7B q (new Q7B_id());   

          if (theArray2.isNull()){
            d->me[sKey] = q; 
          } else {
            theArray2->q7b_array->append(q);
          }                   

          xmlReader->readNext();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "count")) return;
          q->q7b_array_count = xmlReader->readElementText().toInt();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "index0")) return;
          q->array_indexes[0] = xmlReader->readElementText().toInt();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "index1")) return;
          q->array_indexes[1] = xmlReader->readElementText().toInt();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "index2")) return;
          q->array_indexes[2] = xmlReader->readElementText().toInt();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "index3")) return;
          q->array_indexes[3] = xmlReader->readElementText().toInt();

          q->q7b_array = new QVector<Q7B>;

          xmlReader->readNext();

          Q7B_fromXMLDictionary(xmlReader, d, q);

          xmlReader->readNext();

        }
        else
        {                            
          xmlReader->raiseError();
          return;
        }

     } else if (xmlReader->isEndElement()){

       if (theArray2.isNull() && xmlReader->name() == "dictionary"){
         return;
       } else if (!theArray2.isNull() && xmlReader->name() == "array2"){
         return;
       } else {
         xmlReader->readNext();
       }
     } else {
       xmlReader->readNext();
     }

   }
}

void Q7B_fromXMLList(QXmlStreamReader * xmlReader, Q7B_List *a, Q7B theArray2)
{
   while(!xmlReader->atEnd()){      

     if (xmlReader->isStartElement()){

        if (xmlReader->name() == "integer")       
        {
          if (theArray2.isNull()){
            a->me << Q7B_QOBJECT( xmlReader->readElementText().toInt() );   
          } else {
            theArray2->q7b_array->append(Q7B_QOBJECT( xmlReader->readElementText().toInt() ));
          }          
        }
        else if (xmlReader->name() == "float")
        {
          if (theArray2.isNull()){
            a->me << Q7B_QOBJECT( xmlReader->readElementText().toDouble() );   
          } else {
            theArray2->q7b_array->append(Q7B_QOBJECT( xmlReader->readElementText().toDouble() ));
          }          
        }
        else if (xmlReader->name() == "boolean")
        {
          if (theArray2.isNull()){
            a->me << Q7B_QOBJECT( xmlReader->readElementText() == "0" ? false : true );   
          } else {
            theArray2->q7b_array->append(Q7B_QOBJECT( xmlReader->readElementText() == "0" ? false : true ));
          }      
        }
        else if (xmlReader->name() == "string")
        {
          if (theArray2.isNull()){
            a->me << Q7B_QOBJECT( xmlReader->readElementText( )); 
          } else {
            theArray2->q7b_array->append(Q7B_QOBJECT( xmlReader->readElementText( )));
          }
        }
        else if (xmlReader->name() == "datetime")
        {
          if (theArray2.isNull()){
            a->me << Q7B_QOBJECT( QDateTime::fromString(xmlReader->readElementText(), "yyyy-MM-dd hh:mm:ss") ); 
          } else {
            theArray2->q7b_array->append(Q7B_QOBJECT( QDateTime::fromString(xmlReader->readElementText(), "yyyy-MM-dd hh:mm:ss") ));
          }
        }
        else if (xmlReader->name() == "decimal")
        {
          if (theArray2.isNull()){
            a->me << Q7B_QOBJECT( Q7B_Decimal(xmlReader->readElementText()) ); 
          } else {
            theArray2->q7b_array->append(Q7B_QOBJECT( Q7B_Decimal(xmlReader->readElementText()) ));
          }
        }
        else if (xmlReader->name() == "null")
        {
          xmlReader->readElementText();

          if (theArray2.isNull()){
            a->me << Q7B_idnil; 
          } else {
            theArray2->q7b_array->append(Q7B_idnil);
          }
        }
        else if (xmlReader->name() == "QByteArray")
        {
          QByteArray ba = QByteArray::fromBase64(xmlReader->readElementText().toAscii());
          if (theArray2.isNull()){
            a->me << Q7B_QOBJECT(ba); 
          } else {
            theArray2->q7b_array->append(Q7B_QOBJECT(ba));
          }                
        }
        else if (xmlReader->name() == "QIcon")
        {
          QByteArray ba = QByteArray::fromBase64(xmlReader->readElementText().toAscii());
          if (theArray2.isNull()){
            a->me << Q7B_QOBJECT(Q7B_QByteArray2QIcon(ba)); 
          } else {
            theArray2->q7b_array->append(Q7B_QOBJECT(Q7B_QByteArray2QIcon(ba)));
          }              
        }
        else if (xmlReader->name() == "list" || xmlReader->name() == "array") 
        {
          Q7B_List *aa = new Q7B_List();
          Q7B q (new Q7B_id(typeid(Q7B_List).name(), aa));   

          if (theArray2.isNull()){
            a->me << q;   
          } else {
            theArray2->q7b_array->append(q);
          }         

          xmlReader->readNext();

          Q7B theArray;
          Q7B_fromXMLList(xmlReader, aa, theArray);

          xmlReader->readNext();

        }
        else if (xmlReader->name() == "dictionary")
        {
          Q7B_Dictionary *dd = new Q7B_Dictionary();
          Q7B q (new Q7B_id(typeid(Q7B_Dictionary).name(), dd));   

          if (theArray2.isNull()){
            a->me << q;   
          } else {
            theArray2->q7b_array->append(q);
          }         

          xmlReader->readNext();

          Q7B theArray;
          Q7B_fromXMLDictionary(xmlReader, dd, theArray);

          xmlReader->readNext();
        
        }
        else if (xmlReader->name() == "array2")
        {

          Q7B q (new Q7B_id());   

          if (theArray2.isNull()){
            a->me << q;   
          } else {
            theArray2->q7b_array->append(q);
          }                   

          xmlReader->readNext();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "count")) return;
          q->q7b_array_count = xmlReader->readElementText().toInt();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "index0")) return;
          q->array_indexes[0] = xmlReader->readElementText().toInt();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "index1")) return;
          q->array_indexes[1] = xmlReader->readElementText().toInt();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "index2")) return;
          q->array_indexes[2] = xmlReader->readElementText().toInt();

          while(!xmlReader->atEnd()){ if (xmlReader->isStartElement()) break; xmlReader->readNext(); }
          if (!(xmlReader->name() == "index3")) return;
          q->array_indexes[3] = xmlReader->readElementText().toInt();

          q->q7b_array = new QVector<Q7B>;

          xmlReader->readNext();

          Q7B_fromXMLList(xmlReader, a, q);

          xmlReader->readNext();

        }
        else
        {                            
          xmlReader->raiseError();
          return;
        }

     } else if (xmlReader->isEndElement()){

       if (theArray2.isNull() && (xmlReader->name() == "list" || xmlReader->name() == "array")){ 
         return;
       } else if (!theArray2.isNull() && xmlReader->name() == "array2"){
         return;
       } else {
         xmlReader->readNext();
       }
     } else {
       xmlReader->readNext();
     }

   }
}

Q7B Q7B_READLIST(Q7B Q7B_Object)
{
  QString s = Q7B_LoadString(Q7B_Object, "");

  Q7B_List *a = new Q7B_List();
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), a));  

  QXmlStreamReader xmlReader(s.toUtf8());
  xmlReader.readNext(); 
  xmlReader.readNext(); 

  while(!xmlReader.atEnd()){

      
    if (xmlReader.isStartElement() && xmlReader.name() == "V1.0"){ xmlReader.readNext(); while(!xmlReader.atEnd() && !xmlReader.isStartElement()){ xmlReader.readNext(); }
     
      
      if (xmlReader.isStartElement() && (xmlReader.name() == "list" || xmlReader.name() == "array")){ xmlReader.readNext(); while(!xmlReader.atEnd() && !xmlReader.isStartElement()){ xmlReader.readNext(); }

        Q7B theArray;
        Q7B_fromXMLList(&xmlReader, a, theArray);

      }
      
    } 

    if (!xmlReader.atEnd()) xmlReader.readNext();
  }

  if (xmlReader.hasError()) return Q7B_idnil;
   
 

  return Q7B_QOBJECT( q );
}

Q7B Q7B_WRITELIST(Q7B Q7B_Object, Q7B FilePathOrURL)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_LIST(Q7B_Object))){ Q7B_EXCEPTION("List expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FilePathOrURL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWhere = *((QString *) FilePathOrURL->ref);
 
  if (sWhere.startsWith("file:///")){
    sWhere = sWhere.mid(QString("file:///").length());
  }  
  
  QFile f(sWhere);
  if (!f.open(QIODevice::Truncate | QIODevice::WriteOnly)){
  } else {

    QXmlStreamWriter xmlWriter(&f);
    xmlWriter.setAutoFormatting(true);

    xmlWriter.writeStartDocument();

      xmlWriter.writeStartElement("V1.0");

        xmlWriter.writeStartElement("list");

        QList<Q7B>l = ((Q7B_List *) Q7B_Object->ref)->values();
        for (int i = 0; i < l.size(); i++){
          Q7B q = l.at(i);
          Q7B_toXML2(xmlWriter, q);
        }        

      xmlWriter.writeEndElement();

    xmlWriter.writeEndDocument();

    f.close();

    return Q7B_QOBJECT( true );
  }
  
  return Q7B_QOBJECT( false );
}

Q7B Q7B_READDICTIONARY(Q7B Q7B_Object)
{
  QString s = Q7B_LoadString(Q7B_Object, "");

  Q7B_Dictionary *d = new Q7B_Dictionary();
  Q7B q (new Q7B_id(typeid(Q7B_Dictionary).name(), d));  

  QXmlStreamReader xmlReader(s.toUtf8());
  xmlReader.readNext(); 
  xmlReader.readNext(); 

  while(!xmlReader.atEnd()){
      
    if (xmlReader.isStartElement() && xmlReader.name() == "V1.0"){ xmlReader.readNext(); while(!xmlReader.atEnd() && !xmlReader.isStartElement()){ xmlReader.readNext(); }
     
      if (xmlReader.isStartElement() && xmlReader.name() == "dictionary"){ xmlReader.readNext(); while(!xmlReader.atEnd() && !xmlReader.isStartElement()){ xmlReader.readNext(); }

        Q7B theArray;
        Q7B_fromXMLDictionary(&xmlReader, d, theArray);

      }

    }

    if (!xmlReader.atEnd()) xmlReader.readNext();
  }

  if (xmlReader.hasError()) return Q7B_idnil;
   
  return Q7B_QOBJECT( q );
}

Q7B Q7B_WRITEDICTIONARY(Q7B Q7B_Object, Q7B FilePathOrURL)
{
  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_DICTIONARY(Q7B_Object))){ Q7B_EXCEPTION("Dictionary expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FilePathOrURL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sWhere = *((QString *) FilePathOrURL->ref);
 
  if (sWhere.startsWith("file:///")){
    sWhere = sWhere.mid(QString("file:///").length());
  }  
  
  QFile f(sWhere);
  if (!f.open(QIODevice::Truncate | QIODevice::WriteOnly)){
  } else {

    QXmlStreamWriter xmlWriter(&f);
    xmlWriter.setAutoFormatting(true);

    xmlWriter.writeStartDocument();

      xmlWriter.writeStartElement("V1.0");

        xmlWriter.writeStartElement("dictionary");

        QMap<QString, Q7B>m = ((Q7B_Dictionary *) Q7B_Object->ref)->keysvalues();

        QMapIterator<QString, Q7B> i(m);
        while (i.hasNext()) {
           i.next();
           
           xmlWriter.writeTextElement("key", i.key());
           Q7B_toXML2(xmlWriter, i.value());
        }

      xmlWriter.writeEndElement();

    xmlWriter.writeEndDocument();

    f.close();

    return Q7B_QOBJECT( true );
  }
  
  return Q7B_QOBJECT( false );
}

Q7B Q7B_ISLIST(Q7B aList)
{
  if (Q7B_nil(aList)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_QOBJECT( aList->type == typeid(Q7B_List).name() );
}    

Q7B Q7B_ISFLOAT(Q7B v)
{
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_QOBJECT( v->type == typeid(qreal).name() );
}    

Q7B Q7B_ISINTEGER(Q7B v)
{
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_QOBJECT( v->type == typeid(qint64).name() );
}    

Q7B Q7B_ISBOOLEAN(Q7B v)
{
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_QOBJECT( v->type == typeid(bool).name() );
}    

Q7B Q7B_ISSTRING(Q7B v)
{
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_QOBJECT( v->type == typeid(QString).name() );
}    

Q7B Q7B_ISDATETIME(Q7B v)
{
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_QOBJECT( v->type == typeid(QDateTime).name() );
}    

Q7B Q7B_ISDECIMAL(Q7B v)
{
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  return Q7B_QOBJECT( v->type == typeid(Q7B_Decimal).name() );
}    




QSqlDatabase *Q7B_psqldb = 0;

Q7B Q7B_PSQLCONNECT(Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B ConnectOptions, Q7B Port)
{
  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(ConnectOptions))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Port))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (!QSqlDatabase::contains("default.psql")){
    Q7B_psqldb = new QSqlDatabase(QSqlDatabase::addDatabase("QPSQL", "default.psql"));
  }
  if (Q7B_psqldb->isOpen()) Q7B_psqldb->close();

  Q7B_psqldb->setDatabaseName( Q7B_IDQString(Name) );
  Q7B_psqldb->setUserName( Q7B_IDQString(User) );
  Q7B_psqldb->setPassword( Q7B_IDQString(Password) );

  QString sHost = Q7B_IDQString(Host);
  if (!sHost.isEmpty()) Q7B_psqldb->setHostName( sHost );

  QString sConnectOptions = Q7B_IDQString(ConnectOptions);
  if (!sConnectOptions.isEmpty()) Q7B_psqldb->setConnectOptions( sConnectOptions ); 
  

  qint64 nPort = Q7B_IDqint64(Port);
  if (nPort > -1) Q7B_psqldb->setPort( nPort );      

  if (!Q7B_psqldb->open()){
    return Q7B_QOBJECT( Q7B_psqldb->lastError().text() ); 
  }
  return Q7B_QOBJECT( true );
}

void Q7B_PSQLDISCONNECT()
{
  if (Q7B_psqldb){
    Q7B_psqldb->close();
    delete Q7B_psqldb;
    Q7B_psqldb = 0;
    QSqlDatabase::removeDatabase("default.psql"); 
  }    
}

QSqlQuery Q7B_psqldbq; 


Q7B Q7B_PSQLLASTINSERTID(Q7B Table)
{  
  if (Q7B_nil(Table)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Table))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QSqlIndex i = Q7B_psqldb->driver()->primaryIndex(Q7B_IDQString(Table));
  if (i.count()){    
    qint64 oid = Q7B_psqldbq.lastInsertId().toLongLong();

    QSqlQuery q(*Q7B_psqldb);

    if (q.exec("SELECT * FROM " + Q7B_IDQString(Table) + " WHERE oid = " + QString("%1").arg(oid)) && q.first()){  
      QSqlRecord a = q.record();
      qint64 n = a.indexOf(i.fieldName(0));
      if (n >= 0) return Q7B_QOBJECT( Q7B_Variant2id(a.value(n), true, true));
    }
  }
  return Q7B_QOBJECT(0);


  

  
  
}

Q7B Q7B_MD5(Q7B Argument)
{  
  if (Q7B_nil(Argument)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(Argument))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString s = Q7B_IDQString(Argument);
  return Q7B_QOBJECT(QCryptographicHash::hash(s.toUtf8(), QCryptographicHash::Md5).toHex());
}


Q7B Q7B_PSQL(Q7B SQL)
{
  if (Q7B_nil(SQL)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(SQL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  QString sSQL = Q7B_IDQString(SQL);
  
  if (!Q7B_psqldb->isOpen()){   
    if (!Q7B_psqldb->open()){   
      return Q7B_QOBJECT( Q7B_psqldb->lastError().text() ); 
    }
  }

  Q7B_psqldbq = QSqlQuery(*Q7B_psqldb);

  bool b = false;

  if (Q7B_binds.count()){
    Q7B_psqldbq.prepare( sSQL );
    for (int i = 0; i < Q7B_binds.count(); i++){
      Q7B_psqldbq.bindValue(QString(":BIND%1").arg(i + 1), Q7B_id2Variant(Q7B_binds.at(i), true, true));
    }
    Q7B_binds.clear();

    b = Q7B_psqldbq.exec();
  } else {
    b = Q7B_psqldbq.exec(sSQL);
  }

  if (b){

    QMap<int, QString> fieldnames;

    if (Q7B_psqldbq.first()){      

      Q7B_List *aa = new Q7B_List();
      Q7B qa (new Q7B_id(typeid(Q7B_List).name(), aa)); 

      QSqlRecord a = Q7B_psqldbq.record();
      for (int i = 0; i < a.count(); i++){
        fieldnames[i] = a.fieldName(i);
      }        

      do {
        Q7B_Dictionary *d = new Q7B_Dictionary();
        Q7B qq (new Q7B_id(typeid(Q7B_Dictionary).name(), d));

        a = Q7B_psqldbq.record();
        for (int i = 0; i < a.count(); i++){
          d->me[fieldnames[i]] = Q7B_QOBJECT( Q7B_Variant2id(a.value(i), true, true) );
        }

        aa->append(qq);

      } while (Q7B_psqldbq.next());

      return Q7B_QOBJECT(qa);
      
    }

    if (!sSQL.startsWith("SELECT ", Qt::CaseInsensitive)){
      return Q7B_QOBJECT(true);
    } else {
      Q7B_List *aa = new Q7B_List();
      Q7B qa (new Q7B_id(typeid(Q7B_List).name(), aa)); 

      return Q7B_QOBJECT(qa);
    }
  }

  return Q7B_QOBJECT( Q7B_psqldbq.lastError().text() );
}


QSqlDatabase *Q7B_mysqldb = 0;

Q7B Q7B_MYSQLCONNECT(Q7B Name, Q7B User, Q7B Password, Q7B Host, Q7B ConnectOptions, Q7B Port)
{
  if (Q7B_nil(Q7B_QSTRING(Name))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(User))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Password))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(ConnectOptions))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Port))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  if (!QSqlDatabase::contains("default.mysql") && Q7B_mysqldb == 0){
    
    Q7B_mysqldb = new QSqlDatabase(QSqlDatabase::addDatabase("QMYSQL", "default.mysql"));
  }
  if (Q7B_mysqldb->isOpen()) Q7B_mysqldb->close();

 

  Q7B_mysqldb->setDatabaseName( Q7B_IDQString(Name) );
  Q7B_mysqldb->setUserName( Q7B_IDQString(User) );
  Q7B_mysqldb->setPassword( Q7B_IDQString(Password) );

  

  QString sHost = Q7B_IDQString(Host);
  if (!sHost.isEmpty()) Q7B_mysqldb->setHostName( sHost );

 

  QString sConnectOptions = Q7B_IDQString(ConnectOptions);
  if (!sConnectOptions.isEmpty()) Q7B_mysqldb->setConnectOptions( sConnectOptions ); 

  qint64 nPort = Q7B_IDqint64(Port);
  if (nPort > -1) Q7B_mysqldb->setPort( nPort );    

  

  if (!Q7B_mysqldb->open()){
    return Q7B_QOBJECT( Q7B_mysqldb->lastError().text() ); 
  }
  return Q7B_QOBJECT( true );
}

void Q7B_MYSQLDISCONNECT()
{
  if (Q7B_mysqldb){
    Q7B_mysqldb->close();
    delete Q7B_mysqldb;
    Q7B_mysqldb = 0;
    QSqlDatabase::removeDatabase("default.mysql"); 
  }  
}

QSqlQuery Q7B_mysqldbq;

Q7B Q7B_MYSQLLASTINSERTID()
{
  return Q7B_QOBJECT( Q7B_mysqldbq.lastInsertId().toLongLong() );
}

Q7B Q7B_MYSQL(Q7B SQL)
{
  if (Q7B_nil(SQL)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(SQL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sSQL = Q7B_IDQString(SQL);
  
  if (!Q7B_mysqldb->isOpen()){   
    if (!Q7B_mysqldb->open()){   
      return Q7B_QOBJECT( Q7B_mysqldb->lastError().text() ); 
    }
  }

  Q7B_mysqldbq = QSqlQuery(*Q7B_mysqldb);


  bool b = false;

  if (Q7B_binds.count()){
    Q7B_mysqldbq.prepare( sSQL );
    for (int i = 0; i < Q7B_binds.count(); i++){
      Q7B_mysqldbq.bindValue(QString(":BIND%1").arg(i + 1), Q7B_id2Variant(Q7B_binds.at(i), true, true));
    }
    Q7B_binds.clear();

    b = Q7B_mysqldbq.exec();
  } else {
    b = Q7B_mysqldbq.exec(sSQL);
  }

  if (b){

    QMap<int, QString> fieldnames;

    if (Q7B_mysqldbq.first()){
      Q7B_List *aa = new Q7B_List();
      Q7B qa (new Q7B_id(typeid(Q7B_List).name(), aa)); 


      QSqlRecord a = Q7B_mysqldbq.record();
      for (int i = 0; i < a.count(); i++){
        fieldnames[i] = a.fieldName(i);
      }        

      do {
        Q7B_Dictionary *d = new Q7B_Dictionary();
        Q7B qq (new Q7B_id(typeid(Q7B_Dictionary).name(), d));

        a = Q7B_mysqldbq.record();
        for (int i = 0; i < a.count(); i++){
          d->me[fieldnames[i]] = Q7B_QOBJECT( Q7B_Variant2id(a.value(i), true, true) );
        }

        aa->append(qq);

      } while (Q7B_mysqldbq.next());

      return Q7B_QOBJECT(qa);
      
    }

    if (!sSQL.startsWith("SELECT ", Qt::CaseInsensitive)){
      return Q7B_QOBJECT(true);
    } else {
      Q7B_List *aa = new Q7B_List();
      Q7B qa (new Q7B_id(typeid(Q7B_List).name(), aa)); 

      return Q7B_QOBJECT(qa);
    }

  }

  return Q7B_QOBJECT( Q7B_mysqldbq.lastError().text() );
}

QSqlQuery Q7B_sqliteq;

Q7B Q7B_SQLITELASTINSERTID()
{
  return Q7B_QOBJECT( Q7B_sqliteq.lastInsertId().toLongLong() );
}

QMap<QString, QSqlDatabase*> Q7B_sqlite_dbs; 

Q7B Q7B_SQLITE(Q7B SQL, Q7B FilePath)
{
  if (Q7B_nil(SQL)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_QSTRING(SQL))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(FilePath))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  QString sSQL = Q7B_IDQString(SQL);

  QString sFilePath = Q7B_IDQString(FilePath);
  if (!sFilePath.contains("/") && !sFilePath.contains("\\")){
    sFilePath = qApp->applicationDirPath() + "/" + sFilePath; 
  }  

  if (!Q7B_sqlite_dbs.contains( sFilePath )){
    QSqlDatabase *db = new QSqlDatabase(QSqlDatabase::addDatabase("QSQLITE", sFilePath + ".sqlite"));
    db->setDatabaseName( sFilePath );
    if (!db->open()){
      return Q7B_QOBJECT( db->lastError().text() ); 

    }
    Q7B_sqlite_dbs[ sFilePath ] = db;
  }

  if (!Q7B_sqlite_dbs[ sFilePath ]->isOpen()){   
    if (!Q7B_sqlite_dbs[ sFilePath ]->open()){   
      return Q7B_QOBJECT( Q7B_sqlite_dbs[ sFilePath ]->lastError().text() ); 
    }
  }

  Q7B_sqliteq = QSqlQuery(*Q7B_sqlite_dbs[ sFilePath ]);


  bool b = false;

  if (Q7B_binds.count()){
    Q7B_sqliteq.prepare( sSQL );
    for (int i = 0; i < Q7B_binds.count(); i++){

      Q7B_sqliteq.bindValue(QString(":BIND%1").arg(i + 1), Q7B_id2Variant(Q7B_binds.at(i), true, true));
    }
    Q7B_binds.clear();

    b = Q7B_sqliteq.exec();
  } else {
    b = Q7B_sqliteq.exec(sSQL);
  }

  if (b){

  
    

    QMap<int, QString> fieldnames;


    if (Q7B_sqliteq.first()){

      Q7B_List *aa = new Q7B_List();
      Q7B qa (new Q7B_id(typeid(Q7B_List).name(), aa)); 

      QSqlRecord a = Q7B_sqliteq.record();
      for (int i = 0; i < a.count(); i++){
        fieldnames[i] = a.fieldName(i);
      }        

      do {
        Q7B_Dictionary *d = new Q7B_Dictionary();
        Q7B qq (new Q7B_id(typeid(Q7B_Dictionary).name(), d));

        a = Q7B_sqliteq.record();
        for (int i = 0; i < a.count(); i++){
          d->me[fieldnames[i]] = Q7B_QOBJECT( Q7B_Variant2id(a.value(i), true, true) );
        }

        aa->append(qq);

      } while (Q7B_sqliteq.next());

      Q7B_sqliteq.clear();

      return Q7B_QOBJECT(qa);
      
    }

    if (!sSQL.startsWith("SELECT ", Qt::CaseInsensitive)){
      return Q7B_QOBJECT(true);
    } else {
      Q7B_List *aa = new Q7B_List();
      Q7B qa (new Q7B_id(typeid(Q7B_List).name(), aa)); 

      return Q7B_QOBJECT(qa);
    }
  }

  return Q7B_QOBJECT( Q7B_sqliteq.lastError().text() );
}

void Q7B_CLOSEALLDATABASES()
{
  Q7B_MYSQLDISCONNECT();
  Q7B_PSQLDISCONNECT();

  QMapIterator<QString, QSqlDatabase*> i(Q7B_sqlite_dbs);
  while (i.hasNext()) {
     i.next();
     QSqlDatabase *db = i.value();
     db->close();
     delete db;    
     QSqlDatabase::removeDatabase(i.key() + ".sqlite"); 
  }
  Q7B_sqlite_dbs.clear();

}

Q7B Q7B_SQLBLOB(Q7B v)
{  
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  Q7B_binds.append(v);  

  return Q7B_QOBJECT( QString(":BIND%1").arg(Q7B_binds.count()) );
}    

Q7B Q7B_SQLTEXT(Q7B v)
{  
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  Q7B_binds.append(v);  

  return Q7B_QOBJECT( QString(":BIND%1").arg(Q7B_binds.count()) );
}    

Q7B Q7B_SQLBOOLEAN(Q7B v)
{  
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  Q7B_binds.append(v);  

  return Q7B_QOBJECT( QString(":BIND%1").arg(Q7B_binds.count()) );
}    

Q7B Q7B_SQLINTEGER(Q7B v)
{  
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  Q7B_binds.append(v);  

  return Q7B_QOBJECT( QString(":BIND%1").arg(Q7B_binds.count()) );
}    

Q7B Q7B_SQLFLOAT(Q7B v)
{  
  if (Q7B_nil(v)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  Q7B_binds.append(v);  

  return Q7B_QOBJECT( QString(":BIND%1").arg(Q7B_binds.count()) );
}    




void Q7B_ControlHelper::frameChanged(int)
{
  q7b_super->setMyIcon2();
}


void Q7B_Control::setMyIcon(QString n)
{  
  
  
  if (qobject_cast<Q7B_Label *>((QWidget *) q7b_super)){
     
    if (n.isEmpty()){
      ((Q7B_Label *) this)->setPixmap(QPixmap());
      return;
    }
  } else if (qobject_cast<Q7B_ToolButton *>((QWidget *) q7b_super)){
    if (n.isEmpty()){
      ((Q7B_ToolButton *) this)->setToolButtonStyle(Qt::ToolButtonTextOnly);
      return;
    } else {
      if (((Q7B_ToolButton *) this)->text().isEmpty()){
        ((Q7B_ToolButton *) this)->setToolButtonStyle(Qt::ToolButtonIconOnly);
      } else {
        ((Q7B_ToolButton *) this)->setToolButtonStyle(Qt::ToolButtonTextBesideIcon);
      }      
    }
  }

  

   bool bMovie = false;

   QList<QByteArray> l = QMovie::supportedFormats();
   for (int i = 0; i < l.size(); ++i) {
      QString ss(l.at(i));
      if (n.endsWith("." + ss, Qt::CaseInsensitive)){
        bMovie = true;
        break;
      }
   }    
   

   if (bMovie){     
     

     if (setMyMovie(0, &movie, &moviea, &movieb, n)){
       
       QObject::connect(movie, SIGNAL(frameChanged(int)), Q7B_ControlPrivate, SLOT(frameChanged(int)));
       movie->start();
     } else {
       qpixmap = Q7B_loadPixmap(n.contains(".") ? n : n + ".png");
     }
     
   } else {

     

     qpixmap = Q7B_createPixmap(n);
   
   }
}

void Q7B_Control::setMyIcon2()
{
  
  if (qobject_cast<Q7B_CommandButton *>(q7b_super)){ ((Q7B_CommandButton *)q7b_super)->setIcon(movie->currentPixmap()); }
  else if (qobject_cast<Q7B_CommandLinkButton *>(q7b_super)){ ((Q7B_CommandLinkButton *)q7b_super)->setIcon(movie->currentPixmap()); }
  else if (qobject_cast<Q7B_ToolButton *>(q7b_super)){ ((Q7B_ToolButton *)q7b_super)->setIcon(movie->currentPixmap()); }
  else if (qobject_cast<Q7B_CheckBox *>(q7b_super)){ ((Q7B_CheckBox *)q7b_super)->setIcon(movie->currentPixmap()); }
  else if (qobject_cast<Q7B_RadioButton *>(q7b_super)){ ((Q7B_RadioButton *)q7b_super)->setIcon(movie->currentPixmap()); }
  else if (qobject_cast<Q7B_Label *>(q7b_super)){ ((Q7B_Label *)q7b_super)->setPixmap(movie->currentPixmap()); }
  
}

void Q7B_Control_constructor(QWidget *o)
{

    
  o->setProperty("Value", "");
  o->setProperty("OldValue", "");

  o->setProperty("Name", "");
  o->setProperty("Layout", "");
  o->setProperty("ControlType", "");

  o->setProperty("X", 0);
  o->setProperty("Y", 0);
  o->setProperty("Width", 0);
  o->setProperty("Height", 0);

  o->setProperty("LoadedX", 0);
  o->setProperty("LoadedY", 0);
  o->setProperty("LoadedWidth", 0);
  o->setProperty("LoadedHeight", 0);
  


  o->setProperty("OldX", 0);
  o->setProperty("GlobalX", 0);
  o->setProperty("OldY", 0);
  o->setProperty("GlobalY", 0);
  o->setProperty("OldWidth", 0);
  o->setProperty("OldHeight", 0);

  
    o->setProperty("Group", "");  
    o->setProperty("Palette", "");
    o->setProperty("Mask", "");  
    o->setProperty("MouseTracking", false);    
    o->setProperty("DrawOnPaint", true);
    

  o->setProperty("Background", "");
  o->setProperty("BackgroundStyle", "");

    o->setProperty("MinimumWidth", 0);
    o->setProperty("MinimumHeight", 0);
    o->setProperty("MaximumWidth", 0);
    o->setProperty("MaximumHeight", 0);
 
  o->setProperty("Tag", "");

  
    o->setProperty("DragDrop", false);
    o->setProperty("FocusPolicy", "");
    o->setProperty("FocusProxy", "");
    o->setProperty("FocusOrder", 0);
 
  o->setProperty("TimerInterval", 0);

  o->setProperty("Visible", false);
  o->setProperty("Cursor", "");
   o->setProperty("CursorAnimation", "");
  
  o->setProperty("FontName", "");
  o->setProperty("FontSize", 0);
  o->setProperty("FontItalic", false);
  o->setProperty("FontBold", false);
  o->setProperty("FontUnderline", false);
  o->setProperty("FontColor", "");
  
  o->setProperty("Enabled", true);
 
  

  o->setProperty("ParentForm", "");
  o->setProperty("ParentControl", "");


  
    o->setProperty("StatusTip", "");
    o->setProperty("ToolTip", "");
    o->setProperty("StyleSheet", "");
    o->setProperty("WhatsThis", "");
 

   



} 

Q7B Q7B_CONTROL_INIT(QObject *parent, const char *objectName)
{
  QWidget* o = new QWidget( 0 );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);
  

  Q7B_Control_constructor(o);

  Q7B q (new Q7B_id(typeid(QWidget).name(), o)); 
  return q;
}

void Q7B_CONTROL_ENABLED(Q7B q7b_control, Q7B v)
{  
  if (Q7B_nil(q7b_control)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((QWidget *) q7b_control->ref)->setProperty("Enabled", Q7B_IDbool(v));

  Q7B_ImageButton *ib = qobject_cast<Q7B_ImageButton *>(((QWidget *) q7b_control->ref));
  if (ib){
    if (ib->property("Checked").toBool()){
      if (ib->property("Enabled").toBool()){
        ib->setImage(ib->property("CheckedEnabledImage").toString());

      } else {
        ib->setImage(ib->property("CheckedDisabledImage").toString());
        
      }
    } else {
      if (ib->property("Enabled").toBool()){
        ib->setImage(ib->property("EnabledImage").toString());
        
      } else {
        ib->setImage(ib->property("DisabledImage").toString());
        
      }
    }
  }  
}

Q7B Q7B_CONTROL_ENABLED(Q7B q7b_control)
{
  if (Q7B_nil(q7b_control)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_CONTROL(q7b_control))){ Q7B_EXCEPTION("Control expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QWidget *) q7b_control->ref)->property("Enabled").toBool() );
}

void Q7B_CONTROL_GROUP(Q7B q7b_control, Q7B v)
{
  if (Q7B_nil(q7b_control)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_CONTROL(q7b_control))){ Q7B_EXCEPTION("Control expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((QWidget *) q7b_control->ref)->setProperty("Group", Q7B_IDQString(v));
}

Q7B Q7B_CONTROL_GROUP(Q7B q7b_control)
{
  if (Q7B_nil(q7b_control)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_CONTROL(q7b_control))){ Q7B_EXCEPTION("Control expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QWidget *) q7b_control->ref)->property("Group").toString() );
}







Q7B Q7B_TIMER_INIT(QObject *parent, const char *objectName)
{
  Q7B_Timer* o = new Q7B_Timer( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_Timer).name(), o)); 
  return q;
}

void Q7B_TIMER_ENABLED(Q7B q7b_timer, Q7B v)
{
  if (Q7B_nil(q7b_timer)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_TIMER(q7b_timer))){ Q7B_EXCEPTION("Timer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((Q7B_Timer *) q7b_timer->ref)->setProperty("Enabled", Q7B_IDbool(v));
}

Q7B Q7B_TIMER_ENABLED(Q7B q7b_timer)
{
  if (Q7B_nil(q7b_timer)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_TIMER(q7b_timer))){ Q7B_EXCEPTION("Timer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Timer *) q7b_timer->ref)->property("Enabled") == true );
}

Q7B Q7B_TIMER_ISRUNNING(Q7B q7b_timer)
{
  if (Q7B_nil(q7b_timer)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_TIMER(q7b_timer))){ Q7B_EXCEPTION("Timer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Timer *) q7b_timer->ref)->t.isActive() );
}

void Q7B_TIMER_INTERVAL(Q7B q7b_timer, Q7B v)
{
  if (Q7B_nil(q7b_timer)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_TIMER(q7b_timer))){ Q7B_EXCEPTION("Timer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }

  Q7B_Timer *tr = ((Q7B_Timer *) q7b_timer->ref);
  
  qint64 n = Q7B_IDqint64(v);
  tr->t.setInterval(n);

  if (n == 0 && tr->t.isActive()) tr->t.stop();
  if (tr->t.interval() >= 0 && tr->property("Enabled") == true) tr->t.start();
}

Q7B Q7B_TIMER_INTERVAL(Q7B q7b_timer)
{
  if (Q7B_nil(q7b_timer)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_TIMER(q7b_timer))){ Q7B_EXCEPTION("Timer expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_Timer *) q7b_timer->ref)->t.interval() );
}

void Q7B_TIMER_START(Q7B q7b_timer)
{
  if (Q7B_nil(q7b_timer)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_TIMER(q7b_timer))){ Q7B_EXCEPTION("Timer expected"); return; }
  
  ((Q7B_Timer *) q7b_timer->ref)->t.start();
}

void Q7B_TIMER_STOP(Q7B q7b_timer)
{
  if (Q7B_nil(q7b_timer)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_TIMER(q7b_timer))){ Q7B_EXCEPTION("Timer expected"); return; }

  ((Q7B_Timer *) q7b_timer->ref)->t.stop();
}











Q7B Q7B_IMAGEBUTTON_INIT(QObject *parent, const char *objectName)
{
  Q7B_ImageButton* o = new Q7B_ImageButton( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_ImageButton).name(), o)); 
  return q;
}

void Q7B_IMAGEBUTTON_CHECKABLE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("Checkable", Q7B_IDbool(v));
}

Q7B Q7B_IMAGEBUTTON_CHECKABLE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Checkable").toBool() );
}

void Q7B_IMAGEBUTTON_CHECKABLEEXCLUSIVE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("CheckableExclusive", Q7B_IDbool(v));
}

Q7B Q7B_IMAGEBUTTON_CHECKABLEEXCLUSIVE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("CheckableExclusive").toBool() );
}

void Q7B_IMAGEBUTTON_CHECKED(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  Q7B_ImageButton *ib = ((Q7B_ImageButton *) q7b_imagebutton->ref);

  ib->setChecked(Q7B_IDbool(v));
}

Q7B Q7B_IMAGEBUTTON_CHECKED(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Checked").toBool() );
}


void Q7B_IMAGEBUTTON_CAPTION(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("Caption", Q7B_IDQString(v));

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->repaint();
}

Q7B Q7B_IMAGEBUTTON_CAPTION(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Caption").toString() );
}

void Q7B_IMAGEBUTTON_ENABLEDIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  QString s = Q7B_IDQString(v);
  if (((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Checked") == false){
    ((Q7B_ImageButton *) q7b_imagebutton->ref)->setImage(s);
  }
  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("EnabledImage", s);
}

Q7B Q7B_IMAGEBUTTON_ENABLEDIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("EnabledImage").toString() );
}

void Q7B_IMAGEBUTTON_DISABLEDIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  QString s = Q7B_IDQString(v);
  if (((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Checked") == false && ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Enabled") == false){
    ((Q7B_ImageButton *) q7b_imagebutton->ref)->setImage(s);
  }
  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("DisabledImage", s);
}

Q7B Q7B_IMAGEBUTTON_DISABLEDIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("DisabledImage").toString() );
}

void Q7B_IMAGEBUTTON_ENTERIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("EnterImage", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_ENTERIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("EnterImage").toString() );
}

void Q7B_IMAGEBUTTON_EXITIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("ExitImage", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_EXITIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("ExitImage").toString() );
}

void Q7B_IMAGEBUTTON_MOUSEDOWNIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("MouseDownImage", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_MOUSEDOWNIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("MouseDownImage").toString() );
}

void Q7B_IMAGEBUTTON_MOUSEUPIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("MouseUpImage", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_MOUSEUPIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("MouseUpImage").toString() );
}

void Q7B_IMAGEBUTTON_ENTERSOUND(Q7B q7b_imagebutton, Q7B v)
{ 
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("EnterSound", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_ENTERSOUND(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("EnterSound").toString() );
}

void Q7B_IMAGEBUTTON_EXITSOUND(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("ExitSound", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_EXITSOUND(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("ExitSound").toString() );
}

void Q7B_IMAGEBUTTON_MOUSEDOWNSOUND(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("MouseDownSound", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_MOUSEDOWNSOUND(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("MouseDownSound").toString() );
}

void Q7B_IMAGEBUTTON_MOUSEUPSOUND(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("MouseUpSound", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_MOUSEUPSOUND(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("MouseUpSound").toString() );
}

void Q7B_IMAGEBUTTON_CHECKEDENABLEDIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  QString s = Q7B_IDQString(v);
  if (((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Checked").toBool()){
    ((Q7B_ImageButton *) q7b_imagebutton->ref)->setImage(s);
  }
  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("CheckedEnabledImage", s);
}

Q7B Q7B_IMAGEBUTTON_CHECKEDENABLEDIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("CheckedEnabledImage").toString() );
}

void Q7B_IMAGEBUTTON_CHECKEDDISABLEDIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  QString s = Q7B_IDQString(v);
  if (((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Checked").toBool() && ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Enabled") == false){
    ((Q7B_ImageButton *) q7b_imagebutton->ref)->setImage(s);
  }
  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("CheckedDisabledImage", s);
}

Q7B Q7B_IMAGEBUTTON_CHECKEDDISABLEDIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("CheckedDisabledImage").toString() );
}

void Q7B_IMAGEBUTTON_CHECKEDENTERIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("CheckedEnterImage", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_CHECKEDENTERIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("CheckedEnterImage").toString() );
}

void Q7B_IMAGEBUTTON_CHECKEDEXITIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("CheckedExitImage", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_CHECKEDEXITIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("CheckedExitImage").toString() );
}

void Q7B_IMAGEBUTTON_CHECKEDMOUSEDOWNIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("CheckedMouseDownImage", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_CHECKEDMOUSEDOWNIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("CheckedMouseDownImage").toString() );
}

void Q7B_IMAGEBUTTON_CHECKEDMOUSEUPIMAGE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("CheckedMouseUpImage", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBUTTON_CHECKEDMOUSEUPIMAGE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("CheckedMouseUpImage").toString() );
}

void Q7B_IMAGEBUTTON_SCALE(Q7B q7b_imagebutton, Q7B v)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  ((Q7B_ImageButton *) q7b_imagebutton->ref)->setProperty("Scale", Q7B_IDbool(v));
}

Q7B Q7B_IMAGEBUTTON_SCALE(Q7B q7b_imagebutton)
{
  if (Q7B_nil(q7b_imagebutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBUTTON(q7b_imagebutton))){ Q7B_EXCEPTION("ImageButton expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((Q7B_ImageButton *) q7b_imagebutton->ref)->property("Scale").toBool() );
}







Q7B Q7B_TEXTBOX_INIT(QObject *parent, const char *objectName)
{
  Q7B_TextBox* o = new Q7B_TextBox( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_TextBox).name(), o)); 
  return q;
}





Q7B Q7B_COMMANDBUTTON_INIT(QObject *parent, const char *objectName)
{
  Q7B_CommandButton* o = new Q7B_CommandButton( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_CommandButton).name(), o)); 
  return q;
}

void Q7B_COMMANDBUTTON_ICON(Q7B commandbutton, Q7B Value)
{
  if (Q7B_nil(commandbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_COMMANDBUTTON(commandbutton))){ Q7B_EXCEPTION("CommandButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_CommandButton *) commandbutton->ref)->setMyIcon( Q7B_IDQString(Value) );
}

Q7B Q7B_COMMANDBUTTON_ICON(Q7B commandbutton)
{
  if (Q7B_nil(commandbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_COMMANDBUTTON(commandbutton))){ Q7B_EXCEPTION("CommandButton expected"); return Q7B_idnil; }

  return Q7B_idnil; 
}





Q7B Q7B_COMMANDLINKBUTTON_INIT(QObject *parent, const char *objectName)
{
  Q7B_CommandLinkButton* o = new Q7B_CommandLinkButton( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_CommandLinkButton).name(), o)); 
  return q;
}

void Q7B_COMMANDLINKBUTTON_ICON(Q7B commandlinkbutton, Q7B Value)
{
  if (Q7B_nil(commandlinkbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_COMMANDLINKBUTTON(commandlinkbutton))){ Q7B_EXCEPTION("CommandLinkButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_CommandLinkButton *) commandlinkbutton->ref)->setMyIcon( Q7B_IDQString(Value) );
}

Q7B Q7B_COMMANDLINKBUTTON_ICON(Q7B commandlinkbutton)
{
  if (Q7B_nil(commandlinkbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_COMMANDLINKBUTTON(commandlinkbutton))){ Q7B_EXCEPTION("CommandLinkButton expected"); return Q7B_idnil; }

  return Q7B_idnil; 
}





Q7B Q7B_TOOLBUTTON_INIT(QObject *parent, const char *objectName)
{
  Q7B_ToolButton* o = new Q7B_ToolButton( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_ToolButton).name(), o)); 
  return q;
}

void Q7B_TOOLBUTTON_ICON(Q7B toolbutton, Q7B Value)
{
  if (Q7B_nil(toolbutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_TOOLBUTTON(toolbutton))){ Q7B_EXCEPTION("ToolButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_ToolButton *) toolbutton->ref)->setMyIcon( Q7B_IDQString(Value) );
}

Q7B Q7B_TOOLBUTTON_ICON(Q7B toolbutton)
{
  if (Q7B_nil(toolbutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_TOOLBUTTON(toolbutton))){ Q7B_EXCEPTION("ToolButton expected"); return Q7B_idnil; }

  return Q7B_idnil; 
}





Q7B Q7B_CHECKBOX_INIT(QObject *parent, const char *objectName)
{
  Q7B_CheckBox* o = new Q7B_CheckBox( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_CheckBox).name(), o)); 
  return q;
}

void Q7B_CHECKBOX_ICON(Q7B checkbox, Q7B Value)
{
  if (Q7B_nil(checkbox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_CHECKBOX(checkbox))){ Q7B_EXCEPTION("CheckBox expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_CheckBox *) checkbox->ref)->setMyIcon( Q7B_IDQString(Value) );
}

Q7B Q7B_CHECKBOX_ICON(Q7B checkbox)
{
  if (Q7B_nil(checkbox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_CHECKBOX(checkbox))){ Q7B_EXCEPTION("CheckBox expected"); return Q7B_idnil; }

  return Q7B_idnil; 
}





Q7B Q7B_RADIOBUTTON_INIT(QObject *parent, const char *objectName)
{
  Q7B_RadioButton* o = new Q7B_RadioButton( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_RadioButton).name(), o)); 
  return q;
}

void Q7B_RADIOBUTTON_ICON(Q7B radiobutton, Q7B Value)
{
  if (Q7B_nil(radiobutton)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_RADIOBUTTON(radiobutton))){ Q7B_EXCEPTION("RadioButton expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_RadioButton *) radiobutton->ref)->setMyIcon( Q7B_IDQString(Value) );
}

Q7B Q7B_RADIOBUTTON_ICON(Q7B radiobutton)
{
  if (Q7B_nil(radiobutton)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_RADIOBUTTON(radiobutton))){ Q7B_EXCEPTION("RadioButton expected"); return Q7B_idnil; }

  return Q7B_idnil; 
}





Q7B Q7B_LABEL_INIT(QObject *parent, const char *objectName)
{
  Q7B_Label* o = new Q7B_Label( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_Label).name(), o)); 
  return q;
}

void Q7B_LABEL_SHAPE(Q7B q7b_label, Q7B v)
{
  if (Q7B_nil(q7b_label)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LABEL(q7b_label))){ Q7B_EXCEPTION("Label expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(v))){ Q7B_EXCEPTION("Boolean expected"); return; }

  if (Q7B_IDbool(v)){
    ((QLabel *) q7b_label->ref)->setFrameShape(QFrame::StyledPanel);
  } else {
    ((QLabel *) q7b_label->ref)->setFrameShape(QFrame::NoFrame);
  }
}

Q7B Q7B_LABEL_SHAPE(Q7B q7b_label)
{
  return Q7B_idnil; 
}

void Q7B_LABEL_INPUTCONTROL(Q7B q7b_label, Q7B v)
{
  
  if (Q7B_nil(q7b_label)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LABEL(q7b_label))){ Q7B_EXCEPTION("Label expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  QLabel *l = ((QLabel *) q7b_label->ref);

  QWidget *w = 0;

  
  QWidget *ss = ((QWidget *) q7b_label->ref)->parentWidget();
  if (ss == 0) return;

  

  QObjectList ol = ss->children();

  for (int q = 0; q < ol.size(); q++){
    if (ol.at(q)->objectName() == Q7B_IDQString(v)){
      w = (QWidget *) ol.at(q);
      break;
    }    
  }

  
  if (w){
    l->setTextFormat(Qt::PlainText);
  } else {
    l->setTextFormat(Qt::AutoText);
  }
  if (l->buddy() || w){
    
    l->setBuddy(w);
  }
  if (w) w->show(); 
}

Q7B Q7B_LABEL_INPUTCONTROL(Q7B q7b_label)
{
  if (Q7B_nil(q7b_label)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_LABEL(q7b_label))){ Q7B_EXCEPTION("Label expected"); return Q7B_idnil; }

  return Q7B_QOBJECT( ((QLabel *) q7b_label->ref)->buddy()->objectName() );
}

void Q7B_LABEL_ICON(Q7B q7b_label, Q7B Value)
{
  if (Q7B_nil(q7b_label)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_LABEL(q7b_label))){ Q7B_EXCEPTION("Label expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(Value))){ Q7B_EXCEPTION("String expected"); return; }

  ((Q7B_Label *) q7b_label->ref)->setMyIcon( Q7B_IDQString(Value) );
}

Q7B Q7B_LABEL_ICON(Q7B q7b_label)
{
  if (Q7B_nil(q7b_label)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_LABEL(q7b_label))){ Q7B_EXCEPTION("Label expected"); return Q7B_idnil; }

  return Q7B_idnil; 
}





Q7B Q7B_FRAME_INIT(QObject *parent, const char *objectName)
{
  Q7B_Frame* o = new Q7B_Frame( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_Frame).name(), o)); 
  return q;
}





Q7B Q7B_UICLASS_INIT(QObject *parent, const char *objectName)
{
  Q7B_uiClass* o = new Q7B_uiClass( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_uiClass).name(), o)); 
  return q;
}





Q7B Q7B_CLASS_INIT(QObject *parent, const char *objectName)
{
  Q7B_Class* o = new Q7B_Class( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_Class).name(), o)); 
  return q;
}





Q7B Q7B_MODULE_INIT(QObject *parent, const char *objectName)
{
  Q7B_Module* o = new Q7B_Module( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_Module).name(), o)); 
  return q;
}





Q7B Q7B_IMAGEBOX_INIT(QObject *parent, const char *objectName)
{
  Q7B_ImageBox* o = new Q7B_ImageBox( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_ImageBox).name(), o)); 
  return q;
}

void Q7B_IMAGEBOX_VALUE(Q7B q7b_imagebox, Q7B v)
{
  if (Q7B_nil(q7b_imagebox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBOX(q7b_imagebox))){ Q7B_EXCEPTION("ImageBox expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  QPixmap qpixmap = Q7B_createPixmap(Q7B_IDQString(v));

  Q7B_ImageBox *ib = ((Q7B_ImageBox *) q7b_imagebox->ref);

  QPalette p = ib->palette();
  QBrush b(qpixmap);
  p.setBrush(QPalette::Window, b);  
  ib->setPalette(p);

  ib->setProperty("OldValue", ib->property("Value"));
  ib->setProperty("Value", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBOX_VALUE(Q7B q7b_imagebox)
{
  if (Q7B_nil(q7b_imagebox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBOX(q7b_imagebox))){ Q7B_EXCEPTION("ImageBox expected"); return Q7B_idnil; }

  Q7B_ImageBox *ib = ((Q7B_ImageBox *) q7b_imagebox->ref);

  return Q7B_QOBJECT( ib->property("Value") );
}

void Q7B_IMAGEBOX_TEXT(Q7B q7b_imagebox, Q7B v)
{
  if (Q7B_nil(q7b_imagebox)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_IMAGEBOX(q7b_imagebox))){ Q7B_EXCEPTION("ImageBox expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  QPixmap qpixmap = Q7B_createPixmap(Q7B_IDQString(v));

  Q7B_ImageBox *ib = ((Q7B_ImageBox *) q7b_imagebox->ref);

  QPalette p = ib->palette();
  QBrush b(qpixmap);
  p.setBrush(QPalette::Window, b);  
  ib->setPalette(p);

  ib->setProperty("OldValue", ib->property("Value"));
  ib->setProperty("Value", Q7B_IDQString(v));
}

Q7B Q7B_IMAGEBOX_TEXT(Q7B q7b_imagebox)
{
  if (Q7B_nil(q7b_imagebox)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_IMAGEBOX(q7b_imagebox))){ Q7B_EXCEPTION("ImageBox expected"); return Q7B_idnil; }

  Q7B_ImageBox *ib = ((Q7B_ImageBox *) q7b_imagebox->ref);

  return Q7B_QOBJECT( ib->property("Value") );
}







Q7B Q7B_UDPSOCKET_INIT(QObject *parent, const char *objectName)
{
  Q7B_UdpSocket* o = new Q7B_UdpSocket( );
  o->setProperty("Parent", (qint64) parent);
  o->setObjectName(objectName);

  Q7B_connectSlotsByName((QObject *) o, parent);

  Q7B q (new Q7B_id(typeid(Q7B_UdpSocket).name(), o)); 
  return q;
}

Q7B Q7B_UDPSOCKET_OPEN(Q7B q7b_udpsocket)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return Q7B_idnil; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  if (udp->sHost.compare("LocalHost", Qt::CaseInsensitive) == 0) udp->a = new QHostAddress(QHostAddress::LocalHost);
  else if (udp->sHost.compare("LocalHostIPv6", Qt::CaseInsensitive) == 0) udp->a = new QHostAddress(QHostAddress::LocalHostIPv6);
  else if (udp->sHost.compare("Broadcast", Qt::CaseInsensitive) == 0) udp->a = new QHostAddress(QHostAddress::Broadcast);
  else if (udp->sHost.compare("Any", Qt::CaseInsensitive) == 0) udp->a = new QHostAddress(QHostAddress::Any);
  else if (udp->sHost.compare("AnyIPv6", Qt::CaseInsensitive) == 0) udp->a = new QHostAddress(QHostAddress::AnyIPv6);
  else udp->a = new QHostAddress(udp->sHost);

  udp->t->connectToHost(*(udp->a), udp->nPort);

  if (udp->t->waitForConnected()){
    return Q7B_QOBJECT( true );
  }
  
  return Q7B_QOBJECT( false );
}

Q7B Q7B_UDPSOCKET_BIND(Q7B q7b_udpsocket, Q7B Host, Q7B Port)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Host))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_INTEGER(Port))){ Q7B_EXCEPTION("Integer expected"); return Q7B_idnil; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  QString sHost = Q7B_IDQString(Host);
  udp->nPort2 = Q7B_IDqint64(Port);

  if (sHost.compare("LocalHost", Qt::CaseInsensitive) == 0) udp->a2 = new QHostAddress(QHostAddress::LocalHost);
  else if (sHost.compare("LocalHostIPv6", Qt::CaseInsensitive) == 0) udp->a2 = new QHostAddress(QHostAddress::LocalHostIPv6);
  else if (sHost.compare("Broadcast", Qt::CaseInsensitive) == 0) udp->a2 = new QHostAddress(QHostAddress::Broadcast);
  else if (sHost.compare("Any", Qt::CaseInsensitive) == 0) udp->a2 = new QHostAddress(QHostAddress::Any);
  else if (sHost.compare("AnyIPv6", Qt::CaseInsensitive) == 0) udp->a2 = new QHostAddress(QHostAddress::AnyIPv6);
  else udp->a2 = new QHostAddress(sHost);

  if (udp->t->bind(*(udp->a2), udp->nPort2)){
    return Q7B_QOBJECT( true );
  }

  return Q7B_QOBJECT( false );
}

Q7B Q7B_UDPSOCKET_READDATA(Q7B q7b_udpsocket)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return Q7B_idnil; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  QString s;

  while ((udp->a || udp->a2) && udp->t->hasPendingDatagrams()) {
       QByteArray datagram;
       datagram.resize(udp->t->pendingDatagramSize());
       QHostAddress sender;
       quint16 senderPort;

       udp->t->readDatagram(datagram.data(), datagram.size(), &sender, &senderPort);

       s += QString::fromLatin1((const char *) datagram.data(), datagram.size());
  }

  return Q7B_QOBJECT( s );
}

Q7B Q7B_UDPSOCKET_WRITEDATA(Q7B q7b_udpsocket, Q7B Data)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return Q7B_idnil; }
  if (Q7B_nil(Q7B_QSTRING(Data))){ Q7B_EXCEPTION("String expected"); return Q7B_idnil; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  if (udp->a == 0) return Q7B_QOBJECT( false );

  QString sData = Q7B_IDQString(Data);
  QByteArray datagram = sData.toLatin1();
  return Q7B_QOBJECT( udp->t->writeDatagram(datagram.data(), datagram.size(), *(udp->a), udp->nPort) > 0 );
}

void Q7B_UDPSOCKET_CLOSE(Q7B q7b_udpsocket)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  udp->t->disconnectFromHost();
  delete udp->a;
  udp->a = 0;
}

Q7B Q7B_UDPSOCKET_LASTERROR(Q7B q7b_udpsocket)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return Q7B_idnil; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  QAbstractSocket::SocketError l = udp->t->error();

  QString s = "";

  if (l == QAbstractSocket::ConnectionRefusedError) s = "ConnectionRefusedError";
  else if (l == QAbstractSocket::RemoteHostClosedError) s = "RemoteHostClosedError";
  else if (l == QAbstractSocket::HostNotFoundError) s = "HostNotFoundError";
  else if (l == QAbstractSocket::SocketAccessError) s = "SocketAccessError";
  else if (l == QAbstractSocket::SocketResourceError) s = "SocketResourceError";
  else if (l == QAbstractSocket::SocketTimeoutError) s = "SocketTimeoutError";
  else if (l == QAbstractSocket::DatagramTooLargeError) s = "DatagramTooLargeError";
  else if (l == QAbstractSocket::NetworkError) s = "NetworkError";
  else if (l == QAbstractSocket::AddressInUseError) s = "AddressInUseError";
  else if (l == QAbstractSocket::SocketAddressNotAvailableError) s = "SocketAddressNotAvailableError";
  else if (l == QAbstractSocket::UnsupportedSocketOperationError) s = "UnsupportedSocketOperationError";
  else if (l == QAbstractSocket::ProxyAuthenticationRequiredError) s = "ProxyAuthenticationRequiredError";
  else if (l == QAbstractSocket::SslHandshakeFailedError) s = "SslHandshakeFailedError";
  else if (l == QAbstractSocket::UnfinishedSocketOperationError) s = "UnfinishedSocketOperationError";
#ifndef Q_WS_X11
  else if (l == QAbstractSocket::ProxyConnectionRefusedError) s = "ProxyConnectionRefusedError";
  else if (l == QAbstractSocket::ProxyConnectionClosedError) s = "ProxyConnectionClosedError";
  else if (l == QAbstractSocket::ProxyConnectionTimeoutError) s = "ProxyConnectionTimeoutError";
  else if (l == QAbstractSocket::ProxyNotFoundError) s = "ProxyNotFoundError";
  else if (l == QAbstractSocket::ProxyProtocolError) s = "ProxyProtocolError";
#endif
  else if (l == QAbstractSocket::UnknownSocketError) s = "UnknownSocketError"; 

  return Q7B_QOBJECT( s );
}

Q7B Q7B_UDPSOCKET_LASTERRORTEXT(Q7B q7b_udpsocket)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return Q7B_idnil; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  return Q7B_QOBJECT( udp->t->errorString() );
}

void Q7B_UDPSOCKET_HOST(Q7B q7b_udpsocket, Q7B v)
{  
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return; }
  if (Q7B_nil(Q7B_QSTRING(v))){ Q7B_EXCEPTION("String expected"); return; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  udp->sHost = Q7B_IDQString(v); 
}

Q7B Q7B_UDPSOCKET_HOST(Q7B q7b_udpsocket)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return Q7B_idnil; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  return Q7B_QOBJECT( udp->sHost );
}

void Q7B_UDPSOCKET_PORT(Q7B q7b_udpsocket, Q7B v)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return; }  
  if (Q7B_nil(Q7B_INTEGER(v))){ Q7B_EXCEPTION("Integer expected"); return; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  udp->nPort = Q7B_IDqint64(v);
}

Q7B Q7B_UDPSOCKET_PORT(Q7B q7b_udpsocket)
{
  if (Q7B_nil(q7b_udpsocket)){ Q7B_NULLPOINTEREXCEPTION(); return Q7B_idnil; }

  if (Q7B_nil(Q7B_UDPSOCKET(q7b_udpsocket))){ Q7B_EXCEPTION("UdpSocket expected"); return Q7B_idnil; }

  Q7B_UdpSocket *udp = ((Q7B_UdpSocket *) q7b_udpsocket->ref);

  return Q7B_QOBJECT( udp->nPort );
}




Q7B_Screen::Q7B_Screen(QWidget *_parent) : QWidget (0)
{
  nFontWidth = 10;
  nFontHeight = 19;

  PI = 3.14159265;

  getWidth = 800;
  getHeight = 570;
  getColumn = 81;
  getLine = 30;
  

  bInputted = false;
  setWindowFlags(Qt::CustomizeWindowHint | Qt::WindowTitleHint | Qt::WindowMinimizeButtonHint | Qt::WindowCloseButtonHint  | Qt::WindowSystemMenuHint );
  bHide = false;

  setFocusPolicy(Qt::StrongFocus);

  for (int i = 0; i < 256; i++){
    switch(i % 16){
      case 0:
        colors[i] = Qt::black;
        break;
      case 1:
        colors[i] = Qt::darkBlue;
        break;
      case 2:
        colors[i] = Qt::darkGreen;
        break;
      case 3:
        colors[i] = Qt::darkCyan;
        break;
      case 4:
        colors[i] = Qt::darkRed;
        break;
      case 5:
        colors[i] = Qt::darkMagenta;
        break;
      case 6:
        colors[i] = QColor(153, 102, 0);
        break;
      case 7:
        colors[i] = Qt::lightGray;
        break;
      case 8:
        colors[i] = Qt::darkGray;
        break;
      case 9:
        colors[i] = Qt::blue;
        break;
      case 10:
        colors[i] = Qt::green;
        break;
      case 11:
        colors[i] = Qt::cyan;
        break;
      case 12:
        colors[i] = Qt::red;
        break;
      case 13:
        colors[i] = Qt::magenta;
        break;
      case 14:
        colors[i] = Qt::yellow;
        break;
      case 15:
        colors[i] = Qt::white;
        break;
    }
   
    if (i / 16 > 0){
      colors[i] = colors[i].dark(100 + 50 * i / 16);
    }    


  }

  nForecolor = 15;
  nBackcolor = 0;

 
  nInput2 = nInput = 0xffff; 

  setWindowTitle("Screen");
  setWindowIconText("Screen");

  m2 = QPixmap(getWidth, getHeight);
  m2.fill(Qt::black);


  nForecolor = 15;
  nBackcolor = 0;

  bCursor = false;
  nCursorX = 1;
  nCursorY = 1;
  font = QFont("Courier");
  font.setPixelSize(16);


	setHidden(true);
  setFixedSize(getWidth, getHeight); 

  nTimerId = startTimer( 500 ); 
  
  bCTRL = false;
  bSHIFT = false;

  bWasActivated = bActivated = false;
  setHidden(true);
  
  QRect r = QApplication::desktop()->screenGeometry(QApplication::desktop()->primaryScreen());
  move((r.width() / 2) - (width() / 2), (r.height() / 2) - (height() / 2));

}

Q7B_Screen::~Q7B_Screen(void)
{  
  killTimer(nTimerId);  
  nTimerId = 0;
  
  captureScreen();
  hide();

 
}

int Q7B_Screen::getCursorX()
{
  return (nCursorX-1)*nFontWidth;
}

int Q7B_Screen::getCursorY()
{
  return (nCursorY*nFontHeight)-5;
}

void Q7B_Screen::setWindowIcon2()
{ 
  
  
}

void Q7B_Screen::activate()
{ 
  if (bActivated == false){

    nInput2 = nInput = 0xffff; 

    bWasActivated = bActivated = true;
    show();   
    activateWindow();
    if (bWasActivated) clearLastLine();
  } else show();

}

void Q7B_Screen::setActiveW()
{
  show();
  activateWindow();
}

void Q7B_Screen::deactivate()
{
  if (bActivated == true){

    bActivated = false;

    bHide = true; hide();
  }

}

void Q7B_Screen::setActivated(bool b)
{
  bActivated = b;
}

void Q7B_Screen::pressAnyKey(bool bPrintText)
{
  if (bPrintText){

    int x = pos();
    int y = csrlin();

    int forecolor = nForecolor;
    int backcolor = nBackcolor;
  
    locate(getLine, 1);
    color(15, 0);
    print("Press ANY KEY to continue...");

    
    locate(y, x);
    nForecolor = forecolor;
    nBackcolor = backcolor;
    
  }

  bActivated = false;
}

bool Q7B_Screen::isActivated()
{
  return bActivated;
}

void Q7B_Screen::paintEvent( QPaintEvent * e)
{

  QPainter p(this);

  p.drawPixmap(0, 0, m2);
  if (bCursor || bInputted){
    p.setPen( colors[nBackcolor] );      
    p.fillRect( QRect(getCursorX(), getCursorY() + 1, nFontWidth,  3), colors[nForecolor]);
  }

 
  
}

void Q7B_Screen::keyPressEvent( QKeyEvent * e)
{
  
  nInput = e->nativeVirtualKey();
  nInput2 = e->key();
  sInput = e->text();
  
  if (nInput == 0 && e->key() != 0){ 
    int b = e->key();

    if ((b == Qt::Key_Shift) || (b == Qt::Key_Alt) || (b == Qt::Key_Control) || (b == Qt::Key_Meta)) {
      nInput2 = nInput = 0xffff; 
    } else {
      nInput = 0;
    }
  } else {
    bInputted = true;
  }

  if (!bActivated){    

    bHide = true; hide();
    nInput2 = nInput = 0xffff; 
  }

  int n = e->key();

  if (n == Qt::Key_Control){
    bCTRL = true;
  }

  if (n == Qt::Key_C && bCTRL){
  
  }

}
 
void Q7B_Screen::closeEvent ( QCloseEvent * e )
{

  
  bHide = true; hide();
  e->accept();
}

void Q7B_Screen::keyReleaseEvent ( QKeyEvent * e )
{  
  switch(e->key()){
    case Qt::Key_Control:
      bCTRL = false;
      break;
    case Qt::Key_Shift:
      bSHIFT = false;
      break;
  }
}

void Q7B_Screen::focusInEvent (QFocusEvent *e)
{
  show();
}

void Q7B_Screen::focusOutEvent (QFocusEvent *e)
{

}

void Q7B_Screen::hideEvent (QHideEvent *e)
{
  if (bHide){
    bHide = false;
  } else {

  }
  QWidget::hideEvent(e);
}

void Q7B_Screen::timerEvent( QTimerEvent * )
{  
  bCursor = !bCursor;
  static QRect r2;
  
  QRect r = QRect(getCursorX(), getCursorY() + 1, nFontWidth,  3);
  update(r);
  update(r2);
  r2 = r;
  
}

void Q7B_Screen::incCursorX()
{
  nCursorX++;
  if (nCursorX >= getColumn){
    nCursorX = 1;
    incCursorY();
  }
}

void Q7B_Screen::decCursorX()
{
  nCursorX--;
  if (nCursorX < 1){
    nCursorX = getColumn;
    decCursorY();
  }
}

void Q7B_Screen::setCursorX(int n)
{
  nCursorX = n;
}

void Q7B_Screen::setCursorY(int n)
{
  nCursorY = n;
}

void Q7B_Screen::decCursorY()
{
  nCursorY--;
  if (nCursorY < 1){
    nCursorX = 1;
    nCursorY = 1;
  }
}

void Q7B_Screen::incCursorY()
{
  nCursorY++;
  if (nCursorY > getLine){

    int h = getHeight - nFontHeight;    


    p2.drawPixmap(0, 0, m2, 0, nFontHeight, getWidth, h);

    p2.fillRect(QRect(0, h, getWidth, nFontHeight), colors[nBackcolor]);
    

    nCursorY = getLine;
  }
}

void Q7B_Screen::clearLastLine()
{
  int y = getHeight - (nFontHeight + 0);
  int w = getWidth;

  QPainter p( &m2 );

  QRect r = QRect(0, y, w, nFontHeight + 0);
  p.fillRect(r, colors[nBackcolor]);
  
  update(r);
}

int Q7B_Screen::abs(int n)
{
  if (n < 0) return n *= -1;
  return n;
}


void Q7B_Screen::line(bool step, int x1, int y1, 
                bool step2, bool expression, int x2, int y2, 
                bool bColor, int color, bool b, bool bf, bool bStyle, int style)
{
  activate();

  QPainter p2( &m2 );

  if (bColor){
    p2.setPen( colors[color] );      
  } else {
    p2.setPen( colors[nForecolor] );      
  }
  
  if (bStyle){
    p2.setPen( QPen(colors[color]) );      
  }
  if (b){     
    p2.drawRect(x1, y1, abs(x2 - x1), abs(y2 - y1)); 
  } else if (bf){
    QPixmap k( abs(x2 - x1), abs(y2 - y1));
    k.fill(colors[color]);    
    p2.drawPixmap(x1, y1, k); 
  } else {
    p2.drawLine(x1, y1, x2, y2); 
  }
  

  update();
}


void Q7B_Screen::circle(bool step, int x, int y, int radius, int color, int start, int end, int aspect)
{
  activate();

  QPainter p( &m2 );

  

  if (start == -1) start = 0 / (PI / 180);
  if (end == -1) end = 360 / (PI / 180);
  if (aspect == -1) aspect = 1;

  if (color == -1){
    p.setPen( colors[nForecolor] );   
  } else {
    p.setPen( colors[color] );   
  }

  p.drawArc ( x - radius, y - radius, radius * 2, radius * 2, 0 * 16, 360 * 16);
  
  
  update();
}


void Q7B_Screen::color(int forecolor, int backcolor)
{
  activate();

  if (forecolor < 256 && forecolor != -1) nForecolor = forecolor;
  if (backcolor < 256 && backcolor != -1) nBackcolor = backcolor;
}


void Q7B_Screen::paint(bool step, int x, int y, int color, char *pattern, int bordercolor, int backcolor)
{
}


void Q7B_Screen::cls(int no)
{
  activate();

  QPainter p( &m2 );

  QPixmap k(QApplication::desktop()->width(), QApplication::desktop()->height());
  k.fill( colors[nBackcolor] );    
  

  p.drawPixmap(0, 0, k); 
  
  locate(1, 1);
  update();
}


void Q7B_Screen::viewprint(int no)
{
  activate();

}


void Q7B_Screen::viewscreen(int no)
{
  activate();

}


void Q7B_Screen::window(int no)
{
  activate();

}


int Q7B_Screen::csrlin()
{
  activate();

  return nCursorY;
}


void Q7B_Screen::pmap(int no)
{
  activate();

}


void Q7B_Screen::point(int no)
{
  activate();

}


void Q7B_Screen::beep()
{
  
  QApplication::beep();
}


void Q7B_Screen::draw(int no)
{
  activate();

}


void Q7B_Screen::get(int no)
{
  activate();

}


void Q7B_Screen::put(int no)
{
  activate();

}


void Q7B_Screen::key(int no)
{
  activate();

}

char *Q7B_Screen::inkey(int *nKeyPressed)
{
  
  activate();

  static char ac[1024];


  
  if (nInput == 0xffff){ 
    *nKeyPressed = 1;

    ac[0] = '\0';
    return ac;
  }

  if (nInput == 0){ 
    *nKeyPressed = 2;

	  ac[0] = ' ';
    ac[1] = '\0';  

    
    return ac;
  }

  *nKeyPressed = 3;

	ac[0] = sInput.at(0).toAscii();
  ac[1] = '\0';  

  nInput = 0xffff; 

  return ac;
}


char *Q7B_Screen::input()
{
  activate();
  
  static char ac[1024];

  int i = 0;
  while (nInput2 != Qt::Key_Enter && nInput2 != Qt::Key_Return){
    if (nInput2 != 0xffff){ 

 

      if (nInput2 == Qt::Key_Backspace){
        if (i > 0){ 
         i--;

         decCursorX();
         static QString ss = QString(QChar(' '));
         print(ss);
         decCursorX();
        }

        nInput2 = 0xffff; 
        bInputted = false;
      } else if (nInput2 >= 32){

       QChar *c = sInput.data();
       ac[i] = c->toAscii();       

       print(sInput);
       nInput2 = 0xffff; 
       bInputted = false;
       i++;
       if (i > 1023) break;
      
      } else { 
       nInput2 = 0xffff; 
       bInputted = false;
      }
    }
    update();
    qApp->processEvents(QEventLoop::AllEvents, 100);
  };  

  setCursorX(1);
  incCursorY();

  nInput2 = 0xffff; 
  bInputted = false;

	ac[i] = '\0';  

  return ac;  
}




void Q7B_Screen::print(const char *s)
{  
  
  
  static QString ss; ss = s;
  print(ss);
  
}


void Q7B_Screen::print(const QString &j)
{
  activate();

  p2.begin(&m2);

  p2.setPen( colors[nForecolor] );   
  p2.setBackgroundMode(Qt::OpaqueMode);
  p2.setBackground ( colors[nBackcolor] );
  p2.setFont(font); 


  int i = 0;
  int i2 = 0;
  bool b = false;
  QString k;

  do {

    i2 = j.indexOf("\n", i);
    if (i2 != -1){
      k = j.mid(i, i2 - i);
      i = i2;
      b = true;
    } else {
      k = j.mid(i);
      if (k == 0) break;
      b = false;
    }

  
   do {

      int n = k.length() + nCursorX;
      if (n > getColumn){
        n = getColumn - nCursorX;
       

        p2.drawText(getCursorX(), getCursorY(), k.left(n));

        k = k.mid(n);

        nCursorX = 1;
        incCursorY();

      } else {
        

        p2.drawText(getCursorX(), getCursorY(), k);

        if (b){
          i++;
          nCursorX = 1;
          incCursorY();
        } else {
          nCursorX += k.length();
        }

        break;
      }

   } while (k.length());
 
 
} while (b);

  update();

  p2.end();

}



void Q7B_Screen::preset(bool step, int x, int y, int color)
{
  activate();

  QPainter p( this );


  if (color == -1){
    p.setPen( colors[nBackcolor] );      
  } else {
    p.setPen( colors[color] );      
  }

  p.drawPoint(x, y); 

  update();
}


void Q7B_Screen::pset(bool step, int x, int y, bool bColor, int color)
{
  activate();

  QPainter p( &m2 );


  if (bColor){
    p.setPen( colors[color] );      
  } else {
    p.setPen( colors[nForecolor] );      
  }

  p.drawPoint(x, y); 

  
  update();
}


int Q7B_Screen::pos()
{
  activate();

  return nCursorX;
}


void Q7B_Screen::locate(int y, int x)
{
  activate();

  if (x > getColumn || y > getLine) return;

  if (x != -1) nCursorX = x;
  if (y != -1) nCursorY = y;
  
}


void Q7B_Screen::palette(int no)
{
  activate();
}


void Q7B_Screen::sound(int no)
{
}


void Q7B_Screen::play(int no)
{
}


void Q7B_Screen::view(int no)
{
  activate();
}

void Q7B_Screen::test1()
{

  circle(false, 44, 66, 8, 8, 6, 6, 4);
  
  color(15, 1);
  locate(1, 1);
  print("1gy567890 1234567890 123456g890 1234567u90 1234567u90 1234567u90 1234567u90 1234567u90");

  char buffer[1024];
  sprintf(buffer, "\n\n\n     hi");
  print(buffer);
  int n = pos();
  n = csrlin();

  locate(5, 11);
  print("gut");

  locate(2, 1);
  print(".2\n");
  print(".3\n");
  print(".4\n");
  print(".5\n");
  print(".6\n");
  print(".7\n");
  print(".8\n");
  print(".9\n");
  
  print(".0\n");
  print(".1\n");
  print(".2\n");
  print(".3\n");
  print(".4\n");
  print(".5\n");
  print(".6\n");
  print(".7\n");
  print(".8\n");
  print(".9\n");
  
  
  print(".0\n");
  print(".1\n");
  print(".2\n");
  print(".3\n");
  print(".4\n");
  print(".5\n");
  print(".6\n");
  print(".7\n");
  print(".8\n");
  print(".9\n");
  print(".0\n");
  

  locate(2, 1);
  print("WyW");
  locate(2, 2);
  
  
  
}


void Q7B_Screen::test2()
{
  color(15, 1);

  locate(1, 1);
  
  input();
  for (int i = 0; i < 35; i++){

   

    QString s = "1234567890 1234567890 123456g890 1234567u90 1234567890 1234567890 1234567u9!";

    QString k;
    k.sprintf("%d\n", i);

    print((s + k));
  }


  
  

  circle(false, 320, 100, 200, 15, -1, -1, -1);

 
 
    

 
  
  
  
  

  
}


void Q7B_Screen::aboutToQuit()
{
  
  if (bActivated){
  
    
    
  }
}

void Q7B_Screen::captureScreen()
{
  

  if (bActivated){
    qApp->processEvents(); 
    
  }
 
}

void Q7B_Screen::printScreen(bool bDialog)
{
  static QPrinter printer;
  

  if (bDialog){
    QPrintDialog *dialog = new QPrintDialog(&printer, this);
    dialog->setWindowTitle(tr("Print Document"));
    if (dialog->exec() != QDialog::Accepted) return;
  }

  QPainter painter;
  painter.begin(&printer);

  painter.drawPixmap(0, 0, m2);

  painter.end();
}

Q7B_Screen *Q7B_myScreen = 0;

void Q7B_SHOWSCREEN()
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  Q7B_myScreen->activate();
}

void Q7B_HIDESCREEN()
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  Q7B_myScreen->deactivate();
}

void Q7B_CLOSESCREEN()
{
  if (Q7B_myScreen){
    delete Q7B_myScreen;
    Q7B_myScreen = 0;
  }
}

void Q7B_CLS()
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  Q7B_myScreen->cls(0);
}

void Q7B_LINE(Q7B x1, Q7B y1, Q7B x2, Q7B y2, Q7B bColor, Q7B color)
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  if (Q7B_nil(Q7B_INTEGER(x1))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(y1))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(x2))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(y2))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(bColor))){ Q7B_EXCEPTION("Boolean expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(color))){ Q7B_EXCEPTION("Integer expected"); return; }

  bool step = false;
  bool step2 = false;
  bool expression = false;
  bool b = false;
  bool bf = false;
  bool bStyle = false;
  int style = 0;

   Q7B_myScreen->line(step, Q7B_IDqint64(x1), Q7B_IDqint64(y1), 
         step2, expression, Q7B_IDqint64(x2), Q7B_IDqint64(y2), 
         Q7B_IDbool(bColor), Q7B_IDqint64(color), b, bf, bStyle, style);
}

void Q7B_PSET(Q7B x1, Q7B y1, Q7B bColor, Q7B color)
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  if (Q7B_nil(Q7B_INTEGER(x1))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(y1))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_BOOLEAN(bColor))){ Q7B_EXCEPTION("Boolean expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(color))){ Q7B_EXCEPTION("Integer expected"); return; }

  bool step = false;
   Q7B_myScreen->pset(step, Q7B_IDqint64(x1), Q7B_IDqint64(y1),Q7B_IDbool(bColor), Q7B_IDqint64(color));
}

Q7B Q7B_CSRLIN()
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  return Q7B_QOBJECT( Q7B_myScreen->csrlin() );
}

Q7B Q7B_POS()
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  return Q7B_QOBJECT( Q7B_myScreen->pos() );
}

void Q7B_COLOR(Q7B nFORE, Q7B nBACK)
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  if (Q7B_nil(Q7B_INTEGER(nFORE))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(nBACK))){ Q7B_EXCEPTION("Integer expected"); return; }

  Q7B_myScreen->color(Q7B_IDqint64(nFORE), Q7B_IDqint64(nBACK));
}

void Q7B_PRINTSCREEN(Q7B bPrintDialog)
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  if (Q7B_nil(Q7B_BOOLEAN(bPrintDialog))){ Q7B_EXCEPTION("Boolean expected"); return; }

  Q7B_myScreen->printScreen(Q7B_IDbool(bPrintDialog));
}

void Q7B_LOCATE(Q7B Y, Q7B X)
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  if (Q7B_nil(Q7B_INTEGER(Y))){ Q7B_EXCEPTION("Integer expected"); return; }
  if (Q7B_nil(Q7B_INTEGER(X))){ Q7B_EXCEPTION("Integer expected"); return; }

  Q7B_myScreen->locate(Q7B_IDqint64(Y), Q7B_IDqint64(X));
}

void Q7B_PRINT(Q7B Q7B_Object)
{
  if (Q7B_myScreen == 0) Q7B_myScreen = new Q7B_Screen();

  if (Q7B_nil(Q7B_Object)){ Q7B_NULLPOINTEREXCEPTION(); return; }
  if (Q7B_nil(Q7B_QSTRING(Q7B_Object))){ Q7B_EXCEPTION("String expected"); return; }

  QString s = Q7B_IDQString(Q7B_Object);
  Q7B_myScreen->print(s);
}


void Q7B_RECONNECTSIGNALS(Q7B Argument, QObject *Q7B_Parent)
{  
  if (Q7B_nil(Argument)){ Q7B_NULLPOINTEREXCEPTION(); return; }

  QObject *o = (QObject *) Argument->ref; 
  Q7B_connectSlotsByName(o, Q7B_Parent);
}








bool Q7B_bDebugBreak = false;
bool Q7B_bDebug = true;
bool Q7B_bStepInto = false;
bool Q7B_bStepOut = false;
bool Q7B_bRunToCursor = false;
QString Q7B_sRunToCursorFile;
QString Q7B_sRunToCursorLine;
bool Q7B_bStepOver = false;

QString Q7B_sStepOverScope;
QString Q7B_sDebugScope;

void Q7BWriteDebugOutput(QString s)
{
  QFile f( QDir::tempPath() + "/Q7Basic/" + "/q7b_in" + QString("%1").arg(qApp->applicationPid()) + ".txt");
  if (f.open(QIODevice::WriteOnly | QIODevice::Truncate)){
    QTextStream t(&f);
    t << s;
    f.close();
   
    
  }
}

QString Q7BReadDebugInput()
{
  QString s;
  if (QFile::exists(QDir::tempPath() + "/Q7Basic/" + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt")){
    QFile f( QDir::tempPath() + "/Q7Basic/" + "/q7b_out" + QString("%1").arg(qApp->applicationPid()) + ".txt");
    if (f.open(QIODevice::ReadOnly)){
      QTextStream t(&f);
      s = t.readAll();
      f.close();

      

      
    }
  }
  return s;
}



QMap<QString, QStringList> Q7B_breakpoints;

Q7BDebugListener Q7BDebugCommandExecuter;

void Q7BE(QString sFile, QString sScope, QString sLine, int nType)
{
  Q7B_META_sCurrentFile = sFile;
  Q7B_META_sCurrentScope = sScope;
  Q7B_META_sCurrentLine = sLine;

  if (!Q7B_bDebug) return;
}



bool Q7BS(QString sFile, QString sScope, QString sLine, int nType) 
{

 

  Q7B_META_sCurrentFile = sFile;
  Q7B_META_sCurrentScope = sScope;
  Q7B_META_sCurrentLine = sLine;





 

  if (!Q7B_bDebug) return true;

  static bool bFirst = true;
  if (bFirst){
    bFirst = false;  
    Q7BDebugCommandExecuter.init();
  }

  bool bbb = Q7B_breakpoints[sFile].contains(sLine);
  

  bool bb = Q7B_breakpoints.contains(sFile) && Q7B_breakpoints[sFile].contains(sLine) && nType == 1; 


  if (bb || (Q7B_bStepInto && nType == 1) || (Q7B_bStepOut && nType == 2 && sScope == Q7B_sDebugScope) || (Q7B_bStepOver && nType == 1 && sScope == Q7B_sDebugScope) || (Q7B_bRunToCursor && nType == 1 && Q7B_sRunToCursorFile == sFile && Q7B_sRunToCursorLine == sLine)){   


    Q7B_sRunToCursorFile = "";
    Q7B_sRunToCursorLine = "";

    Q7B_bStepInto = false;
    Q7B_bStepOver = false;
    Q7B_bStepOut = false;
    Q7B_bRunToCursor = false;

    Q7B_bDebugBreak = true;

    if (nType == 2){
      
      
      Q7B_bStepInto = true;
    } else {      

      Q7BWriteDebugOutput("Breakpoint\n" + sFile + "\n" + sLine + "\n"); 
      
      
      while(Q7B_bDebugBreak && Q7B_bDebug){
        if (QFile::exists(QDir::tempPath() + "/Q7Basic/" + "/stop" + QString("%1").arg(qApp->applicationPid()) + ".txt")){
          QFile::remove(QDir::tempPath() + "/Q7Basic/" + "/stop" + QString("%1").arg(qApp->applicationPid()) + ".txt");
          Q7B_bDebugBreak = false;
        }
        
        

        qApp->processEvents(QEventLoop::WaitForMoreEvents);
      }
    }

   
    Q7B_sDebugScope = sScope;
    return true;

  } else if (nType == 2){
  
    Q7BWriteDebugOutput("ClearBreakpoint\n" + sFile + "\n" + sLine + "\n"); 

    if (Q7B_sStepOverScope == Q7B_sDebugScope){
  
      Q7B_bStepOver = false;
      Q7B_bStepInto = true;

    }
  }


  if (!Q7B_bStepOver && !Q7B_bStepOut){
    Q7B_sDebugScope = sScope; 
  }
  return true; 
}








  

#endif




QObject *Q7B_CQOBJECT(Q7B l)
{
  return ( ((QObject *) l->ref) );
}

bool Q7B_CBOOLEAN(Q7B l)
{
  if (l->type == typeid(bool).name()){
    return ( *((bool *) l->ref) );
  }
  if (l->type == typeid(qint64).name()){
    return ( (bool) *((qint64 *) l->ref) );
  }
  if (l->type == typeid(qreal).name()){
    return ( (bool) *((qreal *) l->ref) );
  }
  
  if (l->type == typeid(QString).name()){ 
    return ( !((QString *) l->ref)->isEmpty() );
  }
  
  Q7B_CASTEXCEPTION("'Boolean' expected");
  return false;
}


bool Q7B_CBOOLEAN(bool l)
{
  return l;
}


qint64 Q7B_CINTEGER(Q7B l)
{
  if (l->type == typeid(qint64).name()){
    return ( *((qint64 *) l->ref) );
  }
  if (l->type == typeid(qreal).name()){
    return ( (qint64) *((qreal *) l->ref) );
  }
  if (l->type == typeid(bool).name()){
    return ( (qint64) *((bool *) l->ref) );
  }

  Q7B_CASTEXCEPTION("'Integer' expected");
  return 0;
}

qreal Q7B_CFLOAT(Q7B l)
{
  if (l->type == typeid(qreal).name()){
    return ( *((qreal *) l->ref) );
  }
  if (l->type == typeid(qint64).name()){
    return ( (qreal) *((qint64 *) l->ref) );
  }
  if (l->type == typeid(bool).name()){
    return ( (qreal) *((bool *) l->ref) );
  }
  
  Q7B_CASTEXCEPTION("'Float' expected");
  return 0;
}

QString Q7B_CQSTRING(Q7B l)
{
  return Q7B_toString2(l);
}

QStringList Q7B_CQSTRINGLIST(Q7B l)
{
  if (l->type == typeid(Q7B_List).name()){
    QStringList ll = ((Q7B_List *) l->ref)->toStringList();
    return ll;
  }

  Q7B_CASTEXCEPTION("'Array' expected");
  return QStringList();
}














Q7B Q7B_QOBJECT(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_ID(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_TIMER(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_UDPSOCKET(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_CONTROL(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QWIDGET(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_IMAGEBUTTON(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_COMMANDBUTTON(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_COMMANDLINKBUTTON(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_TOOLBUTTON(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_CHECKBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_RADIOBUTTON(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_LABEL(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_FRAME(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_IMAGEBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_TEXTBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QDIALOG(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QABSTRACTBUTTON(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QPUSHBUTTON(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QRADIOBUTTON(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QMAINWINDOW(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QMDIAREA(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QPROGRESSBAR(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QCHECKBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QBUTTONGROUP(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QCOMMANDLINKBUTTON(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QLISTWIDGET(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QTREEWIDGET(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QCOMBOBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QWEBVIEW(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QDECLARATIVEVIEW(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QVBOXLAYOUT(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QHBOXLAYOUT(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QGRIDLAYOUT(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QFORMLAYOUT(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QDIALOGBUTTONBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QLISTVIEW(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QTREEVIEW(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QTABLEVIEW(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QCOLUMNVIEW(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QTABLEWIDGET(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QGRAPHICSVIEW(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QCALENDERWIDGET(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QLCDNUMBER(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QGROUPBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QSCROLLAREA(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QTOOLBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QTABWIDGET(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QSTACKEDWIDGET(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QFRAME(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QFONTCOMBOBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QPLAINTEXTEDIT(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QDIAL(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QDOCKWIDGET(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QLINEEDIT(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QTEXTEDIT(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QSPINBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_PHONONVIDEOPLAYER(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_PHONONSEEKSLIDER(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_PHONONVOLUMESLIDER(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QDOUBLESPINBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QTIMEEDIT(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QDATEEDIT(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QDATETIMEEDIT(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QSCROLLBAR(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QSLIDER(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QTEXTBROWSER(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QTOOLBUTTON(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QLABEL(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QMENUBAR(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QTOOLBAR(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QSTATUSBAR(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QACTION(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QPAINTER(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QICON(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QLAYOUT(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_QMENU(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_COMBOBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_LISTBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_DATEBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_TIMEBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_DATETIMEBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_MOVIEBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_TABVIEW(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_TREEVIEW(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_LISTVIEW(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_BOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_PROGRESSBAR(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_RICHTEXTBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_WEBVIEW(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_HTMLVIEW(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_SVGBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_SLIDER(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_SCROLLBAR(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_SPINBOX(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_FORMVIEW(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_FORMSVIEW(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_TOOLBARVIEW(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_UICLASS(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_CLASS(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}

Q7B Q7B_MODULE(Q7B m)
{
  
    return m;
  
  
  return Q7B_idnil;
}




Q7B Q7B__QOBJECT(bool o)
{
  Q7B q (new Q7B_id(typeid(bool).name(), new bool(o))); 
  return q;
}

Q7B Q7B__QOBJECT(char * o)
{
  Q7B q (new Q7B_id(typeid(QString).name(), new QString(o))); 
  return q;
}

Q7B Q7B__QOBJECT(const char * o)
{
  Q7B q (new Q7B_id(typeid(QString).name(), new QString(o))); 
  return q;
}

Q7B Q7B__QOBJECT(QString o)
{
  Q7B q (new Q7B_id(typeid(QString).name(), new QString(o))); 
  return q;
}

Q7B Q7B__QOBJECT(qint8 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B__QOBJECT(qint16 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B__QOBJECT(qint32 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B__QOBJECT(qint64 o)
{
  Q7B q (new Q7B_id(typeid(qint64).name(), new qint64(o))); 
  return q;
}

Q7B Q7B__QOBJECT(float o)
{
  Q7B q (new Q7B_id(typeid(qreal).name(), new qreal(o))); 
  return q;
}

Q7B Q7B__QOBJECT(double o)
{
  Q7B q (new Q7B_id(typeid(qreal).name(), new qreal(o))); 
  return q;
}

Q7B Q7B__QOBJECT(QStringList o)
{
  Q7B q (new Q7B_id(typeid(Q7B_List).name(), new Q7B_List(o))); 
  return q;
}

Q7B Q7B__QOBJECT(QDateTime o)
{
  Q7B q (new Q7B_id(typeid(QDateTime).name(), new QDateTime(o))); 
  return q;
}




Q7B Q7B__BOOLEAN(Q7B o)
{
  if (o->type == typeid(bool).name()){
    return o;
  }
  if (o->type == typeid(qint64).name()){ 
    return Q7B__QOBJECT((bool) *((qint64*) o->ref));
  }
  if (o->type == typeid(qreal).name()){ 
    return Q7B__QOBJECT((bool) *((qreal*) o->ref));
  }

  Q7B_CASTEXCEPTION("'Boolean' for assignment expected");
  return Q7B_idnil;  
}

Q7B Q7B__STRING(Q7B o)
{
  if (o->type == typeid(QString).name()){
    return o;
  }

  Q7B_CASTEXCEPTION("'String' for assignment expected");
  return Q7B_idnil;  
}

Q7B Q7B__INTEGER(Q7B o)
{
  if (o->type == typeid(qint64).name()){
    return o;
  }
  if (o->type == typeid(qreal).name()){ 
    return Q7B__QOBJECT((qint64) *((qreal*) o->ref));
  }
  if (o->type == typeid(bool).name()){ 
    return Q7B__QOBJECT((qint64) *((bool*) o->ref));
  }

  Q7B_CASTEXCEPTION("'Integer' for assignment expected");
  return Q7B_idnil;  
}

Q7B Q7B__FLOAT(Q7B o)
{
  if (o->type == typeid(qreal).name()){
    return o;
  }
  if (o->type == typeid(qint64).name()){ 
    return Q7B__QOBJECT((qreal) *((qint64*) o->ref));
  }
  if (o->type == typeid(bool).name()){ 
    return Q7B__QOBJECT((qreal) *((bool*) o->ref));
  }

  Q7B_CASTEXCEPTION("'Float' for assignment expected");
  return Q7B_idnil;  
}

Q7B Q7B__DATETIME(Q7B o)
{
  if (o->type == typeid(QDateTime).name()){
    return o;
  }

  Q7B_CASTEXCEPTION("'DateTime' for assignment expected");
  return Q7B_idnil;  
}

Q7B Q7B__DECIMAL(Q7B o)
{
  if (o->type == typeid(Q7B_Decimal).name()){
    return o;
  }

  Q7B_CASTEXCEPTION("'Decimal' for assignment expected");
  return Q7B_idnil;  
}

Q7B Q7B__ARRAY(Q7B o)
{
  if (o->type == typeid(Q7B_List).name()){
    return o;
  }

  Q7B_CASTEXCEPTION("'Array' for assignment expected");
  return Q7B_idnil;  
}

Q7B Q7B__DICTIONARY(Q7B o)
{
  if (o->type == typeid(Q7B_Dictionary).name()){
    return o;
  }

  Q7B_CASTEXCEPTION("'Dictionary' for assignment expected");
  return Q7B_idnil;  
}

Q7B Q7B__DATA(Q7B o)
{
  if (o->type == typeid(Q7B_Data).name()){
    return o;
  }

  Q7B_CASTEXCEPTION("'Data' for assignment expected");
  return Q7B_idnil;  
}




Q7B Q7B__QOBJECT(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__ID(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__TIMER(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__UDPSOCKET(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__CONTROL(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QWIDGET(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__IMAGEBUTTON(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__COMMANDBUTTON(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__COMMANDLINKBUTTON(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__TOOLBUTTON(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__CHECKBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__RADIOBUTTON(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__LABEL(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__FRAME(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__IMAGEBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__TEXTBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QDIALOG(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QABSTRACTBUTTON(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QPUSHBUTTON(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QRADIOBUTTON(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QMAINWINDOW(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QMDIAREA(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QPROGRESSBAR(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QCHECKBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QBUTTONGROUP(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QCOMMANDLINKBUTTON(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QLISTWIDGET(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QTREEWIDGET(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QCOMBOBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QWEBVIEW(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QDECLARATIVEVIEW(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QVBOXLAYOUT(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QHBOXLAYOUT(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QGRIDLAYOUT(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QFORMLAYOUT(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QDIALOGBUTTONBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QLISTVIEW(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QTREEVIEW(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QTABLEVIEW(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QCOLUMNVIEW(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QTABLEWIDGET(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QGRAPHICSVIEW(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QCALENDERWIDGET(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QLCDNUMBER(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QGROUPBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QSCROLLAREA(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QTOOLBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QTABWIDGET(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QSTACKEDWIDGET(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QFRAME(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QFONTCOMBOBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QPLAINTEXTEDIT(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QDIAL(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QDOCKWIDGET(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QLINEEDIT(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QTEXTEDIT(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QSPINBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__PHONONVIDEOPLAYER(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__PHONONSEEKSLIDER(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__PHONONVOLUMESLIDER(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QDOUBLESPINBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QTIMEEDIT(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QDATEEDIT(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QDATETIMEEDIT(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QSCROLLBAR(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QSLIDER(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QTEXTBROWSER(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QTOOLBUTTON(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QLABEL(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QMENUBAR(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QTOOLBAR(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QSTATUSBAR(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QACTION(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QPAINTER(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QICON(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QLAYOUT(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__QMENU(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__COMBOBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__LISTBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__DATEBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__TIMEBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__DATETIMEBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__MOVIEBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__TABVIEW(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__TREEVIEW(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__LISTVIEW(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__BOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__PROGRESSBAR(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__RICHTEXTBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__WEBVIEW(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__HTMLVIEW(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__SVGBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__SLIDER(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__SCROLLBAR(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__SPINBOX(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__FORMVIEW(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__FORMSVIEW(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__TOOLBARVIEW(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__UICLASS(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__CLASS(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

Q7B Q7B__MODULE(Q7B m)
{
  
    return m;
  
  return Q7B_idnil;
}

